/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],be=function(te){for(var e=[],h=0,t=te.length;h<t;h++)e[h]=we[te[h]];return e};define(we[55],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(t,k){if(!t)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=h}),define(we[73],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function h(S){return S?S.replace(/\$\((.*?)\)/g,(P,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=h;class t{constructor(P,C,T){this.id=P,this.definition=C,this.description=T,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(S,P){const C=["codicon","codicon-"+S];return P&&C.push("codicon-modifier-"+P),C}e.getClassNamesArray=k;var A;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function C(D){if(D instanceof t)return["codicon","codicon-"+D.id];const g=P.exec(D.id);if(!g)return C(t.error);let[,E,f]=g;const u=["codicon","codicon-"+E];return f&&u.push("codicon-modifier-"+f.substr(1)),u}S.asClassNameArray=C;function T(D){return C(D).join(" ")}S.asClassName=T;function F(D){return"."+C(D).join(".")}S.asCSSSelector=F})(A=e.CSSIcon||(e.CSSIcon={}))}),define(we[74],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function t(F){const D=[];for(let g in F)h.call(F,g)&&D.push(F[g]);return D}e.values=t;function k(F,D){for(let g in F)if(h.call(F,g)&&D({key:g,value:F[g]},function(){delete F[g]})===!1)return}e.forEach=k;function A(F,D){const g=Object.create(null);for(const E of F){const f=D(E);let u=g[f];u||(u=g[f]=[]),u.push(E)}return g}e.groupBy=A;function S(F){const D=Object.create(null);return F&&F.forEach((g,E)=>{D[E]=g}),D}e.fromMap=S;function P(F,D){const g=[],E=[];for(let f of F)D.has(f)||g.push(f);for(let f of D)F.has(f)||E.push(f);return{removed:g,added:E}}e.diffSets=P;function C(F,D){const g=[],E=[];for(let[f,u]of F)D.has(f)||g.push(u);for(let[f,u]of D)F.has(f)||E.push(u);return{removed:g,added:E}}e.diffMaps=C;class T{constructor(){this.map=new Map}add(D,g){let E=this.map.get(D);E||(E=new Set,this.map.set(D,E)),E.add(g)}delete(D,g){const E=this.map.get(D);!E||(E.delete(g),E.size===0&&this.map.delete(D))}forEach(D,g){const E=this.map.get(D);!E||E.forEach(g)}}e.SetMap=T}),define(we[56],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(S){return(P,C,T)=>{let F=null,D=null;if(typeof T.value=="function"?(F="value",D=T.value):typeof T.get=="function"&&(F="get",D=T.get),!D)throw new Error("not supported");T[F]=S(D,C)}}e.createDecorator=h;function t(S,P,C){let T=null,F=null;if(typeof C.value=="function"?(T="value",F=C.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(T="get",F=C.get),!F)throw new Error("not supported");const D=`$memoize$${P}`;C[T]=function(...g){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,g)}),this[D]}}e.memoize=t;function k(S,P,C){return h((T,F)=>{const D=`$debounce$${F}`,g=`$debounce$result$${F}`;return function(...E){this[g]||(this[g]=C?C():void 0),clearTimeout(this[D]),P&&(this[g]=P(this[g],...E),E=[this[g]]),this[D]=setTimeout(()=>{T.apply(this,E),this[g]=C?C():void 0},S)}})}e.debounce=k;function A(S,P,C){return h((T,F)=>{const D=`$throttle$timer$${F}`,g=`$throttle$result$${F}`,E=`$throttle$lastRun$${F}`,f=`$throttle$pending$${F}`;return function(...u){if(this[g]||(this[g]=C?C():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...u)),this[f])return;const w=this[E]+S;w<=Date.now()?(this[E]=Date.now(),T.apply(this,[this[g]]),this[g]=C?C():void 0):(this[f]=!0,this[D]=setTimeout(()=>{this[f]=!1,this[E]=Date.now(),T.apply(this,[this[g]]),this[g]=C?C():void 0},w-Date.now()))}})}e.throttle=A}),define(we[16],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class h{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(b=>{b(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=h,e.errorHandler=new h;function t(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=t;function k(m){C(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=k;function A(m){C(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=A;function S(m){if(m instanceof Error){let{name:s,message:b}=m;const o=m.stacktrace||m.stack;return{$isError:!0,name:s,message:b,stack:o}}return m}e.transformErrorForSerialization=S;const P="Canceled";function C(m){return m instanceof T?!0:m instanceof Error&&m.name===P&&m.message===P}e.isCancellationError=C;class T extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=T;function F(){const m=new Error(P);return m.name=m.message,m}e.canceled=F;function D(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=D;function g(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=g;function E(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function f(m){const s=new Error(`${m} has been disposed`);return s.name="DISPOSED",s}e.disposed=f;function u(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=u;class w extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=w;class y extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=y;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function a(m){const s=m;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=a;function c(m,s=Object.create(null)){const b=new Error(m);return s.actions&&(b.actions=s.actions),b}e.createErrorWithActions=c}),define(we[17],be([1,0,16]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(ee,Q=0){return ee[ee.length-(1+Q)]}e.tail=t;function k(ee){if(ee.length===0)throw new Error("Invalid tail call");return[ee.slice(0,ee.length-1),ee[ee.length-1]]}e.tail2=k;function A(ee,Q,oe=(de,ve)=>de===ve){if(ee===Q)return!0;if(!ee||!Q||ee.length!==Q.length)return!1;for(let de=0,ve=ee.length;de<ve;de++)if(!oe(ee[de],Q[de]))return!1;return!0}e.equals=A;function S(ee,Q,oe){let de=0,ve=ee.length-1;for(;de<=ve;){const ke=(de+ve)/2|0,Ne=oe(ee[ke],Q);if(Ne<0)de=ke+1;else if(Ne>0)ve=ke-1;else return ke}return-(de+1)}e.binarySearch=S;function P(ee,Q){let oe=0,de=ee.length;if(de===0)return 0;for(;oe<de;){const ve=Math.floor((oe+de)/2);Q(ee[ve])?de=ve:oe=ve+1}return oe}e.findFirstInSorted=P;function C(ee,Q,oe){if(ee=ee|0,ee>=Q.length)throw new TypeError("invalid index");let de=Q[Math.floor(Q.length*Math.random())],ve=[],ke=[],Ne=[];for(let _e of Q){const Ee=oe(_e,de);Ee<0?ve.push(_e):Ee>0?ke.push(_e):Ne.push(_e)}return ee<ve.length?C(ee,ve,oe):ee<ve.length+Ne.length?Ne[0]:C(ee-(ve.length+Ne.length),ke,oe)}e.quickSelect=C;function T(ee,Q){const oe=[];let de;for(const ve of ee.slice(0).sort(Q))!de||Q(de[0],ve)!==0?(de=[ve],oe.push(de)):de.push(ve);return oe}e.groupBy=T;function F(ee,Q,oe){const de=[];function ve(_e,Ee,z){if(Ee===0&&z.length===0)return;const W=de[de.length-1];W&&W.start+W.deleteCount===_e?(W.deleteCount+=Ee,W.toInsert.push(...z)):de.push({start:_e,deleteCount:Ee,toInsert:z})}let ke=0,Ne=0;for(;;){if(ke===ee.length){ve(ke,0,Q.slice(Ne));break}if(Ne===Q.length){ve(ke,ee.length-ke,[]);break}const _e=ee[ke],Ee=Q[Ne],z=oe(_e,Ee);z===0?(ke+=1,Ne+=1):z<0?(ve(ke,1,[]),ke+=1):z>0&&(ve(ke,0,[Ee]),Ne+=1)}return de}e.sortedDiff=F;function D(ee,Q,oe){const de=F(ee,Q,oe),ve=[],ke=[];for(const Ne of de)ve.push(...ee.slice(Ne.start,Ne.start+Ne.deleteCount)),ke.push(...Ne.toInsert);return{removed:ve,added:ke}}e.delta=D;function g(ee,Q,oe){if(oe===0)return[];const de=ee.slice(0,oe).sort(Q);return f(ee,Q,de,oe,ee.length),de}e.top=g;function E(ee,Q,oe,de,ve){return oe===0?Promise.resolve([]):new Promise((ke,Ne)=>{(async()=>{const _e=ee.length,Ee=ee.slice(0,oe).sort(Q);for(let z=oe,W=Math.min(oe+de,_e);z<_e;z=W,W=Math.min(W+de,_e)){if(z>oe&&await new Promise(N=>setTimeout(N)),ve&&ve.isCancellationRequested)throw(0,h.canceled)();f(ee,Q,Ee,z,W)}return Ee})().then(ke,Ne)})}e.topAsync=E;function f(ee,Q,oe,de,ve){for(const ke=oe.length;de<ve;de++){const Ne=ee[de];if(Q(Ne,oe[ke-1])<0){oe.pop();const _e=P(oe,Ee=>Q(Ne,Ee)<0);oe.splice(_e,0,Ne)}}}function u(ee){return ee.filter(Q=>!!Q)}e.coalesce=u;function w(ee){let Q=0;for(let oe=0;oe<ee.length;oe++)ee[oe]&&(ee[Q]=ee[oe],Q+=1);ee.length=Q}e.coalesceInPlace=w;function y(ee,Q,oe){ee.splice(oe,0,ee.splice(Q,1)[0])}e.move=y;function I(ee){return!Array.isArray(ee)||ee.length===0}e.isFalsyOrEmpty=I;function a(ee){return Array.isArray(ee)&&ee.length>0}e.isNonEmptyArray=a;function c(ee,Q=oe=>oe){const oe=new Set;return ee.filter(de=>{const ve=Q(de);return oe.has(ve)?!1:(oe.add(ve),!0)})}e.distinct=c;function m(ee){const Q=new Set;return oe=>{const de=ee(oe);return Q.has(de)?!1:(Q.add(de),!0)}}e.uniqueFilter=m;function s(ee,Q){const oe=b(ee,Q);if(oe!==-1)return ee[oe]}e.findLast=s;function b(ee,Q){for(let oe=ee.length-1;oe>=0;oe--){const de=ee[oe];if(Q(de))return oe}return-1}e.lastIndex=b;function o(ee,Q){return ee.length>0?ee[0]:Q}e.firstOrDefault=o;function n(ee,Q,oe=(de,ve)=>de===ve){let de=0;for(let ve=0,ke=Math.min(ee.length,Q.length);ve<ke&&oe(ee[ve],Q[ve]);ve++)de++;return de}e.commonPrefixLength=n;function i(ee){return[].concat(...ee)}e.flatten=i;function r(ee,Q){let oe=typeof Q=="number"?ee:0;typeof Q=="number"?oe=ee:(oe=0,Q=ee);const de=[];if(oe<=Q)for(let ve=oe;ve<Q;ve++)de.push(ve);else for(let ve=oe;ve>Q;ve--)de.push(ve);return de}e.range=r;function l(ee,Q,oe){return ee.reduce((de,ve)=>(de[Q(ve)]=oe?oe(ve):ve,de),Object.create(null))}e.index=l;function p(ee,Q){return ee.push(Q),()=>d(ee,Q)}e.insert=p;function d(ee,Q){const oe=ee.indexOf(Q);if(oe>-1)return ee.splice(oe,1),Q}e.remove=d;function v(ee,Q,oe){const de=ee.slice(0,Q),ve=ee.slice(Q);return de.concat(oe,ve)}e.arrayInsert=v;function R(ee,Q){let oe;if(typeof Q=="number"){let de=Q;oe=()=>{const ve=Math.sin(de++)*179426549;return ve-Math.floor(ve)}}else oe=Math.random;for(let de=ee.length-1;de>0;de-=1){const ve=Math.floor(oe()*(de+1)),ke=ee[de];ee[de]=ee[ve],ee[ve]=ke}}e.shuffle=R;function O(ee,Q){const oe=ee.indexOf(Q);oe>-1&&(ee.splice(oe,1),ee.unshift(Q))}e.pushToStart=O;function L(ee,Q){const oe=ee.indexOf(Q);oe>-1&&(ee.splice(oe,1),ee.push(Q))}e.pushToEnd=L;function _(ee,Q){return Array.isArray(ee)?ee.map(Q):Q(ee)}e.mapArrayOrNot=_;function U(ee){return Array.isArray(ee)?ee:[ee]}e.asArray=U;function M(ee){return ee[Math.floor(Math.random()*ee.length)]}e.getRandomElement=M;function q(ee,Q){for(const oe of ee){const de=Q(oe);if(de!==void 0)return de}}e.mapFind=q;function K(ee,Q,oe){const de=B(ee,Q),ve=ee.length,ke=oe.length;ee.length=ve+ke;for(let Ne=ve-1;Ne>=de;Ne--)ee[Ne+ke]=ee[Ne];for(let Ne=0;Ne<ke;Ne++)ee[Ne+de]=oe[Ne]}e.insertInto=K;function x(ee,Q,oe,de){const ve=B(ee,Q),ke=ee.splice(ve,oe);return K(ee,ve,de),ke}e.splice=x;function B(ee,Q){return Q<0?Math.max(Q+ee.length,0):Math.min(Q,ee.length)}function G(ee,Q){return(oe,de)=>Q(ee(oe),ee(de))}e.compareBy=G;const X=(ee,Q)=>ee-Q;e.numberComparator=X;function V(ee,Q){if(ee.length===0)return;let oe=ee[0];for(let de=1;de<ee.length;de++){const ve=ee[de];Q(ve,oe)>0&&(oe=ve)}return oe}e.findMaxBy=V;function Z(ee,Q){if(ee.length===0)return;let oe=ee[0];for(let de=1;de<ee.length;de++){const ve=ee[de];Q(ve,oe)>=0&&(oe=ve)}return oe}e.findLastMaxBy=Z;function se(ee,Q){return V(ee,(oe,de)=>-Q(oe,de))}e.findMinBy=se;class ce{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let oe=this.firstIdx;for(;oe<this.items.length&&Q(this.items[oe]);)oe++;const de=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,de}takeFromEndWhile(Q){let oe=this.lastIdx;for(;oe>=0&&Q(this.items[oe]);)oe--;const de=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,de}peek(){return this.items[this.firstIdx]}dequeue(){const Q=this.items[this.firstIdx];return this.firstIdx++,Q}takeCount(Q){const oe=this.items.slice(this.firstIdx,this.firstIdx+Q);return this.firstIdx+=Q,oe}}e.ArrayQueue=ce}),define(we[75],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function h(t){const k=this;let A=!1,S;return function(){return A||(A=!0,S=t.apply(k,arguments)),S}}e.once=h}),define(we[76],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(we[77],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(t){function k(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}t.is=k;const A=Object.freeze([]);function S(){return A}t.empty=S;function*P(m){yield m}t.single=P;function C(m){return m||A}t.from=C;function T(m){return!m||m[Symbol.iterator]().next().done===!0}t.isEmpty=T;function F(m){return m[Symbol.iterator]().next().value}t.first=F;function D(m,s){for(const b of m)if(s(b))return!0;return!1}t.some=D;function g(m,s){for(const b of m)if(s(b))return b}t.find=g;function*E(m,s){for(const b of m)s(b)&&(yield b)}t.filter=E;function*f(m,s){let b=0;for(const o of m)yield s(o,b++)}t.map=f;function*u(...m){for(const s of m)for(const b of s)yield b}t.concat=u;function*w(m){for(const s of m)for(const b of s)yield b}t.concatNested=w;function y(m,s,b){let o=b;for(const n of m)o=s(o,n);return o}t.reduce=y;function*I(m,s,b=m.length){for(s<0&&(s+=m.length),b<0?b+=m.length:b>m.length&&(b=m.length);s<b;s++)yield m[s]}t.slice=I;function a(m,s=Number.POSITIVE_INFINITY){const b=[];if(s===0)return[b,m];const o=m[Symbol.iterator]();for(let n=0;n<s;n++){const i=o.next();if(i.done)return[b,t.empty()];b.push(i.value)}return[b,{[Symbol.iterator](){return o}}]}t.consume=a;function c(m,s,b=(o,n)=>o===n){const o=m[Symbol.iterator](),n=s[Symbol.iterator]();for(;;){const i=o.next(),r=n.next();if(i.done!==r.done)return!1;if(i.done)return!0;if(!b(i.value,r.value))return!1}}t.equals=c})(h=e.Iterable||(e.Iterable={}))}),define(we[57],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function S(s,b=!1){let o=0,n=s.length,i="",r=0,l=16,p=0;function d(M){let q=0,K=0;for(;q<M;){const x=s.charCodeAt(o);if(x>=48&&x<=57)K=K*16+x-48;else if(x>=65&&x<=70)K=K*16+x-65+10;else if(x>=97&&x<=102)K=K*16+x-97+10;else break;o++,q++}return q<M&&(K=-1),K}function v(M){o=M,i="",r=0,l=16,p=0}function R(){const M=o;if(s.charCodeAt(o)===48)o++;else for(o++;o<s.length&&T(s.charCodeAt(o));)o++;if(o<s.length&&s.charCodeAt(o)===46)if(o++,o<s.length&&T(s.charCodeAt(o)))for(o++;o<s.length&&T(s.charCodeAt(o));)o++;else return p=3,s.substring(M,o);let q=o;if(o<s.length&&(s.charCodeAt(o)===69||s.charCodeAt(o)===101))if(o++,(o<s.length&&s.charCodeAt(o)===43||s.charCodeAt(o)===45)&&o++,o<s.length&&T(s.charCodeAt(o))){for(o++;o<s.length&&T(s.charCodeAt(o));)o++;q=o}else p=3;return s.substring(M,q)}function O(){let M="",q=o;for(;;){if(o>=n){M+=s.substring(q,o),p=2;break}const K=s.charCodeAt(o);if(K===34){M+=s.substring(q,o),o++;break}if(K===92){if(M+=s.substring(q,o),o++,o>=n){p=2;break}switch(s.charCodeAt(o++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const B=d(4);B>=0?M+=String.fromCharCode(B):p=4;break}default:p=5}q=o;continue}if(K>=0&&K<=31)if(C(K)){M+=s.substring(q,o),p=2;break}else p=6;o++}return M}function L(){if(i="",p=0,r=o,o>=n)return r=n,l=17;let M=s.charCodeAt(o);if(P(M)){do o++,i+=String.fromCharCode(M),M=s.charCodeAt(o);while(P(M));return l=15}if(C(M))return o++,i+=String.fromCharCode(M),M===13&&s.charCodeAt(o)===10&&(o++,i+=`
`),l=14;switch(M){case 123:return o++,l=1;case 125:return o++,l=2;case 91:return o++,l=3;case 93:return o++,l=4;case 58:return o++,l=6;case 44:return o++,l=5;case 34:return o++,i=O(),l=10;case 47:{const q=o-1;if(s.charCodeAt(o+1)===47){for(o+=2;o<n&&!C(s.charCodeAt(o));)o++;return i=s.substring(q,o),l=12}if(s.charCodeAt(o+1)===42){o+=2;const K=n-1;let x=!1;for(;o<K;){if(s.charCodeAt(o)===42&&s.charCodeAt(o+1)===47){o+=2,x=!0;break}o++}return x||(o++,p=1),i=s.substring(q,o),l=13}return i+=String.fromCharCode(M),o++,l=16}case 45:if(i+=String.fromCharCode(M),o++,o===n||!T(s.charCodeAt(o)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=R(),l=11;default:for(;o<n&&_(M);)o++,M=s.charCodeAt(o);if(r!==o){switch(i=s.substring(r,o),i){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return i+=String.fromCharCode(M),o++,l=16}}function _(M){if(P(M)||C(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let M;do M=L();while(M>=12&&M<=15);return M}return{setPosition:v,getPosition:()=>o,scan:b?U:L,getToken:()=>l,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>o-r,getTokenError:()=>p}}e.createScanner=S;function P(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function C(s){return s===10||s===13||s===8232||s===8233}function T(s){return s>=48&&s<=57}var F;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(F||(F={}));function D(s,b){const o=[],n=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function p(d,v,R,O){r.value=d,r.offset=v,r.length=R,r.type=O,r.colonOffset=void 0,i=r}try{a(s,{onObjectBegin:(d,v)=>{if(b<=d)throw n;i=void 0,l=b>d,o.push("")},onObjectProperty:(d,v,R)=>{if(b<v||(p(d,v,R,"property"),o[o.length-1]=d,b<=v+R))throw n},onObjectEnd:(d,v)=>{if(b<=d)throw n;i=void 0,o.pop()},onArrayBegin:(d,v)=>{if(b<=d)throw n;i=void 0,o.push(0)},onArrayEnd:(d,v)=>{if(b<=d)throw n;i=void 0,o.pop()},onLiteralValue:(d,v,R)=>{if(b<v||(p(d,v,R,m(d)),b<=v+R))throw n},onSeparator:(d,v,R)=>{if(b<=v)throw n;if(d===":"&&i&&i.type==="property")i.colonOffset=v,l=!1,i=void 0;else if(d===","){const O=o[o.length-1];typeof O=="number"?o[o.length-1]=O+1:(l=!0,o[o.length-1]=""),i=void 0}}})}catch(d){if(d!==n)throw d}return{path:o,previousNode:i,isAtPropertyKey:l,matches:d=>{let v=0;for(let R=0;v<d.length&&R<o.length;R++)if(d[v]===o[R]||d[v]==="*")v++;else if(d[v]!=="**")return!1;return v===d.length}}}e.getLocation=D;function g(s,b=[],o=A.DEFAULT){let n=null,i=[];const r=[];function l(d){Array.isArray(i)?i.push(d):n!==null&&(i[n]=d)}return a(s,{onObjectBegin:()=>{const d={};l(d),r.push(i),i=d,n=null},onObjectProperty:d=>{n=d},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const d=[];l(d),r.push(i),i=d,n=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:l,onError:(d,v,R)=>{b.push({error:d,offset:v,length:R})}},o),i[0]}e.parse=g;function E(s,b=[],o=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(d){n.type==="property"&&(n.length=d-n.offset,n=n.parent)}function r(d){return n.children.push(d),d}a(s,{onObjectBegin:d=>{n=r({type:"object",offset:d,length:-1,parent:n,children:[]})},onObjectProperty:(d,v,R)=>{n=r({type:"property",offset:v,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:d,offset:v,length:R,parent:n})},onObjectEnd:(d,v)=>{n.length=d+v-n.offset,n=n.parent,i(d+v)},onArrayBegin:(d,v)=>{n=r({type:"array",offset:d,length:-1,parent:n,children:[]})},onArrayEnd:(d,v)=>{n.length=d+v-n.offset,n=n.parent,i(d+v)},onLiteralValue:(d,v,R)=>{r({type:m(d),offset:v,length:R,parent:n,value:d}),i(v+R)},onSeparator:(d,v,R)=>{n.type==="property"&&(d===":"?n.colonOffset=v:d===","&&i(v))},onError:(d,v,R)=>{b.push({error:d,offset:v,length:R})}},o);const p=n.children[0];return p&&delete p.parent,p}e.parseTree=E;function f(s,b){if(!s)return;let o=s;for(let n of b)if(typeof n=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let i=!1;for(const r of o.children)if(Array.isArray(r.children)&&r.children[0].value===n){o=r.children[1],i=!0;break}if(!i)return}else{const i=n;if(o.type!=="array"||i<0||!Array.isArray(o.children)||i>=o.children.length)return;o=o.children[i]}return o}e.findNodeAtLocation=f;function u(s){if(!s.parent||!s.parent.children)return[];const b=u(s.parent);if(s.parent.type==="property"){const o=s.parent.children[0].value;b.push(o)}else if(s.parent.type==="array"){const o=s.parent.children.indexOf(s);o!==-1&&b.push(o)}return b}e.getNodePath=u;function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const b=Object.create(null);for(let o of s.children){const n=o.children[1];n&&(b[o.children[0].value]=w(n))}return b}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=w;function y(s,b,o=!1){return b>=s.offset&&b<s.offset+s.length||o&&b===s.offset+s.length}e.contains=y;function I(s,b,o=!1){if(y(s,b,o)){const n=s.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=b;i++){const r=I(n[i],b,o);if(r)return r}return s}}e.findNodeAtOffset=I;function a(s,b,o=A.DEFAULT){const n=S(s,!1);function i(ce){return ce?()=>ce(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(ce){return ce?ee=>ce(ee,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=i(b.onObjectBegin),p=r(b.onObjectProperty),d=i(b.onObjectEnd),v=i(b.onArrayBegin),R=i(b.onArrayEnd),O=r(b.onLiteralValue),L=r(b.onSeparator),_=i(b.onComment),U=r(b.onError),M=o&&o.disallowComments,q=o&&o.allowTrailingComma;function K(){for(;;){const ce=n.scan();switch(n.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:M||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ce){case 12:case 13:M?x(10):_();break;case 16:x(1);break;case 15:case 14:break;default:return ce}}}function x(ce,ee=[],Q=[]){if(U(ce),ee.length+Q.length>0){let oe=n.getToken();for(;oe!==17;){if(ee.indexOf(oe)!==-1){K();break}else if(Q.indexOf(oe)!==-1)break;oe=K()}}}function B(ce){const ee=n.getTokenValue();return ce?O(ee):p(ee),K(),!0}function G(){switch(n.getToken()){case 11:{let ce=0;try{ce=JSON.parse(n.getTokenValue()),typeof ce!="number"&&(x(2),ce=0)}catch{x(2)}O(ce);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return K(),!0}function X(){return n.getToken()!==10?(x(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(L(":"),K(),se()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){l(),K();let ce=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ce||x(4,[],[]),L(","),K(),n.getToken()===2&&q)break}else ce&&x(6,[],[]);X()||x(4,[],[2,5]),ce=!0}return d(),n.getToken()!==2?x(7,[2],[]):K(),!0}function Z(){v(),K();let ce=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ce||x(4,[],[]),L(","),K(),n.getToken()===4&&q)break}else ce&&x(6,[],[]);se()||x(4,[],[4,5]),ce=!0}return R(),n.getToken()!==4?x(8,[4],[]):K(),!0}function se(){switch(n.getToken()){case 3:return Z();case 1:return V();case 10:return B(!0);default:return G()}}return K(),n.getToken()===17?o.allowEmptyContent?!0:(x(4,[],[]),!1):se()?(n.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=a;function c(s,b){let o=S(s),n=[],i,r=0,l;do switch(l=o.getPosition(),i=o.scan(),i){case 12:case 13:case 17:r!==l&&n.push(s.substring(r,l)),b!==void 0&&n.push(o.getTokenValue().replace(/[^\r\n]/g,b)),r=o.getPosition();break}while(i!==17);return n.join("")}e.stripComments=c;function m(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(we[142],be([1,0,57]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(T,F,D){let g,E,f,u,w;if(F){for(u=F.offset,w=u+F.length,f=u;f>0&&!C(T,f-1);)f--;let l=w;for(;l<T.length&&!C(T,l);)l++;E=T.substring(f,l),g=S(E,D)}else E=T,g=0,f=0,u=0,w=T.length;const y=P(D,T);let I=!1,a=0,c;D.insertSpaces?c=A(" ",D.tabSize||4):c="	";const m=(0,h.createScanner)(E,!1);let s=!1;function b(){return y+A(c,g+a)}function o(){let l=m.scan();for(I=!1;l===15||l===14;)I=I||l===14,l=m.scan();return s=l===16||m.getTokenError()!==0,l}const n=[];function i(l,p,d){!s&&p<w&&d>u&&T.substring(p,d)!==l&&n.push({offset:p,length:d-p,content:l})}let r=o();if(r!==17){const l=m.getTokenOffset()+f,p=A(c,g);i(p,f,l)}for(;r!==17;){let l=m.getTokenOffset()+m.getTokenLength()+f,p=o(),d="";for(;!I&&(p===12||p===13);){const R=m.getTokenOffset()+f;i(" ",l,R),l=m.getTokenOffset()+m.getTokenLength()+f,d=p===12?b():"",p=o()}if(p===2)r!==1&&(a--,d=b());else if(p===4)r!==3&&(a--,d=b());else{switch(r){case 3:case 1:a++,d=b();break;case 5:case 12:d=b();break;case 13:I?d=b():d=" ";break;case 6:d=" ";break;case 10:if(p===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?d=" ":p!==5&&p!==17&&(s=!0);break;case 16:s=!0;break}I&&(p===12||p===13)&&(d=b())}const v=m.getTokenOffset()+f;i(d,l,v),r=p}return n}e.format=t;function k(T,F){const D=JSON.stringify(T,void 0,F.insertSpaces?F.tabSize||4:"	");return F.eol!==void 0?D.replace(/\r\n|\r|\n/g,F.eol):D}e.toFormattedString=k;function A(T,F){let D="";for(let g=0;g<F;g++)D+=T;return D}function S(T,F){let D=0,g=0;const E=F.tabSize||4;for(;D<T.length;){const f=T.charAt(D);if(f===" ")g++;else if(f==="	")g+=E;else break;D++}return Math.floor(g/E)}function P(T,F){for(let D=0;D<F.length;D++){const g=F.charAt(D);if(g==="\r")return D+1<F.length&&F.charAt(D+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return T&&T.eol||`
`}e.getEOL=P;function C(T,F){return`\r
`.indexOf(T.charAt(F))!==-1}e.isEOL=C}),define(we[143],be([1,0,57,142]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(T,F,D){return A(T,F,void 0,D)}e.removeProperty=k;function A(T,F,D,g,E){const f=F.slice(),u=[],w=(0,h.parseTree)(T,u);let y,I;for(;f.length>0&&(I=f.pop(),y=(0,h.findNodeAtLocation)(w,f),y===void 0&&D!==void 0);)typeof I=="string"?D={[I]:D}:D=[D];if(y)if(y.type==="object"&&typeof I=="string"&&Array.isArray(y.children)){const a=(0,h.findNodeAtLocation)(y,[I]);if(a!==void 0)if(D===void 0){if(!a.parent)throw new Error("Malformed AST");const c=y.children.indexOf(a.parent);let m,s=a.parent.offset+a.parent.length;if(c>0){const b=y.children[c-1];m=b.offset+b.length}else m=y.offset+1,y.children.length>1&&(s=y.children[1].offset);return S(T,{offset:m,length:s-m,content:""},g)}else return S(T,{offset:a.offset,length:a.length,content:JSON.stringify(D)},g);else{if(D===void 0)return[];const c=`${JSON.stringify(I)}: ${JSON.stringify(D)}`,m=E?E(y.children.map(b=>b.children[0].value)):y.children.length;let s;if(m>0){const b=y.children[m-1];s={offset:b.offset+b.length,length:0,content:","+c}}else y.children.length===0?s={offset:y.offset+1,length:0,content:c}:s={offset:y.offset+1,length:0,content:c+","};return S(T,s,g)}}else if(y.type==="array"&&typeof I=="number"&&Array.isArray(y.children))if(D!==void 0){const a=`${JSON.stringify(D)}`;let c;if(y.children.length===0||I===0)c={offset:y.offset+1,length:0,content:y.children.length===0?a:a+","};else{const m=I===-1||I>y.children.length?y.children.length:I,s=y.children[m-1];c={offset:s.offset+s.length,length:0,content:","+a}}return S(T,c,g)}else{const a=I,c=y.children[a];let m;if(y.children.length===1)m={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===a){const s=y.children[a-1],b=s.offset+s.length,o=y.offset+y.length;m={offset:b,length:o-2-b,content:""}}else m={offset:c.offset,length:y.children[a+1].offset-c.offset,content:""};return S(T,m,g)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${y.type}`);else{if(D===void 0)throw new Error("Can not delete in empty document");return S(T,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(D)},g)}}e.setProperty=A;function S(T,F,D){let g=P(T,F),E=F.offset,f=F.offset+F.content.length;if(F.length===0||F.content.length===0){for(;E>0&&!(0,t.isEOL)(g,E-1);)E--;for(;f<g.length&&!(0,t.isEOL)(g,f);)f++}const u=(0,t.format)(g,{offset:E,length:f-E},D);for(let y=u.length-1;y>=0;y--){const I=u[y];g=P(g,I),E=Math.min(E,I.offset),f=Math.max(f,I.offset+I.length),f+=I.content.length-I.length}const w=T.length-(g.length-f)-E;return[{offset:E,length:w,content:g.substring(E,f)}]}e.withFormatting=S;function P(T,F){return T.substring(0,F.offset)+F.content+T.substring(F.offset+F.length)}e.applyEdit=P;function C(T,F){let D=F.slice(0).sort((E,f)=>{const u=E.offset-f.offset;return u===0?E.length-f.length:u}),g=T.length;for(let E=D.length-1;E>=0;E--){let f=D[E];if(f.offset+f.length<=g)T=P(T,f);else throw new Error("Overlapping edit");g=f.offset}return T}e.applyEdits=C}),define(we[92],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new h(()=>k(this.getValue()))}}e.Lazy=h}),define(we[6],be([1,0,75,77]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let A=null;function S(n){A=n}if(e.setDisposableTracker=S,k){const n="__is_disposable_tracked__";S(new class{trackDisposable(i){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[n]||console.log(r)},3e3)}setParent(i,r){if(i&&i!==I.None)try{i[n]=!0}catch{}}markAsDisposed(i){if(i&&i!==I.None)try{i[n]=!0}catch{}}markAsSingleton(i){}})}function P(n){return A?.trackDisposable(n),n}function C(n){A?.markAsDisposed(n)}function T(n,i){A?.setParent(n,i)}function F(n,i){if(!!A)for(const r of n)A.setParent(r,i)}function D(n){return A?.markAsSingleton(n),n}e.markAsSingleton=D;class g extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=g;function E(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=E;function f(n){if(t.Iterable.is(n)){let i=[];for(const r of n)if(r)try{r.dispose()}catch(l){i.push(l)}if(i.length===1)throw i[0];if(i.length>1)throw new g(i);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=f;function u(...n){const i=w(()=>f(n));return F(n,i),i}e.combinedDisposable=u;function w(n){const i=P({dispose:(0,h.once)(()=>{C(i),n()})});return i}e.toDisposable=w;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return T(i,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new y,P(this),T(this._store,this)}dispose(){C(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&T(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&T(i,null),i}}e.MutableDisposable=a;class c{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class m{constructor(){this.references=new Map}acquire(i,...r){let l=this.references.get(i);l||(l={counter:0,object:this.createReferencedObject(i,...r)},this.references.set(i,l));const{object:p}=l,d=(0,h.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(i,l.object),this.references.delete(i))});return l.counter++,{object:p,dispose:d}}}e.ReferenceCollection=m;class s{constructor(i){this.referenceCollection=i}async acquire(i,...r){const l=this.referenceCollection.acquire(i,...r);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(p){throw l.dispose(),p}}}e.AsyncReferenceCollection=s;class b{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=b;function o(n){const i=new y;try{n(i)}finally{i.dispose()}}e.disposeOnReturn=o}),define(we[93],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class h{constructor(A){this.element=A,this.next=h.Undefined,this.prev=h.Undefined}}h.Undefined=new h(void 0);class t{constructor(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===h.Undefined}clear(){let A=this._first;for(;A!==h.Undefined;){const S=A.next;A.prev=h.Undefined,A.next=h.Undefined,A=S}this._first=h.Undefined,this._last=h.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,S){const P=new h(A);if(this._first===h.Undefined)this._first=P,this._last=P;else if(S){const T=this._last;this._last=P,P.prev=T,T.next=P}else{const T=this._first;this._first=P,P.next=T,T.prev=P}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(P))}}shift(){if(this._first!==h.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==h.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==h.Undefined&&A.next!==h.Undefined){const S=A.prev;S.next=A.next,A.next.prev=S}else A.prev===h.Undefined&&A.next===h.Undefined?(this._first=h.Undefined,this._last=h.Undefined):A.next===h.Undefined?(this._last=this._last.prev,this._last.next=h.Undefined):A.prev===h.Undefined&&(this._first=this._first.next,this._first.prev=h.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==h.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(we[144],be([0]),e):(te=typeof globalThis!="undefined"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(_e,Ee){for(var z=0;z<Ee.length;z++){var W=Ee[z];W.enumerable=W.enumerable||!1,W.configurable=!0,"value"in W&&(W.writable=!0),Object.defineProperty(_e,W.key,W)}}function h(_e,Ee,z){return Ee&&e(_e.prototype,Ee),z&&e(_e,z),Object.defineProperty(_e,"prototype",{writable:!1}),_e}function t(_e,Ee){if(!!_e){if(typeof _e=="string")return k(_e,Ee);var z=Object.prototype.toString.call(_e).slice(8,-1);if(z==="Object"&&_e.constructor&&(z=_e.constructor.name),z==="Map"||z==="Set")return Array.from(_e);if(z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(z))return k(_e,Ee)}}function k(_e,Ee){(Ee==null||Ee>_e.length)&&(Ee=_e.length);for(var z=0,W=new Array(Ee);z<Ee;z++)W[z]=_e[z];return W}function A(_e,Ee){var z=typeof Symbol!="undefined"&&_e[Symbol.iterator]||_e["@@iterator"];if(z)return(z=z.call(_e)).next.bind(z);if(Array.isArray(_e)||(z=t(_e))||Ee&&_e&&typeof _e.length=="number"){z&&(_e=z);var W=0;return function(){return W>=_e.length?{done:!0}:{done:!1,value:_e[W++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=S();function P(_e){te.defaults=_e}var C=/[&<>"']/,T=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Ee){return g[Ee]};function f(_e,Ee){if(Ee){if(C.test(_e))return _e.replace(T,E)}else if(F.test(_e))return _e.replace(D,E);return _e}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(_e){return _e.replace(u,function(Ee,z){return z=z.toLowerCase(),z==="colon"?":":z.charAt(0)==="#"?z.charAt(1)==="x"?String.fromCharCode(parseInt(z.substring(2),16)):String.fromCharCode(+z.substring(1)):""})}var y=/(^|[^\[])\^/g;function I(_e,Ee){_e=_e.source||_e,Ee=Ee||"";var z={replace:function(N,$){return $=$.source||$,$=$.replace(y,"$1"),_e=_e.replace(N,$),z},getRegex:function(){return new RegExp(_e,Ee)}};return z}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(_e,Ee,z){if(_e){var W;try{W=decodeURIComponent(w(z)).replace(a,"").toLowerCase()}catch{return null}if(W.indexOf("javascript:")===0||W.indexOf("vbscript:")===0||W.indexOf("data:")===0)return null}Ee&&!c.test(z)&&(z=i(Ee,z));try{z=encodeURI(z).replace(/%25/g,"%")}catch{return null}return z}var s={},b=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(_e,Ee){s[" "+_e]||(b.test(_e)?s[" "+_e]=_e+"/":s[" "+_e]=d(_e,"/",!0)),_e=s[" "+_e];var z=_e.indexOf(":")===-1;return Ee.substring(0,2)==="//"?z?Ee:_e.replace(o,"$1")+Ee:Ee.charAt(0)==="/"?z?Ee:_e.replace(n,"$1")+Ee:_e+Ee}var r={exec:function(){}};function l(_e){for(var Ee=1,z,W;Ee<arguments.length;Ee++){z=arguments[Ee];for(W in z)Object.prototype.hasOwnProperty.call(z,W)&&(_e[W]=z[W])}return _e}function p(_e,Ee){var z=_e.replace(/\|/g,function($,j,re){for(var he=!1,Ce=j;--Ce>=0&&re[Ce]==="\\";)he=!he;return he?"|":" |"}),W=z.split(/ \|/),N=0;if(W[0].trim()||W.shift(),W[W.length-1].trim()||W.pop(),W.length>Ee)W.splice(Ee);else for(;W.length<Ee;)W.push("");for(;N<W.length;N++)W[N]=W[N].trim().replace(/\\\|/g,"|");return W}function d(_e,Ee,z){var W=_e.length;if(W===0)return"";for(var N=0;N<W;){var $=_e.charAt(W-N-1);if($===Ee&&!z)N++;else if($!==Ee&&z)N++;else break}return _e.substr(0,W-N)}function v(_e,Ee){if(_e.indexOf(Ee[1])===-1)return-1;for(var z=_e.length,W=0,N=0;N<z;N++)if(_e[N]==="\\")N++;else if(_e[N]===Ee[0])W++;else if(_e[N]===Ee[1]&&(W--,W<0))return N;return-1}function R(_e){_e&&_e.sanitize&&!_e.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(_e,Ee){if(Ee<1)return"";for(var z="";Ee>1;)Ee&1&&(z+=_e),Ee>>=1,_e+=_e;return z+_e}function L(_e,Ee,z,W){var N=Ee.href,$=Ee.title?f(Ee.title):null,j=_e[1].replace(/\\([\[\]])/g,"$1");if(_e[0].charAt(0)!=="!"){W.state.inLink=!0;var re={type:"link",raw:z,href:N,title:$,text:j,tokens:W.inlineTokens(j,[])};return W.state.inLink=!1,re}else return{type:"image",raw:z,href:N,title:$,text:f(j)}}function _(_e,Ee){var z=_e.match(/^(\s+)(?:```)/);if(z===null)return Ee;var W=z[1];return Ee.split(`
`).map(function(N){var $=N.match(/^\s+/);if($===null)return N;var j=$[0];return j.length>=W.length?N.slice(W.length):N}).join(`
`)}var U=function(){function _e(z){this.options=z||te.defaults}var Ee=_e.prototype;return Ee.space=function(W){var N=this.rules.block.newline.exec(W);if(N&&N[0].length>0)return{type:"space",raw:N[0]}},Ee.code=function(W){var N=this.rules.block.code.exec(W);if(N){var $=N[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:N[0],codeBlockStyle:"indented",text:this.options.pedantic?$:d($,`
`)}}},Ee.fences=function(W){var N=this.rules.block.fences.exec(W);if(N){var $=N[0],j=_($,N[3]||"");return{type:"code",raw:$,lang:N[2]?N[2].trim():N[2],text:j}}},Ee.heading=function(W){var N=this.rules.block.heading.exec(W);if(N){var $=N[2].trim();if(/#$/.test($)){var j=d($,"#");(this.options.pedantic||!j||/ $/.test(j))&&($=j.trim())}var re={type:"heading",raw:N[0],depth:N[1].length,text:$,tokens:[]};return this.lexer.inline(re.text,re.tokens),re}},Ee.hr=function(W){var N=this.rules.block.hr.exec(W);if(N)return{type:"hr",raw:N[0]}},Ee.blockquote=function(W){var N=this.rules.block.blockquote.exec(W);if(N){var $=N[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:N[0],tokens:this.lexer.blockTokens($,[]),text:$}}},Ee.list=function(W){var N=this.rules.block.list.exec(W);if(N){var $,j,re,he,Ce,Ae,We,$e,je,He,Ue,Qe,et=N[1].trim(),Re=et.length>1,tt={type:"list",raw:"",ordered:Re,start:Re?+et.slice(0,-1):"",loose:!1,items:[]};et=Re?"\\d{1,9}\\"+et.slice(-1):"\\"+et,this.options.pedantic&&(et=Re?et:"[*+-]");for(var ie=new RegExp("^( {0,3}"+et+")((?: [^\\n]*)?(?:\\n|$))");W&&(Qe=!1,!(!(N=ie.exec(W))||this.rules.block.hr.test(W)));){if($=N[0],W=W.substring($.length),$e=N[2].split(`
`,1)[0],je=W.split(`
`,1)[0],this.options.pedantic?(he=2,Ue=$e.trimLeft()):(he=N[2].search(/[^ ]/),he=he>4?1:he,Ue=$e.slice(he),he+=N[1].length),Ae=!1,!$e&&/^ *$/.test(je)&&($+=je+`
`,W=W.substring(je.length+1),Qe=!0),!Qe)for(var ae=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])");W&&(He=W.split(`
`,1)[0],$e=He,this.options.pedantic&&($e=$e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!ae.test($e));){if($e.search(/[^ ]/)>=he||!$e.trim())Ue+=`
`+$e.slice(he);else if(!Ae)Ue+=`
`+$e;else break;!Ae&&!$e.trim()&&(Ae=!0),$+=He+`
`,W=W.substring(He.length+1)}tt.loose||(We?tt.loose=!0:/\n *\n *$/.test($)&&(We=!0)),this.options.gfm&&(j=/^\[[ xX]\] /.exec(Ue),j&&(re=j[0]!=="[ ] ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),tt.items.push({type:"list_item",raw:$,task:!!j,checked:re,loose:!1,text:Ue}),tt.raw+=$}tt.items[tt.items.length-1].raw=$.trimRight(),tt.items[tt.items.length-1].text=Ue.trimRight(),tt.raw=tt.raw.trimRight();var J=tt.items.length;for(Ce=0;Ce<J;Ce++){this.lexer.state.top=!1,tt.items[Ce].tokens=this.lexer.blockTokens(tt.items[Ce].text,[]);var pe=tt.items[Ce].tokens.filter(function(Me){return Me.type==="space"}),Se=pe.every(function(Me){for(var ze=Me.raw.split(""),Ye=0,st=A(ze),pt;!(pt=st()).done;){var mt=pt.value;if(mt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!tt.loose&&pe.length&&Se&&(tt.loose=!0,tt.items[Ce].loose=!0)}return tt}},Ee.html=function(W){var N=this.rules.block.html.exec(W);if(N){var $={type:"html",raw:N[0],pre:!this.options.sanitizer&&(N[1]==="pre"||N[1]==="script"||N[1]==="style"),text:N[0]};return this.options.sanitize&&($.type="paragraph",$.text=this.options.sanitizer?this.options.sanitizer(N[0]):f(N[0]),$.tokens=[],this.lexer.inline($.text,$.tokens)),$}},Ee.def=function(W){var N=this.rules.block.def.exec(W);if(N){N[3]&&(N[3]=N[3].substring(1,N[3].length-1));var $=N[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$,raw:N[0],href:N[2],title:N[3]}}},Ee.table=function(W){var N=this.rules.block.table.exec(W);if(N){var $={type:"table",header:p(N[1]).map(function(We){return{text:We}}),align:N[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:N[3]?N[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($.header.length===$.align.length){$.raw=N[0];var j=$.align.length,re,he,Ce,Ae;for(re=0;re<j;re++)/^ *-+: *$/.test($.align[re])?$.align[re]="right":/^ *:-+: *$/.test($.align[re])?$.align[re]="center":/^ *:-+ *$/.test($.align[re])?$.align[re]="left":$.align[re]=null;for(j=$.rows.length,re=0;re<j;re++)$.rows[re]=p($.rows[re],$.header.length).map(function(We){return{text:We}});for(j=$.header.length,he=0;he<j;he++)$.header[he].tokens=[],this.lexer.inlineTokens($.header[he].text,$.header[he].tokens);for(j=$.rows.length,he=0;he<j;he++)for(Ae=$.rows[he],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=[],this.lexer.inlineTokens(Ae[Ce].text,Ae[Ce].tokens);return $}}},Ee.lheading=function(W){var N=this.rules.block.lheading.exec(W);if(N){var $={type:"heading",raw:N[0],depth:N[2].charAt(0)==="="?1:2,text:N[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Ee.paragraph=function(W){var N=this.rules.block.paragraph.exec(W);if(N){var $={type:"paragraph",raw:N[0],text:N[1].charAt(N[1].length-1)===`
`?N[1].slice(0,-1):N[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Ee.text=function(W){var N=this.rules.block.text.exec(W);if(N){var $={type:"text",raw:N[0],text:N[0],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Ee.escape=function(W){var N=this.rules.inline.escape.exec(W);if(N)return{type:"escape",raw:N[0],text:f(N[1])}},Ee.tag=function(W){var N=this.rules.inline.tag.exec(W);if(N)return!this.lexer.state.inLink&&/^<a /i.test(N[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(N[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(N[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(N[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:N[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(N[0]):f(N[0]):N[0]}},Ee.link=function(W){var N=this.rules.inline.link.exec(W);if(N){var $=N[2].trim();if(!this.options.pedantic&&/^</.test($)){if(!/>$/.test($))return;var j=d($.slice(0,-1),"\\");if(($.length-j.length)%2==0)return}else{var re=v(N[2],"()");if(re>-1){var he=N[0].indexOf("!")===0?5:4,Ce=he+N[1].length+re;N[2]=N[2].substring(0,re),N[0]=N[0].substring(0,Ce).trim(),N[3]=""}}var Ae=N[2],We="";if(this.options.pedantic){var $e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);$e&&(Ae=$e[1],We=$e[3])}else We=N[3]?N[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test($)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),L(N,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},N[0],this.lexer)}},Ee.reflink=function(W,N){var $;if(($=this.rules.inline.reflink.exec(W))||($=this.rules.inline.nolink.exec(W))){var j=($[2]||$[1]).replace(/\s+/g," ");if(j=N[j.toLowerCase()],!j||!j.href){var re=$[0].charAt(0);return{type:"text",raw:re,text:re}}return L($,j,$[0],this.lexer)}},Ee.emStrong=function(W,N,$){$===void 0&&($="");var j=this.rules.inline.emStrong.lDelim.exec(W);if(!!j&&!(j[3]&&$.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=j[1]||j[2]||"";if(!re||re&&($===""||this.rules.inline.punctuation.exec($))){var he=j[0].length-1,Ce,Ae,We=he,$e=0,je=j[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(je.lastIndex=0,N=N.slice(-1*W.length+he);(j=je.exec(N))!=null;)if(Ce=j[1]||j[2]||j[3]||j[4]||j[5]||j[6],!!Ce){if(Ae=Ce.length,j[3]||j[4]){We+=Ae;continue}else if((j[5]||j[6])&&he%3&&!((he+Ae)%3)){$e+=Ae;continue}if(We-=Ae,!(We>0)){if(Ae=Math.min(Ae,Ae+We+$e),Math.min(he,Ae)%2){var He=W.slice(1,he+j.index+Ae);return{type:"em",raw:W.slice(0,he+j.index+Ae+1),text:He,tokens:this.lexer.inlineTokens(He,[])}}var Ue=W.slice(2,he+j.index+Ae-1);return{type:"strong",raw:W.slice(0,he+j.index+Ae+1),text:Ue,tokens:this.lexer.inlineTokens(Ue,[])}}}}}},Ee.codespan=function(W){var N=this.rules.inline.code.exec(W);if(N){var $=N[2].replace(/\n/g," "),j=/[^ ]/.test($),re=/^ /.test($)&&/ $/.test($);return j&&re&&($=$.substring(1,$.length-1)),$=f($,!0),{type:"codespan",raw:N[0],text:$}}},Ee.br=function(W){var N=this.rules.inline.br.exec(W);if(N)return{type:"br",raw:N[0]}},Ee.del=function(W){var N=this.rules.inline.del.exec(W);if(N)return{type:"del",raw:N[0],text:N[2],tokens:this.lexer.inlineTokens(N[2],[])}},Ee.autolink=function(W,N){var $=this.rules.inline.autolink.exec(W);if($){var j,re;return $[2]==="@"?(j=f(this.options.mangle?N($[1]):$[1]),re="mailto:"+j):(j=f($[1]),re=j),{type:"link",raw:$[0],text:j,href:re,tokens:[{type:"text",raw:j,text:j}]}}},Ee.url=function(W,N){var $;if($=this.rules.inline.url.exec(W)){var j,re;if($[2]==="@")j=f(this.options.mangle?N($[0]):$[0]),re="mailto:"+j;else{var he;do he=$[0],$[0]=this.rules.inline._backpedal.exec($[0])[0];while(he!==$[0]);j=f($[0]),$[1]==="www."?re="http://"+j:re=j}return{type:"link",raw:$[0],text:j,href:re,tokens:[{type:"text",raw:j,text:j}]}}},Ee.inlineText=function(W,N){var $=this.rules.inline.text.exec(W);if($){var j;return this.lexer.state.inRawBlock?j=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($[0]):f($[0]):$[0]:j=f(this.options.smartypants?N($[0]):$[0]),{type:"text",raw:$[0],text:j}}},_e}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:r,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=I(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=I(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=I(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=I(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=I(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=I(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=l({},M),M.gfm=l({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=I(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=I(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=l({},M.normal,{html:I(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:r,paragraph:I(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:r,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:r,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=I(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=I(M._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=I(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=I(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=I(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=I(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=I(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=I(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=I(q.reflink).replace("label",q._label).replace("ref",M._label).getRegex(),q.nolink=I(q.nolink).replace("ref",M._label).getRegex(),q.reflinkSearch=I(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=l({},q),q.pedantic=l({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:I(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:I(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=l({},q.normal,{escape:I(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=I(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=l({},q.gfm,{br:I(q.br).replace("{2,}","*").getRegex(),text:I(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(_e){return _e.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(_e){var Ee="",z,W,N=_e.length;for(z=0;z<N;z++)W=_e.charCodeAt(z),Math.random()>.5&&(W="x"+W.toString(16)),Ee+="&#"+W+";";return Ee}var B=function(){function _e(z){this.tokens=[],this.tokens.links=Object.create(null),this.options=z||te.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var W={block:M.normal,inline:q.normal};this.options.pedantic?(W.block=M.pedantic,W.inline=q.pedantic):this.options.gfm&&(W.block=M.gfm,this.options.breaks?W.inline=q.breaks:W.inline=q.gfm),this.tokenizer.rules=W}_e.lex=function(W,N){var $=new _e(N);return $.lex(W)},_e.lexInline=function(W,N){var $=new _e(N);return $.inlineTokens(W)};var Ee=_e.prototype;return Ee.lex=function(W){W=W.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(W,this.tokens);for(var N;N=this.inlineQueue.shift();)this.inlineTokens(N.src,N.tokens);return this.tokens},Ee.blockTokens=function(W,N){var $=this;N===void 0&&(N=[]),this.options.pedantic&&(W=W.replace(/^ +$/gm,""));for(var j,re,he,Ce;W;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(j=We.call({lexer:$},W,N))?(W=W.substring(j.raw.length),N.push(j),!0):!1}))){if(j=this.tokenizer.space(W)){W=W.substring(j.raw.length),j.raw.length===1&&N.length>0?N[N.length-1].raw+=`
`:N.push(j);continue}if(j=this.tokenizer.code(W)){W=W.substring(j.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j);continue}if(j=this.tokenizer.fences(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.heading(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.hr(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.blockquote(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.list(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.html(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.def(W)){W=W.substring(j.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+j.raw,re.text+=`
`+j.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[j.tag]||(this.tokens.links[j.tag]={href:j.href,title:j.title});continue}if(j=this.tokenizer.table(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.lheading(W)){W=W.substring(j.raw.length),N.push(j);continue}if(he=W,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=1/0,$e=W.slice(1),je=void 0;$.options.extensions.startBlock.forEach(function(He){je=He.call({lexer:this},$e),typeof je=="number"&&je>=0&&(We=Math.min(We,je))}),We<1/0&&We>=0&&(he=W.substring(0,We+1))}(),this.state.top&&(j=this.tokenizer.paragraph(he))){re=N[N.length-1],Ce&&re.type==="paragraph"?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j),Ce=he.length!==W.length,W=W.substring(j.raw.length);continue}if(j=this.tokenizer.text(W)){W=W.substring(j.raw.length),re=N[N.length-1],re&&re.type==="text"?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j);continue}if(W){var Ae="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,N},Ee.inline=function(W,N){this.inlineQueue.push({src:W,tokens:N})},Ee.inlineTokens=function(W,N){var $=this;N===void 0&&(N=[]);var j,re,he,Ce=W,Ae,We,$e;if(this.tokens.links){var je=Object.keys(this.tokens.links);if(je.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)je.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+O("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+O("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;W;)if(We||($e=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ue){return(j=Ue.call({lexer:$},W,N))?(W=W.substring(j.raw.length),N.push(j),!0):!1}))){if(j=this.tokenizer.escape(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.tag(W)){W=W.substring(j.raw.length),re=N[N.length-1],re&&j.type==="text"&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(j=this.tokenizer.link(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.reflink(W,this.tokens.links)){W=W.substring(j.raw.length),re=N[N.length-1],re&&j.type==="text"&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(j=this.tokenizer.emStrong(W,Ce,$e)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.codespan(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.br(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.del(W)){W=W.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.autolink(W,x)){W=W.substring(j.raw.length),N.push(j);continue}if(!this.state.inLink&&(j=this.tokenizer.url(W,x))){W=W.substring(j.raw.length),N.push(j);continue}if(he=W,this.options.extensions&&this.options.extensions.startInline&&function(){var Ue=1/0,Qe=W.slice(1),et=void 0;$.options.extensions.startInline.forEach(function(Re){et=Re.call({lexer:this},Qe),typeof et=="number"&&et>=0&&(Ue=Math.min(Ue,et))}),Ue<1/0&&Ue>=0&&(he=W.substring(0,Ue+1))}(),j=this.tokenizer.inlineText(he,K)){W=W.substring(j.raw.length),j.raw.slice(-1)!=="_"&&($e=j.raw.slice(-1)),We=!0,re=N[N.length-1],re&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(W){var He="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return N},h(_e,null,[{key:"rules",get:function(){return{block:M,inline:q}}}]),_e}(),G=function(){function _e(z){this.options=z||te.defaults}var Ee=_e.prototype;return Ee.code=function(W,N,$){var j=(N||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(W,j);re!=null&&re!==W&&($=!0,W=re)}return W=W.replace(/\n$/,"")+`
`,j?'<pre><code class="'+this.options.langPrefix+f(j,!0)+'">'+($?W:f(W,!0))+`</code></pre>
`:"<pre><code>"+($?W:f(W,!0))+`</code></pre>
`},Ee.blockquote=function(W){return`<blockquote>
`+W+`</blockquote>
`},Ee.html=function(W){return W},Ee.heading=function(W,N,$,j){return this.options.headerIds?"<h"+N+' id="'+this.options.headerPrefix+j.slug($)+'">'+W+"</h"+N+`>
`:"<h"+N+">"+W+"</h"+N+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(W,N,$){var j=N?"ol":"ul",re=N&&$!==1?' start="'+$+'"':"";return"<"+j+re+`>
`+W+"</"+j+`>
`},Ee.listitem=function(W){return"<li>"+W+`</li>
`},Ee.checkbox=function(W){return"<input "+(W?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(W){return"<p>"+W+`</p>
`},Ee.table=function(W,N){return N&&(N="<tbody>"+N+"</tbody>"),`<table>
<thead>
`+W+`</thead>
`+N+`</table>
`},Ee.tablerow=function(W){return`<tr>
`+W+`</tr>
`},Ee.tablecell=function(W,N){var $=N.header?"th":"td",j=N.align?"<"+$+' align="'+N.align+'">':"<"+$+">";return j+W+"</"+$+`>
`},Ee.strong=function(W){return"<strong>"+W+"</strong>"},Ee.em=function(W){return"<em>"+W+"</em>"},Ee.codespan=function(W){return"<code>"+W+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(W){return"<del>"+W+"</del>"},Ee.link=function(W,N,$){if(W=m(this.options.sanitize,this.options.baseUrl,W),W===null)return $;var j='<a href="'+f(W)+'"';return N&&(j+=' title="'+N+'"'),j+=">"+$+"</a>",j},Ee.image=function(W,N,$){if(W=m(this.options.sanitize,this.options.baseUrl,W),W===null)return $;var j='<img src="'+W+'" alt="'+$+'"';return N&&(j+=' title="'+N+'"'),j+=this.options.xhtml?"/>":">",j},Ee.text=function(W){return W},_e}(),X=function(){function _e(){}var Ee=_e.prototype;return Ee.strong=function(W){return W},Ee.em=function(W){return W},Ee.codespan=function(W){return W},Ee.del=function(W){return W},Ee.html=function(W){return W},Ee.text=function(W){return W},Ee.link=function(W,N,$){return""+$},Ee.image=function(W,N,$){return""+$},Ee.br=function(){return""},_e}(),V=function(){function _e(){this.seen={}}var Ee=_e.prototype;return Ee.serialize=function(W){return W.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(W,N){var $=W,j=0;if(this.seen.hasOwnProperty($)){j=this.seen[W];do j++,$=W+"-"+j;while(this.seen.hasOwnProperty($))}return N||(this.seen[W]=j,this.seen[$]=0),$},Ee.slug=function(W,N){N===void 0&&(N={});var $=this.serialize(W);return this.getNextSafeSlug($,N.dryrun)},_e}(),Z=function(){function _e(z){this.options=z||te.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new V}_e.parse=function(W,N){var $=new _e(N);return $.parse(W)},_e.parseInline=function(W,N){var $=new _e(N);return $.parseInline(W)};var Ee=_e.prototype;return Ee.parse=function(W,N){N===void 0&&(N=!0);var $="",j,re,he,Ce,Ae,We,$e,je,He,Ue,Qe,et,Re,tt,ie,ae,J,pe,Se,Me=W.length;for(j=0;j<Me;j++){if(Ue=W[j],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ue.type]&&(Se=this.options.extensions.renderers[Ue.type].call({parser:this},Ue),Se!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ue.type))){$+=Se||"";continue}switch(Ue.type){case"space":continue;case"hr":{$+=this.renderer.hr();continue}case"heading":{$+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,w(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{$+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for(je="",$e="",Ce=Ue.header.length,re=0;re<Ce;re++)$e+=this.renderer.tablecell(this.parseInline(Ue.header[re].tokens),{header:!0,align:Ue.align[re]});for(je+=this.renderer.tablerow($e),He="",Ce=Ue.rows.length,re=0;re<Ce;re++){for(We=Ue.rows[re],$e="",Ae=We.length,he=0;he<Ae;he++)$e+=this.renderer.tablecell(this.parseInline(We[he].tokens),{header:!1,align:Ue.align[he]});He+=this.renderer.tablerow($e)}$+=this.renderer.table(je,He);continue}case"blockquote":{He=this.parse(Ue.tokens),$+=this.renderer.blockquote(He);continue}case"list":{for(Qe=Ue.ordered,et=Ue.start,Re=Ue.loose,Ce=Ue.items.length,He="",re=0;re<Ce;re++)ie=Ue.items[re],ae=ie.checked,J=ie.task,tt="",ie.task&&(pe=this.renderer.checkbox(ae),Re?ie.tokens.length>0&&ie.tokens[0].type==="paragraph"?(ie.tokens[0].text=pe+" "+ie.tokens[0].text,ie.tokens[0].tokens&&ie.tokens[0].tokens.length>0&&ie.tokens[0].tokens[0].type==="text"&&(ie.tokens[0].tokens[0].text=pe+" "+ie.tokens[0].tokens[0].text)):ie.tokens.unshift({type:"text",text:pe}):tt+=pe),tt+=this.parse(ie.tokens,Re),He+=this.renderer.listitem(tt,J,ae);$+=this.renderer.list(He,Qe,et);continue}case"html":{$+=this.renderer.html(Ue.text);continue}case"paragraph":{$+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for(He=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;j+1<Me&&W[j+1].type==="text";)Ue=W[++j],He+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);$+=N?this.renderer.paragraph(He):He;continue}default:{var ze='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return $},Ee.parseInline=function(W,N){N=N||this.renderer;var $="",j,re,he,Ce=W.length;for(j=0;j<Ce;j++){if(re=W[j],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(he=this.options.extensions.renderers[re.type].call({parser:this},re),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type))){$+=he||"";continue}switch(re.type){case"escape":{$+=N.text(re.text);break}case"html":{$+=N.html(re.text);break}case"link":{$+=N.link(re.href,re.title,this.parseInline(re.tokens,N));break}case"image":{$+=N.image(re.href,re.title,re.text);break}case"strong":{$+=N.strong(this.parseInline(re.tokens,N));break}case"em":{$+=N.em(this.parseInline(re.tokens,N));break}case"codespan":{$+=N.codespan(re.text);break}case"br":{$+=N.br();break}case"del":{$+=N.del(this.parseInline(re.tokens,N));break}case"text":{$+=N.text(re.text);break}default:{var Ae='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return $},_e}();function se(_e,Ee,z){if(typeof _e=="undefined"||_e===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _e!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_e)+", string expected");if(typeof Ee=="function"&&(z=Ee,Ee=null),Ee=l({},se.defaults,Ee||{}),R(Ee),z){var W=Ee.highlight,N;try{N=B.lex(_e,Ee)}catch(he){return z(he)}var $=function(Ce){var Ae;if(!Ce)try{Ee.walkTokens&&se.walkTokens(N,Ee.walkTokens),Ae=Z.parse(N,Ee)}catch(We){Ce=We}return Ee.highlight=W,Ce?z(Ce):z(null,Ae)};if(!W||W.length<3||(delete Ee.highlight,!N.length))return $();var j=0;se.walkTokens(N,function(he){he.type==="code"&&(j++,setTimeout(function(){W(he.text,he.lang,function(Ce,Ae){if(Ce)return $(Ce);Ae!=null&&Ae!==he.text&&(he.text=Ae,he.escaped=!0),j--,j===0&&$()})},0))}),j===0&&$();return}try{var re=B.lex(_e,Ee);return Ee.walkTokens&&se.walkTokens(re,Ee.walkTokens),Z.parse(re,Ee)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+f(he.message+"",!0)+"</pre>";throw he}}se.options=se.setOptions=function(_e){return l(se.defaults,_e),P(se.defaults),se},se.getDefaults=S,se.defaults=te.defaults,se.use=function(){for(var _e=arguments.length,Ee=new Array(_e),z=0;z<_e;z++)Ee[z]=arguments[z];var W=l.apply(void 0,[{}].concat(Ee)),N=se.defaults.extensions||{renderers:{},childTokens:{}},$;Ee.forEach(function(j){if(j.extensions&&($=!0,j.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=N.renderers?N.renderers[he.name]:null;Ce?N.renderers[he.name]=function(){for(var Ae=arguments.length,We=new Array(Ae),$e=0;$e<Ae;$e++)We[$e]=arguments[$e];var je=he.renderer.apply(this,We);return je===!1&&(je=Ce.apply(this,We)),je}:N.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");N[he.level]?N[he.level].unshift(he.tokenizer):N[he.level]=[he.tokenizer],he.start&&(he.level==="block"?N.startBlock?N.startBlock.push(he.start):N.startBlock=[he.start]:he.level==="inline"&&(N.startInline?N.startInline.push(he.start):N.startInline=[he.start]))}he.childTokens&&(N.childTokens[he.name]=he.childTokens)})),j.renderer&&function(){var he=se.defaults.renderer||new G,Ce=function($e){var je=he[$e];he[$e]=function(){for(var He=arguments.length,Ue=new Array(He),Qe=0;Qe<He;Qe++)Ue[Qe]=arguments[Qe];var et=j.renderer[$e].apply(he,Ue);return et===!1&&(et=je.apply(he,Ue)),et}};for(var Ae in j.renderer)Ce(Ae);W.renderer=he}(),j.tokenizer&&function(){var he=se.defaults.tokenizer||new U,Ce=function($e){var je=he[$e];he[$e]=function(){for(var He=arguments.length,Ue=new Array(He),Qe=0;Qe<He;Qe++)Ue[Qe]=arguments[Qe];var et=j.tokenizer[$e].apply(he,Ue);return et===!1&&(et=je.apply(he,Ue)),et}};for(var Ae in j.tokenizer)Ce(Ae);W.tokenizer=he}(),j.walkTokens){var re=se.defaults.walkTokens;W.walkTokens=function(he){j.walkTokens.call(this,he),re&&re.call(this,he)}}$&&(W.extensions=N),se.setOptions(W)})},se.walkTokens=function(_e,Ee){for(var z=function(){var j=N.value;switch(Ee.call(se,j),j.type){case"table":{for(var re=A(j.header),he;!(he=re()).done;){var Ce=he.value;se.walkTokens(Ce.tokens,Ee)}for(var Ae=A(j.rows),We;!(We=Ae()).done;)for(var $e=We.value,je=A($e),He;!(He=je()).done;){var Ue=He.value;se.walkTokens(Ue.tokens,Ee)}break}case"list":{se.walkTokens(j.items,Ee);break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[j.type]?se.defaults.extensions.childTokens[j.type].forEach(function(Qe){se.walkTokens(j[Qe],Ee)}):j.tokens&&se.walkTokens(j.tokens,Ee)}},W=A(_e),N;!(N=W()).done;)z()},se.parseInline=function(_e,Ee){if(typeof _e=="undefined"||_e===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _e!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_e)+", string expected");Ee=l({},se.defaults,Ee||{}),R(Ee);try{var z=B.lexInline(_e,Ee);return Ee.walkTokens&&se.walkTokens(z,Ee.walkTokens),Z.parseInline(z,Ee)}catch(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+f(W.message+"",!0)+"</pre>";throw W}},se.Parser=Z,se.parser=Z.parse,se.Renderer=G,se.TextRenderer=X,se.Lexer=B,se.lexer=B.lex,se.Tokenizer=U,se.Slugger=V,se.parse=se;var ce=se.options,ee=se.setOptions,Q=se.use,oe=se.walkTokens,de=se.parseInline,ve=se,ke=Z.parse,Ne=B.lex;te.Lexer=B,te.Parser=Z,te.Renderer=G,te.Slugger=V,te.TextRenderer=X,te.Tokenizer=U,te.getDefaults=S,te.lexer=Ne,te.marked=se,te.options=ce,te.parse=ve,te.parseInline=de,te.parser=ke,te.setOptions=ee,te.use=Q,te.walkTokens=oe,Object.defineProperty(te,"__esModule",{value:!0})}),define(we[94],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(P,C,T){return Math.min(Math.max(P,C),T)}e.clamp=h;function t(P,C){return(C+P%C)%C}e.rot=t;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class A{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class S{constructor(C){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(C),this._values.fill(0,0,C)}update(C){const T=this._values[this._index];return this._values[this._index]=C,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=C,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=S}),function(){function te(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function S(C){A.push(C,Date.now())}function P(){const C=[];for(let T=0;T<A.length;T+=2)C.push({name:A[T],startTime:A[T+1]});return C}return{mark:S,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const S of performance.getEntriesByType("mark"))A.push({name:S.name,startTime:Math.round(k+S.startTime)});return A}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function h(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=h(t))}(),define(we[12],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const h="en";let t=!1,k=!1,A=!1,S=!1,P=!1,C=!1,T=!1,F=!1,D=!1,g,E=h,f,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const y=typeof w?.versions?.electron=="string",I=y&&w?.type==="renderer";if(e.isElectronSandboxed=I&&w?.sandboxed,typeof navigator=="object"&&!I)u=navigator.userAgent,t=u.indexOf("Windows")>=0,k=u.indexOf("Macintosh")>=0,F=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=u.indexOf("Linux")>=0,C=!0,g=navigator.language,E=g;else if(typeof w=="object"){t=w.platform==="win32",k=w.platform==="darwin",A=w.platform==="linux",S=A&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,T=y,D=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=h,E=h;const r=w.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),p=l.availableLanguages["*"];g=l.locale,E=p||h,f=l._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var a;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(a=e.Platform||(e.Platform={}));function c(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let m=0;k?m=1:t?m=3:A&&(m=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=A,e.isLinuxSnap=S,e.isNative=P,e.isElectron=T,e.isWeb=C,e.isIOS=F,e.isCI=D,e.platform=m,e.userAgent=u,e.language=E;var s;(function(r){function l(){return e.language}r.value=l;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=p;function d(){return e.language==="en"}r.isDefault=d})(s=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=f,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let d=0,v=r.length;d<v;d++){const R=r[d];if(R.id===p.data.vscodeScheduleAsyncWork){r.splice(d,1),R.callback();return}}});let l=0;return p=>{const d=++l;r.push({id:d,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return r=>setTimeout(r)})();var b;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(b=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||F?2:t?1:3;let o=!0,n=!1;function i(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,o=new Uint16Array(r.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(we[40],be([1,0,12]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof h.globals.vscode!="undefined"&&typeof h.globals.vscode.process!="undefined"){const k=h.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return h.isWindows?"win32":h.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(we[9],be([1,0,40]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,A=90,S=122,P=46,C=47,T=92,F=58,D=63;class g extends Error{constructor(c,m,s){let b;typeof m=="string"&&m.indexOf("not ")===0?(b="must not be",m=m.replace(/^not /,"")):b="must be";const o=c.indexOf(".")!==-1?"property":"argument";let n=`The "${c}" ${o} ${b} of type ${m}`;n+=`. Received type ${typeof s}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function E(a,c){if(typeof a!="string")throw new g(c,"string",a)}function f(a){return a===C||a===T}function u(a){return a===C}function w(a){return a>=t&&a<=A||a>=k&&a<=S}function y(a,c,m,s){let b="",o=0,n=-1,i=0,r=0;for(let l=0;l<=a.length;++l){if(l<a.length)r=a.charCodeAt(l);else{if(s(r))break;r=C}if(s(r)){if(!(n===l-1||i===1))if(i===2){if(b.length<2||o!==2||b.charCodeAt(b.length-1)!==P||b.charCodeAt(b.length-2)!==P){if(b.length>2){const p=b.lastIndexOf(m);p===-1?(b="",o=0):(b=b.slice(0,p),o=b.length-1-b.lastIndexOf(m)),n=l,i=0;continue}else if(b.length!==0){b="",o=0,n=l,i=0;continue}}c&&(b+=b.length>0?`${m}..`:"..",o=2)}else b.length>0?b+=`${m}${a.slice(n+1,l)}`:b=a.slice(n+1,l),o=l-n-1;n=l,i=0}else r===P&&i!==-1?++i:i=-1}return b}function I(a,c){if(c===null||typeof c!="object")throw new g("pathObject","Object",c);const m=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return m?m===c.root?`${m}${s}`:`${m}${a}${s}`:s}e.win32={resolve(...a){let c="",m="",s=!1;for(let b=a.length-1;b>=-1;b--){let o;if(b>=0){if(o=a[b],E(o,"path"),o.length===0)continue}else c.length===0?o=h.cwd():(o=h.env[`=${c}`]||h.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==c.toLowerCase()&&o.charCodeAt(2)===T)&&(o=`${c}\\`));const n=o.length;let i=0,r="",l=!1;const p=o.charCodeAt(0);if(n===1)f(p)&&(i=1,l=!0);else if(f(p))if(l=!0,f(o.charCodeAt(1))){let d=2,v=d;for(;d<n&&!f(o.charCodeAt(d));)d++;if(d<n&&d!==v){const R=o.slice(v,d);for(v=d;d<n&&f(o.charCodeAt(d));)d++;if(d<n&&d!==v){for(v=d;d<n&&!f(o.charCodeAt(d));)d++;(d===n||d!==v)&&(r=`\\\\${R}\\${o.slice(v,d)}`,i=d)}}}else i=1;else w(p)&&o.charCodeAt(1)===F&&(r=o.slice(0,2),i=2,n>2&&f(o.charCodeAt(2))&&(l=!0,i=3));if(r.length>0)if(c.length>0){if(r.toLowerCase()!==c.toLowerCase())continue}else c=r;if(s){if(c.length>0)break}else if(m=`${o.slice(i)}\\${m}`,s=l,l&&c.length>0)break}return m=y(m,!s,"\\",f),s?`${c}\\${m}`:`${c}${m}`||"."},normalize(a){E(a,"path");const c=a.length;if(c===0)return".";let m=0,s,b=!1;const o=a.charCodeAt(0);if(c===1)return u(o)?"\\":a;if(f(o))if(b=!0,f(a.charCodeAt(1))){let i=2,r=i;for(;i<c&&!f(a.charCodeAt(i));)i++;if(i<c&&i!==r){const l=a.slice(r,i);for(r=i;i<c&&f(a.charCodeAt(i));)i++;if(i<c&&i!==r){for(r=i;i<c&&!f(a.charCodeAt(i));)i++;if(i===c)return`\\\\${l}\\${a.slice(r)}\\`;i!==r&&(s=`\\\\${l}\\${a.slice(r,i)}`,m=i)}}}else m=1;else w(o)&&a.charCodeAt(1)===F&&(s=a.slice(0,2),m=2,c>2&&f(a.charCodeAt(2))&&(b=!0,m=3));let n=m<c?y(a.slice(m),!b,"\\",f):"";return n.length===0&&!b&&(n="."),n.length>0&&f(a.charCodeAt(c-1))&&(n+="\\"),s===void 0?b?`\\${n}`:n:b?`${s}\\${n}`:`${s}${n}`},isAbsolute(a){E(a,"path");const c=a.length;if(c===0)return!1;const m=a.charCodeAt(0);return f(m)||c>2&&w(m)&&a.charCodeAt(1)===F&&f(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let c,m;for(let o=0;o<a.length;++o){const n=a[o];E(n,"path"),n.length>0&&(c===void 0?c=m=n:c+=`\\${n}`)}if(c===void 0)return".";let s=!0,b=0;if(typeof m=="string"&&f(m.charCodeAt(0))){++b;const o=m.length;o>1&&f(m.charCodeAt(1))&&(++b,o>2&&(f(m.charCodeAt(2))?++b:s=!1))}if(s){for(;b<c.length&&f(c.charCodeAt(b));)b++;b>=2&&(c=`\\${c.slice(b)}`)}return e.win32.normalize(c)},relative(a,c){if(E(a,"from"),E(c,"to"),a===c)return"";const m=e.win32.resolve(a),s=e.win32.resolve(c);if(m===s||(a=m.toLowerCase(),c=s.toLowerCase(),a===c))return"";let b=0;for(;b<a.length&&a.charCodeAt(b)===T;)b++;let o=a.length;for(;o-1>b&&a.charCodeAt(o-1)===T;)o--;const n=o-b;let i=0;for(;i<c.length&&c.charCodeAt(i)===T;)i++;let r=c.length;for(;r-1>i&&c.charCodeAt(r-1)===T;)r--;const l=r-i,p=n<l?n:l;let d=-1,v=0;for(;v<p;v++){const O=a.charCodeAt(b+v);if(O!==c.charCodeAt(i+v))break;O===T&&(d=v)}if(v!==p){if(d===-1)return s}else{if(l>p){if(c.charCodeAt(i+v)===T)return s.slice(i+v+1);if(v===2)return s.slice(i+v)}n>p&&(a.charCodeAt(b+v)===T?d=v:v===2&&(d=3)),d===-1&&(d=0)}let R="";for(v=b+d+1;v<=o;++v)(v===o||a.charCodeAt(v)===T)&&(R+=R.length===0?"..":"\\..");return i+=d,R.length>0?`${R}${s.slice(i,r)}`:(s.charCodeAt(i)===T&&++i,s.slice(i,r))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const c=e.win32.resolve(a);if(c.length<=2)return a;if(c.charCodeAt(0)===T){if(c.charCodeAt(1)===T){const m=c.charCodeAt(2);if(m!==D&&m!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(w(c.charCodeAt(0))&&c.charCodeAt(1)===F&&c.charCodeAt(2)===T)return`\\\\?\\${c}`;return a},dirname(a){E(a,"path");const c=a.length;if(c===0)return".";let m=-1,s=0;const b=a.charCodeAt(0);if(c===1)return f(b)?a:".";if(f(b)){if(m=s=1,f(a.charCodeAt(1))){let i=2,r=i;for(;i<c&&!f(a.charCodeAt(i));)i++;if(i<c&&i!==r){for(r=i;i<c&&f(a.charCodeAt(i));)i++;if(i<c&&i!==r){for(r=i;i<c&&!f(a.charCodeAt(i));)i++;if(i===c)return a;i!==r&&(m=s=i+1)}}}}else w(b)&&a.charCodeAt(1)===F&&(m=c>2&&f(a.charCodeAt(2))?3:2,s=m);let o=-1,n=!0;for(let i=c-1;i>=s;--i)if(f(a.charCodeAt(i))){if(!n){o=i;break}}else n=!1;if(o===-1){if(m===-1)return".";o=m}return a.slice(0,o)},basename(a,c){c!==void 0&&E(c,"ext"),E(a,"path");let m=0,s=-1,b=!0,o;if(a.length>=2&&w(a.charCodeAt(0))&&a.charCodeAt(1)===F&&(m=2),c!==void 0&&c.length>0&&c.length<=a.length){if(c===a)return"";let n=c.length-1,i=-1;for(o=a.length-1;o>=m;--o){const r=a.charCodeAt(o);if(f(r)){if(!b){m=o+1;break}}else i===-1&&(b=!1,i=o+1),n>=0&&(r===c.charCodeAt(n)?--n==-1&&(s=o):(n=-1,s=i))}return m===s?s=i:s===-1&&(s=a.length),a.slice(m,s)}for(o=a.length-1;o>=m;--o)if(f(a.charCodeAt(o))){if(!b){m=o+1;break}}else s===-1&&(b=!1,s=o+1);return s===-1?"":a.slice(m,s)},extname(a){E(a,"path");let c=0,m=-1,s=0,b=-1,o=!0,n=0;a.length>=2&&a.charCodeAt(1)===F&&w(a.charCodeAt(0))&&(c=s=2);for(let i=a.length-1;i>=c;--i){const r=a.charCodeAt(i);if(f(r)){if(!o){s=i+1;break}continue}b===-1&&(o=!1,b=i+1),r===P?m===-1?m=i:n!==1&&(n=1):m!==-1&&(n=-1)}return m===-1||b===-1||n===0||n===1&&m===b-1&&m===s+1?"":a.slice(m,b)},format:I.bind(null,"\\"),parse(a){E(a,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return c;const m=a.length;let s=0,b=a.charCodeAt(0);if(m===1)return f(b)?(c.root=c.dir=a,c):(c.base=c.name=a,c);if(f(b)){if(s=1,f(a.charCodeAt(1))){let d=2,v=d;for(;d<m&&!f(a.charCodeAt(d));)d++;if(d<m&&d!==v){for(v=d;d<m&&f(a.charCodeAt(d));)d++;if(d<m&&d!==v){for(v=d;d<m&&!f(a.charCodeAt(d));)d++;d===m?s=d:d!==v&&(s=d+1)}}}}else if(w(b)&&a.charCodeAt(1)===F){if(m<=2)return c.root=c.dir=a,c;if(s=2,f(a.charCodeAt(2))){if(m===3)return c.root=c.dir=a,c;s=3}}s>0&&(c.root=a.slice(0,s));let o=-1,n=s,i=-1,r=!0,l=a.length-1,p=0;for(;l>=s;--l){if(b=a.charCodeAt(l),f(b)){if(!r){n=l+1;break}continue}i===-1&&(r=!1,i=l+1),b===P?o===-1?o=l:p!==1&&(p=1):o!==-1&&(p=-1)}return i!==-1&&(o===-1||p===0||p===1&&o===i-1&&o===n+1?c.base=c.name=a.slice(n,i):(c.name=a.slice(n,o),c.base=a.slice(n,i),c.ext=a.slice(o,i))),n>0&&n!==s?c.dir=a.slice(0,n-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let c="",m=!1;for(let s=a.length-1;s>=-1&&!m;s--){const b=s>=0?a[s]:h.cwd();E(b,"path"),b.length!==0&&(c=`${b}/${c}`,m=b.charCodeAt(0)===C)}return c=y(c,!m,"/",u),m?`/${c}`:c.length>0?c:"."},normalize(a){if(E(a,"path"),a.length===0)return".";const c=a.charCodeAt(0)===C,m=a.charCodeAt(a.length-1)===C;return a=y(a,!c,"/",u),a.length===0?c?"/":m?"./":".":(m&&(a+="/"),c?`/${a}`:a)},isAbsolute(a){return E(a,"path"),a.length>0&&a.charCodeAt(0)===C},join(...a){if(a.length===0)return".";let c;for(let m=0;m<a.length;++m){const s=a[m];E(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.posix.normalize(c)},relative(a,c){if(E(a,"from"),E(c,"to"),a===c||(a=e.posix.resolve(a),c=e.posix.resolve(c),a===c))return"";const m=1,s=a.length,b=s-m,o=1,n=c.length-o,i=b<n?b:n;let r=-1,l=0;for(;l<i;l++){const d=a.charCodeAt(m+l);if(d!==c.charCodeAt(o+l))break;d===C&&(r=l)}if(l===i)if(n>i){if(c.charCodeAt(o+l)===C)return c.slice(o+l+1);if(l===0)return c.slice(o+l)}else b>i&&(a.charCodeAt(m+l)===C?r=l:l===0&&(r=0));let p="";for(l=m+r+1;l<=s;++l)(l===s||a.charCodeAt(l)===C)&&(p+=p.length===0?"..":"/..");return`${p}${c.slice(o+r)}`},toNamespacedPath(a){return a},dirname(a){if(E(a,"path"),a.length===0)return".";const c=a.charCodeAt(0)===C;let m=-1,s=!0;for(let b=a.length-1;b>=1;--b)if(a.charCodeAt(b)===C){if(!s){m=b;break}}else s=!1;return m===-1?c?"/":".":c&&m===1?"//":a.slice(0,m)},basename(a,c){c!==void 0&&E(c,"ext"),E(a,"path");let m=0,s=-1,b=!0,o;if(c!==void 0&&c.length>0&&c.length<=a.length){if(c===a)return"";let n=c.length-1,i=-1;for(o=a.length-1;o>=0;--o){const r=a.charCodeAt(o);if(r===C){if(!b){m=o+1;break}}else i===-1&&(b=!1,i=o+1),n>=0&&(r===c.charCodeAt(n)?--n==-1&&(s=o):(n=-1,s=i))}return m===s?s=i:s===-1&&(s=a.length),a.slice(m,s)}for(o=a.length-1;o>=0;--o)if(a.charCodeAt(o)===C){if(!b){m=o+1;break}}else s===-1&&(b=!1,s=o+1);return s===-1?"":a.slice(m,s)},extname(a){E(a,"path");let c=-1,m=0,s=-1,b=!0,o=0;for(let n=a.length-1;n>=0;--n){const i=a.charCodeAt(n);if(i===C){if(!b){m=n+1;break}continue}s===-1&&(b=!1,s=n+1),i===P?c===-1?c=n:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||s===-1||o===0||o===1&&c===s-1&&c===m+1?"":a.slice(c,s)},format:I.bind(null,"/"),parse(a){E(a,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return c;const m=a.charCodeAt(0)===C;let s;m?(c.root="/",s=1):s=0;let b=-1,o=0,n=-1,i=!0,r=a.length-1,l=0;for(;r>=s;--r){const p=a.charCodeAt(r);if(p===C){if(!i){o=r+1;break}continue}n===-1&&(i=!1,n=r+1),p===P?b===-1?b=r:l!==1&&(l=1):b!==-1&&(l=-1)}if(n!==-1){const p=o===0&&m?1:o;b===-1||l===0||l===1&&b===n-1&&b===o+1?c.base=c.name=a.slice(p,n):(c.name=a.slice(p,b),c.base=a.slice(p,n),c.ext=a.slice(b,n))}return o>0?c.dir=a.slice(0,o-1):m&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=h.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h.platform==="win32"?e.win32.join:e.posix.join,e.resolve=h.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=h.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=h.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=h.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=h.platform==="win32"?e.win32.extname:e.posix.extname,e.format=h.platform==="win32"?e.win32.format:e.posix.format,e.parse=h.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=h.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=h.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[95],be([1,0,9]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(D){D.text="text/plain",D.binary="application/octet-stream",D.unknown="application/unknown",D.markdown="text/markdown",D.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(D){const g=(0,h.extname)(D),E=k[g.toLowerCase()];return E!==void 0?E:P(D)}e.getMediaOrTextMime=S;function P(D){const g=(0,h.extname)(D);return A[g.toLowerCase()]}e.getMediaMime=P;function C(D){for(const g in A)if(A[g]===D)return g}e.getExtensionForMimeType=C;const T=/^(.+)\/(.+?)(;.+)?$/;function F(D,g){const E=T.exec(D);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:g?void 0:D}e.normalizeMimeType=F}),define(we[96],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var h;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(h=e.Source||(e.Source={}));var t;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(A,...S){const P=S.reduce((F,D)=>(F[D]=!0,F),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(F=>!P[F]).forEach(F=>{for(let D=0;D<C.length;D++)if(F.search(C[D])!==-1){delete A[F];break}})}e.sanitizeProcessEnvironment=k}),define(we[46],be([1,0,12]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=h.globals.performance&&typeof h.globals.performance.now=="function";class k{constructor(S){this._highResolution=t&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new k(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?h.globals.performance.now():Date.now()}}e.StopWatch=k}),define(we[3],be([1,0,16,75,6,93,46]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.SafeDisposable=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(b){b.None=()=>k.Disposable.None;function o(V){return(Z,se=null,ce)=>{let ee=!1,Q;return Q=V(oe=>{if(!ee)return Q?Q.dispose():ee=!0,Z.call(se,oe)},null,ce),ee&&Q.dispose(),Q}}b.once=o;function n(V,Z){return v((se,ce=null,ee)=>V(Q=>se.call(ce,Z(Q)),null,ee))}b.map=n;function i(V,Z){return v((se,ce=null,ee)=>V(Q=>{Z(Q),se.call(ce,Q)},null,ee))}b.forEach=i;function r(V,Z){return v((se,ce=null,ee)=>V(Q=>Z(Q)&&se.call(ce,Q),null,ee))}b.filter=r;function l(V){return V}b.signal=l;function p(...V){return(Z,se=null,ce)=>(0,k.combinedDisposable)(...V.map(ee=>ee(Q=>Z.call(se,Q),null,ce)))}b.any=p;function d(V,Z,se){let ce=se;return n(V,ee=>(ce=Z(ce,ee),ce))}b.reduce=d;function v(V){let Z;const se=new u({onFirstListenerAdd(){Z=V(se.fire,se)},onLastListenerRemove(){Z.dispose()}});return se.event}function R(V,Z,se,ce=100,ee=!1){let Q,oe,de=0;return V(ve=>{de++,Q=se(Q,ve),ee&&!oe&&(Z(Q),Q=void 0),clearTimeout(oe),oe=setTimeout(()=>{const ke=Q;Q=void 0,oe=void 0,(!ee||de>1)&&Z(ke),de=0},ce)})}b.debouncedListener=R;function O(V,Z,se=100,ce=!1,ee){let Q,oe,de,ve=0;const ke=new u({leakWarningThreshold:ee,onFirstListenerAdd(){Q=V(Ne=>{ve++,oe=Z(oe,Ne),ce&&!de&&(ke.fire(oe),oe=void 0),clearTimeout(de),de=setTimeout(()=>{const _e=oe;oe=void 0,de=void 0,(!ce||ve>1)&&ke.fire(_e),ve=0},se)})},onLastListenerRemove(){Q.dispose()}});return ke.event}b.debounce=O;function L(V,Z=(se,ce)=>se===ce){let se=!0,ce;return r(V,ee=>{const Q=se||!Z(ee,ce);return se=!1,ce=ee,Q})}b.latch=L;function _(V,Z){return[b.filter(V,Z),b.filter(V,se=>!Z(se))]}b.split=_;function U(V,Z=!1,se=[]){let ce=se.slice(),ee=V(de=>{ce?ce.push(de):oe.fire(de)});const Q=()=>{ce&&ce.forEach(de=>oe.fire(de)),ce=null},oe=new u({onFirstListenerAdd(){ee||(ee=V(de=>oe.fire(de)))},onFirstListenerDidAdd(){ce&&(Z?setTimeout(Q):Q())},onLastListenerRemove(){ee&&ee.dispose(),ee=null}});return oe.event}b.buffer=U;class M{constructor(Z){this.event=Z}map(Z){return new M(n(this.event,Z))}forEach(Z){return new M(i(this.event,Z))}filter(Z){return new M(r(this.event,Z))}reduce(Z,se){return new M(d(this.event,Z,se))}latch(){return new M(L(this.event))}debounce(Z,se=100,ce=!1,ee){return new M(O(this.event,Z,se,ce,ee))}on(Z,se,ce){return this.event(Z,se,ce)}once(Z,se,ce){return o(this.event)(Z,se,ce)}}function q(V){return new M(V)}b.chain=q;function K(V,Z,se=ce=>ce){const ce=(...de)=>oe.fire(se(...de)),ee=()=>V.on(Z,ce),Q=()=>V.removeListener(Z,ce),oe=new u({onFirstListenerAdd:ee,onLastListenerRemove:Q});return oe.event}b.fromNodeEventEmitter=K;function x(V,Z,se=ce=>ce){const ce=(...de)=>oe.fire(se(...de)),ee=()=>V.addEventListener(Z,ce),Q=()=>V.removeEventListener(Z,ce),oe=new u({onFirstListenerAdd:ee,onLastListenerRemove:Q});return oe.event}b.fromDOMEventEmitter=x;function B(V){return new Promise(Z=>o(V)(Z))}b.toPromise=B;function G(V,Z){return Z(void 0),V(se=>Z(se))}b.runAndSubscribe=G;function X(V,Z){let se=null;function ce(Q){se?.dispose(),se=new k.DisposableStore,Z(Q,se)}ce(void 0);const ee=V(Q=>ce(Q));return(0,k.toDisposable)(()=>{ee.dispose(),se?.dispose()})}b.runAndSubscribeWithStore=X})(P=e.Event||(e.Event={}));class C{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${C._idPool++}`}start(o){this._stopWatch=new S.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let T=-1;function F(b){const o=T;return T=b,{dispose(){T=o}}}e.setGlobalLeakWarningThreshold=F;class D{constructor(o,n=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,n){let i=T;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||n<i)return;this._stacks||(this._stacks=new Map);const r=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let l,p=0;for(const[d,v]of this._stacks)(!l||p<v)&&(l=d,p=v);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${p}):`),console.warn(l)}return()=>{const l=this._stacks.get(o.value)||0;this._stacks.set(o.value,l-1)}}}class g{constructor(o){this._error=o}static create(){return new g(new Error)}get value(){return this._error.stack??""}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(){this.dispose=E._noop,this.unset=E._noop}set(o){let n=o;return this.unset=()=>n=void 0,this.dispose=()=>n?.dispose(),this}}e.SafeDisposable=E,E._noop=()=>{};class f{constructor(o,n,i){this.callback=o,this.callbackThis=n,this.stack=i,this.subscription=new E}invoke(o){this.callback.call(this.callbackThis,o)}}class u{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=T>0?new D(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(o,n,i)=>{this._listeners||(this._listeners=new A.LinkedList);const r=this._listeners.isEmpty();r&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let l,p;this._leakageMon&&(p=g.create(),l=this._leakageMon.check(p,this._listeners.size+1));const d=new f(o,n,p),v=this._listeners.push(d);r&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,n);const R=d.subscription.set((0,k.toDisposable)(()=>{l&&l(),this._disposed||(v(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}));return i instanceof k.DisposableStore?i.add(R):Array.isArray(i)&&i.push(R),R}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,i]=this._deliveryQueue.shift();try{n.invoke(i)}catch(r){(0,h.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){for(const o of this._listeners)o.subscription.dispose(),o.subscription.unset();this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}}e.Emitter=u;class w extends u{async fireAsync(o,n,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,o]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[r,l]=this._asyncDeliveryQueue.shift(),p=[],d={...l,token:n,waitUntil:v=>{if(Object.isFrozen(p))throw new Error("waitUntil can NOT be called asynchronous");i&&(v=i(v,r.callback)),p.push(v)}};try{r.invoke(d)}catch(v){(0,h.onUnexpectedError)(v);continue}Object.freeze(p),await Promise.allSettled(p).then(v=>{for(const R of v)R.status==="rejected"&&(0,h.onUnexpectedError)(R.reason)})}}}}e.AsyncEmitter=w;class y extends u{constructor(o){super(o);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=y;class I extends y{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=I;class a extends u{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=a;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const n={event:o,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const i=()=>{this.hasListeners&&this.unhook(n);const r=this.events.indexOf(n);this.events.splice(r,1)};return(0,k.toDisposable)((0,t.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(n=>this.emitter.fire(n))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class m{constructor(){this.buffers=[]}wrapEvent(o){return(n,i,r)=>o(l=>{const p=this.buffers[this.buffers.length-1];p?p.push(()=>n.call(i,l)):n.call(i,l)},void 0,r)}bufferEvents(o){const n=[];this.buffers.push(n);const i=o();return this.buffers.pop(),n.forEach(r=>r()),i}}e.EventBufferer=m;class s{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=k.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(we[21],be([1,0,3]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,C){const T=setTimeout(P.bind(C),0);return{dispose(){clearTimeout(T)}}});var k;(function(P){function C(T){return T===P.None||T===P.Cancelled||T instanceof A?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}P.isCancellationToken=C,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new h.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=k.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=S}),define(we[145],be([1,0,21]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(S){this.task=S,this.result=null}get(){if(this.result)return this.result;const S=new h.CancellationTokenSource,P=this.task(S.token);return this.result={promise:P,dispose:()=>{this.result=null,S.cancel(),S.dispose()}},this.result}}e.Cache=t;class k{constructor(S){this.computeFn=S,this.lastCache=void 0,this.lastArgKey=void 0}get(S){const P=JSON.stringify(S);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.computeFn(S)),this.lastCache}}e.LRUCachedComputed=k}),define(we[97],be([1,0,16,6]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(a){const c=a;return c?[c.on,c.pause,c.resume,c.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=k;function A(a){const c=a;return c?k(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function S(a,c){return new P(a,c)}e.newWriteableStream=S;class P{constructor(c,m){this.reducer=c,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(m=>m(c))}emitError(c){this.listeners.error.length===0?(0,h.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(m=>m(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,m){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(c,m){if(this.state.destroyed)return;let s;switch(c){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const b=s.indexOf(m);b>=0&&s.splice(b,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(a,c){const m=[];let s;for(;(s=a.read())!==null;)m.push(s);return c(m)}e.consumeReadable=C;function T(a,c,m){const s=[];let b;for(;(b=a.read())!==null&&s.length<m;)s.push(b);return b===null&&s.length>0?c(s):{read:()=>{if(s.length>0)return s.shift();if(typeof b!="undefined"){const o=b;return b=void 0,o}return a.read()}}}e.peekReadable=T;function F(a,c){return new Promise((m,s)=>{const b=[];D(a,{onData:o=>{c&&b.push(o)},onError:o=>{c?s(o):m(void 0)},onEnd:()=>{m(c?c(b):void 0)}})})}e.consumeStream=F;function D(a,c){let m=!1;return a.on("error",s=>{m||c.onError(s)}),a.on("end",()=>{m||c.onEnd()}),a.on("data",s=>{m||c.onData(s)}),(0,t.toDisposable)(()=>m=!0)}e.listenStream=D;function g(a,c){return new Promise((m,s)=>{const b=new t.DisposableStore,o=[],n=l=>{if(o.push(l),o.length>c)return b.dispose(),a.pause(),m({stream:a,buffer:o,ended:!1})},i=l=>s(l),r=()=>m({stream:a,buffer:o,ended:!0});b.add((0,t.toDisposable)(()=>a.removeListener("error",i))),a.on("error",i),b.add((0,t.toDisposable)(()=>a.removeListener("end",r))),a.on("end",r),b.add((0,t.toDisposable)(()=>a.removeListener("data",n))),a.on("data",n)})}e.peekStream=g;function E(a,c){const m=S(c);return m.end(a),m}e.toStream=E;function f(){const a=S(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=f;function u(a){let c=!1;return{read:()=>c?null:(c=!0,a)}}e.toReadable=u;function w(a,c,m){const s=S(m);return D(a,{onData:b=>s.write(c.data(b)),onError:b=>s.error(c.error?c.error(b):b),onEnd:()=>s.end()}),s}e.transform=w;function y(a,c,m){let s=!1;return{read:()=>{const b=c.read();return s?b:(s=!0,b!==null?m([a,b]):a)}}}e.prefixedReadable=y;function I(a,c,m){let s=!1;const b=S(m);return D(c,{onData:o=>s?b.write(o):(s=!0,b.write(m([a,o]))),onError:o=>b.error(o),onEnd:()=>{s||(s=!0,b.write(a)),b.end()}}),b}e.prefixedStream=I}),define(we[23],be([1,0,97]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let k,A;class S{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return t?new S(Buffer.allocUnsafe(p)):new S(new Uint8Array(p))}static wrap(p){return t&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new S(p)}static fromString(p,d){return!(d?.dontUseNodeBuffer||!1)&&t?new S(Buffer.from(p)):(k||(k=new TextEncoder),new S(k.encode(p)))}static fromByteArray(p){const d=S.alloc(p.length);for(let v=0,R=p.length;v<R;v++)d.buffer[v]=p[v];return d}static concat(p,d){if(typeof d=="undefined"){d=0;for(let O=0,L=p.length;O<L;O++)d+=p[O].byteLength}const v=S.alloc(d);let R=0;for(let O=0,L=p.length;O<L;O++){const _=p[O];v.set(_,R),R+=_.byteLength}return v}clone(){const p=S.alloc(this.byteLength);return p.set(this),p}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(p,d){return new S(this.buffer.subarray(p,d))}set(p,d){if(p instanceof S)this.buffer.set(p.buffer,d);else if(p instanceof Uint8Array)this.buffer.set(p,d);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),d);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return T(this.buffer,p)}writeUInt32BE(p,d){F(this.buffer,p,d)}readUInt32LE(p){return D(this.buffer,p)}writeUInt32LE(p,d){g(this.buffer,p,d)}readUInt8(p){return E(this.buffer,p)}writeUInt8(p,d){f(this.buffer,p,d)}}e.VSBuffer=S;function P(l,p){return l[p+0]<<0>>>0|l[p+1]<<8>>>0}e.readUInt16LE=P;function C(l,p,d){l[d+0]=p&255,p=p>>>8,l[d+1]=p&255}e.writeUInt16LE=C;function T(l,p){return l[p]*2**24+l[p+1]*2**16+l[p+2]*2**8+l[p+3]}e.readUInt32BE=T;function F(l,p,d){l[d+3]=p,p=p>>>8,l[d+2]=p,p=p>>>8,l[d+1]=p,p=p>>>8,l[d]=p}e.writeUInt32BE=F;function D(l,p){return l[p+0]<<0>>>0|l[p+1]<<8>>>0|l[p+2]<<16>>>0|l[p+3]<<24>>>0}e.readUInt32LE=D;function g(l,p,d){l[d+0]=p&255,p=p>>>8,l[d+1]=p&255,p=p>>>8,l[d+2]=p&255,p=p>>>8,l[d+3]=p&255}e.writeUInt32LE=g;function E(l,p){return l[p]}e.readUInt8=E;function f(l,p,d){l[d]=p}e.writeUInt8=f;function u(l){return h.consumeReadable(l,p=>S.concat(p))}e.readableToBuffer=u;function w(l){return h.toReadable(l)}e.bufferToReadable=w;function y(l){return h.consumeStream(l,p=>S.concat(p))}e.streamToBuffer=y;async function I(l){return l.ended?S.concat(l.buffer):S.concat([...l.buffer,await y(l.stream)])}e.bufferedStreamToBuffer=I;function a(l){return h.toStream(l,p=>S.concat(p))}e.bufferToStream=a;function c(l){return h.transform(l,{data:p=>typeof p=="string"?S.fromString(p):S.wrap(p)},p=>S.concat(p))}e.streamToBufferReadableStream=c;function m(l){return h.newWriteableStream(p=>S.concat(p),l)}e.newWriteableBufferStream=m;function s(l,p){return h.prefixedReadable(l,p,d=>S.concat(d))}e.prefixedBufferReadable=s;function b(l,p){return h.prefixedStream(l,p,d=>S.concat(d))}e.prefixedBufferStream=b;function o(l){let p=0,d=0,v=0;const R=new Uint8Array(Math.floor(l.length/4*3)),O=_=>{switch(d){case 3:R[v++]=p|_,d=0;break;case 2:R[v++]=p|_>>>2,p=_<<6,d=3;break;case 1:R[v++]=p|_>>>4,p=_<<4,d=2;break;default:p=_<<2,d=1}};for(let _=0;_<l.length;_++){const U=l.charCodeAt(_);if(U>=65&&U<=90)O(U-65);else if(U>=97&&U<=122)O(U-97+26);else if(U>=48&&U<=57)O(U-48+52);else if(U===43||U===45)O(62);else if(U===47||U===95)O(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${l[_]}`)}}const L=v;for(;d>0;)O(0);return S.wrap(R).slice(0,L)}e.decodeBase64=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function r({buffer:l},p=!0,d=!1){const v=d?i:n;let R="";const O=l.byteLength%3;let L=0;for(;L<l.byteLength-O;L+=3){const _=l[L+0],U=l[L+1],M=l[L+2];R+=v[_>>>2],R+=v[(_<<4|U>>>4)&63],R+=v[(U<<2|M>>>6)&63],R+=v[M&63]}if(O===1){const _=l[L+0];R+=v[_>>>2],R+=v[_<<4&63],p&&(R+="==")}else if(O===2){const _=l[L+0],U=l[L+1];R+=v[_>>>2],R+=v[(_<<4|U>>>4)&63],R+=v[U<<2&63],p&&(R+="=")}return R}e.encodeBase64=r}),define(we[8],be([1,0,145,92]),function(te,e,h,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=A;const S=/{(\d+)}/g;function P(J,...pe){return pe.length===0?J:J.replace(S,function(Se,Me){const ze=parseInt(Me,10);return isNaN(ze)||ze<0||ze>=pe.length?Se:pe[ze]})}e.format=P;const C=/{([^}]+)}/g;function T(J,pe){return J.replace(C,(Se,Me)=>pe[Me]??Se)}e.format2=T;function F(J){return J.replace(/[<>&]/g,function(pe){switch(pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return pe}})}e.escape=F;function D(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function g(J,pe){let Se=0;const Me=pe.charCodeAt(0);for(let ze=J.length-1;ze>=0;ze--)J.charCodeAt(ze)===Me&&Se++;return Se}e.count=g;function E(J,pe,Se="\u2026"){return J.length<=pe?J:`${J.substr(0,pe)}${Se}`}e.truncate=E;function f(J,pe=" "){const Se=u(J,pe);return w(Se,pe)}e.trim=f;function u(J,pe){if(!J||!pe)return J;const Se=pe.length;if(Se===0||J.length===0)return J;let Me=0;for(;J.indexOf(pe,Me)===Me;)Me=Me+Se;return J.substring(Me)}e.ltrim=u;function w(J,pe){if(!J||!pe)return J;const Se=pe.length,Me=J.length;if(Se===0||Me===0)return J;let ze=Me,Ye=-1;for(;Ye=J.lastIndexOf(pe,ze-1),!(Ye===-1||Ye+Se!==ze);){if(Ye===0)return"";ze=Ye}return J.substring(0,ze)}e.rtrim=w;function y(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function I(J){return J.replace(/\*/g,"")}e.stripWildcards=I;function a(J,pe,Se={}){if(!J)throw new Error("Cannot create regex from empty string");pe||(J=D(J)),Se.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Me="";return Se.global&&(Me+="g"),Se.matchCase||(Me+="i"),Se.multiline&&(Me+="m"),Se.unicode&&(Me+="u"),new RegExp(J,Me)}e.createRegExp=a;function c(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function m(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function s(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=s;function b(J){return J.split(/\r\n|\r|\n/)}e.splitLines=b;function o(J){for(let pe=0,Se=J.length;pe<Se;pe++){const Me=J.charCodeAt(pe);if(Me!==32&&Me!==9)return pe}return-1}e.firstNonWhitespaceIndex=o;function n(J,pe=0,Se=J.length){for(let Me=pe;Me<Se;Me++){const ze=J.charCodeAt(Me);if(ze!==32&&ze!==9)return J.substring(pe,Me)}return J.substring(pe,Se)}e.getLeadingWhitespace=n;function i(J,pe=J.length-1){for(let Se=pe;Se>=0;Se--){const Me=J.charCodeAt(Se);if(Me!==32&&Me!==9)return Se}return-1}e.lastNonWhitespaceIndex=i;function r(J,pe){return J<pe?-1:J>pe?1:0}e.compare=r;function l(J,pe,Se=0,Me=J.length,ze=0,Ye=pe.length){for(;Se<Me&&ze<Ye;Se++,ze++){let mt=J.charCodeAt(Se),Ve=pe.charCodeAt(ze);if(mt<Ve)return-1;if(mt>Ve)return 1}const st=Me-Se,pt=Ye-ze;return st<pt?-1:st>pt?1:0}e.compareSubstring=l;function p(J,pe){return d(J,pe,0,J.length,0,pe.length)}e.compareIgnoreCase=p;function d(J,pe,Se=0,Me=J.length,ze=0,Ye=pe.length){for(;Se<Me&&ze<Ye;Se++,ze++){let mt=J.charCodeAt(Se),Ve=pe.charCodeAt(ze);if(mt===Ve)continue;if(mt>=128||Ve>=128)return l(J.toLowerCase(),pe.toLowerCase(),Se,Me,ze,Ye);v(mt)&&(mt-=32),v(Ve)&&(Ve-=32);const ot=mt-Ve;if(ot!==0)return ot}const st=Me-Se,pt=Ye-ze;return st<pt?-1:st>pt?1:0}e.compareSubstringIgnoreCase=d;function v(J){return J>=97&&J<=122}e.isLowerAsciiLetter=v;function R(J){return J>=65&&J<=90}e.isUpperAsciiLetter=R;function O(J,pe){return J.length===pe.length&&d(J,pe)===0}e.equalsIgnoreCase=O;function L(J,pe){const Se=pe.length;return pe.length>J.length?!1:d(J,pe,0,Se)===0}e.startsWithIgnoreCase=L;function _(J,pe){let Se,Me=Math.min(J.length,pe.length);for(Se=0;Se<Me;Se++)if(J.charCodeAt(Se)!==pe.charCodeAt(Se))return Se;return Me}e.commonPrefixLength=_;function U(J,pe){let Se,Me=Math.min(J.length,pe.length);const ze=J.length-1,Ye=pe.length-1;for(Se=0;Se<Me;Se++)if(J.charCodeAt(ze-Se)!==pe.charCodeAt(Ye-Se))return Se;return Me}e.commonSuffixLength=U;function M(J){return 55296<=J&&J<=56319}e.isHighSurrogate=M;function q(J){return 56320<=J&&J<=57343}e.isLowSurrogate=q;function K(J,pe){return(J-55296<<10)+(pe-56320)+65536}e.computeCodePoint=K;function x(J,pe,Se){const Me=J.charCodeAt(Se);if(M(Me)&&Se+1<pe){const ze=J.charCodeAt(Se+1);if(q(ze))return K(Me,ze)}return Me}e.getNextCodePoint=x;function B(J,pe){const Se=J.charCodeAt(pe-1);if(q(Se)&&pe>1){const Me=J.charCodeAt(pe-2);if(M(Me))return K(Me,Se)}return Se}class G{constructor(pe,Se=0){this._str=pe,this._len=pe.length,this._offset=Se}get offset(){return this._offset}setOffset(pe){this._offset=pe}prevCodePoint(){const pe=B(this._str,this._offset);return this._offset-=pe>=65536?2:1,pe}nextCodePoint(){const pe=x(this._str,this._len,this._offset);return this._offset+=pe>=65536?2:1,pe}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class X{constructor(pe,Se=0){this._iterator=new G(pe,Se)}get offset(){return this._iterator.offset}nextGraphemeLength(){const pe=He.getInstance(),Se=this._iterator,Me=Se.offset;let ze=pe.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Ye=Se.offset,st=pe.getGraphemeBreakType(Se.nextCodePoint());if($e(ze,st)){Se.setOffset(Ye);break}ze=st}return Se.offset-Me}prevGraphemeLength(){const pe=He.getInstance(),Se=this._iterator,Me=Se.offset;let ze=pe.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Ye=Se.offset,st=pe.getGraphemeBreakType(Se.prevCodePoint());if($e(st,ze)){Se.setOffset(Ye);break}ze=st}return Me-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function V(J,pe){return new X(J,pe).nextGraphemeLength()}e.nextCharLength=V;function Z(J,pe){return new X(J,pe).prevGraphemeLength()}e.prevCharLength=Z;function se(J,pe){pe>0&&q(J.charCodeAt(pe))&&pe--;const Se=pe+V(J,pe);return[Se-Z(J,Se),Se]}e.getCharContainingOffset=se;const ce=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ee(J){return ce.test(J)}e.containsRTL=ee;const Q=/^[\t\n\r\x20-\x7E]*$/;function oe(J){return Q.test(J)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=de;function ve(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=ve;function ke(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=ke;function Ne(J,pe){if(J.length<pe)return J;const Se=/\b/g;let Me=0;for(;Se.test(J)&&!(J.length-Se.lastIndex<pe);)Me=Se.lastIndex,Se.lastIndex+=1;return J.substring(Me).replace(/^\s/,"")}e.lcut=Ne;const _e=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,z=/\x1b\[0?m/g;function W(J){return J&&(J=J.replace(_e,""),J=J.replace(Ee,""),J=J.replace(z,"")),J}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function $(J){return N(J)?J.substr(1):J}e.stripUTF8BOM=$;function j(J,pe){if(!J||!pe||J.length<pe.length)return!1;const Se=pe.length,Me=J.toLowerCase();let ze=0,Ye=-1;for(;ze<Se;){const st=Me.indexOf(pe[ze],Ye+1);if(st<0)return!1;Ye=st,ze++}return!0}e.fuzzyContains=j;function re(J,pe=!1){return J?(pe&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=re;function he(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=he;function Ce(J,pe=1){if(pe===0)return"";let Se=-1;do Se=J.indexOf(`
`,Se+1),pe--;while(pe>0&&Se>=0);return Se===-1?J:(J[Se-1]==="\r"&&Se--,J.substr(0,Se))}e.getNLines=Ce;function Ae(J){const pe=90-65+1;return J=J%(2*pe),J<pe?String.fromCharCode(97+J):String.fromCharCode(65+J-pe)}e.singleLetterHash=Ae;function We(J){return He.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=We;function $e(J,pe){return J===0?pe!==5&&pe!==7:J===2&&pe===3?!1:J===4||J===2||J===3||pe===4||pe===2||pe===3?!0:!(J===8&&(pe===8||pe===9||pe===11||pe===12)||(J===11||J===9)&&(pe===9||pe===10)||(J===12||J===10)&&pe===10||pe===5||pe===13||pe===7||J===1||J===13&&pe===14||J===6&&pe===6)}var je;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{constructor(){this._data=Ue()}static getInstance(){return He._INSTANCE||(He._INSTANCE=new He),He._INSTANCE}getGraphemeBreakType(pe){if(pe<32)return pe===10?3:pe===13?2:4;if(pe<127)return 0;const Se=this._data,Me=Se.length/3;let ze=1;for(;ze<=Me;)if(pe<Se[3*ze])ze=2*ze;else if(pe>Se[3*ze+1])ze=2*ze+1;else return Se[3*ze+2];return 0}}He._INSTANCE=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(J,pe){if(J===0)return 0;const Se=et(J,pe);if(Se!==void 0)return Se;const Me=new G(pe,J);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Qe;function et(J,pe){const Se=new G(pe,J);let Me=Se.prevCodePoint();for(;Re(Me)||Me===65039||Me===8419;){if(Se.offset===0)return;Me=Se.prevCodePoint()}if(!ke(Me))return;let ze=Se.offset;return ze>0&&Se.prevCodePoint()===8205&&(ze=Se.offset),ze}function Re(J){return 127995<=J&&J<=127999}var tt;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.noBreakWhitespace="\xA0";class ie{constructor(pe){this.confusableDictionary=pe}static getInstance(pe){return ie.cache.get(Array.from(pe))}static getLocales(){return ie._locales.getValue()}isAmbiguous(pe){return this.confusableDictionary.has(pe)}getPrimaryConfusable(pe){return this.confusableDictionary.get(pe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ie,k=ie,ie.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ie.cache=new h.LRUCachedComputed(J=>{function pe(Ve){const ot=new Map;for(let _t=0;_t<Ve.length;_t+=2)ot.set(Ve[_t],Ve[_t+1]);return ot}function Se(Ve,ot){const _t=new Map(Ve);for(const[nt,lt]of ot)_t.set(nt,lt);return _t}function Me(Ve,ot){if(!Ve)return ot;const _t=new Map;for(const[nt,lt]of Ve)ot.has(nt)&&_t.set(nt,lt);return _t}const ze=k.ambiguousCharacterData.getValue();let Ye=J.filter(Ve=>!Ve.startsWith("_")&&Ve in ze);Ye.length===0&&(Ye=["_default"]);let st;for(const Ve of Ye){const ot=pe(ze[Ve]);st=Me(st,ot)}const pt=pe(ze._common),mt=Se(pt,st);return new ie(mt)}),ie._locales=new t.Lazy(()=>Object.keys(ie.ambiguousCharacterData.getValue()).filter(J=>!J.startsWith("_")));class ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ae.getRawData())),this._data}static isInvisibleCharacter(pe){return ae.getData().has(pe)}static get codePoints(){return ae.getData()}}e.InvisibleCharacters=ae,ae._data=void 0}),define(we[58],be([1,0,8]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(y){return k(y,0)}e.hash=t;function k(y,I){switch(typeof y){case"object":return y===null?A(349,I):Array.isArray(y)?C(y,I):T(y,I);case"string":return P(y,I);case"boolean":return S(y,I);case"number":return A(y,I);case"undefined":return A(937,I);default:return A(617,I)}}e.doHash=k;function A(y,I){return(I<<5)-I+y|0}e.numberHash=A;function S(y,I){return A(y?433:863,I)}function P(y,I){I=A(149417,I);for(let a=0,c=y.length;a<c;a++)I=A(y.charCodeAt(a),I);return I}e.stringHash=P;function C(y,I){return I=A(104579,I),y.reduce((a,c)=>k(c,a),I)}function T(y,I){return I=A(181387,I),Object.keys(y).sort().reduce((a,c)=>(a=P(c,a),k(y[c],a)),I)}class F{constructor(){this._value=0}get value(){return this._value}hash(I){return this._value=k(I,this._value),this._value}}e.Hasher=F;var D;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function g(y,I,a=32){const c=a-I,m=~((1<<c)-1);return(y<<I|(m&y)>>>c)>>>0}function E(y,I=0,a=y.byteLength,c=0){for(let m=0;m<a;m++)y[I+m]=c}function f(y,I,a="0"){for(;y.length<I;)y=a+y;return y}function u(y,I=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(a=>a.toString(16).padStart(2,"0")).join(""):f((y>>>0).toString(16),I/4)}e.toHexString=u;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(I){const a=I.length;if(a===0)return;const c=this._buff;let m=this._buffLen,s=this._leftoverHighSurrogate,b,o;for(s!==0?(b=s,o=-1,s=0):(b=I.charCodeAt(0),o=0);;){let n=b;if(h.isHighSurrogate(b))if(o+1<a){const i=I.charCodeAt(o+1);h.isLowSurrogate(i)?(o++,n=h.computeCodePoint(b,i)):n=65533}else{s=b;break}else h.isLowSurrogate(b)&&(n=65533);if(m=this._push(c,m,n),o++,o<a)b=I.charCodeAt(o);else break}this._buffLen=m,this._leftoverHighSurrogate=s}_push(I,a,c){return c<128?I[a++]=c:c<2048?(I[a++]=192|(c&1984)>>>6,I[a++]=128|(c&63)>>>0):c<65536?(I[a++]=224|(c&61440)>>>12,I[a++]=128|(c&4032)>>>6,I[a++]=128|(c&63)>>>0):(I[a++]=240|(c&1835008)>>>18,I[a++]=128|(c&258048)>>>12,I[a++]=128|(c&4032)>>>6,I[a++]=128|(c&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,I[0]=I[64+0],I[1]=I[64+1],I[2]=I[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const I=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(I/4294967296),!1),this._buffDV.setUint32(60,I%4294967296,!1),this._step()}_step(){const I=w._bigBlock32,a=this._buffDV;for(let l=0;l<64;l+=4)I.setUint32(l,a.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)I.setUint32(l,g(I.getUint32(l-12,!1)^I.getUint32(l-32,!1)^I.getUint32(l-56,!1)^I.getUint32(l-64,!1),1),!1);let c=this._h0,m=this._h1,s=this._h2,b=this._h3,o=this._h4,n,i,r;for(let l=0;l<80;l++)l<20?(n=m&s|~m&b,i=1518500249):l<40?(n=m^s^b,i=1859775393):l<60?(n=m&s|m&b|s&b,i=2400959708):(n=m^s^b,i=3395469782),r=g(c,5)+n+o+i+I.getUint32(l*4,!1)&4294967295,o=b,b=s,s=g(m,30),m=c,c=r;this._h0=this._h0+c&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+b&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[24],be([1,0,17,8]),function(te,e,h,t){"use strict";var k,A,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(o,n,i){let r=o.get(n);return r===void 0&&(r=i,o.set(n,r)),r}e.getOrSet=P;function C(o){const n=[];return o.forEach((i,r)=>{n.push(`${r} => ${i}`)}),`Map(${o.size}) {${n.join(", ")}}`}e.mapToString=C;function T(o){const n=[];return o.forEach(i=>{n.push(i)}),`Set(${o.size}) {${n.join(", ")}}`}e.setToString=T;class F{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const i=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return i-r}value(){return this._value[this._pos]}}e.StringIterator=F;class D{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=D;class g{constructor(n=!0,i=!0){this._splitOnBackslash=n,this._caseSensitive=i}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let i=n.length-1;i>=0;i--,this._valueLen--){const r=this._value.charCodeAt(i);if(!(r===47||this._splitOnBackslash&&r===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var E;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(E||(E={}));class f{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(w||(w={}));class y{constructor(n){this._iter=n}static forUris(n=()=>!1){return new y(new f(n))}static forPaths(n=!1){return new y(new g(void 0,!n))}static forStrings(){return new y(new F)}static forConfigKeys(){return new y(new D)}clear(){this._root=void 0}fill(n,i){if(i){const r=i.slice(0);(0,h.shuffle)(r);for(let l of r)this.set(l,n)}else{const r=n.slice(0);(0,h.shuffle)(r);for(let l of r)this.set(l[0],l[1])}}set(n,i){const r=this._iter.reset(n);let l;this._root||(this._root=new u,this._root.segment=r.value());const p=[];for(l=this._root;;){const v=r.cmp(l.segment);if(v>0)l.left||(l.left=new u,l.left.segment=r.value()),p.push([-1,l]),l=l.left;else if(v<0)l.right||(l.right=new u,l.right.segment=r.value()),p.push([1,l]),l=l.right;else if(r.hasNext())r.next(),l.mid||(l.mid=new u,l.mid.segment=r.value()),p.push([0,l]),l=l.mid;else break}const d=l.value;l.value=i,l.key=n;for(let v=p.length-1;v>=0;v--){const R=p[v][1];R.updateHeight();const O=R.balanceFactor();if(O<-1||O>1){const L=p[v][0],_=p[v+1][0];if(L===1&&_===1)p[v][1]=R.rotateLeft();else if(L===-1&&_===-1)p[v][1]=R.rotateRight();else if(L===1&&_===-1)R.right=p[v+1][1]=p[v+1][1].rotateRight(),p[v][1]=R.rotateLeft();else if(L===-1&&_===1)R.left=p[v+1][1]=p[v+1][1].rotateLeft(),p[v][1]=R.rotateRight();else throw new Error;if(v>0)switch(p[v-1][0]){case-1:p[v-1][1].left=p[v][1];break;case 1:p[v-1][1].right=p[v][1];break;case 0:p[v-1][1].mid=p[v][1];break}else this._root=p[0][1]}}return d}get(n){return this._getNode(n)?.value}_getNode(n){const i=this._iter.reset(n);let r=this._root;for(;r;){const l=i.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else break}return r}has(n){const i=this._getNode(n);return!(i?.value===void 0&&i?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,i){const r=this._iter.reset(n),l=[];let p=this._root;for(;p;){const d=r.cmp(p.segment);if(d>0)l.push([-1,p]),p=p.left;else if(d<0)l.push([1,p]),p=p.right;else if(r.hasNext())r.next(),l.push([0,p]),p=p.mid;else break}if(!!p){if(i?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const d=this._min(p.right),{key:v,value:R,segment:O}=d;this._delete(d.key,!1),p.key=v,p.value=R,p.segment=O}else{const d=p.left??p.right;if(l.length>0){const[v,R]=l[l.length-1];switch(v){case-1:R.left=d;break;case 0:R.mid=d;break;case 1:R.right=d;break}}else this._root=d}for(let d=l.length-1;d>=0;d--){const v=l[d][1];v.updateHeight();const R=v.balanceFactor();if(R>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),l[d][1]=v.rotateLeft()):R<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),l[d][1]=v.rotateRight()),d>0)switch(l[d-1][0]){case-1:l[d-1][1].left=l[d][1];break;case 1:l[d-1][1].right=l[d][1];break;case 0:l[d-1][1].mid=l[d][1];break}else this._root=l[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const i=this._iter.reset(n);let r=this._root,l;for(;r;){const p=i.cmp(r.segment);if(p>0)r=r.left;else if(p<0)r=r.right;else if(i.hasNext())i.next(),l=r.value||l,r=r.mid;else break}return r&&r.value||l}findSuperstr(n){const i=this._iter.reset(n);let r=this._root;for(;r;){const l=i.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[i,r]of this)n(r,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=i=>{if(!i)return!0;const r=i.balanceFactor();return r<-1||r>1?!1:n(i.left)&&n(i.right)};return n(this._root)}}e.TernarySearchTree=y;class I{constructor(n,i){this.uri=n,this.value=i}}class a{constructor(n,i){this[k]="ResourceMap",n instanceof a?(this.map=new Map(n.map),this.toKey=i??a.defaultToKey):(this.map=new Map,this.toKey=n??a.defaultToKey)}set(n,i){return this.map.set(this.toKey(n),new I(n,i)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,i){typeof i!="undefined"&&(n=n.bind(i));for(let[r,l]of this.map)n(l.value,l.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=a,a.defaultToKey=o=>o.toString();var c;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class m{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,i=0){const r=this._map.get(n);if(!!r)return i!==0&&this.touch(r,i),r.value}set(n,i,r=0){let l=this._map.get(n);if(l)l.value=i,r!==0&&this.touch(l,r);else{switch(l={key:n,value:i,next:void 0,previous:void 0},r){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this._map.get(n);if(!!i)return this._map.delete(n),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,i){const r=this._state;let l=this._head;for(;l;){if(i?n.bind(i)(l.value,l.key,this):n(l.value,l.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,i=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const p={value:r.key,done:!1};return r=r.next,p}else return{value:void 0,done:!0}}};return l}values(){const n=this,i=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const p={value:r.value,done:!1};return r=r.next,p}else return{value:void 0,done:!0}}};return l}entries(){const n=this,i=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const p={value:[r.key,r.value],done:!1};return r=r.next,p}else return{value:void 0,done:!0}}};return l}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._head,r=this.size;for(;i&&r>n;)this._map.delete(i.key),i=i.next,r--;this._head=i,this._size=r,i&&(i.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const i=n.next,r=n.previous;if(!i||!r)throw new Error("Invalid list");i.previous=r,r.next=i}n.next=void 0,n.previous=void 0,this._state++}touch(n,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(n===this._head)return;const r=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(r.previous=l,l.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(i===2){if(n===this._tail)return;const r=n.next,l=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=l,l.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((i,r)=>{n.push([r,i])}),n}fromJSON(n){this.clear();for(const[i,r]of n)this.set(i,r)}}e.LinkedMap=m;class s extends m{constructor(n,i=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,i=2){return super.get(n,i)}peek(n){return super.get(n,0)}set(n,i){return super.set(n,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class b{constructor(n){S.set(this,void 0),Ke(this,S,n,"f")}get size(){return Te(this,S,"f").size}forEach(n,i){Te(this,S,"f").forEach(n,i)}get(n){return Te(this,S,"f").get(n)}has(n){return Te(this,S,"f").has(n)}entries(){return Te(this,S,"f").entries()}keys(){return Te(this,S,"f").keys()}values(){return Te(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return Te(this,S,"f").entries()}}e.ReadonlyMapView=b}),define(we[98],be([1,0,24,8]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...N){return function($,j){for(let re=0,he=N.length;re<he;re++){const Ce=N[re]($,j);if(Ce)return Ce}return null}}e.or=k,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(N,$,j){if(!j||j.length<$.length)return null;let re;return N?re=t.startsWithIgnoreCase(j,$):re=j.indexOf($)===0,re?$.length>0?[{start:0,end:$.length}]:[]:null}function S(N,$){const j=$.toLowerCase().indexOf(N.toLowerCase());return j===-1?null:[{start:j,end:j+N.length}]}e.matchesContiguousSubString=S;function P(N,$){return C(N.toLowerCase(),$.toLowerCase(),0,0)}e.matchesSubString=P;function C(N,$,j,re){if(j===N.length)return[];if(re===$.length)return null;if(N[j]===$[re]){let he=null;return(he=C(N,$,j+1,re+1))?y({start:re,end:re+1},he):null}return C(N,$,j,re+1)}function T(N){return 97<=N&&N<=122}function F(N){return 65<=N&&N<=90}e.isUpper=F;function D(N){return 48<=N&&N<=57}function g(N){return N===32||N===9||N===10||N===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(N=>E.add(N.charCodeAt(0)));function f(N){return g(N)||E.has(N)}function u(N,$){return N===$||f(N)&&f($)}function w(N){return T(N)||F(N)||D(N)}function y(N,$){return $.length===0?$=[N]:N.end===$[0].start?$[0].start=N.start:$.unshift(N),$}function I(N,$){for(let j=$;j<N.length;j++){const re=N.charCodeAt(j);if(F(re)||D(re)||j>0&&!w(N.charCodeAt(j-1)))return j}return N.length}function a(N,$,j,re){if(j===N.length)return[];if(re===$.length)return null;if(N[j]!==$[re].toLowerCase())return null;{let he=null,Ce=re+1;for(he=a(N,$,j+1,re+1);!he&&(Ce=I($,Ce))<$.length;)he=a(N,$,j+1,Ce),Ce++;return he===null?null:y({start:re,end:re+1},he)}}function c(N){let $=0,j=0,re=0,he=0,Ce=0;for(let He=0;He<N.length;He++)Ce=N.charCodeAt(He),F(Ce)&&$++,T(Ce)&&j++,w(Ce)&&re++,D(Ce)&&he++;const Ae=$/N.length,We=j/N.length,$e=re/N.length,je=he/N.length;return{upperPercent:Ae,lowerPercent:We,alphaPercent:$e,numericPercent:je}}function m(N){const{upperPercent:$,lowerPercent:j}=N;return j===0&&$>.6}function s(N){const{upperPercent:$,lowerPercent:j,alphaPercent:re,numericPercent:he}=N;return j>.2&&$<.8&&re>.6&&he<.2}function b(N){let $=0,j=0,re=0,he=0;for(let Ce=0;Ce<N.length;Ce++)re=N.charCodeAt(Ce),F(re)&&$++,T(re)&&j++,g(re)&&he++;return($===0||j===0)&&he===0?N.length<=30:$<=5}function o(N,$){if(!$||($=$.trim(),$.length===0)||!b(N)||$.length>60)return null;const j=c($);if(!s(j)){if(!m(j))return null;$=$.toLowerCase()}let re=null,he=0;for(N=N.toLowerCase();he<$.length&&(re=a(N,$,0,he))===null;)he=I($,he+1);return re}e.matchesCamelCase=o;function n(N,$,j=!1){if(!$||$.length===0)return null;let re=null,he=0;for(N=N.toLowerCase(),$=$.toLowerCase();he<$.length&&(re=i(N,$,0,he,j))===null;)he=r($,he+1);return re}e.matchesWords=n;function i(N,$,j,re,he){if(j===N.length)return[];if(re===$.length)return null;if(u(N.charCodeAt(j),$.charCodeAt(re))){let Ce=null,Ae=re+1;if(Ce=i(N,$,j+1,re+1,he),!he)for(;!Ce&&(Ae=r($,Ae))<$.length;)Ce=i(N,$,j+1,Ae,he),Ae++;return Ce===null?null:y({start:re,end:re+1},Ce)}else return null}function r(N,$){for(let j=$;j<N.length;j++)if(f(N.charCodeAt(j))||j>0&&f(N.charCodeAt(j-1)))return j;return N.length}const l=k(e.matchesPrefix,o,S),p=k(e.matchesPrefix,o,P),d=new h.LRUCache(1e4);function v(N,$,j=!1){if(typeof N!="string"||typeof $!="string")return null;let re=d.get(N);re||(re=new RegExp(t.convertSimple2RegExpPattern(N),"i"),d.set(N,re));const he=re.exec($);return he?[{start:he.index,end:he.index+he[0].length}]:j?p(N,$):l(N,$)}e.matchesFuzzy=v;function R(N,$){const j=ve(N,N.toLowerCase(),0,$,$.toLowerCase(),0,!0);return j?L(j):null}e.matchesFuzzy2=R;function O(N,$,j,re,he,Ce){const Ae=Math.min(13,N.length);for(;j<Ae;j++){const We=ve(N,$,j,re,he,Ce,!1);if(We)return We}return[0,Ce]}e.anyScore=O;function L(N){if(typeof N=="undefined")return[];const $=[],j=N[1];for(let re=N.length-1;re>1;re--){const he=N[re]+j,Ce=$[$.length-1];Ce&&Ce.end===he?Ce.end=he+1:$.push({start:he,end:he+1})}return $}e.createMatches=L;const _=128;function U(){const N=[],$=[];for(let j=0;j<=_;j++)$[j]=0;for(let j=0;j<=_;j++)N.push($.slice(0));return N}function M(N){const $=[];for(let j=0;j<=N;j++)$[j]=0;return $}const q=M(2*_),K=M(2*_),x=U(),B=U(),G=U(),X=!1;function V(N,$,j,re,he){function Ce(We,$e,je=" "){for(;We.length<$e;)We=je+We;return We}let Ae=` |   |${re.split("").map(We=>Ce(We,3)).join("|")}
`;for(let We=0;We<=j;We++)We===0?Ae+=" |":Ae+=`${$[We-1]}|`,Ae+=N[We].slice(0,he+1).map($e=>Ce($e.toString(),3)).join("|")+`
`;return Ae}function Z(N,$,j,re){N=N.substr($),j=j.substr(re),console.log(V(B,N,N.length,j,j.length)),console.log(V(G,N,N.length,j,j.length)),console.log(V(x,N,N.length,j,j.length))}function se(N,$){if($<0||$>=N.length)return!1;const j=N.codePointAt($);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(j)}}function ce(N,$){if($<0||$>=N.length)return!1;switch(N.charCodeAt($)){case 32:case 9:return!0;default:return!1}}function ee(N,$,j){return $[N]!==j[N]}function Q(N,$,j,re,he,Ce,Ae=!1){for(;$<j&&he<Ce;)N[$]===re[he]&&(Ae&&(q[$]=he),$+=1),he+=1;return $===j}e.isPatternInWord=Q;var oe;(function(N){N[N.Diag=1]="Diag",N[N.Left=2]="Left",N[N.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var de;(function(N){N.Default=[-100,0];function $(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}N.isDefault=$})(de=e.FuzzyScore||(e.FuzzyScore={}));function ve(N,$,j,re,he,Ce,Ae){const We=N.length>_?_:N.length,$e=re.length>_?_:re.length;if(j>=We||Ce>=$e||We-j>$e-Ce||!Q($,j,We,he,Ce,$e,!0))return;ke(We,$e,j,Ce,$,he);let je=1,He=1,Ue=j,Qe=Ce;const et=[!1];for(je=1,Ue=j;Ue<We;je++,Ue++){const J=q[Ue],pe=K[Ue],Se=Ue+1<We?K[Ue+1]:$e;for(He=J-Ce+1,Qe=J;Qe<Se;He++,Qe++){let Me=Number.MIN_SAFE_INTEGER,ze=!1;Qe<=pe&&(Me=Ne(N,$,Ue,j,re,he,Qe,$e,Ce,x[je-1][He-1]===0,et));let Ye=0;Me!==Number.MAX_SAFE_INTEGER&&(ze=!0,Ye=Me+B[je-1][He-1]);const st=Qe>J,pt=st?B[je][He-1]+(x[je][He-1]>0?-5:0):0,mt=Qe>J+1&&x[je][He-1]>0,Ve=mt?B[je][He-2]+(x[je][He-2]>0?-5:0):0;if(mt&&(!st||Ve>=pt)&&(!ze||Ve>=Ye))B[je][He]=Ve,G[je][He]=3,x[je][He]=0;else if(st&&(!ze||pt>=Ye))B[je][He]=pt,G[je][He]=2,x[je][He]=0;else if(ze)B[je][He]=Ye,G[je][He]=1,x[je][He]=x[je-1][He-1]+1;else throw new Error("not possible")}}if(X&&Z(N,j,re,Ce),!et[0]&&!Ae)return;je--,He--;const Re=[B[je][He],Ce];let tt=0,ie=0;for(;je>=1;){let J=He;do{const pe=G[je][J];if(pe===3)J=J-2;else if(pe===2)J=J-1;else break}while(J>=1);tt>1&&$[j+je-1]===he[Ce+He-1]&&!ee(J+Ce-1,re,he)&&tt+1>x[je][J]&&(J=He),J===He?tt++:tt=1,ie||(ie=J),je--,He=J-1,Re.push(He)}$e===We&&(Re[0]+=2);const ae=ie-We;return Re[0]-=ae,Re}e.fuzzyScore=ve;function ke(N,$,j,re,he,Ce){let Ae=N-1,We=$-1;for(;Ae>=j&&We>=re;)he[Ae]===Ce[We]&&(K[Ae]=We,Ae--),We--}function Ne(N,$,j,re,he,Ce,Ae,We,$e,je,He){if($[j]!==Ce[Ae])return Number.MIN_SAFE_INTEGER;let Ue=1,Qe=!1;return Ae===j-re?Ue=N[j]===he[Ae]?7:5:ee(Ae,he,Ce)&&(Ae===0||!ee(Ae-1,he,Ce))?(Ue=N[j]===he[Ae]?7:5,Qe=!0):se(Ce,Ae)&&(Ae===0||!se(Ce,Ae-1))?Ue=5:(se(Ce,Ae-1)||ce(Ce,Ae-1))&&(Ue=5,Qe=!0),Ue>1&&j===re&&(He[0]=!0),Qe||(Qe=ee(Ae,he,Ce)||se(Ce,Ae-1)||ce(Ce,Ae-1)),j===re?Ae>$e&&(Ue-=Qe?3:5):je?Ue+=Qe?2:0:Ue+=Qe?0:1,Ae+1===We&&(Ue-=Qe?3:5),Ue}function _e(N,$,j,re,he,Ce,Ae){return z(N,$,j,re,he,Ce,!0,Ae)}e.fuzzyScoreGracefulAggressive=_e;function Ee(N,$,j,re,he,Ce,Ae){return z(N,$,j,re,he,Ce,!1,Ae)}e.fuzzyScoreGraceful=Ee;function z(N,$,j,re,he,Ce,Ae,We){let $e=ve(N,$,j,re,he,Ce,We);if($e&&!Ae)return $e;if(N.length>=3){const je=Math.min(7,N.length-1);for(let He=j+1;He<je;He++){const Ue=W(N,He);if(Ue){const Qe=ve(Ue,Ue.toLowerCase(),j,re,he,Ce,We);Qe&&(Qe[0]-=3,(!$e||Qe[0]>$e[0])&&($e=Qe))}}}return $e}function W(N,$){if($+1>=N.length)return;const j=N[$],re=N[$+1];if(j!==re)return N.slice(0,$)+re+j+N.slice($+2)}}),define(we[146],be([1,0,73,98,8]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(h.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${A.source}`,"g");function C(w){return w.replace(P,(y,I)=>I?y:`\\${y}`)}e.escapeIcons=C;const T=new RegExp(`\\\\${A.source}`,"g");function F(w){return w.replace(T,y=>`\\${y}`)}e.markdownEscapeEscapedIcons=F;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function g(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(D,(y,I,a,c)=>a?y:I||c||"")}e.stripIcons=g;function E(w){const y=w.indexOf(e.iconStartMarker);return y===-1?{text:w}:f(w,y)}e.parseLabelWithIcons=E;function f(w,y){const I=[];let a="";function c(l){if(l){a+=l;for(const p of l)I.push(b)}}let m=-1,s="",b=0,o,n,i=y;const r=w.length;for(c(w.substr(0,y));i<r;)o=w[i],n=w[i+1],o===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(m=i,c(s),s=e.iconStartMarker,i++):o===")"&&m!==-1?(b+=i-m+1,m=-1,s=""):m!==-1?S.test(o)?s+=o:(c(s),m=-1,s=""):c(o),i++;return c(s),{text:a,iconOffsets:I}}function u(w,y,I=!1){const{text:a,iconOffsets:c}=y;if(!c||c.length===0)return(0,t.matchesFuzzy)(w,a,I);const m=(0,k.ltrim)(a," "),s=a.length-m.length,b=(0,t.matchesFuzzy)(w,m,I);if(b)for(const o of b){const n=c[o.start+s]+s;o.start+=n,o.end+=n}return b}e.matchesFuzzyIconAware=u}),define(we[78],be([1,0,24]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new h.LRUCache(1e4);function k(T){return C(T,"NFC",t)}e.normalizeNFC=k;const A=new h.LRUCache(1e4);function S(T){return C(T,"NFD",A)}e.normalizeNFD=S;const P=/[^\u0000-\u0080]/;function C(T,F,D){if(!T)return T;const g=D.get(T);if(g)return g;let E;return P.test(T)?E=T.normalize(F):E=T,D.set(T,E),E}e.removeAccents=function(){const T=/[\u0300-\u036f]/g;return function(F){return S(F).replace(T,"")}}()}),define(we[47],be([1,0,8]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const A="error",S="warning",P="warn",C="info",T="ignore";function F(g){return g?h.equalsIgnoreCase(A,g)?k.Error:h.equalsIgnoreCase(S,g)||h.equalsIgnoreCase(P,g)?k.Warning:h.equalsIgnoreCase(C,g)?k.Info:k.Ignore:k.Ignore}k.fromValue=F;function D(g){switch(g){case k.Error:return A;case k.Warning:return S;case k.Info:return C;default:return T}}k.toString=D}(t||(t={})),e.default=t}),define(we[18],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function h(r){return Array.isArray(r)}e.isArray=h;function t(r){return typeof r=="string"}e.isString=t;function k(r){return Array.isArray(r)&&r.every(l=>t(l))}e.isStringArray=k;function A(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=A;function S(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=S;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function C(r){return r===!0||r===!1}e.isBoolean=C;function T(r){return typeof r=="undefined"}e.isUndefined=T;function F(r){return!D(r)}e.isDefined=F;function D(r){return T(r)||r===null}e.isUndefinedOrNull=D;function g(r,l){if(!r)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=g;function E(r){if(D(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=E;function f(...r){const l=[];for(let p=0;p<r.length;p++){const d=r[p];if(D(d))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);l.push(d)}return l}e.assertAllDefined=f;const u=Object.prototype.hasOwnProperty;function w(r){if(!A(r))return!1;for(let l in r)if(u.call(r,l))return!1;return!0}e.isEmptyObject=w;function y(r){return typeof r=="function"}e.isFunction=y;function I(...r){return r.length>0&&r.every(y)}e.areFunctions=I;function a(r,l){const p=Math.min(r.length,l.length);for(let d=0;d<p;d++)c(r[d],l[d])}e.validateConstraints=a;function c(r,l){if(t(l)){if(typeof r!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(y(l)){try{if(r instanceof l)return}catch{}if(!D(r)&&r.constructor===l||l.length===1&&l.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function m(r){let l=[],p=Object.getPrototypeOf(r);for(;Object.prototype!==p;)l=l.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return l}e.getAllPropertyNames=m;function s(r){const l=[];for(const p of m(r))typeof r[p]=="function"&&l.push(p);return l}e.getAllMethodNames=s;function b(r,l){const p=v=>function(){const R=Array.prototype.slice.call(arguments,0);return l(v,R)};let d={};for(const v of r)d[v]=p(v);return d}e.createProxyObject=b;function o(r){return r===null?void 0:r}e.withNullAsUndefined=o;function n(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=n;function i(r,l="Unreachable"){throw new Error(l)}e.assertNever=i}),define(we[28],be([1,0,9,12,8,18]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(i){return i===47||i===92}e.isPathSeparator=S;function P(i){return i.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=P;function C(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=C;function T(i,r=h.posix.sep){if(!i)return"";const l=i.length,p=i.charCodeAt(0);if(S(p)){if(S(i.charCodeAt(1))&&!S(i.charCodeAt(2))){let v=3;const R=v;for(;v<l&&!S(i.charCodeAt(v));v++);if(R!==v&&!S(i.charCodeAt(v+1))){for(v+=1;v<l;v++)if(S(i.charCodeAt(v)))return i.slice(0,v+1).replace(/[\\/]/g,r)}}return r}else if(y(p)&&i.charCodeAt(1)===58)return S(i.charCodeAt(2))?i.slice(0,2)+r:i.slice(0,2);let d=i.indexOf("://");if(d!==-1){for(d+=3;d<l;d++)if(S(i.charCodeAt(d)))return i.slice(0,d+1)}return""}e.getRoot=T;function F(i){if(!t.isWindows||!i||i.length<5)return!1;let r=i.charCodeAt(0);if(r!==92||(r=i.charCodeAt(1),r!==92))return!1;let l=2;const p=l;for(;l<i.length&&(r=i.charCodeAt(l),r!==92);l++);return!(p===l||(r=i.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=F;const D=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(i,r=t.isWindows){const l=r?D:g;return!(!i||i.length===0||/^\s+$/.test(i)||(l.lastIndex=0,l.test(i))||r&&E.test(i)||i==="."||i===".."||r&&i[i.length-1]==="."||r&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=f;function u(i,r,l){const p=i===r;return!l||p?p:!i||!r?!1:(0,k.equalsIgnoreCase)(i,r)}e.isEqual=u;function w(i,r,l,p=h.sep){if(i===r)return!0;if(!i||!r||r.length>i.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(i,r))return!1;if(r.length===i.length)return!0;let v=r.length;return r.charAt(r.length-1)===p&&v--,i.charAt(v)===p}return r.charAt(r.length-1)!==p&&(r+=p),i.indexOf(r)===0}e.isEqualOrParent=w;function y(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=y;function I(i,r){return t.isWindows&&i.endsWith(":")&&(i+=h.sep),(0,h.isAbsolute)(i)||(i=(0,h.join)(r,i)),i=(0,h.normalize)(i),t.isWindows?(i=(0,k.rtrim)(i,h.sep),i.endsWith(":")&&(i+=h.sep)):(i=(0,k.rtrim)(i,h.sep),i||(i=h.sep)),i}e.sanitizeFilePath=I;function a(i){const r=(0,h.normalize)(i);return t.isWindows?i.length>3?!1:c(r)&&(i.length===2||r.charCodeAt(2)===92):r===h.posix.sep}e.isRootOrDriveLetter=a;function c(i,r){return(r!==void 0?r:t.isWindows)?y(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function m(i){return c(i)?i[0]:void 0}e.getDriveLetter=m;function s(i,r,l){return r.length>i.length?-1:i===r?0:(l&&(i=i.toLowerCase(),r=r.toLowerCase()),i.indexOf(r))}e.indexOfPath=s;function b(i){const r=i.split(":");let l,p,d;for(const v of r){const R=Number(v);(0,A.isNumber)(R)?p===void 0?p=R:d===void 0&&(d=R):l=l?[l,v].join(":"):v}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:p!==void 0?p:void 0,column:d!==void 0?d:p!==void 0?1:void 0}}e.parseLineAndColumnAware=b;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(i,r,l=8){let p="";for(let v=0;v<l;v++)p+=o.charAt(Math.floor(Math.random()*o.length));let d;return r?d=`${r}-${p}`:d=p,i?(0,h.join)(i,d):d}e.randomPath=n}),define(we[25],be([1,0,18]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const w=Array.isArray(u)?[]:{};return Object.keys(u).forEach(y=>{u[y]&&typeof u[y]=="object"?w[y]=t(u[y]):w[y]=u[y]}),w}e.deepClone=t;function k(u){if(!u||typeof u!="object")return u;const w=[u];for(;w.length>0;){const y=w.shift();Object.freeze(y);for(const I in y)if(A.call(y,I)){const a=y[I];typeof a=="object"&&!Object.isFrozen(a)&&w.push(a)}}return u}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function S(u,w){return P(u,w,new Set)}e.cloneAndChange=S;function P(u,w,y){if((0,h.isUndefinedOrNull)(u))return u;const I=w(u);if(typeof I!="undefined")return I;if((0,h.isArray)(u)){const a=[];for(const c of u)a.push(P(c,w,y));return a}if((0,h.isObject)(u)){if(y.has(u))throw new Error("Cannot clone recursive data-structure");y.add(u);const a={};for(let c in u)A.call(u,c)&&(a[c]=P(u[c],w,y));return y.delete(u),a}return u}function C(u,w,y=!0){return(0,h.isObject)(u)?((0,h.isObject)(w)&&Object.keys(w).forEach(I=>{I in u?y&&((0,h.isObject)(u[I])&&(0,h.isObject)(w[I])?C(u[I],w[I],y):u[I]=w[I]):u[I]=w[I]}),u):w}e.mixin=C;function T(u,w){if(u===w)return!0;if(u==null||w===null||w===void 0||typeof u!=typeof w||typeof u!="object"||Array.isArray(u)!==Array.isArray(w))return!1;let y,I;if(Array.isArray(u)){if(u.length!==w.length)return!1;for(y=0;y<u.length;y++)if(!T(u[y],w[y]))return!1}else{const a=[];for(I in u)a.push(I);a.sort();const c=[];for(I in w)c.push(I);if(c.sort(),!T(a,c))return!1;for(y=0;y<a.length;y++)if(!T(u[a[y]],w[a[y]]))return!1}return!0}e.equals=T;function F(u){const w=new Set;return JSON.stringify(u,(y,I)=>{if((0,h.isObject)(I)||Array.isArray(I)){if(w.has(I))return"[Circular]";w.add(I)}return I})}e.safeStringify=F;function D(u,w,y){const I=w(u);return typeof I=="undefined"?y:I}e.getOrDefault=D;function g(u,w){const y=Object.create(null);return!u||!w||Object.keys(w).forEach(a=>{const c=u[a],m=w[a];T(c,m)||(y[a]=m)}),y}e.distinct=g;function E(u,w){const y=w.toLowerCase(),I=Object.keys(u).find(a=>a.toLowerCase()===y);return I?u[I]:u[w]}e.getCaseInsensitive=E;function f(u,w){const y=Object.create(null);for(const[I,a]of Object.entries(u))w(I,a)&&(y[I]=a);return y}e.filter=f}),define(we[99],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var h;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function k(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=k}),define(we[2],be([1,0,9,12]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,A=/^\//,S=/^\/\//;function P(o,n){if(!o.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!k.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!A.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(o,n){return!o&&!n?"file":o}function T(o,n){switch(o){case"https":case"http":case"file":n?n[0]!==D&&(n=D+n):n=D;break}return n}const F="",D="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(n,i,r,l,p,d=!1){typeof n=="object"?(this.scheme=n.scheme||F,this.authority=n.authority||F,this.path=n.path||F,this.query=n.query||F,this.fragment=n.fragment||F):(this.scheme=C(n,d),this.authority=i||F,this.path=T(this.scheme,r||F),this.query=l||F,this.fragment=p||F,P(this,d))}static isUri(n){return n instanceof E?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return a(this,!1)}with(n){if(!n)return this;let{scheme:i,authority:r,path:l,query:p,fragment:d}=n;return i===void 0?i=this.scheme:i===null&&(i=F),r===void 0?r=this.authority:r===null&&(r=F),l===void 0?l=this.path:l===null&&(l=F),p===void 0?p=this.query:p===null&&(p=F),d===void 0?d=this.fragment:d===null&&(d=F),i===this.scheme&&r===this.authority&&l===this.path&&p===this.query&&d===this.fragment?this:new u(i,r,l,p,d)}static parse(n,i=!1){const r=g.exec(n);return r?new u(r[2]||F,b(r[4]||F),b(r[5]||F),b(r[7]||F),b(r[9]||F),i):new u(F,F,F,F,F)}static file(n){let i=F;if(t.isWindows&&(n=n.replace(/\\/g,D)),n[0]===D&&n[1]===D){const r=n.indexOf(D,2);r===-1?(i=n.substring(2),n=D):(i=n.substring(2,r),n=n.substring(r)||D)}return new u("file",i,n,F,F)}static from(n){const i=new u(n.scheme,n.authority,n.path,n.query,n.fragment);return P(i,!0),i}static joinPath(n,...i){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let r;return t.isWindows&&n.scheme==="file"?r=E.file(h.win32.join(a(n,!0),...i)).path:r=h.posix.join(n.path,...i),n.with({path:r})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof E)return n;{const i=new u(n);return i._formatted=n.external,i._fsPath=n._sep===f?n.fsPath:null,i}}else return n}}e.URI=E;const f=t.isWindows?1:void 0;class u extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=f),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(o,n){let i,r=-1;for(let l=0;l<o.length;l++){const p=o.charCodeAt(l);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||n&&p===47)r!==-1&&(i+=encodeURIComponent(o.substring(r,l)),r=-1),i!==void 0&&(i+=o.charAt(l));else{i===void 0&&(i=o.substr(0,l));const d=w[p];d!==void 0?(r!==-1&&(i+=encodeURIComponent(o.substring(r,l)),r=-1),i+=d):r===-1&&(r=l)}}return r!==-1&&(i+=encodeURIComponent(o.substring(r))),i!==void 0?i:o}function I(o){let n;for(let i=0;i<o.length;i++){const r=o.charCodeAt(i);r===35||r===63?(n===void 0&&(n=o.substr(0,i)),n+=w[r]):n!==void 0&&(n+=o[i])}return n!==void 0?n:o}function a(o,n){let i;return o.authority&&o.path.length>1&&o.scheme==="file"?i=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?n?i=o.path.substr(1):i=o.path[1].toLowerCase()+o.path.substr(2):i=o.path,t.isWindows&&(i=i.replace(/\//g,"\\")),i}e.uriToFsPath=a;function c(o,n){const i=n?I:y;let r="",{scheme:l,authority:p,path:d,query:v,fragment:R}=o;if(l&&(r+=l,r+=":"),(p||l==="file")&&(r+=D,r+=D),p){let O=p.indexOf("@");if(O!==-1){const L=p.substr(0,O);p=p.substr(O+1),O=L.indexOf(":"),O===-1?r+=i(L,!1):(r+=i(L.substr(0,O),!1),r+=":",r+=i(L.substr(O+1),!1)),r+="@"}p=p.toLowerCase(),O=p.indexOf(":"),O===-1?r+=i(p,!1):(r+=i(p.substr(0,O),!1),r+=p.substr(O))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const O=d.charCodeAt(1);O>=65&&O<=90&&(d=`/${String.fromCharCode(O+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const O=d.charCodeAt(0);O>=65&&O<=90&&(d=`${String.fromCharCode(O+32)}:${d.substr(2)}`)}r+=i(d,!0)}return v&&(r+="?",r+=i(v,!1)),R&&(r+="#",r+=n?R:y(R,!1)),r}function m(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+m(o.substr(3)):o}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(o){return o.match(s)?o.replace(s,n=>m(n)):o}}),define(we[59],be([1,0,23,8,2]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(F){return JSON.stringify(F,C)}e.stringify=A;function S(F){let D=JSON.parse(F);return D=T(D),D}e.parse=S;var P;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext",F[F.Date=14]="Date"})(P=e.MarshalledId||(e.MarshalledId={}));function C(F,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,t.regExpFlags)(D)}:D}function T(F,D=0){if(!F||D>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return k.URI.revive(F);case 2:return new RegExp(F.source,F.flags);case 14:return new Date(F.source)}if(F instanceof h.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let g=0;g<F.length;++g)F[g]=T(F[g],D+1);else for(const g in F)Object.hasOwnProperty.call(F,g)&&(F[g]=T(F[g],D+1))}return F}e.revive=T}),define(we[10],be([1,0,12,2]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,T,F){this._hosts[C]=T,this._ports[C]=F}setConnectionToken(C,T){this._connectionTokens[C]=T}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const T=C.authority;let F=this._hosts[T];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const D=this._ports[T],g=this._connectionTokens[T];let E=`path=${encodeURIComponent(C.path)}`;return typeof g=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),t.URI.from({scheme:h.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${F}:${D}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new A;class S{asBrowserUri(C,T){const F=this.toUri(C,T);return F.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===k.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${k.vscodeFileResource}://${S.FALLBACK_AUTHORITY}`)?F.with({scheme:k.vscodeFileResource,authority:F.authority||S.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(C,T){const F=this.toUri(C,T);return F.scheme===k.vscodeFileResource?F.with({scheme:k.file,authority:F.authority!==S.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(C,T){return t.URI.isUri(C)?C:t.URI.parse(T.toUrl(C))}}S.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new S}),define(we[22],be([1,0,28,10,9,12,8,2]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(E){return(0,P.uriToFsPath)(E,!0)}e.originalFSPath=C;class T{constructor(f){this._ignorePathCasing=f}compare(f,u,w=!1){return f===u?0:(0,S.compare)(this.getComparisonKey(f,w),this.getComparisonKey(u,w))}isEqual(f,u,w=!1){return f===u?!0:!f||!u?!1:this.getComparisonKey(f,w)===this.getComparisonKey(u,w)}getComparisonKey(f,u=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,u,w=!1){if(f.scheme===u.scheme){if(f.scheme===t.Schemas.file)return h.isEqualOrParent(C(f),C(u),this._ignorePathCasing(f))&&f.query===u.query&&(w||f.fragment===u.fragment);if((0,e.isEqualAuthority)(f.authority,u.authority))return h.isEqualOrParent(f.path,u.path,this._ignorePathCasing(f),"/")&&f.query===u.query&&(w||f.fragment===u.fragment)}return!1}joinPath(f,...u){return P.URI.joinPath(f,...u)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return k.posix.basename(f.path)}extname(f){return k.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let u;return f.scheme===t.Schemas.file?u=P.URI.file(k.dirname(C(f))).path:(u=k.posix.dirname(f.path),f.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),u="/")),f.with({path:u})}normalizePath(f){if(!f.path.length)return f;let u;return f.scheme===t.Schemas.file?u=P.URI.file(k.normalize(C(f))).path:u=k.posix.normalize(f.path),f.with({path:u})}relativePath(f,u){if(f.scheme!==u.scheme||!(0,e.isEqualAuthority)(f.authority,u.authority))return;if(f.scheme===t.Schemas.file){const I=k.relative(C(f),C(u));return A.isWindows?h.toSlashes(I):I}let w=f.path||"/",y=u.path||"/";if(this._ignorePathCasing(f)){let I=0;for(const a=Math.min(w.length,y.length);I<a&&!(w.charCodeAt(I)!==y.charCodeAt(I)&&w.charAt(I).toLowerCase()!==y.charAt(I).toLowerCase());I++);w=y.substr(0,I)+w.substr(I)}return k.posix.relative(w,y)}resolvePath(f,u){if(f.scheme===t.Schemas.file){const w=P.URI.file(k.resolve(C(f),u));return f.with({authority:w.authority,path:w.path})}return u=h.toPosixPath(u),f.with({path:k.posix.resolve(f.path,u)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,u){return f===u||f!==void 0&&u!==void 0&&(0,S.equalsIgnoreCase)(f,u)}hasTrailingPathSeparator(f,u=k.sep){if(f.scheme===t.Schemas.file){const w=C(f);return w.length>h.getRoot(w).length&&w[w.length-1]===u}else{const w=f.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,u=k.sep){return(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,u=k.sep){let w=!1;if(f.scheme===t.Schemas.file){const y=C(f);w=y!==void 0&&y.length===h.getRoot(y).length&&y[y.length-1]===u}else{u="/";const y=f.path;w=y.length===1&&y.charCodeAt(y.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path+"/"}):f}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(E=>E.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(E,f){const u=[];for(let w=0;w<E.length;w++){const y=f(E[w]);E.some((I,a)=>a===w?!1:(0,e.isEqualOrParent)(y,f(I)))||u.push(E[w])}return u}e.distinctParents=F;var D;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function f(u){const w=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,m]=a.split(":");c&&m&&w.set(c,m)});const I=u.path.substring(0,u.path.indexOf(";"));return I&&w.set(E.META_DATA_MIME,I),w}E.parseMetaData=f})(D=e.DataUri||(e.DataUri={}));function g(E,f,u){if(f){let w=E.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),E.with({scheme:u,authority:f,path:w})}return E.with({scheme:u})}e.toLocalResource=g}),define(we[13],be([1,0,21,16,3,6,22,12]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(ee){return!!ee&&typeof ee.then=="function"}e.isThenable=C;function T(ee){const Q=new h.CancellationTokenSource,oe=ee(Q.token),de=new Promise((ve,ke)=>{const Ne=Q.token.onCancellationRequested(()=>{Ne.dispose(),Q.dispose(),ke(new t.CancellationError)});Promise.resolve(oe).then(_e=>{Ne.dispose(),Q.dispose(),ve(_e)},_e=>{Ne.dispose(),Q.dispose(),ke(_e)})});return new class{cancel(){Q.cancel()}then(ve,ke){return de.then(ve,ke)}catch(ve){return this.then(void 0,ve)}finally(ve){return de.finally(ve)}}}e.createCancelablePromise=T;function F(ee,Q,oe){return new Promise((de,ve)=>{const ke=Q.onCancellationRequested(()=>{ke.dispose(),de(oe)});ee.then(de,ve).finally(()=>ke.dispose())})}e.raceCancellation=F;function D(ee,Q){return new Promise((oe,de)=>{const ve=Q.onCancellationRequested(()=>{ve.dispose(),de(new t.CancellationError)});ee.then(oe,de).finally(()=>ve.dispose())})}e.raceCancellationError=D;async function g(ee){let Q=-1;const oe=ee.map((ve,ke)=>ve.then(Ne=>(Q=ke,Ne))),de=await Promise.race(oe);return ee.forEach((ve,ke)=>{ke!==Q&&ve.cancel()}),de}e.raceCancellablePromises=g;function E(ee,Q,oe){let de;const ve=setTimeout(()=>{de?.(void 0),oe?.()},Q);return Promise.race([ee.finally(()=>clearTimeout(ve)),new Promise(ke=>de=ke)])}e.raceTimeout=E;function f(ee){return new Promise((Q,oe)=>{const de=ee();C(de)?de.then(Q,oe):Q(de)})}e.asPromise=f;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const oe=()=>{this.queuedPromise=null;const de=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,de};this.queuedPromise=new Promise(de=>{this.activePromise.then(oe,oe).then(de)})}return new Promise((oe,de)=>{this.queuedPromise.then(oe,de)})}return this.activePromise=Q(),new Promise((oe,de)=>{this.activePromise.then(ve=>{this.activePromise=null,oe(ve)},ve=>{this.activePromise=null,de(ve)})})}}e.Throttler=u;class w{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=w;class y{constructor(){this.promiseMap=new Map}queue(Q,oe){const ve=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.promiseMap.get(Q)===ve&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,ve),ve}}e.SequencerByKey=y;const I=(ee,Q)=>{let oe=!0;const de=setTimeout(()=>{oe=!1,Q()},ee);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(de),oe=!1}}},a=ee=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ee())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,oe=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ve,ke)=>{this.doResolve=ve,this.doReject=ke}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ve=this.task;return this.task=null,ve()}}));const de=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=oe===e.MicrotaskDelay?a(de):I(oe,de),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class m{constructor(Q){this.delayer=new c(Q),this.throttler=new u}trigger(Q,oe){return this.delayer.trigger(()=>this.throttler.queue(Q),oe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class s{constructor(){this._isOpen=!1,this._promise=new Promise((Q,oe)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class b extends s{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=b;function o(ee,Q){return Q?new Promise((oe,de)=>{const ve=setTimeout(()=>{ke.dispose(),oe()},ee),ke=Q.onCancellationRequested(()=>{clearTimeout(ve),ke.dispose(),de(new t.CancellationError)})}):T(oe=>o(ee,oe))}e.timeout=o;function n(ee,Q=0){const oe=setTimeout(ee,Q);return(0,A.toDisposable)(()=>clearTimeout(oe))}e.disposableTimeout=n;function i(ee){const Q=[];let oe=0;const de=ee.length;function ve(){return oe<de?ee[oe++]():null}function ke(Ne){Ne!=null&&Q.push(Ne);const _e=ve();return _e?_e.then(ke):Promise.resolve(Q)}return Promise.resolve(null).then(ke)}e.sequence=i;function r(ee,Q=de=>!!de,oe=null){let de=0;const ve=ee.length,ke=()=>{if(de>=ve)return Promise.resolve(oe);const Ne=ee[de++];return Promise.resolve(Ne()).then(Ee=>Q(Ee)?Promise.resolve(Ee):ke())};return ke()}e.first=r;function l(ee,Q=de=>!!de,oe=null){if(ee.length===0)return Promise.resolve(oe);let de=ee.length;const ve=()=>{de=-1;for(const ke of ee)ke.cancel?.()};return new Promise((ke,Ne)=>{for(const _e of ee)_e.then(Ee=>{--de>=0&&Q(Ee)?(ve(),ke(Ee)):de===0&&ke(oe)}).catch(Ee=>{--de>=0&&(ve(),Ne(Ee))})})}e.firstParallel=l;class p{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((oe,de)=>{this.outstandingPromises.push({factory:Q,c:oe,e:de}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const oe=Q.factory();oe.then(Q.c,Q.e),oe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class d extends p{constructor(){super(1)}}e.Queue=d;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new G;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,oe=S.extUri){const de=oe.getComparisonKey(Q);let ve=this.queues.get(de);return ve||(ve=new d,k.Event.once(ve.onFinished)(()=>{ve?.dispose(),this.queues.delete(de),this.onDidQueueFinish()}),this.queues.set(de,ve)),ve}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class R{constructor(Q,oe){this._token=-1,typeof Q=="function"&&typeof oe=="number"&&this.setIfNotSet(Q,oe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,oe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},oe)}setIfNotSet(Q,oe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},oe))}}e.TimeoutTimer=R;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,oe){this.cancel(),this._token=setInterval(()=>{Q()},oe)}}e.IntervalTimer=O;class L{constructor(Q,oe){this.timeoutToken=-1,this.runner=Q,this.timeout=oe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class _{constructor(Q,oe){oe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=oe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=_;class U extends L{constructor(Q,oe){super(Q,oe);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class M extends A.Disposable{constructor(Q,oe){super();this.options=Q,this.handler=oe,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ee=>{(0,P.setTimeout0)(()=>{if(Q)return;const oe=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(ee,Q)=>{const oe=requestIdleCallback(ee,typeof Q=="number"?{timeout:Q}:void 0);let de=!1;return{dispose(){de||(de=!0,cancelIdleCallback(oe))}}}}();class q{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(oe){this._error=oe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function K(ee,Q,oe){let de;for(let ve=0;ve<oe;ve++)try{return await ee()}catch(ke){de=ke,await o(Q)}throw de}e.retry=K;class x{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Q,oe,de){return this._pending={taskId:Q,cancel:()=>de?.(),promise:oe},oe.then(()=>this.donePending(Q),()=>this.donePending(Q)),oe}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let oe,de;const ve=new Promise((ke,Ne)=>{oe=ke,de=Ne});this._next={run:Q,promise:ve,promiseResolve:oe,promiseReject:de}}return this._next.promise}}e.TaskSequentializer=x;class B{constructor(Q,oe=()=>Date.now()){this.interval=Q,this.nowFn=oe,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,oe)=>{this.completeCallback=Q,this.errorCallback=oe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(oe=>{this.completeCallback(Q),this.resolved=!0,oe()})}error(Q){return new Promise(oe=>{this.errorCallback(Q),this.rejected=!0,oe()})}cancel(){new Promise(Q=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=G;var X;(function(ee){async function Q(de){let ve;const ke=await Promise.all(de.map(Ne=>Ne.then(_e=>_e,_e=>{ve||(ve=_e)})));if(typeof ve!="undefined")throw ve;return ke}ee.settled=Q;function oe(de){return new Promise(async(ve,ke)=>{try{await de(ve,ke)}catch(Ne){ke(Ne)}})}ee.withAsyncBody=oe})(X=e.Promises||(e.Promises={}));var V;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(V||(V={}));class Z{constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const oe={emitOne:de=>this.emitOne(de),emitMany:de=>this.emitMany(de),reject:de=>this.reject(de)};try{await Promise.resolve(Q(oe)),this.resolve()}catch(de){this.reject(de)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}static fromArray(Q){return new Z(oe=>{oe.emitMany(Q)})}static fromPromise(Q){return new Z(async oe=>{oe.emitMany(await Q)})}static fromPromises(Q){return new Z(async oe=>{await Promise.all(Q.map(async de=>oe.emitOne(await de)))})}static merge(Q){return new Z(async oe=>{await Promise.all(Q.map(async de=>{for await(const ve of de)oe.emitOne(ve)}))})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,oe){return new Z(async de=>{for await(const ve of Q)de.emitOne(oe(ve))})}map(Q){return Z.map(this,Q)}static filter(Q,oe){return new Z(async de=>{for await(const ve of Q)oe(ve)&&de.emitOne(ve)})}filter(Q){return Z.filter(this,Q)}static coalesce(Q){return Z.filter(Q,oe=>!!oe)}coalesce(){return Z.coalesce(this)}static async toPromise(Q){const oe=[];for await(const de of Q)oe.push(de);return oe}toPromise(){return Z.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=Z,Z.EMPTY=Z.fromArray([]);class se extends Z{constructor(Q,oe){super(oe);this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function ce(ee){const Q=new h.CancellationTokenSource,oe=ee(Q.token);return new se(Q,async de=>{const ve=Q.token.onCancellationRequested(()=>{ve.dispose(),Q.dispose(),de.reject(new t.CancellationError)});try{for await(const ke of oe){if(Q.token.isCancellationRequested)return;de.emitOne(ke)}ve.dispose(),Q.dispose()}catch(ke){ve.dispose(),Q.dispose(),de.reject(ke)}})}e.createCancelableAsyncIterable=ce}),define(we[100],be([1,0,13,9]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new h.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),A=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(d,v,R=!1){const O=d||"",L=v||"",_=k.value.collator.compare(O,L);return k.value.collatorIsNumeric&&_===0&&O!==L?O<L?-1:1:_}e.compareFileNames=P;function C(d,v){const R=A.value.collator;return d=d||"",v=v||"",m(R,d,v)}e.compareFileNamesDefault=C;function T(d,v){const R=A.value.collator;return d=d||"",v=v||"",n(d,v)||m(R,d,v)}e.compareFileNamesUpper=T;function F(d,v){const R=A.value.collator;return d=d||"",v=v||"",o(d,v)||m(R,d,v)}e.compareFileNamesLower=F;function D(d,v){return d=d||"",v=v||"",d===v?0:d<v?-1:1}e.compareFileNamesUnicode=D;function g(d,v,R=!1){R||(d=d&&d.toLowerCase(),v=v&&v.toLowerCase());const[O,L]=a(d),[_,U]=a(v);return O!==_?O<_?-1:1:L===U?0:L<U?-1:1}e.noIntlCompareFileNames=g;function E(d,v){const[R,O]=a(d),[L,_]=a(v);let U=k.value.collator.compare(O,_);if(U===0){if(k.value.collatorIsNumeric&&O!==_)return O<_?-1:1;if(U=k.value.collator.compare(R,L),k.value.collatorIsNumeric&&U===0&&R!==L)return R<L?-1:1}return U}e.compareFileExtensions=E;function f(d,v){d=d||"",v=v||"";const R=c(d),O=c(v),L=A.value.collator,_=S.value.collator;return m(_,R,O)||m(L,d,v)}e.compareFileExtensionsDefault=f;function u(d,v){d=d||"",v=v||"";const R=c(d),O=c(v),L=A.value.collator,_=S.value.collator;return m(_,R,O)||n(d,v)||m(L,d,v)}e.compareFileExtensionsUpper=u;function w(d,v){d=d||"",v=v||"";const R=c(d),O=c(v),L=A.value.collator,_=S.value.collator;return m(_,R,O)||o(d,v)||m(L,d,v)}e.compareFileExtensionsLower=w;function y(d,v){d=d||"",v=v||"";const R=c(d).toLowerCase(),O=c(v).toLowerCase();return R!==O?R<O?-1:1:d!==v?d<v?-1:1:0}e.compareFileExtensionsUnicode=y;const I=/^(.*?)(\.([^.]*))?$/;function a(d,v=!1){const R=d?I.exec(d):[];let O=[R&&R[1]||"",R&&R[3]||""];return v&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function c(d){const v=d?I.exec(d):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function m(d,v,R){let O=d.compare(v,R);return O!==0?O:v.length!==R.length?v.length<R.length?-1:1:0}function s(d){const v=d.charAt(0);return v.toLocaleUpperCase()!==v}function b(d){const v=d.charAt(0);return v.toLocaleLowerCase()!==v}function o(d,v){return s(d)&&b(v)?-1:b(d)&&s(v)?1:0}function n(d,v){return b(d)&&s(v)?-1:s(d)&&b(v)?1:0}function i(d,v,R=!1){return R||(d=d&&d.toLowerCase(),v=v&&v.toLowerCase()),d===v?0:d<v?-1:1}function r(d,v,R=!1){const O=d.split(t.sep),L=v.split(t.sep),_=O.length-1,U=L.length-1;let M,q;for(let K=0;;K++){if(M=_===K,q=U===K,M&&q)return P(O[K],L[K],R);if(M)return-1;if(q)return 1;const x=i(O[K],L[K],R);if(x!==0)return x}}e.comparePaths=r;function l(d,v,R){const O=d.toLowerCase(),L=v.toLowerCase(),_=p(d,v,R);if(_)return _;const U=O.endsWith(R),M=L.endsWith(R);if(U!==M)return U?-1:1;const q=P(O,L);return q!==0?q:O.localeCompare(L)}e.compareAnything=l;function p(d,v,R){const O=d.toLowerCase(),L=v.toLowerCase(),_=O.startsWith(R),U=L.startsWith(R);if(_!==U)return _?-1:1;if(_&&U){if(O.length<L.length)return-1;if(O.length>L.length)return 1}return 0}e.compareByPrefix=p}),define(we[101],be([1,0,100,98,58,9,12,8]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,T=[C,[]];function F(x,B,G,X){if(!x||!B)return T;const V=x.length,Z=B.length;if(V<Z)return T;const se=x.toLowerCase();return D(B,G,Z,x,se,V,X)}e.scoreFuzzy=F;function D(x,B,G,X,V,Z,se){const ce=[],ee=[];for(let ve=0;ve<G;ve++){const ke=ve*Z,Ne=ke-Z,_e=ve>0,Ee=x[ve],z=B[ve];for(let W=0;W<Z;W++){const N=W>0,$=ke+W,j=$-1,re=Ne+W-1,he=N?ce[j]:0,Ce=_e&&N?ce[re]:0,Ae=_e&&N?ee[re]:0;let We;!Ce&&_e?We=0:We=g(Ee,z,X,V,W,Ae),We&&Ce+We>=he&&(se||_e||V.startsWith(B,W))?(ee[$]=Ae+1,ce[$]=Ce+We):(ee[$]=C,ce[$]=he)}}const Q=[];let oe=G-1,de=Z-1;for(;oe>=0&&de>=0;){const ve=oe*Z+de;ee[ve]===C||(Q.push(de),oe--),de--}return[ce[G*Z-1],Q.reverse()]}function g(x,B,G,X,V,Z){let se=0;if(!E(B,X[V]))return se;if(se+=1,Z>0&&(se+=Z*5),x===G[V]&&(se+=1),V===0)se+=8;else{const ce=f(G.charCodeAt(V-1));ce?se+=ce:(0,t.isUpper)(G.charCodeAt(V))&&Z===0&&(se+=2)}return se}function E(x,B){return x===B?!0:x==="/"||x==="\\"?B==="/"||B==="\\":!1}function f(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function w(x,B,G=0,X=0){const V=B;return V.values&&V.values.length>1?y(x,V.values,G,X):I(x,B,G,X)}e.scoreFuzzy2=w;function y(x,B,G,X){let V=0;const Z=[];for(const se of B){const[ce,ee]=I(x,se,G,X);if(typeof ce!="number")return u;V+=ce,Z.push(...ee)}return[V,p(Z)]}function I(x,B,G,X){const V=(0,t.fuzzyScore)(B.original,B.originalLowercase,G,x,x.toLowerCase(),X,!0);return V?[V[0],(0,t.createMatches)(V)]:u}const a=Object.freeze({score:0}),c=1<<18,m=1<<17,s=1<<16;function b(x,B,G,X){const V=X.values?X.values:[X];return(0,k.hash)({[X.normalized]:{values:V.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:x,description:B,allowNonContiguousMatches:G}})}function o(x,B,G,X,V){if(!x||!B.normalized)return a;const Z=X.getItemLabel(x);if(!Z)return a;const se=X.getItemDescription(x),ce=b(Z,se,G,B),ee=V[ce];if(ee)return ee;const Q=n(Z,se,X.getItemPath(x),B,G);return V[ce]=Q,Q}e.scoreItemFuzzy=o;function n(x,B,G,X,V){const Z=!G||!X.containsPathSeparator;return G&&(S.isLinux?X.pathNormalized===G:(0,P.equalsIgnoreCase)(X.pathNormalized,G))?{score:c,labelMatch:[{start:0,end:x.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:X.values&&X.values.length>1?i(x,B,G,X.values,Z,V):r(x,B,G,X,Z,V)}function i(x,B,G,X,V,Z){let se=0;const ce=[],ee=[];for(const Q of X){const{score:oe,labelMatch:de,descriptionMatch:ve}=r(x,B,G,Q,V,Z);if(oe===C)return a;se+=oe,de&&ce.push(...de),ve&&ee.push(...ve)}return{score:se,labelMatch:p(ce),descriptionMatch:p(ee)}}function r(x,B,G,X,V,Z){if(V||!B){const[se,ce]=F(x,X.normalized,X.normalizedLowercase,Z&&!X.expectContiguousMatch);if(se){const ee=(0,t.matchesPrefix)(X.normalized,x);let Q;return ee?(Q=m,Q+=Math.round(X.normalized.length/x.length*100)):Q=s,{score:Q+se,labelMatch:ee||l(ce)}}}if(B){let se=B;G&&(se=`${B}${A.sep}`);const ce=se.length,ee=`${se}${x}`,[Q,oe]=F(ee,X.normalized,X.normalizedLowercase,Z&&!X.expectContiguousMatch);if(Q){const de=l(oe),ve=[],ke=[];return de.forEach(Ne=>{Ne.start<ce&&Ne.end>ce?(ve.push({start:0,end:Ne.end-ce}),ke.push({start:Ne.start,end:ce})):Ne.start>=ce?ve.push({start:Ne.start-ce,end:Ne.end-ce}):ke.push(Ne)}),{score:Q,labelMatch:ve,descriptionMatch:ke}}}return a}function l(x){const B=[];if(!x)return B;let G;for(const X of x)G&&G.end===X?G.end+=1:(G={start:X,end:X+1},B.push(G));return B}function p(x){const B=x.sort((V,Z)=>V.start-Z.start),G=[];let X;for(const V of B)!X||!d(X,V)?(X=V,G.push(V)):(X.start=Math.min(X.start,V.start),X.end=Math.max(X.end,V.end));return G}function d(x,B){return!(x.end<B.start||B.end<x.start)}function v(x,B,G,X,V,Z){const se=o(x,G,X,V,Z),ce=o(B,G,X,V,Z),ee=se.score,Q=ce.score;if((ee===c||Q===c)&&ee!==Q)return ee===c?-1:1;if(ee>s||Q>s){if(ee!==Q)return ee>Q?-1:1;if(ee<m&&Q<m){const Ee=O(se.labelMatch,ce.labelMatch);if(Ee!==0)return Ee}const Ne=V.getItemLabel(x)||"",_e=V.getItemLabel(B)||"";if(Ne.length!==_e.length)return Ne.length-_e.length}if(ee!==Q)return ee>Q?-1:1;const oe=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,de=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0;if(oe&&!de)return-1;if(de&&!oe)return 1;const ve=R(x,se,V),ke=R(B,ce,V);return ve&&ke&&ve!==ke?ke>ve?-1:1:L(x,B,G,V)}e.compareItemsByFuzzyScore=v;function R(x,B,G){let X=-1,V=-1;if(B.descriptionMatch&&B.descriptionMatch.length?X=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(X=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(V=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const Z=G.getItemDescription(x);Z&&(V+=Z.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(V=B.descriptionMatch[B.descriptionMatch.length-1].end);return V-X}function O(x,B){if(!x&&!B||(!x||!x.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!x||!x.length)return 1;const G=x[0].start,V=x[x.length-1].end-G,Z=B[0].start,ce=B[B.length-1].end-Z;return V===ce?0:ce<V?1:-1}function L(x,B,G,X){const V=X.getItemLabel(x)||"",Z=X.getItemLabel(B)||"",se=X.getItemDescription(x),ce=X.getItemDescription(B),ee=V.length+(se?se.length:0),Q=Z.length+(ce?ce.length:0);if(ee!==Q)return ee-Q;const oe=X.getItemPath(x),de=X.getItemPath(B);return oe&&de&&oe.length!==de.length?oe.length-de.length:V!==Z?(0,h.compareAnything)(V,Z,G.normalized):se&&ce&&se!==ce?(0,h.compareAnything)(se,ce,G.normalized):oe&&de&&oe!==de?(0,h.compareAnything)(oe,de,G.normalized):0}function _(x){return x.startsWith('"')&&x.endsWith('"')}const U=" ";function M(x){typeof x!="string"&&(x="");const B=x.toLowerCase(),{pathNormalized:G,normalized:X,normalizedLowercase:V}=q(x),Z=G.indexOf(A.sep)>=0,se=_(x);let ce;const ee=x.split(U);if(ee.length>1)for(const Q of ee){const oe=_(Q),{pathNormalized:de,normalized:ve,normalizedLowercase:ke}=q(Q);ve&&(ce||(ce=[]),ce.push({original:Q,originalLowercase:Q.toLowerCase(),pathNormalized:de,normalized:ve,normalizedLowercase:ke,expectContiguousMatch:oe}))}return{original:x,originalLowercase:B,pathNormalized:G,normalized:X,normalizedLowercase:V,values:ce,containsPathSeparator:Z,expectContiguousMatch:se}}e.prepareQuery=M;function q(x){let B;S.isWindows?B=x.replace(/\//g,A.sep):B=x.replace(/\\/g,A.sep);const G=(0,P.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:G,normalizedLowercase:G.toLowerCase()}}function K(x){return Array.isArray(x)?M(x.map(B=>B.original).join(U)):M(x.original)}e.pieceToQuery=K}),define(we[32],be([1,0,13,28,24,9,12,8]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",F="[^/\\\\]",D=/\//g;function g(G){switch(G){case 0:return"";case 1:return`${F}*?`;default:return`(?:${T}|${F}+${T}|${T}${F}+)*?`}}function E(G,X){if(!G)return[];const V=[];let Z=!1,se=!1,ce="";for(const ee of G){switch(ee){case X:if(!Z&&!se){V.push(ce),ce="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":se=!0;break;case"]":se=!1;break}ce+=ee}return ce&&V.push(ce),V}e.splitGlobAware=E;function f(G){if(!G)return"";let X="";const V=E(G,e.GLOB_SPLIT);if(V.every(Z=>Z===e.GLOBSTAR))X=".*";else{let Z=!1;V.forEach((se,ce)=>{if(se===e.GLOBSTAR){Z||(X+=g(2),Z=!0);return}let ee=!1,Q="",oe=!1,de="";for(const ve of se){if(ve!=="}"&&ee){Q+=ve;continue}if(oe&&(ve!=="]"||!de)){let ke;ve==="-"?ke=ve:(ve==="^"||ve==="!")&&!de?ke="^":ve===e.GLOB_SPLIT?ke="":ke=(0,P.escapeRegExpCharacters)(ve),de+=ke;continue}switch(ve){case"{":ee=!0;continue;case"[":oe=!0;continue;case"}":{X+=`(?:${E(Q,",").map(_e=>f(_e)).join("|")})`,ee=!1,Q="";break}case"]":X+="["+de+"]",oe=!1,de="";break;case"?":X+=F;continue;case"*":X+=g(1);continue;default:X+=(0,P.escapeRegExpCharacters)(ve)}}ce<V.length-1&&(V[ce+1]!==e.GLOBSTAR||ce+2<V.length)&&(X+=T),Z=!1})}return X}const u=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,I=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,m=new k.LRUCache(1e4),s=function(){return!1},b=function(){return null};function o(G,X){if(!G)return b;let V;typeof G!="string"?V=G.pattern:V=G,V=V.trim();const Z=`${V}_${!!X.trimForExclusions}`;let se=m.get(Z);if(se)return n(se,G);let ce;if(u.test(V)){const ee=V.substr(4);se=function(Q,oe){return typeof Q=="string"&&Q.endsWith(ee)?V:null}}else(ce=w.exec(i(V,X)))?se=r(ce[1],V):(X.trimForExclusions?I:y).test(V)?se=l(V,X):(ce=a.exec(i(V,X)))?se=p(ce[1].substr(1),V,!0):(ce=c.exec(i(V,X)))?se=p(ce[1],V,!1):se=d(V);return m.set(Z,se),n(se,G)}function n(G,X){return typeof X=="string"?G:function(V,Z){return(0,t.isEqualOrParent)(V,X.base,!S.isLinux)?G(V.substr(X.base.length+1),Z):null}}function i(G,X){return X.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function r(G,X){const V=`/${G}`,Z=`\\${G}`,se=function(ee,Q){return typeof ee!="string"?null:Q?Q===G?X:null:ee===G||ee.endsWith(V)||ee.endsWith(Z)?X:null},ce=[G];return se.basenames=ce,se.patterns=[X],se.allBasenames=ce,se}function l(G,X){const V=B(G.slice(1,-1).split(",").map(Q=>o(Q,X)).filter(Q=>Q!==b),G),Z=V.length;if(!Z)return b;if(Z===1)return V[0];const se=function(Q,oe){for(let de=0,ve=V.length;de<ve;de++)if(V[de](Q,oe))return G;return null},ce=V.find(Q=>!!Q.allBasenames);ce&&(se.allBasenames=ce.allBasenames);const ee=V.reduce((Q,oe)=>oe.allPaths?Q.concat(oe.allPaths):Q,[]);return ee.length&&(se.allPaths=ee),se}function p(G,X,V){const Z=A.sep===A.posix.sep,se=Z?G:G.replace(D,A.sep),ce=A.sep+se,ee=A.posix.sep+G,Q=V?function(oe,de){return typeof oe=="string"&&(oe===se||oe.endsWith(ce)||!Z&&(oe===G||oe.endsWith(ee)))?X:null}:function(oe,de){return typeof oe=="string"&&(oe===se||!Z&&oe===G)?X:null};return Q.allPaths=[(V?"*/":"./")+G],Q}function d(G){try{const X=new RegExp(`^${f(G)}$`);return function(V){return X.lastIndex=0,typeof V=="string"&&X.test(V)?G:null}}catch{return b}}function v(G,X,V){return!G||typeof X!="string"?!1:R(G)(X,void 0,V)}e.match=v;function R(G,X={}){if(!G)return s;if(typeof G=="string"||U(G)){const V=o(G,X);if(V===b)return s;const Z=function(se,ce){return!!V(se,ce)};return V.allBasenames&&(Z.allBasenames=V.allBasenames),V.allPaths&&(Z.allPaths=V.allPaths),Z}return K(G,X)}e.parse=R;function O(G){if(!G)return;let X;return V=>(X||(X=(G()||Promise.resolve([])).then(Z=>Z?_(Z):{})),X.then(Z=>!!Z[V]))}e.hasSiblingPromiseFn=O;function L(G){if(!G)return;let X;return V=>{if(!X){const Z=G();X=Z?_(Z):{}}return!!X[V]}}e.hasSiblingFn=L;function _(G){const X={};for(const V of G)X[V]=!0;return X}function U(G){const X=G;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.isRelativePattern=U;function M(G){return G.allBasenames||[]}e.getBasenameTerms=M;function q(G){return G.allPaths||[]}e.getPathTerms=q;function K(G,X){const V=B(Object.getOwnPropertyNames(G).map(Q=>x(Q,G[Q],X)).filter(Q=>Q!==b)),Z=V.length;if(!Z)return b;if(!V.some(Q=>!!Q.requiresSiblings)){if(Z===1)return V[0];const Q=function(ve,ke){for(let Ne=0,_e=V.length;Ne<_e;Ne++){const Ee=V[Ne](ve,ke);if(Ee)return Ee}return null},oe=V.find(ve=>!!ve.allBasenames);oe&&(Q.allBasenames=oe.allBasenames);const de=V.reduce((ve,ke)=>ke.allPaths?ve.concat(ke.allPaths):ve,[]);return de.length&&(Q.allPaths=de),Q}const se=function(Q,oe,de){let ve;for(let ke=0,Ne=V.length;ke<Ne;ke++){const _e=V[ke];_e.requiresSiblings&&de&&(oe||(oe=(0,A.basename)(Q)),ve||(ve=oe.substr(0,oe.length-(0,A.extname)(Q).length)));const Ee=_e(Q,oe,ve,de);if(Ee)return Ee}return null},ce=V.find(Q=>!!Q.allBasenames);ce&&(se.allBasenames=ce.allBasenames);const ee=V.reduce((Q,oe)=>oe.allPaths?Q.concat(oe.allPaths):Q,[]);return ee.length&&(se.allPaths=ee),se}function x(G,X,V){if(X===!1)return b;const Z=o(G,V);if(Z===b)return b;if(typeof X=="boolean")return Z;if(X){const se=X.when;if(typeof se=="string"){const ce=(ee,Q,oe,de)=>{if(!de||!Z(ee,Q))return null;const ve=se.replace("$(basename)",oe),ke=de(ve);return(0,h.isThenable)(ke)?ke.then(Ne=>Ne?G:null):ke?G:null};return ce.requiresSiblings=!0,ce}}return Z}function B(G,X){const V=G.filter(Q=>!!Q.basenames);if(V.length<2)return G;const Z=V.reduce((Q,oe)=>{const de=oe.basenames;return de?Q.concat(de):Q},[]);let se;if(X){se=[];for(let Q=0,oe=Z.length;Q<oe;Q++)se.push(X)}else se=V.reduce((Q,oe)=>{const de=oe.patterns;return de?Q.concat(de):Q},[]);const ce=function(Q,oe){if(typeof Q!="string")return null;if(!oe){let ve;for(ve=Q.length;ve>0;ve--){const ke=Q.charCodeAt(ve-1);if(ke===47||ke===92)break}oe=Q.substr(ve)}const de=Z.indexOf(oe);return de!==-1?se[de]:null};ce.basenames=Z,ce.patterns=se,ce.allBasenames=Z;const ee=G.filter(Q=>!Q.basenames);return ee.push(ce),ee}}),define(we[102],be([1,0,16,146,22,2]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(u="",w=!1){if(this.value=u,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(u,w=0){return this.value+=D(this.supportThemeIcons?(0,t.escapeIcons)(u):u).replace(/([ \t]+)/g,(y,I)=>"&nbsp;".repeat(I.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,w){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}}e.MarkdownString=P;function C(f){return T(f)?!f.value:Array.isArray(f)?f.every(C):!0}e.isEmptyMarkdownString=C;function T(f){return f instanceof P?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function F(f,u){return f===u?!0:!f||!u?!1:f.value===u.value&&f.isTrusted===u.isTrusted&&f.supportThemeIcons===u.supportThemeIcons&&f.supportHtml===u.supportHtml&&(f.baseUri===u.baseUri||!!f.baseUri&&!!u.baseUri&&(0,k.isEqual)(A.URI.from(f.baseUri),A.URI.from(u.baseUri)))}e.markdownStringEqual=F;function D(f){return f.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function g(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function E(f){const u=[],w=f.split("|").map(I=>I.trim());f=w[0];const y=w[1];if(y){const I=/height=(\d+)/.exec(y),a=/width=(\d+)/.exec(y),c=I?I[1]:"",m=a?a[1]:"",s=isFinite(parseInt(m)),b=isFinite(parseInt(c));s&&u.push(`width="${m}"`),b&&u.push(`height="${c}"`)}return{href:f,dimensions:u}}e.parseHrefAndDimensions=E}),define(we[79],be([1,0,28,10,9,12,22,8,2]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(n,i,r){if(typeof n=="string"&&(n=C.URI.file(n)),r){const p=r.getWorkspaceFolder(n);if(p){const d=r.getWorkspace().folders.length>1;let v;if((0,S.isEqual)(p.uri,n)?v="":v=(0,S.relativePath)(p.uri,n),d){const R=p.name?p.name:(0,S.basename)(p.uri);v=v?R+" \u2022 "+v:R}return v}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(n.fsPath))return(0,k.normalize)(D(n.fsPath));let l=(0,k.normalize)(n.fsPath);return!A.isWindows&&i?.userHome&&(l=E(l,i.userHome.fsPath)),l}e.getPathLabel=T;function F(n){if(!n)return;typeof n=="string"&&(n=C.URI.file(n));const i=(0,S.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return A.isWindows&&(0,h.isRootOrDriveLetter)(i)?D(i):i}e.getBaseLabel=F;function D(n,i){return(0,h.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=D;let g=Object.create(null);function E(n,i){if(A.isWindows||!n||!i)return n;let r=g.original===i?g.normalized:void 0;return r||(r=`${(0,P.rtrim)(i,k.posix.sep)}${k.posix.sep}`,g={original:i,normalized:r}),(A.isLinux?n.startsWith(r):(0,P.startsWithIgnoreCase)(n,r))&&(n=`~/${n.substr(r.length)}`),n}e.tildify=E;function f(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=f;const u="\u2026",w="\\\\",y="~";function I(n,i=k.sep){const r=new Array(n.length);let l=!1;for(let p=0;p<n.length;p++){let d=n[p];if(d===""){r[p]=`.${i}`;continue}if(!d){r[p]=d;continue}l=!0;let v="";d.indexOf(w)===0?(v=d.substr(0,d.indexOf(w)+w.length),d=d.substr(d.indexOf(w)+w.length)):d.indexOf(i)===0?(v=d.substr(0,d.indexOf(i)+i.length),d=d.substr(d.indexOf(i)+i.length)):d.indexOf(y)===0&&(v=d.substr(0,d.indexOf(y)+y.length),d=d.substr(d.indexOf(y)+y.length));const R=d.split(i);for(let O=1;l&&O<=R.length;O++)for(let L=R.length-O;l&&L>=0;L--){l=!1;let _=R.slice(L,L+O).join(i);for(let U=0;!l&&U<n.length;U++)if(U!==p&&n[U]&&n[U].indexOf(_)>-1){const M=L+O===R.length,q=L>0&&n[U].indexOf(i)>-1?i+_:_,K=n[U].endsWith(q);l=!M||K}if(!l){let U="";(R[0].endsWith(":")||v!=="")&&(L===1&&(L=0,O++,_=R[0]+i+_),L>0&&(U=R[0]+i),U=v+U),L>0&&(U=U+u+i),U=U+_,L+O<R.length&&(U=U+i+u),r[p]=U}}l&&(r[p]=d)}return r}e.shorten=I;var a;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function c(n,i=Object.create(null)){const r=[];let l=!1,p="";for(const d of n)if(d==="$"||l&&d==="{")p&&r.push({value:p,type:a.TEXT}),p="",l=!0;else if(d==="}"&&l){const v=i[p];if(typeof v=="string")v.length&&r.push({value:v,type:a.VARIABLE});else if(v){const R=r[r.length-1];(!R||R.type!==a.SEPARATOR)&&r.push({value:v.label,type:a.SEPARATOR})}p="",l=!1}else p+=d;return p&&!l&&r.push({value:p,type:a.TEXT}),r.filter((d,v)=>{if(d.type===a.SEPARATOR){const R=r[v-1],O=r[v+1];return[R,O].every(L=>L&&(L.type===a.VARIABLE||L.type===a.TEXT)&&L.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=c;function m(n,i){return A.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function s(n,i){return A.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,r=>r==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function b(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=b;function o(n){const i=n.indexOf("/")!==-1?k.posix:k.win32,r=i.basename(n),l=i.dirname(n);return r.length?{name:r,parentPath:l}:{name:l,parentPath:""}}e.splitName=o}),define(we[103],be([1,0,2]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class k{constructor(D){this._uriTransformer=D}transformIncoming(D){const g=this._uriTransformer.transformIncoming(D);return g===D?D:t(h.URI.from(g))}transformOutgoing(D){const g=this._uriTransformer.transformOutgoing(D);return g===D?D:t(h.URI.from(g))}transformOutgoingURI(D){const g=this._uriTransformer.transformOutgoing(D);return g===D?D:h.URI.from(g)}transformOutgoingScheme(D){return this._uriTransformer.transformOutgoingScheme(D)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function A(F,D,g){if(!F||g>200)return null;if(typeof F=="object"){if(F instanceof h.URI)return D.transformOutgoing(F);for(let E in F)if(Object.hasOwnProperty.call(F,E)){const f=A(F[E],D,g+1);f!==null&&(F[E]=f)}}return null}function S(F,D){const g=A(F,D,0);return g===null?F:g}e.transformOutgoingURIs=S;function P(F,D,g,E){if(!F||E>200)return null;if(typeof F=="object"){if(F.$mid===1)return g?h.URI.revive(D.transformIncoming(F)):D.transformIncoming(F);for(let f in F)if(Object.hasOwnProperty.call(F,f)){const u=P(F[f],D,g,E+1);u!==null&&(F[f]=u)}}return null}function C(F,D){const g=P(F,D,!1,0);return g===null?F:g}e.transformIncomingURIs=C;function T(F,D){const g=P(F,D,!0,0);return g===null?F:g}e.transformAndReviveIncomingURIs=T}),define(we[33],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return h.test(C)}e.isUUID=t;const k=new Uint8Array(16),A=[];for(let C=0;C<256;C++)A.push(C.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(C){for(let T=0;T<C.length;T++)C[T]=Math.floor(Math.random()*256);return C};function P(){S(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let C=0,T="";return T+=A[k[C++]],T+=A[k[C++]],T+=A[k[C++]],T+=A[k[C++]],T+="-",T+=A[k[C++]],T+=A[k[C++]],T+="-",T+=A[k[C++]],T+=A[k[C++]],T+="-",T+=A[k[C++]],T+=A[k[C++]],T+="-",T+=A[k[C++]],T+=A[k[C++]],T+=A[k[C++]],T+=A[k[C++]],T+=A[k[C++]],T+=A[k[C++]],T}e.generateUuid=P}),define(we[147],be([1,0,104]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(A="utf8"){this.stringDecoder=new h.StringDecoder(A),this.remaining=null}write(A){const S=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return S;let C=0,T,F=C;for(;F<P.length;)if(T=P.charCodeAt(F),T===13||T===10){if(S.push(P.substring(C,F)),F++,F<P.length){const D=T;T=P.charCodeAt(F),(D===13&&T===10||D===10&&T===13)&&F++}C=F}else F++;return this.remaining=C<P.length?P.substr(C):null,S}end(){return this.remaining}}e.LineDecoder=t}),define(we[29],be([1,0,60,80,294,13,28,78,9,12,22,2]),function(te,e,h,t,k,A,S,P,C,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function E(M,q=g.UNLINK){if((0,S.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return q===g.UNLINK?u(M):f(M)}async function f(M){try{const q=(0,S.randomPath)((0,t.tmpdir)());try{await h.promises.rename(M,q)}catch{return u(M)}u(q).catch(K=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function u(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function w(M){if((0,S.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");h.rmdirSync(M,{recursive:!0})}e.rimrafSync=w;async function y(M,q){return c(await(q?I(M):(0,k.promisify)(h.readdir)(M)))}async function I(M){try{return await(0,k.promisify)(h.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const q=[],K=await y(M);for(const x of K){let B=!1,G=!1,X=!1;try{const V=await e.Promises.lstat((0,C.join)(M,x));B=V.isFile(),G=V.isDirectory(),X=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}q.push({name:x,isFile:()=>B,isDirectory:()=>G,isSymbolicLink:()=>X})}return q}function a(M){return c(h.readdirSync(M))}e.readdirSync=a;function c(M){return M.map(q=>typeof q=="string"?T.isMacintosh?(0,P.normalizeNFC)(q):q:(q.name=T.isMacintosh?(0,P.normalizeNFC)(q.name):q.name,q))}async function m(M){const q=await y(M),K=[];for(const x of q)await b.existsDirectory((0,C.join)(M,x))&&K.push(x);return K}function s(M,q=1e3){return new Promise(K=>{let x=!1;const B=setInterval(()=>{x||(x=!0,h.access(M,G=>{x=!1,G&&(clearInterval(B),K(void 0))}))},q)})}e.whenDeleted=s;var b;(function(M){async function q(B){let G;try{if(G=await e.Promises.lstat(B),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(T.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw V}throw X}}M.stat=q;async function K(B){try{const{stat:G,symbolicLink:X}=await M.stat(B);return G.isFile()&&X?.dangling!==!0}catch{}return!1}M.existsFile=K;async function x(B){try{const{stat:G,symbolicLink:X}=await M.stat(B);return G.isDirectory()&&X?.dangling!==!0}catch{}return!1}M.existsDirectory=x})(b=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new A.ResourceQueue;function n(M,q,K){return o.queueFor(D.URI.file(M),F.extUriBiasedIgnorePathCase).queue(()=>{const x=p(K);return new Promise((B,G)=>r(M,q,x,X=>X?G(X):B()))})}let i=!0;function r(M,q,K,x){if(!i)return h.writeFile(M,q,{mode:K.mode,flag:K.flag},x);h.open(M,K.flag,K.mode,(B,G)=>{if(B)return x(B);h.writeFile(G,q,X=>{if(X)return h.close(G,()=>x(X));h.fdatasync(G,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),i=!1),h.close(G,Z=>x(Z))))})})}function l(M,q,K){const x=p(K);if(!i)return h.writeFileSync(M,q,{mode:x.mode,flag:x.flag});const B=h.openSync(M,x.flag,x.mode);try{h.writeFileSync(B,q);try{h.fdatasyncSync(B)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),i=!1}}finally{h.closeSync(B)}}e.writeFileSync=l;function p(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function d(M,q){if(M===q)return;async function K(x){try{const B=await e.Promises.lstat(x);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(x,B.atime,new Date)}catch{}}try{await e.Promises.rename(M,q),await K(q)}catch(x){if(M.toLowerCase()!==q.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await v(M,q,{preserveSymlinks:!1}),await E(M,g.MOVE),await K(q);else throw x}}async function v(M,q,K){return O(M,q,{root:{source:M,target:q},options:K,handledSourcePaths:new Set})}const R=511;async function O(M,q,K){if(K.handledSourcePaths.has(M))return;K.handledSourcePaths.add(M);const{stat:x,symbolicLink:B}=await b.stat(M);if(B){if(K.options.preserveSymlinks)try{return await U(M,q,K)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(B.dangling)return}return x.isDirectory()?L(M,q,x.mode&R,K):_(M,q,x.mode&R)}async function L(M,q,K,x){await e.Promises.mkdir(q,{recursive:!0,mode:K});const B=await y(M);for(const G of B)await O((0,C.join)(M,G),(0,C.join)(q,G),x)}async function _(M,q,K){await e.Promises.copyFile(M,q),await e.Promises.chmod(q,K)}async function U(M,q,K){let x=await e.Promises.readlink(M);(0,S.isEqualOrParent)(x,K.root.source,!T.isLinux)&&(x=(0,C.join)(K.root.target,x.substr(K.root.source.length+1))),await e.Promises.symlink(x,q)}e.Promises=new class{get access(){return(0,k.promisify)(h.access)}get stat(){return(0,k.promisify)(h.stat)}get lstat(){return(0,k.promisify)(h.lstat)}get utimes(){return(0,k.promisify)(h.utimes)}get read(){return(M,q,K,x,B)=>new Promise((G,X)=>{h.read(M,q,K,x,B,(V,Z,se)=>V?X(V):G({bytesRead:Z,buffer:se}))})}get readFile(){return(0,k.promisify)(h.readFile)}get write(){return(M,q,K,x,B)=>new Promise((G,X)=>{h.write(M,q,K,x,B,(V,Z,se)=>V?X(V):G({bytesWritten:Z,buffer:se}))})}get appendFile(){return(0,k.promisify)(h.appendFile)}get fdatasync(){return(0,k.promisify)(h.fdatasync)}get truncate(){return(0,k.promisify)(h.truncate)}get rename(){return(0,k.promisify)(h.rename)}get copyFile(){return(0,k.promisify)(h.copyFile)}get open(){return(0,k.promisify)(h.open)}get close(){return(0,k.promisify)(h.close)}get symlink(){return(0,k.promisify)(h.symlink)}get readlink(){return(0,k.promisify)(h.readlink)}get chmod(){return(0,k.promisify)(h.chmod)}get mkdir(){return(0,k.promisify)(h.mkdir)}get unlink(){return(0,k.promisify)(h.unlink)}get rmdir(){return(0,k.promisify)(h.rmdir)}get realpath(){return(0,k.promisify)(h.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return m}get writeFile(){return n}get rm(){return E}get move(){return d}get copy(){return v}}}),define(we[105],be([1,0,60,9,12,8,29]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(g){if(k.isLinux)return g;const E=(0,t.dirname)(g);if(g===E)return g;const f=((0,t.basename)(g)||g).toLowerCase();try{const w=(0,S.readdirSync)(E).filter(y=>y.toLowerCase()===f);if(w.length===1){const y=P(E);if(y)return(0,t.join)(y,w[0])}else if(w.length>1){const y=w.indexOf(f);if(y>=0){const I=P(E);if(I)return(0,t.join)(I,w[y])}}}catch{}return null}e.realcaseSync=P;async function C(g){if(k.isLinux)return g;const E=(0,t.dirname)(g);if(g===E)return g;const f=((0,t.basename)(g)||g).toLowerCase();try{const w=(await S.Promises.readdir(E)).filter(y=>y.toLowerCase()===f);if(w.length===1){const y=await C(E);if(y)return(0,t.join)(y,w[0])}else if(w.length>1){const y=w.indexOf(f);if(y>=0){const I=await C(E);if(I)return(0,t.join)(I,w[y])}}}catch{}return null}e.realcase=C;async function T(g){try{return await S.Promises.realpath(g)}catch{const f=D(g);return await S.Promises.access(f,h.constants.R_OK),f}}e.realpath=T;function F(g){try{return h.realpathSync(g)}catch{const f=D(g);return h.accessSync(f,h.constants.R_OK),f}}e.realpathSync=F;function D(g){return(0,A.rtrim)((0,t.normalize)(g),t.sep)}});var Be=this&&this.__decorate||function(te,e,h,t){var k=arguments.length,A=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,h):t,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,h,t);else for(var P=te.length-1;P>=0;P--)(S=te[P])&&(A=(k<3?S(A):k>3?S(e,h,A):S(e,h))||A);return k>3&&A&&Object.defineProperty(e,h,A),A};define(we[106],be([1,0,17,13,23,21,56,16,3,6,59,8,18]),function(te,e,h,t,k,A,S,P,C,T,F,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function f(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(u=e.ResponseType||(e.ResponseType={}));function w(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(y||(y={}));class I{constructor(X){this.buffer=X,this.pos=0}read(X){const V=this.buffer.slice(this.pos,this.pos+X);return this.pos+=V.byteLength,V}}class a{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(X){this.buffers.push(X)}}var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object"})(c||(c={}));function m(G){const X=k.VSBuffer.alloc(4);return X.writeUInt32BE(G,0),X}function s(G){return G.read(4).readUInt32BE(0)}function b(G){const X=k.VSBuffer.alloc(1);return X.writeUInt8(G,0),X}const o={Undefined:b(c.Undefined),String:b(c.String),Buffer:b(c.Buffer),VSBuffer:b(c.VSBuffer),Array:b(c.Array),Object:b(c.Object)},n=typeof Buffer!="undefined";function i(G,X){if(typeof X=="undefined")G.write(o.Undefined);else if(typeof X=="string"){const V=k.VSBuffer.fromString(X);G.write(o.String),G.write(m(V.byteLength)),G.write(V)}else if(n&&Buffer.isBuffer(X)){const V=k.VSBuffer.wrap(X);G.write(o.Buffer),G.write(m(V.byteLength)),G.write(V)}else if(X instanceof k.VSBuffer)G.write(o.VSBuffer),G.write(m(X.byteLength)),G.write(X);else if(Array.isArray(X)){G.write(o.Array),G.write(m(X.length));for(const V of X)i(G,V)}else{const V=k.VSBuffer.fromString(JSON.stringify(X));G.write(o.Object),G.write(m(V.byteLength)),G.write(V)}}function r(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(s(G)).toString();case c.Buffer:return G.read(s(G)).buffer;case c.VSBuffer:return G.read(s(G));case c.Array:{const V=s(G),Z=[];for(let se=0;se<V;se++)Z.push(r(G));return Z}case c.Object:return JSON.parse(G.read(s(G)).toString())}}class l{constructor(X,V,Z=null,se=1e3){this.protocol=X,this.ctx=V,this.logger=Z,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ce=>this.onRawMessage(ce)),this.sendResponse({type:200})}registerChannel(X,V){this.channels.set(X,V),setTimeout(()=>this.flushPendingRequests(X),0)}sendResponse(X){switch(X.type){case 200:{const V=this.send([X.type]);this.logger?.logOutgoing(V,0,1,w(X.type));return}case 201:case 202:case 204:case 203:{const V=this.send([X.type,X.id],X.data);this.logger?.logOutgoing(V,X.id,1,w(X.type),X.data);return}}}send(X,V=void 0){const Z=new a;return i(Z,X),i(Z,V),this.sendBuffer(Z.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onRawMessage(X){const V=new I(X),Z=r(V),se=r(V),ce=Z[0];switch(ce){case 100:return this.logger?.logIncoming(X.byteLength,Z[1],1,`${f(ce)}: ${Z[2]}.${Z[3]}`,se),this.onPromise({type:ce,id:Z[1],channelName:Z[2],name:Z[3],arg:se});case 102:return this.logger?.logIncoming(X.byteLength,Z[1],1,`${f(ce)}: ${Z[2]}.${Z[3]}`,se),this.onEventListen({type:ce,id:Z[1],channelName:Z[2],name:Z[3],arg:se});case 101:return this.logger?.logIncoming(X.byteLength,Z[1],1,`${f(ce)}`),this.disposeActiveRequest({type:ce,id:Z[1]});case 103:return this.logger?.logIncoming(X.byteLength,Z[1],1,`${f(ce)}`),this.disposeActiveRequest({type:ce,id:Z[1]})}}onPromise(X){const V=this.channels.get(X.channelName);if(!V){this.collectPendingRequest(X);return}const Z=new A.CancellationTokenSource;let se;try{se=V.call(this.ctx,X.name,X.arg,Z.token)}catch(Q){se=Promise.reject(Q)}const ce=X.id;se.then(Q=>{this.sendResponse({id:ce,data:Q,type:201}),this.activeRequests.delete(X.id)},Q=>{Q instanceof Error?this.sendResponse({id:ce,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:ce,data:Q,type:203}),this.activeRequests.delete(X.id)});const ee=(0,T.toDisposable)(()=>Z.cancel());this.activeRequests.set(X.id,ee)}onEventListen(X){const V=this.channels.get(X.channelName);if(!V){this.collectPendingRequest(X);return}const Z=X.id,ce=V.listen(this.ctx,X.name,X.arg)(ee=>this.sendResponse({id:Z,data:ee,type:204}));this.activeRequests.set(X.id,ce)}disposeActiveRequest(X){const V=this.activeRequests.get(X.id);V&&(V.dispose(),this.activeRequests.delete(X.id))}collectPendingRequest(X){let V=this.pendingRequests.get(X.channelName);V||(V=[],this.pendingRequests.set(X.channelName,V));const Z=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.sendResponse({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:X,timeoutTimer:Z})}flushPendingRequests(X){const V=this.pendingRequests.get(X);if(V){for(const Z of V)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.onPromise(Z.request);break;case 102:this.onEventListen(Z.request);break}this.pendingRequests.delete(X)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,T.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var p;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(X,V=null){this.protocol=X,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Z=>this.onBuffer(Z)),this.logger=V}getChannel(X){const V=this;return{call(Z,se,ce){return V.isDisposed?Promise.reject(P.canceled()):V.requestPromise(X,Z,se,ce)},listen(Z,se){return V.isDisposed?Promise.reject(P.canceled()):V.requestEvent(X,Z,se)}}}requestPromise(X,V,Z,se=A.CancellationToken.None){const ce=this.lastRequestId++,Q={id:ce,type:100,channelName:X,name:V,arg:Z};if(se.isCancellationRequested)return Promise.reject(P.canceled());let oe;return new Promise((ve,ke)=>{if(se.isCancellationRequested)return ke(P.canceled());const Ne=()=>{const W=N=>{switch(N.type){case 201:this.handlers.delete(ce),ve(N.data);break;case 202:{this.handlers.delete(ce);const $=new Error(N.data.message);$.stack=N.data.stack,$.name=N.data.name,ke($);break}case 203:this.handlers.delete(ce),ke(N.data);break}};this.handlers.set(ce,W),this.sendRequest(Q)};let _e=null;this.state===y.Idle?Ne():(_e=(0,t.createCancelablePromise)(W=>this.whenInitialized()),_e.then(()=>{_e=null,Ne()}));const Ee=()=>{_e?(_e.cancel(),_e=null):this.sendRequest({id:ce,type:101}),ke(P.canceled())},z=se.onCancellationRequested(Ee);oe=(0,T.combinedDisposable)((0,T.toDisposable)(Ee),z),this.activeRequests.add(oe)}).finally(()=>{this.activeRequests.delete(oe)})}requestEvent(X,V,Z){const se=this.lastRequestId++,ee={id:se,type:102,channelName:X,name:V,arg:Z};let Q=null;const oe=new C.Emitter({onFirstListenerAdd:()=>{Q=(0,t.createCancelablePromise)(ve=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(oe),this.sendRequest(ee)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(oe),this.sendRequest({id:se,type:103}))}}),de=ve=>oe.fire(ve.data);return this.handlers.set(se,de),oe.event}sendRequest(X){switch(X.type){case 100:case 102:{const V=this.send([X.type,X.id,X.channelName,X.name],X.arg);this.logger&&this.logger.logOutgoing(V,X.id,0,`${f(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const V=this.send([X.type,X.id]);this.logger&&this.logger.logOutgoing(V,X.id,0,f(X.type));return}}}send(X,V=void 0){const Z=new a;return i(Z,X),i(Z,V),this.sendBuffer(Z.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onBuffer(X){const V=new I(X),Z=r(V),se=r(V),ce=Z[0];switch(ce){case 200:return this.logger&&this.logger.logIncoming(X.byteLength,0,0,w(ce)),this.onResponse({type:Z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(X.byteLength,Z[1],0,w(ce),se),this.onResponse({type:Z[0],id:Z[1],data:se})}}onResponse(X){if(X.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(X.id);V&&V(X)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,T.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Be([S.memoize],d.prototype,"onDidInitializePromise",null),e.ChannelClient=d;class v{constructor(X){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,X(({protocol:V,onDidClientDisconnect:Z})=>{C.Event.once(V.onMessage)(ce=>{const ee=new I(ce),Q=r(ee),oe=new l(V,Q),de=new d(V);this.channels.forEach((ke,Ne)=>oe.registerChannel(Ne,ke));const ve={channelServer:oe,channelClient:de,ctx:Q};this._connections.add(ve),this._onDidAddConnection.fire(ve),Z(()=>{oe.dispose(),de.dispose(),this._connections.delete(ve),this._onDidRemoveConnection.fire(ve)})})})}get connections(){const X=[];return this._connections.forEach(V=>X.push(V)),X}getChannel(X,V){const Z=this;return{call(se,ce,ee){let Q;if((0,g.isFunction)(V)){let de=(0,h.getRandomElement)(Z.connections.filter(V));Q=de?Promise.resolve(de):C.Event.toPromise(C.Event.filter(Z.onDidAddConnection,V))}else Q=V.routeCall(Z,se,ce);const oe=Q.then(de=>de.channelClient.getChannel(X));return O(oe).call(se,ce,ee)},listen(se,ce){if((0,g.isFunction)(V))return Z.getMulticastEvent(X,V,se,ce);const ee=V.routeEvent(Z,se,ce).then(Q=>Q.channelClient.getChannel(X));return O(ee).listen(se,ce)}}}getMulticastEvent(X,V,Z,se){const ce=this;let ee=new T.DisposableStore;const Q=new C.Emitter({onFirstListenerAdd:()=>{ee=new T.DisposableStore;const oe=new C.EventMultiplexer,de=new Map,ve=Ne=>{const Ee=Ne.channelClient.getChannel(X).listen(Z,se),z=oe.add(Ee);de.set(Ne,z)},ke=Ne=>{const _e=de.get(Ne);!_e||(_e.dispose(),de.delete(Ne))};ce.connections.filter(V).forEach(ve),C.Event.filter(ce.onDidAddConnection,V)(ve,void 0,ee),ce.onDidRemoveConnection(ke,void 0,ee),oe.event(Q.fire,Q,ee),ee.add(oe)},onLastListenerRemove:()=>{ee.dispose()}});return Q.event}registerChannel(X,V){this.channels.set(X,V),this._connections.forEach(Z=>{Z.channelServer.registerChannel(X,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class R{constructor(X,V,Z=null){const se=new a;i(se,V),X.send(se.buffer),this.channelClient=new d(X,Z),this.channelServer=new l(X,V,Z)}getChannel(X){return this.channelClient.getChannel(X)}registerChannel(X,V){this.channelServer.registerChannel(X,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function O(G){return{call(X,V,Z){return G.then(se=>se.call(X,V,Z))},listen(X,V){const Z=new C.Relay;return G.then(se=>Z.input=se.listen(X,V)),Z.event}}}e.getDelayedChannel=O;function L(G){let X=!1;return{call(V,Z,se){return X?G.call(V,Z,se):(0,t.timeout)(0).then(()=>X=!0).then(()=>G.call(V,Z,se))},listen(V,Z){if(X)return G.listen(V,Z);const se=new C.Relay;return(0,t.timeout)(0).then(()=>X=!0).then(()=>se.input=G.listen(V,Z)),se.event}}}e.getNextTickChannel=L;class _{constructor(X){this.fn=X}routeCall(X){return this.route(X)}routeEvent(X){return this.route(X)}async route(X){for(const V of X.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await C.Event.toPromise(X.onDidAddConnection),await this.route(X)}}e.StaticRouter=_;var U;(function(G){function X(ce,ee){const Q=ce,oe=ee&&ee.disableMarshalling,de=new Map;for(const ve in Q)Z(ve)&&de.set(ve,C.Event.buffer(Q[ve],!0));return new class{listen(ve,ke,Ne){const _e=de.get(ke);if(_e)return _e;if(se(ke)){const Ee=Q[ke];if(typeof Ee=="function")return Ee.call(Q,Ne)}throw new Error(`Event not found: ${ke}`)}call(ve,ke,Ne){const _e=Q[ke];if(typeof _e=="function"){if(!oe&&Array.isArray(Ne))for(let Ee=0;Ee<Ne.length;Ee++)Ne[Ee]=(0,F.revive)(Ne[Ee]);return _e.apply(Q,Ne)}throw new Error(`Method not found: ${ke}`)}}}G.fromService=X;function V(ce,ee){const Q=ee&&ee.disableMarshalling;return new Proxy({},{get(oe,de){if(typeof de=="string")return ee?.properties?.has(de)?ee.properties.get(de):se(de)?function(ve){return ce.listen(de,ve)}:Z(de)?ce.listen(de):async function(...ve){let ke;ee&&!(0,g.isUndefinedOrNull)(ee.context)?ke=[ee.context,...ve]:ke=ve;const Ne=await ce.call(de,ke);return Q?Ne:(0,F.revive)(Ne)};throw new Error(`Property not found: ${String(de)}`)}})}G.toService=V;function Z(ce){return ce[0]==="o"&&ce[1]==="n"&&D.isUpperAsciiLetter(ce.charCodeAt(2))}function se(ce){return/^onDynamic/.test(ce)&&D.isUpperAsciiLetter(ce.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){let X=G.toString();if(X!=="[object Object]")return X}return G}function K(G){return Array.isArray(G)?G.map(q):q(G)}function x(G,X,V,Z,se,ce,ee){ee=K(ee);const Q=M[se],oe=Q[Z%Q.length];let de=[`%c[${G}]%c[${String(X).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${oe}`];/\($/.test(ce)?(de=de.concat(ee),de.push(")")):de.push(ee),console.log.apply(console,de)}e.logWithColors=x;class B{constructor(X,V){this._outgoingPrefix=X,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(X,V,Z,se,ce){this._totalOutgoing+=X,x(this._outgoingPrefix,this._totalOutgoing,X,V,Z,se,ce)}logIncoming(X,V,Z,se,ce){this._totalIncoming+=X,x(this._incomingPrefix,this._totalIncoming,X,V,Z,se,ce)}}e.IPCLogger=B}),define(we[107],be([1,0,23,3,6,106]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var S;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(S=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let r=0;function l(d,v){if(!i.has(d)){const R=String(++r);i.set(d,R)}return i.get(d)}function p(d,v,R,O){if(!n.enableDiagnostics)return;const L=l(d,v);if(O instanceof h.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const _=h.VSBuffer.alloc(O.byteLength);_.set(O),n.records.push({timestamp:Date.now(),id:L,label:v,type:R,buff:_})}else n.records.push({timestamp:Date.now(),id:L,label:v,type:R,data:O})}n.traceSocketEvent=p})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function F(){return T||(T=h.VSBuffer.alloc(0)),T}class D{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,r){if(i===0)return F();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const v=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=i),v}if(this._chunks[0].byteLength>i){const v=this._chunks[0].slice(0,i);return r&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),v}let l=h.VSBuffer.alloc(i),p=0,d=0;for(;i>0;){const v=this._chunks[d];if(v.byteLength>i){const R=v.slice(0,i);l.set(R,p),p+=i,r&&(this._chunks[d]=v.slice(i),this._totalLength-=i),i-=i}else l.set(v,p),p+=v.byteLength,r?(this._chunks.shift(),this._totalLength-=v.byteLength):d++,i-=v.byteLength}return l}}e.ChunkStream=D;var g;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(g||(g={}));function E(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(i,r,l,p){this.type=i,this.id=r,this.ack=l,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(i){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,p=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new u(l,p,d,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=h.VSBuffer.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(r,i.data)}_bufferAdd(i,r){const l=this._totalLength===0;return this._data.push(i,r),this._totalLength+=i.byteLength+r.byteLength,l}_bufferTake(){const i=h.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,r){this._bufferAdd(i,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class I extends k.Disposable{constructor(i){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new u(1,0,0,i))}}e.Protocol=I;class a extends A.IPCClient{constructor(i,r,l=null){super(i,r,l);this.protocol=i}static fromSocket(i,r){return new a(new I(i),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=a;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class m{constructor(i){this.data=i,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],r=0,l=this._first;for(;l;)i[r++]=l.data,l=l.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const r=new m(i);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class b{constructor(){this.lastRuns=[];const i=Date.now();for(let r=0;r<b._HISTORY_LENGTH;r++)this.lastRuns[r]=i-1e3*r;setInterval(()=>{for(let r=b._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return b._INSTANCE||(b._INSTANCE=new b),b._INSTANCE}load(){const i=Date.now(),r=(1+b._HISTORY_LENGTH)*1e3;let l=0;for(let p=0;p<b._HISTORY_LENGTH;p++)i-this.lastRuns[p]<=r&&l++;return 1-l/b._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}b._HISTORY_LENGTH=10,b._INSTANCE=null;class o{constructor(i,r=null,l=b.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=i,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),r&&this._socketReader.acceptChunk(r)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new u(5,0,0,F());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new u(7,0,0,F());this._socketWriter.write(i)}sendResume(){const i=new u(8,0,0,F());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,r){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const i=new u(3,0,this._incomingAckId,F());this._socketWriter.write(i);const r=this._outgoingUnackMsg.toArray();for(let l=0,p=r.length;l<p;l++)this._socketWriter.write(r[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new u(6,0,0,F())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let l=0,p=r.length;l<p;l++)this._socketWriter.write(r[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new u(1,r,this._incomingAckId,i);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(i){const r=new u(2,0,0,i);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),r=Date.now()-i.writtenTime,l=Date.now()-this._socketReader.lastReadTime,p=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&l>=2e4&&p>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const d=Math.max(2e4-r,2e4-l,2e4-p,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},d)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new u(3,0,this._incomingAckId,F());this._socketWriter.write(i)}}e.PersistentProtocol=o}),define(we[108],be([1,0,99]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(P){const C=(0,h.toUint8)(P);this._defaultValue=C,this._asciiMap=t._createAsciiMap(C),this._map=new Map}static _createAsciiMap(P){const C=new Uint8Array(256);for(let T=0;T<256;T++)C[T]=P;return C}set(P,C){const T=(0,h.toUint8)(C);P>=0&&P<256?this._asciiMap[P]=T:this._map.set(P,T)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=t;var k;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(k||(k={}));class A{constructor(){this._actual=new t(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=A}),define(we[48],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class h{constructor(k,A){this.lineNumber=k,this.column=A}with(k=this.lineNumber,A=this.column){return k===this.lineNumber&&A===this.column?this:new h(k,A)}delta(k=0,A=0){return this.with(this.lineNumber+k,this.column+A)}equals(k){return h.equals(this,k)}static equals(k,A){return!k&&!A?!0:!!k&&!!A&&k.lineNumber===A.lineNumber&&k.column===A.column}isBefore(k){return h.isBefore(this,k)}static isBefore(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<A.column}isBeforeOrEqual(k){return h.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<=A.column}static compare(k,A){const S=k.lineNumber|0,P=A.lineNumber|0;if(S===P){const C=k.column|0,T=A.column|0;return C-T}return S-P}clone(){return new h(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new h(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=h}),define(we[41],be([1,0,48]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,S,P,C){A>P||A===P&&S>C?(this.startLineNumber=P,this.startColumn=C,this.endLineNumber=A,this.endColumn=S):(this.startLineNumber=A,this.startColumn=S,this.endLineNumber=P,this.endColumn=C)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,S){return!(S.lineNumber<A.startLineNumber||S.lineNumber>A.endLineNumber||S.lineNumber===A.startLineNumber&&S.column<A.startColumn||S.lineNumber===A.endLineNumber&&S.column>A.endColumn)}static strictContainsPosition(A,S){return!(S.lineNumber<A.startLineNumber||S.lineNumber>A.endLineNumber||S.lineNumber===A.startLineNumber&&S.column<=A.startColumn||S.lineNumber===A.endLineNumber&&S.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<=A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,S){let P,C,T,F;return S.startLineNumber<A.startLineNumber?(P=S.startLineNumber,C=S.startColumn):S.startLineNumber===A.startLineNumber?(P=S.startLineNumber,C=Math.min(S.startColumn,A.startColumn)):(P=A.startLineNumber,C=A.startColumn),S.endLineNumber>A.endLineNumber?(T=S.endLineNumber,F=S.endColumn):S.endLineNumber===A.endLineNumber?(T=S.endLineNumber,F=Math.max(S.endColumn,A.endColumn)):(T=A.endLineNumber,F=A.endColumn),new t(P,C,T,F)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,S){let P=A.startLineNumber,C=A.startColumn,T=A.endLineNumber,F=A.endColumn,D=S.startLineNumber,g=S.startColumn,E=S.endLineNumber,f=S.endColumn;return P<D?(P=D,C=g):P===D&&(C=Math.max(C,g)),T>E?(T=E,F=f):T===E&&(F=Math.min(F,f)),P>T||P===T&&C>F?null:new t(P,C,T,F)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,S){return!!A&&!!S&&A.startLineNumber===S.startLineNumber&&A.startColumn===S.startColumn&&A.endLineNumber===S.endLineNumber&&A.endColumn===S.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new h.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new h.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,S){return new t(this.startLineNumber,this.startColumn,A,S)}setStartPosition(A,S){return new t(A,S,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,S=A){return new t(A.lineNumber,A.column,S.lineNumber,S.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn)}static areIntersecting(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,S){if(A&&S){const T=A.startLineNumber|0,F=S.startLineNumber|0;if(T===F){const D=A.startColumn|0,g=S.startColumn|0;if(D===g){const E=A.endLineNumber|0,f=S.endLineNumber|0;if(E===f){const u=A.endColumn|0,w=S.endColumn|0;return u-w}return E-f}return D-g}return T-F}return(A?1:0)-(S?1:0)}static compareRangesUsingEnds(A,S){return A.endLineNumber===S.endLineNumber?A.endColumn===S.endColumn?A.startLineNumber===S.startLineNumber?A.startColumn-S.startColumn:A.startLineNumber-S.startLineNumber:A.endColumn-S.endColumn:A.endLineNumber-S.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=t}),define(we[148],be([1,0,48,41]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(P,C,T,F){super(P,C,T,F);this.selectionStartLineNumber=P,this.selectionStartColumn=C,this.positionLineNumber=T,this.positionColumn=F}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return A.selectionsEqual(this,P)}static selectionsEqual(P,C){return P.selectionStartLineNumber===C.selectionStartLineNumber&&P.selectionStartColumn===C.selectionStartColumn&&P.positionLineNumber===C.positionLineNumber&&P.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,C){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,P,C):new A(P,C,this.startLineNumber,this.startColumn)}getPosition(){return new h.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new h.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,C){return this.getDirection()===0?new A(P,C,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,P,C)}static fromPositions(P,C=P){return new A(P.lineNumber,P.column,C.lineNumber,C.column)}static fromRange(P,C){return C===0?new A(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new A(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new A(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,C){if(P&&!C||!P&&C)return!1;if(!P&&!C)return!0;if(P.length!==C.length)return!1;for(let T=0,F=P.length;T<F;T++)if(!this.selectionsEqual(P[T],C[T]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,C,T,F,D){return D===0?new A(P,C,T,F):new A(T,F,P,C)}}e.Selection=A}),define(we[149],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(we[150],be([1,0,108]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends h.CharacterClassifier{constructor(P){super(0);for(let C=0,T=P.length;C<T;C++)this.set(P.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function A(S){const P={};return C=>(P.hasOwnProperty(C)||(P[C]=S(C)),P[C])}e.getMapForWordSeparators=A(S=>new k(S))}),define(we[109],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(P=""){let C="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)P.indexOf(T)>=0||(C+="\\"+T);return C+="\\s]+)",new RegExp(C,"g")}e.DEFAULT_WORD_REGEXP=h();function t(P){let C=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)C=P;else{let T="g";P.ignoreCase&&(T+="i"),P.multiline&&(T+="m"),P.unicode&&(T+="u"),C=new RegExp(P.source,T)}return C.lastIndex=0,C}e.ensureValidWordDefinition=t;const k={maxLen:1e3,windowSize:15,timeBudget:150};function A(P,C,T,F,D=k){if(T.length>D.maxLen){let w=P-D.maxLen/2;return w<0?w=0:F+=w,T=T.substring(w,P+D.maxLen/2),A(P,C,T,F,D)}const g=Date.now(),E=P-1-F;let f=-1,u=null;for(let w=1;!(Date.now()-g>=D.timeBudget);w++){const y=E-D.windowSize*w;C.lastIndex=Math.max(0,y);const I=S(C,T,E,f);if(!I&&u||(u=I,y<=0))break;f=y}if(u){const w={word:u[0],startColumn:F+1+u.index,endColumn:F+1+u.index+u[0].length};return C.lastIndex=0,w}return null}e.getWordAtText=A;function S(P,C,T,F){let D;for(;D=P.exec(C);){const g=D.index||0;if(g<=T&&P.lastIndex>=T)return D;if(F>0&&g>F)return null}return null}}),define(we[110],be([1,0,32,9]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(A,S,P,C){if(Array.isArray(A)){let T=0;for(const F of A){const D=k(F,S,P,C);if(D===10)return D;D>T&&(T=D)}return T}else{if(typeof A=="string")return C?A==="*"?5:A===P?10:0:0;if(A){const{language:T,pattern:F,scheme:D,hasAccessToAllModels:g}=A;if(!C&&!g)return 0;let E=0;if(D)if(D===S.scheme)E=10;else if(D==="*")E=5;else return 0;if(T)if(T===P)E=10;else if(T==="*")E=Math.max(E,5);else return 0;if(F){let f;if(typeof F=="string"?f=F:f={...F,base:(0,t.normalize)(F.base)},f===S.fsPath||(0,h.match)(f,S.fsPath))E=10;else return 0}return E}else return 0}}e.score=k}),define(we[151],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class t{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let C=0,T=P.notIn.length;C<T;C++)switch(P.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,C){if(P.getTokenCount()===0)return!0;const T=P.findTokenIndexAtOffset(C-2),F=P.getStandardTokenType(T);return this.isOK(F)}_findNeutralCharacterInRange(P,C){for(let T=P;T<=C;T++){const F=String.fromCharCode(T);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class k{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of P)A(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),A(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),A(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),A(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&A(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=k;function A(S,P,C){S.has(P)?S.get(P).push(C):S.set(P,[C])}}),define(we[152],be([1,0,108]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class k{constructor(f,u,w){const y=new Uint8Array(f*u);for(let I=0,a=f*u;I<a;I++)y[I]=w;this._data=y,this.rows=f,this.cols=u}get(f,u){return this._data[f*this.cols+u]}set(f,u,w){this._data[f*this.cols+u]=w}}e.Uint8Matrix=k;class A{constructor(f){let u=0,w=0;for(let I=0,a=f.length;I<a;I++){const[c,m,s]=f[I];m>u&&(u=m),c>w&&(w=c),s>w&&(w=s)}u++,w++;const y=new k(w,u,0);for(let I=0,a=f.length;I<a;I++){const[c,m,s]=f[I];y.set(c,m,s)}this._states=y,this._maxCharCode=u}nextState(f,u){return u<0||u>=this._maxCharCode?0:this._states.get(f,u)}}e.StateMachine=A;let S=null;function P(){return S===null&&(S=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var C;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(C||(C={}));let T=null;function F(){if(T===null){T=new h.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<E.length;u++)T.set(E.charCodeAt(u),1);const f=".,;";for(let u=0;u<f.length;u++)T.set(f.charCodeAt(u),2)}return T}class D{static _createLink(f,u,w,y,I){let a=I-1;do{const c=u.charCodeAt(a);if(f.get(c)!==2)break;a--}while(a>y);if(y>0){const c=u.charCodeAt(y-1),m=u.charCodeAt(a);(c===40&&m===41||c===91&&m===93||c===123&&m===125)&&a--}return{range:{startLineNumber:w,startColumn:y+1,endLineNumber:w,endColumn:a+2},url:u.substring(y,a+1)}}static computeLinks(f,u=P()){const w=F(),y=[];for(let I=1,a=f.getLineCount();I<=a;I++){const c=f.getLineContent(I),m=c.length;let s=0,b=0,o=0,n=1,i=!1,r=!1,l=!1,p=!1;for(;s<m;){let d=!1;const v=c.charCodeAt(s);if(n===13){let R;switch(v){case 40:i=!0,R=0;break;case 41:R=i?0:1;break;case 91:l=!0,r=!0,R=0;break;case 93:l=!1,R=r?0:1;break;case 123:p=!0,R=0;break;case 125:R=p?0:1;break;case 39:R=o===34||o===96?0:1;break;case 34:R=o===39||o===96?0:1;break;case 96:R=o===39||o===34?0:1;break;case 42:R=o===42?1:0;break;case 124:R=o===124?1:0;break;case 32:R=l?0:1;break;default:R=w.get(v)}R===1&&(y.push(D._createLink(w,c,I,b,s)),d=!0)}else if(n===12){let R;v===91?(r=!0,R=0):R=w.get(v),R===1?d=!0:n=13}else n=u.nextState(n,v),n===0&&(d=!0);d&&(n=1,i=!1,r=!1,p=!1,b=s+1,o=v),s++}n===13&&y.push(D._createLink(w,c,I,b,m))}return y}}e.LinkComputer=D;function g(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:D.computeLinks(E)}e.computeLinks=g}),define(we[111],be([1,0,25]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(I){I[I.Left=1]="Left",I[I.Center=2]="Center",I[I.Right=4]="Right",I[I.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(I){I[I.Inline=1]="Inline",I[I.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(I){I[I.Both=0]="Both",I[I.Right=1]="Right",I[I.Left=2]="Left",I[I.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var S;(function(I){I[I.TextDefined=0]="TextDefined",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(I){I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(I){I[I.LF=0]="LF",I[I.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class T{constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace),this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=T;class F{constructor(a,c){this._findMatchBrand=void 0,this.range=a,this.matches=c}}e.FindMatch=F;var D;(function(I){I[I.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",I[I.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",I[I.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",I[I.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(D=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var g;(function(I){I[I.Left=0]="Left",I[I.Right=1]="Right",I[I.None=2]="None"})(g=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(I){I[I.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class f{constructor(a,c,m,s,b,o){this.identifier=a,this.range=c,this.text=m,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=b,this._isTracked=o}}e.ValidAnnotatedEditOperation=f;class u{constructor(a,c,m){this.regex=a,this.wordSeparators=c,this.simpleSearch=m}}e.SearchData=u;class w{constructor(a,c,m){this.reverseEdits=a,this.changes=c,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=w;function y(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=y}),define(we[112],be([1,0,17,99]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,T){C=(0,t.toUint32)(C);const F=this.values,D=this.prefixSum,g=T.length;return g===0?!1:(this.values=new Uint32Array(F.length+g),this.values.set(F.subarray(0,C),0),this.values.set(F.subarray(C),C+g),this.values.set(T,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(C,T){return C=(0,t.toUint32)(C),T=(0,t.toUint32)(T),this.values[C]===T?!1:(this.values[C]=T,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,T){C=(0,t.toUint32)(C),T=(0,t.toUint32)(T);const F=this.values,D=this.prefixSum;if(C>=F.length)return!1;const g=F.length-C;return T>=g&&(T=g),T===0?!1:(this.values=new Uint32Array(F.length-T),this.values.set(F.subarray(0,C),0),this.values.set(F.subarray(C+T),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(C){return C<0?0:(C=(0,t.toUint32)(C),this._getPrefixSum(C))}_getPrefixSum(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let T=this.prefixSumValidIndex[0]+1;T===0&&(this.prefixSum[0]=this.values[0],T++),C>=this.values.length&&(C=this.values.length-1);for(let F=T;F<=C;F++)this.prefixSum[F]=this.prefixSum[F-1]+this.values[F];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalSum();let T=0,F=this.values.length-1,D=0,g=0,E=0;for(;T<=F;)if(D=T+(F-T)/2|0,g=this.prefixSum[D],E=g-this.values[D],C<E)F=D-1;else if(C>=g)T=D+1;else break;return new S(D,C-E)}}e.PrefixSumComputer=k;class A{constructor(C){this._values=C,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(C){return this._ensureValid(),C===0?0:this._prefixSum[C-1]}getIndexOf(C){this._ensureValid();const T=this._indexBySum[C],F=T>0?this._prefixSum[T-1]:0;return new S(T,C-F)}removeValues(C,T){this._values.splice(C,T),this._invalidate(C)}insertValues(C,T){this._values=(0,h.arrayInsert)(this._values,C,T),this._invalidate(C)}_invalidate(C){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,C-1)}_ensureValid(){if(!this._isValid){for(let C=this._validEndIndex+1,T=this._values.length;C<T;C++){const F=this._values[C],D=C>0?this._prefixSum[C-1]:0;this._prefixSum[C]=D+F;for(let g=0;g<F;g++)this._indexBySum[D+g]=C}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(C,T){this._values[C]!==T&&(this._values[C]=T,this._invalidate(C))}}e.ConstantTimePrefixSumComputer=A;class S{constructor(C,T){this.index=C,this.remainder=T,this._prefixSumIndexOfResultBrand=void 0,this.index=C,this.remainder=T}}e.PrefixSumIndexOfResult=S}),define(we[153],be([1,0,8,48,112]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(P,C,T,F){this._uri=P,this._lines=C,this._eol=T,this._versionId=F,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const C=P.changes;for(const T of C)this._acceptDeleteRange(T.range),this._acceptInsertText(new t.Position(T.range.startLineNumber,T.range.startColumn),T.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,C=this._lines.length,T=new Uint32Array(C);for(let F=0;F<C;F++)T[F]=this._lines[F].length+P;this._lineStarts=new k.PrefixSumComputer(T)}}_setLineText(P,C){this._lines[P]=C,this._lineStarts&&this._lineStarts.setValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,C){if(C.length===0)return;const T=(0,h.splitLines)(C);if(T.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+T[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}T[T.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+T[0]);const F=new Uint32Array(T.length-1);for(let D=1;D<T.length;D++)this._lines.splice(P.lineNumber+D-1,0,T[D]),F[D-1]=T[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,F)}}e.MirrorTextModel=A}),define(we[154],be([1,0,8,150,48,41,111]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class C{constructor(I,a,c,m){this.searchString=I,this.isRegex=a,this.matchCase=c,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let I;this.isRegex?I=T(this.searchString):I=this.searchString.indexOf(`
`)>=0;let a=null;try{a=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:I,global:!0,unicode:!0})}catch{return null}if(!a)return null;let c=!this.isRegex&&!I;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new S.SearchData(a,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=C;function T(y){if(!y||y.length===0)return!1;for(let I=0,a=y.length;I<a;I++)if(y.charCodeAt(I)===92){if(I++,I>=a)break;const m=y.charCodeAt(I);if(m===110||m===114||m===87)return!0}return!1}e.isMultilineRegexSource=T;function F(y,I,a){if(!a)return new S.FindMatch(y,null);const c=[];for(let m=0,s=I.length;m<s;m++)c[m]=I[m];return new S.FindMatch(y,c)}e.createFindMatch=F;class D{constructor(I){const a=[];let c=0;for(let m=0,s=I.length;m<s;m++)I.charCodeAt(m)===10&&(a[c++]=m);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(I){const a=this._lineFeedsOffsets;let c=0,m=a.length-1;if(m===-1||I<=a[0])return 0;for(;c<m;){const s=c+((m-c)/2>>0);a[s]>=I?m=s-1:a[s+1]>=I?(c=s,m=s):c=s+1}return c+1}}class g{static findMatches(I,a,c,m,s){const b=a.parseSearchRequest();return b?b.regex.multiline?this._doFindMatchesMultiline(I,c,new w(b.wordSeparators,b.regex),m,s):this._doFindMatchesLineByLine(I,c,b,m,s):[]}static _getMultilineMatchRange(I,a,c,m,s,b){let o,n=0;m?(n=m.findLineFeedCountBeforeOffset(s),o=a+s+n):o=a+s;let i;if(m){const d=m.findLineFeedCountBeforeOffset(s+b.length)-n;i=o+b.length+d}else i=o+b.length;const r=I.getPositionAt(o),l=I.getPositionAt(i);return new A.Range(r.lineNumber,r.column,l.lineNumber,l.column)}static _doFindMatchesMultiline(I,a,c,m,s){const b=I.getOffsetAt(a.getStartPosition()),o=I.getValueInRange(a,1),n=I.getEOL()===`\r
`?new D(o):null,i=[];let r=0,l;for(c.reset(0);l=c.next(o);)if(i[r++]=F(this._getMultilineMatchRange(I,b,o,n,l.index,l[0]),l,m),r>=s)return i;return i}static _doFindMatchesLineByLine(I,a,c,m,s){const b=[];let o=0;if(a.startLineNumber===a.endLineNumber){const i=I.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return o=this._findMatchesInLine(c,i,a.startLineNumber,a.startColumn-1,o,b,m,s),b}const n=I.getLineContent(a.startLineNumber).substring(a.startColumn-1);o=this._findMatchesInLine(c,n,a.startLineNumber,a.startColumn-1,o,b,m,s);for(let i=a.startLineNumber+1;i<a.endLineNumber&&o<s;i++)o=this._findMatchesInLine(c,I.getLineContent(i),i,0,o,b,m,s);if(o<s){const i=I.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);o=this._findMatchesInLine(c,i,a.endLineNumber,0,o,b,m,s)}return b}static _findMatchesInLine(I,a,c,m,s,b,o,n){const i=I.wordSeparators;if(!o&&I.simpleSearch){const p=I.simpleSearch,d=p.length,v=a.length;let R=-d;for(;(R=a.indexOf(p,R+d))!==-1;)if((!i||u(i,a,v,R,d))&&(b[s++]=new S.FindMatch(new A.Range(c,R+1+m,c,R+1+d+m),null),s>=n))return s;return s}const r=new w(I.wordSeparators,I.regex);let l;r.reset(0);do if(l=r.next(a),l&&(b[s++]=F(new A.Range(c,l.index+1+m,c,l.index+1+l[0].length+m),l,o),s>=n))return s;while(l);return s}static findNextMatch(I,a,c,m){const s=a.parseSearchRequest();if(!s)return null;const b=new w(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(I,c,b,m):this._doFindNextMatchLineByLine(I,c,b,m)}static _doFindNextMatchMultiline(I,a,c,m){const s=new k.Position(a.lineNumber,1),b=I.getOffsetAt(s),o=I.getLineCount(),n=I.getValueInRange(new A.Range(s.lineNumber,s.column,o,I.getLineMaxColumn(o)),1),i=I.getEOL()===`\r
`?new D(n):null;c.reset(a.column-1);let r=c.next(n);return r?F(this._getMultilineMatchRange(I,b,n,i,r.index,r[0]),r,m):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(I,new k.Position(1,1),c,m):null}static _doFindNextMatchLineByLine(I,a,c,m){const s=I.getLineCount(),b=a.lineNumber,o=I.getLineContent(b),n=this._findFirstMatchInLine(c,o,b,a.column,m);if(n)return n;for(let i=1;i<=s;i++){const r=(b+i-1)%s,l=I.getLineContent(r+1),p=this._findFirstMatchInLine(c,l,r+1,1,m);if(p)return p}return null}static _findFirstMatchInLine(I,a,c,m,s){I.reset(m-1);const b=I.next(a);return b?F(new A.Range(c,b.index+1,c,b.index+1+b[0].length),b,s):null}static findPreviousMatch(I,a,c,m){const s=a.parseSearchRequest();if(!s)return null;const b=new w(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(I,c,b,m):this._doFindPreviousMatchLineByLine(I,c,b,m)}static _doFindPreviousMatchMultiline(I,a,c,m){const s=this._doFindMatchesMultiline(I,new A.Range(1,1,a.lineNumber,a.column),c,m,10*P);if(s.length>0)return s[s.length-1];const b=I.getLineCount();return a.lineNumber!==b||a.column!==I.getLineMaxColumn(b)?this._doFindPreviousMatchMultiline(I,new k.Position(b,I.getLineMaxColumn(b)),c,m):null}static _doFindPreviousMatchLineByLine(I,a,c,m){const s=I.getLineCount(),b=a.lineNumber,o=I.getLineContent(b).substring(0,a.column-1),n=this._findLastMatchInLine(c,o,b,m);if(n)return n;for(let i=1;i<=s;i++){const r=(s+b-i-1)%s,l=I.getLineContent(r+1),p=this._findLastMatchInLine(c,l,r+1,m);if(p)return p}return null}static _findLastMatchInLine(I,a,c,m){let s=null,b;for(I.reset(0);b=I.next(a);)s=F(new A.Range(c,b.index+1,c,b.index+1+b[0].length),b,m);return s}}e.TextModelSearch=g;function E(y,I,a,c,m){if(c===0)return!0;const s=I.charCodeAt(c-1);if(y.get(s)!==0||s===13||s===10)return!0;if(m>0){const b=I.charCodeAt(c);if(y.get(b)!==0)return!0}return!1}function f(y,I,a,c,m){if(c+m===a)return!0;const s=I.charCodeAt(c+m);if(y.get(s)!==0||s===13||s===10)return!0;if(m>0){const b=I.charCodeAt(c+m-1);if(y.get(b)!==0)return!0}return!1}function u(y,I,a,c,m){return E(y,I,a,c,m)&&f(y,I,a,c,m)}e.isValidMatch=u;class w{constructor(I,a){this._wordSeparators=I,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(I){this._searchRegex.lastIndex=I,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(I){const a=I.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(c=this._searchRegex.exec(I),!c))return null;const m=c.index,s=c[0].length;if(m===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){h.getNextCodePoint(I,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=s,!this._wordSeparators||u(this._wordSeparators,I,a,m,s))return c}while(c);return null}}e.Searcher=w}),define(we[113],be([1,0,23,12]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(k||(k={}));function A(D){for(let g=0,E=D.length;g<E;g+=4){const f=D[g+0],u=D[g+1],w=D[g+2],y=D[g+3];D[g+0]=y,D[g+1]=w,D[g+2]=u,D[g+3]=f}}function S(D){const g=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return t.isLittleEndian()||A(g),h.VSBuffer.wrap(g)}function P(D){const g=D.buffer;if(t.isLittleEndian()||A(g),g.byteOffset%4==0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const E=new Uint8Array(g.byteLength);return E.set(g),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function C(D){const g=new Uint32Array(T(D));let E=0;if(g[E++]=D.id,D.type==="full")g[E++]=1,g[E++]=D.data.length,g.set(D.data,E),E+=D.data.length;else{g[E++]=2,g[E++]=D.deltas.length;for(const f of D.deltas)g[E++]=f.start,g[E++]=f.deleteCount,f.data?(g[E++]=f.data.length,g.set(f.data,E),E+=f.data.length):g[E++]=0}return S(g)}e.encodeSemanticTokensDto=C;function T(D){let g=0;if(g+=1+1,D.type==="full")g+=1+D.data.length;else{g+=1,g+=(1+1+1)*D.deltas.length;for(const E of D.deltas)E.data&&(g+=E.data.length)}return g}function F(D){const g=P(D);let E=0;const f=g[E++];if(g[E++]===1){const I=g[E++],a=g.subarray(E,E+I);return E+=I,{id:f,type:"full",data:a}}const w=g[E++],y=[];for(let I=0;I<w;I++){const a=g[E++],c=g[E++],m=g[E++];let s;m>0&&(s=g.subarray(E,E+m),E+=m),y[I]={start:a,deleteCount:c,data:s}}return{id:f,type:"delta",deltas:y}}e.decodeSemanticTokensDto=F}),define(we[155],be([1,0,3,6]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,C){return this._map.set(P,C),this.fire([P]),(0,t.toDisposable)(()=>{this._map.get(P)===C&&(this._map.delete(P),this.fire([P]))})}registerFactory(P,C){this._factories.get(P)?.dispose();const T=new A(this,P,C);return this._factories.set(P,T),(0,t.toDisposable)(()=>{const F=this._factories.get(P);!F||F!==T||(this._factories.delete(P),F.dispose())})}async getOrCreate(P){const C=this.get(P);if(C)return C;const T=this._factories.get(P);return!T||T.isResolved?null:(await T.resolve(),this.get(P))}get(P){return this._map.get(P)||null}isResolved(P){if(this.get(P))return!0;const T=this._factories.get(P);return!!(!T||T.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=k;class A extends t.Disposable{constructor(P,C,T){super();this._registry=P,this._languageId=C,this._factory=T,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(we[81],be([1,0,2,41,155,73]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var S;(function(L){L[L.Null=0]="Null",L[L.PlainText=1]="PlainText"})(S=e.LanguageId||(e.LanguageId={}));var P;(function(L){L[L.NotSet=-1]="NotSet",L[L.None=0]="None",L[L.Italic=1]="Italic",L[L.Bold=2]="Bold",L[L.Underline=4]="Underline",L[L.Strikethrough=8]="Strikethrough"})(P=e.FontStyle||(e.FontStyle={}));var C;(function(L){L[L.None=0]="None",L[L.DefaultForeground=1]="DefaultForeground",L[L.DefaultBackground=2]="DefaultBackground"})(C=e.ColorId||(e.ColorId={}));var T;(function(L){L[L.Other=0]="Other",L[L.Comment=1]="Comment",L[L.String=2]="String",L[L.RegEx=3]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var F;(function(L){L[L.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",L[L.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",L[L.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",L[L.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",L[L.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",L[L.ITALIC_MASK=1024]="ITALIC_MASK",L[L.BOLD_MASK=2048]="BOLD_MASK",L[L.UNDERLINE_MASK=4096]="UNDERLINE_MASK",L[L.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",L[L.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",L[L.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",L[L.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",L[L.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",L[L.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",L[L.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",L[L.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",L[L.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",L[L.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",L[L.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",L[L.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(F=e.MetadataConsts||(e.MetadataConsts={}));class D{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&768)>>>8}static getFontStyle(_){return(_&15360)>>>10}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){const U=this.getForeground(_);let M="mtk"+U;const q=this.getFontStyle(_);return q&1&&(M+=" mtki"),q&2&&(M+=" mtkb"),q&4&&(M+=" mtku"),q&8&&(M+=" mtks"),M}static getInlineStyleFromMetadata(_,U){const M=this.getForeground(_),q=this.getFontStyle(_);let K=`color: ${U[M]};`;q&1&&(K+="font-style: italic;"),q&2&&(K+="font-weight: bold;");let x="";return q&4&&(x+=" underline"),q&8&&(x+=" line-through"),x&&(K+=`text-decoration:${x};`),K}static getPresentationFromMetadata(_){const U=this.getForeground(_),M=this.getFontStyle(_);return{foreground:U,italic:Boolean(M&1),bold:Boolean(M&2),underline:Boolean(M&4),strikethrough:Boolean(M&8)}}}e.TokenMetadata=D;class g{constructor(_,U,M){this._tokenBrand=void 0,this.offset=_,this.type=U,this.language=M}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=g;class E{constructor(_,U){this._tokenizationResultBrand=void 0,this.tokens=_,this.endState=U}}e.TokenizationResult=E;class f{constructor(_,U){this._encodedTokenizationResultBrand=void 0,this.tokens=_,this.endState=U}}e.EncodedTokenizationResult=f;var u;(function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue",L[L.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={}));var w;(function(L){const _=new Map;_.set(0,A.Codicon.symbolMethod),_.set(1,A.Codicon.symbolFunction),_.set(2,A.Codicon.symbolConstructor),_.set(3,A.Codicon.symbolField),_.set(4,A.Codicon.symbolVariable),_.set(5,A.Codicon.symbolClass),_.set(6,A.Codicon.symbolStruct),_.set(7,A.Codicon.symbolInterface),_.set(8,A.Codicon.symbolModule),_.set(9,A.Codicon.symbolProperty),_.set(10,A.Codicon.symbolEvent),_.set(11,A.Codicon.symbolOperator),_.set(12,A.Codicon.symbolUnit),_.set(13,A.Codicon.symbolValue),_.set(15,A.Codicon.symbolEnum),_.set(14,A.Codicon.symbolConstant),_.set(15,A.Codicon.symbolEnum),_.set(16,A.Codicon.symbolEnumMember),_.set(17,A.Codicon.symbolKeyword),_.set(27,A.Codicon.symbolSnippet),_.set(18,A.Codicon.symbolText),_.set(19,A.Codicon.symbolColor),_.set(20,A.Codicon.symbolFile),_.set(21,A.Codicon.symbolReference),_.set(22,A.Codicon.symbolCustomColor),_.set(23,A.Codicon.symbolFolder),_.set(24,A.Codicon.symbolTypeParameter),_.set(25,A.Codicon.account),_.set(26,A.Codicon.issues);function U(K){let x=_.get(K);return x||(console.info("No codicon found for CompletionItemKind "+K),x=A.Codicon.symbolProperty),x}L.toIcon=U;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function q(K,x){let B=M.get(K);return typeof B=="undefined"&&!x&&(B=9),B}L.fromString=q})(w=e.CompletionItemKinds||(e.CompletionItemKinds={}));var y;(function(L){L[L.Deprecated=1]="Deprecated"})(y=e.CompletionItemTag||(e.CompletionItemTag={}));var I;(function(L){L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"})(I=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var a;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(a=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var c;(function(L){L[L.Automatic=0]="Automatic",L[L.Explicit=1]="Explicit"})(c=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(L){L[L.Invoke=1]="Invoke",L[L.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var b;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(b=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(L){return L&&h.URI.isUri(L.uri)&&t.Range.isIRange(L.range)&&(t.Range.isIRange(L.originSelectionRange)||t.Range.isIRange(L.targetSelectionRange))}e.isLocationLink=o;var n;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var i;(function(L){L[L.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var r;(function(L){const _=new Map;_.set(0,A.Codicon.symbolFile),_.set(1,A.Codicon.symbolModule),_.set(2,A.Codicon.symbolNamespace),_.set(3,A.Codicon.symbolPackage),_.set(4,A.Codicon.symbolClass),_.set(5,A.Codicon.symbolMethod),_.set(6,A.Codicon.symbolProperty),_.set(7,A.Codicon.symbolField),_.set(8,A.Codicon.symbolConstructor),_.set(9,A.Codicon.symbolEnum),_.set(10,A.Codicon.symbolInterface),_.set(11,A.Codicon.symbolFunction),_.set(12,A.Codicon.symbolVariable),_.set(13,A.Codicon.symbolConstant),_.set(14,A.Codicon.symbolString),_.set(15,A.Codicon.symbolNumber),_.set(16,A.Codicon.symbolBoolean),_.set(17,A.Codicon.symbolArray),_.set(18,A.Codicon.symbolObject),_.set(19,A.Codicon.symbolKey),_.set(20,A.Codicon.symbolNull),_.set(21,A.Codicon.symbolEnumMember),_.set(22,A.Codicon.symbolStruct),_.set(23,A.Codicon.symbolEvent),_.set(24,A.Codicon.symbolOperator),_.set(25,A.Codicon.symbolTypeParameter);function U(M){let q=_.get(M);return q||(console.info("No codicon found for SymbolKind "+M),q=A.Codicon.symbolProperty),q}L.toIcon=U})(r=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(_){this.value=_}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var p;(function(L){function _(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}L.is=_})(p=e.Command||(e.Command={}));var d;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var v;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(v=e.CommentMode||(e.CommentMode={}));var R;(function(L){L[L.Other=0]="Other",L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(R=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new k.TokenizationRegistry;var O;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(O=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[156],be([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(we[157],be([1,0,156]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,A=k*24,S=A*7,P=A*30,C=A*365;function T(D,g,E){typeof D!="number"&&(D=D.getTime());const f=Math.round((new Date().getTime()-D)/1e3);if(f<-30)return(0,h.localize)(0,null,T(new Date().getTime()+f*1e3,!1));if(f<30)return(0,h.localize)(1,null);let u;return f<t?(u=f,g?u===1?E?(0,h.localize)(2,null,u):(0,h.localize)(3,null,u):E?(0,h.localize)(4,null,u):(0,h.localize)(5,null,u):u===1?E?(0,h.localize)(6,null,u):(0,h.localize)(7,null,u):E?(0,h.localize)(8,null,u):(0,h.localize)(9,null,u)):f<k?(u=Math.floor(f/t),g?u===1?E?(0,h.localize)(10,null,u):(0,h.localize)(11,null,u):E?(0,h.localize)(12,null,u):(0,h.localize)(13,null,u):u===1?E?(0,h.localize)(14,null,u):(0,h.localize)(15,null,u):E?(0,h.localize)(16,null,u):(0,h.localize)(17,null,u)):f<A?(u=Math.floor(f/k),g?u===1?E?(0,h.localize)(18,null,u):(0,h.localize)(19,null,u):E?(0,h.localize)(20,null,u):(0,h.localize)(21,null,u):u===1?E?(0,h.localize)(22,null,u):(0,h.localize)(23,null,u):E?(0,h.localize)(24,null,u):(0,h.localize)(25,null,u)):f<S?(u=Math.floor(f/A),g?u===1?(0,h.localize)(26,null,u):(0,h.localize)(27,null,u):u===1?(0,h.localize)(28,null,u):(0,h.localize)(29,null,u)):f<P?(u=Math.floor(f/S),g?u===1?E?(0,h.localize)(30,null,u):(0,h.localize)(31,null,u):E?(0,h.localize)(32,null,u):(0,h.localize)(33,null,u):u===1?E?(0,h.localize)(34,null,u):(0,h.localize)(35,null,u):E?(0,h.localize)(36,null,u):(0,h.localize)(37,null,u)):f<C?(u=Math.floor(f/P),g?u===1?E?(0,h.localize)(38,null,u):(0,h.localize)(39,null,u):E?(0,h.localize)(40,null,u):(0,h.localize)(41,null,u):u===1?E?(0,h.localize)(42,null,u):(0,h.localize)(43,null,u):E?(0,h.localize)(44,null,u):(0,h.localize)(45,null,u)):(u=Math.floor(f/C),g?u===1?E?(0,h.localize)(46,null,u):(0,h.localize)(47,null,u):E?(0,h.localize)(48,null,u):(0,h.localize)(49,null,u):u===1?E?(0,h.localize)(50,null,u):(0,h.localize)(51,null,u):E?(0,h.localize)(52,null,u):(0,h.localize)(53,null,u))}e.fromNow=T;function F(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(we[158],be([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(we[49],be([1,0,17,18,158]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,F){return F&&(T.stack||T.stacktrace)?k.localize(0,null,P(T),S(T.stack)||S(T.stacktrace)):P(T)}function S(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?k.localize(1,null,T.message):T.message||k.localize(2,null)}function C(T=null,F=!1){if(!T)return k.localize(3,null);if(Array.isArray(T)){const D=h.coalesce(T),g=C(D[0],F);return D.length>1?k.localize(4,null,g,D.length):g}if(t.isString(T))return T;if(T.detail){const D=T.detail;if(D.error)return A(D.error,F);if(D.exception)return A(D.exception,F)}return T.stack?A(T,F):T.message?T.message:k.localize(5,null)}e.toErrorMessage=C}),define(we[159],be([19,20]),function(te,e){return te.create("vs/base/node/processes",e)}),define(we[114],be([1,0,37,28,10,25,9,12,40,96,18,147,29,159]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function f(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(s,b){if(P.isWindows)try{const o={stdio:["pipe","pipe","ignore"]};b&&(o.cwd=b);const n=h.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],o);return new Promise(i=>{n.once("error",r=>{i({success:!1,error:r})}),n.once("exit",(r,l)=>{i(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(o){return Promise.resolve({success:!1,error:o,code:o.status?f(o.status):1})}else if(P.isLinux||P.isMacintosh)try{const o=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",te).fsPath;return new Promise(n=>{h.execFile(o,[s.pid.toString()],{encoding:"utf8",shell:!0},(i,r,l)=>{n(i?{success:!1,error:i}:{success:!0})})})}catch(o){return Promise.resolve({success:!1,error:o})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function w(s){!s||(delete s.DEBUG,P.isMacintosh&&delete s.DYLD_LIBRARY_PATH,P.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=w;function y(s=C.env){return s.comspec||"cmd.exe"}e.getWindowsShell=y;class I{constructor(b,o,n,i){if(o!==void 0&&n!==void 0&&i!==void 0)this.cmd=b,this.args=o,this.shell=n,this.options=i;else{const r=b;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(C.env).forEach(l=>{r[l]=C.env[l]}),Object.keys(this.options.env).forEach(l=>{r[l]=this.options.env[l]}),this.options.env=r}}getSanitizedCommand(){let b=this.cmd.toLowerCase();const o=b.lastIndexOf(S.sep);return o!==-1&&(b=b.substring(o+1)),I.WellKnowCommands[b]?b:"other"}start(b){return P.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(C.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(o=>{let n,i;const r=new Promise((l,p)=>{n=l,i=p});if(o){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=h.exec(l,this.options,(p,d,v)=>{this.childProcess=null;const R=p;R&&R.killed?i({killed:this.terminateRequested,stdout:d.toString(),stderr:v.toString()}):this.handleExec(n,b,p,d,v)})}else{let l=null;const p=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,n,b,i);const v={terminated:this.terminateRequested};F.isNumber(d)&&(v.cmdCode=d),n(v)};if(this.shell&&P.isWindows){const d=A.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let v=!1,R=!1;const O=[];let L=this.ensureQuotes(this.cmd);O.push(L.value),v=L.quoted,this.args&&this.args.forEach(U=>{L=this.ensureQuotes(U),O.push(L.value),R=R&&L.quoted});const _=["/s","/c"];v?R?_.push('"'+O.join(" ")+'"'):O.length>1?_.push('"'+O[0]+'" '+O.slice(1).join(" ")):_.push('"'+O[0]+'"'):_.push(O.join(" ")),l=h.spawn(y(),_,d)}else this.cmd&&(l=h.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(F.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",d=>{this.childProcess=null,i({terminated:this.terminateRequested,error:d})}),l.pid&&(this.childProcess.on("close",p),this.handleSpawn(l,n,b,i,!0)))}return r})}handleClose(b,o,n,i){}ensureQuotes(b){return I.regexp.test(b)?{value:'"'+b+'"',quoted:!0}:{value:b,quoted:b.length>0&&b[0]==='"'&&b[b.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(b=>b.pid,b=>-1):new Promise(b=>{this.pidResolve=b})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(b=>(this.terminateRequested=!0,u(b,this.options.cwd).then(o=>(o.success&&(this.childProcess=null),o))),b=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(b=>{if(!this.shell||!P.isWindows)return b(!1);const o=h.spawn(y(),["/s","/c"]);o.on("error",n=>b(!0)),o.on("exit",n=>b(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class a extends I{constructor(b,o,n,i){super(b,o,n,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(b,o,n,i,r){[i,r].forEach((l,p)=>{const d=new D.LineDecoder;d.write(l).forEach(O=>{o({line:O,source:p===0?0:1})});const R=d.end();R&&o({line:R,source:p===0?0:1})}),b({terminated:this.terminateRequested,error:n})}handleSpawn(b,o,n,i,r){const l=new D.LineDecoder,p=new D.LineDecoder;b.stdout.on("data",d=>{l.write(d).forEach(R=>n({line:R,source:0}))}),b.stderr.on("data",d=>{p.write(d).forEach(R=>n({line:R,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=p}handleClose(b,o,n,i){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&n({line:l,source:1})}}e.LineProcess=a;function c(s){let b=[],o=!1;const n=function(i){if(o){b.push(i);return}(!s.send(i,l=>{if(l&&console.error(l),o=!1,b.length>0){const p=b.slice(0);b=[],p.forEach(d=>n(d))}})||P.isWindows)&&(o=!0)};return{send:n}}e.createQueuedSender=c;var m;(function(s){async function b(o,n,i){if(S.isAbsolute(o))return o;if(n===void 0&&(n=C.cwd()),S.dirname(o)!=="."||(i===void 0&&F.isString(C.env.PATH)&&(i=C.env.PATH.split(S.delimiter)),i===void 0||i.length===0))return S.join(n,o);async function l(p){if(await g.Promises.exists(p)){let d;try{d=await g.Promises.stat(p)}catch(v){v.message.startsWith("EACCES")&&(d=await g.Promises.lstat(p))}return d?!d.isDirectory():!1}return!1}for(let p of i){let d;if(S.isAbsolute(p)?d=S.join(p,o):d=S.join(n,p,o),await l(d))return d;let v=d+".com";if(await l(v)||(v=d+".exe",await l(v)))return v}return S.join(n,o)}s.findExecutable=b})(m=e.win32||(e.win32={}))}),define(we[160],be([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(we[115],be([1,0,160,12,109,17,25,149]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(ie){ie[ie.None=0]="None",ie[ie.Keep=1]="Keep",ie[ie.Brackets=2]="Brackets",ie[ie.Advanced=3]="Advanced",ie[ie.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(ae){this._values=ae}hasChanged(ae){return this._values[ae]}}e.ConfigurationChangedEvent=T;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class D{constructor(ae,J,pe,Se){this.id=ae,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(ae,J){return E(ae,J)}compute(ae,J,pe){return pe}}class g{constructor(ae,J){this.newValue=ae,this.didChange=J}}e.ApplyUpdateResult=g;function E(ie,ae){if(typeof ie!="object"||typeof ae!="object"||!ie||!ae)return new g(ae,ie!==ae);if(Array.isArray(ie)||Array.isArray(ae)){const pe=Array.isArray(ie)&&Array.isArray(ae)&&A.equals(ie,ae);return new g(ae,pe)}let J=!1;for(const pe in ae)if(ae.hasOwnProperty(pe)){const Se=E(ie[pe],ae[pe]);Se.didChange&&(ie[pe]=Se.newValue,J=!0)}return new g(ie,J)}class f{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,J){return E(ae,J)}validate(ae){return this.defaultValue}}class u{constructor(ae,J,pe,Se){this.id=ae,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(ae,J){return E(ae,J)}validate(ae){return typeof ae=="undefined"?this.defaultValue:ae}compute(ae,J,pe){return pe}}function w(ie,ae){return typeof ie=="undefined"?ae:ie==="false"?!1:Boolean(ie)}e.boolean=w;class y extends u{constructor(ae,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="boolean",Se.default=pe);super(ae,J,pe,Se)}validate(ae){return w(ae,this.defaultValue)}}function I(ie,ae,J,pe){if(typeof ie=="undefined")return ae;let Se=parseInt(ie,10);return isNaN(Se)?ae:(Se=Math.max(J,Se),Se=Math.min(pe,Se),Se|0)}e.clampedInt=I;class a extends u{constructor(ae,J,pe,Se,Me,ze=void 0){typeof ze!="undefined"&&(ze.type="integer",ze.default=pe,ze.minimum=Se,ze.maximum=Me);super(ae,J,pe,ze);this.minimum=Se,this.maximum=Me}static clampedInt(ae,J,pe,Se){return I(ae,J,pe,Se)}validate(ae){return a.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}class c extends u{constructor(ae,J,pe,Se,Me){typeof Me!="undefined"&&(Me.type="number",Me.default=pe);super(ae,J,pe,Me);this.validationFn=Se}static clamp(ae,J,pe){return ae<J?J:ae>pe?pe:ae}static float(ae,J){if(typeof ae=="number")return ae;if(typeof ae=="undefined")return J;const pe=parseFloat(ae);return isNaN(pe)?J:pe}validate(ae){return this.validationFn(c.float(ae,this.defaultValue))}}class m extends u{static string(ae,J){return typeof ae!="string"?J:ae}constructor(ae,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.default=pe);super(ae,J,pe,Se)}validate(ae){return m.string(ae,this.defaultValue)}}function s(ie,ae,J){return typeof ie!="string"||J.indexOf(ie)===-1?ae:ie}e.stringSet=s;class b extends u{constructor(ae,J,pe,Se,Me=void 0){typeof Me!="undefined"&&(Me.type="string",Me.enum=Se,Me.default=pe);super(ae,J,pe,Me);this._allowedValues=Se}validate(ae){return s(ae,this.defaultValue,this._allowedValues)}}class o extends D{constructor(ae,J,pe,Se,Me,ze,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Me,Ye.default=Se);super(ae,J,pe,Ye);this._allowedValues=Me,this._convert=ze}validate(ae){return typeof ae!="string"?this.defaultValue:this._allowedValues.indexOf(ae)===-1?this.defaultValue:this._convert(ae)}}function n(ie){switch(ie){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,J,pe){return pe===0?ae.accessibilitySupport:pe}}class r extends D{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:h.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{insertSpace:w(J.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(J.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(ie){ie[ie.Hidden=0]="Hidden",ie[ie.Blink=1]="Blink",ie[ie.Smooth=2]="Smooth",ie[ie.Phase=3]="Phase",ie[ie.Expand=4]="Expand",ie[ie.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function p(ie){switch(ie){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(ie){ie[ie.Line=1]="Line",ie[ie.Block=2]="Block",ie[ie.Underline=3]="Underline",ie[ie.LineThin=4]="LineThin",ie[ie.BlockOutline=5]="BlockOutline",ie[ie.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function v(ie){switch(ie){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function R(ie){switch(ie){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class O extends f{constructor(){super(128)}compute(ae,J,pe){const Se=["monaco-editor"];return J.get(33)&&Se.push(J.get(33)),ae.extraEditorClassName&&Se.push(ae.extraEditorClassName),J.get(66)==="default"?Se.push("mouse-default"):J.get(66)==="copy"&&Se.push("mouse-copy"),J.get(100)&&Se.push("showUnused"),J.get(126)&&Se.push("showDeprecated"),Se.join(" ")}}class L extends y{constructor(){super(32,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(ae,J,pe){return pe&&ae.emptySelectionClipboard}}class _ extends D{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:h.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:h.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{cursorMoveOnType:w(J.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":s(J.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":s(J.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(J.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(J.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(J.loop,this.defaultValue.loop)}}}class U extends D{constructor(){super(45,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(ae){return typeof ae=="undefined"?this.defaultValue:typeof ae=="string"?ae==="false"?U.OFF:ae==="true"?U.ON:ae:Boolean(ae)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class M extends f{constructor(){super(44)}compute(ae,J,pe){return ae.fontInfo}}class q extends u{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(ae){const J=c.float(ae,this.defaultValue);return J===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(J,6,100)}compute(ae,J,pe){return ae.fontInfo.fontSize}}class K extends D{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(a.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class x extends D{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},J={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},pe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...J},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...J},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...J},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...J},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...J},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:pe,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:pe,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:pe,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:pe,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:pe,description:h.localize(38,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{multiple:s(J.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:J.multipleDefinitions??s(J.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:J.multipleTypeDefinitions??s(J.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:J.multipleDeclarations??s(J.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:J.multipleImplementations??s(J.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:J.multipleReferences??s(J.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(J.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(J.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(J.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(J.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(J.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class B extends D{constructor(){const ae={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:h.localize(41,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:h.localize(42,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:w(J.enabled,this.defaultValue.enabled),delay:a.clampedInt(J.delay,this.defaultValue.delay,0,1e4),sticky:w(J.sticky,this.defaultValue.sticky),above:w(J.above,this.defaultValue.above)}}}var G;(function(ie){ie[ie.None=0]="None",ie[ie.Text=1]="Text",ie[ie.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class X extends f{constructor(){super(131)}compute(ae,J,pe){return X.computeLayout(J,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio})}static computeContainedMinimapLineCount(ae){const J=ae.height/ae.lineHeight,pe=ae.scrollBeyondLastLine?J-1:0,Se=(ae.viewLineCount+pe)/(ae.pixelRatio*ae.height),Me=Math.floor(ae.viewLineCount/Se);return{typicalViewportLineCount:J,extraLinesBeyondLastLine:pe,desiredRatio:Se,minimapLineCount:Me}}static _computeMinimapLayout(ae,J){const pe=ae.outerWidth,Se=ae.outerHeight,Me=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Se),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Se};const ze=J.stableMinimapLayoutInput,Ye=ze&&ae.outerHeight===ze.outerHeight&&ae.lineHeight===ze.lineHeight&&ae.typicalHalfwidthCharacterWidth===ze.typicalHalfwidthCharacterWidth&&ae.pixelRatio===ze.pixelRatio&&ae.scrollBeyondLastLine===ze.scrollBeyondLastLine&&ae.minimap.enabled===ze.minimap.enabled&&ae.minimap.side===ze.minimap.side&&ae.minimap.size===ze.minimap.size&&ae.minimap.showSlider===ze.minimap.showSlider&&ae.minimap.renderCharacters===ze.minimap.renderCharacters&&ae.minimap.maxColumn===ze.minimap.maxColumn&&ae.minimap.scale===ze.minimap.scale&&ae.verticalScrollbarWidth===ze.verticalScrollbarWidth&&ae.isViewportWrapping===ze.isViewportWrapping,st=ae.lineHeight,pt=ae.typicalHalfwidthCharacterWidth,mt=ae.scrollBeyondLastLine,Ve=ae.minimap.renderCharacters;let ot=Me>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const _t=ae.minimap.maxColumn,nt=ae.minimap.size,lt=ae.minimap.side,Rt=ae.verticalScrollbarWidth,It=ae.viewLineCount,kt=ae.remainingWidth,dt=ae.isViewportWrapping,Ot=Ve?2:3;let Mt=Math.floor(Me*Se);const Ft=Mt/Me;let fe=!1,Ie=!1,ge=Ot*ot,ne=ot/Me,ye=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:Et,extraLinesBeyondLastLine:rt,desiredRatio:ut,minimapLineCount:wt}=X.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:mt,height:Se,lineHeight:st,pixelRatio:Me});if(It/wt>1)fe=!0,Ie=!0,ot=1,ge=1,ne=ot/Me;else{let ht=!1,Pt=ot+1;if(nt==="fit"){const Ut=Math.ceil((It+rt)*ge);dt&&Ye&&kt<=J.stableFitRemainingWidth?(ht=!0,Pt=J.stableFitMaxMinimapScale):ht=Ut>Mt}if(nt==="fill"||ht){fe=!0;const Ut=ot;ge=Math.min(st*Me,Math.max(1,Math.floor(1/ut))),dt&&Ye&&kt<=J.stableFitRemainingWidth&&(Pt=J.stableFitMaxMinimapScale),ot=Math.min(Pt,Math.max(1,Math.floor(ge/Ot))),ot>Ut&&(ye=Math.min(2,ot/Ut)),ne=ot/Me/ye,Mt=Math.ceil(Math.max(Et,It+rt)*ge),dt?(J.stableMinimapLayoutInput=ae,J.stableFitRemainingWidth=kt,J.stableFitMaxMinimapScale=ot):(J.stableMinimapLayoutInput=null,J.stableFitRemainingWidth=0)}}}const Le=Math.floor(_t*ne),xe=Math.min(Le,Math.max(0,Math.floor((kt-Rt-2)*ne/(pt+ne)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(Me*xe);const ct=Ge/Me;Ge=Math.floor(Ge*ye);const vt=Ve?1:2,St=lt==="left"?0:pe-xe-Rt;return{renderMinimap:vt,minimapLeft:St,minimapWidth:xe,minimapHeightIsEditorHeight:fe,minimapIsSampling:Ie,minimapScale:ot,minimapLineHeight:ge,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:ct,minimapCanvasOuterHeight:Ft}}static computeLayout(ae,J){const pe=J.outerWidth|0,Se=J.outerHeight|0,Me=J.lineHeight|0,ze=J.lineNumbersDigitCount|0,Ye=J.typicalHalfwidthCharacterWidth,st=J.maxDigitWidth,pt=J.pixelRatio,mt=J.viewLineCount,Ve=ae.get(123),ot=Ve==="inherit"?ae.get(122):Ve,_t=ot==="inherit"?ae.get(118):ot,nt=ae.get(121),lt=ae.get(2),Rt=J.isDominatedByLongLines,It=ae.get(50),kt=ae.get(60).renderType!==0,dt=ae.get(61),Ot=ae.get(94),Mt=ae.get(65),Ft=ae.get(92),fe=Ft.verticalScrollbarSize,Ie=Ft.verticalHasArrows,ge=Ft.arrowSize,ne=Ft.horizontalScrollbarSize,ye=ae.get(58),Le=ae.get(37);let xe;if(typeof ye=="string"&&/^\d+(\.\d+)?ch$/.test(ye)){const xt=parseFloat(ye.substr(0,ye.length-2));xe=a.clampedInt(xt*Ye,0,0,1e3)}else xe=a.clampedInt(ye,0,0,1e3);Le&&(xe+=16);let Ge=0;if(kt){const xt=Math.max(ze,dt);Ge=Math.round(xt*st)}let ct=0;It&&(ct=Me);let vt=0,St=vt+ct,Et=St+Ge,rt=Et+xe;const ut=pe-ct-Ge-xe;let wt=!1,Nt=!1,ht=-1;lt!==2&&(ot==="inherit"&&Rt?(wt=!0,Nt=!0):_t==="on"||_t==="bounded"?Nt=!0:_t==="wordWrapColumn"&&(ht=nt));const Pt=X._computeMinimapLayout({outerWidth:pe,outerHeight:Se,lineHeight:Me,typicalHalfwidthCharacterWidth:Ye,pixelRatio:pt,scrollBeyondLastLine:Ot,minimap:Mt,verticalScrollbarWidth:fe,viewLineCount:mt,remainingWidth:ut,isViewportWrapping:Nt},J.memory||new F);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(vt+=Pt.minimapWidth,St+=Pt.minimapWidth,Et+=Pt.minimapWidth,rt+=Pt.minimapWidth);const Ut=ut-Pt.minimapWidth,Ct=Math.max(1,Math.floor((Ut-fe-2)/Ye)),Bt=Ie?ge:0;return Nt&&(ht=Math.max(1,Ct),_t==="bounded"&&(ht=Math.min(ht,nt))),{width:pe,height:Se,glyphMarginLeft:vt,glyphMarginWidth:ct,lineNumbersLeft:St,lineNumbersWidth:Ge,decorationsLeft:Et,decorationsWidth:xe,contentLeft:rt,contentWidth:Ut,minimap:Pt,viewportColumn:Ct,isWordWrapMinified:wt,isViewportWrapping:Nt,wrappingColumn:ht,verticalScrollbarWidth:fe,horizontalScrollbarHeight:ne,overviewRuler:{top:Bt,width:fe,height:Se-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=X;class V extends D{constructor(){const ae={enabled:!0};super(57,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:h.localize(43,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:w(ae.enabled,this.defaultValue.enabled)}}}class Z extends D{constructor(){const ae={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"boolean",default:ae.enabled,description:h.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:h.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:h.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:w(J.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(J.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(J.fontFamily,this.defaultValue.fontFamily)}}}class se extends c{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>c.clamp(ae,0,150),{markdownDescription:h.localize(47,null)})}compute(ae,J,pe){return ae.fontInfo.lineHeight}}class ce extends D{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:h.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(49,null),h.localize(50,null),h.localize(51,null)],default:ae.size,description:h.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:h.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:h.localize(54,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:h.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:h.localize(57,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:w(J.enabled,this.defaultValue.enabled),size:s(J.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(J.side,this.defaultValue.side,["right","left"]),showSlider:s(J.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(J.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(J.scale,1,1,3),maxColumn:a.clampedInt(J.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(ie){return ie==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends D{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(59,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{top:a.clampedInt(J.top,0,0,1e3),bottom:a.clampedInt(J.bottom,0,0,1e3)}}}class oe extends D{constructor(){const ae={enabled:!0,cycle:!1};super(76,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:h.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:h.localize(61,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:w(J.enabled,this.defaultValue.enabled),cycle:w(J.cycle,this.defaultValue.cycle)}}}class de extends f{constructor(){super(129)}compute(ae,J,pe){return ae.pixelRatio}}class ve extends D{constructor(){const ae={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",ae,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ae.strings,description:h.localize(62,null)},comments:{type:"boolean",default:ae.comments,description:h.localize(63,null)},other:{type:"boolean",default:ae.other,description:h.localize(64,null)}}}],default:ae,description:h.localize(65,null)});this.defaultValue=ae}validate(ae){if(typeof ae=="boolean")return ae;if(ae&&typeof ae=="object"){const J=ae,pe={other:w(J.other,this.defaultValue.other),comments:w(J.comments,this.defaultValue.comments),strings:w(J.strings,this.defaultValue.strings)};return pe.other&&pe.comments&&pe.strings?!0:!pe.other&&!pe.comments&&!pe.strings?!1:pe}return this.defaultValue}}var ke;(function(ie){ie[ie.Off=0]="Off",ie[ie.On=1]="On",ie[ie.Relative=2]="Relative",ie[ie.Interval=3]="Interval",ie[ie.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends D{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(66,null),h.localize(67,null),h.localize(68,null),h.localize(69,null)],default:"on",description:h.localize(70,null)})}validate(ae){let J=this.defaultValue.renderType,pe=this.defaultValue.renderFn;return typeof ae!="undefined"&&(typeof ae=="function"?(J=4,pe=ae):ae==="interval"?J=3:ae==="relative"?J=2:ae==="on"?J=1:J=0),{renderType:J,renderFn:pe}}}function _e(ie){const ae=ie.get(87);return ae==="editable"?ie.get(81):ae!=="on"}e.filterValidationDecorations=_e;class Ee extends D{constructor(){const ae=[],J={type:"number",description:h.localize(71,null)};super(91,"rulers",ae,{type:"array",items:{anyOf:[J,{type:["object"],properties:{column:J,color:{type:"string",description:h.localize(72,null),format:"color-hex"}}}]},default:ae,description:h.localize(73,null)})}validate(ae){if(Array.isArray(ae)){const J=[];for(let pe of ae)if(typeof pe=="number")J.push({column:a.clampedInt(pe,0,0,1e4),color:null});else if(pe&&typeof pe=="object"){const Se=pe;J.push({column:a.clampedInt(Se.column,0,0,1e4),color:Se.color})}return J.sort((pe,Se)=>pe.column-Se.column),J}return this.defaultValue}}function z(ie,ae){if(typeof ie!="string")return ae;switch(ie){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends D{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(74,null),h.localize(75,null),h.localize(76,null)],default:"auto",description:h.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(78,null),h.localize(79,null),h.localize(80,null)],default:"auto",description:h.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:h.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:h.localize(84,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae,pe=a.clampedInt(J.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Se=a.clampedInt(J.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(J.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(J.vertical,this.defaultValue.vertical),horizontal:z(J.horizontal,this.defaultValue.horizontal),useShadows:w(J.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(J.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(J.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(J.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(J.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:pe,horizontalSliderSize:a.clampedInt(J.horizontalSliderSize,pe,0,1e3),verticalScrollbarSize:Se,verticalSliderSize:a.clampedInt(J.verticalSliderSize,Se,0,1e3),scrollByPage:w(J.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class N extends D{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:h.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:h.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:h.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:h.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:h.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:h.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:h.localize(91,null)}})}applyUpdate(ae,J){let pe=!1;J.allowedCharacters&&(S.equals(ae.allowedCharacters,J.allowedCharacters)||(ae={...ae,allowedCharacters:J.allowedCharacters},pe=!0)),J.allowedLocales&&(S.equals(ae.allowedLocales,J.allowedLocales)||(ae={...ae,allowedLocales:J.allowedLocales},pe=!0));const Se=super.applyUpdate(ae,J);return pe?new g(Se.newValue,!0):Se}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{nonBasicASCII:he(J.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:w(J.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:w(J.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(J.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(J.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ae.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ae,J){if(typeof ae!="object"||!ae)return J;const pe={};for(const[Se,Me]of Object.entries(ae))Me===!0&&(pe[Se]=!0);return pe}}class $ extends D{constructor(){const ae={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:h.localize(92,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:w(J.enabled,this.defaultValue.enabled),mode:s(J.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class j extends D{constructor(){const ae={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,description:h.localize(93,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:w(ae.enabled,this.defaultValue.enabled)}}}class re extends D{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(94,null),h.localize(95,null),h.localize(96,null)],default:ae.bracketPairs,description:h.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(98,null),h.localize(99,null),h.localize(100,null)],default:ae.bracketPairsHorizontal,description:h.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:h.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:h.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ae.highlightActiveIndentation,description:h.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{bracketPairs:he(J.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(J.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:w(J.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:w(J.indentation,this.defaultValue.indentation),highlightActiveIndentation:w(J.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function he(ie,ae,J){const pe=J.indexOf(ie);return pe===-1?ae:J[pe]}class Ce extends D{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(105,null),h.localize(106,null)],default:ae.insertMode,description:h.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:h.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:h.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:h.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:h.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:h.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:h.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:h.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:h.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(146,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{insertMode:s(J.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(J.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(J.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(J.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(J.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:w(J.showIcons,this.defaultValue.showIcons),showStatusBar:w(J.showStatusBar,this.defaultValue.showStatusBar),preview:w(J.preview,this.defaultValue.preview),previewMode:s(J.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:w(J.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(J.showMethods,this.defaultValue.showMethods),showFunctions:w(J.showFunctions,this.defaultValue.showFunctions),showConstructors:w(J.showConstructors,this.defaultValue.showConstructors),showDeprecated:w(J.showDeprecated,this.defaultValue.showDeprecated),showFields:w(J.showFields,this.defaultValue.showFields),showVariables:w(J.showVariables,this.defaultValue.showVariables),showClasses:w(J.showClasses,this.defaultValue.showClasses),showStructs:w(J.showStructs,this.defaultValue.showStructs),showInterfaces:w(J.showInterfaces,this.defaultValue.showInterfaces),showModules:w(J.showModules,this.defaultValue.showModules),showProperties:w(J.showProperties,this.defaultValue.showProperties),showEvents:w(J.showEvents,this.defaultValue.showEvents),showOperators:w(J.showOperators,this.defaultValue.showOperators),showUnits:w(J.showUnits,this.defaultValue.showUnits),showValues:w(J.showValues,this.defaultValue.showValues),showConstants:w(J.showConstants,this.defaultValue.showConstants),showEnums:w(J.showEnums,this.defaultValue.showEnums),showEnumMembers:w(J.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(J.showKeywords,this.defaultValue.showKeywords),showWords:w(J.showWords,this.defaultValue.showWords),showColors:w(J.showColors,this.defaultValue.showColors),showFiles:w(J.showFiles,this.defaultValue.showFiles),showReferences:w(J.showReferences,this.defaultValue.showReferences),showFolders:w(J.showFolders,this.defaultValue.showFolders),showTypeParameters:w(J.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(J.showSnippets,this.defaultValue.showSnippets),showUsers:w(J.showUsers,this.defaultValue.showUsers),showIssues:w(J.showIssues,this.defaultValue.showIssues)}}}class Ae extends D{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(147,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class We extends f{constructor(){super(130)}compute(ae,J,pe){return J.get(81)?!0:ae.tabFocusMode}}var $e;(function(ie){ie[ie.None=0]="None",ie[ie.Same=1]="Same",ie[ie.Indent=2]="Indent",ie[ie.DeepIndent=3]="DeepIndent"})($e=e.WrappingIndent||(e.WrappingIndent={}));function je(ie){switch(ie){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends f{constructor(){super(132)}compute(ae,J,pe){const Se=J.get(131);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Se.isWordWrapMinified,isViewportWrapping:Se.isViewportWrapping,wrappingColumn:Se.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Qe:t.isLinux?et:Ue,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ie){return e.editorOptionsRegistry[ie.id]=ie,ie}var tt;(function(ie){ie[ie.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ie[ie.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ie[ie.accessibilitySupport=2]="accessibilitySupport",ie[ie.accessibilityPageSize=3]="accessibilityPageSize",ie[ie.ariaLabel=4]="ariaLabel",ie[ie.autoClosingBrackets=5]="autoClosingBrackets",ie[ie.autoClosingDelete=6]="autoClosingDelete",ie[ie.autoClosingOvertype=7]="autoClosingOvertype",ie[ie.autoClosingQuotes=8]="autoClosingQuotes",ie[ie.autoIndent=9]="autoIndent",ie[ie.automaticLayout=10]="automaticLayout",ie[ie.autoSurround=11]="autoSurround",ie[ie.bracketPairColorization=12]="bracketPairColorization",ie[ie.guides=13]="guides",ie[ie.codeLens=14]="codeLens",ie[ie.codeLensFontFamily=15]="codeLensFontFamily",ie[ie.codeLensFontSize=16]="codeLensFontSize",ie[ie.colorDecorators=17]="colorDecorators",ie[ie.columnSelection=18]="columnSelection",ie[ie.comments=19]="comments",ie[ie.contextmenu=20]="contextmenu",ie[ie.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ie[ie.cursorBlinking=22]="cursorBlinking",ie[ie.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ie[ie.cursorStyle=24]="cursorStyle",ie[ie.cursorSurroundingLines=25]="cursorSurroundingLines",ie[ie.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ie[ie.cursorWidth=27]="cursorWidth",ie[ie.disableLayerHinting=28]="disableLayerHinting",ie[ie.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ie[ie.domReadOnly=30]="domReadOnly",ie[ie.dragAndDrop=31]="dragAndDrop",ie[ie.emptySelectionClipboard=32]="emptySelectionClipboard",ie[ie.extraEditorClassName=33]="extraEditorClassName",ie[ie.fastScrollSensitivity=34]="fastScrollSensitivity",ie[ie.find=35]="find",ie[ie.fixedOverflowWidgets=36]="fixedOverflowWidgets",ie[ie.folding=37]="folding",ie[ie.foldingStrategy=38]="foldingStrategy",ie[ie.foldingHighlight=39]="foldingHighlight",ie[ie.foldingImportsByDefault=40]="foldingImportsByDefault",ie[ie.foldingMaximumRegions=41]="foldingMaximumRegions",ie[ie.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ie[ie.fontFamily=43]="fontFamily",ie[ie.fontInfo=44]="fontInfo",ie[ie.fontLigatures=45]="fontLigatures",ie[ie.fontSize=46]="fontSize",ie[ie.fontWeight=47]="fontWeight",ie[ie.formatOnPaste=48]="formatOnPaste",ie[ie.formatOnType=49]="formatOnType",ie[ie.glyphMargin=50]="glyphMargin",ie[ie.gotoLocation=51]="gotoLocation",ie[ie.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ie[ie.hover=53]="hover",ie[ie.inDiffEditor=54]="inDiffEditor",ie[ie.inlineSuggest=55]="inlineSuggest",ie[ie.letterSpacing=56]="letterSpacing",ie[ie.lightbulb=57]="lightbulb",ie[ie.lineDecorationsWidth=58]="lineDecorationsWidth",ie[ie.lineHeight=59]="lineHeight",ie[ie.lineNumbers=60]="lineNumbers",ie[ie.lineNumbersMinChars=61]="lineNumbersMinChars",ie[ie.linkedEditing=62]="linkedEditing",ie[ie.links=63]="links",ie[ie.matchBrackets=64]="matchBrackets",ie[ie.minimap=65]="minimap",ie[ie.mouseStyle=66]="mouseStyle",ie[ie.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ie[ie.mouseWheelZoom=68]="mouseWheelZoom",ie[ie.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ie[ie.multiCursorModifier=70]="multiCursorModifier",ie[ie.multiCursorPaste=71]="multiCursorPaste",ie[ie.occurrencesHighlight=72]="occurrencesHighlight",ie[ie.overviewRulerBorder=73]="overviewRulerBorder",ie[ie.overviewRulerLanes=74]="overviewRulerLanes",ie[ie.padding=75]="padding",ie[ie.parameterHints=76]="parameterHints",ie[ie.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ie[ie.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ie[ie.quickSuggestions=79]="quickSuggestions",ie[ie.quickSuggestionsDelay=80]="quickSuggestionsDelay",ie[ie.readOnly=81]="readOnly",ie[ie.renameOnType=82]="renameOnType",ie[ie.renderControlCharacters=83]="renderControlCharacters",ie[ie.renderFinalNewline=84]="renderFinalNewline",ie[ie.renderLineHighlight=85]="renderLineHighlight",ie[ie.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ie[ie.renderValidationDecorations=87]="renderValidationDecorations",ie[ie.renderWhitespace=88]="renderWhitespace",ie[ie.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ie[ie.roundedSelection=90]="roundedSelection",ie[ie.rulers=91]="rulers",ie[ie.scrollbar=92]="scrollbar",ie[ie.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ie[ie.scrollBeyondLastLine=94]="scrollBeyondLastLine",ie[ie.scrollPredominantAxis=95]="scrollPredominantAxis",ie[ie.selectionClipboard=96]="selectionClipboard",ie[ie.selectionHighlight=97]="selectionHighlight",ie[ie.selectOnLineNumbers=98]="selectOnLineNumbers",ie[ie.showFoldingControls=99]="showFoldingControls",ie[ie.showUnused=100]="showUnused",ie[ie.snippetSuggestions=101]="snippetSuggestions",ie[ie.smartSelect=102]="smartSelect",ie[ie.smoothScrolling=103]="smoothScrolling",ie[ie.stickyTabStops=104]="stickyTabStops",ie[ie.stopRenderingLineAfter=105]="stopRenderingLineAfter",ie[ie.suggest=106]="suggest",ie[ie.suggestFontSize=107]="suggestFontSize",ie[ie.suggestLineHeight=108]="suggestLineHeight",ie[ie.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ie[ie.suggestSelection=110]="suggestSelection",ie[ie.tabCompletion=111]="tabCompletion",ie[ie.tabIndex=112]="tabIndex",ie[ie.unicodeHighlighting=113]="unicodeHighlighting",ie[ie.unusualLineTerminators=114]="unusualLineTerminators",ie[ie.useShadowDOM=115]="useShadowDOM",ie[ie.useTabStops=116]="useTabStops",ie[ie.wordSeparators=117]="wordSeparators",ie[ie.wordWrap=118]="wordWrap",ie[ie.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ie[ie.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ie[ie.wordWrapColumn=121]="wordWrapColumn",ie[ie.wordWrapOverride1=122]="wordWrapOverride1",ie[ie.wordWrapOverride2=123]="wordWrapOverride2",ie[ie.wrappingIndent=124]="wrappingIndent",ie[ie.wrappingStrategy=125]="wrappingStrategy",ie[ie.showDeprecated=126]="showDeprecated",ie[ie.inlayHints=127]="inlayHints",ie[ie.editorClassName=128]="editorClassName",ie[ie.pixelRatio=129]="pixelRatio",ie[ie.tabFocusMode=130]="tabFocusMode",ie[ie.layoutInfo=131]="layoutInfo",ie[ie.wrappingInfo=132]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new y(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(148,null)})),acceptSuggestionOnEnter:Re(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(149,null),""],markdownDescription:h.localize(150,null)})),accessibilitySupport:Re(new i),accessibilityPageSize:Re(new a(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(151,null)})),ariaLabel:Re(new m(4,"ariaLabel",h.localize(152,null))),autoClosingBrackets:Re(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(153,null),h.localize(154,null),""],description:h.localize(155,null)})),autoClosingDelete:Re(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(156,null),""],description:h.localize(157,null)})),autoClosingOvertype:Re(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(158,null),""],description:h.localize(159,null)})),autoClosingQuotes:Re(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(160,null),h.localize(161,null),""],description:h.localize(162,null)})),autoIndent:Re(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[h.localize(163,null),h.localize(164,null),h.localize(165,null),h.localize(166,null),h.localize(167,null)],description:h.localize(168,null)})),automaticLayout:Re(new y(10,"automaticLayout",!1)),autoSurround:Re(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(169,null),h.localize(170,null),h.localize(171,null),""],description:h.localize(172,null)})),bracketPairColorization:Re(new j),bracketPairGuides:Re(new re),stickyTabStops:Re(new y(104,"stickyTabStops",!1,{description:h.localize(173,null)})),codeLens:Re(new y(14,"codeLens",!0,{description:h.localize(174,null)})),codeLensFontFamily:Re(new m(15,"codeLensFontFamily","",{description:h.localize(175,null)})),codeLensFontSize:Re(new a(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(176,null)})),colorDecorators:Re(new y(17,"colorDecorators",!0,{description:h.localize(177,null)})),columnSelection:Re(new y(18,"columnSelection",!1,{description:h.localize(178,null)})),comments:Re(new r),contextmenu:Re(new y(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new y(21,"copyWithSyntaxHighlighting",!0,{description:h.localize(179,null)})),cursorBlinking:Re(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:h.localize(180,null)})),cursorSmoothCaretAnimation:Re(new y(23,"cursorSmoothCaretAnimation",!1,{description:h.localize(181,null)})),cursorStyle:Re(new o(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:h.localize(182,null)})),cursorSurroundingLines:Re(new a(25,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(183,null)})),cursorSurroundingLinesStyle:Re(new b(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(184,null),h.localize(185,null)],description:h.localize(186,null)})),cursorWidth:Re(new a(27,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(187,null)})),disableLayerHinting:Re(new y(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new y(29,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new y(30,"domReadOnly",!1)),dragAndDrop:Re(new y(31,"dragAndDrop",!0,{description:h.localize(188,null)})),emptySelectionClipboard:Re(new L),extraEditorClassName:Re(new m(33,"extraEditorClassName","")),fastScrollSensitivity:Re(new c(34,"fastScrollSensitivity",5,ie=>ie<=0?5:ie,{markdownDescription:h.localize(189,null)})),find:Re(new _),fixedOverflowWidgets:Re(new y(36,"fixedOverflowWidgets",!1)),folding:Re(new y(37,"folding",!0,{description:h.localize(190,null)})),foldingStrategy:Re(new b(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(191,null),h.localize(192,null)],description:h.localize(193,null)})),foldingHighlight:Re(new y(39,"foldingHighlight",!0,{description:h.localize(194,null)})),foldingImportsByDefault:Re(new y(40,"foldingImportsByDefault",!1,{description:h.localize(195,null)})),foldingMaximumRegions:Re(new a(41,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(196,null)})),unfoldOnClickAfterEndOfLine:Re(new y(42,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(197,null)})),fontFamily:Re(new m(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(198,null)})),fontInfo:Re(new M),fontLigatures2:Re(new U),fontSize:Re(new q),fontWeight:Re(new K),formatOnPaste:Re(new y(48,"formatOnPaste",!1,{description:h.localize(199,null)})),formatOnType:Re(new y(49,"formatOnType",!1,{description:h.localize(200,null)})),glyphMargin:Re(new y(50,"glyphMargin",!0,{description:h.localize(201,null)})),gotoLocation:Re(new x),hideCursorInOverviewRuler:Re(new y(52,"hideCursorInOverviewRuler",!1,{description:h.localize(202,null)})),hover:Re(new B),inDiffEditor:Re(new y(54,"inDiffEditor",!1)),letterSpacing:Re(new c(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ie=>c.clamp(ie,-5,20),{description:h.localize(203,null)})),lightbulb:Re(new V),lineDecorationsWidth:Re(new u(58,"lineDecorationsWidth",10)),lineHeight:Re(new se),lineNumbers:Re(new Ne),lineNumbersMinChars:Re(new a(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new y(62,"linkedEditing",!1,{description:h.localize(204,null)})),links:Re(new y(63,"links",!0,{description:h.localize(205,null)})),matchBrackets:Re(new b(64,"matchBrackets","always",["always","near","never"],{description:h.localize(206,null)})),minimap:Re(new ce),mouseStyle:Re(new b(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new c(67,"mouseWheelScrollSensitivity",1,ie=>ie===0?1:ie,{markdownDescription:h.localize(207,null)})),mouseWheelZoom:Re(new y(68,"mouseWheelZoom",!1,{markdownDescription:h.localize(208,null)})),multiCursorMergeOverlapping:Re(new y(69,"multiCursorMergeOverlapping",!0,{description:h.localize(209,null)})),multiCursorModifier:Re(new o(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[h.localize(210,null),h.localize(211,null)],markdownDescription:h.localize(212,null)})),multiCursorPaste:Re(new b(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(213,null),h.localize(214,null)],markdownDescription:h.localize(215,null)})),occurrencesHighlight:Re(new y(72,"occurrencesHighlight",!0,{description:h.localize(216,null)})),overviewRulerBorder:Re(new y(73,"overviewRulerBorder",!0,{description:h.localize(217,null)})),overviewRulerLanes:Re(new a(74,"overviewRulerLanes",3,0,3)),padding:Re(new Q),parameterHints:Re(new oe),peekWidgetDefaultFocus:Re(new b(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(218,null),h.localize(219,null)],description:h.localize(220,null)})),definitionLinkOpensInPeek:Re(new y(78,"definitionLinkOpensInPeek",!1,{description:h.localize(221,null)})),quickSuggestions:Re(new ve),quickSuggestionsDelay:Re(new a(80,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(222,null)})),readOnly:Re(new y(81,"readOnly",!1)),renameOnType:Re(new y(82,"renameOnType",!1,{description:h.localize(223,null),markdownDeprecationMessage:h.localize(224,null)})),renderControlCharacters:Re(new y(83,"renderControlCharacters",!0,{description:h.localize(225,null),restricted:!0})),renderFinalNewline:Re(new y(84,"renderFinalNewline",!0,{description:h.localize(226,null)})),renderLineHighlight:Re(new b(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(227,null)],description:h.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Re(new y(86,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(229,null)})),renderValidationDecorations:Re(new b(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new b(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(230,null),h.localize(231,null),h.localize(232,null),""],description:h.localize(233,null)})),revealHorizontalRightPadding:Re(new a(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Re(new y(90,"roundedSelection",!0,{description:h.localize(234,null)})),rulers:Re(new Ee),scrollbar:Re(new W),scrollBeyondLastColumn:Re(new a(93,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(235,null)})),scrollBeyondLastLine:Re(new y(94,"scrollBeyondLastLine",!0,{description:h.localize(236,null)})),scrollPredominantAxis:Re(new y(95,"scrollPredominantAxis",!0,{description:h.localize(237,null)})),selectionClipboard:Re(new y(96,"selectionClipboard",!0,{description:h.localize(238,null),included:t.isLinux})),selectionHighlight:Re(new y(97,"selectionHighlight",!0,{description:h.localize(239,null)})),selectOnLineNumbers:Re(new y(98,"selectOnLineNumbers",!0)),showFoldingControls:Re(new b(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(240,null),h.localize(241,null)],description:h.localize(242,null)})),showUnused:Re(new y(100,"showUnused",!0,{description:h.localize(243,null)})),showDeprecated:Re(new y(126,"showDeprecated",!0,{description:h.localize(244,null)})),inlayHints:Re(new Z),snippetSuggestions:Re(new b(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(245,null),h.localize(246,null),h.localize(247,null),h.localize(248,null)],description:h.localize(249,null)})),smartSelect:Re(new Ae),smoothScrolling:Re(new y(103,"smoothScrolling",!1,{description:h.localize(250,null)})),stopRenderingLineAfter:Re(new a(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Ce),inlineSuggest:Re(new $),suggestFontSize:Re(new a(107,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(251,null)})),suggestLineHeight:Re(new a(108,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(252,null)})),suggestOnTriggerCharacters:Re(new y(109,"suggestOnTriggerCharacters",!0,{description:h.localize(253,null)})),suggestSelection:Re(new b(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(254,null),h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),tabCompletion:Re(new b(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(258,null),h.localize(259,null),h.localize(260,null)],description:h.localize(261,null)})),tabIndex:Re(new a(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new N),unusualLineTerminators:Re(new b(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(262,null),h.localize(263,null),h.localize(264,null)],description:h.localize(265,null)})),useShadowDOM:Re(new y(115,"useShadowDOM",!0)),useTabStops:Re(new y(116,"useTabStops",!0,{description:h.localize(266,null)})),wordSeparators:Re(new m(117,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:h.localize(267,null)})),wordWrap:Re(new b(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(268,null),h.localize(269,null),h.localize(270,null),h.localize(271,null)],description:h.localize(272,null)})),wordWrapBreakAfterCharacters:Re(new m(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new m(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new a(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(273,null)})),wordWrapOverride1:Re(new b(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new b(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Re(new o(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[h.localize(274,null),h.localize(275,null),h.localize(276,null),h.localize(277,null)],description:h.localize(278,null)})),wrappingStrategy:Re(new b(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(279,null),h.localize(280,null)],description:h.localize(281,null)})),editorClassName:Re(new O),pixelRatio:Re(new de),tabFocusMode:Re(new We),layoutInfo:Re(new X),wrappingInfo:Re(new He)}}),define(we[161],be([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[162],be([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[163],be([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[164],be([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(we[165],be([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(we[166],be([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(we[167],be([19,20]),function(te,e){return te.create("vs/platform/workspaces/common/workspaces",e)}),define(we[168],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[169],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[170],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(we[171],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[172],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[173],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[174],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[175],be([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(we[176],be([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(we[177],be([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(we[178],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[179],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(we[180],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(we[181],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[182],be([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[183],be([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(we[184],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(S){S[S.ACTIVATE=1]="ACTIVATE",S[S.RESTORE=2]="RESTORE",S[S.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var t;(function(S){S[S.PICK=0]="PICK",S[S.DISABLED=1]="DISABLED",S[S.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var k;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[185],be([1,0,163]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function A(g){return g=g.trim(),g==="*"||t.test(g)}e.isValidVersionStr=A;function S(g){if(!A(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=g.match(t);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=S;function P(g){if(!g)return null;let E=g.majorBase,f=g.majorMustEqual,u=g.minorBase,w=g.minorMustEqual,y=g.patchBase,I=g.patchMustEqual;g.hasCaret&&(E===0||(w=!1),I=!1);let a=0;if(g.preRelease){const c=k.exec(g.preRelease);if(c){const[,m,s,b]=c;a=Date.UTC(Number(m),Number(s)-1,Number(b))}}return{majorBase:E,majorMustEqual:f,minorBase:u,minorMustEqual:w,patchBase:y,patchMustEqual:I,isMinimum:g.hasGreaterEquals,notBefore:a}}e.normalizeVersion=P;function C(g,E,f){let u;typeof g=="string"?u=P(S(g)):u=g;let w;E instanceof Date?w=E.getTime():typeof E=="string"&&(w=new Date(E).getTime());let y;if(typeof f=="string"?y=P(S(f)):y=f,!u||!y)return!1;let I=u.majorBase,a=u.minorBase,c=u.patchBase,m=y.majorBase,s=y.minorBase,b=y.patchBase,o=y.notBefore,n=y.majorMustEqual,i=y.minorMustEqual,r=y.patchMustEqual;return y.isMinimum?I>m?!0:I<m?!1:a>s?!0:a<s||w&&w<o?!1:c>=b:(I===1&&m===0&&(!n||!i||!r)&&(m=1,s=0,b=0,n=!0,i=!1,r=!1),I<m?!1:I>m?!n:a<s?!1:a>s?!i:c<b?!1:c>b?!r:!(w&&w<o))}e.isValidVersion=C;function T(g,E,f,u){return f.isBuiltin||typeof f.main=="undefined"?!0:D(g,E,f.engines.vscode,u)}e.isValidExtensionVersion=T;function F(g,E,f){return g==="*"||D(E,f,g)}e.isEngineValid=F;function D(g,E,f,u=[]){let w=P(S(f));if(!w)return u.push(h.localize(0,null,f)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return u.push(h.localize(1,null,f)),!1}else if(!w.majorMustEqual)return u.push(h.localize(2,null,f)),!1;return C(g,E,w)?!0:(u.push(h.localize(3,null,g,f)),!1)}}),define(we[116],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(k,A=[],S=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=h}),define(we[61],be([1,0,116]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(S,P,C){P instanceof h.SyncDescriptor||(P=new h.SyncDescriptor(P,[],C)),t.push([S,P])}e.registerSingleton=k;function A(){return t}e.getSingletonServiceDescriptors=A}),define(we[186],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=h;class t{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let S of this._nodes.values())S.outgoing.size===0&&A.push(S);return A}insertEdge(A,S){const P=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(S);P.outgoing.set(this._hashFn(S),C),C.incoming.set(this._hashFn(A),P)}removeNode(A){const S=this._hashFn(A);this._nodes.delete(S);for(let P of this._nodes.values())P.outgoing.delete(S),P.incoming.delete(S)}lookupOrInsertNode(A){const S=this._hashFn(A);let P=this._nodes.get(S);return P||(P=new h(A),this._nodes.set(S,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[S,P]of this._nodes)A.push(`${S}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,S]of this._nodes){const P=new Set([A]),C=this._findCycle(S,P);if(C)return C}}_findCycle(A,S){for(let[P,C]of A.outgoing){if(S.has(P))return[...S,P].join(" -> ");S.add(P);const T=this._findCycle(C,S);if(T)return T;S.delete(P)}}}e.Graph=t}),define(we[4],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function P(C){return C[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=P})(h=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(S,P,C,T){P[h.DI_TARGET]===P?P[h.DI_DEPENDENCIES].push({id:S,index:C,optional:T}):(P[h.DI_DEPENDENCIES]=[{id:S,index:C,optional:T}],P[h.DI_TARGET]=P)}function k(S){if(h.serviceIds.has(S))return h.serviceIds.get(S);const P=function(C,T,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,C,F,!1)};return P.toString=()=>S,h.serviceIds.set(S,P),P}e.createDecorator=k;function A(S){return S}e.refineServiceDecorator=A}),define(we[117],be([1,0,18,2,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationOverrides=A;function S(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||h.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=S;var P;(function(w){w[w.USER=1]="USER",w[w.USER_LOCAL=2]="USER_LOCAL",w[w.USER_REMOTE=3]="USER_REMOTE",w[w.WORKSPACE=4]="WORKSPACE",w[w.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",w[w.DEFAULT=6]="DEFAULT",w[w.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(w){switch(w){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function T(w,y){const I=Object.create(null);for(let a in w)F(I,a,w[a],y);return I}e.toValuesTree=T;function F(w,y,I,a){const c=y.split("."),m=c.pop();let s=w;for(let b=0;b<c.length;b++){let o=c[b],n=s[o];switch(typeof n){case"undefined":n=s[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${y} as ${c.slice(0,b+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[m]=I}catch{a(`Ignoring ${y} as ${c.join(".")} is ${JSON.stringify(s)}`)}else a(`Ignoring ${y} as ${c.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=F;function D(w,y){const I=y.split(".");g(w,I)}e.removeFromValueTree=D;function g(w,y){const I=y.shift();if(y.length===0){delete w[I];return}if(Object.keys(w).indexOf(I)!==-1){const a=w[I];typeof a=="object"&&!Array.isArray(a)&&(g(a,y),Object.keys(a).length===0&&delete w[I])}}function E(w,y,I){function a(s,b){let o=s;for(const n of b){if(typeof o!="object"||o===null)return;o=o[n]}return o}const c=y.split("."),m=a(w,c);return typeof m=="undefined"?I:m}e.getConfigurationValue=E;function f(w,y,I){Object.keys(y).forEach(a=>{a!=="__proto__"&&(a in w?h.isObject(w[a])&&h.isObject(y[a])?f(w[a],y[a],I):I&&(w[a]=y[a]):w[a]=y[a])})}e.merge=f;function u(w,y,I){const a=w.inspect(y),c=w.inspect(I);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:a.defaultValue}e.getMigratedSettingValue=u}),define(we[62],be([1,0,12,8,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",h.isMacintosh),A.set("isLinux",h.isLinux),A.set("isWindows",h.isWindows),A.set("isWeb",h.isWeb),A.set("isMacNative",h.isMacintosh&&!h.isWeb),A.set("isEdge",h.isEdge),A.set("isFirefox",h.isFirefox),A.set("isChrome",h.isChrome),A.set("isSafari",h.isSafari);const S=Object.prototype.hasOwnProperty;var P;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return D.INSTANCE}static true(){return g.INSTANCE}static has(_){return E.create(_)}static equals(_,U){return f.create(_,U)}static notEquals(_,U){return y.create(_,U)}static regex(_,U){return o.create(_,U)}static in(_,U){return u.create(_,U)}static not(_){return I.create(_)}static and(..._){return r.create(_,null)}static or(..._){return l.create(_,null,!0)}static greater(_,U){return c.create(_,U)}static greaterEquals(_,U){return m.create(_,U)}static smaller(_,U){return s.create(_,U)}static smallerEquals(_,U){return b.create(_,U)}static deserialize(_,U=!1){if(!!_)return this._deserializeOrExpression(_,U)}static _deserializeOrExpression(_,U){let M=_.split("||");return l.create(M.map(q=>this._deserializeAndExpression(q,U)),null,!0)}static _deserializeAndExpression(_,U){let M=_.split("&&");return r.create(M.map(q=>this._deserializeOne(q,U)),null)}static _deserializeOne(_,U){if(_=_.trim(),_.indexOf("!=")>=0){let M=_.split("!=");return y.create(M[0].trim(),this._deserializeValue(M[1],U))}if(_.indexOf("==")>=0){let M=_.split("==");return f.create(M[0].trim(),this._deserializeValue(M[1],U))}if(_.indexOf("=~")>=0){let M=_.split("=~");return o.create(M[0].trim(),this._deserializeRegexValue(M[1],U))}if(_.indexOf(" in ")>=0){let M=_.split(" in ");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const M=_.split(">=");return m.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const M=_.split(">");return c.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const M=_.split("<=");return b.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const M=_.split("<");return s.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(_)?I.create(_.substr(1).trim()):E.create(_)}static _deserializeValue(_,U){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let M=/^'([^']*)'$/.exec(_);return M?M[1].trim():_}static _deserializeRegexValue(_,U){if((0,t.isFalsyOrWhitespace)(_)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=_.indexOf("/"),q=_.lastIndexOf("/");if(M===q||M<0){if(U)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let K=_.slice(M+1,q),x=_[q+1]==="i"?"i":"";try{return new RegExp(K,x)}catch(B){if(U)throw new Error(`bad regexp-value '${_}', parse error: ${B}`);return console.warn(`bad regexp-value '${_}', parse error: ${B}`),null}}}e.ContextKeyExpr=C;function T(L,_){const U=L?L.substituteConstants():void 0,M=_?_.substituteConstants():void 0;return!U&&!M?!0:!U||!M?!1:U.equals(M)}e.expressionsAreEqualWithConstantSubstitution=T;function F(L,_){return L.cmp(_)}class D{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class g{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class E{constructor(_,U){this.key=_,this.negated=U,this.type=2}static create(_,U=null){const M=A.get(_);return typeof M=="boolean"?M?g.INSTANCE:D.INSTANCE:new E(_,U)}cmp(_){return _.type!==this.type?this.type-_.type:d(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=A.get(this.key);return typeof _=="boolean"?_?g.INSTANCE:D.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class f{constructor(_,U,M){this.key=_,this.value=U,this.negated=M,this.type=4}static create(_,U,M=null){if(typeof U=="boolean")return U?E.create(_,M):I.create(_,M);const q=A.get(_);return typeof q=="boolean"?U===(q?"true":"false")?g.INSTANCE:D.INSTANCE:new f(_,U,M)}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=A.get(this.key);if(typeof _=="boolean"){const U=_?"true":"false";return this.value===U?g.INSTANCE:D.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class u{constructor(_,U){this.key=_,this.valueKey=U,this.type=10,this.negated=null}static create(_,U){return new u(_,U)}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const U=_.getValue(this.valueKey),M=_.getValue(this.key);return Array.isArray(U)?U.indexOf(M)>=0:typeof M=="string"&&typeof U=="object"&&U!==null?S.call(U,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=u;class w{constructor(_){this._actual=_,this.type=11}static create(_){return new w(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new w(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class y{constructor(_,U,M){this.key=_,this.value=U,this.negated=M,this.type=5}static create(_,U,M=null){if(typeof U=="boolean")return U?I.create(_,M):E.create(_,M);const q=A.get(_);return typeof q=="boolean"?U===(q?"true":"false")?D.INSTANCE:g.INSTANCE:new y(_,U,M)}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=A.get(this.key);if(typeof _=="boolean"){const U=_?"true":"false";return this.value===U?D.INSTANCE:g.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class I{constructor(_,U){this.key=_,this.negated=U,this.type=3}static create(_,U=null){const M=A.get(_);return typeof M=="boolean"?M?D.INSTANCE:g.INSTANCE:new I(_,U)}cmp(_){return _.type!==this.type?this.type-_.type:d(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=A.get(this.key);return typeof _=="boolean"?_?D.INSTANCE:g.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=I;function a(L,_){if(typeof L=="string"){const U=parseFloat(L);isNaN(U)||(L=U)}return typeof L=="string"||typeof L=="number"?_(L):D.INSTANCE}class c{constructor(_,U,M){this.key=_,this.value=U,this.negated=M,this.type=12}static create(_,U,M=null){return a(U,q=>new c(_,q,M))}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class m{constructor(_,U,M){this.key=_,this.value=U,this.negated=M,this.type=13}static create(_,U,M=null){return a(U,q=>new m(_,q,M))}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class s{constructor(_,U,M){this.key=_,this.value=U,this.negated=M,this.type=14}static create(_,U,M=null){return a(U,q=>new s(_,q,M))}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class b{constructor(_,U,M){this.key=_,this.value=U,this.negated=M,this.type=15}static create(_,U,M=null){return a(U,q=>new b(_,q,M))}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=b;class o{constructor(_,U){this.key=_,this.regexp=U,this.type=7,this.negated=null}static create(_,U){return new o(_,U)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const U=this.regexp?this.regexp.source:"",M=_.regexp?_.regexp.source:"";return U<M?-1:U>M?1:0}equals(_){if(_.type===this.type){const U=this.regexp?this.regexp.source:"",M=_.regexp?_.regexp.source:"";return this.key===_.key&&U===M}return!1}substituteConstants(){return this}evaluate(_){let U=_.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class n{constructor(_){this._actual=_,this.type=8}static create(_){return new n(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new n(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function i(L){let _=null;for(let U=0,M=L.length;U<M;U++){const q=L[U].substituteConstants();if(L[U]!==q&&_===null){_=[];for(let K=0;K<U;K++)_[K]=L[K]}_!==null&&(_[U]=q)}return _===null?L:_}class r{constructor(_,U){this.expr=_,this.negated=U,this.type=6}static create(_,U){return r._normalizeArr(_,U)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let U=0,M=this.expr.length;U<M;U++){const q=F(this.expr[U],_.expr[U]);if(q!==0)return q}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let U=0,M=this.expr.length;U<M;U++)if(!this.expr[U].equals(_.expr[U]))return!1;return!0}return!1}substituteConstants(){const _=i(this.expr);return _===this.expr?this:r.create(_,this.negated)}evaluate(_){for(let U=0,M=this.expr.length;U<M;U++)if(!this.expr[U].evaluate(_))return!1;return!0}static _normalizeArr(_,U){const M=[];let q=!1;for(const K of _)if(!!K){if(K.type===1){q=!0;continue}if(K.type===0)return D.INSTANCE;if(K.type===6){M.push(...K.expr);continue}M.push(K)}if(M.length===0&&q)return g.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(F);for(let K=1;K<M.length;K++)M[K-1].equals(M[K])&&(M.splice(K,1),K--);if(M.length===1)return M[0];for(;M.length>1;){const K=M[M.length-1];if(K.type!==9)break;M.pop();const x=M.pop(),B=M.length===0,G=l.create(K.expr.map(X=>r.create([X,x],null)),null,B);G&&(M.push(G),M.sort(F))}return M.length===1?M[0]:new r(M,U)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let U of this.expr)_.push(...U.keys());return _}map(_){return new r(this.expr.map(U=>U.map(_)),null)}negate(){if(!this.negated){const _=[];for(let U of this.expr)_.push(U.negate());this.negated=l.create(_,this,!0)}return this.negated}}class l{constructor(_,U){this.expr=_,this.negated=U,this.type=9}static create(_,U,M){return l._normalizeArr(_,U,M)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let U=0,M=this.expr.length;U<M;U++){const q=F(this.expr[U],_.expr[U]);if(q!==0)return q}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let U=0,M=this.expr.length;U<M;U++)if(!this.expr[U].equals(_.expr[U]))return!1;return!0}return!1}substituteConstants(){const _=i(this.expr);return _===this.expr?this:l.create(_,this.negated,!1)}evaluate(_){for(let U=0,M=this.expr.length;U<M;U++)if(this.expr[U].evaluate(_))return!0;return!1}static _normalizeArr(_,U,M){let q=[],K=!1;if(_){for(let x=0,B=_.length;x<B;x++){const G=_[x];if(!!G){if(G.type===0){K=!0;continue}if(G.type===1)return g.INSTANCE;if(G.type===9){q=q.concat(G.expr);continue}q.push(G)}}if(q.length===0&&K)return D.INSTANCE;q.sort(F)}if(q.length!==0){if(q.length===1)return q[0];for(let x=1;x<q.length;x++)q[x-1].equals(q[x])&&(q.splice(x,1),x--);if(q.length===1)return q[0];if(M){for(let x=0;x<q.length;x++)for(let B=x+1;B<q.length;B++)R(q[x],q[B])&&(q.splice(B,1),B--);if(q.length===1)return q[0]}return new l(q,U)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let U of this.expr)_.push(...U.keys());return _}map(_){return new l(this.expr.map(U=>U.map(_)),null)}negate(){if(!this.negated){let _=[];for(let U of this.expr)_.push(U.negate());for(;_.length>1;){const U=_.shift(),M=_.shift(),q=[];for(const x of O(U))for(const B of O(M))q.push(r.create([x,B],null));const K=_.length===0;_.unshift(l.create(q,null,K))}this.negated=_[0]}return this.negated}}class p extends E{constructor(_,U,M){super(_,null);this._defaultValue=U,typeof M=="object"?p._info.push({...M,key:_}):M!==!0&&p._info.push({key:_,description:M,type:U!=null?typeof U:void 0})}static all(){return p._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return f.create(this.key,_)}notEqualsTo(_){return y.create(this.key,_)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(L,_){return L<_?-1:L>_?1:0}function v(L,_,U,M){return L<U?-1:L>U?1:_<M?-1:_>M?1:0}function R(L,_){if(_.type===6&&L.type!==9&&L.type!==6){for(const q of _.expr)if(L.equals(q))return!0}const U=L.negate(),M=O(U).concat(O(_));M.sort(F);for(let q=0;q<M.length;q++){const x=M[q].negate();for(let B=q+1;B<M.length;B++){const G=M[B];if(x.equals(G))return!0}}return!1}e.implies=R;function O(L){return L.type===9?L.expr:[L]}}),define(we[187],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(we[188],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,h.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,h.createDecorator)("externalTerminal")}),define(we[189],be([1,0,37,10,9,12,96,29,114,164,188]),function(te,e,h,t,k,A,S,P,C,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const D=T.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await u.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends g{openTerminal(c,m){return this.spawnTerminal(h,c,C.getWindowsShell(),m)}spawnTerminal(c,m,s,b){const o=m.windowsExec||E.getDefaultTerminalWindows();b&&b[1]===":"&&(b=b[0].toUpperCase()+b.substr(1));const n=k.basename(o).toLowerCase();if(n==="cmder"||n==="cmder.exe")return c.spawn(o,b?[b]:void 0),Promise.resolve(void 0);const i=["/c","start","/wait"];return o.indexOf(" ")>=0&&i.push('""'),i.push(o),(n==="wt"||n==="wt.exe")&&i.push("-d ."),new Promise((r,l)=>{const p=w(process),d=c.spawn(s,i,{cwd:b,env:p});d.on("error",l),d.on("exit",()=>r())})}runInTerminal(c,m,s,b,o){const n="windowsExec"in o&&o.windowsExec?o.windowsExec:E.getDefaultTerminalWindows();return new Promise((i,r)=>{const l=`"${m} - ${D}"`,p=`""${s.join('" "')}" & pause"`,d=["/c","start",l,"/wait",n,"/c",p],v=Object.assign({},w(process),b);Object.keys(v).filter(L=>v[L]===null).forEach(L=>delete v[L]);const R={cwd:m,env:v,windowsVerbatimArguments:!0};h.spawn(E.CMD,d,R).on("error",L=>{r(y(L))}),i(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class f extends g{openTerminal(c,m){return this.spawnTerminal(h,c,m)}runInTerminal(c,m,s,b,o){const n=o.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{if(n===F.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const l=n===F.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,te).fsPath,"-t",c||D,"-w",m];for(let O of s)d.push("-a"),d.push(O);if(b){const O=Object.assign({},w(process),b);for(let L in O){const _=O[L];_===null?(d.push("-u"),d.push(L)):(d.push("-e"),d.push(`${L}=${_}`))}}let v="";const R=h.spawn(f.OSASCRIPT,d);R.on("error",O=>{r(y(O))}),R.stderr.on("data",O=>{v+=O.toString()}),R.on("exit",O=>{if(O===0)i(void 0);else if(v){const L=v.split(`
`,1);r(new Error(L[0]))}else r(new Error(T.localize(1,null,l,O)))})}else r(new Error(T.localize(2,null,n)))})}spawnTerminal(c,m,s){const b=m.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((o,n)=>{const i=["-a",b];s&&i.push(s);const r=w(process),l=c.spawn("/usr/bin/open",i,{cwd:s,env:r});l.on("error",n),l.on("exit",()=>o())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class u extends g{openTerminal(c,m){return this.spawnTerminal(h,c,m)}runInTerminal(c,m,s,b,o){const n=o.linuxExec?Promise.resolve(o.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{let l=[];n.then(p=>{p.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const d=`${I(s)}; echo; read -p "${u.WAIT_MESSAGE}" -n1;`;l.push(`''${d}''`);const v=Object.assign({},w(process),b);Object.keys(v).filter(_=>v[_]===null).forEach(_=>delete v[_]);const R={cwd:m,env:v};let O="";const L=h.spawn(p,l,R);L.on("error",_=>{r(y(_))}),L.stderr.on("data",_=>{O+=_.toString()}),L.on("exit",_=>{if(_===0)i(void 0);else if(O){const U=O.split(`
`,1);r(new Error(U[0]))}else r(new Error(T.localize(4,null,p,_)))})})})}static async getDefaultTerminalLinuxReady(){if(!u._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)u._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await P.Promises.exists("/etc/debian_version");u._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{c?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return u._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,m,s){const b=m.linuxExec?Promise.resolve(m.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((o,n)=>{b.then(i=>{const r=w(process),l=c.spawn(i,[],{cwd:s,env:r});l.on("error",n),l.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=u,u.WAIT_MESSAGE=T.localize(3,null);function w(a){const c={...a.env};return(0,S.sanitizeProcessEnvironment)(c),c}function y(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(T.localize(5,null,a.path)):a}function I(a){let c="";for(let m of a)m.indexOf(" ")>=0?c+='"'+m+'"':c+=m,c+=" ";return c}}),define(we[42],be([1,0,24,9,8,18,2,165,4]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function T(K){return K.create===!0}e.isFileOpenForWriteOptions=T;var F;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var D;(function(K){K[K.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var g;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=E;function f(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=f;function u(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function w(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=w;function y(K){return E(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var I;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(x,B){super(x);this.code=B}}e.FileSystemProviderError=a;function c(K,x){const B=new a(K.toString(),x);return s(B,x),B}e.createFileSystemProviderError=c;function m(K){return K||c((0,P.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=m;function s(K,x){return K.name=x?`${x} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=s;function b(K){if(!K)return I.Unknown;if(K instanceof a)return K.code;const x=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!x)return I.Unknown;switch(x[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=b;function o(K){if(K instanceof d)return K.fileOperationResult;switch(b(K)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var n;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class i{constructor(x,B,G){this.resource=x,this.operation=B,this.target=G}isOperation(x){return this.operation===x}}e.FileOperationEvent=i;var r;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class l{constructor(x,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=x;const G=new Map;for(const X of x){const V=G.get(X.type);switch(V?V.push([X.resource,X]):G.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,V]of G)switch(X){case 1:this.added=h.TernarySearchTree.forUris(()=>B),this.added.fill(V);break;case 0:this.updated=h.TernarySearchTree.forUris(()=>B),this.updated.fill(V);break;case 2:this.deleted=h.TernarySearchTree.forUris(()=>B),this.deleted.fill(V);break}}contains(x,...B){return this.doContains(x,{includeChildren:!1},...B)}affects(x,...B){return this.doContains(x,{includeChildren:!0},...B)}doContains(x,B,...G){if(!x)return!1;const X=G.length>0;return!!((!X||G.includes(1))&&(this.added?.get(x)||B.includeChildren&&this.added?.findSuperstr(x))||(!X||G.includes(0))&&(this.updated?.get(x)||B.includeChildren&&this.updated?.findSuperstr(x))||(!X||G.includes(2))&&(this.deleted?.findSubstr(x)||B.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function p(K,x,B){return!K||!x||K===x||x.length>K.length?!1:(x.charAt(x.length-1)!==t.sep&&(x+=t.sep),B?(0,k.startsWithIgnoreCase)(K,x):K.indexOf(x)===0)}e.isParent=p;class d extends Error{constructor(x,B,G){super(x);this.fileOperationResult=B,this.options=G}}e.FileOperationError=d;class v extends d{constructor(x,B,G){super(x,2,G);this.stat=B}}e.NotModifiedSinceFileOperationError=v;var R;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=L;async function _(K,x){if(!x.hasProvider(S.URI.from({scheme:K.scheme})))return new Promise(B=>{const G=x.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===K.scheme&&X.added&&(G.dispose(),B())})})}e.whenProviderRegistered=_,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(x){return(0,A.isNumber)(x)||(x=0),x<U.KB?(0,P.localize)(1,null,x.toFixed(0)):x<U.MB?(0,P.localize)(2,null,(x/U.KB).toFixed(2)):x<U.GB?(0,P.localize)(3,null,(x/U.MB).toFixed(2)):x<U.TB?(0,P.localize)(4,null,(x/U.GB).toFixed(2)):(0,P.localize)(5,null,(x/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var M;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function q(K){return{maxFileSize:K===0?300*U.MB:16*U.GB,maxHeapSize:K===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=q}),define(we[82],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...k){this._entries=new Map;for(let[A,S]of k)this.set(A,S)}set(k,A){const S=this._entries.get(k);return this._entries.set(k,A),S}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=h}),define(we[190],be([1,0,13,16,116,186,4,82]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class T extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class F{constructor(f=new P.ServiceCollection,u=!1,w){this._activeInstantiations=new Set,this._services=f,this._strict=u,this._parent=w,this._services.set(S.IInstantiationService,this)}createChild(f){return new F(f,this._strict,this)}invokeFunction(f,...u){let w=g.traceInvocation(f),y=!1;try{return f({get:a=>{if(y)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(a,w);if(!c)throw new Error(`[invokeFunction] unknown service '${a}'`);return c}},...u)}finally{y=!0,w.stop()}}createInstance(f,...u){let w,y;return f instanceof k.SyncDescriptor?(w=g.traceCreation(f.ctor),y=this._createInstance(f.ctor,f.staticArguments.concat(u),w)):(w=g.traceCreation(f),y=this._createInstance(f,u,w)),w.stop(),y}_createInstance(f,u=[],w){let y=S._util.getServiceDependencies(f).sort((c,m)=>c.index-m.index),I=[];for(const c of y){let m=this._getOrCreateServiceInstance(c.id,w);if(!m&&this._strict&&!c.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${c.id}.`);I.push(m)}let a=y.length>0?y[0].index:u.length;if(u.length!==a){console.warn(`[createInstance] First service dependency of ${f.name} at position ${a+1} conflicts with ${u.length} static arguments`);let c=a-u.length;c>0?u=u.concat(new Array(c)):u=u.slice(0,a)}return new f(...[...u,...I])}_setServiceInstance(f,u){if(this._services.get(f)instanceof k.SyncDescriptor)this._services.set(f,u);else if(this._parent)this._parent._setServiceInstance(f,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let u=this._services.get(f);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):u}_getOrCreateServiceInstance(f,u){let w=this._getServiceInstanceOrDescriptor(f);return w instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,w,u.branch(f,!0)):(u.branch(f,!1),w)}_safeCreateAndCacheServiceInstance(f,u,w){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,u,w)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,u,w){const y=new A.Graph(c=>c.id.toString());let I=0;const a=[{id:f,desc:u,_trace:w}];for(;a.length;){const c=a.pop();if(y.lookupOrInsertNode(c),I++>1e3)throw new T(y);for(let m of S._util.getServiceDependencies(c.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(m.id);if(!s&&!m.optional&&console.warn(`[createInstance] ${f} depends on ${m.id} which is NOT registered.`),s instanceof k.SyncDescriptor){const b={id:m.id,desc:s,_trace:c._trace.branch(m.id,!0)};y.insertEdge(c,b),a.push(b)}}}for(;;){const c=y.roots();if(c.length===0){if(!y.isEmpty())throw new T(y);break}for(const{data:m}of c){if(this._getServiceInstanceOrDescriptor(m.id)instanceof k.SyncDescriptor){const b=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,b)}y.removeNode(m)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,u,w=[],y,I){if(this._services.get(f)instanceof k.SyncDescriptor)return this._createServiceInstance(u,w,y,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,u,w,y,I);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(f,u=[],w,y){if(w){const I=new h.IdleValue(()=>this._createInstance(f,u,y));return new Proxy(Object.create(null),{get(a,c){if(c in a)return a[c];let m=I.value,s=m[c];return typeof s!="function"||(s=s.bind(m),a[c]=s),s},set(a,c,m){return I.value[c]=m,!0}})}else return this._createInstance(f,u,y)}}e.InstantiationService=F;var D;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(D||(D={}));class g{constructor(f,u){this.type=f,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return C?new g(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(f){return C?new g(0,f.name):g._None}branch(f,u){let w=new g(2,f.toString());return this._dep.push([f,u,w]),w}stop(){let f=Date.now()-this._start;g._totals+=f;let u=!1;function w(I,a){let c=[],m=new Array(I+1).join("	");for(const[s,b,o]of a._dep)if(b&&o){u=!0,c.push(`${m}CREATES -> ${s}`);let n=w(I+1,o);n&&c.push(n)}else c.push(`${m}uses -> ${s}`);return c.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(f>2||u)&&console.log(y.join(`
`))}}e.Trace=g,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(we[11],be([1,0,49,3,6,12,4]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function P(){return new Date().toISOString()}var C;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function T(b,o,n){switch(o){case C.Trace:b.trace(n);break;case C.Debug:b.debug(n);break;case C.Info:b.info(n);break;case C.Warning:b.warn(n);break;case C.Error:b.error(n);break;case C.Critical:b.critical(n);break;default:throw new Error("Invalid log level")}}e.log=T;function F(b){let o="";for(let n=0;n<b.length;n++){let i=b[n];if(typeof i=="object")try{i=JSON.stringify(i)}catch{}o+=(n>0?" ":"")+i}return o}e.format=F;class D extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=D;class g extends D{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...n){this.checkLogLevel(C.Trace)&&this.log(C.Trace,F([o,...n]))}debug(o,...n){this.checkLogLevel(C.Debug)&&this.log(C.Debug,F([o,...n]))}info(o,...n){this.checkLogLevel(C.Info)&&this.log(C.Info,F([o,...n]))}warn(o,...n){this.checkLogLevel(C.Warning)&&this.log(C.Warning,F([o,...n]))}error(o,...n){if(this.checkLogLevel(C.Error))if(o instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=o.stack,this.log(C.Error,F(i))}else this.log(C.Error,F([o,...n]))}critical(o,...n){this.checkLogLevel(C.Critical)&&this.log(C.Critical,F([o,...n]))}flush(){}}e.AbstractMessageLogger=g;class E extends D{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!A.isWindows}trace(o,...n){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...n):console.log(`[main ${P()}]`,o,...n))}debug(o,...n){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...n):console.log(`[main ${P()}]`,o,...n))}info(o,...n){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...n):console.log(`[main ${P()}]`,o,...n))}warn(o,...n){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,o,...n):console.warn(`[main ${P()}]`,o,...n))}error(o,...n){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,o,...n):console.error(`[main ${P()}]`,o,...n))}critical(o,...n){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,o,...n):console.error(`[main ${P()}]`,o,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class f extends D{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...n){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",o,...n)}debug(o,...n){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...n)}info(o,...n){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",o,...n)}warn(o,...n){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",o,...n)}error(o,...n){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",o,...n)}critical(o,...n){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class u extends D{constructor(o,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(n)}trace(o,...n){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(o),...n])}debug(o,...n){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(o),...n])}info(o,...n){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(o),...n])}warn(o,...n){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(o),...n])}error(o,...n){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(o),...n])}critical(o,...n){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(o),...n])}extractMessage(o){return typeof o=="string"?o:(0,h.toErrorMessage)(o,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class w extends D{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const n of this.logServices)n.setLevel(o);super.setLevel(o)}trace(o,...n){for(const i of this.logServices)i.trace(o,...n)}debug(o,...n){for(const i of this.logServices)i.debug(o,...n)}info(o,...n){for(const i of this.logServices)i.info(o,...n)}warn(o,...n){for(const i of this.logServices)i.warn(o,...n)}error(o,...n){for(const i of this.logServices)i.error(o,...n)}critical(o,...n){for(const i of this.logServices)i.critical(o,...n)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=w;class y extends k.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...n){this.logger.trace(o,...n)}debug(o,...n){this.logger.debug(o,...n)}info(o,...n){this.logger.info(o,...n)}warn(o,...n){this.logger.warn(o,...n)}error(o,...n){this.logger.error(o,...n)}critical(o,...n){this.logger.critical(o,...n)}flush(){this.logger.flush()}}e.LogService=y;class I extends k.Disposable{constructor(o,n){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,n){let i=this.loggers.get(o.toString());return i||(i=this.doCreateLogger(o,n?.always?C.Trace:this.logLevel,n),this.loggers.set(o.toString(),i),n?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class a{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return C.Info}trace(o,...n){}debug(o,...n){}info(o,...n){}warn(o,...n){}error(o,...n){}critical(o,...n){}dispose(){}flush(){}}e.NullLogService=a;function c(b){if(b.verbose)return C.Trace;if(typeof b.logLevel=="string"){const o=m(b.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function m(b){switch(b){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=m;function s(b){switch(b){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=s}),define(we[191],be([1,0,42,11]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(P,C,T,F,D){try{const g=await new Promise((f,u)=>{te(["spdlog"],f,u)});g.setFlushOn(t.LogLevel.Trace);const E=await g.createAsyncRotatingLogger(P,C,T,F);return D&&E.clearFormatters(),E}catch(g){console.error(g)}return null}function A(P,C,T){switch(C){case t.LogLevel.Trace:P.trace(T);break;case t.LogLevel.Debug:P.debug(T);break;case t.LogLevel.Info:P.info(T);break;case t.LogLevel.Warning:P.warn(T);break;case t.LogLevel.Error:P.error(T);break;case t.LogLevel.Critical:P.critical(T);break;default:throw new Error("Invalid log level")}}class S extends t.AbstractMessageLogger{constructor(C,T,F,D,g){super();this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(C,T,F,D),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(C,T,F,D){const g=F?6:1,E=30/g*h.ByteSize.MB,f=await k(C,T,E,g,D);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:u,message:w}of this.buffer)A(this._logger,u,w);this.buffer=[]}}log(C,T){this._logger?A(this._logger,C,T):this.getLevel()<=C&&this.buffer.push({level:C,message:T})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=S}),define(we[118],be([1,0,47,166,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var S;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function T(f,u){return u-f}C.compare=T;const F=Object.create(null);F[C.Error]=(0,t.localize)(0,null),F[C.Warning]=(0,t.localize)(1,null),F[C.Info]=(0,t.localize)(2,null);function D(f){return F[f]||""}C.toString=D;function g(f){switch(f){case h.default.Error:return C.Error;case h.default.Warning:return C.Warning;case h.default.Info:return C.Info;case h.default.Ignore:return C.Hint}}C.fromSeverity=g;function E(f){switch(f){case C.Error:return h.default.Error;case C.Warning:return h.default.Warning;case C.Info:return h.default.Info;case C.Hint:return h.default.Ignore}}C.toSeverity=E}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(C){const T="";function F(g){return D(g,!0)}C.makeKey=F;function D(g,E){let f=[T];return g.source?f.push(g.source.replace("\xA6","\\\xA6")):f.push(T),g.code?typeof g.code=="string"?f.push(g.code.replace("\xA6","\\\xA6")):f.push(g.code.value.replace("\xA6","\\\xA6")):f.push(T),g.severity!==void 0&&g.severity!==null?f.push(S.toString(g.severity)):f.push(T),g.message&&E?f.push(g.message.replace("\xA6","\\\xA6")):f.push(T),g.startLineNumber!==void 0&&g.startLineNumber!==null?f.push(g.startLineNumber.toString()):f.push(T),g.startColumn!==void 0&&g.startColumn!==null?f.push(g.startColumn.toString()):f.push(T),g.endLineNumber!==void 0&&g.endLineNumber!==null?f.push(g.endLineNumber.toString()):f.push(T),g.endColumn!==void 0&&g.endColumn!==null?f.push(g.endColumn.toString()):f.push(T),f.push(T),f.join("\xA6")}C.makeKeyOptionalMessage=D})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(we[192],be([1,0,3,47,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,k.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new C,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=P;class C{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=C}),define(we[119],be([1,0,6,8,2,4]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(T){return{resolved:T,dispose(){}}}});function S(T,F){return k.URI.isUri(T)?(0,t.equalsIgnoreCase)(T.scheme,F):(0,t.startsWithIgnoreCase)(T,F+":")}e.matchesScheme=S;function P(T,...F){return F.some(D=>S(T,D))}e.matchesSomeScheme=P;function C(T){let F;const D=/^L?(\d+)(?:,(\d+))?/.exec(T.fragment);return D&&(F={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1}),F}e.selectionFragment=C}),define(we[193],be([1,0,10,12,40,22]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let S;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const P=t.globals.vscode.context.configuration();if(P)S=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof te?.__$__nodeRequire=="function"){const P=(0,A.dirname)(h.FileAccess.asFileUri("",te));S=te.__$__nodeRequire((0,A.joinPath)(P,"product.json").fsPath);const C=te.__$__nodeRequire((0,A.joinPath)(P,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(S,{nameShort:`${S.nameShort} Dev`,nameLong:`${S.nameLong} Dev`,dataFolderName:`${S.dataFolderName}-dev`,serverDataFolderName:S.serverDataFolderName?`${S.serverDataFolderName}-dev`:void 0}),Object.assign(S,{version:C.version})}else S={},Object.keys(S).length===0&&Object.assign(S,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=S});var Fe=this&&this.__param||function(te,e){return function(h,t){e(h,t,te)}};define(we[120],be([1,0,13,21,6,4]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var S;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(D){this.callback=D}get value(){return this._value}report(D){this._value=D,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let C=class extends k.Disposable{constructor(D,g){super();this.deferred=new h.DeferredPromise,g.withProgress(D,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(D){this.reporter?this.reporter.report(D):this.lastStep=D}};C=Be([Fe(1,e.IProgressService)],C),e.UnmanagedProgress=C;class T extends k.Disposable{constructor(D){super();this.progressIndicator=D,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(D){this.stop();const g=++this.currentOperationId,E=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},D),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:E.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(D){this.currentOperationId===D&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(we[50],be([1,0,55,18]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(S,P){h.ok(t.isString(S)),h.ok(t.isObject(P)),h.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,P)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new k}),define(we[194],be([1,0,3,50]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,T){this.schemasById[k(C)]=T,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new A;t.Registry.add(e.Extensions.JSONContribution,S)}),define(we[121],be([1,0,17,3,18,161,194,50]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=P.Registry.as(S.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(m,s=!0){this.registerConfigurations([m],s)}registerConfigurations(m,s=!0){const b=this.doRegisterConfigurations(m,s);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:b})}deregisterConfigurations(m){const s=this.doDeregisterConfigurations(m);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:m,remove:s}){const b=[];b.push(...this.doDeregisterConfigurations(s)),b.push(...this.doRegisterConfigurations(m,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,h.distinct)(b)})}registerDefaultConfigurations(m){const s=[],b=[];for(const{overrides:o,source:n}of m)for(const i in o)if(s.push(i),e.OVERRIDE_PROPERTY_REGEX.test(i)){const r={...this.configurationDefaultsOverrides.get(i)?.value||{},...o[i]};this.configurationDefaultsOverrides.set(i,{source:n,value:r});const l={type:"object",default:r,description:A.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:r,source:k.isString(n)?void 0:n};b.push(...f(i)),this.configurationProperties[i]=l,this.defaultLanguageConfigurationOverridesNode.properties[i]=l}else{this.configurationDefaultsOverrides.set(i,{value:o[i],source:n});const r=this.configurationProperties[i];r&&(this.updatePropertyDefaultValue(i,r),this.updateSchema(i,r))}this.registerOverrideIdentifiers(b),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(m){const s=[];for(const{overrides:b,source:o}of m)for(const n in b){const i=this.configurationDefaultsOverrides.get(n),r=k.isString(o)?o:o?.id,l=k.isString(i?.source)?i?.source:i?.source?.id;if(r===l)if(s.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const p=this.configurationProperties[n];p&&(this.updatePropertyDefaultValue(n,p),this.updateSchema(n,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const s of m)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(m,s){const b=[];return m.forEach(o=>{b.push(...this.validateAndRegisterProperties(o,s,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),b}doDeregisterConfigurations(m){const s=[],b=o=>{if(o.properties)for(const n in o.properties)s.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,o.properties[n]);o.allOf&&o.allOf.forEach(n=>b(n))};for(const o of m){b(o);const n=this.configurationContributors.indexOf(o);n!==-1&&this.configurationContributors.splice(n,1)}return s}validateAndRegisterProperties(m,s=!0,b,o,n=3){n=k.isUndefinedOrNull(m.scope)?n:m.scope;let i=[],r=m.properties;if(r)for(let p in r){if(s&&I(p)){delete r[p];continue}const d=r[p];if(d.source=b,d.defaultDefaultValue=r[p].default,this.updatePropertyDefaultValue(p,d),e.OVERRIDE_PROPERTY_REGEX.test(p)?d.scope=void 0:(d.scope=k.isUndefinedOrNull(d.scope)?n:d.scope,d.restricted=k.isUndefinedOrNull(d.restricted)?!!o?.includes(p):d.restricted),r[p].hasOwnProperty("included")&&!r[p].included){this.excludedConfigurationProperties[p]=r[p],delete r[p];continue}else this.configurationProperties[p]=r[p];!r[p].deprecationMessage&&r[p].markdownDeprecationMessage&&(r[p].deprecationMessage=r[p].markdownDeprecationMessage),i.push(p)}let l=m.allOf;if(l)for(let p of l)i.push(...this.validateAndRegisterProperties(p,s,b,o,n));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(m){const s=b=>{let o=b.properties;if(o)for(const i in o)this.updateSchema(i,o[i]);let n=b.allOf;n&&n.forEach(s)};s(m)}updateSchema(m,s){switch(e.allSettings.properties[m]=s,s.scope){case 1:e.applicationSettings.properties[m]=s;break;case 2:e.machineSettings.properties[m]=s;break;case 6:e.machineOverridableSettings.properties[m]=s;break;case 3:e.windowSettings.properties[m]=s;break;case 4:e.resourceSettings.properties[m]=s;break;case 5:e.resourceSettings.properties[m]=s,this.resourceLanguageSettingsSchema.properties[m]=s;break}}removeFromSchema(m,s){switch(delete e.allSettings.properties[m],s.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m],delete this.resourceLanguageSettingsSchema.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const s=`[${m}]`,b={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,b),e.allSettings.properties[s]=b,e.applicationSettings.properties[s]=b,e.machineSettings.properties[s]=b,e.machineOverridableSettings.properties[s]=b,e.windowSettings.properties[s]=b,e.resourceSettings.properties[s]=b}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const m={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,s){const b=this.configurationDefaultsOverrides.get(m);let o=b?.value,n=b?.source;k.isUndefined(o)&&(o=s.defaultDefaultValue,n=void 0),k.isUndefined(o)&&(o=w(s.type)),s.default=o,s.defaultValueSource=n}}const g="\\[([^\\]]+)\\]",E=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(c){const m=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let s=E.exec(c);for(;s?.length;){const b=s[1].trim();b&&m.push(b),s=E.exec(c)}}return(0,h.distinct)(m)}e.overrideIdentifiersFromKey=f;function u(c){return c.reduce((m,s)=>`${m}[${s}]`,"")}e.keyFromOverrideIdentifiers=u;function w(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const y=new D;P.Registry.add(e.Extensions.Configuration,y);function I(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?A.localize(7,null,c):y.getConfigurationProperties()[c]!==void 0?A.localize(8,null,c):null:A.localize(6,null)}e.validateProperty=I;function a(){const c=[],m=y.getConfigurationProperties();for(const s of Object.keys(m))c.push([s,m[s].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=a}),define(we[195],be([1,0,17,3,57,6,24,25,18,2,117,121,50]),function(te,e,h,t,k,A,S,P,C,T,F,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(o={},n=[],i=[]){this._contents=o,this._keys=n,this._overrides=i,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,F.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,n){const i=this.getContentsForOverrideIdentifer(n);return i?o?(0,F.getConfigurationValue)(i,o):i:void 0}getKeysForOverrideIdentifier(o){const n=[];for(const i of this.overrides)i.identifiers.includes(o)&&n.push(...i.keys);return h.distinct(n)}getAllOverrideIdentifiers(){const o=[];for(const n of this.overrides)o.push(...n.identifiers);return h.distinct(o)}override(o){let n=this.overrideConfigurations.get(o);return n||(n=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,n)),n}merge(...o){const n=P.deepClone(this.contents),i=P.deepClone(this.overrides),r=[...this.keys];for(const l of o){this.mergeContents(n,l.contents);for(const p of l.overrides){const[d]=i.filter(v=>h.equals(v.identifiers,p.identifiers));d?(this.mergeContents(d.contents,p.contents),d.keys.push(...p.keys),d.keys=h.distinct(d.keys)):i.push(P.deepClone(p))}for(const p of l.keys)r.indexOf(p)===-1&&r.push(p)}return new E(n,r,i)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(o){const n=this.getContentsForOverrideIdentifer(o);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let i={};for(const r of h.distinct([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r],p=n[r];p&&(typeof l=="object"&&typeof p=="object"?(l=P.deepClone(l),this.mergeContents(l,p)):l=p),i[r]=l}return new E(i,this.keys,this.overrides)}mergeContents(o,n){for(const i of Object.keys(n)){if(i in o&&C.isObject(o[i])&&C.isObject(n[i])){this.mergeContents(o[i],n[i]);continue}o[i]=P.deepClone(n[i])}}checkAndFreeze(o){return this.isFrozen&&!Object.isFrozen(o)?P.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let n=null,i=null;const r=l=>{l&&(i?this.mergeContents(i,l):i=P.deepClone(l))};for(const l of this.overrides)h.equals(l.identifiers,[o])?n=l.contents:l.identifiers.includes(o)&&r(l.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,n){this.addKey(o),(0,F.addToValueTree)(this.contents,o,n,i=>{throw new Error(i)})}removeValue(o){this.removeKey(o)&&(0,F.removeFromValueTree)(this.contents,o)}addKey(o){let n=this.keys.length;for(let i=0;i<n;i++)o.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,o)}removeKey(o){let n=this.keys.indexOf(o);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=E;class f extends E{constructor(o={}){const n=g.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=Object.keys(n),r=Object.create(null),l=[];for(const p in n){const d=o[p],v=d!==void 0?d:n[p].default;(0,F.addToValueTree)(r,p,v,R=>console.error(`Conflict in default settings: ${R}`))}for(const p of Object.keys(r))D.OVERRIDE_PROPERTY_REGEX.test(p)&&l.push({identifiers:(0,D.overrideIdentifiersFromKey)(p),keys:Object.keys(r[p]),contents:(0,F.toValuesTree)(r[p],d=>console.error(`Conflict in default settings file: ${d}`))});super(r,i,l)}}e.DefaultConfigurationModel=f;class u{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,n){if(!C.isUndefinedOrNull(o)){const i=this.doParseContent(o);this.parseRaw(i,n)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,n){this._raw=o;const{contents:i,keys:r,overrides:l,restricted:p}=this.doParseRaw(o,n);this._configurationModel=new E(i,r,l),this._restrictedConfigurations=p||[]}doParseContent(o){let n={},i=null,r=[],l=[],p=[];function d(R){Array.isArray(r)?r.push(R):i!==null&&(r[i]=R)}let v={onObjectBegin:()=>{let R={};d(R),l.push(r),r=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let R=[];d(R),l.push(r),r=R,i=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:d,onError:(R,O,L)=>{p.push({error:R,offset:O,length:L})}};if(o)try{k.visit(o,v),n=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return n}doParseRaw(o,n){const i=g.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(o,i,!0,n);o=r.raw;const l=(0,F.toValuesTree)(o,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),p=Object.keys(o),d=this.toOverrides(o,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:l,keys:p,overrides:d,restricted:r.restricted}}filter(o,n,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:o,restricted:[]};const l={},p=[];for(let d in o)if(D.OVERRIDE_PROPERTY_REGEX.test(d)&&i){const v=this.filter(o[d],n,!1,r);l[d]=v.raw,p.push(...v.restricted)}else{const v=n[d],R=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&p.push(d),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&v?.restricted||(l[d]=o[d]))}return{raw:l,restricted:p}}toOverrides(o,n){const i=[];for(const r of Object.keys(o))if(D.OVERRIDE_PROPERTY_REGEX.test(r)){const l={};for(const p in o[r])l[p]=o[r][p];i.push({identifiers:(0,D.overrideIdentifiersFromKey)(r),keys:Object.keys(l),contents:(0,F.toValuesTree)(l,n)})}return i}}e.ConfigurationModelParser=u;class w extends A.Disposable{constructor(o,n,i,r){super();this.userSettingsResource=o,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class y{constructor(o,n,i=new E,r=new E,l=new S.ResourceMap,p=new E,d=new S.ResourceMap,v=!0){this._defaultConfiguration=o,this._localUserConfiguration=n,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=p,this._memoryConfigurationByResource=d,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new S.ResourceMap,this._userConfiguration=null}getValue(o,n,i){return this.getConsolidateConfigurationModel(n,i).getValue(o)}updateValue(o,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new E,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(o):r.setValue(o,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,n,i){const r=this.getConsolidateConfigurationModel(n,i),l=this.getFolderConfigurationModelForResource(n.resource,i),p=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,d=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),v=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),R=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),O=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),L=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,_=l?n.overrideIdentifier?l.freeze().override(n.overrideIdentifier).getValue(o):l.freeze().getValue(o):void 0,U=n.overrideIdentifier?p.override(n.overrideIdentifier).getValue(o):p.getValue(o),M=r.getValue(o),q=h.distinct(h.flatten(r.overrides.map(K=>K.identifiers))).filter(K=>r.getOverrideValue(o,K)!==void 0);return{defaultValue:d,userValue:v,userLocalValue:R,userRemoteValue:O,workspaceValue:L,workspaceFolderValue:_,memoryValue:U,value:M,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:l?.freeze().getValue(o),override:n.overrideIdentifier?l?.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:p.getValue(o),override:n.overrideIdentifier?p.getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(o){const n=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,n){this._folderConfigurations.set(o,n),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,n){const i=[];if(!n){const{added:r,updated:l,removed:p}=m(this._defaultConfiguration,o);n=[...r,...l,...p]}for(const r of n)for(const l of(0,D.overrideIdentifiersFromKey)(r)){const p=this._defaultConfiguration.getKeysForOverrideIdentifier(l),d=o.getKeysForOverrideIdentifier(l),v=[...d.filter(R=>p.indexOf(R)===-1),...p.filter(R=>d.indexOf(R)===-1),...p.filter(R=>!P.equals(this._defaultConfiguration.override(l).getValue(R),o.override(l).getValue(R)))];i.push([l,v])}return this.updateDefaultConfiguration(o),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(o){const{added:n,updated:i,removed:r,overrides:l}=m(this.localUserConfiguration,o),p=[...n,...i,...r];return p.length&&this.updateLocalUserConfiguration(o),{keys:p,overrides:l}}compareAndUpdateRemoteUserConfiguration(o){const{added:n,updated:i,removed:r,overrides:l}=m(this.remoteUserConfiguration,o);let p=[...n,...i,...r];return p.length&&this.updateRemoteUserConfiguration(o),{keys:p,overrides:l}}compareAndUpdateWorkspaceConfiguration(o){const{added:n,updated:i,removed:r,overrides:l}=m(this.workspaceConfiguration,o);let p=[...n,...i,...r];return p.length&&this.updateWorkspaceConfiguration(o),{keys:p,overrides:l}}compareAndUpdateFolderConfiguration(o,n){const i=this.folderConfigurations.get(o),{added:r,updated:l,removed:p,overrides:d}=m(i,n);let v=[...r,...l,...p];return(v.length||!i)&&this.updateFolderConfiguration(o,n),{keys:v,overrides:d}}compareAndDeleteFolderConfiguration(o){const n=this.folderConfigurations.get(o);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:i,updated:r,removed:l,overrides:p}=m(n,void 0);return{keys:[...i,...r,...l],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(o,n){let i=this.getConsolidatedConfigurationModelForResource(o,n);return o.overrideIdentifier?i.override(o.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:o},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&o){const r=n.getFolder(o);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const l=this._memoryConfigurationByResource.get(o);l&&(i=i.merge(l))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let n=this._foldersConsolidatedConfigurations.get(o);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(o);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(o,n)):n=i}return n}getFolderConfigurationModelForResource(o,n){if(n&&o){const i=n.getFolder(o);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,n)=>{const{contents:i,overrides:r,keys:l}=this._folderConfigurations.get(n);return o.push([n,{contents:i,overrides:r,keys:l}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>o.add(n)),this.userConfiguration.freeze().keys.forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>o.add(i))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(o).forEach(r=>n.add(r))),[...n.values()]}static parse(o){const n=this.parseConfigurationModel(o.defaults),i=this.parseConfigurationModel(o.user),r=this.parseConfigurationModel(o.workspace),l=o.folders.reduce((p,d)=>(p.set(T.URI.revive(d[0]),this.parseConfigurationModel(d[1])),p),new S.ResourceMap);return new y(n,i,new E,r,l,new E,new S.ResourceMap,!1)}static parseConfigurationModel(o){return new E(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=y;function I(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const o=new Set,n=new Map;for(const r of b)r.keys.forEach(l=>o.add(l)),r.overrides.forEach(([l,p])=>{const d=(0,S.getOrSet)(n,l,new Set);p.forEach(v=>d.add(v))});const i=[];return n.forEach((r,l)=>i.push([l,[...r.values()]])),{keys:[...o.values()],overrides:i}}e.mergeChanges=I;class a{constructor(o,n,i,r){this.change=o,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;o.keys.forEach(d=>l.add(d)),o.overrides.forEach(([,d])=>d.forEach(v=>l.add(v))),this.affectedKeys=[...l.values()];const p=new E;this.affectedKeys.forEach(d=>p.setValue(d,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(o,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(o,n,this.currentWorkspace);return!P.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(o,n){let i=(0,F.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(o=o[r],!o)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=a;class c extends a{constructor(o,n,i,r){super({keys:o.allKeys(),overrides:[]},void 0,o,n);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c;function m(b,o){const{added:n,removed:i,updated:r}=s(o,b),l=[],p=b?.getAllOverrideIdentifiers()||[],d=o?.getAllOverrideIdentifiers()||[];if(o){const v=d.filter(R=>!p.includes(R));for(const R of v)l.push([R,o.getKeysForOverrideIdentifier(R)])}if(b){const v=p.filter(R=>!d.includes(R));for(const R of v)l.push([R,b.getKeysForOverrideIdentifier(R)])}if(o&&b){for(const v of p)if(d.includes(v)){const R=s({contents:b.getOverrideValue(void 0,v)||{},keys:b.getKeysForOverrideIdentifier(v)},{contents:o.getOverrideValue(void 0,v)||{},keys:o.getKeysForOverrideIdentifier(v)});l.push([v,[...R.added,...R.removed,...R.updated]])}}return{added:n,removed:i,updated:r,overrides:l}}function s(b,o){const n=b?o?b.keys.filter(l=>o.keys.indexOf(l)===-1):[...b.keys]:[],i=o?b?o.keys.filter(l=>b.keys.indexOf(l)===-1):[...o.keys]:[],r=[];if(b&&o){for(const l of o.keys)if(b.keys.indexOf(l)!==-1){const p=(0,F.getConfigurationValue)(o.contents,l),d=(0,F.getConfigurationValue)(b.contents,l);P.equals(p,d)||r.push(l)}}return{added:n,removed:i,updated:r}}}),define(we[122],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var t;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(S,P=t.Unknown,C){super(S);this._message=S,this._code=P,this._detail=C,this.isHandled=P===t.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===t.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===t.NoResolverFound}static isHandled(S){return S instanceof k&&S.isHandled}}e.RemoteAuthorityResolverError=k}),define(we[83],be([1,0,10]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(A){return A.scheme===h.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=t;function k(A){if(!A)return;const S=A.indexOf("+");return S<0?A:A.substr(0,S)}e.getRemoteName=k}),define(we[27],be([1,0,8,4,83]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=A;function S(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,f){if(typeof E=="undefined"||E===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof E=="string"||typeof f=="string"){let u=typeof E=="string"?E:E.value,w=typeof f=="string"?f:f.value;return h.equalsIgnoreCase(u,w)}return E._lower===f._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=C;function T(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function F(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function D(g,E){if(E){const f=`onResolveRemoteAuthority:${(0,k.getRemoteName)(E)}`;return g.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[123],be([1,0,8,27]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(f,u){return f.uuid&&u.uuid?f.uuid===u.uuid:f.id===u.id?!0:(0,h.compareIgnoreCase)(f.id,u.id)===0}e.areSameExtensions=k;class A{constructor(u,w){this.version=w,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof A?k(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=A;function S(f,u){return`${f}.${u}`}e.getExtensionId=S;function P(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function C(f,u){return P(S(f,u))}e.getGalleryExtensionId=C;function T(f,u){const w=[],y=I=>{for(const a of w)if(a.some(c=>k(u(c),u(I))))return a;return null};for(const I of f){const a=y(I);a?a.push(I):w.push([I])}return w}e.groupByExtension=T;function F(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function D(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function g(f){const u=new Set;if(f.malicious)for(const w of f.malicious)u.add(w.id);return u}e.getMaliciousExtensionsSet=g;function E(f,u){const w=[],y=u.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const I=y.shift();if(I&&w.every(a=>!k(a.identifier,{id:I}))){const a=f.filter(c=>k(c.identifier,{id:I}));a.length===1&&(w.push(a[0]),y.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=E}),define(we[196],be([1,0,10,162,123,4]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const S=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function P(s){const b=S.exec(s);return b&&b[1]?[(0,k.adoptToGalleryExtensionId)(b[1]),b[2]]:[(0,k.adoptToGalleryExtensionId)(s),void 0]}e.getIdAndVersion=P;var C;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function T(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function F(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function D(s,b){switch(s){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function g(s,b){return b==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function E(s,b,o){return g(b,o)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===o?!0:f(o).includes(s)}e.isTargetPlatformCompatible=E;function f(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=f;function u(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=u;var w;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var y;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var I;(function(s){s.Install="install",s.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var a;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(a=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var c;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(c=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class m extends Error{constructor(b,o){super(b);this.code=o,this.name=o}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=h.FileAccess.asBrowserUri("./media/defaultIcon.png",te).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(we[197],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class h{constructor(){this.validators=new Map}vsda(){return new Promise((k,A)=>te(["vsda"],k,A))}async createNewMessage(k){try{const A=await this.vsda(),S=new A.validator;if(S){const P=String(h._nextId++);return this.validators.set(P,S),{id:P,data:S.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const S=this.validators.get(k.id);if(!S)return!1;this.validators.delete(k.id);try{return S.validate(A)==="ok"}catch{return!1}}async sign(k){try{const A=await this.vsda(),S=new A.signer;if(S)return S.sign(k)}catch{}return k}}e.SignService=h,h._nextId=1}),define(we[198],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,A,S=5){let P;return P=A(C=>{const T=typeof C=="string"?C:C.data;let F=this._terminalBufferMap.get(k);if(F){F.data.push(T);return}const D=setTimeout(()=>this.flushBuffer(k),S);F={data:[T],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(k),P.dispose()}},this._terminalBufferMap.set(k,F)}),P}stopBuffering(k){const A=this._terminalBufferMap.get(k);A&&A.dispose()}flushBuffer(k){const A=this._terminalBufferMap.get(k);A&&(this._terminalBufferMap.delete(k),this._callback(k,A.data.join("")))}}e.TerminalDataBufferer=h}),define(we[199],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(we[84],be([1,0,73,3,6,4,50,199]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var C;(function(w){function y(I){return I&&typeof I=="object"&&typeof I.id=="string"}w.isThemeColor=y})(C=e.ThemeColor||(e.ThemeColor={}));function T(w){return{id:w}}e.themeColorFromId=T;var F;(function(w){function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||C.isThemeColor(n.color))}w.isThemeIcon=y;const I=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function a(n){const i=I.exec(n);if(!i)return;let[,r]=i;return{id:r}}w.fromString=a;function c(n){return{id:n}}w.fromId=c;function m(n,i){let r=n.id;const l=r.lastIndexOf("~");return l!==-1&&(r=r.substring(0,l)),i&&(r=`${r}~${i}`),{id:r}}w.modify=m;function s(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}w.getModifier=s;function b(n,i){return n.id===i.id&&n.color?.id===i.color?.id}w.isEqual=b;function o(n,i){return{id:n.id,color:i?T(i):void 0}}w.asThemeIcon=o,w.asClassNameArray=h.CSSIcon.asClassNameArray,w.asClassName=h.CSSIcon.asClassName,w.asCSSSelector=h.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function D(w){switch(w){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,k.toDisposable)(()=>{const I=this.themingParticipants.indexOf(y);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new g;S.Registry.add(e.Extensions.ThemingContribution,E);function f(w){return E.onColorThemeChange(w)}e.registerThemingParticipant=f;class u extends k.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,I){let a=this.theme.getColor(y);return a&&I&&(a=I(a,this.theme)),a?a.toString():null}}e.Themable=u}),define(we[124],be([1,0,3,12,4,11]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var S;(function(f){f.Http="http",f.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=D;function g(f,u){return u?u!==1&&f<1024:!t.isWindows&&f<1024}e.isPortPrivileged=g;let E=class{constructor(u){this.logService=u,this._onTunnelOpened=new h.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new h.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new h.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],w=Array.from(this._tunnels.values());for(let y of w){const I=Array.from(y.values());for(let a of I){const c=await a.value;c&&u.push(c)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:w}of u.values())await w.then(y=>y?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,w,y,I,a=!1,c=P.Private,m){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${y} on local port ${I}.`),!u)return;w||(w="localhost");const s=this.retainOrCreateTunnel(u,w,y,I,a,c,m);return s?s.then(b=>{if(!b){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(b);return(b.tunnelRemoteHost!==w||b.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const w=this._tunnels.get(u.tunnelRemoteHost);if(w){const y=w.get(u.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,y))}}}}async tryDisposeTunnel(u,w,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${w}.`);const I=y.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(w),I}}async closeTunnel(u,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${w} `);const y=this._tunnels.get(u);if(y&&y.has(w)){const I=y.get(w);I.refcount=0,await this.tryDisposeTunnel(u,w,I)}}addTunnelToMap(u,w,y){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(w,{refcount:1,value:y})}async removeEmptyTunnelFromMap(u,w){const y=this._tunnels.get(u);y&&(await y.get(w)||y.delete(w),y.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,w){let y=[u];F(u)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):D(u)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const I=y.map(a=>this._tunnels.get(a));for(const a of I){const c=a?.get(w);if(c)return c}}canTunnel(u){return!!T(u)}createWithProvider(u,w,y,I,a,c,m){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${y} on local port ${I}.`);const b={elevationRequired:a?g(I===void 0?y:I):!1},o={remoteAddress:{host:w,port:y},localAddressPort:I,privacy:c,public:c!==P.Private,protocol:m},n=u.forwardPort(o,b);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(w,y,n),n}};E=Be([Fe(0,A.ILogService)],E),e.AbstractTunnelService=E}),define(we[200],be([1,0,10]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(P){return P.scheme!==h.Schemas.file&&P.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=t;function k(P){if(P.folders.length)return P.folders.every(C=>t(C.uri))?P.folders[0].uri:void 0;if(P.configuration&&t(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=k;function A(P){return k(P)?.scheme}e.getVirtualWorkspaceScheme=A;function S(P){return k(P)!==void 0}e.isVirtualWorkspace=S}),define(we[43],be([1,0,24,22,2,4]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var S;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function P(g){const E=g;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=P;function C(g){const E=g;return!!(E&&typeof E=="object"&&k.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=C;class T{constructor(E,f,u,w,y){this._id=E,this._transient=u,this._configuration=w,this._ignorePathCasing=y,this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class F{constructor(E,f){this.raw=f,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,t.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function D(g){return new F({uri:g,index:0,name:(0,t.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=D}),define(we[201],be([1,0,28,57,143,79,10,9,12,22,2,167,4,83,43]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(x){return(typeof x=="string"?(0,P.extname)(x):(0,T.extname)(x))===u}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=(0,g.createDecorator)("workspacesService");function y(x){return x.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function I(x){return x.hasOwnProperty("folderUri")}e.isRecentFolder=I;function a(x){return x.hasOwnProperty("fileUri")}e.isRecentFile=a;function c(x){return x&&x.hasOwnProperty("folderUri")}e.isFolderBackupInfo=c;function m(x){return x&&x.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=m;function s(x){const B=x;return typeof B?.id=="string"&&F.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=s;function b(x){if(x.configuration)return{id:x.id,configPath:x.configuration};if(x.folders.length===1)return{id:x.id,uri:x.folders[0].uri}}e.toWorkspaceIdentifier=b;function o(x){const B=x;return typeof B?.id=="string"&&F.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=o;function n(x){const B=x;if(B?.uri)return{id:B.id,uri:F.URI.revive(B.uri)};const G=x;if(G?.configPath)return{id:G.id,configPath:F.URI.revive(G.configPath)};if(x?.id)return{id:x.id}}e.reviveIdentifier=n;function i(x,B){return T.extUriBiasedIgnorePathCase.isEqualOrParent(x,B.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function r(x){return l(x)||p(x)}e.isStoredWorkspaceFolder=r;function l(x){const B=x;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=l;function p(x){const B=x;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=p;function d(x,B,G,X,V=!C.isWindows,Z){if(x.scheme!==X.scheme)return{name:G,uri:x.toString(!0)};let se=B?void 0:Z.relativePath(X,x);if(se!==void 0)se.length===0?se=".":C.isWindows&&x.scheme===S.Schemas.file&&!V&&(se=se.replace(/\//g,"\\"));else if(x.scheme===S.Schemas.file)se=x.fsPath,C.isWindows&&(se=(0,A.normalizeDriveLetter)(se),V&&(se=(0,h.toSlashes)(se)));else{if(!Z.isEqualAuthority(x.authority,X.authority))return{name:G,uri:x.toString(!0)};se=x.path}return{name:G,path:se}}e.getStoredWorkspaceFolder=d;function v(x,B,G){let X=[],V=new Set;const Z=G.dirname(B);for(let se of x){let ce;if(l(se))se.path&&(ce=G.resolvePath(Z,se.path));else if(p(se))try{ce=F.URI.parse(se.uri),ce.path[0]!=="/"&&(ce=ce.with({path:"/"+ce.path}))}catch(ee){console.warn(ee)}if(ce){let ee=G.getComparisonKey(ce);if(!V.has(ee)){V.add(ee);const Q=se.name||G.basenameOrAuthority(ce);X.push(new f.WorkspaceFolder({uri:ce,name:Q,index:X.length},se))}}}return X}e.toWorkspaceFolders=v;function R(x,B,G,X,V){let Z=O(B,x);const se=V.dirname(B),ce=V.dirname(X),ee=[],Q=L(Z.folders);for(const ke of Z.folders){const Ne=l(ke)?V.resolvePath(se,ke.path):F.URI.parse(ke.uri);let _e;G?_e=!1:_e=!l(ke)||(0,P.isAbsolute)(ke.path),ee.push(d(Ne,_e,ke.name,ce,Q,V))}const oe={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},de=k.setProperty(x,["folders"],ee,oe);let ve=k.applyEdits(x,de);return(0,T.isEqualAuthority)(Z.remoteAuthority,(0,E.getRemoteAuthority)(X))&&(ve=k.applyEdits(ve,k.removeProperty(ve,["remoteAuthority"],oe))),ve}e.rewriteWorkspaceFileForNewLocation=R;function O(x,B){let G=t.parse(B);if(G&&Array.isArray(G.folders))G.folders=G.folders.filter(X=>r(X));else throw new Error(`${x} looks like an invalid workspace file.`);return G}function L(x){return C.isWindows?x.some(B=>l(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function _(x){return x.workspace&&typeof x.workspace=="object"&&typeof x.workspace.id=="string"&&typeof x.workspace.configPath=="string"}function U(x){return typeof x.folderUri=="string"}function M(x){return typeof x.fileUri=="string"}function q(x,B){const G={workspaces:[],files:[]};if(x){const X=function(Z,se){for(let ce=0;ce<Z.length;ce++)try{se(Z[ce],ce)}catch(ee){B.warn(`Error restoring recent entry ${JSON.stringify(Z[ce])}: ${ee.toString()}. Skip entry.`)}},V=x;if(Array.isArray(V.entries))X(V.entries,Z=>{const se=Z.label,ce=Z.remoteAuthority;_(Z)?G.workspaces.push({label:se,remoteAuthority:ce,workspace:{id:Z.workspace.id,configPath:F.URI.parse(Z.workspace.configPath)}}):U(Z)?G.workspaces.push({label:se,remoteAuthority:ce,folderUri:F.URI.parse(Z.folderUri)}):M(Z)&&G.files.push({label:se,remoteAuthority:ce,fileUri:F.URI.parse(Z.fileUri)})});else{const Z=x;Array.isArray(Z.workspaces3)&&X(Z.workspaces3,(se,ce)=>{const ee=Array.isArray(Z.workspaceLabels)&&Z.workspaceLabels[ce]||void 0;typeof se=="object"&&typeof se.id=="string"&&typeof se.configURIPath=="string"?G.workspaces.push({label:ee,workspace:{id:se.id,configPath:F.URI.parse(se.configURIPath)}}):typeof se=="string"&&G.workspaces.push({label:ee,folderUri:F.URI.parse(se)})}),Array.isArray(Z.files2)&&X(Z.files2,(se,ce)=>{const ee=Array.isArray(Z.fileLabels)&&Z.fileLabels[ce]||void 0;typeof se=="string"&&G.files.push({label:ee,fileUri:F.URI.parse(se)})})}}return G}e.restoreRecentlyOpened=q;function K(x){const B={entries:[]};for(const G of x.workspaces)I(G)?B.entries.push({folderUri:G.folderUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority}):B.entries.push({workspace:{id:G.workspace.id,configPath:G.workspace.configPath.toString()},label:G.label,remoteAuthority:G.remoteAuthority});for(const G of x.files)B.entries.push({fileUri:G.fileUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority});return B}e.toStoreData=K}),define(we[85],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const A=this._idPool++;return this._data.set(A,k),this.logDebugInfo(),A}get(k,A){return this._data.has(k)?this._data.get(k)[A]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(we[44],be([1,0,10,22,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(P=>{const C=this._providerInfo.get(P.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(P,C){C===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,C)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(we[26],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(we[202],be([1,0,13]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(S,P,C){this._deferredPromises=new Map,this._id=S,this._shared=P,this._storage=C,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of T.values())F.complete()}catch(F){for(const D of T.values())D.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this._init}get(S,P){let C=this._value[S];return typeof C=="undefined"&&(C=P),C}update(S,P){this._value[S]=P;let C=this._deferredPromises.get(S);if(C!==void 0)return C.p;const T=new h.DeferredPromise;return this._deferredPromises.set(S,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class k extends t{constructor(S,P){super(S.identifier.value,!0,P);this._extension=S}setKeysForSync(S){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},S)}}e.ExtensionGlobalMemento=k}),define(we[203],be([1,0,3,2,11]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(P,C){this._logService=P,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,C,T){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptModelChanged(C.value,T)}$acceptDirtyStateChanged(P,C){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptDirty(C)}$acceptModelSaved(P){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(P,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,C);const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));T.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=Be([Fe(0,k.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(we[14],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[204],be([1,0,27,3]),function(te,e,h,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,C){k.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(P.identifier),Ke(this,k,C,"f"),Te(this,k,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(P){return Te(this,k,"f").get(this._id,P)}store(P,C){return Te(this,k,"f").store(this._id,P,C)}delete(P){return Te(this,k,"f").delete(this._id,P)}}e.ExtensionSecrets=A,k=new WeakMap}),define(we[125],be([1,0,4,3]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(S){this._level=S}$onDidChangeTelemetryLevel(S){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=S,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(we[63],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(I){I[I.Upsert=0]="Upsert",I[I.RemoveChild=1]="RemoveChild",I[I.Invalidated=2]="Invalidated",I[I.SetProp=3]="SetProp",I[I.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,k=(I,a)=>{const c={controllerId:a};return t.set(I,c),c};e.createPrivateApiFor=k;const A=I=>t.get(I);e.getPrivateApiFor=A;const S=(I,a,c,m)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(b){if(!m(s,b)){const o=s;s=b,I.listener?.({op:3,key:a,value:b,previous:o})}}}},P=(I,a)=>I===a,C={range:(I,a)=>I===a?!0:!I||!a?!1:I.isEqual(a),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(I,a)=>!(I.length!==a.length||I.some(c=>!a.find(m=>c.id===m.id)))},T=Object.keys(C),F=(I,a)=>({range:S(I,"range",void 0,C.range),label:S(I,"label",a,C.label),description:S(I,"description",void 0,C.description),sortText:S(I,"sortText",void 0,C.sortText),canResolveChildren:S(I,"canResolveChildren",!1,C.canResolveChildren),busy:S(I,"busy",!1,C.busy),error:S(I,"error",void 0,C.error),tags:S(I,"tags",[],C.tags)}),D=(I,a)=>{const c=new Map;for(const m of T)C[m](I[m],a[m])||c.set(m,a[m]);return c};e.diffTestItems=D;class g extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=g;class E extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class f extends Error{constructor(a,c,m){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=f;const u=I=>{const a=(0,e.getPrivateApiFor)(I);let c=new Map;return{get size(){return c.size},forEach(m,s){for(const b of c.values())m.call(s,b,this)},replace(m){const s=new Map,b=new Set(c.keys()),o={op:4,ops:[]};for(const n of m){if(!(n instanceof w))throw new E(n.id);const i=(0,e.getPrivateApiFor)(n).controllerId;if(i!==a.controllerId)throw new f(n.id,i,a.controllerId);if(s.has(n.id))throw new g(n.id);s.set(n.id,n),b.delete(n.id),o.ops.push({op:0,item:n})}for(const n of b.keys())o.ops.push({op:1,id:n});a.listener?.(o),c=s},add(m){if(!(m instanceof w))throw new E(m.id);c.set(m.id,m),a.listener?.({op:0,item:m})},delete(m){c.delete(m)&&a.listener?.({op:1,id:m})},get(m){return c.get(m)},toJSON(){return Array.from(c.values())},[Symbol.iterator](){return c.values()}}};class w{constructor(a,c,m,s){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const b=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return b.parent instanceof y?void 0:b.parent}},children:{value:u(this),enumerable:!0,writable:!1},...F(b,m)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class y extends w{constructor(a,c){super(a,a,c,void 0)}}e.TestItemRootImpl=y}),define(we[51],be([1,0,4,124,3,14]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(C){function T(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:D.protocol}}C.fromApiTunnel=T;function F(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==t.TunnelPrivacyId.ConstantPrivate&&D.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}C.fromServiceTunnel=F})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let P=class{constructor(T){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,F){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,F){return{dispose:()=>{}}}async $providePortAttributes(T,F,D,g,E){return[]}async $forwardPort(T,F){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Be([Fe(0,A.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[7],be([1,0,17,16,102,24,95,8,18,2,33,42,122]),function(te,e,h,t,k,A,S,P,C,T,F,D,g){"use strict";var E,f,u,w,y,I,a,c,m,s,b,o,n,i,r,l,p,d,v,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O(Y){function H(){return Reflect.construct(Y,arguments,this.constructor)}return Object.defineProperty(H,"name",Object.getOwnPropertyDescriptor(Y,"name")),Object.setPrototypeOf(H,Y),Object.setPrototypeOf(H.prototype,Y.prototype),H}let L=y=class{constructor(H){E.set(this,void 0),Ke(this,E,H,"f")}static from(...H){let ue=H;return new y(function(){if(ue){for(const De of ue)De&&typeof De.dispose=="function"&&De.dispose();ue=void 0}})}dispose(){typeof Te(this,E,"f")=="function"&&(Te(this,E,"f").call(this),Ke(this,E,void 0,"f"))}};E=new WeakMap,L=y=Be([O],L),e.Disposable=L;let _=I=class{constructor(H,ue){if(H<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=H,this._character=ue}static Min(...H){if(H.length===0)throw new TypeError;let ue=H[0];for(let De=1;De<H.length;De++){const qe=H[De];qe.isBefore(ue)&&(ue=qe)}return ue}static Max(...H){if(H.length===0)throw new TypeError;let ue=H[0];for(let De=1;De<H.length;De++){const qe=H[De];qe.isAfter(ue)&&(ue=qe)}return ue}static isPosition(H){if(!H)return!1;if(H instanceof I)return!0;let{line:ue,character:De}=H;return typeof ue=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,ue=0){if(H===null||ue===null)throw(0,t.illegalArgument)();let De;return typeof H=="undefined"?De=0:typeof H=="number"?De=H:(De=typeof H.lineDelta=="number"?H.lineDelta:0,ue=typeof H.characterDelta=="number"?H.characterDelta:0),De===0&&ue===0?this:new I(this.line+De,this.character+ue)}with(H,ue=this.character){if(H===null||ue===null)throw(0,t.illegalArgument)();let De;return typeof H=="undefined"?De=this.line:typeof H=="number"?De=H:(De=typeof H.line=="number"?H.line:this.line,ue=typeof H.character=="number"?H.character:this.character),De===this.line&&ue===this.character?this:new I(De,ue)}toJSON(){return{line:this.line,character:this.character}}};_=I=Be([O],_),e.Position=_;let U=a=class{constructor(H,ue,De,qe){let Xe,Ze;if(typeof H=="number"&&typeof ue=="number"&&typeof De=="number"&&typeof qe=="number"?(Xe=new _(H,ue),Ze=new _(De,qe)):H instanceof _&&ue instanceof _&&(Xe=H,Ze=ue),!Xe||!Ze)throw new Error("Invalid arguments");Xe.isBefore(Ze)?(this._start=Xe,this._end=Ze):(this._start=Ze,this._end=Xe)}static isRange(H){return H instanceof a?!0:H?_.isPosition(H.start)&&_.isPosition(H.end):!1}get start(){return this._start}get end(){return this._end}contains(H){return H instanceof a?this.contains(H._start)&&this.contains(H._end):H instanceof _?!(H.isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const ue=_.Max(H.start,this._start),De=_.Min(H.end,this._end);if(!ue.isAfter(De))return new a(ue,De)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const ue=_.Min(H.start,this._start),De=_.Max(H.end,this.end);return new a(ue,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,ue=this.end){if(H===null||ue===null)throw(0,t.illegalArgument)();let De;return H?_.isPosition(H)?De=H:(De=H.start||this.start,ue=H.end||this.end):De=this.start,De.isEqual(this._start)&&ue.isEqual(this.end)?this:new a(De,ue)}toJSON(){return[this.start,this.end]}};U=a=Be([O],U),e.Range=U;let M=c=class extends U{constructor(H,ue,De,qe){let Xe,Ze;if(typeof H=="number"&&typeof ue=="number"&&typeof De=="number"&&typeof qe=="number"?(Xe=new _(H,ue),Ze=new _(De,qe)):H instanceof _&&ue instanceof _&&(Xe=H,Ze=ue),!Xe||!Ze)throw new Error("Invalid arguments");super(Xe,Ze);this._anchor=Xe,this._active=Ze}static isSelection(H){return H instanceof c?!0:H?U.isRange(H)&&_.isPosition(H.anchor)&&_.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=c=Be([O],M),e.Selection=M;class q{constructor(H,ue,De){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,t.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(ue),this.connectionToken=De}}e.ResolvedAuthority=q;class K extends Error{constructor(H,ue=g.RemoteAuthorityResolverErrorCode.Unknown,De){super(H);this._message=H,this._code=ue,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,K.prototype)}static NotAvailable(H,ue){return new K(H,g.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(H){return new K(H,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=K;var x;(function(Y){Y[Y.LF=1]="LF",Y[Y.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var B;(function(Y){Y[Y.Replace=1]="Replace",Y[Y.Append=2]="Append",Y[Y.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=m=class{constructor(H,ue){this._range=H,this._newText=ue}static isTextEdit(H){return H instanceof m?!0:H?U.isRange(H)&&typeof H.newText=="string":!1}static replace(H,ue){return new m(H,ue)}static insert(H,ue){return m.replace(new U(H,H),ue)}static delete(H){return m.replace(H,"")}static setEndOfLine(H){const ue=new m(new U(new _(0,0),new _(0,0)),"");return ue.newEol=H,ue}get range(){return this._range}set range(H){if(H&&!U.isRange(H))throw(0,t.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,t.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,t.illegalArgument)("newEol");this._newEol=H}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=m=Be([O],G),e.TextEdit=G;var X;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.Cell=3]="Cell",Y[Y.CellReplace=5]="CellReplace"})(X=e.FileEditType||(e.FileEditType={}));let V=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,ue,De,qe){this._edits.push({_type:1,from:H,to:ue,options:De,metadata:qe})}createFile(H,ue,De){this._edits.push({_type:1,from:void 0,to:H,options:ue,metadata:De})}deleteFile(H,ue,De){this._edits.push({_type:1,from:H,to:void 0,options:ue,metadata:De})}replaceNotebookMetadata(H,ue,De){this._edits.push({_type:3,metadata:De,uri:H,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(H,ue,De,qe,Xe){let Ze,it,yt=[],At;if(Qt.isNotebookRange(ue)&&zt.isNotebookCellDataArray(De)&&!zt.isNotebookCellDataArray(qe)?(Ze=ue.start,it=ue.end,yt=De,At=qe):typeof ue=="number"&&typeof De=="number"&&zt.isNotebookCellDataArray(qe)&&(Ze=ue,it=De,yt=qe,At=Xe),Ze===void 0||it===void 0)throw new Error("Invalid arguments");(Ze!==it||yt.length>0)&&this._edits.push({_type:5,uri:H,index:Ze,count:it-Ze,cells:yt,metadata:At})}replaceNotebookCellMetadata(H,ue,De,qe){this._edits.push({_type:3,metadata:qe,uri:H,edit:{editType:8,index:ue,metadata:De}})}replace(H,ue,De,qe){this._edits.push({_type:2,uri:H,edit:new G(ue,De),metadata:qe})}insert(H,ue,De,qe){this.replace(H,new U(ue,ue),De,qe)}delete(H,ue,De){this.replace(H,ue,"",De)}has(H){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===H.toString())}set(H,ue){if(ue)for(const De of ue)De&&this._edits.push({_type:2,uri:H,edit:De});else{for(let De=0;De<this._edits.length;De++){const qe=this._edits[De];qe._type===2&&qe.uri.toString()===H.toString()&&(this._edits[De]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(H){const ue=[];for(let De of this._edits)De._type===2&&De.uri.toString()===H.toString()&&ue.push(De.edit);return ue}entries(){const H=new A.ResourceMap;for(let ue of this._edits)if(ue._type===2){let De=H.get(ue.uri);De||(De=[ue.uri,[]],H.set(ue.uri,De)),De[1].push(ue.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};V=Be([O],V),e.WorkspaceEdit=V;let Z=s=class{constructor(H){this._tabstop=1,this.value=H||""}static isSnippetString(H){return H instanceof s?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}appendText(H){return this.value+=s._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,ue=this._tabstop++){if(typeof H=="function"){const De=new s;De._tabstop=this._tabstop,H(De),this._tabstop=De._tabstop,H=De.value}else H=s._escape(H);return this.value+="${",this.value+=ue,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,ue=this._tabstop++){const De=H.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(H,ue){if(typeof ue=="function"){const De=new s;De._tabstop=this._tabstop,ue(De),this._tabstop=De._tabstop,ue=De.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};Z=s=Be([O],Z),e.SnippetString=Z;var se;(function(Y){Y[Y.Unnecessary=1]="Unnecessary",Y[Y.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ce;(function(Y){Y[Y.Hint=3]="Hint",Y[Y.Information=2]="Information",Y[Y.Warning=1]="Warning",Y[Y.Error=0]="Error"})(ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ee=b=class{constructor(H,ue){if(this.uri=H,ue)if(ue instanceof U)this.range=ue;else if(ue instanceof _)this.range=new U(ue,ue);else throw new Error("Illegal argument")}static isLocation(H){return H instanceof b?!0:H?U.isRange(H.range)&&T.URI.isUri(H.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ee=b=Be([O],ee),e.Location=ee;let Q=class{constructor(H,ue){this.location=H,this.message=ue}static is(H){return H?typeof H.message=="string"&&H.location&&U.isRange(H.location.range)&&T.URI.isUri(H.location.uri):!1}static isEqual(H,ue){return H===ue?!0:!H||!ue?!1:H.message===ue.message&&H.location.range.isEqual(ue.location.range)&&H.location.uri.toString()===ue.location.uri.toString()}};Q=Be([O],Q),e.DiagnosticRelatedInformation=Q;let oe=class{constructor(H,ue,De=ce.Error){if(!U.isRange(H))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=H,this.message=ue,this.severity=De}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,ue){return H===ue?!0:!H||!ue?!1:H.message===ue.message&&H.severity===ue.severity&&H.code===ue.code&&H.severity===ue.severity&&H.source===ue.source&&H.range.isEqual(ue.range)&&(0,h.equals)(H.tags,ue.tags)&&(0,h.equals)(H.relatedInformation,ue.relatedInformation,Q.isEqual)}};oe=Be([O],oe),e.Diagnostic=oe;let de=class{constructor(H,ue){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=ue}};de=Be([O],de),e.Hover=de;var ve;(function(Y){Y[Y.Text=0]="Text",Y[Y.Read=1]="Read",Y[Y.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ke=class{constructor(H,ue=ve.Text){this.range=H,this.kind=ue}toJSON(){return{range:this.range,kind:ve[this.kind]}}};ke=Be([O],ke),e.DocumentHighlight=ke;var Ne;(function(Y){Y[Y.File=0]="File",Y[Y.Module=1]="Module",Y[Y.Namespace=2]="Namespace",Y[Y.Package=3]="Package",Y[Y.Class=4]="Class",Y[Y.Method=5]="Method",Y[Y.Property=6]="Property",Y[Y.Field=7]="Field",Y[Y.Constructor=8]="Constructor",Y[Y.Enum=9]="Enum",Y[Y.Interface=10]="Interface",Y[Y.Function=11]="Function",Y[Y.Variable=12]="Variable",Y[Y.Constant=13]="Constant",Y[Y.String=14]="String",Y[Y.Number=15]="Number",Y[Y.Boolean=16]="Boolean",Y[Y.Array=17]="Array",Y[Y.Object=18]="Object",Y[Y.Key=19]="Key",Y[Y.Null=20]="Null",Y[Y.EnumMember=21]="EnumMember",Y[Y.Struct=22]="Struct",Y[Y.Event=23]="Event",Y[Y.Operator=24]="Operator",Y[Y.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var _e;(function(Y){Y[Y.Deprecated=1]="Deprecated"})(_e=e.SymbolTag||(e.SymbolTag={}));let Ee=o=class{constructor(H,ue,De,qe,Xe){this.name=H,this.kind=ue,this.containerName=Xe,typeof De=="string"&&(this.containerName=De),qe instanceof ee?this.location=qe:De instanceof U&&(this.location=new ee(qe,De)),o.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};Ee=o=Be([O],Ee),e.SymbolInformation=Ee;let z=n=class{constructor(H,ue,De,qe,Xe){this.name=H,this.detail=ue,this.kind=De,this.range=qe,this.selectionRange=Xe,this.children=[],n.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children&&H.children.forEach(n.validate)}};z=n=Be([O],z),e.DocumentSymbol=z;var W;(function(Y){Y[Y.Invoke=1]="Invoke",Y[Y.Automatic=2]="Automatic"})(W=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let N=class{constructor(H,ue){this.title=H,this.kind=ue}};N=Be([O],N),e.CodeAction=N;let $=i=class{constructor(H){this.value=H}append(H){return new i(this.value?this.value+i.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+i.sep)}};$.sep=".",$=i=Be([O],$),e.CodeActionKind=$,$.Empty=new $(""),$.QuickFix=$.Empty.append("quickfix"),$.Refactor=$.Empty.append("refactor"),$.RefactorExtract=$.Refactor.append("extract"),$.RefactorInline=$.Refactor.append("inline"),$.RefactorRewrite=$.Refactor.append("rewrite"),$.Source=$.Empty.append("source"),$.SourceOrganizeImports=$.Source.append("organizeImports"),$.SourceFixAll=$.Source.append("fixAll");let j=class{constructor(H,ue){if(this.range=H,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};j=Be([O],j),e.SelectionRange=j;class re{constructor(H,ue,De,qe,Xe,Ze){this.kind=H,this.name=ue,this.detail=De,this.uri=qe,this.range=Xe,this.selectionRange=Ze}}e.CallHierarchyItem=re;class he{constructor(H,ue){this.fromRanges=ue,this.from=H}}e.CallHierarchyIncomingCall=he;class Ce{constructor(H,ue){this.fromRanges=ue,this.to=H}}e.CallHierarchyOutgoingCall=Ce;var Ae;(function(Y){Y[Y.Information=0]="Information",Y[Y.Warning=1]="Warning",Y[Y.Error=2]="Error"})(Ae=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let We=class{constructor(H,ue){this.range=H,this.command=ue}get isResolved(){return!!this.command}};We=Be([O],We),e.CodeLens=We;let $e=r=class{constructor(H,ue=!1){f.set(this,void 0),Ke(this,f,new k.MarkdownString(H,{supportThemeIcons:ue}),"f")}static isMarkdownString(H){return H instanceof r?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}get value(){return Te(this,f,"f").value}set value(H){Te(this,f,"f").value=H}get isTrusted(){return Te(this,f,"f").isTrusted}set isTrusted(H){Te(this,f,"f").isTrusted=H}get supportThemeIcons(){return Te(this,f,"f").supportThemeIcons}set supportThemeIcons(H){Te(this,f,"f").supportThemeIcons=H}get supportHtml(){return Te(this,f,"f").supportHtml}set supportHtml(H){Te(this,f,"f").supportHtml=H}get baseUri(){return Te(this,f,"f").baseUri}set baseUri(H){Te(this,f,"f").baseUri=H}appendText(H){return Te(this,f,"f").appendText(H),this}appendMarkdown(H){return Te(this,f,"f").appendMarkdown(H),this}appendCodeblock(H,ue){return Te(this,f,"f").appendCodeblock(ue??"",H),this}};f=new WeakMap,$e=r=Be([O],$e),e.MarkdownString=$e;let je=class{constructor(H,ue){this.label=H,this.documentation=ue}};je=Be([O],je),e.ParameterInformation=je;let He=class{constructor(H,ue){this.label=H,this.documentation=ue,this.parameters=[]}};He=Be([O],He),e.SignatureInformation=He;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=Be([O],Ue),e.SignatureHelp=Ue;var Qe;(function(Y){Y[Y.Invoke=1]="Invoke",Y[Y.TriggerCharacter=2]="TriggerCharacter",Y[Y.ContentChange=3]="ContentChange"})(Qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(Y){Y[Y.Other=0]="Other",Y[Y.Type=1]="Type",Y[Y.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Re=class{constructor(H){this.value=H}};Re=Be([O],Re),e.InlayHintLabelPart=Re;let tt=class{constructor(H,ue,De){this.position=H,this.label=ue,this.kind=De}};tt=Be([O],tt),e.InlayHint=tt;var ie;(function(Y){Y[Y.Invoke=0]="Invoke",Y[Y.TriggerCharacter=1]="TriggerCharacter",Y[Y.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Y){Y[Y.Text=0]="Text",Y[Y.Method=1]="Method",Y[Y.Function=2]="Function",Y[Y.Constructor=3]="Constructor",Y[Y.Field=4]="Field",Y[Y.Variable=5]="Variable",Y[Y.Class=6]="Class",Y[Y.Interface=7]="Interface",Y[Y.Module=8]="Module",Y[Y.Property=9]="Property",Y[Y.Unit=10]="Unit",Y[Y.Value=11]="Value",Y[Y.Enum=12]="Enum",Y[Y.Keyword=13]="Keyword",Y[Y.Snippet=14]="Snippet",Y[Y.Color=15]="Color",Y[Y.File=16]="File",Y[Y.Reference=17]="Reference",Y[Y.Folder=18]="Folder",Y[Y.EnumMember=19]="EnumMember",Y[Y.Constant=20]="Constant",Y[Y.Struct=21]="Struct",Y[Y.Event=22]="Event",Y[Y.Operator=23]="Operator",Y[Y.TypeParameter=24]="TypeParameter",Y[Y.User=25]="User",Y[Y.Issue=26]="Issue"})(ae=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(Y){Y[Y.Deprecated=1]="Deprecated"})(J=e.CompletionItemTag||(e.CompletionItemTag={}));let pe=class{constructor(H,ue){this.label=H,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&ae[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pe=Be([O],pe),e.CompletionItem=pe;let Se=class{constructor(H=[],ue=!1){this.items=H,this.isIncomplete=ue}};Se=Be([O],Se),e.CompletionList=Se;let Me=class{constructor(H,ue,De){this.text=H,this.range=ue,this.command=De}};Me=Be([O],Me),e.InlineSuggestion=Me;let ze=class{constructor(H){this.items=H}};ze=Be([O],ze),e.InlineSuggestions=ze;var Ye;(function(Y){Y[Y.Active=-1]="Active",Y[Y.Beside=-2]="Beside",Y[Y.One=1]="One",Y[Y.Two=2]="Two",Y[Y.Three=3]="Three",Y[Y.Four=4]="Four",Y[Y.Five=5]="Five",Y[Y.Six=6]="Six",Y[Y.Seven=7]="Seven",Y[Y.Eight=8]="Eight",Y[Y.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var st;(function(Y){Y[Y.Left=1]="Left",Y[Y.Right=2]="Right"})(st=e.StatusBarAlignment||(e.StatusBarAlignment={}));var pt;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative"})(pt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var mt;(function(Y){Y[Y.Manual=1]="Manual",Y[Y.AfterDelay=2]="AfterDelay",Y[Y.FocusOut=3]="FocusOut"})(mt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ve;(function(Y){Y[Y.Default=0]="Default",Y[Y.InCenter=1]="InCenter",Y[Y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Y[Y.AtTop=3]="AtTop"})(Ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ot;(function(Y){Y[Y.Keyboard=1]="Keyboard",Y[Y.Mouse=2]="Mouse",Y[Y.Command=3]="Command"})(ot=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var _t;(function(Y){Y[Y.Undo=1]="Undo",Y[Y.Redo=2]="Redo"})(_t=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(Y){Y[Y.OpenOpen=0]="OpenOpen",Y[Y.ClosedClosed=1]="ClosedClosed",Y[Y.OpenClosed=2]="OpenClosed",Y[Y.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(Y){function H(ue){switch(ue){case"keyboard":return Y.Keyboard;case"mouse":return Y.Mouse;case"api":return Y.Command}}Y.fromValue=H}(ot=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let lt=class{constructor(H,ue){if(ue&&!T.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!U.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.target=ue}};lt=Be([O],lt),e.DocumentLink=lt;let Rt=class{constructor(H,ue,De,qe){this.red=H,this.green=ue,this.blue=De,this.alpha=qe}};Rt=Be([O],Rt),e.Color=Rt;let It=class{constructor(H,ue){if(ue&&!(ue instanceof Rt))throw(0,t.illegalArgument)("color");if(!U.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.color=ue}};It=Be([O],It),e.ColorInformation=It;let kt=class{constructor(H){if(!H||typeof H!="string")throw(0,t.illegalArgument)("label");this.label=H}};kt=Be([O],kt),e.ColorPresentation=kt;var dt;(function(Y){Y[Y.RGB=0]="RGB",Y[Y.HEX=1]="HEX",Y[Y.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var Ot;(function(Y){Y[Y.Error=0]="Error",Y[Y.Warning=1]="Warning",Y[Y.Information=2]="Information"})(Ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Mt{constructor(H,ue,De){if(this.startIndex=H,this.length=ue,this.tooltip=De,typeof H!="number"||H<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Mt;var Ft;(function(Y){Y[Y.Panel=1]="Panel",Y[Y.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class fe{constructor(H){this.options=H,typeof H!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=fe;var Ie;(function(Y){Y[Y.Always=1]="Always",Y[Y.Silent=2]="Silent",Y[Y.Never=3]="Never"})(Ie=e.TaskRevealKind||(e.TaskRevealKind={}));var ge;(function(Y){Y[Y.Shared=1]="Shared",Y[Y.Dedicated=2]="Dedicated",Y[Y.New=3]="New"})(ge=e.TaskPanelKind||(e.TaskPanelKind={}));let ne=l=class{constructor(H,ue){if(this.label=ue,typeof H!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=H}static from(H){switch(H){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};ne.Clean=new l("clean","Clean"),ne.Build=new l("build","Build"),ne.Rebuild=new l("rebuild","Rebuild"),ne.Test=new l("test","Test"),ne=l=Be([O],ne),e.TaskGroup=ne;function ye(Y){let H="";for(let ue=0;ue<Y.length;ue++)H+=Y[ue].replace(/,/g,",,")+",";return H}let Le=class{constructor(H,ue,De){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=H,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=De):this._options=ue)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)H.push(ue);return ye(H)}};Le=Be([O],Le),e.ProcessExecution=Le;let xe=class{constructor(H,ue,De){if(this._args=[],Array.isArray(ue)){if(!H)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H,this._args=ue,this._options=De}else{if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)H.push(typeof ue=="string"?ue:ue.value);return ye(H)}};xe=Be([O],xe),e.ShellExecution=xe;var Ge;(function(Y){Y[Y.Escape=1]="Escape",Y[Y.Strong=2]="Strong",Y[Y.Weak=3]="Weak"})(Ge=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function(Y){Y[Y.Global=1]="Global",Y[Y.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class vt{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=vt;let St=p=class{constructor(H,ue,De,qe,Xe,Ze){this.__deprecated=!1,this._definition=this.definition=H;let it;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=De,this.execution=qe,it=Xe,this.__deprecated=!0):ue===ct.Global||ue===ct.Workspace?(this.target=ue,this._name=this.name=De,this._source=this.source=qe,this.execution=Xe,it=Ze):(this.target=ue,this._name=this.name=De,this._source=this.source=qe,this.execution=Xe,it=Ze),typeof it=="string"?(this._problemMatchers=[it],this._hasDefinedMatchers=!0):Array.isArray(it)?(this._problemMatchers=it,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Le?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const ue=this._definition.type;(p.EmptyType===ue||p.ProcessType===ue||p.ShellType===ue||p.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};St.ExtensionCallbackType="customExecution",St.ProcessType="process",St.ShellType="shell",St.EmptyType="$empty",St=p=Be([O],St),e.Task=St;var Et;(function(Y){Y[Y.SourceControl=1]="SourceControl",Y[Y.Window=10]="Window",Y[Y.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));let rt=class{constructor(H,ue=ut.None){this.collapsibleState=ue,T.URI.isUri(H)?this.resourceUri=H:this.label=H}};rt=Be([O],rt),e.TreeItem=rt;var ut;(function(Y){Y[Y.None=0]="None",Y[Y.Collapsed=1]="Collapsed",Y[Y.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let wt=class{constructor(H){this.value=H}async asString(){return JSON.stringify(this.value)}};wt=Be([O],wt),e.TreeDataTransferItem=wt;let Nt=class{constructor(){this._items=new Map}get(H){return this._items.get(H)}set(H,ue){this._items.set(H,ue)}forEach(H){this._items.forEach(H)}};Nt=Be([O],Nt),e.TreeDataTransfer=Nt;let ht=class{constructor(H,ue){this.id=H,this.color=ue}};ht=Be([O],ht),e.ThemeIcon=ht,ht.File=new ht("file"),ht.Folder=new ht("folder");let Pt=class{constructor(H){this.id=H}};Pt=Be([O],Pt),e.ThemeColor=Pt;var Ut;(function(Y){Y[Y.Global=1]="Global",Y[Y.Workspace=2]="Workspace",Y[Y.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(H,ue){if(typeof H!="string"&&(!H||!T.URI.isUri(H)&&!T.URI.isUri(H.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof H=="string"?this.baseUri=T.URI.file(H):T.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=ue}get base(){return this._base}set base(H){this._base=H,this._baseUri=T.URI.file(H)}get baseUri(){return this._baseUri}set baseUri(H){this._baseUri=H,this._base=H.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ct=Be([O],Ct),e.RelativePattern=Ct;let Bt=class{constructor(H,ue,De,qe){this.enabled=typeof H=="boolean"?H:!0,typeof ue=="string"&&(this.condition=ue),typeof De=="string"&&(this.hitCondition=De),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Bt=Be([O],Bt),e.Breakpoint=Bt;let xt=class extends Bt{constructor(H,ue,De,qe,Xe){super(ue,De,qe,Xe);if(H===null)throw(0,t.illegalArgument)("location");this.location=H}};xt=Be([O],xt),e.SourceBreakpoint=xt;let gt=class extends Bt{constructor(H,ue,De,qe,Xe){super(ue,De,qe,Xe);this.functionName=H}};gt=Be([O],gt),e.FunctionBreakpoint=gt;let en=class extends Bt{constructor(H,ue,De,qe,Xe,Ze,it){super(qe,Xe,Ze,it);if(!ue)throw(0,t.illegalArgument)("dataId");this.label=H,this.dataId=ue,this.canPersist=De}};en=Be([O],en),e.DataBreakpoint=en;let Yt=class{constructor(H,ue,De){this.command=H,this.args=ue||[],this.options=De}};Yt=Be([O],Yt),e.DebugAdapterExecutable=Yt;let tn=class{constructor(H,ue){this.port=H,this.host=ue}};tn=Be([O],tn),e.DebugAdapterServer=tn;let an=class{constructor(H){this.path=H}};an=Be([O],an),e.DebugAdapterNamedPipeServer=an;let Tt=class{constructor(H){this.implementation=H}};Tt=Be([O],Tt),e.DebugAdapterInlineImplementation=Tt;let nn=class{constructor(H,ue){this.range=H,this.expression=ue}};nn=Be([O],nn),e.EvaluatableExpression=nn;var Sn;(function(Y){Y[Y.Automatic=0]="Automatic",Y[Y.Explicit=1]="Explicit"})(Sn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Kt=class{constructor(H,ue){this.range=H,this.text=ue}};Kt=Be([O],Kt),e.InlineValueText=Kt;let Xt=class{constructor(H,ue,De=!0){this.range=H,this.variableName=ue,this.caseSensitiveLookup=De}};Xt=Be([O],Xt),e.InlineValueVariableLookup=Xt;let at=class{constructor(H,ue){this.range=H,this.expression=ue}};at=Be([O],at),e.InlineValueEvaluatableExpression=at;let ln=class{constructor(H,ue){this.frameId=H,this.stoppedLocation=ue}};ln=Be([O],ln),e.InlineValueContext=ln;var Vt;(function(Y){Y[Y.Changed=1]="Changed",Y[Y.Created=2]="Created",Y[Y.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let jt=d=class extends Error{constructor(H,ue=D.FileSystemProviderErrorCode.Unknown,De){super(T.URI.isUri(H)?H.toString(!0):H);this.code=De?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(H){return new d(H,D.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(H){return new d(H,D.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(H){return new d(H,D.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(H){return new d(H,D.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(H){return new d(H,D.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(H){return new d(H,D.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}};jt=d=Be([O],jt),e.FileSystemError=jt;let rn=class{constructor(H,ue,De){this.start=H,this.end=ue,this.kind=De}};rn=Be([O],rn),e.FoldingRange=rn;var Cn;(function(Y){Y[Y.Comment=1]="Comment",Y[Y.Imports=2]="Imports",Y[Y.Region=3]="Region"})(Cn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var pn;(function(Y){Y[Y.Collapsed=0]="Collapsed",Y[Y.Expanded=1]="Expanded"})(pn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var yn;(function(Y){Y[Y.Editing=0]="Editing",Y[Y.Preview=1]="Preview"})(yn=e.CommentMode||(e.CommentMode={}));class vn{constructor(H,ue=[]){this.tokenTypes=H,this.tokenModifiers=ue}}e.SemanticTokensLegend=vn;function sn(Y){return typeof Y=="undefined"||(0,C.isStringArray)(Y)}class cn{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let ue=0,De=H.tokenTypes.length;ue<De;ue++)this._tokenTypeStrToInt.set(H.tokenTypes[ue],ue);for(let ue=0,De=H.tokenModifiers.length;ue<De;ue++)this._tokenModifierStrToInt.set(H.tokenModifiers[ue],ue)}}push(H,ue,De,qe,Xe){if(typeof H=="number"&&typeof ue=="number"&&typeof De=="number"&&typeof qe=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(H,ue,De,qe,Xe);if(U.isRange(H)&&typeof ue=="string"&&sn(De))return this._push(H,ue,De);throw(0,t.illegalArgument)()}_push(H,ue,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const qe=H.start.line,Xe=H.start.character,Ze=H.end.character-H.start.character,it=this._tokenTypeStrToInt.get(ue);let yt=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(At);yt|=1<<Wt>>>0}this._pushEncoded(qe,Xe,Ze,it,yt)}_pushEncoded(H,ue,De,qe,Xe){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Wt=0;for(let Ht=0;Ht<yt;Ht++){let qt=this._data[5*Ht],mn=this._data[5*Ht+1];qt===0?(qt=At,mn+=Wt):qt+=At,this._data[5*Ht]=qt,this._data[5*Ht+1]=mn,At=qt,Wt=mn}}let Ze=H,it=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ze-=this._prevLine,Ze===0&&(it-=this._prevChar)),this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=it,this._data[this._dataLen++]=De,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Xe,this._prevLine=H,this._prevChar=ue}static _sortAndDeltaEncode(H){let ue=[];const De=H.length/5|0;for(let it=0;it<De;it++)ue[it]=it;ue.sort((it,yt)=>{const At=H[5*it],Wt=H[5*yt];if(At===Wt){const Ht=H[5*it+1],qt=H[5*yt+1];return Ht-qt}return At-Wt});const qe=new Uint32Array(H.length);let Xe=0,Ze=0;for(let it=0;it<De;it++){const yt=5*ue[it],At=H[yt+0],Wt=H[yt+1],Ht=H[yt+2],qt=H[yt+3],mn=H[yt+4],xn=At-Xe,Jn=xn===0?Wt-Ze:Wt,gn=5*it;qe[gn+0]=xn,qe[gn+1]=Jn,qe[gn+2]=Ht,qe[gn+3]=qt,qe[gn+4]=mn,Xe=At,Ze=Wt}return qe}build(H){return this._dataIsSortedAndDeltaEncoded?new Jt(new Uint32Array(this._data),H):new Jt(cn._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=cn;class Jt{constructor(H,ue){this.resultId=ue,this.data=H}}e.SemanticTokens=Jt;class un{constructor(H,ue,De){this.start=H,this.deleteCount=ue,this.data=De}}e.SemanticTokensEdit=un;class Dn{constructor(H,ue){this.resultId=ue,this.edits=H}}e.SemanticTokensEdits=Dn;var In;(function(Y){Y[Y.Separate=0]="Separate",Y[Y.MergeWithParent=1]="MergeWithParent"})(In=e.DebugConsoleMode||(e.DebugConsoleMode={}));let $t=class{constructor(){}};$t.Back={iconPath:new ht("arrow-left")},$t=Be([O],$t),e.QuickInputButtons=$t;var kn;(function(Y){Y[Y.Separator=-1]="Separator",Y[Y.Default=0]="Default"})(kn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Pn;(function(Y){Y[Y.UI=1]="UI",Y[Y.Workspace=2]="Workspace"})(Pn=e.ExtensionKind||(e.ExtensionKind={}));class Tn{constructor(H,ue,De){this.badge=H,this.tooltip=ue,this.color=De}static validate(H){if(H.badge){let ue=(0,P.nextCharLength)(H.badge,0);if(ue<H.badge.length&&(ue+=(0,P.nextCharLength)(H.badge,ue)),H.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Tn;let dn=class{constructor(H){this.kind=H}};dn=Be([O],dn),e.ColorTheme=dn;var hn;(function(Y){Y[Y.Light=1]="Light",Y[Y.Dark=2]="Dark",Y[Y.HighContrast=3]="HighContrast"})(hn=e.ColorThemeKind||(e.ColorThemeKind={}));class Qt{constructor(H,ue){if(H<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");H<=ue?(this._start=H,this._end=ue):(this._start=ue,this._end=H)}static isNotebookRange(H){return H instanceof Qt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(H){let ue=this._start,De=this._end;return H.start!==void 0&&(ue=H.start),H.end!==void 0&&(De=H.end),ue===this._start&&De===this._end?this:new Qt(ue,De)}}e.NotebookRange=Qt;class zt{constructor(H,ue,De,qe,Xe,Ze,it){this.kind=H,this.value=ue,this.languageId=De,this.mime=qe,this.outputs=Xe??[],this.metadata=Ze,this.executionSummary=it,zt.validate(this)}static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(ue=>zt.isNotebookCellData(ue))}static isNotebookCellData(H){return!0}}e.NotebookCellData=zt;class Oe{constructor(H){this.cells=H}}e.NotebookData=Oe;class Lt{constructor(H,ue){this.data=H,this.mime=ue;const De=(0,S.normalizeMimeType)(ue,!0);if(!De)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(H){return H instanceof Lt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const ue={name:H.name,message:H.message,stack:H.stack};return Lt.json(ue,"application/vnd.code.notebook.error")}static stdout(H){return Lt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Lt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,ue="application/octet-stream"){return new Lt(H,ue)}static text(H,ue=S.Mimes.text){const De=Te(Lt,u,"f",w).encode(String(H));return new Lt(De,ue)}static json(H,ue="application/json"){const De=JSON.stringify(H,void 0,"	");return Lt.text(De,ue)}}e.NotebookCellOutputItem=Lt,u=Lt,w={value:new TextEncoder};class Zt{constructor(H,ue,De){this.items=Zt.ensureUniqueMimeTypes(H,!0),typeof ue=="string"?(this.id=ue,this.metadata=De):(this.id=(0,F.generateUuid)(),this.metadata=ue??De)}static isNotebookCellOutput(H){return H instanceof Zt?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&(0,C.isArray)(H.items)}static ensureUniqueMimeTypes(H,ue=!1){const De=new Set,qe=new Set;for(let Xe=0;Xe<H.length;Xe++){const Ze=H[Xe],it=(0,S.normalizeMimeType)(Ze.mime);if(!De.has(it)){De.add(it);continue}qe.add(Xe),ue&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return qe.size===0?H:H.filter((Xe,Ze)=>!qe.has(Ze))}}e.NotebookCellOutput=Zt;var ft;(function(Y){Y[Y.Markup=1]="Markup",Y[Y.Code=2]="Code"})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var An;(function(Y){Y[Y.Idle=1]="Idle",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})(An=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Rn;(function(Y){Y[Y.Left=1]="Left",Y[Y.Right=2]="Right"})(Rn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var wn;(function(Y){Y[Y.Default=0]="Default",Y[Y.InCenter=1]="InCenter",Y[Y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Y[Y.AtTop=3]="AtTop"})(wn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class bn{constructor(H,ue){this.text=H,this.alignment=ue}}e.NotebookCellStatusBarItem=bn;var Ln;(function(Y){Y[Y.Default=1]="Default",Y[Y.Preferred=2]="Preferred"})(Ln=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class On{constructor(H,ue=[]){this.uri=H,this.provides=(0,h.asArray)(ue)}}e.NotebookRendererScript=On;let fn=class{constructor(H,ue){this.label=H,this.timestamp=ue}};fn=Be([O],fn),e.TimelineItem=fn;var Fn;(function(Y){Y[Y.Production=1]="Production",Y[Y.Development=2]="Development",Y[Y.Test=3]="Test"})(Fn=e.ExtensionMode||(e.ExtensionMode={}));var En;(function(Y){Y[Y.Node=1]="Node",Y[Y.Webworker=2]="Webworker"})(En=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Nn;(function(Y){Y[Y.Other=0]="Other",Y[Y.Comment=1]="Comment",Y[Y.String=2]="String",Y[Y.RegEx=3]="RegEx"})(Nn=e.StandardTokenType||(e.StandardTokenType={}));class Mn{constructor(H,ue){this.ranges=H,this.wordPattern=ue}}e.LinkedEditingRanges=Mn;class Un{constructor(H,ue){this._port=H,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Un;var Bn;(function(Y){Y[Y.Queued=1]="Queued",Y[Y.Running=2]="Running",Y[Y.Passed=3]="Passed",Y[Y.Failed=4]="Failed",Y[Y.Skipped=5]="Skipped",Y[Y.Errored=6]="Errored"})(Bn=e.TestResultState||(e.TestResultState={}));var Wn;(function(Y){Y[Y.Run=1]="Run",Y[Y.Debug=2]="Debug",Y[Y.Coverage=3]="Coverage"})(Wn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let le=class{constructor(H=void 0,ue=void 0,De=void 0){this.include=H,this.exclude=ue,this.profile=De}};le=Be([O],le),e.TestRunRequest=le;let me=v=class{constructor(H){this.message=H}static diff(H,ue,De){const qe=new v(H);return qe.expectedOutput=ue,qe.actualOutput=De,qe}};me=v=Be([O],me),e.TestMessage=me;let Pe=class{constructor(H){this.id=H}};Pe=Be([O],Pe),e.TestTag=Pe;let Je=class{constructor(H,ue){this.covered=H,this.total=ue}};Je=Be([O],Je),e.CoveredCount=Je;let bt=R=class{constructor(H,ue,De,qe){this.uri=H,this.statementCoverage=ue,this.branchCoverage=De,this.functionCoverage=qe}static fromDetails(H,ue){const De=new Je(0,0),qe=new Je(0,0),Xe=new Je(0,0);for(const it of ue)if("branches"in it){De.total+=1,De.covered+=it.executionCount>0?1:0;for(const yt of it.branches)qe.total+=1,qe.covered+=yt.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=it.executionCount>0?1:0;const Ze=new R(H,De,qe.total>0?qe:void 0,Xe.total>0?Xe:void 0);return Ze.detailedCoverage=ue,Ze}};bt=R=Be([O],bt),e.FileCoverage=bt;let Dt=class{constructor(H,ue,De=[]){this.executionCount=H,this.location=ue,this.branches=De}};Dt=Be([O],Dt),e.StatementCoverage=Dt;let $n=class{constructor(H,ue){this.executionCount=H,this.location=ue}};$n=Be([O],$n),e.BranchCoverage=$n;let zn=class{constructor(H,ue){this.executionCount=H,this.location=ue}};zn=Be([O],zn),e.FunctionCoverage=zn;var Kn;(function(Y){Y[Y.None=0]="None",Y[Y.Option=1]="Option",Y[Y.Default=2]="Default",Y[Y.Preferred=3]="Preferred"})(Kn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Xn;(function(Y){Y[Y.Untrusted=0]="Untrusted",Y[Y.Trusted=1]="Trusted",Y[Y.Unspecified=2]="Unspecified"})(Xn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qn;(function(Y){Y[Y.Notify=1]="Notify",Y[Y.OpenBrowser=2]="OpenBrowser",Y[Y.OpenPreview=3]="OpenPreview",Y[Y.Silent=4]="Silent",Y[Y.Ignore=5]="Ignore",Y[Y.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yn{constructor(H,ue,De,qe,Xe,Ze){this.kind=H,this.name=ue,this.detail=De,this.uri=qe,this.range=Xe,this.selectionRange=Ze}}e.TypeHierarchyItem=Yn}),define(we[126],be([1,0,55,10,8,153,109,7,17]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function F(f,u){u?T.set(f,u):T.delete(f)}e.setWordDefinitionFor=F;function D(f){return T.get(f)}e.getWordDefinitionFor=D;class g extends A.MirrorTextModel{constructor(u,w,y,I,a,c,m,s){super(w,y,I,a);this._proxy=u,this._languageId=c,this._isDirty=m,this._notebook=s,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,C.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===t.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(w){return w?u._getTextInRange(w):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(w){return u._lineAt(w)},offsetAt(w){return u._offsetAt(w)},positionAt(w){return u._positionAt(w)},validateRange(w){return u._validateRange(w)},validatePosition(w){return u._validatePosition(w)},getWordRangeAtPosition(w,y){return u._getWordRangeAtPosition(w,y)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,h.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,h.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const w=this._validateRange(u);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const y=this._eol,I=w.start.line,a=w.end.line,c=[];c.push(this._lines[I].substring(w.start.character));for(let m=I+1;m<a;m++)c.push(this._lines[m]);return c.push(this._lines[a].substring(0,w.end.character)),c.join(y)}_lineAt(u){let w;if(u instanceof P.Position?w=u.line:typeof u=="number"&&(w=u),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new E(w,this._lines[w],w===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(u),y=this._lines[w.index].length;return new P.Position(w.index,Math.min(w.remainder,y))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const w=this._validatePosition(u.start),y=this._validatePosition(u.end);return w===u.start&&y===u.end?u:new P.Range(w.line,w.character,y.line,y.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:w,character:y}=u,I=!1;if(w<0)w=0,y=0,I=!0;else if(w>=this._lines.length)w=this._lines.length-1,y=this._lines[w].length,I=!0;else{const a=this._lines[w].length;y<0?(y=0,I=!0):y>a&&(y=a,I=!0)}return I?new P.Position(w,y):u}_getWordRangeAtPosition(u,w){const y=this._validatePosition(u);if(!w)w=D(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const I=(0,S.getWordAtText)(y.character+1,(0,S.ensureValidWordDefinition)(w),this._lines[y.line],0);if(I)return new P.Range(y.line,I.startColumn-1,y.line,I.endColumn-1)}}e.ExtHostDocumentData=g;class E{constructor(u,w,y){this._line=u,this._text=w,this._isLastLine=y}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(we[205],be([1,0,7,3,112,6,110,24,2,33]),function(te,e,h,t,k,A,S,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(g,E,f,u){this._notebook=f,this._selector=u,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(y=>{const I=this._cellUris.get(y.document.uri);I!==void 0&&(this._cellLengths.setValue(I,this._cells[I].document.getText().length+1),this._cellLines.setValue(I,this._cells[I].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=y=>{y===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(g.onDidChangeNotebookCells(y=>w(y.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const g=[],E=[];for(const f of this._notebook.getCells())f.kind===h.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,f.document.uri,f.document.languageId,!0))&&(this._cellUris.set(f.document.uri,this._cells.length),this._cells.push(f),g.push(f.document.getText().length+1),E.push(f.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(g)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(g){if(!g){let I="";for(const a of this._cells)I+=a.document.getText()+`
`;return I=I.slice(0,-1),I}if(g.isEmpty)return"";const E=this.locationAt(g.start),f=this.locationAt(g.end),u=this._cellUris.get(E.uri),w=this._cellUris.get(f.uri);if(u===void 0||w===void 0)return"";if(u===w)return this._cells[u].document.getText(new h.Range(E.range.start,f.range.end));const y=[this._cells[u].document.getText(new h.Range(E.range.start,new h.Position(this._cells[u].document.lineCount,0)))];for(let I=u+1;I<w;I++)y.push(this._cells[I].document.getText());return y.push(this._cells[w].document.getText(new h.Range(new h.Position(0,0),f.range.end))),y.join(`
`)}offsetAt(g){const E=this._cellLines.getIndexOf(g.line),f=this._cellLengths.getPrefixSum(E.index-1),u=this._cells[E.index].document.offsetAt(g.with(E.remainder));return f+u}positionAt(g){if(typeof g=="number"){const f=this._cellLengths.getIndexOf(g),u=this._cellLines.getPrefixSum(f.index-1);return this._cells[f.index].document.positionAt(f.remainder).translate(u)}const E=this._cellUris.get(g.uri);if(E!==void 0){const f=this._cellLines.getPrefixSum(E-1);return new h.Position(f+g.range.start.line,g.range.start.character)}return new h.Position(0,0)}locationAt(g){h.Range.isRange(g)||(g=new h.Range(g,g));const E=this._cellLines.getIndexOf(g.start.line);let f=E;g.isEmpty||(f=this._cellLines.getIndexOf(g.end.line));const u=new h.Position(E.remainder,g.start.character),w=new h.Position(f.remainder,g.end.character),y=new h.Range(u,w),I=this._cells[E.index];return new h.Location(I.document.uri,I.document.validateRange(y))}contains(g){return this._cellUris.has(g)}validateRange(g){const E=this.validatePosition(g.start),f=this.validatePosition(g.end);return g.with(E,f)}validatePosition(g){const E=this._cellLines.getIndexOf(g.line),f=new h.Position(E.remainder,g.character),u=this._cells[E.index].document.validatePosition(f),w=this._cellLines.getPrefixSum(E.index-1);return new h.Position(w+u.line,u.character)}}e.ExtHostNotebookConcatDocument=F}),define(we[206],be([1,0,7,14,3]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let C=P==="light"?h.ColorThemeKind.Light:P==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([Fe(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(we[64],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=t}),define(we[207],be([1,0,23]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(C){let T=this.buffers.indexOf(C);return T<0&&(T=this.buffers.length,this.buffers.push(C)),T}}function k(P,C){if(C.serializeBuffersForPostMessage){const T=new t,F=(E,f)=>{if(f instanceof ArrayBuffer){const u=T.add(f);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(f)){const u=A(f);if(u){const w=T.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:u,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},D=JSON.stringify(P,F),g=T.buffers.map(E=>{const f=new Uint8Array(E);return h.VSBuffer.wrap(f)});return{message:D,buffers:g}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=k;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(P,C){const T=C.map(g=>{const E=new ArrayBuffer(g.byteLength);return new Uint8Array(E).set(g.buffer),E}),F=C.length?(g,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const f=E,{index:u}=f,w=T[u];if(f.view)switch(f.view.type){case 1:return new Int8Array(w,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return E}:void 0;return{message:JSON.parse(P,F),arrayBuffers:T}}e.deserializeWebviewMessage=S}),define(we[208],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(t){function k(S){const P=new Map;return S.types.forEach((C,T)=>{P.set(C,{asString:async()=>S.items[T].asString,value:void 0})}),P}t.toITreeDataTransfer=k;async function A(S){const P={types:[],items:[]},C=Array.from(S.entries());for(const T of C)P.types.push(T[0]),P.items.push({asString:await T[1].asString()});return P}t.toTreeDataTransferDTO=A})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[209],be([1,0,103]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(A){return{transformIncoming:S=>S.scheme==="vscode-remote"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="file"?{scheme:"vscode-local",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoing:S=>S.scheme==="file"?{scheme:"vscode-remote",authority:A,path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="vscode-local"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoingScheme:S=>S==="file"?"vscode-remote":S==="vscode-local"?"file":S}}function k(A){return new h.URITransformer(t(A))}e.createURITransformer=k}),define(we[210],be([1,0,177,18,2,6,4,50,42,17,10]),function(te,e,h,t,k,A,S,P,C,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function D(_,U,M){for(const q of M.visibleEditorPanes)if(q.group.id===U&&_.matches(q.input))return q.getViewState()}e.findViewStateForEditor=D;function g(_){if(c(_))return!1;const U=_;return k.URI.isUri(U?.resource)}e.isResourceEditorInput=g;function E(_){if(c(_))return!1;const U=_;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=E;function f(_){if(c(_)||E(_))return!1;const U=_;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function u(_){if(c(_))return!1;const U=_;return U?U.resource===void 0||U.resource.scheme===F.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var w;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var y;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(y=e.SaveReason||(e.SaveReason={}));var I;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription"})(I=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends A.Disposable{}e.AbstractEditorInput=a;function c(_){return _ instanceof a}e.isEditorInput=c;function m(_){const U=_;return k.URI.isUri(U?.preferredResource)}function s(_){const U=_;return c(U?.primary)&&c(U?.secondary)}e.isSideBySideEditorInput=s;function b(_){const U=_;return c(U?.modified)&&c(U?.original)}e.isDiffEditorInput=b;function o(_){return c(_?.editor)}e.isEditorInputWithOptions=o;function n(_){const U=_;return o(_)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function i(_){const U=_;return typeof U?.groupId=="number"&&c(U.editor)}e.isEditorIdentifier=i;var r;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(r=e.EditorCloseContext||(e.EditorCloseContext={}));var l;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LOCKED=2]="GROUP_LOCKED",_[_.EDITOR_OPEN=3]="EDITOR_OPEN",_[_.EDITOR_CLOSE=4]="EDITOR_CLOSE",_[_.EDITOR_MOVE=5]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=7]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=9]="EDITOR_PIN",_[_.EDITOR_STICKY=10]="EDITOR_STICKY",_[_.EDITOR_DIRTY=11]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(l=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var p;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(p=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(U,M){if(!U)return;if(M?.supportSideBySide){const{primary:K,secondary:x}=this.getSideEditors(U);if(K&&x){if(M?.supportSideBySide===p.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(x,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===p.ANY)return this.getOriginalUri(K,{filterByScheme:M.filterByScheme})??this.getOriginalUri(x,{filterByScheme:M.filterByScheme});U=M.supportSideBySide===p.PRIMARY?K:x}}if(E(U)||f(U))return;const q=m(U)?U.preferredResource:U.resource;return!q||!M||!M.filterByScheme?q:this.filterUri(q,M.filterByScheme)}getSideEditors(U){return s(U)||f(U)?{primary:U.primary,secondary:U.secondary}:b(U)||E(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,M){if(!U)return;if(M?.supportSideBySide){const{primary:K,secondary:x}=this.getSideEditors(U);if(K&&x){if(M?.supportSideBySide===p.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(x,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===p.ANY)return this.getCanonicalUri(K,{filterByScheme:M.filterByScheme})??this.getCanonicalUri(x,{filterByScheme:M.filterByScheme});U=M.supportSideBySide===p.PRIMARY?K:x}}if(E(U)||f(U))return;const q=U.resource;return!q||!M||!M.filterByScheme?q:this.filterUri(q,M.filterByScheme)}filterUri(U,M){if(Array.isArray(M)){if(M.some(q=>U.scheme===q))return U}else if(M===U.scheme)return U}}e.EditorResourceAccessor=new d;var v;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const M=this.instantiationService=U.get(S.IInstantiationService);for(const[q,K]of this.editorSerializerConstructors)this.createEditorSerializer(q,K,M);this.editorSerializerConstructors.clear()}createEditorSerializer(U,M,q){const K=q.createInstance(M);this.editorSerializerInstances.set(U,K)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,M){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,M,this.instantiationService):this.editorSerializerConstructors.set(U,M),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new R);async function O(_,U){if(!_||!_.length)return[];const M=await Promise.all(_.map(async q=>{const K=k.URI.revive(q.fileUri);if(!K||!await U.canHandleResource(K))return;let B=q.exists,G=q.type;if(typeof B!="boolean"||typeof G!="number")try{G=(await U.resolve(K)).isDirectory?C.FileType.Directory:C.FileType.Unknown,B=!0}catch{B=!1}if(!B&&q.openOnlyIfExists||G===C.FileType.Directory)return;const X={selection:B?q.selection:void 0,pinned:!0,override:q.editorOverrideId};let V;return B?V={resource:K,options:X}:V={resource:K,options:X,forceUntitled:!0},V}));return(0,T.coalesce)(M)}e.pathsToEditors=O;var L;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(L=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[86],be([1,0,10,2]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(P,C){return P.scheme===h.Schemas.http||P.scheme===h.Schemas.https?P:(C&&C.authority&&C.isRemote&&P.scheme===h.Schemas.file&&(P=t.URI.from({scheme:h.Schemas.vscodeRemote,authority:C.authority,path:P.path})),t.URI.from({scheme:h.Schemas.https,authority:`${P.scheme}+${A(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=k;function A(P){return P.replace(/./g,C=>{const T=C.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?C:"-"+T.toString(16).padStart(4,"0")})}function S(P){return P.replace(/-([0-9a-f]{4})/g,(C,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=S}),define(we[211],be([1,0,3,6,86]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(P,C,T){this._proxy=P,this._editors=C,this._initData=T,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const F=C.getVisibleTextEditors();for(const D of this._insets.values())F.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,C,T,F,D){let g;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===P){g=a;break}if(!g)throw new Error("not a visible editor");const E=this,f=this._handlePool++,u=new h.Emitter,w=new h.Emitter,y=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,k.asWebviewUri)(a,E._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(a){this._options=a,E._proxy.$setOptions(f,a)}get options(){return this._options}set html(a){this._html=a,E._proxy.$setHtml(f,a)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(a){return E._proxy.$postMessage(f,a)}},I=new class{constructor(){this.editor=P,this.line=C,this.height=T,this.webview=y,this.onDidDispose=w.event}dispose(){E._insets.has(f)&&(E._insets.delete(f),E._proxy.$disposeEditorInset(f),w.fire(),w.dispose(),u.dispose())}};return this._proxy.$createEditorInset(f,g.id,g.value.document.uri,C+1,T,F||{},D.identifier,D.extensionLocation),this._insets.set(f,{editor:P,inset:I,onDidReceiveMessage:u}),I}$onDidDispose(P){const C=this._insets.get(P);C&&C.inset.dispose()}$onDidReceiveMessage(P,C){const T=this._insets.get(P);T&&T.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=A}),define(we[127],be([1,0,3,13,178]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,C,T,F){const D={command:P};if(C&&Object.keys(C).length>0&&(D.arguments=C),this.internalSend("request",D),typeof F=="number"){const g=setTimeout(()=>{clearTimeout(g);const E=this.pendingRequests.get(D.seq);if(E){this.pendingRequests.delete(D.seq);const f={type:"response",seq:0,request_seq:D.seq,success:!1,command:P,message:(0,k.localize)(0,null,F,P)};E(f)}},F)}return T&&this.pendingRequests.set(D.seq,T),D.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,C){return P.type!=="event"||C.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,t.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const C=P,T=this.pendingRequests.get(C.request_seq);T&&(this.pendingRequests.delete(C.request_seq),T(C));break}}}}internalSend(P,C){C.type=P,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((C,T)=>P.set(T,C)),await(0,t.timeout)(500),P.forEach((C,T)=>{C({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(we[212],be([1,0,179,62,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:h.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:h.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:h.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:h.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:h.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:h.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:h.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:h.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:h.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:h.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:h.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:h.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:h.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:h.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:h.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:h.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:h.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:h.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:h.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:h.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:h.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:h.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:h.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:h.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(49,null)});const A=D=>h.localize(50,null,D);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(51,null)};var S;(function(D){D[D.Inactive=0]="Inactive",D[D.Initializing=1]="Initializing",D[D.Stopped=2]="Stopped",D[D.Running=3]="Running"})(S=e.State||(e.State={}));function P(D){switch(D){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var C;(function(D){D[D.Valid=0]="Valid",D[D.Unreadable=1]="Unreadable",D[D.Error=2]="Error"})(C=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(D){D[D.Initial=1]="Initial",D[D.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,k.createDecorator)(e.DEBUG_SERVICE_ID);var F;(function(D){D[D.CONDITION=0]="CONDITION",D[D.HIT_COUNT=1]="HIT_COUNT",D[D.LOG_MESSAGE=2]="LOG_MESSAGE"})(F=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(we[213],be([1,0,8,2,9,25,10]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function C(o,n,i){return o.replace(P,function(r,l){return n&&l.length>0&&l[0]!=="_"?r:i&&i.hasOwnProperty(l)?i[l]:r})}e.formatPII=C;function T(o){const n={};for(const i of Object.keys(o))i.startsWith("!")||(n[i]=o[i]);return n}e.filterExceptionsFromTelemetry=T;function F(o){return o.configuration.request==="attach"&&!D(o)&&(!o.parentSession||F(o.parentSession))}e.isSessionAttach=F;function D(o){let n=o.configuration.type;if(!!n)return n==="vslsShare"&&(n=o.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(n,"extensionhost")||(0,h.equalsIgnoreCase)(n,"pwa-extensionhost")?o:o.parentSession?D(o.parentSession):void 0}e.getExtensionHostDebugSession=D;function g(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=g;function E(o,n,i){let r,l=0;const p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let d=null;for(;d=p.exec(o);){const v=d.index+1,R=v+d[0].length;if(v<=n&&R>=i){r=d[0],l=v;break}}if(r){const v=/\w+/g;let R=null;for(;(R=v.exec(r))&&!(R.index+1+l+R[0].length>=i););R&&(r=r.substring(0,v.lastIndex))}return r?{start:l,end:l+r.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(o){return!!(o&&o.match(f))}e.isUri=u;function w(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(u(o.path))return t.URI.parse(o.path);if((0,k.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function y(o){if(typeof o.path=="object"){const n=t.URI.revive(o.path);if(n)return n.scheme===S.Schemas.file?n.fsPath:n.toString()}return o.path}function I(o,n){const i=n?w:y,r=(0,A.deepClone)(o);return c(r,(l,p)=>{l&&p&&(p.path=i(p))}),r}e.convertToDAPaths=I;function a(o,n){const i=n?w:y,r=(0,A.deepClone)(o);return c(r,(l,p)=>{!l&&p&&(p.path=i(p))}),r}e.convertToVSCPaths=a;function c(o,n){switch(o.type){case"event":{const i=o;switch(i.event){case"output":n(!1,i.body.source);break;case"loadedSource":n(!1,i.body.source);break;case"breakpoint":n(!1,i.body.breakpoint.source);break;default:break}break}case"request":{const i=o;switch(i.command){case"setBreakpoints":n(!0,i.arguments.source);break;case"breakpointLocations":n(!0,i.arguments.source);break;case"source":n(!0,i.arguments.source);break;case"gotoTargets":n(!0,i.arguments.source);break;case"launchVSCode":i.arguments.args.forEach(r=>n(!1,r));break;default:break}break}case"response":{const i=o;if(i.success&&i.body)switch(i.command){case"stackTrace":i.body.stackFrames.forEach(r=>n(!1,r.source));break;case"loadedSources":i.body.sources.forEach(r=>n(!1,r));break;case"scopes":i.body.scopes.forEach(r=>n(!1,r.source));break;case"setFunctionBreakpoints":i.body.breakpoints.forEach(r=>n(!1,r.source));break;case"setBreakpoints":i.body.breakpoints.forEach(r=>n(!1,r.source));break;case"disassemble":{const r=i;r.body&&r.body.instructions.forEach(l=>n(!1,l.location))}break;default:break}break}}}function m(o){return o.filter(n=>!n.presentation?.hidden).sort((n,i)=>n.presentation?i.presentation?n.presentation.group?i.presentation.group?n.presentation.group!==i.presentation.group?n.presentation.group.localeCompare(i.presentation.group):s(n.presentation.order,i.presentation.order):-1:i.presentation.group?1:s(n.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=m;function s(o,n){return typeof o!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:o-n}async function b(o,n){const i=o.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(i!=="none"&&(await n.saveAll(),i==="allEditorsInActiveGroup")){const r=n.activeEditorPane;r&&r.input.resource?.scheme===S.Schemas.untitled&&await n.save({editor:r.input,groupId:r.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(we[214],be([1,0,29,37,180,128,9,8,25,12,196,127]),function(te,e,h,t,k,A,S,P,C,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class g extends D.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(I,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,I.on("data",c=>this.handleData(c))}sendMessage(I){if(this.outputStream){const a=JSON.stringify(I);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${g.TWO_CRLF}${a}`,"utf8")}}handleData(I){for(this.rawData=Buffer.concat([this.rawData,I]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+a))}continue}}else{const a=this.rawData.indexOf(g.TWO_CRLF);if(a!==-1){const m=this.rawData.toString("utf8",0,a).split(g.HEADER_LINESEPARATOR);for(const s of m){const b=s.split(g.HEADER_FIELDSEPARATOR);b[0]==="Content-Length"&&(this.contentLength=Number(b[1]))}this.rawData=this.rawData.slice(a+g.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=g,g.TWO_CRLF=`\r
\r
`,g.HEADER_LINESEPARATOR=/\r?\n/,g.HEADER_FIELDSEPARATOR=/: */;class E extends g{startSession(){return new Promise((I,a)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),I(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",m=>{c?this._onError.fire(m):a(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class f extends E{constructor(I){super();this.adapterServer=I}createConnection(I){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",I)}}e.SocketDebugAdapter=f;class u extends E{constructor(I){super();this.adapterServer=I}createConnection(I){return A.createConnection(this.adapterServer.path,I)}}e.NamedPipeDebugAdapter=u;class w extends g{constructor(I,a,c){super();this.adapterExecutable=I,this.debugType=a,this.outputService=c}async startSession(){const I=this.adapterExecutable.command,a=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(I)if(S.isAbsolute(I)){if(!await h.Promises.exists(I))throw new Error(k.localize(0,null,I))}else I.indexOf("/")<0&&I.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let m=process.env;if(c.env&&Object.keys(c.env).length>0&&(m=C.mixin(C.deepClone(process.env),c.env)),I==="node")if(Array.isArray(a)&&a.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:m,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(o.cwd=c.cwd);const n=t.fork(a[0],a.slice(1),o);if(!n.pid)throw new Error(k.localize(2,null,a[0]));this.serverProcess=n}else throw new Error(k.localize(3,null));else{const b={env:m};c.cwd&&(b.cwd=c.cwd),this.serverProcess=t.spawn(I,a,b)}this.serverProcess.on("error",b=>{this._onError.fire(b)}),this.serverProcess.on("exit",(b,o)=>{this._onExit.fire(b)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stdin.on("error",b=>{this._onError.fire(b)});const s=this.outputService;if(s){const b=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const n=s.getChannel(F.ExtensionsChannelId);n&&n.append(b(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((I,a)=>{const c=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,s,b){if(m)return a(m)});c.on("exit",I),c.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(I,a){if(!I)return;const c=Object.create(null);I.runtime&&(I.runtime.indexOf("./")===0?c.runtime=S.join(a,I.runtime):c.runtime=I.runtime),I.runtimeArgs&&(c.runtimeArgs=I.runtimeArgs),I.program&&(S.isAbsolute(I.program)?c.program=I.program:c.program=S.join(a,I.program)),I.args&&(c.args=I.args);const m=I;return m.win&&(c.win=w.extract(m.win,a)),m.winx86&&(c.winx86=w.extract(m.winx86,a)),m.windows&&(c.windows=w.extract(m.windows,a)),m.osx&&(c.osx=w.extract(m.osx,a)),m.linux&&(c.linux=w.extract(m.linux,a)),c}static platformAdapterExecutable(I,a){let c=Object.create(null);a=a.toLowerCase();for(const i of I)if(i.contributes){const r=i.contributes.debuggers;r&&r.length>0&&r.filter(l=>typeof l.type=="string"&&P.equalsIgnoreCase(l.type,a)).forEach(l=>{const p=w.extract(l,i.extensionLocation.fsPath);c=C.mixin(c,p,i.isBuiltin)})}let m;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=c.winx86||c.win||c.windows:T.isWindows?m=c.win||c.windows:T.isMacintosh?m=c.osx:T.isLinux&&(m=c.linux),m=m||c;const s=m.program||c.program,b=m.args||c.args,o=m.runtime||c.runtime,n=m.runtimeArgs||c.runtimeArgs;if(o)return{type:"executable",command:o,args:(n||[]).concat(typeof s=="string"?[s]:[]).concat(b||[])};if(s)return{type:"executable",command:s,args:b||[]}}}e.ExecutableDebugAdapter=w}),define(we[215],be([1,0,37,28,12]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(T,F){return new Promise((D,g)=>{let E="";const f=h.spawn(T,F);f.pid&&f.stdout.on("data",u=>{E+=u.toString()}),f.on("error",u=>{g(u)}),f.on("close",u=>{D(E)})})}async function S(T){if(T)if(k.isWindows){const F=await new Promise((D,g)=>{te(["windows-process-tree"],D,g)});return new Promise(D=>{F.getProcessTree(T,g=>{D(g.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(T)]).then(F=>{const D=F.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},F=>!0);return Promise.resolve(!0)}e.hasChildProcesses=S;var P;(function(T){T[T.cmd=0]="cmd",T[T.powershell=1]="powershell",T[T.bash=2]="bash"})(P||(P={}));function C(T,F,D,g){T=T.trim().toLowerCase();let E;T.indexOf("powershell")>=0||T.indexOf("pwsh")>=0?E=1:T.indexOf("cmd.exe")>=0?E=0:T.indexOf("bash")>=0?E=2:k.isWindows?E=0:E=2;let f,u=" ";switch(E){case 1:if(f=w=>(w=w.replace(/\'/g,"''"),w.length>0&&w.charAt(w.length-1)==="\\"?`'${w}\\'`:`'${w}'`),D){const w=(0,t.getDriveLetter)(D);w&&(u+=`${w}:; `),u+=`cd ${f(D)}; `}if(g)for(const w in g){const y=g[w];y===null?u+=`Remove-Item env:${w}; `:u+=`\${env:${w}}='${y}'; `}if(F.length>0){const w=f(F.shift());u+=w[0]==="'"?`& ${w} `:`${w} `;for(const y of F)u+=`${f(y)} `}break;case 0:if(f=w=>(w=w.replace(/\"/g,'""'),w.indexOf(" ")>=0||w.indexOf('"')>=0||w.length===0?`"${w}"`:w),D){const w=(0,t.getDriveLetter)(D);w&&(u+=`${w}: && `),u+=`cd ${f(D)} && `}if(g){u+='cmd /C "';for(const w in g){let y=g[w];y===null?u+=`set "${w}=" && `:(y=y.replace(/[\^\&\|\<\>]/g,I=>`^${I}`),u+=`set "${w}=${y}" && `)}}for(const w of F)u+=`${f(w)} `;g&&(u+='"');break;case 2:{f=y=>(y=y.replace(/(["'\\\$])/g,"\\$1"),y.indexOf(" ")>=0||y.indexOf(";")>=0||y.length===0?`"${y}"`:y);const w=y=>/[^\w@%\/+=,.:^-]/.test(y)?`'${y.replace(/'/g,"'\\''")}'`:y;if(D&&(u+=`cd ${f(D)} ; `),g){u+="/usr/bin/env";for(const y in g){const I=g[y];I===null?u+=` -u ${w(y)}`:u+=` ${w(`${y}=${I}`)}`}u+=" "}for(const y of F)u+=`${f(y)} `;break}}return u}e.prepareCommand=C}),define(we[129],be([1,0,32,77,95,10,9,12,62]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var T;(function(v){v[v.Markup=1]="Markup",v[v.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",k.Mimes.latex,k.Mimes.markdown,"image/png","image/jpeg",k.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[k.Mimes.latex,k.Mimes.markdown,"application/json",k.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var D;(function(v){v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(D=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var g;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(g=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(v){v.Always="always",v.Never="never",v.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",v[v.ChangeCellMime=13]="ChangeCellMime",v[v.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata",v[v.PartialInternalMetadata=9]="PartialInternalMetadata"})(w=e.CellEditType||(e.CellEditType={}));var y;(function(v){v.scheme=A.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function O(K,x){return K.with({scheme:v.scheme,fragment:`ch${x.toString().padStart(7,"0")}${K.scheme!==A.Schemas.file?K.scheme:""}`})}v.generate=O;function L(K){if(K.scheme!==v.scheme)return;const x=R.exec(K.fragment);return x?{handle:Number(x[1]),notebook:K.with({scheme:K.fragment.substring(x[0].length)||A.Schemas.file,fragment:null})}:void 0}v.parse=L;function _(K,x,B){return K.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`ch${x.toString().padStart(7,"0")},${B??""},${K.scheme!==A.Schemas.file?K.scheme:""}`})}v.generateCellOutputUri=_;function U(K){if(K.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const x=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(K.fragment);if(!x)return;const B=Number(x[1]),G=x[2]&&x[2]!==""?x[2]:void 0,X=x[3];return{handle:B,outputId:G,notebook:K.with({scheme:X||A.Schemas.file,fragment:null})}}v.parseCellOutputUri=U;function M(K,x,B){return K.with({scheme:B,fragment:`ch${x.toString().padStart(7,"0")}${K.scheme!==A.Schemas.file?K.scheme:""}`})}v.generateCellUri=M;function q(K,x){if(K.scheme!==x)return;const B=R.exec(K.fragment);return B?{handle:Number(B[1]),notebook:K.with({scheme:K.fragment.substring(B[0].length)||A.Schemas.file,fragment:null})}:void 0}v.parseCellUri=q})(y=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[k.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function a(v){return I.get(v)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=a;function c(v){return I.get(v)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function m(v){return I.get(v)?.mergeable??!1}e.mimeTypeIsMergeable=m;const s=v=>P.isWindows?v.replace(/\//g,"\\"):v;class b{constructor(R=[],O=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=O,this.order=[...new Set(R)].map(L=>({pattern:L,matches:h.parse(s(L))}))}sort(R){const O=new Map(t.Iterable.map(R,_=>[_,s(_)]));let L=[];for(const{matches:_}of this.order)for(const[U,M]of O)if(_(M)){L.push(U),O.delete(U);break}return O.size&&(L=L.concat([...O.keys()].sort((_,U)=>this.defaultOrder.indexOf(_)-this.defaultOrder.indexOf(U)))),L}prioritize(R,O){const L=this.findIndex(R);if(L===-1){this.order.unshift({pattern:R,matches:h.parse(s(R))});return}const _=new Set(O.map(M=>this.findIndex(M,L)));_.delete(-1);const U=Array.from(_).sort();this.order.splice(L+1,0,...U.map(M=>this.order[M]));for(let M=U.length-1;M>=0;M--)this.order.splice(U[M],1)}toArray(){return this.order.map(R=>R.pattern)}findIndex(R,O=this.order.length){const L=s(R);for(let _=0;_<O;_++)if(this.order[_].matches(L))return _;return-1}}e.MimeTypeDisplayOrder=b;function o(v,R,O,L=(_,U)=>_===U){const _=[];function U(K,x,B){if(x===0&&B.length===0)return;const G=_[_.length-1];G&&G.start+G.deleteCount===K?(G.deleteCount+=x,G.toInsert.push(...B)):_.push({start:K,deleteCount:x,toInsert:B})}let M=0,q=0;for(;;){if(M===v.length){U(M,0,R.slice(q));break}if(q===R.length){U(M,v.length-M,[]);break}const K=v[M],x=R[q];if(L(K,x)){M+=1,q+=1;continue}O(x)?(U(M,1,[]),M+=1):(U(M,0,[x]),q+=1)}return _}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(v){v.default="default",v.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(v){const R=v;return!!((typeof R.include=="string"||h.isRelativePattern(R.include))&&(typeof R.exclude=="string"||h.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=i;function r(v,R,O){if(Array.isArray(v.viewType)&&v.viewType.indexOf(R)>=0||v.viewType===R)return!0;if(v.filenamePattern){const L=i(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,_=i(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(h.match(L,(0,S.basename)(O.fsPath).toLowerCase()))return!(_&&h.match(_,(0,S.basename)(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r;class l{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)R[O]=this.textModel.cells[O].getHashValue();return R}}e.CellSequence=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var p;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(p=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class d{static create(R){return`${d._prefix}${R}`}static parse(R){if(R.startsWith(d._prefix))return R.substring(d._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=d,d._prefix="notebook/"}),define(we[216],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(we[217],be([1,0,4,62]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,h.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(A){A[A.Append=1]="Append",A[A.Replace=2]="Replace",A[A.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(we[218],be([1,0,181,4,62]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[219],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=h;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t}),define(we[87],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.denamespaceTestTag=e.namespaceTestTag=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var h;(function(f){f[f.Unset=0]="Unset",f[f.Queued=1]="Queued",f[f.Running=2]="Running",f[f.Passed=3]="Passed",f[f.Failed=4]="Failed",f[f.Skipped=5]="Skipped",f[f.Errored=6]="Errored"})(h=e.TestResultState||(e.TestResultState={}));var t;(function(f){f[f.Run=2]="Run",f[f.Debug=4]="Debug",f[f.Coverage=8]="Coverage",f[f.HasNonDefaultProfile=16]="HasNonDefaultProfile",f[f.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(f){f[f.Error=0]="Error",f[f.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));const A="\0",S=(f,u)=>f+A+u;e.namespaceTestTag=S;const P=f=>{const u=f.indexOf(A);return{ctrlId:f.slice(0,u),tagId:f.slice(u+1)}};e.denamespaceTestTag=P;var C;(function(f){f[f.NotExpandable=0]="NotExpandable",f[f.Expandable=1]="Expandable",f[f.BusyExpanding=2]="BusyExpanding",f[f.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(f,u)=>{u.expand!==void 0&&(f.expand=u.expand),u.item!==void 0&&(f.item=f.item?Object.assign(f.item,u.item):u.item)};e.applyTestItemUpdate=T;var F;(function(f){f[f.Function=0]="Function",f[f.Statement=1]="Statement"})(F=e.DetailType||(e.DetailType={}));var D;(function(f){f[f.Add=0]="Add",f[f.Update=1]="Update",f[f.Remove=2]="Remove",f[f.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",f[f.Retire=4]="Retire",f[f.AddTag=5]="AddTag",f[f.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class g{add(u){}update(u){}remove(u,w){}complete(){}}e.IncrementalChangeCollector=g;class E{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(u){const w=this.createChangeCollector();for(const y of u)switch(y[0]){case 0:{const I=y[1];if(I.parent){if(this.items.has(I.parent)){const a=this.items.get(I.parent);a.children.add(I.item.extId);const c=this.createItem(I,a);this.items.set(I.item.extId,c),w.add(c)}}else{const a=this.createItem(I);this.roots.add(a),this.items.set(I.item.extId,a),w.add(a)}I.expand===2&&this.busyControllerCount++;break}case 1:{const I=y[1],a=this.items.get(I.extId);if(!a)break;I.expand!==void 0&&(a.expand===2&&this.busyControllerCount--,I.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(a,I),w.update(a);break}case 2:{const I=this.items.get(y[1]);if(!I)break;I.parent?this.items.get(I.parent).children.delete(I.item.extId):this.roots.delete(I);const a=[[y[1]]];for(;a.length;)for(const c of a.pop()){const m=this.items.get(c);m&&(a.push(m.children),this.items.delete(c),w.remove(m,m!==I),m.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(y[1]);break;case 3:this.updatePendingRoots(y[1]);break;case 5:this._tags.set(y[1].id,y[1]);break;case 6:this._tags.delete(y[1]);break}w.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new g}}e.AbstractIncrementalTestCollection=E}),define(we[88],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(A){A.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{constructor(S,P=S.length){if(this.path=S,this.viewEnd=P,S.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(S,P,C=S.parent){if(S.id===P)return new k([P]);let T=[S.id];for(let F=C;F&&F.id!==P;F=F.parent)T.push(F.id);return T.push(P),new k(T.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const P=S.indexOf("\0");return P===-1?S:S.slice(0,P)}static fromString(S){return new k(S.split("\0"))}static join(S,P){return new k([...S.path,P])}static joinToString(S,P){return S.toString()+"\0"+P}static compare(S,P){return S===P?0:P.startsWith(S+"\0")?2:S.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let S=1;S<=this.viewEnd;S++)yield new k(this.path,S)}compare(S){if(typeof S=="string")return k.compare(this.toString(),S);for(let P=0;P<S.viewEnd&&P<this.viewEnd;P++)if(S.path[P]!==this.path[P])return 1;return S.viewEnd>this.viewEnd?2:S.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let S=1;S<this.viewEnd;S++)this.stringifed+="\0",this.stringifed+=this.path[S]}return this.stringifed}}e.TestId=k}),define(we[220],be([1,0,9,40,18,25,12,79,182]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(D,g,E){this._contributedVariables=new Map,this._context=D,this._labelService=g,E&&(this._envVariablesPromise=E.then(f=>this.prepareEnv(f)))}prepareEnv(D){if(S.isWindows){const g=Object.create(null);return Object.keys(D).forEach(E=>{g[E.toLowerCase()]=D[E]}),g}return D}resolveWithEnvironment(D,g,E){return this.recursiveResolve(this.prepareEnv(D),g?g.uri:void 0,E)}async resolveAsync(D,g){return this.recursiveResolve(await this._envVariablesPromise,D?D.uri:void 0,g)}async resolveAnyBase(D,g,E,f){const u=A.deepClone(g);return S.isWindows&&u.windows?Object.keys(u.windows).forEach(w=>u[w]=u.windows[w]):S.isMacintosh&&u.osx?Object.keys(u.osx).forEach(w=>u[w]=u.osx[w]):S.isLinux&&u.linux&&Object.keys(u.linux).forEach(w=>u[w]=u.linux[w]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,D?D.uri:void 0,u,E,f)}async resolveAnyAsync(D,g,E){return this.resolveAnyBase(D,g,E)}async resolveAnyMap(D,g,E){const f=new Map;return{newConfig:await this.resolveAnyBase(D,g,E,f),resolvedVariables:f}}resolveWithInteractionReplace(D,g,E,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,g,E,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,g){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,g)}recursiveResolve(D,g,E,f,u){if(k.isString(E))return this.resolveString(D,g,E,f,u);if(k.isArray(E))return E.map(w=>this.recursiveResolve(D,g,w,f,u));if(k.isObject(E)){let w=Object.create(null);return Object.keys(E).forEach(y=>{const I=this.resolveString(D,g,y,f,u);w[I]=this.recursiveResolve(D,g,E[y],f,u)}),w}return E}resolveString(D,g,E,f,u){return E.replace(T.VARIABLE_REGEXP,(y,I)=>{if(I.includes(T.VARIABLE_LHS))return y;let a=this.evaluateSingleVariable(D,y,I,g,f);return u&&u.set(I,a),a!==y&&k.isString(a)&&a.match(T.VARIABLE_REGEXP)&&(a=this.resolveString(D,g,a,f,u)),a})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}evaluateSingleVariable(D,g,E,f,u){let w;const y=E.split(":");y.length>1&&(E=y[0],w=y[1]);const I=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,C.localize)(0,null,g))},a=()=>{const m=I();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,C.localize)(1,null,g,h.basename(m)))},c=()=>{if(w){const m=this._context.getFolderUri(w);if(m)return m;throw new Error((0,C.localize)(2,null,g,w))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,g)):new Error((0,C.localize)(4,null,g))};switch(E){case"env":if(w){if(D){const m=D[S.isWindows?w.toLowerCase():w];if(k.isString(m))return m}return""}throw new Error((0,C.localize)(5,null,g));case"config":if(w){const m=this._context.getConfigurationValue(f,w);if(k.isUndefinedOrNull(m))throw new Error((0,C.localize)(6,null,g,w));if(k.isObject(m))throw new Error((0,C.localize)(7,null,g,w));return m}throw new Error((0,C.localize)(8,null,g));case"command":return this.resolveFromMap(g,w,u,"command");case"input":return this.resolveFromMap(g,w,u,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return f||w?(0,P.normalizeDriveLetter)(this.fsPath(c())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(c()));case"lineNumber":{const m=this._context.getLineNumber();if(m)return m;throw new Error((0,C.localize)(9,null,g))}case"selectedText":{const m=this._context.getSelectedText();if(m)return m;throw new Error((0,C.localize)(10,null,g))}case"file":return I();case"fileWorkspaceFolder":return a();case"relativeFile":return f||w?h.relative(this.fsPath(c()),I()):I();case"relativeFileDirname":{const m=h.dirname(I());if(f||w){const s=h.relative(this.fsPath(c()),m);return s.length===0?".":s}return m}case"fileDirname":return h.dirname(I());case"fileExtname":return h.extname(I());case"fileBasename":return h.basename(I());case"fileBasenameNoExtension":{const m=h.basename(I());return m.slice(0,m.length-h.extname(m).length)}case"fileDirnameBasename":return h.basename(h.dirname(I()));case"execPath":{const m=this._context.getExecPath();return m||g}case"execInstallFolder":{const m=this._context.getAppRoot();return m||g}case"pathSeparator":return h.sep;default:try{const m=w?`${E}:${w}`:E;return this.resolveFromMap(g,m,u,void 0)}catch{return g}}}}resolveFromMap(D,g,E,f){if(g&&E){const u=f===void 0?E[g]:E[f+":"+g];if(typeof u=="string")return u;throw new Error((0,C.localize)(11,null,D))}return D}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[130],be([1,0,4,210]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var k;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var P;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function T(f){const u=f;return(0,t.isEditorInput)(u?.editor)&&(0,t.isEditorInput)(u?.replacement)}e.isEditorReplacement=T;var F;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function g(f){const u=f;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=g;function E(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(we[221],be([1,0,4,130]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(A){const S=A;return typeof A=="number"||(0,t.isEditorGroup)(S)}e.isPreferredGroup=k}),define(we[15],be([1,0,17,23,102,144,59,25,18,2,41,81,184,118,63,129,87,88,221,7]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(fe){function Ie(ne){const{selectionStartLineNumber:ye,selectionStartColumn:Le,positionLineNumber:xe,positionColumn:Ge}=ne,ct=new a.Position(ye-1,Le-1),vt=new a.Position(xe-1,Ge-1);return new a.Selection(ct,vt)}fe.to=Ie;function ge(ne){const{anchor:ye,active:Le}=ne;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}fe.from=ge})(c=e.Selection||(e.Selection={}));var m;(function(fe){function Ie(ne){if(!ne)return;const{start:ye,end:Le}=ne;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}fe.from=Ie;function ge(ne){if(!ne)return;const{startLineNumber:ye,startColumn:Le,endLineNumber:xe,endColumn:Ge}=ne;return new a.Range(ye-1,Le-1,xe-1,Ge-1)}fe.to=ge})(m=e.Range||(e.Range={}));var s;(function(fe){function Ie(ge){switch(ge){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}fe.to=Ie})(s=e.TokenType||(e.TokenType={}));var b;(function(fe){function Ie(ne){return new a.Position(ne.lineNumber-1,ne.column-1)}fe.to=Ie;function ge(ne){return{lineNumber:ne.line+1,column:ne.character+1}}fe.from=ge})(b=e.Position||(e.Position={}));var o;(function(fe){function Ie(ye,Le){return(0,h.coalesce)((0,h.asArray)(ye).map(xe=>ge(xe,Le)))}fe.from=Ie;function ge(ye,Le){if(typeof ye=="string")return{$serialized:!0,language:ye};if(ye)return{$serialized:!0,language:ye.language,scheme:ne(ye.scheme,Le),pattern:J.from(ye.pattern)??void 0,exclusive:ye.exclusive}}function ne(ye,Le){return Le&&typeof ye=="string"?Le.transformOutgoingScheme(ye):ye}})(o=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(fe){function Ie(ne){switch(ne){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}fe.from=Ie;function ge(ne){switch(ne){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}fe.to=ge})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(fe){function Ie(ne){let ye;return ne.code&&((0,C.isString)(ne.code)||(0,C.isNumber)(ne.code)?ye=String(ne.code):ye={value:String(ne.code.value),target:ne.code.target}),{...m.from(ne.range),message:ne.message,source:ne.source,code:ye,severity:l.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(r.from),tags:Array.isArray(ne.tags)?(0,h.coalesce)(ne.tags.map(n.from)):void 0}}fe.from=Ie;function ge(ne){const ye=new a.Diagnostic(m.to(ne),ne.message,l.to(ne.severity));return ye.source=ne.source,ye.code=(0,C.isString)(ne.code)?ne.code:ne.code?.value,ye.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(r.to),ye.tags=ne.tags&&(0,h.coalesce)(ne.tags.map(n.to)),ye}fe.to=ge})(i=e.Diagnostic||(e.Diagnostic={}));var r;(function(fe){function Ie(ne){return{...m.from(ne.location.range),message:ne.message,resource:ne.location.uri}}fe.from=Ie;function ge(ne){return new a.DiagnosticRelatedInformation(new a.Location(ne.resource,m.to(ne)),ne.message)}fe.to=ge})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(fe){function Ie(ne){switch(ne){case a.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}fe.from=Ie;function ge(ne){switch(ne){case E.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}fe.to=ge})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var p;(function(fe){function Ie(ne){return typeof ne=="number"&&ne>=a.ViewColumn.One?ne-1:ne===a.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}fe.from=Ie;function ge(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}fe.to=ge})(p=e.ViewColumn||(e.ViewColumn={}));function d(fe){return typeof fe.range!="undefined"}function v(fe){return fe.length===0?!0:!!d(fe[0])}e.isDecorationOptionsArr=v;var R;(function(fe){function Ie(Ge){return Ge.map(fe.from)}fe.fromMany=Ie;function ge(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ne(Ge){let ct;if(ge(Ge)){const{language:rt,value:ut}=Ge;ct={value:"```"+rt+`
`+ut+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const vt=Object.create(null);ct.uris=vt;const St=rt=>{try{let ut=T.URI.parse(rt,!0);ut=ut.with({query:ye(ut.query,vt)}),vt[rt]=ut}catch{}return""},Et=new A.marked.Renderer;return Et.link=St,Et.image=rt=>typeof rt=="string"?St(k.parseHrefAndDimensions(rt).href):"",(0,A.marked)(ct.value,{renderer:Et}),ct}fe.from=ne;function ye(Ge,ct){if(!Ge)return Ge;let vt;try{vt=(0,S.parse)(Ge)}catch{}if(!vt)return Ge;let St=!1;return vt=(0,P.cloneAndChange)(vt,Et=>{if(T.URI.isUri(Et)){const rt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[rt]=Et,St=!0,rt}else return}),St?JSON.stringify(vt):Ge}function Le(Ge){const ct=new a.MarkdownString(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct.supportHtml=Ge.supportHtml,ct.baseUri=Ge.baseUri?T.URI.from(Ge.baseUri):void 0,ct}fe.to=Le;function xe(Ge){if(!!Ge)return typeof Ge=="string"?Ge:fe.from(Ge)}fe.fromStrict=xe})(R=e.MarkdownString||(e.MarkdownString={}));function O(fe){return v(fe)?fe.map(Ie=>({range:m.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?R.fromMany(Ie.hoverMessage):Ie.hoverMessage?R.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):fe.map(Ie=>({range:m.from(Ie)}))}e.fromRangeOrRangeWithMessage=O;function L(fe){return typeof fe=="undefined"?fe:typeof fe=="string"?T.URI.file(fe):fe}e.pathOrURIToURI=L;var _;(function(fe){function Ie(ge){return typeof ge=="undefined"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?L(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}fe.from=Ie})(_=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(fe){function Ie(ge){return typeof ge=="undefined"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?L(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?_.from(ge.before):void 0,after:ge.after?_.from(ge.after):void 0}}fe.from=Ie})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(fe){function Ie(ge){if(typeof ge=="undefined")return ge;switch(ge){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}fe.from=Ie})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(fe){function Ie(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?M.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?U.from(ge.light):void 0,dark:ge.dark?U.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?L(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?_.from(ge.before):void 0,after:ge.after?_.from(ge.after):void 0}}fe.from=Ie})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(fe){function Ie(ne){return{text:ne.newText,eol:ne.newEol&&et.from(ne.newEol),range:m.from(ne.range)}}fe.from=Ie;function ge(ne){const ye=new a.TextEdit(m.to(ne.range),ne.text);return ye.newEol=typeof ne.eol=="undefined"?void 0:et.to(ne.eol),ye}fe.to=ge})(K=e.TextEdit||(e.TextEdit={}));var x;(function(fe){function Ie(ne,ye){const Le={edits:[]};if(ne instanceof a.WorkspaceEdit)for(let xe of ne._allEntries())xe._type===1?Le.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata}):xe._type===2?Le.edits.push({_type:2,resource:xe.uri,edit:K.from(xe.edit),modelVersionId:ye?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?Le.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:ye?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&Le.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:ye?.getNotebookDocumentVersion(xe.uri),edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(st.from)}});return Le}fe.from=Ie;function ge(ne){const ye=new a.WorkspaceEdit;for(const Le of ne.edits)Le.edit?ye.replace(T.URI.revive(Le.resource),m.to(Le.edit.range),Le.edit.text):ye.renameFile(T.URI.revive(Le.oldUri),T.URI.revive(Le.newUri),Le.options);return ye}fe.to=ge})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(fe){const Ie=Object.create(null);Ie[a.SymbolKind.File]=0,Ie[a.SymbolKind.Module]=1,Ie[a.SymbolKind.Namespace]=2,Ie[a.SymbolKind.Package]=3,Ie[a.SymbolKind.Class]=4,Ie[a.SymbolKind.Method]=5,Ie[a.SymbolKind.Property]=6,Ie[a.SymbolKind.Field]=7,Ie[a.SymbolKind.Constructor]=8,Ie[a.SymbolKind.Enum]=9,Ie[a.SymbolKind.Interface]=10,Ie[a.SymbolKind.Function]=11,Ie[a.SymbolKind.Variable]=12,Ie[a.SymbolKind.Constant]=13,Ie[a.SymbolKind.String]=14,Ie[a.SymbolKind.Number]=15,Ie[a.SymbolKind.Boolean]=16,Ie[a.SymbolKind.Array]=17,Ie[a.SymbolKind.Object]=18,Ie[a.SymbolKind.Key]=19,Ie[a.SymbolKind.Null]=20,Ie[a.SymbolKind.EnumMember]=21,Ie[a.SymbolKind.Struct]=22,Ie[a.SymbolKind.Event]=23,Ie[a.SymbolKind.Operator]=24,Ie[a.SymbolKind.TypeParameter]=25;function ge(ye){return typeof Ie[ye]=="number"?Ie[ye]:6}fe.from=ge;function ne(ye){for(const Le in Ie)if(Ie[Le]===ye)return Number(Le);return a.SymbolKind.Property}fe.to=ne})(B=e.SymbolKind||(e.SymbolKind={}));var G;(function(fe){function Ie(ne){switch(ne){case a.SymbolTag.Deprecated:return 1}}fe.from=Ie;function ge(ne){switch(ne){case 1:return a.SymbolTag.Deprecated}}fe.to=ge})(G=e.SymbolTag||(e.SymbolTag={}));var X;(function(fe){function Ie(ne){return{name:ne.name,kind:B.from(ne.kind),tags:ne.tags&&ne.tags.map(G.from),containerName:ne.containerName,location:ee.from(ne.location)}}fe.from=Ie;function ge(ne){const ye=new a.SymbolInformation(ne.name,B.to(ne.kind),ne.containerName,ee.to(ne.location));return ye.tags=ne.tags&&ne.tags.map(G.to),ye}fe.to=ge})(X=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(fe){function Ie(ne){const ye={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:m.from(ne.range),selectionRange:m.from(ne.selectionRange),kind:B.from(ne.kind),tags:ne.tags?.map(G.from)??[]};return ne.children&&(ye.children=ne.children.map(Ie)),ye}fe.from=Ie;function ge(ne){const ye=new a.DocumentSymbol(ne.name,ne.detail,B.to(ne.kind),m.to(ne.range),m.to(ne.selectionRange));return(0,h.isNonEmptyArray)(ne.tags)&&(ye.tags=ne.tags.map(G.to)),ne.children&&(ye.children=ne.children.map(ge)),ye}fe.to=ge})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var Z;(function(fe){function Ie(ne){const ye=new a.CallHierarchyItem(B.to(ne.kind),ne.name,ne.detail||"",T.URI.revive(ne.uri),m.to(ne.range),m.to(ne.selectionRange));return ye._sessionId=ne._sessionId,ye._itemId=ne._itemId,ye}fe.to=Ie;function ge(ne,ye,Le){if(ye=ye??ne._sessionId,Le=Le??ne._itemId,ye===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Le,name:ne.name,detail:ne.detail,kind:B.from(ne.kind),uri:ne.uri,range:m.from(ne.range),selectionRange:m.from(ne.selectionRange),tags:ne.tags?.map(G.from)}}fe.from=ge})(Z=e.CallHierarchyItem||(e.CallHierarchyItem={}));var se;(function(fe){function Ie(ge){return new a.CallHierarchyIncomingCall(Z.to(ge.from),ge.fromRanges.map(ne=>m.to(ne)))}fe.to=Ie})(se=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ce;(function(fe){function Ie(ge){return new a.CallHierarchyOutgoingCall(Z.to(ge.to),ge.fromRanges.map(ne=>m.to(ne)))}fe.to=Ie})(ce=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ee;(function(fe){function Ie(ne){return{range:ne.range&&m.from(ne.range),uri:ne.uri}}fe.from=Ie;function ge(ne){return new a.Location(T.URI.revive(ne.uri),m.to(ne.range))}fe.to=ge})(ee=e.location||(e.location={}));var Q;(function(fe){function Ie(ne){const ye=ne,Le=ne;return{originSelectionRange:ye.originSelectionRange?m.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Le.uri,range:m.from(ye.targetRange?ye.targetRange:Le.range),targetSelectionRange:ye.targetSelectionRange?m.from(ye.targetSelectionRange):void 0}}fe.from=Ie;function ge(ne){return{targetUri:T.URI.revive(ne.uri),targetRange:m.to(ne.range),targetSelectionRange:ne.targetSelectionRange?m.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?m.to(ne.originSelectionRange):void 0}}fe.to=ge})(Q=e.DefinitionLink||(e.DefinitionLink={}));var oe;(function(fe){function Ie(ne){return{range:m.from(ne.range),contents:R.fromMany(ne.contents)}}fe.from=Ie;function ge(ne){return new a.Hover(ne.contents.map(R.to),m.to(ne.range))}fe.to=ge})(oe=e.Hover||(e.Hover={}));var de;(function(fe){function Ie(ne){return{range:m.from(ne.range),expression:ne.expression}}fe.from=Ie;function ge(ne){return new a.EvaluatableExpression(m.to(ne.range),ne.expression)}fe.to=ge})(de=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(fe){function Ie(ne){if(ne instanceof a.InlineValueText)return{type:"text",range:m.from(ne.range),text:ne.text};if(ne instanceof a.InlineValueVariableLookup)return{type:"variable",range:m.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}fe.from=Ie;function ge(ne){switch(ne.type){case"text":return{range:m.to(ne.range),text:ne.text};case"variable":return{range:m.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:m.to(ne.range),expression:ne.expression}}}fe.to=ge})(ve=e.InlineValue||(e.InlineValue={}));var ke;(function(fe){function Ie(ne){return{frameId:ne.frameId,stoppedLocation:m.from(ne.stoppedLocation)}}fe.from=Ie;function ge(ne){return new a.InlineValueContext(ne.frameId,m.to(ne.stoppedLocation))}fe.to=ge})(ke=e.InlineValueContext||(e.InlineValueContext={}));var Ne;(function(fe){function Ie(ne){return{range:m.from(ne.range),kind:ne.kind}}fe.from=Ie;function ge(ne){return new a.DocumentHighlight(m.to(ne.range),ne.kind)}fe.to=ge})(Ne=e.DocumentHighlight||(e.DocumentHighlight={}));var _e;(function(fe){function Ie(ge){switch(ge){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}fe.to=Ie})(_e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(fe){function Ie(ge){return{triggerKind:_e.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}fe.to=Ie})(Ee=e.CompletionContext||(e.CompletionContext={}));var z;(function(fe){function Ie(ne){switch(ne){case a.CompletionItemTag.Deprecated:return 1}}fe.from=Ie;function ge(ne){switch(ne){case 1:return a.CompletionItemTag.Deprecated}}fe.to=ge})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(fe){const Ie=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ge(Le){return Ie.get(Le)??9}fe.from=ge;const ne=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function ye(Le){return ne.get(Le)??a.CompletionItemKind.Property}fe.to=ye})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var N;(function(fe){function Ie(ge,ne){const ye=new a.CompletionItem(ge.label);return ye.insertText=ge.insertText,ye.kind=W.to(ge.kind),ye.tags=ge.tags?.map(z.to),ye.detail=ge.detail,ye.documentation=k.isMarkdownString(ge.documentation)?R.to(ge.documentation):ge.documentation,ye.sortText=ge.sortText,ye.filterText=ge.filterText,ye.preselect=ge.preselect,ye.commitCharacters=ge.commitCharacters,F.Range.isIRange(ge.range)?ye.range=m.to(ge.range):typeof ge.range=="object"&&(ye.range={inserting:m.to(ge.range.insert),replacing:m.to(ge.range.replace)}),ye.keepWhitespace=typeof ge.insertTextRules=="undefined"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules!="undefined"&&ge.insertTextRules&4?ye.insertText=new a.SnippetString(ge.insertText):(ye.insertText=ge.insertText,ye.textEdit=ye.range instanceof a.Range?new a.TextEdit(ye.range,ye.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(ye.additionalTextEdits=ge.additionalTextEdits.map(Le=>K.to(Le))),ye.command=ne&&ge.command?ne.fromInternal(ge.command):void 0,ye}fe.to=Ie})(N=e.CompletionItem||(e.CompletionItem={}));var $;(function(fe){function Ie(ne){return{label:ne.label,documentation:R.fromStrict(ne.documentation)}}fe.from=Ie;function ge(ne){return{label:ne.label,documentation:k.isMarkdownString(ne.documentation)?R.to(ne.documentation):ne.documentation}}fe.to=ge})($=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(fe){function Ie(ne){return{label:ne.label,documentation:R.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map($.from):[],activeParameter:ne.activeParameter}}fe.from=Ie;function ge(ne){return{label:ne.label,documentation:k.isMarkdownString(ne.documentation)?R.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map($.to):[],activeParameter:ne.activeParameter}}fe.to=ge})(j=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(fe){function Ie(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(j.from):[]}}fe.from=Ie;function ge(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(j.to):[]}}fe.to=ge})(re=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(fe){function Ie(ge,ne){const ye=new a.InlayHint(b.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(Ce.to.bind(void 0,ge)),Ae.to(ne.kind));return ye.tooltip=k.isMarkdownString(ne.tooltip)?R.to(ne.tooltip):ne.tooltip,ye.command=ne.command&&ge.fromInternal(ne.command),ye.paddingLeft=ne.paddingLeft,ye.paddingRight=ne.paddingRight,ye}fe.to=Ie})(he=e.InlayHint||(e.InlayHint={}));var Ce;(function(fe){function Ie(ge,ne){const ye=new a.InlayHintLabelPart(ne.label);return ye.tooltip=k.isMarkdownString(ne.tooltip)?R.to(ne.tooltip):ne.tooltip,D.Command.is(ne.command)&&(ye.command=ge.fromInternal(ne.command)),ne.location&&(ye.location=ee.to(ne.location)),ye}fe.to=Ie})(Ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ae;(function(fe){function Ie(ne){return ne}fe.from=Ie;function ge(ne){return ne}fe.to=ge})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var We;(function(fe){function Ie(ne){return{range:m.from(ne.range),url:ne.target,tooltip:ne.tooltip}}fe.from=Ie;function ge(ne){let ye;if(ne.url)try{ye=typeof ne.url=="string"?T.URI.parse(ne.url,!0):T.URI.revive(ne.url)}catch{}return new a.DocumentLink(m.to(ne.range),ye)}fe.to=ge})(We=e.DocumentLink||(e.DocumentLink={}));var $e;(function(fe){function Ie(ne){const ye=new a.ColorPresentation(ne.label);return ne.textEdit&&(ye.textEdit=K.to(ne.textEdit)),ne.additionalTextEdits&&(ye.additionalTextEdits=ne.additionalTextEdits.map(Le=>K.to(Le))),ye}fe.to=Ie;function ge(ne){return{label:ne.label,textEdit:ne.textEdit?K.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(ye=>K.from(ye)):void 0}}fe.from=ge})($e=e.ColorPresentation||(e.ColorPresentation={}));var je;(function(fe){function Ie(ne){return new a.Color(ne[0],ne[1],ne[2],ne[3])}fe.to=Ie;function ge(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}fe.from=ge})(je=e.Color||(e.Color={}));var He;(function(fe){function Ie(ne){return{range:m.from(ne.range)}}fe.from=Ie;function ge(ne){return new a.SelectionRange(m.to(ne.range))}fe.to=ge})(He=e.SelectionRange||(e.SelectionRange={}));var Ue;(function(fe){function Ie(ge){switch(ge){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}fe.to=Ie})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(fe){function Ie(ne){switch(ne){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}fe.from=Ie;function ge(ne){switch(ne){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}fe.to=ge})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var et;(function(fe){function Ie(ne){if(ne===a.EndOfLine.CRLF)return 1;if(ne===a.EndOfLine.LF)return 0}fe.from=Ie;function ge(ne){if(ne===1)return a.EndOfLine.CRLF;if(ne===0)return a.EndOfLine.LF}fe.to=ge})(et=e.EndOfLine||(e.EndOfLine={}));var Re;(function(fe){function Ie(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}fe.from=Ie})(Re=e.ProgressLocation||(e.ProgressLocation={}));var tt;(function(fe){function Ie(ge){const ne={start:ge.start+1,end:ge.end+1};return ge.kind&&(ne.kind=ie.from(ge.kind)),ne}fe.from=Ie})(tt=e.FoldingRange||(e.FoldingRange={}));var ie;(function(fe){function Ie(ge){if(ge)switch(ge){case a.FoldingRangeKind.Comment:return D.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return D.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return D.FoldingRangeKind.Region}}fe.from=Ie})(ie=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(fe){function Ie(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?m.from(ge.selection):void 0,override:typeof ge.override=="boolean"?g.EditorResolution.DISABLED:void 0}}fe.from=Ie})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var J;(function(fe){function Ie(Le){return Le instanceof a.RelativePattern?Le.toJSON():typeof Le=="string"?Le:ge(Le)||ne(Le)?new a.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}fe.from=Ie;function ge(Le){const xe=Le;return xe?T.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ne(Le){const xe=Le;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function ye(Le){return typeof Le=="string"?Le:new a.RelativePattern(T.URI.revive(Le.baseUri),Le.pattern)}fe.to=ye})(J=e.GlobPattern||(e.GlobPattern={}));var pe;(function(fe){function Ie(ge){if(ge){if(Array.isArray(ge))return ge.map(Ie);if(typeof ge=="string")return ge;{const ne=ge;return{language:ne.language,scheme:ne.scheme,pattern:J.from(ne.pattern),exclusive:ne.exclusive}}}else return}fe.from=Ie})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(fe){function Ie(ne){return{start:ne.start,end:ne.end}}fe.from=Ie;function ge(ne){return new a.NotebookRange(ne.start,ne.end)}fe.to=ge})(Se=e.NotebookRange||(e.NotebookRange={}));var Me;(function(fe){function Ie(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}fe.to=Ie;function ge(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}fe.from=ge})(Me=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ze;(function(fe){function Ie(ne){switch(ne){case a.NotebookCellKind.Markup:return u.CellKind.Markup;case a.NotebookCellKind.Code:default:return u.CellKind.Code}}fe.from=Ie;function ge(ne){switch(ne){case u.CellKind.Markup:return a.NotebookCellKind.Markup;case u.CellKind.Code:default:return a.NotebookCellKind.Code}}fe.to=ge})(ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(fe){function Ie(ne){const ye={metadata:ne.metadata??Object.create(null),cells:[]};for(let Le of ne.cells)a.NotebookCellData.validate(Le),ye.cells.push(st.from(Le));return ye}fe.from=Ie;function ge(ne){const ye=new a.NotebookData(ne.cells.map(st.to));return(0,C.isEmptyObject)(ne.metadata)||(ye.metadata=ne.metadata),ye}fe.to=ge})(Ye=e.NotebookData||(e.NotebookData={}));var st;(function(fe){function Ie(ne){return{cellKind:ze.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Me.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(mt.from):[]}}fe.from=Ie;function ge(ne){return new a.NotebookCellData(ze.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(mt.to):void 0,ne.metadata,ne.internalMetadata?Me.to(ne.internalMetadata):void 0)}fe.to=ge})(st=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(fe){function Ie(ne){return{mime:ne.mime,valueBytes:t.VSBuffer.wrap(ne.data)}}fe.from=Ie;function ge(ne){return new a.NotebookCellOutputItem(ne.valueBytes.buffer,ne.mime)}fe.to=ge})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var mt;(function(fe){function Ie(ne){return{outputId:ne.id,items:ne.items.map(pt.from),metadata:ne.metadata}}fe.from=Ie;function ge(ne){const ye=ne.items.map(pt.to);return new a.NotebookCellOutput(ye,ne.outputId,ne.metadata)}fe.to=ge})(mt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ve;(function(fe){function Ie(ye){return ne(ye)?{include:(0,C.withNullAsUndefined)(J.from(ye.include)),exclude:(0,C.withNullAsUndefined)(J.from(ye.exclude))}:(0,C.withNullAsUndefined)(J.from(ye))}fe.from=Ie;function ge(ye){return ne(ye)?{include:J.to(ye.include),exclude:J.to(ye.exclude)}:J.to(ye)}fe.to=ge;function ne(ye){const Le=ye;return Le?!!Le.include&&!!Le.exclude:!1}})(Ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ot;(function(fe){function Ie(ge){return{backgroundColor:ge.backgroundColor,borderColor:ge.borderColor,top:ge.top?_.from(ge.top):void 0}}fe.from=Ie})(ot=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var _t;(function(fe){function Ie(ge,ne,ye){const Le=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Le,ye),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}fe.from=Ie})(_t=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(fe){function Ie(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{}}}fe.from=Ie})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var lt;(function(fe){function Ie(ne){return{uri:ne.uri,provides:ne.provides}}fe.from=Ie;function ge(ne){return new a.NotebookRendererScript(T.URI.revive(ne.uri),ne.provides)}fe.to=ge})(lt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Rt;(function(fe){function Ie(ne){return{message:R.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,location:ne.location?ee.from(ne.location):void 0}}fe.from=Ie;function ge(ne){const ye=new a.TestMessage(typeof ne.message=="string"?ne.message:R.to(ne.message));return ye.actualOutput=ne.actual,ye.expectedOutput=ne.expected,ye.location=ne.location?ee.to(ne.location):void 0,ye}fe.to=ge})(Rt=e.TestMessage||(e.TestMessage={}));var It;(function(fe){fe.namespace=w.namespaceTestTag,fe.denamespace=w.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var kt;(function(fe){function Ie(Le){const xe=(0,f.getPrivateApiFor)(Le).controllerId;return{extId:y.TestId.fromExtHostTestItem(Le,xe).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ge=>It.namespace(xe,Ge.id)),range:m.from(Le.range)||null,description:Le.description||null,sortText:Le.sortText||null,error:Le.error&&R.fromStrict(Le.error)||null}}fe.from=Ie;function ge(Le){return{parent:void 0,error:void 0,id:y.TestId.fromString(Le.extId).localId,label:Le.label,uri:T.URI.revive(Le.uri),tags:(Le.tags||[]).map(xe=>{const{tagId:Ge}=It.denamespace(xe);return new a.TestTag(Ge)}),range:m.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0,sortText:Le.sortText||void 0}}fe.toPlain=ge;function ne(Le){const xe=y.TestId.fromString(Le.extId),Ge=new f.TestItemImpl(xe.controllerId,xe.localId,Le.label,T.URI.revive(Le.uri));return Ge.range=m.to(Le.range||void 0),Ge.description=Le.description||void 0,Ge.sortText=Le.sortText||void 0,Ge}function ye(Le){let xe;for(const Ge of Le.tests){const ct=ne(Ge.item);(0,f.getPrivateApiFor)(ct).parent=xe,xe=ct}return xe}fe.toItemFromContext=ye})(kt=e.TestItem||(e.TestItem={})),function(fe){function Ie(ne){return{id:ne.id}}fe.from=Ie;function ge(ne){return new a.TestTag(ne.id)}fe.to=ge}(It=e.TestTag||(e.TestTag={}));var dt;(function(fe){const Ie=(ne,ye)=>{const Le={...kt.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(Ge=>Ge.type===0).map(Rt.to)})),children:ne.children.map(xe=>ye.get(xe)).filter(C.isDefined).map(xe=>Ie(xe,ye))};for(const xe of Le.children)xe.parent=Le;return Le};function ge(ne){const ye=[],Le=new Map;for(const xe of ne.items)Le.set(xe.item.extId,xe),ne.request.targets.some(Ge=>Ge.controllerId===xe.controllerId&&Ge.testIds.includes(xe.item.extId))&&ye.push(xe);return{completedAt:ne.completedAt,results:ye.map(xe=>Ie(xe,Le))}}fe.to=ge})(dt=e.TestResults||(e.TestResults={}));var Ot;(function(fe){function Ie(Le){return{covered:Le.covered,total:Le.covered}}function ge(Le){return"line"in Le?b.from(Le):m.from(Le)}function ne(Le){return"branches"in Le?{count:Le.executionCount,location:ge(Le.location),type:1,branches:Le.branches.length?Le.branches.map(xe=>({count:xe.executionCount,location:xe.location&&ge(xe.location)})):void 0}:{type:0,count:Le.executionCount,location:ge(Le.location)}}fe.fromDetailed=ne;function ye(Le){return{uri:Le.uri,statement:Ie(Le.statementCoverage),branch:Le.branchCoverage&&Ie(Le.branchCoverage),function:Le.functionCoverage&&Ie(Le.functionCoverage),details:Le.detailedCoverage?.map(ne)}}fe.fromFile=ye})(Ot=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(fe){function Ie(ge){switch(ge){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}fe.to=Ie})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(fe){function Ie(ne){const ye=new a.TypeHierarchyItem(B.to(ne.kind),ne.name,ne.detail||"",T.URI.revive(ne.uri),m.to(ne.range),m.to(ne.selectionRange));return ye._sessionId=ne._sessionId,ye._itemId=ne._itemId,ye}fe.to=Ie;function ge(ne,ye,Le){if(ye=ye??ne._sessionId,Le=Le??ne._itemId,ye===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Le,kind:B.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:m.from(ne.range),selectionRange:m.from(ne.selectionRange),tags:ne.tags?.map(G.from)}}fe.from=ge})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[222],be([1,0,2,16,7,15,93]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(T,F,D,g={timeout:1500,errors:3}){this._logService=T,this._documents=F,this._mainThreadBulkEdits=D,this._thresholds=g,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(F,D,g)=>{const f={dispose:this._callbacks.push([F,D,T])};return Array.isArray(g)&&g.push(f),f}}async $participateInSave(T,F){const D=h.URI.revive(T);let g=!1;const E=setTimeout(()=>g=!0,this._thresholds.timeout),f=[];try{for(let u of[...this._callbacks]){if(g)break;const w=this._documents.getDocument(D),y=await this._deliverEventAsyncAndBlameBadListeners(u,{document:w,reason:A.TextDocumentSaveReason.to(F)});f.push(y)}}finally{clearTimeout(E)}return f}_deliverEventAsyncAndBlameBadListeners([T,F,D],g){const E=this._badListeners.get(T);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,T,F,g).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const u=this._badListeners.get(T);this._badListeners.set(T,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,F,D,g){const E=[],f=Date.now(),{document:u,reason:w}=g,{version:y}=u,I=Object.freeze({document:u,reason:w,waitUntil(a){if(Object.isFrozen(E))throw(0,t.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(a))}});try{F.apply(D,[I])}catch(a){return Promise.reject(a)}return Object.freeze(E),new Promise((a,c)=>{const m=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(m),a(s)}).catch(s=>{clearTimeout(m),c(s)})}).then(a=>{const c={edits:[]};for(const m of a)if(Array.isArray(m)&&m.every(s=>s instanceof k.TextEdit))for(const{newText:s,newEol:b,range:o}of m)c.edits.push({_type:2,resource:u.uri,edit:{range:o&&A.Range.from(o),text:s,eol:b&&A.EndOfLine.from(b)}});if(c.edits.length!==0)return y===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(we[223],be([1,0,10,25,2,15,129]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(D,g,E,f){this.start=D,this.deletedCount=g,this.deletedItems=E,this.items=f}static asApiEvents(D){return D.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(E=>E.apiCell)}))}}class C{constructor(D,g,E){this.notebook=D,this._extHostDocument=g,this._cellData=E,this.handle=E.handle,this.uri=k.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}static asModelAddData(D,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:D}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return D._mime},set mime(E){D._mime=E},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}})}return this._apiCell}setOutputs(D){this._outputs=D.map(A.NotebookCellOutput.to)}setOutputItems(D,g,E){const f=E.map(A.NotebookCellOutputItem.to),u=this._outputs.find(w=>w.id===D);u&&(g||(u.items.length=0),u.items.push(...f))}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=C;class T{constructor(D,g,E,f,u,w){this._proxy=D,this._textDocumentsAndEditors=g,this._textDocuments=E,this._emitter=f,this.uri=u,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const D=this;this._notebook={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===h.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(g){return g=D._validateIndex(g),D._cells[g].apiCell},getCells(g){return(g?D._getCells(g):D._cells).map(f=>f.apiCell)},save(){return D._save()}}}return this._notebook}updateBackup(D){this._backup?.delete(),this._backup=D}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,g){this._versionId=D.versionId,this._isDirty=g;for(const E of D.rawEvents)E.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(E.changes,!1):E.kind===S.NotebookCellsChangeType.Move?this._moveCell(E.index,E.newIdx):E.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(E.index,E.outputs):E.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(E.index,E.outputId,E.append,E.outputItems):E.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(E.index,E.language):E.kind===S.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(E.index,E.mime):E.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(E.index,E.metadata):E.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(E.index,E.internalMetadata)}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let g=D.start|0,E=D.end|0;return g<0&&(g=0),E>this._cells.length&&(E=this._cells.length),D.with({start:g,end:E})}_getCells(D){D=this._validateRange(D);const g=[];for(let E=D.start;E<D.end;E++)g.push(this._cells[E]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,g){if(this._disposed)return;const E=[],f=[],u=[];D.reverse().forEach(w=>{const I=w[2].map(m=>{const s=new C(this,this._textDocumentsAndEditors,m);return g||f.push(C.asModelAddData(this.apiNotebook,m)),s}),a=new P(w[0],w[1],[],I),c=this._cells.splice(w[0],w[1],...I);for(const m of c)u.push(m.uri),a.deletedItems.push(m.apiCell);E.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:u}),g||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(E)}))}_moveCell(D,g){const E=this._cells.splice(D,1);this._cells.splice(g,0,...E);const f=[new P(D,1,E.map(u=>u.apiCell),[]),new P(g,0,[],E)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(f)}))}_setCellOutputs(D,g){const E=this._cells[D];E.setOutputs(g),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_setCellOutputItems(D,g,E,f){const u=this._cells[D];u.setOutputItems(g,E,f),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_changeCellLanguage(D,g){const E=this._cells[D];E.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(E.uri,g)}_changeCellMime(D,g){const E=this._cells[D];E.apiCell.mime=g}_changeCellMetadata(D,g){const E=this._cells[D],f=E.apiCell.metadata;E.setMetadata(g);const u=E.apiCell.metadata;(0,t.equals)(f,u)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:E.apiCell}))}_changeCellInternalMetadata(D,g){this._cells[D].setInternalMetadata(g)}getCellFromApiCell(D){return this._cells.find(g=>g.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(g=>g.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(we[131],be([1,0,7,15,16]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:T})}replaceCells(C,T,F){this._throwIfFinalized(),!(C===T&&F.length===0)&&this._collectedEdits.push({editType:1,index:C,count:T-C,cells:F.map(t.NotebookCellData.from)})}}class S{constructor(C,T,F,D,g,E){this.id=C,this._proxy=T,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._visibleRanges=D,this._viewColumn=E}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(T){if(!Array.isArray(T)||!T.every(h.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");C._selections=T,C._trySetSelections(T)},get visibleRanges(){return C._visibleRanges},revealRange(T,F){C._proxy.$tryRevealRange(C.id,t.NotebookRange.from(T),F??h.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(T){const F=new A(this.document.version);return T(F),C._applyEdit(F.finalize())},setDecorations(T,F){return C.setDecorations(T,F)}},S.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(t.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const T=[];let F=-1;for(let D=0;D<C.cellEdits.length;D++){if(F<0){T.push(C.cellEdits[D]),F++;continue}const E=T[F],f=C.cellEdits[D];if(E.editType===1&&f.editType===1&&E.index===f.index){E.cells.push(...C.cellEdits[D].cells),E.count+=C.cellEdits[D].count;continue}T.push(C.cellEdits[D]),F++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,T)}setDecorations(C,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return T.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(T),C.key)}}e.ExtHostNotebookEditor=S,S.apiEditorsToExtHost=new WeakMap}),define(we[224],be([1,0,15,120,170,21,56,16]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(g){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=g}async withProgress(g,E,f){const u=this._handles++,{title:w,location:y,cancellable:I}=E,a={label:(0,k.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this._proxy.$startProgress(u,{location:h.ProgressLocation.from(y),title:w,source:a,cancellable:I},g.isUnderDevelopment?void 0:g.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(u,f,!!I)}_withProgress(g,E,f){let u;f&&(u=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(g,u));const w=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),u&&u.dispose()};let y;try{y=E(new F(this._proxy,g),f&&u?u.token:A.CancellationToken.None)}catch(I){throw w(g),I}return y.then(I=>w(g),I=>w(g)),y}$acceptProgressCanceled(g){const E=this._mapHandleToCancellationSource.get(g);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(g))}}e.ExtHostProgress=C;function T(D,g){return D.message=g.message,typeof g.increment=="number"&&(typeof D.increment=="number"?D.increment+=g.increment:D.increment=g.increment),D}class F extends t.Progress{constructor(g,E){super(f=>this.throttledReport(f));this._proxy=g,this._handle=E}throttledReport(g){this._proxy.$progressReport(this._handle,g)}}Be([(0,S.throttle)(100,(D,g)=>T(D,g),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(we[132],be([1,0,55,16,76,15,7]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(g,E,f){const u=P._Keys.nextId();g.$registerTextEditorDecorationType(E.identifier,u,A.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:u,dispose(){g.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new k.IdGenerator("TextEditorDecorationType");class C{constructor(g,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,E){this._throwIfFinalized();let f=null;if(g instanceof S.Position)f=new S.Range(g,g);else if(g instanceof S.Range)f=g;else throw new Error("Unrecognized location");this._pushEdit(f,E,!1)}insert(g,E){this._throwIfFinalized(),this._pushEdit(new S.Range(g,g),E,!0)}delete(g){this._throwIfFinalized();let E=null;if(g instanceof S.Range)E=g;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(g,E,f){const u=this._document.validateRange(g);this._collectedEdits.push({range:u,text:E,forceMoveMarkers:f})}setEndOfLine(g){if(this._throwIfFinalized(),g!==S.EndOfLine.LF&&g!==S.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=C;class T{constructor(g,E,f,u){this._proxy=g,this._id=E,this._accept(f),this._logService=u;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(y){w._setTabSize(y)},get insertSpaces(){return w._insertSpaces},set insertSpaces(y){w._setInsertSpaces(y)},get cursorStyle(){return w._cursorStyle},set cursorStyle(y){w._setCursorStyle(y)},get lineNumbers(){return w._lineNumbers},set lineNumbers(y){w._setLineNumbers(y)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const E=Math.floor(g);return E>0?E:null}if(typeof g=="string"){const E=parseInt(g,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(g){const E=this._validateTabSize(g);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const E=this._validateInsertSpaces(g);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(g)})))}assign(g){const E={};let f=!1;if(typeof g.tabSize!="undefined"){const u=this._validateTabSize(g.tabSize);u==="auto"?(f=!0,E.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,f=!0,E.tabSize=u)}if(typeof g.insertSpaces!="undefined"){const u=this._validateInsertSpaces(g.insertSpaces);u==="auto"?(f=!0,E.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,f=!0,E.insertSpaces=u)}typeof g.cursorStyle!="undefined"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,f=!0,E.cursorStyle=g.cursorStyle),typeof g.lineNumbers!="undefined"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,f=!0,E.lineNumbers=A.TextEditorLineNumbersStyle.from(g.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(g,E){E.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=T;class F{constructor(g,E,f,u,w,y,I,a){this.id=g,this._proxy=E,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new T(this._proxy,this.id,y,f),this._visibleRanges=I,this._viewColumn=a;const c=this;this.value=Object.freeze({get document(){return u.getValue()},set document(m){throw(0,t.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(m){if(!(m instanceof S.Selection))throw(0,t.illegalArgument)("selection");c._selections=[m],c._trySetSelection()},get selections(){return c._selections},set selections(m){if(!Array.isArray(m)||m.some(s=>!(s instanceof S.Selection)))throw(0,t.illegalArgument)("selections");c._selections=m,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(m){throw(0,t.readonly)("visibleRanges")},get options(){return c._options.value},set options(m){c._disposed||c._options.assign(m)},get viewColumn(){return c._viewColumn},set viewColumn(m){throw(0,t.readonly)("viewColumn")},edit(m,s={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new C(u.getValue(),s);return m(b),c._applyEdit(b)},insertSnippet(m,s,b={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!s||Array.isArray(s)&&s.length===0)o=c._selections.map(n=>A.Range.from(n));else if(s instanceof S.Position){const{lineNumber:n,column:i}=A.Position.from(s);o=[{startLineNumber:n,startColumn:i,endLineNumber:n,endColumn:i}]}else if(s instanceof S.Range)o=[A.Range.from(s)];else{o=[];for(const n of s)if(n instanceof S.Range)o.push(A.Range.from(n));else{const{lineNumber:i,column:r}=A.Position.from(n);o.push({startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r})}}return E.$tryInsertSnippet(g,m.value,o,b)},setDecorations(m,s){const b=s.length===0;b&&!c._hasDecorationsForKey.has(m.key)||(b?c._hasDecorationsForKey.delete(m.key):c._hasDecorationsForKey.add(m.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(s))return E.$trySetDecorations(g,m.key,A.fromRangeOrRangeWithMessage(s));{const o=new Array(4*s.length);for(let n=0,i=s.length;n<i;n++){const r=s[n];o[4*n]=r.start.line+1,o[4*n+1]=r.start.character+1,o[4*n+2]=r.end.line+1,o[4*n+3]=r.end.character+1}return E.$trySetDecorationsFast(g,m.key,o)}}))},revealRange(m,s){c._runOnProxy(()=>E.$tryRevealRange(g,A.Range.from(m),s||S.TextEditorRevealType.Default))},show(m){E.$tryShowEditor(g,A.ViewColumn.from(m))},hide(){E.$tryHideEditor(g)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,h.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,h.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,h.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,h.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const E=g.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const f=E.edits.map(w=>w.range);f.sort((w,y)=>w.end.line===y.end.line?w.end.character===y.end.character?w.start.line===y.start.line?w.start.character-y.start.character:w.start.line-y.start.line:w.end.character-y.end.character:w.end.line-y.end.line);for(let w=0,y=f.length-1;w<y;w++){const I=f[w].end;if(f[w+1].start.isBefore(I))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=E.edits.map(w=>({range:A.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,u,{setEndOfLine:typeof E.setEndOfLine=="number"?A.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=F}),define(we[225],be([1,0,13,3,6,18,63,15,87,88]),function(te,e,h,t,k,A,S,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends k.Disposable{constructor(g){super();this.controllerId=g,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new S.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const E=this.diff[this.diff.length-1];if(E&&g[0]===1){if(E[0]===1&&E[1].extId===g[1].extId){(0,C.applyTestItemUpdate)(E[1],g[1]);return}if(E[0]===0&&E[1].item.extId===g[1].extId){(0,C.applyTestItemUpdate)(E[1],g[1]);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,E){const f=this.tree.get(g);if(!!f){if((f.expandLevels===void 0||E>f.expandLevels)&&(f.expandLevels=E),f.expand===1){const u=this.resolveChildren(f);return u.isOpen()?this.expandChildren(f,E-1):u.wait().then(()=>this.expandChildren(f,E-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.expandChildren(f,E-1)):this.expandChildren(f,E-1)}}dispose(){for(const g of this.tree.values())(0,S.getPrivateApiFor)(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,E){switch(E.op){case 2:this.pushDiff([4,g.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(g.fullId,E.id));break;case 0:this.upsertItem(E.item,g);break;case 4:for(const f of E.ops)this.onTestItemEvent(g,f);break;case 3:{const{key:f,value:u,previous:w}=E,y=g.fullId.toString();switch(f){case"canResolveChildren":this.updateExpandability(g);break;case"tags":this.diffTagRefs(u,w,y);break;case"range":this.pushDiff([1,{extId:y,item:{range:P.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:y,item:{error:P.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:y,item:{[f]:u??null}}]);break}break}default:(0,A.assertNever)(E)}}upsertItem(g,E){if(!(g instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);const f=T.TestId.fromExtHostTestItem(g,this.root.id,E?.actual),u=(0,S.getPrivateApiFor)(g);u.parent&&u.parent!==E?.actual&&u.parent.children.delete(g.id);let w=this.tree.get(f.toString());if(!w){w={fullId:f,actual:g,parent:E?f.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(g,E),this.pushDiff([0,{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:P.TestItem.from(g)}]),this.connectItemAndChildren(g,w,E);return}if(w.actual===g){this.connectItem(g,w,E);return}const y=w.actual.children,I=w.actual,a=(0,S.diffTestItems)(I,g);(0,S.getPrivateApiFor)(I).listener=void 0,w.actual=g,w.expand=0;for(const[c,m]of a)this.onTestItemEvent(w,{op:3,key:c,value:m,previous:I[c]});this.connectItemAndChildren(g,w,E);for(const c of y)g.children.get(c.id)||this.removeItem(T.TestId.joinToString(f,c.id))}diffTagRefs(g,E,f){const u=new Set(E.map(w=>w.id));for(const w of g)u.delete(w.id)||this.incrementTagRefs(w);this.pushDiff([1,{extId:f,item:{tags:g.map(w=>P.TestTag.namespace(this.controllerId,w.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const E=this.tags.get(g.id);E?E.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,g.id),ctrlLabel:this.root.label}]))}decrementTagRefs(g){const E=this.tags.get(g);E&&!--E.refCount&&(this.tags.delete(g),this.pushDiff([6,P.TestTag.namespace(this.controllerId,g)]))}setItemParent(g,E){(0,S.getPrivateApiFor)(g).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(g,E,f){this.setItemParent(g,f);const u=(0,S.getPrivateApiFor)(g);u.parent=f?.actual,u.listener=w=>this.onTestItemEvent(E,w),this.updateExpandability(E)}connectItemAndChildren(g,E,f){this.connectItem(g,E,f);for(const u of g.children)this.upsertItem(u,E)}updateExpandability(g){let E;this._resolveHandler?g.resolveBarrier?E=g.resolveBarrier.isOpen()?3:2:E=g.actual.canResolveChildren?1:0:E=0,E!==g.expand&&(g.expand=E,this.pushDiff([1,{extId:g.fullId.toString(),expand:E}]),E===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,E){if(E<0)return;const f=[];for(const u of g.actual.children){const w=this.expand(T.TestId.joinToString(g.fullId,u.id),E);(0,h.isThenable)(w)&&f.push(w)}if(f.length)return Promise.all(f).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const w=new h.Barrier;return w.open(),w}g.expand=2,this.pushExpandStateUpdate(g);const E=g.resolveBarrier=new h.Barrier,f=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),g.actual!==this.root&&(g.actual.error=w.stack||w.message||String(w))};let u;try{u=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(w){f(w)}return(0,h.isThenable)(u)?u.catch(f).then(()=>{E.open(),this.updateExpandability(g)}):(E.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff([1,{extId:g.fullId.toString(),expand:g.expand}])}removeItem(g){const E=this.tree.get(g);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff([2,g]);const f=[E];for(;f.length;){const u=f.pop();if(!!u){(0,S.getPrivateApiFor)(u.actual).listener=void 0;for(const w of u.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(u.fullId.toString());for(const w of u.actual.children)f.push(this.tree.get(T.TestId.joinToString(u.fullId,w.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.SingleUseTestCollection=F}),define(we[226],be([1,0,4,187]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(t.IEnvironmentService)}),define(we[227],be([1,0,27,3,9]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=A;class S{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let D of F.activationEvents)D==="onUri"&&(D=`onUri:${h.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(D)||this._activationMap.set(D,[]),this._activationMap.get(D).push(F)}}keepOnly(F){const D=new Set;F.forEach(g=>D.add(h.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>D.has(h.ExtensionIdentifier.toKey(g.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,D){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const g=S._findLoopingExtensions(this._extensionDescriptions);if(D=D.concat(g.map(E=>E.identifier)),D.length>0){const E=new Set;D.forEach(f=>E.add(h.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!E.has(h.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(g)}static _findLoopingExtensions(F){const D=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,y){this.addNode(w),this.addNode(y),this._arcs.has(w)?this._arcs.get(w).push(y):this._arcs.set(w,[y])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,y){const I=D.getArcs(w);for(let a=0;a<I.length;a++)if(!y.has(I[a]))return!1;return!0}getNodes(){return this._nodesArr}};let g=new Map;for(let w of F){const y=h.ExtensionIdentifier.toKey(w.identifier);if(g.set(y,w),w.extensionDependencies)for(let I of w.extensionDependencies){const a=h.ExtensionIdentifier.toKey(I);D.addArc(y,a)}}let E=new Set;D.getNodes().filter(w=>D.getArcs(w).length===0).forEach(w=>E.add(w));let f=D.getNodes().filter(w=>!E.has(w)),u;do{u=!1;for(let w=0;w<f.length;w++){const y=f[w];D.hasOnlyGoodArcs(y,E)&&(f.splice(w,1),w--,E.add(y),u=!0)}}while(u);return f.map(w=>g.get(w))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const D=this._activationMap.get(F);return D?D.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const D=this._extensionsMap.get(h.ExtensionIdentifier.toKey(F));return D||void 0}}e.ExtensionDescriptionRegistry=S;var P;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(P||(P={}));function C(T,F){const D=T.isBuiltin?0:T.isUnderDevelopment?2:1,g=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(D!==g)return D-g;const E=k.posix.basename(T.extensionLocation.path),f=k.posix.basename(F.extensionLocation.path);return E<f?-1:E>f?1:0}}),define(we[133],be([1,0,23]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var k;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function S(C){const T=h.VSBuffer.alloc(1);switch(C){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=S;function P(C,T){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=P}),define(we[30],be([1,0,3,2,4,27,123]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var P;(function(c){c[c.None=0]="None",c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(c){switch(c){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class T{constructor(m){this.dependency=m}}e.MissingExtensionDependency=T;var F;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function D(c){switch(c){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=D;function g(c,m){return c.enabledApiProposals?c.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=g;function E(c,m){if(!g(c,m))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=E;class f{constructor(m,s,b,o){this.codeLoadingTime=m,this.activateCallTime=s,this.activateResolvedTime=b,this.activationReason=o}}e.ActivationTimes=f;class u{constructor(m,s){this.description=m,this.value=s}}e.ExtensionPointContribution=u,e.ExtensionHostLogFileName="exthost";var w;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(w=e.ActivationKind||(e.ActivationKind={}));function y(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=y;function I(c,m){return{identifier:new A.ExtensionIdentifier((0,S.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!m,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid}}e.toExtensionDescription=I;class a{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(m){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(m,s){return Promise.resolve()}}e.NullExtensionService=a}),define(we[228],be([1,0,16,27,30,11]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class P{constructor(u,w,y,I){this.startup=u,this.codeLoadingTime=w,this.activateCallTime=y,this.activateResolvedTime=I}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class C{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,w){return u===-1||w===-1?-1:w-u}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class T{constructor(u,w,y,I,a,c){this.activationFailed=u,this.activationFailedError=w,this.activationTimes=y,this.module=I,this.exports=a,this.subscriptions=c}}e.ActivatedExtension=T;class F extends T{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class D extends T{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class g extends T{constructor(u){super(!0,u,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let E=class{constructor(u,w,y,I,a){this._logService=a,this._isDisposed=!1,this._registry=u,this._resolvedExtensionsSet=new Set,w.forEach(c=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,y.forEach(c=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(c),c)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(u){const w=t.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(w)}getActivatedExtension(u){const w=t.ExtensionIdentifier.toKey(u),y=this._activatedExtensions.get(w);if(!y)throw new Error("Extension `"+u.value+"` is not known or not activated");return y}activateByEvent(u,w){if(this._alreadyActivatedEvents[u])return S;const y=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(y.map(I=>({id:I.identifier,reason:{startup:w,extensionId:I.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,w){const y=this._registry.getExtensionDescription(u);if(!y)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:y.identifier,reason:w}])}_handleActivateRequest(u,w,y){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(u.id))){w[t.ExtensionIdentifier.toKey(u.id)]=u;return}const I=this._registry.getExtensionDescription(u.id);if(!I){const m=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,m,new k.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(u.id),new g(m));return}const a=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let c=!0;for(let m=0,s=a.length;m<s;m++){const b=a[m];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(b)))continue;const o=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(b));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const l=I.displayName||I.identifier.value,p=this._registry.getExtensionDescription(b),d=p&&p.displayName||b,v=new Error(`Cannot activate the '${l}' extension because its dependency '${d}' failed to activate`);v.detail=o.activationFailedError,this._host.onExtensionActivationError(I.identifier,v,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(I.identifier),new g(v));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(b))){c=!1,w[t.ExtensionIdentifier.toKey(b)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(b)),reason:u.reason};continue}const n=this._registry.getExtensionDescription(b);if(n){if(!n.main&&!n.browser)continue;c=!1,w[t.ExtensionIdentifier.toKey(b)]={id:n.identifier,reason:u.reason};continue}const i=I.displayName||I.identifier.value,r=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${b}'`);this._host.onExtensionActivationError(I.identifier,r,new k.MissingExtensionDependency(b)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(I.identifier),new g(r));return}c?w[t.ExtensionIdentifier.toKey(I.identifier)]=u:y.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(a=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(a.id))),u.length===0))return Promise.resolve(void 0);const w=Object.create(null),y=[];for(let a=0,c=u.length;a<c;a++)this._handleActivateRequest(u[a],w,y);for(let a=0,c=y.length;a<c;a++){const m=t.ExtensionIdentifier.toKey(y[a].id);w[m]&&delete w[m]}const I=Object.keys(w).map(a=>w[a]);return y.length===0?Promise.all(I.map(a=>this._activateExtension(a.id,a.reason))).then(a=>{}):this._activateExtensions(I).then(a=>this._activateExtensions(y))}_activateExtension(u,w){const y=t.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(y))return Promise.resolve(void 0);const I=this._activatingExtensions.get(y);if(I)return I;const a=this._host.actualActivateExtension(u,w).then(void 0,c=>{const m=new Error;return c&&c.name&&(m.name=c.name),c&&c.message?m.message=`Activating extension '${u.value}' failed: ${c.message}.`:m.message=`Activating extension '${u.value}' failed: ${c}.`,c&&c.stack&&(m.stack=c.stack),this._isDisposed&&h.isCancellationError(c)?new g(c):(this._host.onExtensionActivationError(u,m,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(c),new g(c))}).then(c=>{this._activatedExtensions.set(y,c),this._activatingExtensions.delete(y)});return this._activatingExtensions.set(y,a),a}};E=Be([Fe(4,A.ILogService)],E),e.ExtensionsActivator=E}),define(we[229],be([1,0,11,26,30]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends h.LogService{constructor(P,C){super(P.createLogger(C.logFile,{name:k.ExtensionHostLogFileName}))}};A=Be([Fe(0,h.ILoggerService),Fe(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(we[230],be([1,0,16]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,S)=>{this._actualOk=A,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,h.onUnexpectedError)(A))}then(A,S){return this._ensureActual().then(A,S)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=t}),define(we[52],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(C){this._proxyIdentifierBrand=void 0,this.sid=C,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const t=[];function k(P){const C=new h(P);return t[C.nid]=C,C}e.createProxyIdentifier=k;function A(P){return t[P].sid}e.getStringIdentifierForProxy=A;class S{constructor(C){this.value=C}}e.SerializableObjectWithBuffers=S}),define(we[5],be([1,0,59,2,52]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=void 0;var A;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(y){y[y.Editable=0]="Editable",y[y.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(y){y[y.Int8Array=1]="Int8Array",y[y.Uint8Array=2]="Uint8Array",y[y.Uint8ClampedArray=3]="Uint8ClampedArray",y[y.Int16Array=4]="Int16Array",y[y.Uint16Array=5]="Uint16Array",y[y.Int32Array=6]="Int32Array",y[y.Uint32Array=7]="Uint32Array",y[y.Float32Array=8]="Float32Array",y[y.Float64Array=9]="Float64Array",y[y.BigInt64Array=10]="BigInt64Array",y[y.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(y){y[y.Text=1]="Text",y[y.Error=2]="Error",y[y.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var F;(function(y){y[y.None=0]="None",y[y.Process=1]="Process",y[y.Output=2]="Output"})(F=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(I){return I._id=D._n++,I}}e.IdObject=D,D._n=0;var g;(function(y){y.label="a",y.kind="b",y.detail="c",y.documentation="d",y.sortText="e",y.filterText="f",y.preselect="g",y.insertText="h",y.insertTextRules="i",y.range="j",y.commitCharacters="k",y.additionalTextEdits="l",y.command="m",y.kindModifier="n"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(y){y.defaultRanges="a",y.completions="b",y.isIncomplete="c",y.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(y){y[y.File=1]="File",y[y.Text=2]="Text",y[y.Cell=3]="Cell"})(f=e.WorkspaceEditType||(e.WorkspaceEditType={}));function u(y){if(y&&y.edits)for(const I of y.edits)typeof I.resource=="object"?I.resource=t.URI.revive(I.resource):(I.newUri=t.URI.revive(I.newUri),I.oldUri=t.URI.revive(I.oldUri)),I.metadata&&I.metadata.iconPath&&(I.metadata=(0,h.revive)(I.metadata));return y}e.reviveWorkspaceEditDto=u;var w;(function(y){y[y.Workspace=0]="Workspace",y[y.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,k.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,k.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createProxyIdentifier)("ExtHostTelemetry")}}),define(we[89],be([1,0,5,3,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,C){return this._proxy.$getPassword(P,C)}store(P,C,T){return this._proxy.$setPassword(P,C,T)}delete(P,C){return this._proxy.$deletePassword(P,C)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(we[65],be([1,0,4,11,5,14]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(C,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(k.MainContext.MainThreadTelemetry)}report(C,T,F){const D=this.getUsageKey(C,T);this._reportedUsages.has(D)||(this._reportedUsages.add(D),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:C}))}getUsageKey(C,T){return`${C}-${T.identifier.value}`}};S=Be([Fe(0,A.IExtHostRpcService),Fe(1,t.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(P,C,T){}})}),define(we[231],be([1,0,3,5,7,27]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,T,F,D={}){const g=A.ExtensionIdentifier.toKey(C.identifier),E=this._inFlightRequests.get(g)||[],f=[...F].sort().join(" ");let u=E.find(w=>w.scopes===f);if(u)return u.result;{const w=this._getSession(C,g,T,F,D);u={scopes:f,result:w},E.push(u),this._inFlightRequests.set(g,E);try{await w}finally{const y=E.findIndex(I=>I.scopes===f);y>-1&&(E.splice(y),this._inFlightRequests.set(g,E))}return w}}async _getSession(C,T,F,D,g={}){await this._proxy.$ensureProvider(F);const E=C.displayName||C.name;return this._proxy.$getSession(F,D,T,E,g)}async removeSession(C,T){const F=this._authenticationProviders.get(C);return F?F.provider.removeSession(T):this._proxy.$removeSession(C,T)}registerAuthenticationProvider(C,T,F,D){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:T,provider:F,options:D??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===C)||this._providers.push({id:C,label:T});const g=F.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(C,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,T,D?.supportsMultipleAccounts??!1),new k.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(C);const E=this._providers.findIndex(f=>f.id===C);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,T){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,T){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,T){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,T){return this._onDidChangeSessions.fire({provider:{id:C,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(we[232],be([1,0,5,14,15]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,C){this._proxy=P.getProxy(h.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:T=>C.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P){const C=k.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(C)}};A=Be([Fe(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(we[233],be([1,0,5]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const S=A.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(P){return S.$writeText(P)}})}}e.ExtHostClipboard=t});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[38],be([1,0,18,7,15,25,5,17,11,59,41,48,2,6,4,14,63,23,52,49]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let m=class{constructor(r,l){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ke(this,c,r.getProxy(S.MainContext.MainThreadCommands),"f"),this._logService=l,this.converter=new s(this,p=>{const d=this._apiCommands.get(p);return d?.result===o.Void?d:void 0},l),this._argumentProcessors=[{processArgument(p){return(0,T.revive)(p)}},{processArgument(p){return(0,A.cloneAndChange)(p,function(d){if(F.Range.isIRange(d))return k.Range.to(d);if(D.Position.isIPosition(d))return k.Position.to(d);if(F.Range.isIRange(d.range)&&g.URI.isUri(d.uri))return k.location.to(d);if(d instanceof y.VSBuffer)return d.buffer.buffer;if(!Array.isArray(d))return d})}}]}registerArgumentProcessor(r){this._argumentProcessors.push(r)}registerApiCommand(r){const l=this.registerCommand(!1,r.id,async(...p)=>{const d=r.args.map((R,O)=>{if(!R.validate(p[O]))throw new Error(`Invalid argument '${R.name}' when running '${r.id}', received: ${p[O]}`);return R.convert(p[O])}),v=await this.executeCommand(r.internalId,...d);return r.result.convert(v,p,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this._apiCommands.set(r.id,r),new t.Disposable(()=>{l.dispose(),this._apiCommands.delete(r.id)})}registerCommand(r,l,p,d,v,R){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:p,thisArg:d,description:v,extension:R}),r&&Te(this,c,"f").$registerCommand(l),new t.Disposable(()=>{this._commands.delete(l)&&r&&Te(this,c,"f").$unregisterCommand(l)})}executeCommand(r,...l){return this._logService.trace("ExtHostCommands#executeCommand",r),this._doExecuteCommand(r,l,!0)}async _doExecuteCommand(r,l,p){if(this._commands.has(r))return this._executeContributedCommand(r,l,!1);{let d=!1;const v=(0,A.cloneAndChange)(l,function(R){if(R instanceof t.Position)return k.Position.from(R);if(R instanceof t.Range)return k.Range.from(R);if(R instanceof t.Location)return k.location.from(R);if(t.NotebookRange.isNotebookRange(R))return k.NotebookRange.from(R);if(R instanceof ArrayBuffer)return d=!0,y.VSBuffer.wrap(new Uint8Array(R));if(R instanceof Uint8Array)return d=!0,y.VSBuffer.wrap(R);if(!Array.isArray(R))return R});try{const R=await Te(this,c,"f").$executeCommand(r,d?new I.SerializableObjectWithBuffers(v):v,p);return(0,T.revive)(R)}catch(R){if(R instanceof Error&&R.message==="$executeCommand:retry")return this._doExecuteCommand(r,l,!1);throw R}}}async _executeContributedCommand(r,l,p){const d=this._commands.get(r);if(!d)throw new Error("Unknown command");let{callback:v,thisArg:R,description:O}=d;if(O)for(let L=0;L<O.args.length;L++)try{(0,h.validateConstraint)(l[L],O.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${O.args[L].name}' - ${O.args[L].description}`)}try{return await v.apply(R,l)}catch(L){if(r===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...l);_&&(r=_.command)}throw this._logService.error(L,r,d.extension?.identifier),p?new class extends Error{constructor(){super((0,a.toErrorMessage)(L));this.id=r,this.source=d.extension?.displayName??d.extension?.name}}:L}}$executeContributedCommand(r,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",r),this._commands.has(r)?(l=l.map(p=>this._argumentProcessors.reduce((d,v)=>v.processArgument(d),p)),this._executeContributedCommand(r,l,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this._logService.trace("ExtHostCommands#getCommands",r),Te(this,c,"f").$getCommands().then(l=>(r&&(l=l.filter(p=>p[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(let[l,p]of this._commands){let{description:d}=p;d&&(r[l]=d)}return Promise.resolve(r)}};c=new WeakMap,m=Be([Fe(0,u.IExtHostRpcService),Fe(1,C.ILogService)],m),e.ExtHostCommands=m,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class s{constructor(r,l,p){this._commands=r,this._lookupApiCommand=l,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(r,l){if(!r)return;const p={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return p;const d=this._lookupApiCommand(r.command);if(d)p.id=d.internalId,p.arguments=d.args.map((v,R)=>v.convert(r.arguments&&r.arguments[R]));else if((0,P.isNonEmptyArray)(r.arguments)){const v=++this._cachIdPool;this._cache.set(v,r),l.add((0,E.toDisposable)(()=>{this._cache.delete(v),this._logService.trace("CommandsConverter#DISPOSE",v)})),p.$ident=v,p.id=this.delegatingCommandId,p.arguments=[v],this._logService.trace("CommandsConverter#CREATE",r.command,v)}return p}fromInternal(r){return typeof r.$ident=="number"?this._cache.get(r.$ident):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this._cache.get(r[0])}_executeConvertedCommand(...r){const l=this.getActualCommand(...r);return this._logService.trace("CommandsConverter#EXECUTE",r[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=s;class b{constructor(r,l,p,d){this.name=r,this.description=l,this.validate=p,this.convert=d}optional(){return new b(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,l){return new b(r??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",i=>g.URI.isUri(i),i=>i),b.Position=new b("position","A position in a text document",i=>t.Position.isPosition(i),k.Position.from),b.Range=new b("range","A range in a text document",i=>t.Range.isRange(i),k.Range.from),b.Selection=new b("selection","A selection in a text document",i=>t.Selection.isSelection(i),k.Selection.from),b.Number=new b("number","",i=>typeof i=="number",i=>i),b.String=new b("string","",i=>typeof i=="string",i=>i),b.CallHierarchyItem=new b("item","A call hierarchy item",i=>i instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),b.TypeHierarchyItem=new b("item","A type hierarchy item",i=>i instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),b.TestItem=new b("testItem","A VS Code TestItem",i=>i instanceof w.TestItemImpl,k.TestItem.from);class o{constructor(r,l){this.description=r,this.convert=l}}e.ApiCommandResult=o,o.Void=new o("no result",i=>i);class n{constructor(r,l,p,d,v){this.id=r,this.internalId=l,this.description=p,this.args=d,this.result=v}}e.ApiCommand=n}),define(we[234],be([1,0,2,15,7,81,38,17,113,119,10]),function(te,e,h,t,k,A,S,P,C,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(t.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,w)=>{if((0,P.isFalsyOrEmpty)(u))return;class y extends k.SymbolInformation{static to(a){const c=new y(a.name,t.SymbolKind.to(a.kind),a.containerName||"",new k.Location(w[0],t.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=t.Range.to(a.selectionRange),c.children=a.children?a.children.map(y.to):[],c}}return u.map(y.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(t.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(t.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new S.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(t.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(t.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(t.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(w=>k.Position.isPosition(w)),u=>u.map(t.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(w=>{let y;for(const I of w.reverse())y=new k.SelectionRange(t.Range.to(I),y);return y}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(t.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(t.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(t.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(t.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",u=>{if(!!u)return{range:t.Range.to(u.range),placeholder:u.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return t.WorkspaceEdit.to(u)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(t.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new k.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const w=(0,C.decodeSemanticTokensDto)(u);if(w.type==="full")return new k.SemanticTokens(w.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new k.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const w=(0,C.decodeSemanticTokensDto)(u);if(w.type==="full")return new k.SemanticTokens(w.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,w,y)=>{if(!u)return new k.CompletionList([]);const I=u.suggestions.map(a=>t.CompletionItem.to(a,y));return new k.CompletionList(I,u.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return t.SignatureHelp.to(u)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,w,y)=>E(I=>new k.CodeLens(t.Range.to(I.range),I.command&&y.fromInternal(I.command)))(u))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>k.Range.isRange(u),u=>k.Selection.isSelection(u)?t.Selection.from(u):t.Range.from(u)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,w,y)=>E(I=>{if(I._isSynthetic){if(!I.command)throw new Error("Synthetic code actions must have a command");return y.fromInternal(I.command)}else{const a=new k.CodeAction(I.title,I.kind?new k.CodeActionKind(I.kind):void 0);return I.edit&&(a.edit=t.WorkspaceEdit.to(I.edit)),I.command&&(a.command=y.fromInternal(I.command)),a.isPreferred=I.isPreferred,a}})(u))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(w=>new k.ColorInformation(t.Range.to(w.range),t.Color.to(w.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",u=>u instanceof k.Color,t.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:t.Range.from(u.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(t.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(u,w,y)=>u.map(t.InlayHint.to.bind(void 0,y)))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(w=>t.NotebookExclusiveDocumentPattern.to(w))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(t.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",u=>h.URI.isUri(u)||typeof u=="string"&&(0,T.matchesSomeScheme)(u,F.Schemas.http,F.Schemas.https),u=>u),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[t.ViewColumn.from(u),void 0]:[t.ViewColumn.from(u.viewColumn),t.TextEditorOpenOptions.from(u)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[t.ViewColumn.from(u),void 0]:[t.ViewColumn.from(u.viewColumn),t.TextEditorOpenOptions.from(u)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[t.ViewColumn.from(u.viewColumn),t.TextEditorOpenOptions.from(u)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(t.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(t.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(t.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void)];class g{static register(w){D.forEach(w.registerApiCommand,w)}}e.ExtHostApiCommands=g;function E(u){return w=>{if(Array.isArray(w))return w.map(u)}}function f(u){if(!Array.isArray(u))return;const w=[];for(const y of u)A.isLocationLink(y)?w.push(t.DefinitionLink.to(y)):w.push(t.location.to(y));return w}}),define(we[235],be([1,0,13,56,3,6,2,81,27,15,7,30,5]),function(te,e,h,t,k,A,S,P,C,T,F,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(f,u,w){const y=f.getProxy(g.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const r=this._commentControllers.get(i.handle);return r||i}else if(i&&i.$mid===7){const r=this._commentControllers.get(i.commentControlHandle);if(!r)return i;const l=r.getCommentThread(i.commentThreadHandle);return l||i}else if(i&&i.$mid===8){const r=this._commentControllers.get(i.thread.commentControlHandle);if(!r)return i;const l=r.getCommentThread(i.thread.commentThreadHandle);return l?{thread:l,text:i.text}:i}else if(i&&i.$mid===9){const r=this._commentControllers.get(i.thread.commentControlHandle);if(!r)return i;const l=r.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let p=i.commentUniqueId,d=l.getCommentByUniqueId(p);return d||i}else if(i&&i.$mid===10){const r=this._commentControllers.get(i.thread.commentControlHandle);if(!r)return i;const l=r.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let p=i.text,d=i.commentUniqueId,v=l.getCommentByUniqueId(d);return v?(v.body=p,v):i}return i}})}createCommentController(i,r,l){const p=I.handlePool++,d=new c(i,p,r,l);this._commentControllers.set(d.handle,d);const v=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return v.push(d),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),v),d.value}$createCommentThreadTemplate(i,r,l){const p=this._commentControllers.get(i);!p||p.$createCommentThreadTemplate(r,l)}async $updateCommentThreadTemplate(i,r,l){const p=this._commentControllers.get(i);!p||p.$updateCommentThreadTemplate(r,l)}$deleteCommentThread(i,r){const l=this._commentControllers.get(i);l&&l.$deleteCommentThread(r)}$provideCommentingRanges(i,r,l){const p=this._commentControllers.get(i);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const d=w.getDocument(S.URI.revive(r));return(0,h.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(d,l)).then(v=>v?v.map(R=>T.Range.from(R)):void 0)}$toggleReaction(i,r,l,p,d){const v=this._commentControllers.get(i);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const R=v.getCommentThread(r);if(R){const O=R.getCommentByUniqueId(p.uniqueIdInThread);if(v!==void 0&&O&&v.reactionHandler)return v.reactionHandler(O,b(d))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class a{constructor(i,r,l,p,d,v,R){this._commentControllerHandle=r,this._id=l,this._uri=p,this._range=d,this._comments=v,this.extensionDescription=R,this.handle=a._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),y.$createCommentThread(r,this.handle,this._id,this._uri,T.Range.from(this._range),R.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{y.$deleteCommentThread(r,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(L){O.range=L},get comments(){return O.comments},set comments(L){O.comments=L},get collapsibleState(){return O.collapsibleState},set collapsibleState(L){O.collapsibleState=L},get canReply(){return O.canReply},set canReply(L){O.canReply=L},get contextValue(){return O.contextValue},set contextValue(L){O.contextValue=L},get label(){return O.label},set label(L){O.label=L},dispose:()=>{O.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const i=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),r={};i("range")&&(r.range=T.Range.from(this._range)),i("label")&&(r.label=this.label),i("contextValue")&&(r.contextValue=this.contextValue??null),i("comments")&&(r.comments=this._comments.map(l=>m(this,l,this._commentsMap))),i("collapsibleState")&&(r.collapseState=o(this._collapseState)),i("canReply")&&(r.canReply=this.canReply),this.modifications={},y.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(i){for(let r of this._commentsMap){let l=r[0],p=r[1];if(i===p)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}a._handlePool=0,Be([(0,t.debounce)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(i,r,l,p){this._extension=i,this._handle=r,this._id=l,this._label=p,this._threads=new Map,y.$registerCommentController(this.handle,l,p);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(v){d.options=v},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(v){d.commentingRangeProvider=v},get reactionHandler(){return d.reactionHandler},set reactionHandler(v){d.reactionHandler=v},createCommentThread(v,R,O){return d.createCommentThread(v,R,O).value},dispose:()=>{d.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{y.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,y.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,y.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,y.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,r,l,p){if(typeof i=="string"){const d=new a(this.id,this.handle,i,r,l,p,this._extension);return this._threads.set(d.handle,d),d}else{const d=new a(this.id,this.handle,void 0,i,r,l,this._extension);return this._threads.set(d.handle,d),d}}$createCommentThreadTemplate(i,r){const l=new a(this.id,this.handle,void 0,S.URI.revive(i),T.Range.to(r),[],this._extension);return l.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(i,r){let l=this._threads.get(i);l&&(l.range=T.Range.to(r))}$deleteCommentThread(i){let r=this._threads.get(i);r&&r.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function m(n,i,r){let l=r.get(i);l||(l=++n.commentHandle,r.set(i,l));const p=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;i.timestamp&&(0,D.checkProposedApiEnabled)(n.extensionDescription,"commentTimestamp");let d;return i.timestamp&&(d={source:i.timestamp,$mid:14}),{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:l,body:typeof i.body=="string"?i.body:T.MarkdownString.from(i.body),userName:i.author.name,userIconPath:p,label:i.label,commentReactions:i.reactions?i.reactions.map(v=>s(v)):void 0,timestamp:d}}function s(n){return{label:n.label,iconPath:n.iconPath?T.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function b(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?S.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function o(n){if(n!==void 0)switch(n){case F.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=E}),define(we[134],be([1,0,2,5,7,4,14,11,17,8,9]),function(te,e,h,t,k,A,S,P,C,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let D=class _n{constructor(E,f){this._logService=f,this._provider=new Map,this._proxy=E.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,f){const u=_n._handlePool++;this._provider.set(u,{provider:E,extensionId:f}),this._proxy.$registerDecorationProvider(u,f.value);const w=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(y=>{if(!y){this._proxy.$onDidChange(u,null);return}let I=(0,C.asArray)(y);if(I.length<=_n._maxEventSize){this._proxy.$onDidChange(u,I);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,I.length);const a=I.map(s=>({uri:s,rank:(0,T.count)(s.path,"/")})),c=(0,C.groupBy)(a,(s,b)=>s.rank-b.rank||(0,T.compare)(s.uri.path,b.uri.path));let m=[];e:for(let s of c){let b;for(let o of s){let n=(0,F.dirname)(o.uri.path);if(b!==n&&(b=n,m.push(o.uri)>=_n._maxEventSize))break e}}this._proxy.$onDidChange(u,m)});return new k.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(E,f,u){if(!this._provider.has(E))return Object.create(null);const w=Object.create(null),{provider:y,extensionId:I}=this._provider.get(E);return await Promise.all(f.map(async a=>{try{const{uri:c,id:m}=a,s=await Promise.resolve(y.provideFileDecoration(h.URI.revive(c),u));if(!s)return;try{k.FileDecoration.validate(s),w[m]=[s.propagate,s.tooltip,s.badge,s.color]}catch(b){this._logService.warn(`INVALID decoration from extension '${I.value}': ${b}`)}}catch(c){this._logService.error(c)}})),w}};D._handlePool=0,D._maxEventSize=250,D=Be([Fe(0,S.IExtHostRpcService),Fe(1,P.ILogService)],D),e.ExtHostDecorations=D,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[236],be([1,0,168,118,2,5,7,15,3,11,24,44]),function(te,e,h,t,k,A,S,P,C,T,F,D){"use strict";var g,E,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(I,a,c,m,s,b){this._name=I,this._owner=a,this._maxDiagnosticsPerFile=c,g.set(this,void 0),E.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Ke(this,f,new F.ResourceMap(o=>m.getComparisonKey(o)),"f"),Ke(this,g,s,"f"),Ke(this,E,b,"f")}dispose(){this._isDisposed||(Te(this,E,"f").fire([...Te(this,f,"f").keys()]),Te(this,g,"f")&&Te(this,g,"f").$clear(this._owner),Te(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(I,a){if(!I){this.clear();return}this._checkDisposed();let c=[];if(k.URI.isUri(I)){if(!a){this.delete(I);return}Te(this,f,"f").set(I,a.slice()),c=[I]}else if(Array.isArray(I)){c=[];let s;I=[...I].sort(u._compareIndexedTuplesByUri);for(const b of I){const[o,n]=b;if((!s||o.toString()!==s.toString())&&(s&&Te(this,f,"f").get(s).length===0&&Te(this,f,"f").delete(s),s=o,c.push(o),Te(this,f,"f").set(o,[])),n){const i=Te(this,f,"f").get(o);i&&i.push(...n)}else{const i=Te(this,f,"f").get(o);i&&(i.length=0)}}}if(Te(this,E,"f").fire(c),!Te(this,g,"f"))return;const m=[];for(let s of c){let b=[];const o=Te(this,f,"f").get(s);if(o)if(o.length>this._maxDiagnosticsPerFile){b=[];const n=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(let r of o)if(r.severity===n[i]&&b.push(P.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;b.push({severity:t.MarkerSeverity.Info,message:(0,h.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:b[b.length-1].startLineNumber,startColumn:b[b.length-1].startColumn,endLineNumber:b[b.length-1].endLineNumber,endColumn:b[b.length-1].endColumn})}else b=o.map(n=>P.Diagnostic.from(n));m.push([s,b])}Te(this,g,"f").$changeMany(this._owner,m)}delete(I){this._checkDisposed(),Te(this,E,"f").fire([I]),Te(this,f,"f").delete(I),Te(this,g,"f")&&Te(this,g,"f").$changeMany(this._owner,[[I,void 0]])}clear(){this._checkDisposed(),Te(this,E,"f").fire([...Te(this,f,"f").keys()]),Te(this,f,"f").clear(),Te(this,g,"f")&&Te(this,g,"f").$clear(this._owner)}forEach(I,a){this._checkDisposed();for(let c of Te(this,f,"f").keys())I.apply(a,[c,this.get(c),this])}get(I){this._checkDisposed();const a=Te(this,f,"f").get(I);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(I){return this._checkDisposed(),Array.isArray(Te(this,f,"f").get(I))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(I,a){return I[0].toString()<a[0].toString()?-1:I[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=u,g=new WeakMap,E=new WeakMap,f=new WeakMap;let w=class on{constructor(I,a,c){this._logService=a,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,on._mapper),this._proxy=I.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(I){const a=new F.ResourceMap;for(const c of I)a.set(c,c);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(I,a){const{_collections:c,_proxy:m,_onDidChangeDiagnostics:s,_logService:b,_fileSystemInfoService:o}=this,n=new class{$changeMany(l,p){m.$changeMany(l,p),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",I.value,l,p.length===0?"CLEARING":p)}$clear(l){m.$clear(l),b.trace("[DiagnosticCollection] remove all (extension, owner)",I.value,l)}dispose(){m.dispose()}};let i;if(!a)a="_generated_diagnostic_collection_name_#"+on._idPool++,i=a;else if(!c.has(a))i=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do i=a+on._idPool++;while(c.has(i))}return new class extends u{constructor(){super(a,i,on._maxDiagnosticsPerFile,o.extUri,n,s);c.set(i,this)}dispose(){super.dispose(),c.delete(i)}}}getDiagnostics(I){if(I)return this._getDiagnostics(I);{const a=new Map,c=[];for(const m of this._collections.values())m.forEach((s,b)=>{let o=a.get(s.toString());typeof o=="undefined"&&(o=c.length,a.set(s.toString(),o),c.push([s,[]])),c[o][1]=c[o][1].concat(...b)});return c}}_getDiagnostics(I){let a=[];for(let c of this._collections.values())c.has(I)&&(a=a.concat(c.get(I)));return a}$acceptMarkersChange(I){if(!this._mirrorCollection){const a="_generated_mirror",c=new u(a,a,on._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,c),this._mirrorCollection=c}for(const[a,c]of I)this._mirrorCollection.set(k.URI.revive(a),c.map(P.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=Be([Fe(1,T.ILogService),Fe(2,D.IExtHostFileSystemInfo)],w),e.ExtHostDiagnostics=w}),define(we[237],be([1,0,2,5]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(S){this._proxy=S.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(P=>P?P.map(C=>h.URI.revive(C)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(P=>P?h.URI.revive(P):void 0)}}e.ExtHostDialogs=k}),define(we[238],be([1,0,16,2,7,5,10,21,8]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(D,g,E){this._documentsAndEditors=g,this._logService=E,this._documentContentProviders=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,g){if(Object.keys(S.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const E=T._handlePool++;this._documentContentProviders.set(E,g),this._proxy.$registerTextContentProvider(E,D);let f;return typeof g.onDidChange=="function"&&(f=g.onDidChange(u=>{if(u.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(E,u).then(w=>{if(!w&&typeof w!="string")return;const y=this._documentsAndEditors.getDocument(u);if(!y)return;const I=(0,C.splitLines)(w);if(!y.equalLines(I))return this._proxy.$onVirtualDocumentChange(u,w)},h.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(D,g){const E=this._documentContentProviders.get(D);return E?Promise.resolve(E.provideTextDocumentContent(t.URI.revive(g),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(we[239],be([1,0,3,6,2,5,126,15,18,25,7]),function(te,e,h,t,k,A,S,P,C,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(E,f){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const w of u)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const w of u)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const f=this._documentsAndEditors.getDocument(E);if(f)return f}getDocument(E){const f=this.getDocumentData(E);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return f.document}ensureDocumentData(E){const f=this._documentsAndEditors.getDocument(E);if(f)return Promise.resolve(f);let u=this._documentLoader.get(E.toString());return u||(u=this._proxy.$tryOpenDocument(E).then(w=>{this._documentLoader.delete(E.toString());const y=k.URI.revive(w);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(y))},w=>(this._documentLoader.delete(E.toString()),Promise.reject(w))),this._documentLoader.set(E.toString(),u)),u}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(f=>k.URI.revive(f))}$acceptModelLanguageChanged(E,f){const u=k.URI.revive(E),w=this._documentsAndEditors.getDocument(u);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(f),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(E){const f=k.URI.revive(E),u=this._documentsAndEditors.getDocument(f);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(E,f){const u=k.URI.revive(E),w=this._documentsAndEditors.getDocument(u);if(!w)throw new Error("unknown document");w._acceptIsDirty(f),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,f,u){const w=k.URI.revive(E),y=this._documentsAndEditors.getDocument(w);if(!y)throw new Error("unknown document");y._acceptIsDirty(u),y.onEvents(f);let I;f.isUndoing?I=F.TextDocumentChangeReason.Undo:f.isRedoing&&(I=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:y.document,contentChanges:f.changes.map(a=>({range:P.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:I}))}setWordDefinitionFor(E,f){(0,S.setWordDefinitionFor)(E,f)}}e.ExtHostDocuments=D}),define(we[45],be([1,0,55,3,6,2,4,5,126,14,132,15,11,24,10,77,92]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class y{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let I=class{constructor(c,m){this._extHostRpc=c,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const m=[],s=[],b=[];if(c.removedDocuments)for(const o of c.removedDocuments){const n=A.URI.revive(o),i=this._documents.get(n);i?.unref()&&(this._documents.delete(n),m.push(i.value))}if(c.addedDocuments)for(const o of c.addedDocuments){const n=A.URI.revive(o.uri);let i=this._documents.get(n);if(i&&n.scheme!==f.Schemas.vscodeNotebookCell&&n.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);i||(i=new y(new C.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),n,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(n,i),s.push(i.value)),i.ref()}if(c.removedEditors)for(const o of c.removedEditors){const n=this._editors.get(o);this._editors.delete(o),n&&b.push(n)}if(c.addedEditors)for(const o of c.addedEditors){const n=A.URI.revive(o.documentUri);h.ok(this._documents.has(n),`document '${n}' does not exist`),h.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const i=this._documents.get(n).value,r=new F.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>i.document),o.selections.map(D.Selection.to),o.options,o.visibleRanges.map(l=>D.Range.to(l)),typeof o.editorPosition=="number"?D.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,r)}c.newActiveEditor!==void 0&&(h.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,k.dispose)(m),(0,k.dispose)(b),c.removedDocuments&&this._onDidRemoveDocuments.fire(m),c.addedDocuments&&this._onDidAddDocuments.fire(s),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return c?m:m?.value}allEditors(){return[...this._editors.values()]}};I=Be([Fe(0,T.IExtHostRpcService),Fe(1,g.ILogService)],I),e.ExtHostDocumentsAndEditors=I,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[53],be([1,0,15,5,2,3,4,14,13]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");let T=class{constructor(D){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=D.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(D){let g=-1;this._tabs=D.map((f,u)=>(f.isActive&&(g=u),Object.freeze({label:f.label,viewColumn:h.ViewColumn.to(f.viewColumn),index:u,resource:k.URI.revive(f.resource),additionalResourcesAndViewIds:f.additionalResourcesAndViewIds.map(({resource:w,viewId:y})=>({resource:k.URI.revive(w),viewId:y})),viewId:f.editorId,isActive:f.isActive,move:async(w,y)=>{this._proxy.$moveTab(f,w,h.ViewColumn.from(y)),await(0,C.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(f),await(0,C.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((f,u)=>f.viewColumn===u.viewColumn?f.index-u.index:f.viewColumn-u.viewColumn);const E=this._activeTab;this._activeTab=g===-1?void 0:this._tabs[g],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=Be([Fe(0,P.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(we[240],be([1,0,2,5,6,7,15,152,8,23,30]),function(te,e,h,t,k,A,S,P,C,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const u=this._schemes.indexOf(f);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),u=[];let w,y,I=14,a=14;for(const c of f){let m=w?(0,C.commonPrefixLength)(w,c):0;for(m===0?y=1:y=a;m<c.length;m++)m+1===c.length?(I=a,a=9):a+=1,u.push([y,c.toUpperCase().charCodeAt(m),a]),u.push([y,c.toLowerCase().charCodeAt(m),a]),y=a;w=c,a=I}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new P.StateMachine(u)}}provideDocumentLinks(f){this._initStateMachine();const u=[],w=P.LinkComputer.computeLinks({getLineContent(y){return f.lineAt(y-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const y of w){const I=S.DocumentLink.to(y);I.target&&u.push(I)}return u}}class g{constructor(f,u){this._extHostLanguageFeatures=u,this._linkProvider=new D,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,u,w,y={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const I=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(I,w);let a=2;y.isCaseSensitive&&(a+=1024),y.isReadonly&&(a+=2048),typeof w.copy=="function"&&(a+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&((0,F.checkProposedApiEnabled)(f,"fsChunks"),a+=4),this._proxy.$registerFileSystemProvider(I,u,a).catch(m=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${u}`),console.error(m)});const c=w.onDidChangeFile(m=>{const s=[];for(const b of m){let{uri:o,type:n}=b;if(o.scheme!==u)continue;let i;switch(n){case A.FileChangeType.Changed:i=0;break;case A.FileChangeType.Created:i=1;break;case A.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:o,type:i})}this._proxy.$onFileSystemChange(I,s)});return(0,k.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(f){const{type:u,ctime:w,mtime:y,size:I,permissions:a}=f;return{type:u,ctime:w,mtime:y,size:I,permissions:a}}$stat(f,u){return Promise.resolve(this._getFsProvider(f).stat(h.URI.revive(u))).then(w=>g._asIStat(w))}$readdir(f,u){return Promise.resolve(this._getFsProvider(f).readDirectory(h.URI.revive(u)))}$readFile(f,u){return Promise.resolve(this._getFsProvider(f).readFile(h.URI.revive(u))).then(w=>T.VSBuffer.wrap(w))}$writeFile(f,u,w,y){return Promise.resolve(this._getFsProvider(f).writeFile(h.URI.revive(u),w.buffer,y))}$delete(f,u,w){return Promise.resolve(this._getFsProvider(f).delete(h.URI.revive(u),w))}$rename(f,u,w,y){return Promise.resolve(this._getFsProvider(f).rename(h.URI.revive(u),h.URI.revive(w),y))}$copy(f,u,w,y){const I=this._getFsProvider(f);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(h.URI.revive(u),h.URI.revive(w),y))}$mkdir(f,u){return Promise.resolve(this._getFsProvider(f).createDirectory(h.URI.revive(u)))}$watch(f,u,w,y){const I=this._getFsProvider(f).watch(h.URI.revive(w),y);this._watches.set(u,I)}$unwatch(f,u){const w=this._watches.get(u);w&&(w.dispose(),this._watches.delete(u))}$open(f,u,w){const y=this._getFsProvider(f);if(!y.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(y.open(h.URI.revive(u),w))}$close(f,u){const w=this._getFsProvider(f);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(u))}$read(f,u,w,y){const I=this._getFsProvider(f);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const a=T.VSBuffer.alloc(y);return Promise.resolve(I.read(u,w,a.buffer,0,y)).then(c=>a.slice(0,c))}$write(f,u,w,y){const I=this._getFsProvider(f);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(u,w,y.buffer,0,y.byteLength))}_getFsProvider(f){const u=this._fsProvider.get(f);if(!u){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return u}}e.ExtHostFileSystem=g}),define(we[66],be([1,0,5,42,7,23,4,14,44,6]),function(te,e,h,t,k,A,S,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class Gt{constructor(g,E){this._fileSystemProvider=new Map,this._proxy=g.getProxy(h.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(u){try{const w=f._fileSystemProvider.get(u.scheme);if(!w)return await f._proxy.$stat(u);await f._proxy.$ensureActivation(u.scheme);const y=await w.stat(u);return{type:y.type,ctime:y.ctime,mtime:y.mtime,size:y.size,permissions:y.permissions}}catch(w){Gt._handleError(w)}},async readDirectory(u){try{const w=f._fileSystemProvider.get(u.scheme);return w?(await f._proxy.$ensureActivation(u.scheme),(await w.readDirectory(u)).slice()):await f._proxy.$readdir(u)}catch(w){return Gt._handleError(w)}},async createDirectory(u){try{return await f._proxy.$mkdir(u)}catch(w){return Gt._handleError(w)}},async readFile(u){try{const w=f._fileSystemProvider.get(u.scheme);return w?(await f._proxy.$ensureActivation(u.scheme),(await w.readFile(u)).slice()):(await f._proxy.$readFile(u)).buffer}catch(w){return Gt._handleError(w)}},async writeFile(u,w){try{return await f._proxy.$writeFile(u,A.VSBuffer.wrap(w))}catch(y){return Gt._handleError(y)}},async delete(u,w){try{const y=f._fileSystemProvider.get(u.scheme);return y?(await f._proxy.$ensureActivation(u.scheme),await y.delete(u,{recursive:!1,...w})):await f._proxy.$delete(u,{recursive:!1,useTrash:!1,...w})}catch(y){return Gt._handleError(y)}},async rename(u,w,y){try{return await f._proxy.$rename(u,w,{overwrite:!1,...y})}catch(I){return Gt._handleError(I)}},async copy(u,w,y){try{return await f._proxy.$copy(u,w,{overwrite:!1,...y})}catch(I){return Gt._handleError(I)}},isWritableFileSystem(u){const w=E.getCapabilities(u);if(typeof w=="number")return!(w&2048)}})}static _handleError(g){if(g instanceof k.FileSystemError)throw g;if(!(g instanceof Error))throw new k.FileSystemError(String(g));if(g.name==="ENOPRO")throw k.FileSystemError.Unavailable(g.message);switch(g.name){case t.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(g.message);case t.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(g.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(g.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(g.message);case t.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(g.message);case t.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(g.message);default:throw new k.FileSystemError(g.message,g.name)}}addFileSystemProvider(g,E){return this._fileSystemProvider.set(g,E),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(g))}};F=Be([Fe(0,P.IExtHostRpcService),Fe(1,C.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(we[241],be([1,0,3,32,2,5,15,7]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(D,g,E,f,u,w,y,I){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter;const a=this.ensureWatching(D,E,u);this._config=0,w&&(this._config+=1),y&&(this._config+=2),I&&(this._config+=4);const c=(0,t.parse)(u),m=typeof u=="string",s=f(b=>{if(!w)for(let o of b.created){const n=k.URI.revive(o);c(n.fsPath)&&(!m||g.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!y)for(let o of b.changed){const n=k.URI.revive(o);c(n.fsPath)&&(!m||g.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!I)for(let o of b.deleted){const n=k.URI.revive(o);c(n.fsPath)&&(!m||g.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=P.Disposable.from(a,this._onDidCreate,this._onDidChange,this._onDidDelete,s)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(D,g,E){let f=P.Disposable.from();if(typeof E=="string")return f;const u=D.getProxy(A.MainContext.MainThreadFileSystem);let w=!1;(E.pattern.includes(t.GLOBSTAR)||E.pattern.includes(t.GLOB_SPLIT))&&(w=!0);const y=Math.random();return u.$watch(g.identifier.value,y,E.baseUri,{recursive:w,excludes:[]}),P.Disposable.from({dispose:()=>u.$unwatch(y)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(D,g,E){this._mainContext=D,this._logService=g,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(D,g,E,f,u,w){return new C(this._mainContext,D,g,this._onFileSystemEvent.event,S.GlobPattern.from(E),f,u,w)}$onFileEvent(D){this._onFileSystemEvent.fire(D)}$onDidRunFileOperation(D,g){switch(D){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(E=>({oldUri:k.URI.revive(E.source),newUri:k.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(E=>k.URI.revive(E.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:g.map(E=>k.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(D){return this._createWillExecuteEvent(D,this._onWillRenameFile)}getOnWillCreateFileEvent(D){return this._createWillExecuteEvent(D,this._onWillCreateFile)}getOnWillDeleteFileEvent(D){return this._createWillExecuteEvent(D,this._onWillDeleteFile)}_createWillExecuteEvent(D,g){return(E,f,u)=>{const w=function(I){E.call(f,I)};return w.extension=D,g.event(w,void 0,u)}}async $onWillRunFileOperation(D,g,E,f){switch(D){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(u=>({oldUri:k.URI.revive(u.source),newUri:k.URI.revive(u.target)}))},E,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(u=>k.URI.revive(u.target))},E,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(u=>k.URI.revive(u.target))},E,f)}}async _fireWillEvent(D,g,E,f){const u=new Set,w=[];if(await D.fireAsync(g,f,async(I,a)=>{const c=Date.now(),m=await Promise.resolve(I);m instanceof P.WorkspaceEdit&&(w.push(m),u.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-c>E&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),f.isCancellationRequested||w.length===0)return;const y={edits:[]};for(let I of w){let{edits:a}=S.WorkspaceEdit.from(I,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});y.edits=y.edits.concat(a)}return{edit:y,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=T}),define(we[242],be([1,0,2,38]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(S,P,C,T){this._extHostNotebooks=P,this._textDocumentsAndEditors=C,this._commands=T;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",D=>!0,D=>D),new t.ApiCommandArgument("resource","Interactive resource Uri",D=>!0,D=>D),new t.ApiCommandArgument("controllerId","Notebook controller Id",D=>!0,D=>D),new t.ApiCommandArgument("title","Interactive editor title",D=>!0,D=>D)],new t.ApiCommandResult("Notebook and input URI",D=>{if(D.notebookEditorId!==void 0){const g=this._extHostNotebooks.getEditorById(D.notebookEditorId);return{notebookUri:h.URI.revive(D.notebookUri),inputUri:h.URI.revive(D.inputUri),notebookEditor:g.apiEditor}}return{notebookUri:h.URI.revive(D.notebookUri),inputUri:h.URI.revive(D.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(S,P,C,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:C,uri:S,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=k}),define(we[243],be([1,0,6,5]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(S){this._handlePool=0,this._proxy=S.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,S),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=k}),define(we[244],be([1,0,2,25,15,7,5,8,41,17,18,148,21,6,113,76,85,46,16,3,13]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentSymbols(z,W){const N=this._documents.getDocument(z),$=await this._provider.provideDocumentSymbols(N,W);if(!(0,T.isFalsyOrEmpty)($))return $[0]instanceof A.DocumentSymbol?$.map(k.DocumentSymbol.from):m._asDocumentSymbolTree($)}static _asDocumentSymbolTree(z){z=z.slice(0).sort(($,j)=>{let re=$.location.range.start.compareTo(j.location.range.start);return re===0&&(re=j.location.range.end.compareTo($.location.range.end)),re});const W=[],N=[];for(const $ of z){const j={name:$.name||"!!MISSING: name!!",kind:k.SymbolKind.from($.kind),tags:$.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:$.containerName,range:k.Range.from($.location.range),selectionRange:k.Range.from($.location.range),children:[]};for(;;){if(N.length===0){N.push(j),W.push(j);break}const re=N[N.length-1];if(C.Range.containsRange(re.range,j.range)&&!C.Range.equalsRange(re.range,j.range)){re.children&&re.children.push(j),N.push(j);break}N.pop()}}return W}}class s{constructor(z,W,N){this._documents=z,this._commands=W,this._provider=N,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,W){const N=this._documents.getDocument(z),$=await this._provider.provideCodeLenses(N,W);if(!$||W.isCancellationRequested)return;const j=this._cache.add($),re=new E.DisposableStore;this._disposables.set(j,re);const he={cacheId:j,lenses:[]};for(let Ce=0;Ce<$.length;Ce++)he.lenses.push({cacheId:[j,Ce],range:k.Range.from($[Ce].range),command:this._commands.toInternal($[Ce].command,re)});return he}async resolveCodeLens(z,W){const N=z.cacheId&&this._cache.get(...z.cacheId);if(!N)return;let $;if(typeof this._provider.resolveCodeLens!="function"||N.isResolved?$=N:$=await this._provider.resolveCodeLens(N,W),$||($=N),W.isCancellationRequested)return;const j=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!j)return z.command=this._commands.toInternal($.command??s._badCmd,j),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function b(Ee){return Array.isArray(Ee)?Ee.map(k.DefinitionLink.from):Ee?[k.DefinitionLink.from(Ee)]:[]}class o{constructor(z,W){this._documents=z,this._provider=W}async provideDefinition(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.provideDefinition($,j,N);return b(re)}}class n{constructor(z,W){this._documents=z,this._provider=W}async provideDeclaration(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.provideDeclaration($,j,N);return b(re)}}class i{constructor(z,W){this._documents=z,this._provider=W}async provideImplementation(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.provideImplementation($,j,N);return b(re)}}class r{constructor(z,W){this._documents=z,this._provider=W}async provideTypeDefinition(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.provideTypeDefinition($,j,N);return b(re)}}class l{constructor(z,W){this._documents=z,this._provider=W}async provideHover(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.provideHover($,j,N);if(!(!re||(0,T.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=$.getWordRangeAtPosition(j)),re.range||(re.range=new A.Range(j,j)),k.Hover.from(re)}}class p{constructor(z,W){this._documents=z,this._provider=W}async provideEvaluatableExpression(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.provideEvaluatableExpression($,j,N);if(re)return k.EvaluatableExpression.from(re)}}class d{constructor(z,W){this._documents=z,this._provider=W}async provideInlineValues(z,W,N,$){const j=this._documents.getDocument(z),re=await this._provider.provideInlineValues(j,k.Range.to(W),k.InlineValueContext.to(N),$);if(Array.isArray(re))return re.map(he=>k.InlineValue.from(he))}}class v{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentHighlights(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.provideDocumentHighlights($,j,N);if(Array.isArray(re))return re.map(k.DocumentHighlight.from)}}class R{constructor(z,W){this._documents=z,this._provider=W}async provideLinkedEditingRanges(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.provideLinkedEditingRanges($,j,N);if(re&&Array.isArray(re.ranges))return{ranges:(0,T.coalesce)(re.ranges.map(k.Range.from)),wordPattern:re.wordPattern}}}class O{constructor(z,W){this._documents=z,this._provider=W}async provideReferences(z,W,N,$){const j=this._documents.getDocument(z),re=k.Position.to(W),he=await this._provider.provideReferences(j,re,N,$);if(Array.isArray(he))return he.map(k.location.from)}}class L{constructor(z,W,N,$,j,re,he){this._documents=z,this._commands=W,this._diagnostics=N,this._provider=$,this._logService=j,this._extension=re,this._apiDeprecation=he,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,W,N,$){const j=this._documents.getDocument(z),re=D.Selection.isISelection(W)?k.Selection.to(W):k.Range.to(W),he=[];for(const He of this._diagnostics.getDiagnostics(z))if(re.intersection(He.range)&&he.push(He)>L._maxCodeActionsPerFile)break;const Ce={diagnostics:he,only:N.only?new A.CodeActionKind(N.only):void 0,triggerKind:k.CodeActionTriggerKind.to(N.trigger)},Ae=await this._provider.provideCodeActions(j,re,Ce,$);if(!(0,T.isNonEmptyArray)(Ae)||$.isCancellationRequested)return;const We=this._cache.add(Ae),$e=new E.DisposableStore;this._disposables.set(We,$e);const je=[];for(let He=0;He<Ae.length;He++){const Ue=Ae[He];!Ue||(L._isCommand(Ue)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Ue.title,command:this._commands.toInternal(Ue,$e)})):(Ce.only&&(Ue.kind?Ce.only.contains(Ue.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Ue.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[We,He],title:Ue.title,command:Ue.command&&this._commands.toInternal(Ue.command,$e),diagnostics:Ue.diagnostics&&Ue.diagnostics.map(k.Diagnostic.from),edit:Ue.edit&&k.WorkspaceEdit.from(Ue.edit),kind:Ue.kind&&Ue.kind.value,isPreferred:Ue.isPreferred,disabled:Ue.disabled?.reason})))}return{cacheId:We,actions:je}}async resolveCodeAction(z,W){const[N,$]=z,j=this._cache.get(N,$);if(!j||L._isCommand(j)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(j,W)??j;return re?.edit?k.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}L._maxCodeActionsPerFile=1e3;class _{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentFormattingEdits(z,W,N){const $=this._documents.getDocument(z),j=await this._provider.provideDocumentFormattingEdits($,W,N);if(Array.isArray(j))return j.map(k.TextEdit.from)}}class U{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentRangeFormattingEdits(z,W,N,$){const j=this._documents.getDocument(z),re=k.Range.to(W),he=await this._provider.provideDocumentRangeFormattingEdits(j,re,N,$);if(Array.isArray(he))return he.map(k.TextEdit.from)}}class M{constructor(z,W){this._documents=z,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,W,N,$,j){const re=this._documents.getDocument(z),he=k.Position.to(W),Ce=await this._provider.provideOnTypeFormattingEdits(re,he,N,$,j);if(Array.isArray(Ce))return Ce.map(k.TextEdit.from)}}class q{constructor(z,W){this._provider=z,this._logService=W,this._cache=new w.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(z,W){const N=await this._provider.provideWorkspaceSymbols(z,W);if(!(0,T.isNonEmptyArray)(N))return{symbols:[]};const $=this._cache.add(N),j={cacheId:$,symbols:[]};for(let re=0;re<N.length;re++){const he=N[re];if(!he||!he.name){this._logService.warn("INVALID SymbolInformation",he);continue}j.symbols.push({...k.WorkspaceSymbol.from(he),cacheId:[$,re]})}return j}async resolveWorkspaceSymbol(z,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const N=this._cache.get(...z.cacheId);if(N){const $=await this._provider.resolveWorkspaceSymbol(N,W);return $&&(0,t.mixin)(z,k.WorkspaceSymbol.from($),!0)}}releaseWorkspaceSymbols(z){this._cache.delete(z)}}class K{constructor(z,W,N){this._documents=z,this._provider=W,this._logService=N}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,W,N,$){const j=this._documents.getDocument(z),re=k.Position.to(W);try{const he=await this._provider.provideRenameEdits(j,re,N,$);return he?k.WorkspaceEdit.from(he):void 0}catch(he){const Ce=K._asMessage(he);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(z,W,N){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const $=this._documents.getDocument(z),j=k.Position.to(W);try{const re=await this._provider.prepareRename($,j,N);let he,Ce;if(A.Range.isRange(re)?(he=re,Ce=$.getText(re)):(0,F.isObject)(re)&&(he=re.range,Ce=re.placeholder),!he||!Ce)return;if(he.start.line>j.line||he.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(he),text:Ce}}catch(re){const he=K._asMessage(re);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class x{constructor(z,W){this.resultId=z,this.tokens=W}}class B{constructor(z,W){this._documents=z,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,W,N){const $=this._documents.getDocument(z),j=W!==0?this._previousResults.get(W):null;let re=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits($,j.resultId,N):await this._provider.provideDocumentSemanticTokens($,N);return j&&this._previousResults.delete(W),re?(re=B._fixProvidedSemanticTokens(re),this._send(B._convertToEdits(j,re),re)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return B._isSemanticTokens(z)?B._isCorrectSemanticTokens(z)?z:new A.SemanticTokens(new Uint32Array(z.data),z.resultId):B._isSemanticTokensEdits(z)?B._isCorrectSemanticTokensEdits(z)?z:new A.SemanticTokensEdits(z.edits.map(W=>new A.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const W of z.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,W){if(!B._isSemanticTokens(W)||!z||!z.tokens)return W;const N=z.tokens,$=N.length,j=W.data,re=j.length;let he=0;const Ce=Math.min($,re);for(;he<Ce&&N[he]===j[he];)he++;if(he===$&&he===re)return new A.SemanticTokensEdits([],W.resultId);let Ae=0;const We=Ce-he;for(;Ae<We&&N[$-Ae-1]===j[re-Ae-1];)Ae++;return new A.SemanticTokensEdits([{start:he,deleteCount:$-he-Ae,data:j.subarray(he,re-Ae)}],W.resultId)}_send(z,W){if(B._isSemanticTokens(z)){const N=this._nextResultId++;return this._previousResults.set(N,new x(z.resultId,z.data)),(0,f.encodeSemanticTokensDto)({id:N,type:"full",data:z.data})}if(B._isSemanticTokensEdits(z)){const N=this._nextResultId++;return B._isSemanticTokens(W)?this._previousResults.set(N,new x(W.resultId,W.data)):this._previousResults.set(N,new x(z.resultId)),(0,f.encodeSemanticTokensDto)({id:N,type:"delta",deltas:(z.edits||[]).map($=>({start:$.start,deleteCount:$.deleteCount,data:$.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class G{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentRangeSemanticTokens(z,W,N){const $=this._documents.getDocument(z),j=await this._provider.provideDocumentRangeSemanticTokens($,k.Range.to(W),N);return j?this._send(j):null}_send(z){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=G;class X{constructor(z,W,N,$,j){this._documents=z,this._commands=W,this._provider=N,this._apiDeprecation=$,this._extension=j,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,W,N,$){const j=this._documents.getDocument(z),re=k.Position.to(W),he=j.getWordRangeAtPosition(re)||new A.Range(re,re),Ce=he.with({end:re}),Ae=new y.StopWatch(!0),We=await this._provider.provideCompletionItems(j,re,$,k.CompletionContext.to(N));if(!We||$.isCancellationRequested)return;const $e=Array.isArray(We)?new A.CompletionList(We):We,je=X.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),He=new E.DisposableStore;this._disposables.set(je,He);const Ue=[],Qe={x:je,b:Ue,a:{replace:k.Range.from(he),insert:k.Range.from(Ce)},c:$e.isIncomplete||void 0,d:Ae.elapsed()};for(let et=0;et<$e.items.length;et++){const Re=$e.items[et],tt=this._convertCompletionItem(Re,[je,et],Ce,he);Ue.push(tt)}return Qe}async resolveCompletionItem(z,W){if(typeof this._provider.resolveCompletionItem!="function")return;const N=this._cache.get(...z);if(!N)return;const $=await this._provider.resolveCompletionItem(N,W);if(!!$)return this._convertCompletionItem($,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,W,N,$){const j=this._disposables.get(W[0]);if(!j)throw Error("DisposableStore is missing...");const re={x:W,a:z.label,b:z.kind!==void 0?k.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(k.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(z.command,j)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=z.textEdit.newText):typeof z.insertText=="string"?re.h=z.insertText:z.insertText instanceof A.SnippetString&&(re.h=z.insertText.value,re.i|=4);let he;return z.textEdit?he=z.textEdit.range:z.range&&(he=z.range),A.Range.isRange(he)?re.j=k.Range.from(he):he&&(!N?.isEqual(he.inserting)||!$?.isEqual(he.replacing))&&(re.j={insert:k.Range.from(he.inserting),replace:k.Range.from(he.replacing)}),re}}class V{constructor(z,W,N){this._documents=z,this._provider=W,this._commands=N,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,W,N,$){const j=this._documents.getDocument(z),re=k.Position.to(W),he=await this._provider.provideInlineCompletionItems(j,re,{selectedCompletionInfo:N.selectedSuggestionInfo?{range:k.Range.to(N.selectedSuggestionInfo.range),text:N.selectedSuggestionInfo.text,isSnippetText:N.selectedSuggestionInfo.isSnippetText,completionKind:k.CompletionItemKind.to(N.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:N.triggerKind},$);if(!he||$.isCancellationRequested)return;const Ce=(0,F.isArray)(he)?{items:he}:he,Ae=this._cache.add(Ce.items);let We;return{pid:Ae,items:Ce.items.map(($e,je)=>{let He;return $e.command&&(We||(We=new E.DisposableStore,this._disposables.set(Ae,We)),He=this._commands.toInternal($e.command,We)),{text:$e.text,range:$e.range?k.Range.from($e.range):void 0,command:He,idx:je,completeBracketPairs:$e.completeBracketPairs}})}}disposeCompletions(z){this._cache.delete(z);const W=this._disposables.get(z);W&&W.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,W){const N=this._cache.get(z,W);N&&Z.get(this._provider).fireOnDidShowCompletionItem({completionItem:N})}}class Z{constructor(){this._onDidShowCompletionItemEmitter=new a.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let W=Z.map.get(z);return W||(W=new Z,Z.map.set(z,W)),W}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=Z,Z.map=new WeakMap;class se{constructor(z,W){this._documents=z,this._provider=W,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(z,W,N,$){const j=this._documents.getDocument(z),re=k.Position.to(W),he=this.reviveContext(N),Ce=await this._provider.provideSignatureHelp(j,re,$,he);if(Ce){const Ae=this._cache.add([Ce]);return{...k.SignatureHelp.from(Ce),id:Ae}}}reviveContext(z){let W;if(z.activeSignatureHelp){const N=k.SignatureHelp.to(z.activeSignatureHelp),$=this._cache.get(z.activeSignatureHelp.id,0);$?(W=$,W.activeSignature=N.activeSignature,W.activeParameter=N.activeParameter):W=N}return{...z,activeSignatureHelp:W}}releaseSignatureHelp(z){this._cache.delete(z)}}class ce{constructor(z,W,N,$,j){this._documents=z,this._commands=W,this._provider=N,this._logService=$,this._extension=j,this._cache=new w.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(z,W,N){const $=this._documents.getDocument(z),j=k.Range.to(W),re=await this._provider.provideInlayHints($,j,N);if(!Array.isArray(re)||re.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(N.isCancellationRequested)return;const he=this._cache.add(re);this._disposables.set(he,new E.DisposableStore);const Ce={hints:[],cacheId:he};for(let Ae=0;Ae<re.length;Ae++)this._isValidInlayHint(re[Ae],j)&&Ce.hints.push(this._convertInlayHint(re[Ae],[he,Ae]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),Ce}async resolveInlayHint(z,W){if(typeof this._provider.resolveInlayHint!="function")return;const N=this._cache.get(...z);if(!N)return;const $=await this._provider.resolveInlayHint(N,W);if(!!$&&!!this._isValidInlayHint($))return this._convertInlayHint($,z)}releaseHints(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_isValidInlayHint(z,W){return z.label.length===0||Array.isArray(z.label)&&z.label.every(N=>N.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(W&&!W.contains(z.position))}_convertInlayHint(z,W){const N=this._disposables.get(W[0]);if(!N)throw Error("DisposableStore is missing...");const $={label:"",cacheId:W,tooltip:k.MarkdownString.fromStrict(z.tooltip),command:z.command&&this._commands.toInternal(z.command,N),position:k.Position.from(z.position),kind:k.InlayHintKind.from(z.kind??A.InlayHintKind.Other),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?$.label=z.label:$.label=z.label.map(j=>{let re={label:j.value};return re.tooltip=k.MarkdownString.fromStrict(j.tooltip),A.Location.isLocation(j.location)&&(re.location=k.location.from(j.location)),j.command&&(re.command=this._commands.toInternal(j.command,N)),re}),$}}class ee{constructor(z,W){this._documents=z,this._provider=W,this._cache=new w.Cache("DocumentLink")}async provideLinks(z,W){const N=this._documents.getDocument(z),$=await this._provider.provideDocumentLinks(N,W);if(!(!Array.isArray($)||$.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:$.filter(ee._validateLink).map(k.DocumentLink.from)};{const j=this._cache.add($),re={links:[],cacheId:j};for(let he=0;he<$.length;he++){if(!ee._validateLink($[he]))continue;const Ce=k.DocumentLink.from($[he]);Ce.cacheId=[j,he],re.links.push(Ce)}return re}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,W){if(typeof this._provider.resolveDocumentLink!="function")return;const N=this._cache.get(...z);if(!N)return;const $=await this._provider.resolveDocumentLink(N,W);if(!(!$||!ee._validateLink($)))return k.DocumentLink.from($)}releaseLinks(z){this._cache.delete(z)}}class Q{constructor(z,W){this._documents=z,this._provider=W}async provideColors(z,W){const N=this._documents.getDocument(z),$=await this._provider.provideDocumentColors(N,W);return Array.isArray($)?$.map(re=>({color:k.Color.from(re.color),range:k.Range.from(re.range)})):[]}async provideColorPresentations(z,W,N){const $=this._documents.getDocument(z),j=k.Range.to(W.range),re=k.Color.to(W.color),he=await this._provider.provideColorPresentations(re,{document:$,range:j},N);if(!!Array.isArray(he))return he.map(k.ColorPresentation.from)}}class oe{constructor(z,W){this._documents=z,this._provider=W}async provideFoldingRanges(z,W,N){const $=this._documents.getDocument(z),j=await this._provider.provideFoldingRanges($,W,N);if(!!Array.isArray(j))return j.map(k.FoldingRange.from)}}class de{constructor(z,W,N){this._documents=z,this._provider=W,this._logService=N}async provideSelectionRanges(z,W,N){const $=this._documents.getDocument(z),j=W.map(k.Position.to),re=await this._provider.provideSelectionRanges($,j,N);if(!(0,T.isNonEmptyArray)(re))return[];if(re.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ce=0;Ce<j.length;Ce++){const Ae=[];he.push(Ae);let We=j[Ce],$e=re[Ce];for(;;){if(!$e.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ae.push(k.SelectionRange.from($e)),!$e.parent)break;We=$e.range,$e=$e.parent}}return he}}class ve{constructor(z,W){this._documents=z,this._provider=W,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.prepareCallHierarchy($,j,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideCallsTo(z,W,N){const $=this._itemFromCache(z,W);if(!$)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls($,N);if(!!j)return j.map(re=>({from:this._cacheAndConvertItem(z,re.from),fromRanges:re.fromRanges.map(he=>k.Range.from(he))}))}async provideCallsFrom(z,W,N){const $=this._itemFromCache(z,W);if(!$)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls($,N);if(!!j)return j.map(re=>({to:this._cacheAndConvertItem(z,re.to),fromRanges:re.fromRanges.map(he=>k.Range.from(he))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,W){const N=this._cache.get(z),$=k.CallHierarchyItem.from(W,z,N.size.toString(36));return N.set($._itemId,W),$}_itemFromCache(z,W){return this._cache.get(z)?.get(W)}}class ke{constructor(z,W){this._documents=z,this._provider=W,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(z,W,N){const $=this._documents.getDocument(z),j=k.Position.to(W),re=await this._provider.prepareTypeHierarchy($,j,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideSupertypes(z,W,N){const $=this._itemFromCache(z,W);if(!$)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes($,N);if(!!j)return j.map(re=>this._cacheAndConvertItem(z,re))}async provideSubtypes(z,W,N){const $=this._itemFromCache(z,W);if(!$)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes($,N);if(!!j)return j.map(re=>this._cacheAndConvertItem(z,re))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,W){const N=this._cache.get(z),$=k.TypeHierarchyItem.from(W,z,N.size.toString(36));return N.set($._itemId,W),$}_itemFromCache(z,W){return this._cache.get(z)?.get(W)}}class Ne{constructor(z,W){this.adapter=z,this.extension=W}}class _e{constructor(z,W,N,$,j,re,he){this._adapter=new Map,this._uriTransformer=W,this._proxy=z.getProxy(S.MainContext.MainThreadLanguageFeatures),this._documents=N,this._commands=$,this._diagnostics=j,this._logService=re,this._apiDeprecation=he}_transformDocumentSelector(z){return k.DocumentSelector.from(z,this._uriTransformer)}_createDisposable(z){return new A.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return _e._handlePool++}async _withAdapter(z,W,N,$,j){const re=this._adapter.get(z);if(!re||!(re.adapter instanceof W))return $;const he=Date.now();this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${N.toString().replace(/[\r\n]/g,"")}'`);const Ce=N(re.adapter,re.extension);return Promise.resolve(Ce).catch(Ae=>{(0,I.isCancellationError)(Ae)||(this._logService.error(`[${re.extension.identifier.value}] provider FAILED`),this._logService.error(Ae))}).finally(()=>{this._logService.trace(`[${re.extension.identifier.value}] provider DONE after ${Date.now()-he}ms`)}),g.CancellationToken.isCancellationToken(j)?(0,c.raceCancellationError)(Ce,j):Ce}_addNewAdapter(z,W){const N=this._nextHandle();return this._adapter.set(N,new Ne(z,W)),N}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,W,N,$){const j=this._addNewAdapter(new m(this._documents,N),z),re=$&&$.label||_e._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(W),re),this._createDisposable(j)}$provideDocumentSymbols(z,W,N){return this._withAdapter(z,m,$=>$.provideDocumentSymbols(h.URI.revive(W),N),void 0,N)}registerCodeLensProvider(z,W,N){const $=this._nextHandle(),j=typeof N.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set($,new Ne(new s(this._documents,this._commands.converter,N),z)),this._proxy.$registerCodeLensSupport($,this._transformDocumentSelector(W),j);let re=this._createDisposable($);if(j!==void 0){const he=N.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(j));re=A.Disposable.from(re,he)}return re}$provideCodeLenses(z,W,N){return this._withAdapter(z,s,$=>$.provideCodeLenses(h.URI.revive(W),N),void 0,N)}$resolveCodeLens(z,W,N){return this._withAdapter(z,s,$=>$.resolveCodeLens(W,N),void 0,void 0)}$releaseCodeLenses(z,W){this._withAdapter(z,s,N=>Promise.resolve(N.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(z,W,N){const $=this._addNewAdapter(new o(this._documents,N),z);return this._proxy.$registerDefinitionSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDefinition(z,W,N,$){return this._withAdapter(z,o,j=>j.provideDefinition(h.URI.revive(W),N,$),[],$)}registerDeclarationProvider(z,W,N){const $=this._addNewAdapter(new n(this._documents,N),z);return this._proxy.$registerDeclarationSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDeclaration(z,W,N,$){return this._withAdapter(z,n,j=>j.provideDeclaration(h.URI.revive(W),N,$),[],$)}registerImplementationProvider(z,W,N){const $=this._addNewAdapter(new i(this._documents,N),z);return this._proxy.$registerImplementationSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideImplementation(z,W,N,$){return this._withAdapter(z,i,j=>j.provideImplementation(h.URI.revive(W),N,$),[],$)}registerTypeDefinitionProvider(z,W,N){const $=this._addNewAdapter(new r(this._documents,N),z);return this._proxy.$registerTypeDefinitionSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideTypeDefinition(z,W,N,$){return this._withAdapter(z,r,j=>j.provideTypeDefinition(h.URI.revive(W),N,$),[],$)}registerHoverProvider(z,W,N,$){const j=this._addNewAdapter(new l(this._documents,N),z);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(W)),this._createDisposable(j)}$provideHover(z,W,N,$){return this._withAdapter(z,l,j=>j.provideHover(h.URI.revive(W),N,$),void 0,$)}registerEvaluatableExpressionProvider(z,W,N,$){const j=this._addNewAdapter(new p(this._documents,N),z);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(W)),this._createDisposable(j)}$provideEvaluatableExpression(z,W,N,$){return this._withAdapter(z,p,j=>j.provideEvaluatableExpression(h.URI.revive(W),N,$),void 0,$)}registerInlineValuesProvider(z,W,N,$){const j=typeof N.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new d(this._documents,N),z);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(W),j);let he=this._createDisposable(re);if(j!==void 0){const Ce=N.onDidChangeInlineValues(Ae=>this._proxy.$emitInlineValuesEvent(j));he=A.Disposable.from(he,Ce)}return he}$provideInlineValues(z,W,N,$,j){return this._withAdapter(z,d,re=>re.provideInlineValues(h.URI.revive(W),N,$,j),void 0,j)}registerDocumentHighlightProvider(z,W,N){const $=this._addNewAdapter(new v(this._documents,N),z);return this._proxy.$registerDocumentHighlightProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDocumentHighlights(z,W,N,$){return this._withAdapter(z,v,j=>j.provideDocumentHighlights(h.URI.revive(W),N,$),void 0,$)}registerLinkedEditingRangeProvider(z,W,N){const $=this._addNewAdapter(new R(this._documents,N),z);return this._proxy.$registerLinkedEditingRangeProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideLinkedEditingRanges(z,W,N,$){return this._withAdapter(z,R,async j=>{const re=await j.provideLinkedEditingRanges(h.URI.revive(W),N,$);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?_e._serializeRegExp(re.wordPattern):void 0}},void 0,$)}registerReferenceProvider(z,W,N){const $=this._addNewAdapter(new O(this._documents,N),z);return this._proxy.$registerReferenceSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideReferences(z,W,N,$,j){return this._withAdapter(z,O,re=>re.provideReferences(h.URI.revive(W),N,$,j),void 0,j)}registerCodeActionProvider(z,W,N,$){const j=new E.DisposableStore,re=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,N,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(W),{providedKinds:$?.providedCodeActionKinds?.map(he=>he.value),documentation:$?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,j)}))},_e._extLabel(z),Boolean(N.resolveCodeAction)),j.add(this._createDisposable(re)),j}$provideCodeActions(z,W,N,$,j){return this._withAdapter(z,L,re=>re.provideCodeActions(h.URI.revive(W),N,$,j),void 0,j)}$resolveCodeAction(z,W,N){return this._withAdapter(z,L,$=>$.resolveCodeAction(W,N),void 0,void 0)}$releaseCodeActions(z,W){this._withAdapter(z,L,N=>Promise.resolve(N.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(z,W,N){const $=this._addNewAdapter(new _(this._documents,N),z);return this._proxy.$registerDocumentFormattingSupport($,this._transformDocumentSelector(W),z.identifier,z.displayName||z.name),this._createDisposable($)}$provideDocumentFormattingEdits(z,W,N,$){return this._withAdapter(z,_,j=>j.provideDocumentFormattingEdits(h.URI.revive(W),N,$),void 0,$)}registerDocumentRangeFormattingEditProvider(z,W,N){const $=this._addNewAdapter(new U(this._documents,N),z);return this._proxy.$registerRangeFormattingSupport($,this._transformDocumentSelector(W),z.identifier,z.displayName||z.name),this._createDisposable($)}$provideDocumentRangeFormattingEdits(z,W,N,$,j){return this._withAdapter(z,U,re=>re.provideDocumentRangeFormattingEdits(h.URI.revive(W),N,$,j),void 0,j)}registerOnTypeFormattingEditProvider(z,W,N,$){const j=this._addNewAdapter(new M(this._documents,N),z);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(W),$,z.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits(z,W,N,$,j,re){return this._withAdapter(z,M,he=>he.provideOnTypeFormattingEdits(h.URI.revive(W),N,$,j,re),void 0,re)}registerWorkspaceSymbolProvider(z,W){const N=this._addNewAdapter(new q(W,this._logService),z);return this._proxy.$registerNavigateTypeSupport(N,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(N)}$provideWorkspaceSymbols(z,W,N){return this._withAdapter(z,q,$=>$.provideWorkspaceSymbols(W,N),{symbols:[]},N)}$resolveWorkspaceSymbol(z,W,N){return this._withAdapter(z,q,$=>$.resolveWorkspaceSymbol(W,N),void 0,void 0)}$releaseWorkspaceSymbols(z,W){this._withAdapter(z,q,N=>N.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(z,W,N){const $=this._addNewAdapter(new K(this._documents,N,this._logService),z);return this._proxy.$registerRenameSupport($,this._transformDocumentSelector(W),K.supportsResolving(N)),this._createDisposable($)}$provideRenameEdits(z,W,N,$,j){return this._withAdapter(z,K,re=>re.provideRenameEdits(h.URI.revive(W),N,$,j),void 0,j)}$resolveRenameLocation(z,W,N,$){return this._withAdapter(z,K,j=>j.resolveRenameLocation(h.URI.revive(W),N,$),void 0,$)}registerDocumentSemanticTokensProvider(z,W,N,$){const j=this._addNewAdapter(new B(this._documents,N),z),re=typeof N.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(W),$,re);let he=this._createDisposable(j);if(re){const Ce=N.onDidChangeSemanticTokens(Ae=>this._proxy.$emitDocumentSemanticTokensEvent(re));he=A.Disposable.from(he,Ce)}return he}$provideDocumentSemanticTokens(z,W,N,$){return this._withAdapter(z,B,j=>j.provideDocumentSemanticTokens(h.URI.revive(W),N,$),null,$)}$releaseDocumentSemanticTokens(z,W){this._withAdapter(z,B,N=>N.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,W,N,$){const j=this._addNewAdapter(new G(this._documents,N),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(W),$),this._createDisposable(j)}$provideDocumentRangeSemanticTokens(z,W,N,$){return this._withAdapter(z,G,j=>j.provideDocumentRangeSemanticTokens(h.URI.revive(W),N,$),null,$)}registerCompletionItemProvider(z,W,N,$){const j=this._addNewAdapter(new X(this._documents,this._commands.converter,N,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(W),$,X.supportsResolving(N),`${z.identifier.value}(${$.join("")})`),this._createDisposable(j)}$provideCompletionItems(z,W,N,$,j){return this._withAdapter(z,X,re=>re.provideCompletionItems(h.URI.revive(W),N,$,j),void 0,j)}$resolveCompletionItem(z,W,N){return this._withAdapter(z,X,$=>$.resolveCompletionItem(W,N),void 0,N)}$releaseCompletionItems(z,W){this._withAdapter(z,X,N=>N.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(z,W,N){const $=this._addNewAdapter(new V(this._documents,N,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideInlineCompletions(z,W,N,$,j){return this._withAdapter(z,V,re=>re.provideInlineCompletions(h.URI.revive(W),N,$,j),void 0,j)}$handleInlineCompletionDidShow(z,W,N){this._withAdapter(z,V,async $=>{$.handleDidShowCompletionItem(W,N)},void 0,void 0)}$freeInlineCompletionsList(z,W){this._withAdapter(z,V,async N=>{N.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(z,W,N,$){const j=Array.isArray($)?{triggerCharacters:$,retriggerCharacters:[]}:$,re=this._addNewAdapter(new se(this._documents,N),z);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(W),j),this._createDisposable(re)}$provideSignatureHelp(z,W,N,$,j){return this._withAdapter(z,se,re=>re.provideSignatureHelp(h.URI.revive(W),N,$,j),void 0,j)}$releaseSignatureHelp(z,W){this._withAdapter(z,se,N=>N.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(z,W,N){const $=typeof N.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new ce(this._documents,this._commands.converter,N,this._logService,z),z);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(W),typeof N.resolveInlayHint=="function",$,_e._extLabel(z));let re=this._createDisposable(j);if($!==void 0){const he=N.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent($));re=A.Disposable.from(re,he)}return re}$provideInlayHints(z,W,N,$){return this._withAdapter(z,ce,j=>j.provideInlayHints(h.URI.revive(W),N,$),void 0,$)}$resolveInlayHint(z,W,N){return this._withAdapter(z,ce,$=>$.resolveInlayHint(W,N),void 0,N)}$releaseInlayHints(z,W){this._withAdapter(z,ce,N=>N.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(z,W,N){const $=this._addNewAdapter(new ee(this._documents,N),z);return this._proxy.$registerDocumentLinkProvider($,this._transformDocumentSelector(W),typeof N.resolveDocumentLink=="function"),this._createDisposable($)}$provideDocumentLinks(z,W,N){return this._withAdapter(z,ee,$=>$.provideLinks(h.URI.revive(W),N),void 0,N)}$resolveDocumentLink(z,W,N){return this._withAdapter(z,ee,$=>$.resolveLink(W,N),void 0,void 0)}$releaseDocumentLinks(z,W){this._withAdapter(z,ee,N=>N.releaseLinks(W),void 0,void 0)}registerColorProvider(z,W,N){const $=this._addNewAdapter(new Q(this._documents,N),z);return this._proxy.$registerDocumentColorProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDocumentColors(z,W,N){return this._withAdapter(z,Q,$=>$.provideColors(h.URI.revive(W),N),[],N)}$provideColorPresentations(z,W,N,$){return this._withAdapter(z,Q,j=>j.provideColorPresentations(h.URI.revive(W),N,$),void 0,$)}registerFoldingRangeProvider(z,W,N){const $=this._nextHandle(),j=typeof N.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set($,new Ne(new oe(this._documents,N),z)),this._proxy.$registerFoldingRangeProvider($,this._transformDocumentSelector(W),j);let re=this._createDisposable($);if(j!==void 0){const he=N.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));re=A.Disposable.from(re,he)}return re}$provideFoldingRanges(z,W,N,$){return this._withAdapter(z,oe,j=>j.provideFoldingRanges(h.URI.revive(W),N,$),void 0,$)}registerSelectionRangeProvider(z,W,N){const $=this._addNewAdapter(new de(this._documents,N,this._logService),z);return this._proxy.$registerSelectionRangeProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideSelectionRanges(z,W,N,$){return this._withAdapter(z,de,j=>j.provideSelectionRanges(h.URI.revive(W),N,$),[],$)}registerCallHierarchyProvider(z,W,N){const $=this._addNewAdapter(new ve(this._documents,N),z);return this._proxy.$registerCallHierarchyProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$prepareCallHierarchy(z,W,N,$){return this._withAdapter(z,ve,j=>Promise.resolve(j.prepareSession(h.URI.revive(W),N,$)),void 0,$)}$provideCallHierarchyIncomingCalls(z,W,N,$){return this._withAdapter(z,ve,j=>j.provideCallsTo(W,N,$),void 0,$)}$provideCallHierarchyOutgoingCalls(z,W,N,$){return this._withAdapter(z,ve,j=>j.provideCallsFrom(W,N,$),void 0,$)}$releaseCallHierarchy(z,W){this._withAdapter(z,ve,N=>Promise.resolve(N.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(z,W,N){const $=this._addNewAdapter(new ke(this._documents,N),z);return this._proxy.$registerTypeHierarchyProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$prepareTypeHierarchy(z,W,N,$){return this._withAdapter(z,ke,j=>Promise.resolve(j.prepareSession(h.URI.revive(W),N,$)),void 0,$)}$provideTypeHierarchySupertypes(z,W,N,$){return this._withAdapter(z,ke,j=>j.provideSupertypes(W,N,$),void 0,$)}$provideTypeHierarchySubtypes(z,W,N,$){return this._withAdapter(z,ke,j=>j.provideSubtypes(W,N,$),void 0,$)}$releaseTypeHierarchy(z,W){this._withAdapter(z,ke,N=>Promise.resolve(N.releaseSession(W)),void 0,void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,P.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:_e._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:_e._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?_e._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?_e._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:_e._serializeRegExp(z.beforeText),afterText:z.afterText?_e._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?_e._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(_e._serializeOnEnterRule)}setLanguageConfiguration(z,W,N){let{wordPattern:$}=N;if($&&(0,P.regExpLeadsToEndlessLoop)($))throw new Error(`Invalid language configuration: wordPattern '${$}' is not allowed to match the empty string.`);$?this._documents.setWordDefinitionFor(W,$):this._documents.setWordDefinitionFor(W,void 0),N.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),N.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const j=this._nextHandle(),re={comments:N.comments,brackets:N.brackets,wordPattern:N.wordPattern?_e._serializeRegExp(N.wordPattern):void 0,indentationRules:N.indentationRules?_e._serializeIndentationRule(N.indentationRules):void 0,onEnterRules:N.onEnterRules?_e._serializeOnEnterRules(N.onEnterRules):void 0,__electricCharacterSupport:N.__electricCharacterSupport,__characterPairSupport:N.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,W,re),this._createDisposable(j)}$setWordDefinitions(z){for(const W of z)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=_e,_e._handlePool=0}),define(we[245],be([1,0,5,15,7,47,13,6]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(F,D,g,E){this._documents=D,this._commands=g,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(h.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,D){await this._proxy.$changeLanguage(F,D);const g=this._documents.getDocumentData(F);if(!g)throw new Error(`document '${F.toString}' NOT found`);return g.document}async tokenAtPosition(F,D){const g=F.version,E=t.Position.from(D),f=await this._proxy.$tokensAtPosition(F.uri,E),u={type:k.StandardTokenType.Other,range:F.getWordRangeAtPosition(D)??new k.Range(D.line,D.character,D.line,D.character)};if(!f)return u;const w={range:t.Range.to(f.range),type:t.TokenType.to(f.type)};return!w.range.contains(D)||g!==F.version?u:w}createLanguageStatusItem(F,D,g){const E=this._handlePool++,f=this._proxy,u=this._ids,w=`${F.identifier.value}/${D}`;if(u.has(w))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);u.add(w);const y={selector:g,id:D,name:F.displayName??F.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let I,a=new P.DisposableStore;const c=()=>{I?.dispose(),I=(0,S.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(E,{id:w,name:y.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(y.selector,this._uriTransformer),label:y.text,detail:y.detail??"",severity:y.severity===k.LanguageStatusSeverity.Error?A.default.Error:y.severity===k.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:y.command&&this._commands.toInternal(y.command,a),accessibilityInfo:y.accessibilityInformation,busy:y.busy})},0)},m={dispose(){a.dispose(),I?.dispose(),f.$removeLanguageStatus(E),u.delete(w)},get id(){return y.id},get name(){return y.name},set name(s){y.name=s,c()},get selector(){return y.selector},set selector(s){y.selector=s,c()},get text(){return y.text},set text(s){y.text=s,c()},get detail(){return y.detail},set detail(s){y.detail=s,c()},get severity(){return y.severity},set severity(s){y.severity=s,c()},get accessibilityInformation(){return y.accessibilityInformation},set accessibilityInformation(s){y.accessibilityInformation=s,c()},get command(){return y.command},set command(s){y.command=s,c()},get busy(){return y.busy},set busy(s){y.busy=s,c()}};return c(),m}}e.ExtHostLanguages=C}),define(we[135],be([1,0,11,5,26,14,3]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends h.AbstractLoggerService{constructor(F,D){const g=new S.Emitter;super(D.logLevel,g.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(g)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,D,g){return new C(this._proxy,F,D,g)}};P=Be([Fe(0,A.IExtHostRpcService),Fe(1,k.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class C extends h.AbstractMessageLogger{constructor(F,D,g,E){super(E?.always);this.proxy=F,this.file=D,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.proxy.$createLogger(D,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,D){const g=[[F,D]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(F){this.proxy.$log(this.file,F)}}}),define(we[246],be([1,0,5,11,30]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let S=class{constructor(C,T){this._logService=T,this._proxy=C.getProxy(h.MainContext.MainThreadMessageService)}showMessage(C,T,F,D,g){const E={source:{identifier:C.identifier,label:C.displayName||C.name}};let f;typeof D=="string"||A(D)?f=[D,...g]:(E.modal=D?.modal,E.useCustom=D?.useCustom,E.detail=D?.detail,f=g),E.useCustom&&(0,k.checkProposedApiEnabled)(C,"resolvers");const u=[];for(let w=0;w<f.length;w++){const y=f[w];if(typeof y=="string")u.push({title:y,handle:w,isCloseAffordance:!1});else if(typeof y=="object"){let{title:I,isCloseAffordance:a}=y;u.push({title:I,isCloseAffordance:!!a,handle:w})}else this._logService.warn("Invalid message item:",y)}return this._proxy.$showMessage(T,F,E,u).then(w=>{if(typeof w=="number")return f[w]})}};S=Be([Fe(1,t.ILogService)],S),e.ExtHostMessageService=S}),define(we[247],be([1,0,23,3,58,6,24,8,18,2,85,5,15,7,52,223,131]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class y{constructor(a,c,m,s,b){this._textDocumentsAndEditors=m,this._textDocuments=s,this._extensionStoragePaths=b,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new S.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(D.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(D.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(D.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const n=o.notebookEditor?.notebookUri,i=o.cell.handle,l=this._documents.get(n)?.getCell(i);if(l)return l.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const c=this._editors.get(a);if(!c)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(a){for(const[c,m]of this._editors)if(m.apiEditor===a)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,c){const m=this._documents.get(a);if(!m&&!c)throw new Error(`NO notebook document for '${a}'`);return m}_getProviderData(a){const c=this._notebookContentProviders.get(a);if(!c)throw new Error(`NO provider for '${a}'`);return c}registerNotebookContentProvider(a,c,m,s,b){if((0,P.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:a,provider:m});let o;return m.onDidChangeNotebookContentOptions&&(o=m.onDidChangeNotebookContentOptions(()=>{const n=g.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(c,n)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},c,g.NotebookDocumentContentOptions.from(s),y._convertNotebookRegistrationData(a,b)),new E.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(a,c){if(!c)return;const m=c.filenamePattern.map(s=>g.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(c.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:c.displayName,filenamePattern:m,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,c,m){const s=y._notebookStatusBarItemProviderHandlePool++,b=typeof m.onDidChangeCellStatusBarItems=="function"?y._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,b,c);let o;return b!==void 0&&(o=m.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(b))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,b),o&&o.dispose()})}async createNotebookDocument(a){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&g.NotebookData.from(a.content)});return T.URI.revive(c)}async openNotebookDocument(a){const c=this._documents.get(a);if(c)return c.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(a),s=this._documents.get(T.URI.revive(m));return(0,C.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(a,c){T.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let m;typeof c=="object"?m={position:g.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(g.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:m={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,m),b=s&&this._editors.get(s)?.apiEditor;if(b)return b;throw s?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,c,m,s){const b=this._notebookStatusBarItemProviders.get(a),o=T.URI.revive(c),n=this._documents.get(o);if(!n||!b)return;const i=n.getCellFromIndex(m);if(!i)return;const r=await b.provideCellStatusBarItems(i.apiCell,s);if(!r)return;const l=new A.DisposableStore,p=this._statusBarCache.add([l]),v=(Array.isArray(r)?r:[r]).map(R=>g.NotebookStatusBarItem.from(R,this._commandsConverter,l));return{cacheId:p,items:v}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,c,m,s,b){if((0,P.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,m),this._notebookProxy.$registerNotebookSerializer(o,{id:a.identifier,location:a.extensionLocation},c,g.NotebookDocumentContentOptions.from(s),y._convertNotebookRegistrationData(a,b)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(a,c,m){const s=this._notebookSerializer.get(a);if(!s)throw new Error("NO serializer found");const b=await s.deserializeNotebook(c.buffer,m);return new f.SerializableObjectWithBuffers(g.NotebookData.from(b))}async $notebookToData(a,c,m){const s=this._notebookSerializer.get(a);if(!s)throw new Error("NO serializer found");const b=await s.serializeNotebook(g.NotebookData.to(c.value),m);return h.VSBuffer.wrap(b)}async $openNotebook(a,c,m,s,b){const{provider:o}=this._getProviderData(a),n=await o.openNotebook(T.URI.revive(c),{backupId:m,untitledDocumentData:s?.buffer},b);return new f.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(g.NotebookCellData.from)})}async $saveNotebook(a,c,m){const s=this.getNotebookDocument(T.URI.revive(c)),{provider:b}=this._getProviderData(a);return await b.saveNotebook(s.apiNotebook,m),!0}async $saveNotebookAs(a,c,m,s){const b=this.getNotebookDocument(T.URI.revive(c)),{provider:o}=this._getProviderData(a);return await o.saveNotebookAs(T.URI.revive(m),b.apiNotebook,s),!0}async $backupNotebook(a,c,m){const s=this.getNotebookDocument(T.URI.revive(c)),b=this._getProviderData(a),o=this._extensionStoragePaths.workspaceValue(b.extension)??this._extensionStoragePaths.globalValue(b.extension),n=String((0,k.hash)([s.uri.toString(),this._backupIdPool++])),i=T.URI.joinPath(o,n),r=await b.provider.backupNotebook(s.apiNotebook,{destination:i},m);return s.updateBackup(r),r.id}_createExtHostEditor(a,c,m){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const s=new w.ExtHostNotebookEditor(c,this._notebookEditorsProxy,a,m.visibleRanges.map(g.NotebookRange.to),m.selections.map(g.NotebookRange.to),typeof m.viewColumn=="number"?g.ViewColumn.to(m.viewColumn):void 0);this._editors.set(c,s)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const m of a.value.removedDocuments){const s=T.URI.revive(m),b=this._documents.get(s);b&&(b.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===s.toString()&&this._editors.delete(o.id)}if(a.value.addedDocuments){const m=[];for(const s of a.value.addedDocuments){const b=T.URI.revive(s.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const o=this,n=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){o._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){o._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){o._onDidChangeCellMetadata.fire(i)}},b,s);m.push(...s.cells.map(i=>u.ExtHostCell.asModelAddData(n.apiNotebook,i))),this._documents.get(b)?.dispose(),this._documents.set(b,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(a.value.addedEditors)for(const m of a.value.addedEditors){if(this._editors.has(m.id))return;const s=T.URI.revive(m.documentUri),b=this._documents.get(s);b&&this._createExtHostEditor(b,m.id,m)}const c=[];if(a.value.removedEditors)for(const m of a.value.removedEditors){const s=this._editors.get(m);s&&(this._editors.delete(m),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),c.push(s))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const m=new Set;this._visibleNotebookEditors.forEach(s=>m.add(s.id));for(const s of this._editors.values()){const b=m.has(s.id);s._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=y,y._notebookStatusBarItemProviderHandlePool=0}),define(we[248],be([1,0,3,76,11,5,14,15]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(D,g){const E=C._Keys.nextId();D.$registerNotebookEditorDecorationType(E,P.NotebookDecorationRenderOptions.from(g)),this.value={key:E,dispose(){D.$removeNotebookEditorDecorationType(E)}}}}C._Keys=new t.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(D,g,E){this._logService=D,this._extHostRpc=g,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(D){return new C(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),D).value}$acceptEditorPropertiesChanged(D,g){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const E=this._notebooksAndEditors.getEditorById(D);g.visibleRanges&&E._acceptVisibleRanges(g.visibleRanges.ranges.map(P.NotebookRange.to)),g.selections&&E._acceptSelections(g.selections.selections.map(P.NotebookRange.to)),g.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),g.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this._notebooksAndEditors.getEditorById(g)._acceptViewColumn(P.ViewColumn.to(D[g]))}};T=Be([Fe(0,k.ILogService),Fe(1,S.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(we[249],be([1,0,17,13,21,3,6,24,2,27,11,5,38,15,7,86,216,30,52]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(n,i,r,l,p){this._initData=i,this._extHostNotebook=r,this._commands=l,this._logService=p,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(D.MainContext.MainThreadNotebookKernels);const d=new g.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.ApiCommandArgument("options","Select kernel options",v=>!0,v=>{if(v&&"notebookEditor"in v&&"id"in v){const R=this._extHostNotebook.getIdByEditor(v.notebookEditor);return{id:v.id,extension:v.extension,notebookEditorId:R}}else if(v&&"notebookEditor"in v){const R=this._extHostNotebook.getIdByEditor(v.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${v.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return v})],g.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(n,i,r,l,p,d){for(const Z of this._kernelData.values())if(Z.controller.id===i&&T.ExtensionIdentifier.equals(n.identifier,Z.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const v=this._handlePool++,R=this;this._logService.trace(`NotebookController[${v}], CREATED by ${n.identifier.value}, ${i}`);const O=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${n.identifier}'`);let L=!1;const _=new S.DisposableStore,U=new A.Emitter,M=new A.Emitter,q={id:b(n,i),notebookType:r,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:l||n.identifier.value,preloads:d?d.map(E.NotebookRendererScript.from):[]};let K=p??O,x;this._proxy.$addKernel(v,q).catch(Z=>{console.log(Z),L=!0});let B=0;const G=()=>{if(L)return;const Z=++B;Promise.resolve().then(()=>{Z===B&&this._proxy.$updateKernel(v,q)})},X=new P.ResourceMap,V={get id(){return i},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return q.label},set label(Z){q.label=Z??n.displayName??n.name,G()},get detail(){return q.detail??""},set detail(Z){q.detail=Z,G()},get description(){return q.description??""},set description(Z){q.description=Z,G()},get kind(){return(0,y.checkProposedApiEnabled)(n,"notebookControllerKind"),q.kind??""},set kind(Z){(0,y.checkProposedApiEnabled)(n,"notebookControllerKind"),q.kind=Z,G()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(Z){q.supportedLanguages=Z,G()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){q.supportsExecutionOrder=Z,G()},get rendererScripts(){return q.preloads?q.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(Z){K=Z??O},get interruptHandler(){return x},set interruptHandler(Z){x=Z,q.supportsInterrupt=Boolean(Z),G()},createNotebookCellExecution(Z){if(L)throw new Error("notebook controller is DISPOSED");if(!X.has(Z.notebook.uri))throw R._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return R._createNotebookCellExecution(Z,b(n,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${v}], DISPOSED`),L=!0,this._kernelData.delete(v),_.dispose(),U.dispose(),M.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(Z,se){R._proxy.$updateNotebookPriority(v,Z.uri,se)},onDidReceiveMessage:M.event,postMessage(Z,se){return(0,y.checkProposedApiEnabled)(n,"notebookMessaging"),R._proxy.$postMessage(v,se&&R._extHostNotebook.getIdByEditor(se),Z)},asWebviewUri(Z){return(0,y.checkProposedApiEnabled)(n,"notebookMessaging"),(0,u.asWebviewUri)(Z,R._initData.remote)}};return this._kernelData.set(v,{extensionId:n.identifier,controller:V,onDidReceiveMessage:M,onDidChangeSelection:U,associatedNotebooks:X}),V}$acceptNotebookAssociation(n,i,r){const l=this._kernelData.get(n);if(l){const p=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));r?l.associatedNotebooks.set(p.uri,!0):l.associatedNotebooks.delete(p.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,p.uri.toString(),r),l.onDidChangeSelection.fire({selected:r,notebook:p.apiNotebook})}}async $executeCells(n,i,r){const l=this._kernelData.get(n);if(!l)return;const p=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)),d=[];for(const v of r){const R=p.getCell(v);R&&d.push(R.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,p.uri.toString(),d.length),await l.controller.executeHandler.call(l.controller,d,p.apiNotebook,l.controller)}catch(v){this._logService.error(`NotebookController[${n}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(n,i,r){const l=this._kernelData.get(n);if(!l)return;const p=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,p.apiNotebook);else for(const d of r){const v=p.getCell(d);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,i,r){const l=this._kernelData.get(n);if(!l)return;const p=this._extHostNotebook.getEditorById(i);l.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:r}))}$cellExecutionChanged(n,i,r){const p=this._extHostNotebook.getNotebookDocument(C.URI.revive(n)).getCell(i);p&&this._onDidChangeCellExecutionState.fire({cell:p.apiCell,state:r??f.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(n,i){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const p=new m(i,l,this._proxy);this._activeExecutions.set(l.uri,p);const d=p.onDidChangeState(()=>{p.state===c.Resolved&&(p.dispose(),d.dispose(),this._activeExecutions.delete(l.uri))});return p.asApiObject()}};a=Be([Fe(4,F.ILogService)],a),e.ExtHostNotebookKernels=a;var c;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(c||(c={}));class m extends S.Disposable{constructor(n,i,r){super();this._cell=i,this._proxy=r,this._handle=m.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new s(10,l=>this.update(l)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const i=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new I.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(n){return n.map(i=>{const r=f.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return r===i.items?E.NotebookCellOutput.from(i):E.NotebookCellOutput.from({items:r,id:i.id,metadata:i.metadata})})}async updateOutputs(n,i,r){const l=this.validateAndConvertOutputs((0,h.asArray)(n));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,append:r,outputs:l})}async updateOutputItems(n,i,r){return n=f.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(n),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,items:n.map(E.NotebookCellOutputItem.from),outputId:i.id,append:r})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(r){n._executionOrder=r,n.update([{editType:w.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(r){if(n._state===c.Resolved||n._state===c.Started)throw new Error("Cannot call start again");n._state=c.Started,n._onDidChangeState.fire(),n.update({editType:w.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,l){if(n._state===c.Resolved)throw new Error("Cannot call resolve twice");n._state=c.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new I.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:r}))},clearOutput(r){return n.verifyStateForOutput(),n.updateOutputs([],r,!1)},appendOutput(r,l){return n.verifyStateForOutput(),n.updateOutputs(r,l,!0)},replaceOutput(r,l){return n.verifyStateForOutput(),n.updateOutputs(r,l,!1)},appendOutputItems(r,l){return n.verifyStateForOutput(),n.updateOutputItems(r,l,!0)},replaceOutputItems(r,l){return n.verifyStateForOutput(),n.updateOutputItems(r,l,!1)}})}}m.HANDLE=0;class s{constructor(n,i){this.delay=n,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>n.complete())}}function b(o,n){return`${o.identifier.value}/${n}`}}),define(we[250],be([1,0,3,5,131,30]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(C,T){this._extHostNotebook=T,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,T,F){const D=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(T)?.fire({editor:D.apiEditor,message:F})}createRendererMessaging(C,T){if(!C.contributes?.notebookRenderer?.some(E=>E.id===T))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${T})`);const F=(0,A.isProposedApiEnabled)(C,"notebookEditor"),D=new WeakMap;return{onDidReceiveMessage:(E,f,u)=>{const w=F?E:y=>{const I={};D.set(I,y.editor),E({editor:I,message:y.message})};return this.getOrCreateEmitterFor(T).event(w,f,u)},postMessage:(E,f)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,f]=[f,E]);const u=F?f:D.get(f),w=u&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(w?.id,T,E)}}}getOrCreateEmitterFor(C){let T=this._rendererMessageEmitters.get(C);return T||(T=new h.Emitter({onLastListenerRemove:()=>{T?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,T),T)}}e.ExtHostNotebookRenderers=S}),define(we[136],be([1,0,5,6,4,14,11,217,66,26,44,157,23]),function(te,e,h,t,k,A,S,P,C,T,F,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends t.Disposable{constructor(w,y,I,a){super();this.id=w,this.name=y,this.logger=I,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(w){this.append(w+`
`)}append(w){this.write(w),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const w=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,w)}replace(w){const y=this.offset;this.write(w),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,y),this.visible&&this.logger.flush()}show(w,y){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof w=="boolean"?w:y))}hide(){this.proxy.$close(this.id)}write(w){this.offset+=g.VSBuffer.fromString(w).byteLength,this.logger.info(w)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let f=class{constructor(w,y,I,a,c){this.extHostFileSystem=I,this.extHostFileSystemInfo=a,this.loggerService=c,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=w.getProxy(h.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(y.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.visibleChannelId=w;for(const[y,I]of this.channels)I.visible=y===this.visibleChannelId}createOutputChannel(w,y){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const I=this.doCreateOutputChannel(w,y);return I.then(a=>{this.channels.set(a.id,a),a.visible=a.id===this.visibleChannelId}),this.createExtHostOutputChannel(w,I)}async doCreateOutputChannel(w,y){const I=await this.createOutputDirectory(),a=this.extHostFileSystemInfo.extUri.joinPath(I,`${this.namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),m=await this.proxy.$register(w,!1,a,y.identifier.value);return new E(m,w,c,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(w,y){let I=!1;const a=()=>{if(I)throw new Error("Channel has been closed")};return{get name(){return w},append(c){a(),y.then(m=>m.append(c))},appendLine(c){a(),y.then(m=>m.appendLine(c))},clear(){a(),y.then(c=>c.clear())},replace(c){a(),y.then(m=>m.replace(c))},show(c,m){a(),y.then(s=>s.show(c,m))},hide(){a(),y.then(c=>c.hide())},dispose(){I=!0,y.then(c=>c.dispose())}}}};f=Be([Fe(0,A.IExtHostRpcService),Fe(1,T.IExtHostInitDataService),Fe(2,C.IExtHostConsumerFileSystem),Fe(3,F.IExtHostFileSystemInfo),Fe(4,S.ILoggerService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(we[251],be([1,0,13,21,3,6,5,2,7,16,17,47,84]),function(te,e,h,t,k,A,S,P,C,T,F,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(f,u,w){const y=f.getProxy(S.MainContext.MainThreadQuickOpen);class I{constructor(r,l){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=l}showQuickPick(r,l,p=t.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(r),v=++this._instances,R=y.$show(v,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},p),O={},L=R.then(()=>O);return Promise.race([L,d]).then(_=>{if(_!==O)return d.then(U=>{const M=[];for(let q=0;q<U.length;q++){const K=U[q];typeof K=="string"?M.push({label:K,handle:q}):K.kind===C.QuickPickItemKind.Separator?M.push({type:"separator",label:K.label}):M.push({label:K.label,description:K.description,detail:K.detail,picked:K.picked,alwaysShow:K.alwaysShow,handle:q})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{l.onDidSelectItem(U[q])}),y.$setItems(v,M),R.then(q=>{if(typeof q=="number")return U[q];if(Array.isArray(q))return q.map(K=>U[K])})})}).then(void 0,_=>{if(!(0,T.isCancellationError)(_))return y.$setError(v,_),Promise.reject(_)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,l=t.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,y.$input(r,typeof this._validateInput=="function",l).then(void 0,p=>{if(!(0,T.isCancellationError)(p))return Promise.reject(p)})}$validateInput(r){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,l=t.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!p)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(v=>v.uri.toString()===p.uri.toString())}createQuickPick(r){const l=new o(r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(r){const l=new n(r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(r,l){const p=this._sessions.get(r);p&&p._fireDidChangeValue(l)}$onDidAccept(r){const l=this._sessions.get(r);l&&l._fireDidAccept()}$onDidChangeActive(r,l){const p=this._sessions.get(r);p instanceof o&&p._fireDidChangeActive(l)}$onDidChangeSelection(r,l){const p=this._sessions.get(r);p instanceof o&&p._fireDidChangeSelection(l)}$onDidTriggerButton(r,l){const p=this._sessions.get(r);p&&p._fireDidTriggerButton(l)}$onDidTriggerItemButton(r,l,p){const d=this._sessions.get(r);d instanceof o&&d._fireDidTriggerItemButton(l,p)}$onDidHide(r){const l=this._sessions.get(r);l&&l._fireDidHide()}}class a{constructor(r,l){this._extensionId=r,this._onDidDispose=l,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((l,p)=>{const d=l===C.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(d,l)}),this.update({buttons:r.map((l,p)=>({...b(l),tooltip:l.tooltip,handle:l===C.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const l=this._handlesToButtons.get(r);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),y.$dispose(this._id))}update(r){if(!this._disposed){for(const l of Object.keys(r)){const p=r[l];this._pendingUpdate[l]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){y.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function c(i){if(i instanceof C.ThemeIcon)return{id:i.id};const r=s(i),l=m(i);return{dark:typeof r=="string"?P.URI.file(r):r,light:typeof l=="string"?P.URI.file(l):l}}function m(i){return typeof i=="object"&&"light"in i?i.light:i}function s(i){return typeof i=="object"&&"dark"in i?i.dark:i}function b(i){const r=c(i.iconPath);let l,p;return"id"in r?p=g.ThemeIcon.asClassName(r):l=r,{iconPath:l,iconClass:p}}class o extends a{constructor(r,l){super(r.identifier,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((p,d)=>{this._handlesToItems.set(d,p),this._itemsToHandles.set(p,d)});const l=[];for(let p=0;p<r.length;p++){const d=r[p];d.kind===C.QuickPickItemKind.Separator?l.push({type:"separator",label:d.label}):l.push({handle:p,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((v,R)=>({...b(v),tooltip:v.tooltip,handle:R}))})}this.update({items:l})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(r){const l=(0,F.coalesce)(r.map(p=>this._handlesToItems.get(p)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(r){const l=(0,F.coalesce)(r.map(p=>this._handlesToItems.get(p)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(r,l){const p=this._handlesToItems.get(r);if(!p||!p.buttons||!p.buttons.length)return;const d=p.buttons[l];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:p})}}class n extends a{constructor(r,l){super(r,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?D.default.Error:D.default.Ignore})}}return new I(u,w)}e.createExtHostQuickOpen=E});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[252],be([1,0,2,3,56,6,13,5,17,100,11,27,84,15,30]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f){"use strict";var u,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function y(p){if(p)return typeof p.iconPath=="string"?h.URI.file(p.iconPath):h.URI.isUri(p.iconPath)||g.ThemeIcon.isThemeIcon(p.iconPath)?p.iconPath:void 0}function I(p,d){if(!p.iconPath&&!d.iconPath)return 0;if(p.iconPath){if(!d.iconPath)return 1}else return-1;const v=typeof p.iconPath=="string"?p.iconPath:h.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id,R=typeof d.iconPath=="string"?d.iconPath:h.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,T.comparePaths)(v,R)}function a(p,d){let v=0;if(p.strikeThrough!==d.strikeThrough)return p.strikeThrough?1:-1;if(p.faded!==d.faded)return p.faded?1:-1;if(p.tooltip!==d.tooltip)return(p.tooltip||"").localeCompare(d.tooltip||"");if(v=I(p,d),v!==0)return v;if(p.light&&d.light)v=I(p.light,d.light);else{if(p.light)return 1;if(d.light)return-1}if(v!==0)return v;if(p.dark&&d.dark)v=I(p.dark,d.dark);else{if(p.dark)return 1;if(d.dark)return-1}return v}function c(p,d){if(p.command!==d.command)return p.command<d.command?-1:1;if(p.title!==d.title)return p.title<d.title?-1:1;if(p.tooltip!==d.tooltip){if(p.tooltip!==void 0&&d.tooltip!==void 0)return p.tooltip<d.tooltip?-1:1;if(p.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(p.arguments===d.arguments)return 0;if(p.arguments)if(d.arguments){if(p.arguments.length!==d.arguments.length)return p.arguments.length-d.arguments.length}else return 1;else return-1;for(let v=0;v<p.arguments.length;v++){const R=p.arguments[v],O=d.arguments[v];if(R!==O)return R<O?-1:1}return 0}function m(p,d){let v=(0,T.comparePaths)(p.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(v!==0)return v;if(p.command&&d.command)v=c(p.command,d.command);else{if(p.command)return 1;if(d.command)return-1}if(v!==0)return v;if(p.decorations&&d.decorations)v=a(p.decorations,d.decorations);else{if(p.decorations)return 1;if(d.decorations)return-1}return v}function s(p,d){for(let v=0;v<p.length;v++)if(p[v]!==d[v])return!1;return!0}function b(p,d){return p.command===d.command&&p.title===d.title&&p.tooltip===d.tooltip&&(p.arguments&&d.arguments?s(p.arguments,d.arguments):p.arguments===d.arguments)}function o(p,d){return(0,C.equals)(p,d,b)}class n{constructor(d,v,R){this._extension=d,this._sourceControlHandle=R,u.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Ke(this,u,v,"f")}get value(){return this._value}set value(d){d=d??"",Te(this,u,"f").$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){Te(this,u,"f").$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(d){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,Te(this,u,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,Te(this,u,"f").$setInputBoxVisibility(this._sourceControlHandle,d))}showValidationMessage(d,v){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Te(this,u,"f").$showValidationMessage(this._sourceControlHandle,d,v)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=n,u=new WeakMap;class i{constructor(d,v,R,O,L){this._proxy=d,this._commands=v,this._sourceControlHandle=R,this._id=O,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=i._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,v){const R=this._resourceStatesCommandsMap.get(d);return R?(0,S.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(m),R=(0,C.sortedDiff)(this._resourceSnapshot,d,m).map(_=>{const U=_.toInsert.map(M=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,M);const K=M.resourceUri;let x;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const oe=new A.DisposableStore;x=this._commands.converter.toInternal(M.command,oe),this._resourceStatesDisposablesMap.set(q,oe)}else this._resourceStatesCommandsMap.set(q,M.command);const B=y(M.decorations),G=M.decorations&&y(M.decorations.light)||B,X=M.decorations&&y(M.decorations.dark)||B,V=[G,X],Z=M.decorations&&M.decorations.tooltip||"",se=M.decorations&&!!M.decorations.strikeThrough,ce=M.decorations&&!!M.decorations.faded,ee=M.contextValue||"";return{rawResource:[q,K,V,Z,se,ce,ee,x],handle:q}});return{start:_.start,deleteCount:_.deleteCount,toInsert:U}}),O=R.map(({start:_,deleteCount:U,toInsert:M})=>[_,U,M.map(q=>q.rawResource)]),L=R.reverse();for(const{start:_,deleteCount:U,toInsert:M}of L){const q=M.map(x=>x.handle),K=this._handlesSnapshot.splice(_,U,...q);for(const x of K)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),this._resourceStatesDisposablesMap.get(x)?.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=d,O}dispose(){this._disposed=!0,this._onDidDispose.fire()}}i._handlePool=0;class r{constructor(d,v,R,O,L,_){this._extension=d,this._commands=R,this._id=O,this._label=L,this._rootUri=_,w.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ke(this,w,v,"f"),this._inputBox=new n(d,Te(this,w,"f"),this.handle),Te(this,w,"f").$registerSourceControl(this.handle,O,L,_)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,Te(this,w,"f").$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,Te(this,w,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,Te(this,w,"f").$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=d;const v=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);Te(this,w,"f").$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(d){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=d;const v=d!==void 0?{command:this._commands.converter.toInternal(d.command,this._actionButtonDisposables.value),description:d.description}:void 0;Te(this,w,"f").$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&o(this._statusBarCommands,d))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=d;const v=(d||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Te(this,w,"f").$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(d,v){const R=new i(Te(this,w,"f"),this._commands,this.handle,d,v),O=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,O),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const d=[],v=[];for(const[R,O]of this.createdResourceGroups){O.dispose();const L=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),L.dispose(),this._groups.delete(R.handle),Te(this,w,"f").$unregisterGroup(this.handle,R.handle)}),d.push([R.handle,R.id,R.label,R.features]);const _=R._takeResourceStateSnapshot();_.length>0&&v.push([R.handle,_]),this._groups.set(R.handle,R)}Te(this,w,"f").$registerGroups(this.handle,d,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(v=>{const R=v._takeResourceStateSnapshot();R.length!==0&&d.push([v.handle,R])}),d.length>0&&Te(this,w,"f").$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),Te(this,w,"f").$unregisterSourceControl(this.handle)}}w=new WeakMap,r._handlePool=0,Be([(0,k.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),Be([(0,k.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let l=class Vn{constructor(d,v,R){this._commands=v,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=d.getProxy(P.MainContext.MainThreadSCM),this._telemetry=d.getProxy(P.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const L=this._sourceControls.get(O.sourceControlHandle);if(!L)return O;const _=L.getResourceGroup(O.groupHandle);return _?_.getResourceState(O.handle):O}else if(O&&O.$mid===4){const L=this._sourceControls.get(O.sourceControlHandle);return L?L.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const L=this._sourceControls.get(O.handle);return L||O}return O}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,v,R,O){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,v,R,O),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const L=Vn._handlePool++,_=new r(d,this._proxy,this._commands,v,R,O);this._sourceControls.set(L,_);const U=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(d.identifier))||[];return U.push(_),this._sourceControlsByExtension.set(D.ExtensionIdentifier.toKey(d.identifier),U),_}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const v=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(d.identifier)),R=v&&v[v.length-1];return R&&R.inputBox}$provideOriginalResource(d,v,R){const O=h.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,O.toString());const L=this._sourceControls.get(d);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>L.quickDiffProvider.provideOriginalResource(O,R)).then(_=>_||null)}$onInputBoxValueChange(d,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const R=this._sourceControls.get(d);return R&&R.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(d,v,R,O){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,v,R);const L=this._sourceControls.get(d);if(!L)return Promise.resolve(void 0);const _=L.getResourceGroup(v);return _?_.$executeResourceCommand(R,O):Promise.resolve(void 0)}$validateInput(d,v,R){this.logService.trace("ExtHostSCM#$validateInput",d);const O=this._sourceControls.get(d);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>O.inputBox.validateInput(v,R)).then(L=>{if(!L)return Promise.resolve(void 0);const _=E.MarkdownString.fromStrict(L.message);return _?Promise.resolve([_,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};l._handlePool=0,l=Be([Fe(2,F.ILogService)],l),e.ExtHostSCM=l});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[253],be([1,0,7,5,171,6,15,18]),function(te,e,h,t,k,A,S,P){"use strict";var C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(f,u,w,y,I=h.StatusBarAlignment.Left,a){C.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Ke(this,C,f,"f"),Ke(this,T,u,"f"),this._entryId=F.ID_GEN++,this._extension=w,this._id=y,this._alignment=I,this._priority=this.validatePriority(a)}validatePriority(f){if(!!(0,P.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!F.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Te(this,T,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Te(this,T,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let u;this._name?u=this._name:u=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const y=S.MarkdownString.fromStrict(this._tooltip);Te(this,C,"f").$setEntry(this._entryId,f,u,this._text,y,this._command?.internal,w,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,C=new WeakMap,T=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const u={message:f};return this._messages.unshift(u),this._update(),new h.Disposable(()=>{const w=this._messages.indexOf(u);w>=0&&(this._messages.splice(w,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class g{constructor(f,u){this._proxy=f.getProxy(t.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new D(this)}createStatusBarEntry(f,u,w,y){return new F(this._proxy,this._commands,f,u,w,y)}setStatusBarMessage(f,u){const w=this._statusMessage.setMessage(f);let y;return typeof u=="number"?y=setTimeout(()=>w.dispose(),u):typeof u!="undefined"&&u.then(()=>w.dispose(),()=>w.dispose()),new h.Disposable(()=>{w.dispose(),clearTimeout(y)})}}e.ExtHostStatusBar=g}),define(we[90],be([1,0,5,3,4]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,C){this._proxy.$registerExtensionStorageKeysToSync(P,C)}initializeExtensionStorage(P,C,T){return this._proxy.$initializeExtensionStorage(P,C).then(F=>F||T)}setValue(P,C,T){return this._proxy.$setValue(P,C,T)}$acceptValue(P,C,T){this._onDidChangeStorage.fire({shared:P,key:C,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(we[67],be([1,0,4,26,11,66,2]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let P=class{constructor(T,F,D){this._logService=F,this._extHostFileSystem=D,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getWorkspaceStorageURI(T){return S.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,F=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:S.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(T){if(this._value)return S.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return S.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Be([Fe(0,t.IExtHostInitDataService),Fe(1,k.ILogService),Fe(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(we[34],be([1,0,3,5,4,2,14,6,7,172,16,219,21,33,198,84,18,13]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class I{constructor(r,l,p,d){this._proxy=r,this._id=l,this._creationOptions=p,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},get state(){return v._state},sendText(R,O=!0){v._checkDisposed(),v._proxy.$sendText(v._id,R,O)},show(R){v._checkDisposed(),v._proxy.$show(v._id,R)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(r,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,w.withNullAsUndefined)(r.shellPath),shellArgs:(0,w.withNullAsUndefined)(r.shellArgs),cwd:(0,w.withNullAsUndefined)(r.cwd),env:(0,w.withNullAsUndefined)(r.env),icon:(0,w.withNullAsUndefined)(o(r.iconPath)),color:u.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,w.withNullAsUndefined)(r.message),strictEnv:(0,w.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(r.location,l?.resolvedExtHostIdentifier),isTransient:(0,w.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,l,p,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:u.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(r,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(r,l){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in r?{viewColumn:r.viewColumn,preserveFocus:r.preserveFocus}:void 0:r}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitCode(r){this._exitStatus=Object.freeze({code:r})}setDimensions(r,l){return r===this._cols&&l===this._rows||r===0||l===0?!1:(this._cols=r,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=I;class a{constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new h.Emitter,this._onDidChangeProperty=new h.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput?.(r)}resize(r,l){this._pty.setDimensions?.({columns:r,rows:l})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(r||void 0),r&&this._pty.setDimensions?.(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let c=1,m=class extends P.Disposable{constructor(r,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[p,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,l){const p=new I(this._proxy,(0,E.generateUuid)(),r,r.name),d=new a(r.pty);return p.createExtensionTerminal(r.location,this._serializeParentTerminal(r,l).resolvedExtHostIdentifier,o(r.iconPath),n(r.color)).then(v=>{const R=this._setupExtHostProcessListeners(v,d);this._terminalProcessDisposables[v]=R}),this._terminals.push(p),p.value}_serializeParentTerminal(r,l){if(l=l||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const p=r.location.parentTerminal;if(p){const d=this._terminals.find(v=>v.value===p);d&&(l.resolvedExtHostIdentifier=d._id)}}else r.location&&typeof r.location!="object"?l.location=r.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(r,l){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const d=new a(l),v=this._setupExtHostProcessListeners(r,d);this._terminalProcessDisposables[r]=v}async $acceptActiveTerminalChanged(r){const l=this._activeTerminal;if(r===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(r);p&&(this._activeTerminal=p,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,l){const p=this._getTerminalById(r);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:l})}async $acceptTerminalDimensions(r,l,p){const d=this._getTerminalById(r);d&&d.setDimensions(l,p)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(r,l,p){this._terminalProcesses.get(r)?.resize(l,p)}async $acceptTerminalTitleChange(r,l){const p=this._getTerminalById(r);p&&(p.name=l)}async $acceptTerminalClosed(r,l){const p=this._getTerminalObjectIndexById(this._terminals,r);if(p!==null){const d=this._terminals.splice(p,1)[0];d.setExitCode(l),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(r,l,p,d){if(l){const O=this._getTerminalObjectIndexById(this._terminals,l);if(O!==null){this._terminals[O]._id=r,this._onDidOpenTerminal.fire(this.terminals[O]),this._terminals[O].isOpen=!0;return}}const v={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:A.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},R=new I(this._proxy,r,v,p);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(r,l){const p=this._getTerminalById(r);p&&p._setProcessId(l)}async $startExtensionTerminal(r,l){const p=this._getTerminalById(r);if(!p)return{message:(0,T.localize)(0,null,r)};p.isOpen||await new Promise(v=>{const R=this.onDidOpenTerminal(async O=>{O===p.value&&(R.dispose(),v())})});const d=this._terminalProcesses.get(r);d?d.startSendingEvents(l):this._extensionTerminalAwaitingStart[r]={initialDimensions:l}}_setupExtHostProcessListeners(r,l){const p=new P.DisposableStore;p.add(l.onProcessReady(v=>this._proxy.$sendProcessReady(r,v.pid,v.cwd))),p.add(l.onDidChangeProperty(v=>this._proxy.$sendProcessProperty(r,v))),this._bufferer.startBuffering(r,l.onProcessData),p.add(l.onProcessExit(v=>this._onProcessExit(r,v))),this._terminalProcesses.set(r,l);const d=this._extensionTerminalAwaitingStart[r];return d&&l instanceof a&&(l.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),p}$acceptProcessAckDataEvent(r,l){this._terminalProcesses.get(r)?.acknowledgeDataEvent(l)}$acceptProcessInput(r,l){this._terminalProcesses.get(r)?.input(l)}$acceptTerminalInteraction(r){const l=this._getTerminalById(r);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(r,l,p){try{this._terminalProcesses.get(r)?.resize(l,p)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(r,l){this._terminalProcesses.get(r)?.shutdown(l)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(r,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(l=>this._proxy.$sendProcessProperty(r,{type:"cwd",value:l}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,l,p){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,p),this._proxy.$registerProfileProvider(l,r.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(r,l){const p=new g.CancellationTokenSource().token;let d=await this._profileProviders.get(r)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,l);return}this.createTerminalFromOptions(d.options,l)}}async $provideLinks(r,l){const p=this._getTerminalById(r);if(!p)return[];this._terminalLinkCache.delete(r);const d=this._terminalLinkCancellationSource.get(r);d&&d.dispose(!0);const v=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,v);const R=[],O={terminal:p.value,line:l},L=[];for(const M of this._linkProviders)L.push(y.Promises.withAsyncBody(async q=>{v.token.onCancellationRequested(()=>q({provider:M,links:[]}));const K=await M.provideTerminalLinks(O,v.token)||[];v.token.isCancellationRequested||q({provider:M,links:K})}));const _=await Promise.all(L);if(v.token.isCancellationRequested)return[];const U=new Map;for(const M of _)M&&M.links.length>0&&R.push(...M.links.map(q=>{const K={id:c++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return U.set(K.id,{provider:M.provider,link:q}),K}));return this._terminalLinkCache.set(r,U),R}$activateLink(r,l){const p=this._terminalLinkCache.get(r)?.get(l);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(r,l){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const p=this._terminalProcessDisposables[r];p&&(p.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,l)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,l){const p=this._getTerminalObjectIndexById(r,l);return p!==null?r[p]:null}_getTerminalObjectIndexById(r,l){let p=null;return r.some((d,v)=>d._id===l?(p=v,!0):!1),p}getEnvironmentVariableCollection(r){let l=this._environmentVariableCollections.get(r.identifier.value);return l||(l=new s,this._setEnvironmentVariableCollection(r.identifier.value,l)),l}_syncEnvironmentVariableCollection(r,l){const p=(0,D.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(r,l.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(r){r.forEach(l=>{const p=l[0],d=new s(l[1]);this._setEnvironmentVariableCollection(p,d)})}$acceptDefaultProfile(r,l){this._defaultProfile=r,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(r,l){this._environmentVariableCollections.set(r,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,l)})}};m=Be([Fe(1,S.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class s{constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(r)}get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(r,l){this._setIfDiffers(r,{value:l,type:C.EnvironmentVariableMutatorType.Replace})}append(r,l){this._setIfDiffers(r,{value:l,type:C.EnvironmentVariableMutatorType.Append})}prepend(r,l){this._setIfDiffers(r,{value:l,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,l){const p=this.map.get(r);(!p||p.value!==l.value||p.type!==l.type)&&(this.map.set(r,l),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,l){this.map.forEach((p,d)=>r.call(l,d,p,this))}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let b=class extends m{constructor(r){super(!1,r)}createTerminal(r,l,p){throw new F.NotSupportedError}createTerminalFromOptions(r,l){throw new F.NotSupportedError}};b=Be([Fe(0,S.IExtHostRpcService)],b),e.WorkerExtHostTerminalService=b;function o(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function n(i){return u.ThemeColor.isThemeColor(i)?i:void 0}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[254],be([1,0,17,23,21,3,75,58,6,25,18,33,5,14,63,15,7,225,87,88]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let m=class{constructor(O,L){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=O.getProxy(g.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new b(this.proxy),L.registerArgumentProcessor({processArgument:_=>_?.$mid===13?u.TestItem.toItemFromContext(_):_})}createTestController(O,L,_){if(this.controllers.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const U=new C.DisposableStore,M=U.add(new y.SingleUseTestCollection(O));M.root.label=L;const q=new Map,K=this.proxy,x={items:M.root.children,get label(){return L},set label(G){L=G,M.root.label=G,K.$updateController(O,{label:L})},get refreshHandler(){return _},set refreshHandler(G){_=G,K.$updateController(O,{canRefresh:!!G})},get id(){return O},createRunProfile:(G,X,V,Z,se)=>{let ce=(0,P.hash)(G);for(;q.has(ce);)ce++;const ee=new d(this.proxy,O,ce,G,X,V,Z,se);return q.set(ce,ee),ee},createTestItem(G,X,V){return new f.TestItemImpl(O,G,X,V)},createTestRun:(G,X,V=!0)=>this.runTracker.createTestRun(O,M,G,X,V),set resolveHandler(G){M.resolveHandler=G},get resolveHandler(){return M.resolveHandler},dispose:()=>{U.dispose()}};K.$registerTestController(O,L,!!_),U.add((0,C.toDisposable)(()=>K.$unregisterTestController(O)));const B={controller:x,collection:M,profiles:q};return this.controllers.set(O,B),U.add((0,C.toDisposable)(()=>this.controllers.delete(O))),U.add(M.onDidGenerateDiff(G=>K.$publishDiff(O,G))),x}createTestObserver(){return this.observer.checkout()}async runTests(O,L=k.CancellationToken.None){const _=o(O);if(!_)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(_.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(M=>M.id)??[U.collection.root.id],profileGroup:v[_.kind],profileId:_.profileId,controllerId:_.controllerId}],exclude:O.exclude?.map(M=>M.id)},L)}$provideFileCoverage(O,L,_){return(0,h.mapFind)(this.runTracker.trackers,M=>M.id===O?M.getCoverage(L):void 0)?.provideFileCoverage(_)??Promise.resolve([])}$resolveFileCoverage(O,L,_,U){return(0,h.mapFind)(this.runTracker.trackers,q=>q.id===O?q.getCoverage(L):void 0)?.resolveFileCoverage(_,U)??Promise.resolve([])}$configureRunProfile(O,L){this.controllers.get(O)?.profiles.get(L)?.configureHandler?.()}async $refreshTests(O,L){await this.controllers.get(O)?.controller.refreshHandler?.(L)}$publishTestResults(O){this.results=Object.freeze(O.map(L=>(0,T.deepFreeze)(u.TestResults.to(L))).concat(this.results).sort((L,_)=>_.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(O,L){const _=this.controllers.get(a.TestId.fromString(O).controllerId)?.collection;_&&(await _.expand(O,L<0?1/0:L),_.flushDiff())}$acceptDiff(O){this.observer.applyDiff(O)}async $runControllerTests(O,L){const _=this.controllers.get(O.controllerId);if(!_)return;const{collection:U,profiles:M}=_,q=M.get(O.profileId);if(!q)return;const K=O.testIds.map(X=>U.tree.get(X)).filter(F.isDefined),x=O.excludeExtIds.map(X=>_.collection.tree.get(X)).filter(F.isDefined).filter(X=>K.some(V=>V.fullId.compare(X.fullId)===2));if(!K.length)return;const B=new w.TestRunRequest(K.some(X=>X.actual instanceof f.TestItemRootImpl)?void 0:K.map(X=>X.actual),x.map(X=>X.actual),q),G=this.runTracker.prepareForMainThreadTestRun(B,n.fromInternal(O,_.collection),L);try{await q.runHandler(B,L)}finally{G.isRunning&&!L.isCancellationRequested&&await A.Event.toPromise(G.onEnd),G.dispose()}}$cancelExtensionTestRun(O){O===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(O)}};m=Be([Fe(0,E.IExtHostRpcService)],m),e.ExtHostTesting=m;class s extends C.Disposable{constructor(O,L,_){super();this.dto=O,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(_)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(O){return this.tasks.get(O)?.coverage}createRun(O){const L=this.dto.id,_=this.dto.controllerId,U=(0,D.generateUuid)(),M=new i(this.proxy,L,U),q=G=>(X,...V)=>{if(x){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(X)||(this.ensureTestIsKnown(X),G(X,...V))},K=(G,X)=>{const V=X instanceof Array?X.map(u.TestMessage.from):[u.TestMessage.from(X)];if(G.uri&&G.range){const Z={range:u.Range.from(G.range),uri:G.uri};for(const se of V)se.location=se.location||Z}this.proxy.$appendTestMessagesInRun(L,U,a.TestId.fromExtHostTestItem(G,_).toString(),V)};let x=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:O,get coverageProvider(){return M.coverageProvider},set coverageProvider(G){M.coverageProvider=G},enqueued:q(G=>{this.proxy.$updateTestStateInRun(L,U,a.TestId.fromExtHostTestItem(G,_).toString(),1)}),skipped:q(G=>{this.proxy.$updateTestStateInRun(L,U,a.TestId.fromExtHostTestItem(G,_).toString(),5)}),started:q(G=>{this.proxy.$updateTestStateInRun(L,U,a.TestId.fromExtHostTestItem(G,_).toString(),2)}),errored:q((G,X,V)=>{K(G,X),this.proxy.$updateTestStateInRun(L,U,a.TestId.fromExtHostTestItem(G,_).toString(),6,V)}),failed:q((G,X,V)=>{K(G,X),this.proxy.$updateTestStateInRun(L,U,a.TestId.fromExtHostTestItem(G,_).toString(),4,V)}),passed:q((G,X)=>{this.proxy.$updateTestStateInRun(L,U,a.TestId.fromExtHostTestItem(G,this.dto.controllerId).toString(),3,X)}),appendOutput:(G,X,V)=>{x||(V&&(this.dto.isIncluded(V)?this.ensureTestIsKnown(V):V=void 0),this.proxy.$appendOutputToRun(L,U,t.VSBuffer.fromString(G),X&&u.location.from(X),V&&a.TestId.fromExtHostTestItem(V,_).toString()))},end:()=>{x||(x=!0,this.proxy.$finishedTestRunTask(L,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:B,coverage:M}),this.proxy.$startedTestRunTask(L,{id:U,name:O,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(O){if(!(O instanceof f.TestItemImpl))throw new f.InvalidTestItemError(O.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(O,this.dto.controllerId).toString()))return;const L=[],_=this.dto.colllection.root;for(;;){const U=u.TestItem.from(O);if(L.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),O===_))break;O=O.parent||_}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class b{constructor(O){this.proxy=O,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(O,L,_){return this.getTracker(O,L,_)}cancelRunById(O){for(const L of this.tracked.values())if(L.id===O){L.dispose();return}}cancelAllRuns(){for(const O of this.tracked.values())O.dispose()}createTestRun(O,L,_,U,M){const q=this.tracked.get(_);if(q)return q.createRun(U);const K=n.fromPublic(O,L,_,M),x=o(_);this.proxy.$startedExtensionTestRun({controllerId:O,profile:x&&{group:v[x.kind],id:x.profileId},exclude:_.exclude?.map(G=>G.id)??[],id:K.id,include:_.include?.map(G=>G.id)??[L.root.id],persist:M});const B=this.getTracker(_,K);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),B.createRun(U)}getTracker(O,L,_){const U=new s(L,this.proxy,_);return this.tracked.set(O,U),U.onEnd(()=>this.tracked.delete(O)),U}}e.TestRunCoordinator=b;const o=R=>{if(!!R.profile){if(!(R.profile instanceof d))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class n{constructor(O,L,_,U,M,q){this.controllerId=O,this.id=L,this.isPersisted=M,this.colllection=q,this.includePrefix=_.map(K=>K+"\0"),this.excludePrefix=U.map(K=>K+"\0")}static fromPublic(O,L,_,U){return new n(O,(0,D.generateUuid)(),_.include?.map(M=>a.TestId.fromExtHostTestItem(M,O).toString())??[O],_.exclude?.map(M=>a.TestId.fromExtHostTestItem(M,O).toString())??[],U,L)}static fromInternal(O,L){return new n(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,L)}isIncluded(O){const L=a.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const _ of this.excludePrefix)if(L===_||L.startsWith(_))return!1;for(const _ of this.includePrefix)if(L===_||L.startsWith(_))return!0;return!1}}e.TestRunDto=n;class i{constructor(O,L,_){this.proxy=O,this.runId=L,this.taskId=_}set coverageProvider(O){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this._coverageProvider=O,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(O){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(O))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(O,L){const _=await this.fileCoverage;let U=_?.[O];return!this._coverageProvider||!_||!U?[]:(U.detailedCoverage||(U=_[O]=await this._coverageProvider.resolveFileCoverage?.(U,L)??U),U.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class r extends I.IncrementalChangeCollector{constructor(O){super();this.emitter=O,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(O){this.added.add(O)}update(O){Object.assign(O.revived,u.TestItem.toPlain(O.item)),this.added.has(O)||this.updated.add(O)}remove(O){if(this.added.has(O)){this.added.delete(O);return}if(this.updated.delete(O),O.parent&&this.alreadyRemoved.has(O.parent)){this.alreadyRemoved.add(O.item.extId);return}this.removed.add(O)}getChangeEvent(){const{added:O,updated:L,removed:_}=this;return{get added(){return[...O].map(U=>U.revived)},get updated(){return[...L].map(U=>U.revived)},get removed(){return[..._].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends I.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(O){return this.items.get(O)}getMirroredTestDataByReference(O){return this.items.get(O.id)}createItem(O,L){return{...O,revived:u.TestItem.toPlain(O.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new r(this.changeEmitter)}}e.MirroredTestCollection=l;class p{constructor(O){this.proxy=O}checkout(){this.current||(this.current=this.createObserverData());const O=this.current;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(L=>L.revived)},dispose:(0,S.once)(()=>{--O.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(O){return this.current?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.current?.tests.apply(O)}createObserverData(){const O=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:O}}}class d{constructor(O,L,_,U,M,q,K=!1,x=void 0){this.controllerId=L,this.profileId=_,this._label=U,this.kind=M,this.runHandler=q,this._isDefault=K,this._tag=x,c.set(this,void 0),Ke(this,c,O,"f");const B=v[M];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${M}`);Te(this,c,"f").$publishTestRunProfile({profileId:_,controllerId:L,tag:x?u.TestTag.namespace(this.controllerId,x.id):null,label:U,group:B,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(O){O!==this._label&&(this._label=O,Te(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get isDefault(){return this._isDefault}set isDefault(O){O!==this._isDefault&&(this._isDefault=O,Te(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Te(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?u.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(O){O!==this._configureHandler&&(this._configureHandler=O,Te(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}dispose(){Te(this,c,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=d,c=new WeakMap;const v={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(we[255],be([1,0,3,17,5,132,15,7]),function(te,e,h,t,k,A,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(F,D){this._extHostDocumentsAndEditors=D,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const D=this._extHostDocumentsAndEditors.allEditors();return F?D:D.map(g=>g.value)}async showTextDocument(F,D,g){let E;typeof D=="number"?E={position:S.ViewColumn.from(D),preserveFocus:g}:typeof D=="object"?E={position:S.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?S.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:E={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(F.uri,E),u=f&&this._extHostDocumentsAndEditors.getEditor(f);if(u)return u.value;throw f?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,D){return new A.TextEditorDecorationType(this._proxy,F,D).value}$acceptEditorPropertiesChanged(F,D){const g=this._extHostDocumentsAndEditors.getEditor(F);if(!g)throw new Error("unknown text editor");if(D.options&&g._acceptOptions(D.options),D.selections){const E=D.selections.selections.map(S.Selection.to);g._acceptSelections(E)}if(D.visibleRanges){const E=t.coalesce(D.visibleRanges.map(S.Range.to));g._acceptVisibleRanges(E)}if(D.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:{...D.options,lineNumbers:S.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const E=P.TextEditorSelectionChangeKind.fromValue(D.selections.source),f=D.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:f,kind:E})}if(D.visibleRanges){const E=t.coalesce(D.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:E})}}$acceptEditorPositionData(F){for(const D in F){const g=this._extHostDocumentsAndEditors.getEditor(D);if(!g)throw new Error("Unknown text editor");const E=S.ViewColumn.to(F[D]);g.value.viewColumn!==E&&(g._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:E}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=C}),define(we[256],be([1,0,2,4,5,6,7]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class P{constructor(F,D){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(k.MainContext.MainThreadTimeline),D.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===11){const E=g.uri===void 0?void 0:h.URI.revive(g.uri);return this._itemsBySourceAndUriMap.get(g.source)?.get(C(E))?.get(g.handle)}return g}})}async $getTimeline(F,D,g,E,f){return this._providers.get(F)?.provideTimeline(h.URI.revive(D),g,E,f)}registerTimelineProvider(F,D,g,E){const f=new A.DisposableStore,u=this.convertTimelineItem(D.id,E,f).bind(this);let w;D.onDidChange&&(w=D.onDidChange(I=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...I,id:D.id}),this));const y=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...D,scheme:F,onDidChange:void 0,async provideTimeline(I,a,c,m){m?.resetCache&&(f.clear(),y.get(D.id)?.clear());const s=await D.provideTimeline(I,a,c);if(s==null)return;const b=u(I,m);return{...s,source:D.id,items:s.items.map(b)}},dispose(){for(const I of y.values())I.get(D.id)?.clear();w?.dispose(),f.dispose()}})}convertTimelineItem(F,D,g){return(E,f)=>{let u;if(f?.cacheResults){let w=this._itemsBySourceAndUriMap.get(F);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(F,w));const y=C(E);u=w.get(y),u===void 0&&(u=new Map,w.set(y,u))}return w=>{const{iconPath:y,...I}=w,a=`${F}|${w.id??w.timestamp}`;u?.set(a,w);let c,m,s;return w.iconPath&&(y instanceof S.ThemeIcon?s={id:y.id,color:y.color}:h.URI.isUri(y)?(c=y,m=y):{light:c,dark:m}=y),{...I,id:I.id??void 0,handle:a,source:F,command:w.command?D.toInternal(w.command,g):void 0,icon:c,iconDark:m,themeIcon:s,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,A.toDisposable)(()=>{for(const g of this._itemsBySourceAndUriMap.values())g.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=P;function C(T){return T?.toString()}}),define(we[257],be([1,0,6,10,2,5]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(C){this._openers=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,T,F,D){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const g=D.schemes.find(E=>!S.supportedSchemes.has(E));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,F),this._proxy.$registerUriOpener(T,D.schemes,C,D.label),(0,h.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(C,T,F){const D=this._openers.get(C);if(!D)throw new Error(`Unknown opener with id: ${C}`);const g=k.URI.revive(T);return D.canOpenExternalUri(g,F)}async $openUri(C,T,F){const D=this._openers.get(C);if(!D)throw new Error(`Unknown opener id: '${C}'`);return D.openExternalUri(k.URI.revive(T.resolvedUri),{sourceUri:k.URI.revive(T.sourceUri)},F)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(we[258],be([1,0,5,2,6,16,27]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(T,F){if(this.handles.has(S.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const D=P.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(T)),this.handlers.set(D,F),this._proxy.$registerUriHandler(D,T),(0,k.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(T)),this.handlers.delete(D),this._proxy.$unregisterUriHandler(D)})}$handleExternalUri(T,F){const D=this.handlers.get(T);if(!D)return Promise.resolve(void 0);try{D.handleUri(t.URI.revive(F))}catch(g){(0,A.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(T){return t.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=P,P.HandlePool=0});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[68],be([1,0,3,10,2,185,207,86,5]),function(te,e,h,t,k,A,S,P,C){"use strict";var T,F,D,g,E,f,u,w,y,I,a,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(p,d,v,R,O,L,_){T.set(this,void 0),F.set(this,void 0),D.set(this,void 0),g.set(this,void 0),E.set(this,void 0),f.set(this,void 0),u.set(this,""),w.set(this,void 0),y.set(this,!1),I.set(this,!1),a.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new h.Emitter),this._onDidDispose=Te(this,c,"f").event,Ke(this,T,p,"f"),Ke(this,F,d,"f"),Ke(this,w,v,"f"),Ke(this,g,R,"f"),Ke(this,E,O,"f"),Ke(this,f,L,"f"),Ke(this,a,s(L),"f"),Ke(this,D,_,"f")}dispose(){Ke(this,y,!0,"f"),Te(this,c,"f").fire(),Te(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return Ke(this,I,!0,"f"),(0,P.asWebviewUri)(p,Te(this,g,"f").remote)}get cspSource(){const p=Te(this,f,"f").extensionLocation;if(p.scheme===t.Schemas.https||p.scheme===t.Schemas.http){let d=p.toString();return d.endsWith("/")||(d+="/"),d+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,u,"f")}set html(p){this.assertNotDisposed(),Te(this,u,"f")!==p&&(Ke(this,u,p,"f"),!Te(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(Ke(this,I,!0,"f"),Te(this,D,"f").report("Webview vscode-resource: uris",Te(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,F,"f").$setHtml(Te(this,T,"f"),p))}get options(){return this.assertNotDisposed(),Te(this,w,"f")}set options(p){this.assertNotDisposed(),Te(this,F,"f").$setOptions(Te(this,T,"f"),n(Te(this,f,"f"),Te(this,E,"f"),p)),Ke(this,w,p,"f")}async postMessage(p){if(Te(this,y,"f"))return!1;const d=(0,S.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Te(this,a,"f")});return Te(this,F,"f").$postMessage(Te(this,T,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Te(this,y,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,T=new WeakMap,F=new WeakMap,D=new WeakMap,g=new WeakMap,E=new WeakMap,f=new WeakMap,u=new WeakMap,w=new WeakMap,y=new WeakMap,I=new WeakMap,a=new WeakMap,c=new WeakMap;function s(l){try{const p=(0,A.normalizeVersion)((0,A.parseVersion)(l.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class b{constructor(p,d,v,R,O){this.initData=d,this.workspace=v,this._logService=R,this._deprecationService=O,this._webviews=new Map,this._webviewProxy=p.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(p,d,v){const R=this.getWebview(p);if(R){const{message:O}=(0,S.deserializeWebviewMessage)(d,v.value);R._onMessageEmitter.fire(O)}}$onMissingCsp(p,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,d,v){const R=new m(p,this._webviewProxy,i(d),this.initData,this.workspace,v,this._deprecationService);return this._webviews.set(p,R),R._onDidDispose(()=>{this._webviews.delete(p)}),R}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=b;function o(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=o;function n(l,p,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||r(l,p)}}e.serializeWebviewOptions=n;function i(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(p=>k.URI.from(p))}}e.reviveOptions=i;function r(l,p){return[...(p?.getWorkspaceFolders()||[]).map(d=>d.uri),l.extensionLocation]}}),define(we[259],be([1,0,21,58,6,10,22,2,15,68,85,5,7]),function(te,e,h,t,k,A,S,P,C,T,F,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(s,b){this.document=s,this._storagePath=b,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,b){await this.getEdit(s).undo(),b||this.disposeBackup()}async redo(s,b){await this.getEdit(s).redo(),b||this.disposeBackup()}disposeEdits(s){for(const b of s)this._edits.delete(b)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=c(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const b=this._edits.get(s,0);if(!b)throw new Error("No edit found");return b}}class f{constructor(){this._documents=new Map}get(s,b){return this._documents.get(this.key(s,b))}add(s,b,o){const n=this.key(s,b.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${s} resource:${b.uri}`);const i=new E(b,o);return this._documents.set(n,i),i}delete(s,b){const o=this.key(s,b.uri);this._documents.delete(o)}key(s,b){return`${s}@@@${b}`}}var u;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(u||(u={}));class w{constructor(){this._providers=new Map}addTextProvider(s,b,o){return this.add(0,s,b,o)}addCustomProvider(s,b,o){return this.add(1,s,b,o)}get(s){return this._providers.get(s)}add(s,b,o,n){if(this._providers.has(b))throw new Error(`Provider for viewType:${b} already registered`);return this._providers.set(b,{type:s,extension:o,provider:n}),new g.Disposable(()=>this._providers.delete(b))}}class y{constructor(s,b,o,n,i){this._extHostDocuments=b,this._extensionStoragePaths=o,this._extHostWebview=n,this._extHostWebviewPanels=i,this._editorProviders=new w,this._documents=new f,this._proxy=s.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,b,o,n){const i=new k.DisposableStore;return I(o)?(i.add(this._editorProviders.addTextProvider(b,s,o)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(s),b,n.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(s))):(i.add(this._editorProviders.addCustomProvider(b,s,o)),this.supportEditing(o)&&i.add(o.onDidChangeCustomDocument(r=>{const l=this.getCustomDocumentEntry(b,r.document.uri);if(a(r)){const p=l.addEdit(r);this._proxy.$onDidEdit(r.document.uri,b,p,r.label)}else this._proxy.$onContentChange(r.document.uri,b)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(s),b,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(s))),g.Disposable.from(i,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(b)}))}async $createCustomDocument(s,b,o,n,i){const r=this._editorProviders.get(b);if(!r)throw new Error(`No provider found for '${b}'`);if(r.type!==1)throw new Error(`Invalid provide type for '${b}'`);const l=P.URI.revive(s),p=await r.provider.openCustomDocument(l,{backupId:o,untitledDocumentData:n?.buffer},i);let d;return this.supportEditing(r.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension)),this._documents.add(b,p,d),{editable:this.supportEditing(r.provider)}}async $disposeCustomDocument(s,b){const o=this._editorProviders.get(b);if(!o)throw new Error(`No provider found for '${b}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${b}'`);const n=P.URI.revive(s),{document:i}=this.getCustomDocumentEntry(b,n);this._documents.delete(b,i),i.dispose()}async $resolveWebviewEditor(s,b,o,n,i,r){const l=this._editorProviders.get(o);if(!l)throw new Error(`No provider found for '${o}'`);const p=C.ViewColumn.to(i),d=this._extHostWebview.createNewWebview(b,n.webviewOptions,l.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(b,o,n.title,p,n.panelOptions,d),R=P.URI.revive(s);switch(l.type){case 1:{const{document:O}=this.getCustomDocumentEntry(o,R);return l.provider.resolveCustomEditor(O,v,r)}case 0:{const O=this._extHostDocuments.getDocument(R);return l.provider.resolveCustomTextEditor(O,v,r)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,b,o){this.getCustomDocumentEntry(b,s).disposeEdits(o)}async $onMoveCustomEditor(s,b,o){const n=this._editorProviders.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const i=this._extHostWebviewPanels.getWebviewPanel(s);if(!i)throw new Error("No webview found");const r=P.URI.revive(b),l=this._extHostDocuments.getDocument(r);await n.provider.moveCustomTextEditor(l,i,h.CancellationToken.None)}async $undo(s,b,o,n){return this.getCustomDocumentEntry(b,s).undo(o,n)}async $redo(s,b,o,n){return this.getCustomDocumentEntry(b,s).redo(o,n)}async $revert(s,b,o){const n=this.getCustomDocumentEntry(b,s);await this.getCustomEditorProvider(b).revertCustomDocument(n.document,o),n.disposeBackup()}async $onSave(s,b,o){const n=this.getCustomDocumentEntry(b,s);await this.getCustomEditorProvider(b).saveCustomDocument(n.document,o),n.disposeBackup()}async $onSaveAs(s,b,o,n){const i=this.getCustomDocumentEntry(b,s);return this.getCustomEditorProvider(b).saveCustomDocumentAs(i.document,P.URI.revive(o),n)}async $backup(s,b,o){const n=this.getCustomDocumentEntry(b,s),r=await this.getCustomEditorProvider(b).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},o);return n.updateBackup(r),r.id}getCustomDocumentEntry(s,b){const o=this._documents.get(s,P.URI.revive(b));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(s){const o=this._editorProviders.get(s)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=y;function I(m){return typeof m.resolveCustomTextEditor=="function"}function a(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function c(m){const s=m.scheme===A.Schemas.file||m.scheme===A.Schemas.untitled?m.fsPath:m.toString();return(0,t.hash)(s)+""}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[260],be([1,0,3,6,2,33,15,68,5,7]),function(te,e,h,t,k,A,S,P,C,T){"use strict";var F,D,g,E,f,u,w,y,I,a,c,m,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class b extends t.Disposable{constructor(r,l,p,d,v,R,O){super();F.set(this,void 0),D.set(this,void 0),g.set(this,void 0),E.set(this,void 0),f.set(this,void 0),u.set(this,void 0),w.set(this,void 0),y.set(this,void 0),I.set(this,!0),a.set(this,!0),c.set(this,!1),m.set(this,this._register(new h.Emitter)),this.onDidDispose=Te(this,m,"f").event,s.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Te(this,s,"f").event,Ke(this,F,r,"f"),Ke(this,D,l,"f"),Ke(this,g,p,"f"),Ke(this,f,R,"f"),Ke(this,y,v,"f"),Ke(this,u,d,"f"),Ke(this,E,O,"f")}dispose(){Te(this,c,"f")||(Ke(this,c,!0,"f"),Te(this,m,"f").fire(),Te(this,D,"f").$disposeWebview(Te(this,F,"f")),Te(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,E,"f")}get viewType(){return this.assertNotDisposed(),Te(this,g,"f")}get title(){return this.assertNotDisposed(),Te(this,u,"f")}set title(r){this.assertNotDisposed(),Te(this,u,"f")!==r&&(Ke(this,u,r,"f"),Te(this,D,"f").$setTitle(Te(this,F,"f"),r))}get iconPath(){return this.assertNotDisposed(),Te(this,w,"f")}set iconPath(r){this.assertNotDisposed(),Te(this,w,"f")!==r&&(Ke(this,w,r,"f"),Te(this,D,"f").$setIconPath(Te(this,F,"f"),k.URI.isUri(r)?{light:r,dark:r}:r))}get options(){return Te(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,y,"f")=="number"&&Te(this,y,"f")<0))return Te(this,y,"f")}get active(){return this.assertNotDisposed(),Te(this,a,"f")}get visible(){return this.assertNotDisposed(),Te(this,I,"f")}_updateViewState(r){Te(this,c,"f")||(this.active!==r.active||this.visible!==r.visible||this.viewColumn!==r.viewColumn)&&(Ke(this,a,r.active,"f"),Ke(this,I,r.visible,"f"),Ke(this,y,r.viewColumn,"f"),Te(this,s,"f").fire({webviewPanel:this}))}reveal(r,l){this.assertNotDisposed(),Te(this,D,"f").$reveal(Te(this,F,"f"),{viewColumn:typeof r=="undefined"?void 0:S.ViewColumn.from(r),preserveFocus:!!l})}assertNotDisposed(){if(Te(this,c,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,D=new WeakMap,g=new WeakMap,E=new WeakMap,f=new WeakMap,u=new WeakMap,w=new WeakMap,y=new WeakMap,I=new WeakMap,a=new WeakMap,c=new WeakMap,m=new WeakMap,s=new WeakMap;class o{constructor(r,l,p){this.webviews=l,this.workspace=p,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(r,l,p,d,v={}){const R=typeof d=="object"?d.viewColumn:d,O={viewColumn:S.ViewColumn.from(R),preserveFocus:typeof d=="object"&&!!d.preserveFocus},L=(0,P.shouldSerializeBuffersForPostMessage)(r),_=o.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(r),_,l,{title:p,panelOptions:n(v),webviewOptions:(0,P.serializeWebviewOptions)(r,this.workspace,v),serializeBuffersForPostMessage:L},O);const U=this.webviews.createNewWebview(_,v,r);return this.createNewWebviewPanel(_,l,p,R,v,U)}$onDidChangeWebviewPanelViewStates(r){const l=Object.keys(r);l.sort((p,d)=>{const v=r[p],R=r[d];return v.active?1:R.active?-1:+v.visible-+R.visible});for(const p of l){const d=this.getWebviewPanel(p);if(!d)continue;const v=r[p];d._updateViewState({active:v.active,visible:v.visible,viewColumn:S.ViewColumn.to(v.position)})}}async $onDidDisposeWebviewPanel(r){this.getWebviewPanel(r)?.dispose(),this._webviewPanels.delete(r),this.webviews.deleteWebview(r)}registerWebviewPanelSerializer(r,l,p){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:p,extension:r}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(r)}),new T.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(r,l,p,d){const v=this._serializers.get(l);if(!v)throw new Error(`No serializer found for '${l}'`);const{serializer:R,extension:O}=v,L=this.webviews.createNewWebview(r,p.webviewOptions,O),_=this.createNewWebviewPanel(r,l,p.title,d,p.panelOptions,L);await R.deserializeWebviewPanel(_,p.state)}createNewWebviewPanel(r,l,p,d,v,R){const O=new b(r,this._proxy,l,p,d,v,R);return this._webviewPanels.set(r,O),O}getWebviewPanel(r){return this._webviewPanels.get(r)}}e.ExtHostWebviewPanels=o;function n(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[261],be([1,0,3,6,68,5,7]),function(te,e,h,t,k,A,S){"use strict";var P,C,T,F,D,g,E,f,u,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends t.Disposable{constructor(c,m,s,b,o,n){super();P.set(this,void 0),C.set(this,void 0),T.set(this,void 0),F.set(this,void 0),D.set(this,!1),g.set(this,void 0),E.set(this,void 0),f.set(this,void 0),u.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Te(this,u,"f").event,w.set(this,this._register(new h.Emitter)),this.onDidDispose=Te(this,w,"f").event,Ke(this,T,s,"f"),Ke(this,E,b,"f"),Ke(this,P,c,"f"),Ke(this,C,m,"f"),Ke(this,F,o,"f"),Ke(this,g,n,"f")}dispose(){Te(this,D,"f")||(Ke(this,D,!0,"f"),Te(this,w,"f").fire(),Te(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,E,"f")}set title(c){this.assertNotDisposed(),Te(this,E,"f")!==c&&(Ke(this,E,c,"f"),Te(this,C,"f").$setWebviewViewTitle(Te(this,P,"f"),c))}get description(){return this.assertNotDisposed(),Te(this,f,"f")}set description(c){this.assertNotDisposed(),Te(this,f,"f")!==c&&(Ke(this,f,c,"f"),Te(this,C,"f").$setWebviewViewDescription(Te(this,P,"f"),c))}get visible(){return Te(this,g,"f")}get webview(){return Te(this,F,"f")}get viewType(){return Te(this,T,"f")}_setVisible(c){c===Te(this,g,"f")||Te(this,D,"f")||(Ke(this,g,c,"f"),Te(this,u,"f").fire())}show(c){this.assertNotDisposed(),Te(this,C,"f").$show(Te(this,P,"f"),!!c)}assertNotDisposed(){if(Te(this,D,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,C=new WeakMap,T=new WeakMap,F=new WeakMap,D=new WeakMap,g=new WeakMap,E=new WeakMap,f=new WeakMap,u=new WeakMap,w=new WeakMap;class I{constructor(c,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,m,s,b){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:s,extension:c}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(c),m,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(c,m,s,b,o){const n=this._viewProviders.get(m);if(!n)throw new Error(`No view provider found for '${m}'`);const{provider:i,extension:r}=n,l=this._extHostWebview.createNewWebview(c,{},r),p=new y(c,this._proxy,m,s,l,!0);this._webviewViews.set(c,p),await i.resolveWebviewView(p,{state:b},o)}async $onDidChangeWebviewViewVisibility(c,m){this.getWebviewView(c)._setVisible(m)}async $disposeWebviewView(c){const m=this.getWebviewView(c);this._webviewViews.delete(c),m.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const m=this._webviewViews.get(c);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=I}),define(we[137],be([1,0,3,5,2,10,8,4,14]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class jn{constructor(D){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=jn.InitialState,this._proxy=D.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}get state(){return this._state}$onDidChangeWindowFocus(D){D!==this._state.focused&&(this._state={...this._state,focused:D},this._onDidChangeWindowState.fire(this._state))}openUri(D,g){let E;if(typeof D=="string"){E=D;try{D=k.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,S.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this._proxy.$openUri(D,E,g)}async asExternalUri(D,g){if((0,S.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(D,g);return k.URI.from(E)}};T.InitialState={focused:!0},T=Be([Fe(0,C.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(we[262],be([1,0,9,80,33,38,6,5,2,14]),function(te,e,h,t,k,A,S,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let F=class extends S.Disposable{constructor(g,E){super();const f=g.getProxy(P.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async u=>{const w=C.URI.file((0,h.join)((0,t.tmpdir)(),(0,k.generateUuid)()));return await f.$download(u,w),w})}};F=Be([Fe(0,T.IExtHostRpcService),Fe(1,A.IExtHostCommands)],F),e.ExtHostDownloadService=F}),define(we[263],be([1,0,135,10,191,33]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class S extends h.ExtHostLoggerService{doCreateLogger(C,T,F){return C.scheme===t.Schemas.file?new k.SpdLogLogger(F?.name||(0,A.generateUuid)(),C.fsPath,!F?.donotRotate,!!F?.donotUseFormatters,T):super.doCreateLogger(C,T,F)}}e.ExtHostLoggerService=S}),define(we[264],be([1,0,60,9,2,67,6,10,13,29]),function(te,e,h,t,k,A,S,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class F extends A.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(s){const b=await super._getWorkspaceStorageURI(s);if(b.scheme!==P.Schemas.file)return b;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${b.fsPath}.`),b;const o=b.fsPath;let n=0;do{let i;n===0?i=o:i=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${n}`:`${o}-${n}`,await D(i);const r=t.join(i,"vscode.lock"),l=await u(this._logService,r,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),k.URI.file(i);n++}while(n<10);return b}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=F;async function D(m){try{await T.Promises.stat(m);return}catch{}try{await T.Promises.mkdir(m,{recursive:!0})}catch{}}const g=1e3,E=10*60*1e3;class f extends S.Disposable{constructor(s,b){super();this.logService=s,this.filename=b,this._timer=this._register(new C.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await w(s,b);(!o||o.pid!==process.pid)&&(s.info(`Lock '${b}': The lock was lost unexpectedly.`),this._timer.cancel());try{await T.Promises.utimes(b,new Date,new Date)}catch(n){s.error(n),s.info(`Lock '${b}': Could not update mtime.`)}},g)}dispose(){super.dispose();try{h.unlinkSync(this.filename)}catch{}}async setWillRelease(s){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const b={pid:process.pid,willReleaseAt:Date.now()+s};await T.Promises.writeFile(this.filename,JSON.stringify(b),{flag:"w"})}catch(b){this.logService.error(b)}}}async function u(m,s,b){try{const n={pid:process.pid,willReleaseAt:0};await T.Promises.writeFile(s,JSON.stringify(n),{flag:"wx"})}catch(n){m.error(n)}const o=await w(m,s);return!o||o.pid!==process.pid?b?(m.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),a(m,s)):(m.info(`Lock '${s}': Lock acquired.`),new f(m,s))}async function w(m,s){let b;try{b=await T.Promises.readFile(s)}catch(o){return m.error(o),null}try{return JSON.parse(String(b))}catch(o){return m.error(o),null}}async function y(m,s){let b;try{b=await T.Promises.stat(s)}catch(o){return m.error(o),0}return b.mtime.getTime()}function I(m){try{return process.kill(m,0),!0}catch{return!1}}async function a(m,s){const b=await w(m,s);if(!b)return m.info(`Lock '${s}': Could not read pid of lock holder.`),c(m,s);if(b.willReleaseAt){let l=b.willReleaseAt-Date.now();if(l<5e3){for(l>0?m.info(`Lock '${s}': The lockfile is scheduled to be released in ${l} ms.`):m.info(`Lock '${s}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,C.timeout)(Math.min(100,l)),await y(m,s)===0)return c(m,s);l=b.willReleaseAt-Date.now()}return c(m,s)}}if(!I(b.pid))return m.info(`Lock '${s}': The pid ${b.pid} appears to be gone.`),c(m,s);const o=await y(m,s),n=Date.now()-o;if(n<=E)return m.info(`Lock '${s}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;m.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,C.timeout)(2e3);const i=await y(m,s),r=Date.now()-i;return r<=E?(m.info(`Lock '${s}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null):(m.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),c(m,s))}async function c(m,s){m.info(`Lock '${s}': Deleting a stale lock.`);try{await T.Promises.unlink(s)}catch{}return u(m,s,!0)}}),define(we[265],be([1,0,33,14,34]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends k.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,C,T){return this.createTerminalFromOptions({name:P,shellPath:C,shellArgs:T})}createTerminalFromOptions(P,C){const T=new k.ExtHostTerminal(this._proxy,(0,h.generateUuid)(),P,P.name);return this._terminals.push(T),T.create(P,this._serializeParentTerminal(P,C)),T.value}};A=Be([Fe(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(we[266],be([1,0,5,14,176,6,26,2,37,22,29,7,12,51,3,124,94,11]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class I{constructor(p,d,v){this.remoteAddress=p,this.localAddress=d,this._dispose=v,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function a(l){const p=l.trim().split(`
`),d=[];return p.forEach(R=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);O&&O.length>=3&&d.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),d.reduce((R,O)=>(R[O.socket]=O,R),{})}e.getSockets=a;function c(...l){const p=[].concat(...l.map(s));return[...new Map(p.filter(d=>d.st==="0A").map(d=>{const v=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:m(v[0]),port:parseInt(v[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=c;function m(l){let p="";if(l.length===8)for(let d=l.length-2;d>=0;d-=2)p+=parseInt(l.substr(d,2),16),d!==0&&(p+=".");else for(let d=l.length-4;d>=0;d-=4)p+=parseInt(l.substr(d,4),16).toString(16),d!==0&&(p+=":");return p}e.parseIpAddress=m;function s(l){const p=l.trim().split(`
`),d=p.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return p.map(R=>R.trim().split(/\s+/).reduce((O,L,_)=>(O[d[_]||_]=L,O),{}))}e.loadConnectionTable=s;function b(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/server-main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function o(l){const p=l.trim().split(`
`),d=[];return p.forEach(v=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(v);R&&R.length>=4&&d.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),d}e.getRootProcesses=o;async function n(l,p,d){const v=d.reduce((O,L)=>(O[L.pid]=L,O),{}),R=[];return l.forEach(({socket:O,ip:L,port:_})=>{const U=p[O]?p[O].pid:void 0,M=U?v[U]?.cmd:void 0;U&&M&&!b(M)&&R.push({host:L,port:_,detail:M,pid:U})}),R}e.findPorts=n;function i(l,p,d){const v=new Map,R=o(p);for(const O of l){const L=d.get(O.port);if(L){v.set(O.port,L);continue}const _=R.find(U=>U.cmd.includes(`${O.port}`));if(_){let U=_,M;do M=R.find(q=>q.ppid===U.pid),M&&(U=M);while(M);v.set(O.port,{host:O.ip,port:O.port,pid:U.pid,detail:U.cmd,ppid:U.ppid})}else v.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return v}e.tryFindRootPorts=i;let r=class extends A.Disposable{constructor(p,d,v){super();this.logService=v,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=p.getProxy(h.MainContext.MainThreadTunnelService),g.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(p,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const v=await this._proxy.$openTunnel(d,p.displayName);if(v){const R=new I(v.remoteAddress,v.localAddress,()=>this._proxy.$closeTunnel(v.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(p){return Math.max(p*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(p,d){const v=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(v,{selector:p,provider:d}),this._proxy.$registerPortsAttributesProvider(p,v),new D.Disposable(()=>{this._portAttributesProviders.delete(v),this._proxy.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(p,d,v,R,O){const L=[];for(const U of p){const M=this._portAttributesProviders.get(U);if(!M)return[];L.push(...await Promise.all(d.map(async q=>M.provider.providePortAttributes(q,v,R,O))))}const _=L.filter(U=>!!U);return _.length>0?_.map(U=>({autoForwardAction:U.autoForwardAction,port:U.port})):[]}async $registerCandidateFinder(p){if(p&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=p;let d=new w.MovingAverage,v;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),O=(await this.findCandidatePorts()).filter(_=>(0,u.isLocalhost)(_.host)||(0,u.isAllInterfaces)(_.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(_=>_.port).join(", ")}`);const L=new Date().getTime()-R;d.update(L),(!v||JSON.stringify(v)!==JSON.stringify(O))&&(v=O,await this._proxy.$onFoundNewCandidates(v)),await new Promise(_=>setTimeout(()=>_(),this.calculateDelay(d.value)))}}async setTunnelFactory(p){if(p){if(p.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this._showCandidatePort=p.showCandidatePort,this._proxy.$setCandidateFilter()),p.tunnelFactory){this._forwardPortProvider=p.tunnelFactory;let d=p.tunnelFeatures?.privacyOptions??[];p.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const v=p.tunnelFeatures?{elevation:!!p.tunnelFeatures?.elevation,public:!!p.tunnelFeatures?.public,privacyOptions:d}:void 0;this._proxy.$setTunnelProvider(v)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(p,d){if(this._extensionTunnels.has(p.host)){const v=this._extensionTunnels.get(p.host);v.has(p.port)&&(d&&v.get(p.port).disposeListener.dispose(),await v.get(p.port).tunnel.dispose(),v.delete(p.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(p,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this._forwardPortProvider(p,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const R=await v;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(p.remoteAddress.host)||this._extensionTunnels.set(p.remoteAddress.host,new Map);const O=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:R,disposeListener:O}),E.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(p){const d=await Promise.all(p.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),v=p.filter((R,O)=>d[O]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(R=>R.port).join(", ")} to ${v.map(R=>R.port).join(", ")}`),v}async findCandidatePorts(){let p="",d="";try{p=await F.Promises.readFile("/proc/net/tcp","utf8"),d=await F.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const v=c(p,d),R=await new Promise(x=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,G,X)=>{x(G)})}),O=a(R),L=await F.Promises.readdir("/proc"),_=[];for(let x of L)try{const B=Number(x),G=T.joinPath(P.URI.file("/proc"),x);if((await F.Promises.stat(G.fsPath)).isDirectory()&&!isNaN(B)){const V=await F.Promises.readlink(T.joinPath(G,"cwd").fsPath),Z=await F.Promises.readFile(T.joinPath(G,"cmdline").fsPath,"utf8");_.push({pid:B,cwd:V,cmd:Z})}}catch{}const U=[],M=v.filter(x=>{const B=O[x.socket];return B||U.push(x),B}),q=n(M,O,_);let K;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${U.length}`),U.length>0){const x=await new Promise(B=>{(0,C.exec)("ps -F -A -l | grep root",(G,X,V)=>{B(X)})});this._foundRootPorts=i(U,x,this._foundRootPorts),K=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.join(", ")}`)}return q.then(x=>K?x.concat(K):x)}};r=Be([Fe(0,t.IExtHostRpcService),Fe(1,S.IExtHostInitDataService),Fe(2,y.ILogService)],r),e.ExtHostTunnelService=r}),define(we[267],be([1,0,13,23,21,16,3,6,103,230,52]),function(te,e,h,t,k,A,S,P,C,T,F){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(v,R){try{return JSON.stringify(v,R)}catch{return"null"}}const E="$$ref$$",f={[E]:-1};class u{constructor(R,O){this.jsonString=R,this.referencedBuffers=O}}function w(v,R=null,O=!1){const L=[];return{jsonString:(O?g:JSON.stringify)(v,(U,M)=>{if(typeof M=="undefined")return f;if(typeof M=="object"){if(M instanceof t.VSBuffer){const q=L.push(M)-1;return{[E]:q}}if(R)return R(U,M)}return M}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=w;function y(v,R,O){return JSON.parse(v,(L,_)=>{if(_){const U=_[E];if(typeof U=="number")return R[U];if(O&&_.$mid===1)return O.transformIncoming(_)}return _})}e.parseJsonAndRestoreBufferRefs=y;function I(v,R){return JSON.stringify(v,R)}function a(v){return v?(R,O)=>O&&O.$mid===1?v.transformOutgoing(O):O:null}var c;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},b=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class n extends P.Disposable{constructor(R,O=null,L=null){super();this[D]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=O,this._uriTransformer=L,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,U=F.ProxyIdentifier.count;_<U;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,C.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:O,sid:L}=R;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,L)),this._proxies[O]}_createProxy(R,O){let L={get:(_,U)=>(typeof U=="string"&&!_[U]&&U.charCodeAt(0)===36&&(_[U]=(...M)=>this._remoteCall(R,U,M)),U===o?O:_[U])};return new Proxy(Object.create(null),L)}set(R,O){return this._locals[R.nid]=O,O}assertRegistered(R){for(let O=0,L=R.length;O<L;O++){const _=R[O];if(!this._locals[_.nid])throw new Error(`Missing proxy instance ${_.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const O=R.byteLength,L=i.read(R,0),_=L.readUInt8(),U=L.readUInt32();switch(_){case 1:case 2:{let{rpcId:M,method:q,args:K}=l.deserializeRequestJSONArgs(L);this._uriTransformer&&(K=(0,C.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(O,U,M,q,K,_===2);break}case 3:case 4:{let{rpcId:M,method:q,args:K}=l.deserializeRequestMixedArgs(L);this._uriTransformer&&(K=(0,C.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(O,U,M,q,K,_===4);break}case 5:{this._logger&&this._logger.logIncoming(O,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(O,U);break}case 7:{this._receiveReply(O,U,void 0);break}case 9:{let M=l.deserializeReplyOKJSON(L);this._uriTransformer&&(M=(0,C.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(O,U,M);break}case 10:{const M=l.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(O,U,M);break}case 8:{let M=l.deserializeReplyOKVSBuffer(L);this._receiveReply(O,U,M);break}case 11:{let M=l.deserializeReplyErrError(L);this._uriTransformer&&(M=(0,C.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(O,U,M);break}case 12:{this._receiveReplyErr(O,U,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,O,L,_,U,M){this._logger&&this._logger.logIncoming(R,O,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(L)}.${_}(`,U);const q=String(O);let K,x;if(M){const G=new k.CancellationTokenSource;U.push(G.token),K=this._invokeHandler(L,_,U),x=()=>G.cancel()}else K=this._invokeHandler(L,_,U),x=s;this._cancelInvokedHandlers[q]=x;const B=l.serializeAcknowledged(O);this._logger&&this._logger.logOutgoing(B.byteLength,O,1,"ack"),this._protocol.send(B),K.then(G=>{delete this._cancelInvokedHandlers[q];const X=l.serializeReplyOK(O,G,this._uriReplacer);this._logger&&this._logger.logOutgoing(X.byteLength,O,1,"reply:",G),this._protocol.send(X)},G=>{delete this._cancelInvokedHandlers[q];const X=l.serializeReplyErr(O,G);this._logger&&this._logger.logOutgoing(X.byteLength,O,1,"replyErr:",G),this._protocol.send(X)})}_receiveCancel(R,O){this._logger&&this._logger.logIncoming(R,O,1,"receiveCancel");const L=String(O);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(R,O,L){this._logger&&this._logger.logIncoming(R,O,0,"receiveReply:",L);const _=String(O);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const U=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],U.resolveOk(L)}_receiveReplyErr(R,O,L){this._logger&&this._logger.logIncoming(R,O,0,"receiveReplyErr:",L);const _=String(O);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const U=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let M;L&&(L.$isError?(M=new Error,M.name=L.name,M.message=L.message,M.stack=L.stack):M=L),U.resolveErr(M)}_invokeHandler(R,O,L){try{return Promise.resolve(this._doInvokeHandler(R,O,L))}catch(_){return Promise.reject(_)}}_doInvokeHandler(R,O,L){const _=this._locals[R];if(!_)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(R));let U=_[O];if(typeof U!="function")throw new Error("Unknown method "+O+" on actor "+(0,F.getStringIdentifierForProxy)(R));return U.apply(_,L)}_remoteCall(R,O,L){if(this._isDisposed)return Promise.reject(A.canceled());let _=null;if(L.length>0&&k.CancellationToken.isCancellationToken(L[L.length-1])&&(_=L.pop()),_&&_.isCancellationRequested)return Promise.reject(A.canceled());const U=l.serializeRequestArguments(L,this._uriReplacer),M=++this._lastMessageId,q=String(M),K=new T.LazyPromise;_&&_.onCancellationRequested(()=>{const B=l.serializeCancel(M);this._logger&&this._logger.logOutgoing(B.byteLength,M,0,"cancel"),this._protocol.send(l.serializeCancel(M))}),this._pendingRPCReplies[q]=K,this._onWillSendRequest(M);const x=l.serializeRequest(M,R,O,U,!!_);return this._logger&&this._logger.logOutgoing(x.byteLength,M,0,`request: ${(0,F.getStringIdentifierForProxy)(R)}.${O}(`,L),this._protocol.send(x),K}}e.RPCProtocol=n,D=b,n.UNRESPONSIVE_TIME=3*1e3;class i{constructor(R,O){this._buff=R,this._offset=O}static alloc(R,O,L){let _=new i(t.VSBuffer.alloc(L+1+4),0);return _.writeUInt8(R),_.writeUInt32(O),_}static read(R,O){return new i(R,O)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,L}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,L}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,O}static sizeMixedArray(R){let O=0;O+=1;for(let L=0,_=R.length;L<_;L++){const U=R[L];switch(O+=1,U.type){case 1:O+=this.sizeLongString(U.value);break;case 2:O+=this.sizeVSBuffer(U.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(U.value);for(let M=0;M<U.buffers.length;++M)O+=this.sizeVSBuffer(U.buffers[M]);break;case 4:break}}return O}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let O=0,L=R.length;O<L;O++){const _=R[O];switch(_.type){case 1:this.writeUInt8(1),this.writeLongString(_.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(_.value);break;case 3:this.writeUInt8(3),this.writeUInt32(_.buffers.length),this.writeLongString(_.value);for(let U=0;U<_.buffers.length;++U)this.writeBuffer(_.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let O=new Array(R);for(let L=0;L<R;L++)switch(this.readUInt8()){case 1:O[L]=this.readLongString();break;case 2:O[L]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),M=this.readLongString(),q=[];for(let K=0;K<U;++K)q.push(this.readVSBuffer());O[L]=new F.SerializableObjectWithBuffers(y(M,q,null));break}case 4:O[L]=void 0;break}return O}}i.sizeUInt32=4;var r;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(r||(r={}));class l{static _useMixedArgSerialization(R){for(let O=0,L=R.length;O<L;O++)if(R[O]instanceof t.VSBuffer||R[O]instanceof F.SerializableObjectWithBuffers||typeof R[O]=="undefined")return!0;return!1}static serializeRequestArguments(R,O){if(this._useMixedArgSerialization(R)){const L=[];for(let _=0,U=R.length;_<U;_++){const M=R[_];if(M instanceof t.VSBuffer)L[_]={type:2,value:M};else if(typeof M=="undefined")L[_]={type:4};else if(M instanceof F.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:K}=w(M.value,O);L[_]={type:3,value:t.VSBuffer.fromString(q),buffers:K}}else L[_]={type:1,value:t.VSBuffer.fromString(I(M,O))}}return{type:1,args:L}}return{type:0,args:I(R,O)}}static serializeRequest(R,O,L,_,U){switch(_.type){case 0:return this._requestJSONArgs(R,O,L,_.args,U);case 1:return this._requestMixedArgs(R,O,L,_.args,U)}}static _requestJSONArgs(R,O,L,_,U){const M=t.VSBuffer.fromString(L),q=t.VSBuffer.fromString(_);let K=0;K+=i.sizeUInt8(),K+=i.sizeShortString(M),K+=i.sizeLongString(q);let x=i.alloc(U?2:1,R,K);return x.writeUInt8(O),x.writeShortString(M),x.writeLongString(q),x.buffer}static deserializeRequestJSONArgs(R){const O=R.readUInt8(),L=R.readShortString(),_=R.readLongString();return{rpcId:O,method:L,args:JSON.parse(_)}}static _requestMixedArgs(R,O,L,_,U){const M=t.VSBuffer.fromString(L);let q=0;q+=i.sizeUInt8(),q+=i.sizeShortString(M),q+=i.sizeMixedArray(_);let K=i.alloc(U?4:3,R,q);return K.writeUInt8(O),K.writeShortString(M),K.writeMixedArray(_),K.buffer}static deserializeRequestMixedArgs(R){const O=R.readUInt8(),L=R.readShortString(),_=R.readMixedArray(),U=new Array(_.length);for(let M=0,q=_.length;M<q;M++){const K=_[M];typeof K=="string"?U[M]=JSON.parse(K):U[M]=K}return{rpcId:O,method:L,args:U}}static serializeAcknowledged(R){return i.alloc(5,R,0).buffer}static serializeCancel(R){return i.alloc(6,R,0).buffer}static serializeReplyOK(R,O,L){if(typeof O=="undefined")return this._serializeReplyOKEmpty(R);if(O instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,O);if(O instanceof F.SerializableObjectWithBuffers){const{jsonString:_,referencedBuffers:U}=w(O.value,L,!0);return this._serializeReplyOKJSONWithBuffers(R,_,U)}else return this._serializeReplyOKJSON(R,g(O,L))}static _serializeReplyOKEmpty(R){return i.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,O){let L=0;L+=i.sizeVSBuffer(O);let _=i.alloc(8,R,L);return _.writeVSBuffer(O),_.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,O){const L=t.VSBuffer.fromString(O);let _=0;_+=i.sizeLongString(L);let U=i.alloc(9,R,_);return U.writeLongString(L),U.buffer}static _serializeReplyOKJSONWithBuffers(R,O,L){const _=t.VSBuffer.fromString(O);let U=0;U+=i.sizeUInt32,U+=i.sizeLongString(_);for(const q of L)U+=i.sizeVSBuffer(q);let M=i.alloc(10,R,U);M.writeUInt32(L.length),M.writeLongString(_);for(const q of L)M.writeBuffer(q);return M.buffer}static deserializeReplyOKJSON(R){const O=R.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(R,O){const L=R.readUInt32(),_=R.readLongString(),U=[];for(let M=0;M<L;++M)U.push(R.readVSBuffer());return new F.SerializableObjectWithBuffers(y(_,U,O))}static serializeReplyErr(R,O){return O?this._serializeReplyErrEror(R,O):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,O){const L=t.VSBuffer.fromString(g(A.transformErrorForSerialization(O),null));let _=0;_+=i.sizeLongString(L);let U=i.alloc(11,R,_);return U.writeLongString(L),U.buffer}static deserializeReplyErrError(R){const O=R.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(R){return i.alloc(12,R,0).buffer}}var p;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var d;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(d||(d={}))}),define(we[268],be([1,0,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(we[269],be([1,0,28,10,9,12,22,2,4,200,43,226,268]),function(te,e,h,t,k,A,S,P,C,T,F,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let E=class qn{constructor(u,w,y,I){this.localUserHome=u,this.remoteAgentService=w,this.environmentService=y,this.contextService=I,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome||u})()}hasValidBasename(u,w,y){return typeof w=="string"||typeof w=="undefined"?this.resolveOS.then(I=>this.doHasValidBasename(u,I,w)):this.doHasValidBasename(u,w,y)}doHasValidBasename(u,w,y){return u.scheme===t.Schemas.file||u.scheme===t.Schemas.vscodeRemote?(0,h.isValidBasename)(y??(0,S.basename)(u),w===1):!0}get defaultUriScheme(){return qn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,w){if(u.remoteAuthority)return t.Schemas.vscodeRemote;const y=(0,T.getVirtualWorkspaceScheme)(w.getWorkspace());if(y)return y;const I=w.getWorkspace().folders[0];if(I)return I.uri.scheme;const a=w.getWorkspace().configuration;return a?a.scheme:t.Schemas.file}async userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?k.win32:k.posix)}async fileURI(u){let w="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const I=u.indexOf("/",2);I===-1?(w=u.substring(2),u="/"):(w=u.substring(2,I),u=u.substring(I)||"/")}return P.URI.from({scheme:t.Schemas.file,authority:w,path:u,query:"",fragment:""})}};E=Be([Fe(1,g.IRemoteAgentService),Fe(2,D.IWorkbenchEnvironmentService),Fe(3,F.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(we[69],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(S,P){this.line=S,this.character=P}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,P){return new h(0,0)}with(S){return new h(0,0)}}e.Position=h;class t{constructor(S,P,C,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(S,P),this.end=new h(C,T)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new t(0,0,0,0)}with(S){return new t(0,0,0,0)}}e.Range=t;var k;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[31],be([1,0,17,32,25,28,8,4,9,16,69,13]),function(te,e,h,t,k,A,S,P,C,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",E=" characters skipped \u27EB",f=(g.length+E.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function y(B){return!!B.preview}e.resultIsMatch=y;function I(B){return!!B.resource}e.isFileMatch=I;function a(B){return!!B.message}e.isProgressMessage=a;var c;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(G){this.resource=G,this.results=[]}}e.FileMatch=m;class s{constructor(G,X,V){this.ranges=X;const Z=Array.isArray(X)?X:[X];if(V&&V.matchLines===1&&b(Z)){G=(0,S.getNLines)(G,V.matchLines);let se="",ce=0,ee=0;const Q=Math.floor(V.charsPerLine/5),oe=[];for(const de of Z){const ve=Math.max(de.startColumn-Q,0),ke=de.startColumn+V.charsPerLine;if(ve>ee+Q+f){const Ne=g+(ve-ee)+E;se+=Ne+G.slice(ve,ke),ce+=ve-(ee+Ne.length)}else se+=G.slice(ee,ke);oe.push(new n(0,de.startColumn-ce,de.endColumn-ce)),ee=ke}this.preview={text:se,matches:Array.isArray(this.ranges)?oe:oe[0]}}else{const se=Array.isArray(X)?X[0].startLineNumber:X.startLineNumber;this.preview={text:G,matches:(0,h.mapArrayOrNot)(X,ce=>new o(ce.startLineNumber-se,ce.startColumn,ce.endLineNumber-se,ce.endColumn))}}}}e.TextSearchMatch=s;function b(B){const G=B[0].startLineNumber;for(const X of B)if(X.startLineNumber!==G||X.endLineNumber!==G)return!1;return!0}class o{constructor(G,X,V,Z){this.startLineNumber=G,this.startColumn=X,this.endLineNumber=V,this.endColumn=Z}}e.SearchRange=o;class n extends o{constructor(G,X,V){super(G,X,G,V)}}e.OneLineRange=n;var i;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function r(B,G=!0){const X=B&&B.files&&B.files.exclude,V=G&&B&&B.search&&B.search.exclude;if(!X&&!V)return;if(!X||!V)return X||V;let Z=Object.create(null);return Z=k.mixin(Z,k.deepClone(X)),Z=k.mixin(Z,k.deepClone(V),!0),Z}e.getExcludes=r;function l(B,G){return B.excludePattern&&t.match(B.excludePattern,G)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&t.match(B.includePattern,G)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(X=>{const V=X.folder.fsPath;if(A.isEqualOrParent(G,V)){const Z=C.relative(V,G);return!X.includePattern||!!t.match(X.includePattern,Z)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var p;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor(G,X){super(G);this.code=X}}e.SearchError=d;function v(B){const G=B.message;if((0,T.isCancellationError)(B))return new d(G,p.canceled);try{const X=JSON.parse(G);return new d(X.message,X.code)}catch{return new d(G,p.other)}}e.deserializeSearchError=v;function R(B){const G={message:B.message,code:B.code};return new Error(JSON.stringify(G))}e.serializeSearchError=R;function O(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=O;function L(B){return B.type==="success"}e.isSerializedSearchSuccess=L;function _(B){return!!B.path}e.isSerializedFileMatch=_;function U(B,G){const X=B.searchPath?B.searchPath:B.relativePath;return(0,S.fuzzyContains)(X,G)}e.isFilePatternMatch=U;class M{constructor(G){this.path=G,this.results=[]}addMatch(G){this.results.push(G)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function q(B,G){const X={...B||{},...G||{}};return Object.keys(X).filter(V=>{const Z=X[V];return typeof Z=="boolean"&&Z})}e.resolvePatternsForProvider=q;class K{constructor(G,X){this._parsedIncludeExpression=null,this._excludeExpression={...G.excludePattern||{},...X.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let V=G.includePattern;X.includePattern&&(V?V={...V,...X.includePattern}:V=X.includePattern),V&&(this._parsedIncludeExpression=t.parse(V))}matchesExcludesSync(G,X,V){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(G,X,V))}includedInQuerySync(G,X,V){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(G,X,V)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(G,X,V))}includedInQuery(G,X,V){const Z=this._parsedExcludeExpression(G,X,V),se=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(G,X,V):!0;return(0,D.isThenable)(Z)?Z.then(ce=>ce?!1:se()):se()}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=K;function x(B){for(const G in B)if(typeof B[G]!="boolean")return!0;return!1}}),define(we[35],be([1,0,17,13,21,3,24,10,94,22,8,18,2,174,4,11,192,43,44,26,14,15,7,31,5]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a,c,m,s,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(O,L,_){return new T.ExtUri(U=>p(U,_)).isEqual(O,L)}function i(O,L,_){return n(O.uri,L.uri,_)?0:(0,F.compare)(O.uri.toString(),L.uri.toString())}function r(O,L,_){return O.index!==L.index?O.index<L.index?-1:1:n(O.uri,L.uri,_)?(0,F.compare)(O.name,L.name):(0,F.compare)(O.uri.toString(),L.uri.toString())}function l(O,L,_,U){const M=O.slice(0).sort((K,x)=>_(K,x,U)),q=L.slice(0).sort((K,x)=>_(K,x,U));return(0,h.delta)(M,q,(K,x)=>_(K,x,U))}function p(O,L){const _=L.getCapabilities(O.scheme);return!(_&&_&1024)}class d extends y.Workspace{constructor(L,_,U,M,q,K,x){super(L,U.map(B=>new y.WorkspaceFolder(B)),M,q,x);this._name=_,this._isUntitled=K,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(x),U.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(L,_,U,M){if(!L)return{workspace:null,added:[],removed:[]};const{id:q,name:K,folders:x,configuration:B,transient:G,isUntitled:X}=L,V=[],Z=_;_?x.forEach((Q,oe)=>{const de=g.URI.revive(Q.uri),ve=d._findFolder(U||_,de,M);ve?(ve.name=Q.name,ve.index=Q.index,V.push(ve)):V.push({uri:de,name:Q.name,index:oe})}):V.push(...x.map(({uri:Q,name:oe,index:de})=>({uri:g.URI.revive(Q),name:oe,index:de}))),V.sort((Q,oe)=>Q.index<oe.index?-1:1);const se=new d(q,K,V,!!G,B?g.URI.revive(B):null,!!X,Q=>p(Q,M)),{added:ce,removed:ee}=l(Z?Z.workspaceFolders:[],se.workspaceFolders,i,M);return{workspace:se,added:ce,removed:ee}}static _findFolder(L,_,U){for(let M=0;M<L.folders.length;M++){const q=L.workspaceFolders[M];if(n(q.uri,_,U))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,_){return _&&this._structure.get(L)&&(L=(0,T.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let v=class{constructor(L,_,U,M){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=U,this._requestIdProvider=new C.Counter,this._barrier=new t.Barrier,this._proxy=L.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(o.MainContext.MainThreadMessageService);const q=_.workspace;this._confirmedWorkspace=q?new d(q.id,q.name,[],!!q.transient,q.configuration?g.URI.revive(q.configuration):null,!!q.isUntitled,K=>p(K,U)):void 0}$initializeWorkspace(L,_){this._trusted=_,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?g.URI.from({scheme:P.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,_,U,...M){const q=[];if(Array.isArray(M)&&M.forEach(X=>{g.URI.isUri(X.uri)&&!q.some(V=>n(V.uri,X.uri,this._extHostFileSystemInfo))&&q.push({uri:X.uri,name:X.name||(0,T.basenameOrAuthority)(X.uri)})}),this._unconfirmedWorkspace||[_,U].some(X=>typeof X!="number"||X<0)||U===0&&q.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(_+U>K.length)return!1;const x=K.slice(0);x.splice(_,U,...q.map(X=>({uri:X.uri,name:X.name||(0,T.basenameOrAuthority)(X.uri),index:void 0})));for(let X=0;X<x.length;X++){const V=x[X];if(x.some((Z,se)=>se!==X&&n(V.uri,Z.uri,this._extHostFileSystemInfo)))return!1}x.forEach((X,V)=>X.index=V);const{added:B,removed:G}=l(K,x,r,this._extHostFileSystemInfo);if(B.length===0&&G.length===0)return!1;if(this._proxy){const X=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(X,_,U,q).then(void 0,V=>{this._unconfirmedWorkspace=void 0;const Z={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(w.Severity.Error,(0,E.localize)(0,null,X,V.toString()),Z,[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(L,_){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,_)}async getWorkspaceFolder2(L,_){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,_)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,_){let U,M="";if(typeof L=="string"?(U=g.URI.file(L),M=L):typeof L!="undefined"&&(U=L,M=L.fsPath),!U)return M;const q=this.getWorkspaceFolder(U,!0);if(!q)return M;typeof _=="undefined"&&this._actualWorkspace&&(_=this._actualWorkspace.folders.length>1);let K=(0,T.relativePath)(q.uri,U);return _&&q.name&&(K=`${q.name}/${K}`),K}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=d.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:_,added:U,removed:M}=d.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=_||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:M}))}findFiles(L,_,U,M,q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let K;if(_===null?K=!1:_&&(typeof _=="string"?K=_:K=_.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:B}=R(m.GlobPattern.from(L));return this._proxy.$startFileSearch((0,D.withUndefinedAsNull)(x),(0,D.withUndefinedAsNull)(B),(0,D.withUndefinedAsNull)(K),(0,D.withUndefinedAsNull)(U),q).then(G=>Array.isArray(G)?G.map(X=>g.URI.revive(X)):[])}async findTextInFiles(L,_,U,M,q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),x=typeof _.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:_.previewOptions,{includePattern:B,folder:G}=R(m.GlobPattern.from(_.include)),X=typeof _.exclude=="string"?_.exclude:_.exclude?_.exclude.pattern:void 0,V={ignoreSymlinks:typeof _.followSymlinks=="boolean"?!_.followSymlinks:void 0,disregardIgnoreFiles:typeof _.useIgnoreFiles=="boolean"?!_.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof _.useGlobalIgnoreFiles=="boolean"?!_.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof _.useParentIgnoreFiles=="boolean"?!_.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof _.useDefaultExcludes=="boolean"?!_.useDefaultExcludes:!0,fileEncoding:_.encoding,maxResults:_.maxResults,previewOptions:x,afterContext:_.afterContext,beforeContext:_.beforeContext,includePattern:B,excludePattern:X},Z=!1;if(this._activeSearchCallbacks[K]=se=>{if(Z)return;const ce=g.URI.revive(se.resource);se.results.forEach(ee=>{(0,b.resultIsMatch)(ee)?U({uri:ce,preview:{text:ee.preview.text,matches:(0,h.mapArrayOrNot)(ee.preview.matches,Q=>new s.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))},ranges:(0,h.mapArrayOrNot)(ee.ranges,Q=>new s.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))}):U({uri:ce,text:ee.text,lineNumber:ee.lineNumber})})},q.isCancellationRequested)return{};try{const se=await this._proxy.$startTextSearch(L,(0,D.withUndefinedAsNull)(G),V,K,q);return delete this._activeSearchCallbacks[K],se||{}}catch(se){throw delete this._activeSearchCallbacks[K],se}}$handleTextSearchResult(L,_){this._activeSearchCallbacks[_]&&this._activeSearchCallbacks[_](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=Be([Fe(0,c.IExtHostRpcService),Fe(1,a.IExtHostInitDataService),Fe(2,I.IExtHostFileSystemInfo),Fe(3,u.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function R(O){let L,_;return O&&(typeof O=="string"?L=O:(L=O.pattern,_=g.URI.revive(O.baseUri))),{includePattern:L,folder:_}}}),define(we[36],be([1,0,25,3,35,5,7,195,121,18,13,4,14,11,2]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(b,o){if(o){const n=o.split(".");let i=b;for(let r=0;i&&r<n.length;r++)i=i[n[r]];return i}}function w(b){return b instanceof f.URI}function y(b){return b&&b.uri instanceof f.URI&&b.languageId&&typeof b.languageId=="string"}function I(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function a(b){return b&&b.uri instanceof f.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function c(b){if(w(b))return{resource:b};if(y(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(I(b))return{overrideIdentifier:b.languageId};if(a(b))return{resource:b.uri};if(b===null)return{resource:null}}let m=class{constructor(o,n,i){this._proxy=o.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=i,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new s(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,n){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(o,n))}};m=Be([Fe(0,g.IExtHostRpcService),Fe(1,k.IExtHostWorkspace),Fe(2,E.ILogService)],m),e.ExtHostConfiguration=m;class s{constructor(o,n,i,r){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=r,this._extHostWorkspace=n,this._configuration=P.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,n){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,i))}getConfiguration(o,n,i){const r=c(n)||{},l=this._toReadonlyValue(o?u(this._configuration.getValue(void 0,r,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,r,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,r,i?.identifier);function p(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(v){return typeof u(l,v)!="undefined"},get:(v,R)=>{this._validateConfigurationAccess(o?`${o}.${v}`:v,r,i?.identifier);let O=u(l,v);if(typeof O=="undefined")O=R;else{let L;const _=(U,M)=>{let q;const K=()=>{L=L||(0,h.deepClone)(l),q=q||u(L,M)};return(0,T.isObject)(U)?new Proxy(U,{get:(x,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return K(),()=>q;if(L)return q=q||u(L,M),q[B];const G=x[B];return typeof B=="string"?_(G,`${M}.${B}`):G},set:(x,B,G)=>(K(),q&&(q[B]=G),!0),deleteProperty:(x,B)=>(K(),q&&delete q[B],!0),defineProperty:(x,B,G)=>(K(),q&&Object.defineProperty(q,B,G),!0)}):U};O=_(O,v)}return O},update:(v,R,O,L)=>{v=o?`${o}.${v}`:v;const _=p(O);return R!==void 0?this._proxy.$updateConfigurationOption(_,v,R,r,L):this._proxy.$removeConfigurationOption(_,v,r,L)},inspect:v=>{v=o?`${o}.${v}`:v;const R=(0,h.deepClone)(this._configuration.inspect(v,r,this._extHostWorkspace.workspace));if(R)return{key:v,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof l=="object"&&(0,h.mixin)(d,l,!1),Object.freeze(d)}_toReadonlyValue(o){const n=i=>(0,T.isObject)(i)?new Proxy(i,{get:(r,l)=>n(r[l]),set:(r,l,p)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(r,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(r,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:r=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return n(o)}_validateConfigurationAccess(o,n,i){const r=C.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),l=i?`[${i.value}] `:"";if(r===4){typeof n?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(r===3){n?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,n){const i=new P.ConfigurationChangeEvent(o,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(r,l)=>i.affectsConfiguration(r,c(l))})}_toMap(o){return o.reduce((n,i)=>(n.set(i[0],i[1]),n),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[70],be([1,0,2,13,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,218,16]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a,c){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(M){function q(x){if(x!=null)return x}M.from=q;function K(x){if(x!=null)return x}M.to=K})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var b;(function(M){function q(x){if(x!=null)return x}M.from=q;function K(x){if(x!=null)return x}M.to=K})(b=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(M){function q(x){if(x!=null)return x}M.from=q;function K(x){if(x!=null)return x}M.to=K})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(M){function q(B){if(B){const G=B;return G&&!!G.process}else return!1}M.is=q;function K(B){if(B==null)return;const G={process:B.process,args:B.args};return B.options&&(G.options=o.from(B.options)),G}M.from=K;function x(B){if(B!=null)return new S.ProcessExecution(B.process,B.args,B.options)}M.to=x})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var i;(function(M){function q(x){if(x!=null)return x}M.from=q;function K(x){if(x!=null)return x}M.to=K})(i=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var r;(function(M){function q(B){if(B){const G=B;return G&&(!!G.commandLine||!!G.command)}else return!1}M.is=q;function K(B){if(B==null)return;const G={};return B.commandLine!==void 0?G.commandLine=B.commandLine:(G.command=B.command,G.args=B.args),B.options&&(G.options=i.from(B.options)),G}M.from=K;function x(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new S.ShellExecution(B.commandLine,B.options):new S.ShellExecution(B.command,B.args?B.args:[],B.options)}M.to=x})(r=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(M){function q(B){if(B){let G=B;return G&&G.customExecution==="customExecution"}else return!1}M.is=q;function K(B){return{customExecution:"customExecution"}}M.from=K;function x(B,G){return G.get(B)}M.to=x})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var p;(function(M){function q(K,x){let B;return K.scope!==void 0&&typeof K.scope!="number"?B=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===S.TaskScope.Workspace&&x&&x.workspaceFile?B=x.workspaceFile:B=a.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:B}}M.from=q})(p=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(M){function q(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}M.from=q})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var v;(function(M){function q(B,G){if(B==null)return[];const X=[];for(let V of B){const Z=K(V,G);Z&&X.push(Z)}return X}M.fromMany=q;function K(B,G){if(B==null)return;let X;B.execution instanceof S.ProcessExecution?X=n.from(B.execution):B.execution instanceof S.ShellExecution?X=r.from(B.execution):B.execution&&B.execution instanceof S.CustomExecution&&(X=l.from(B.execution));const V=s.from(B.definition);let Z;return B.scope?typeof B.scope=="number"?Z=B.scope:Z=B.scope.uri:Z=S.TaskScope.Workspace,!V||!Z?void 0:{_id:B._id,definition:V,name:B.name,source:{extensionId:G.identifier.value,label:B.source,scope:Z},execution:X,isBackground:B.isBackground,group:d.from(B.group),presentationOptions:b.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}M.from=K;async function x(B,G,X){if(B==null)return;let V;n.is(B.execution)?V=n.to(B.execution):r.is(B.execution)?V=r.to(B.execution):l.is(B.execution)&&(V=l.to(B._id,X));const Z=s.to(B.definition);let se;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?se=B.source.scope:se=await G.resolveWorkspaceFolder(h.URI.revive(B.source.scope)):se=S.TaskScope.Workspace),!Z||!se)return;const ce=new S.Task(Z,se,B.name,B.source.label,V,B.problemMatchers);return B.isBackground!==void 0&&(ce.isBackground=B.isBackground),B.group!==void 0&&(ce.group=S.TaskGroup.from(B.group._id),ce.group&&B.group.isDefault&&(ce.group=new S.TaskGroup(ce.group.id,ce.group.label),B.group.isDefault&&(ce.group.isDefault=B.group.isDefault))),B.presentationOptions&&(ce.presentationOptions=b.to(B.presentationOptions)),B._id&&(ce._id=B._id),B.detail&&(ce.detail=B.detail),ce}M.to=x})(v=e.TaskDTO||(e.TaskDTO={}));var R;(function(M){function q(x){return x}M.from=q;function K(x){if(!!x)return Object.assign(Object.create(null),x)}M.to=K})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class O{constructor(q,K,x){this._id=K,this._task=x,m.set(this,void 0),Ke(this,m,q,"f")}get task(){return this._task}terminate(){Te(this,m,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}m=new WeakMap;var L;(function(M){function q(K){return{id:K._id,task:void 0}}M.from=q})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let _=class{constructor(q,K,x,B,G,X,V,Z){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=q.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=B,this._configurationService=G,this._terminalService=X,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=V,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,K,x){if(!x)return new S.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:K,provider:x,extension:q}),this._proxy.$registerTaskProvider(B,K),new S.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(q,K){this._proxy.$registerTaskSystem(q,K)}fetchTasks(q){return this._proxy.$fetchTasks(R.from(q)).then(async K=>{const x=[];for(let B of K){const G=await v.to(B,this._workspaceProvider,this._providedCustomExecutions2);G&&x.push(G)}return x})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(K=>q.push(K)),q}terminateTask(q){if(!(q instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,K,x){const B=this._providedCustomExecutions2.get(q.id);B&&(this._activeCustomExecutions2.set(q.id,B),this._terminalService.attachPtyToTerminal(K,await B.callback(x))),this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const K=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const K=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:K,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const K=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:q.exitCode})}$provideTasks(q,K){const x=this._handlers.get(q);if(!x)return Promise.reject(new Error("no handler found"));const B=[],G=(0,t.asPromise)(()=>x.provider.provideTasks(F.CancellationToken.None)).then(X=>this.provideTasksInternal(K,B,x,X));return new Promise(X=>{G.then(V=>{Promise.all(B).then(()=>{X(V)})})})}async $resolveTask(q,K){const x=this._handlers.get(q);if(!x)return Promise.reject(new Error("no handler found"));if(K.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${x.type}].`);const B=await v.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const G=await x.provider.resolveTask(B,F.CancellationToken.None);if(!G)return;this.checkDeprecation(G,x);const X=v.from(G,x.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(X.execution)&&await this.addCustomExecution(X,G,!0),await this.resolveTaskInternal(X)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,K,x){const B=await this._proxy.$createTaskId(q);!x&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,K.execution)),this._providedCustomExecutions2.set(B,K.execution)}async getTaskExecution(q,K){if(typeof q=="string"){const G=this._taskExecutionPromises.get(q);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}let x=this._taskExecutionPromises.get(q.id);if(x)return x;const B=new Promise((G,X)=>{function V(Z,se,ce){ce?G(new O(Z,se.id,ce)):X("Unexpected: Task does not exist.")}K?V(this,q,K):v.to(q.task,this._workspaceProvider,this._providedCustomExecutions2).then(Z=>V(this,q,Z))});return this._taskExecutionPromises.set(q.id,B),B.then(G=>(this._taskExecutions.set(q.id,G),G),G=>Promise.reject(G))}checkDeprecation(q,K){q._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let x=this._notProvidedCustomExecutions.values(),B=x.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=x.next()}};_=Be([Fe(0,g.IExtHostRpcService),Fe(1,E.IExtHostInitDataService),Fe(2,P.IExtHostWorkspace),Fe(3,C.IExtHostDocumentsAndEditors),Fe(4,T.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,y.ILogService),Fe(7,I.IExtHostApiDeprecationService)],_),e.ExtHostTaskBase=_;let U=class extends _{constructor(q,K,x,B,G,X,V,Z){super(q,K,x,B,G,X,V,Z);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(q,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const x=v.from(K,q);if(x===void 0)throw new Error("Task is not valid");if(l.is(x.execution))await this.addCustomExecution(x,K,!1);else throw new c.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),K);return this._proxy.$executeTask(x).catch(G=>{throw new Error(G)}),B}provideTasksInternal(q,K,x,B){const G=[];if(B)for(let X of B){this.checkDeprecation(X,x),(!X.definition||!q[X.definition.type])&&this._logService.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const V=v.from(X,x.extension);V&&l.is(V.execution)?(G.push(V),K.push(this.addCustomExecution(V,X,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:x.extension}}async resolveTaskInternal(q){if(l.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,K,x){}};U=Be([Fe(0,g.IExtHostRpcService),Fe(1,E.IExtHostInitDataService),Fe(2,P.IExtHostWorkspace),Fe(3,C.IExtHostDocumentsAndEditors),Fe(4,T.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,y.ILogService),Fe(7,I.IExtHostApiDeprecationService)],U),e.WorkerExtHostTask=U,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(we[270],be([1,0,9,21,49,32,22,46,31]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(g,E,f){this.config=g,this.provider=E,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&A.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&A.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const E=this.config.folderQueries||[];return new Promise((f,u)=>{const w=y=>{this.resultCount++,g(y)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(y=>{const I=y.toString(),a=h.basename(I);this.globalExcludePattern&&this.globalExcludePattern(I,a)||this.matchFile(w,{base:y,basename:a})}),Promise.all(E.map(y=>this.searchInFolder(y,w))).then(y=>{f({limitHit:this.isLimitHit,stats:y[0]||void 0})},y=>{u(new Error((0,k.toErrorMessage)(y)))})})}async searchInFolder(g,E){const f=new t.CancellationTokenSource,u=this.getSearchOptionsForFolder(g),w=this.initDirectoryTree(),y=new C.QueryGlobTester(this.config,g),I=!y.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(f),a=P.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,f.token),m=a.elapsed(),s=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(b=>{const o=h.posix.relative(g.folder.path,b.path);if(I){const n=h.basename(b.path);this.matchFile(E,{base:g.folder,relativePath:o,basename:n});return}this.addDirectoryEntries(w,g.folder,o,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,y,E),{providerTime:m,postProcessTime:s.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(g){const E=(0,C.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),f=(0,C.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:f,includes:E,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},E,f,u){if(f===this.filePattern){const y=h.basename(this.filePattern);this.matchFile(u,{base:E,relativePath:this.filePattern,basename:y})}function w(y){const I=h.basename(y),a=h.dirname(y);let c=g[a];c||(c=g[a]=[],w(a)),c.push({base:E,relativePath:y,basename:I})}w(f)}matchDirectoryTree({rootEntries:g,pathToEntries:E},f,u){const w=this,y=this.filePattern;function I(a){const c=A.hasSiblingFn(()=>a.map(m=>m.basename));for(let m=0,s=a.length;m<s;m++){const b=a[m],{relativePath:o,basename:n}=b;if(f.matchesExcludesSync(o,n,y!==n?c:void 0))continue;const i=E[o];if(i)I(i);else{if(o===y)continue;w.matchFile(u,b)}if(w.isLimitHit)break}}I(g)}matchFile(g,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(E))}}class F{constructor(){this.sessions=new Map}fileSearch(g,E,f,u){const w=this.getSessionTokenSource(g.cacheKey),y=new T(g,E,w&&w.token);let I=0;const a=c=>{I+=c.length,f(c.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(y,F.BATCH_SIZE,a,u).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:I,detailStats:c.stats}}))}clearCache(g){const E=this.getSessionTokenSource(g);E&&E.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new t.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:S.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,E,f,u){u.onCancellationRequested(()=>{g.cancel()});const w=I=>{I&&(y.push(I),E>0&&y.length>=E&&(f(y),y=[]))};let y=[];return g.search(w).then(I=>(y.length&&f(y),I),I=>(y.length&&f(y),Promise.reject(I)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(we[271],be([1,0,17,74,32,79,24,10,9,22,8,18,2,154,183,117,11,43,130,269,31]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(d,v,R,O,L){this.configurationService=d,this.workspaceContextService=v,this.editorGroupsService=R,this.logService=O,this.pathService=L}text(d,v,R={}){d=this.getContentPattern(d,R);const O=this.configurationService.getValue(),L=v&&v.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(v?.map(y.toWorkspaceFolder),R),type:2,contentPattern:d,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:O.search.usePCRE2||L||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(d,v){const R=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const O={...d,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(d,v)&&(O.isCaseSensitive=!0),this.isMultiline(d)&&(O.isMultiline=!0),O}file(d,v={}){return{...this.commonQuery(d,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}handleIncludeExclude(d,v){return d?(d=Array.isArray(d)?d.map(i):i(d),v?this.parseSearchPaths(d):{pattern:b(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],v={}){const R=this.handleIncludeExclude(v.includePattern,v.expandPatterns),O=this.handleIncludeExclude(v.excludePattern,v.expandPatterns),L=d.length>1,_=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,v,O)):d.map(q=>this.getFolderQueryForRoot(q,v,O,L))).filter(q=>!!q),U={_reason:v._reason,folderQueries:_,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:O.pattern,includePattern:R.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const q=h.coalesce(h.flatten(this.editorGroupsService.groups.map(B=>B.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const K=q.filter(B=>(0,c.pathIncludedInQuery)(U,B.fsPath)),x=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(x)),{...U,...x}}const M=v.extraFileResources&&v.extraFileResources.filter(q=>(0,c.pathIncludedInQuery)(U,q.fsPath));return U.extraFileResources=M&&M.length?M:void 0,U}commonQueryFromFileList(d){const v=[],R=new S.ResourceMap,O={};let L=!1;return d.forEach(_=>{if(_.scheme===P.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(_)){const M=this.workspaceContextService.getWorkspaceFolder(_)?.uri??_.with({path:C.dirname(_.fsPath)});let q=R.get(M);q||(L=!0,q={folder:M,includePattern:{}},v.push(q),R.set(M,q));const K=C.relative(M.fsPath,_.fsPath);(0,D.assertIsDefined)(q.includePattern)[K.replace(/\\/g,"/")]=!0}else _.fsPath&&(L=!0,O[_.fsPath]=!0)}),{folderQueries:v,includePattern:O,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(d,v){if(v.isSmartCase){if(d.isRegExp){if(F.containsUppercaseCharacter(d.pattern,!0))return!0}else if(F.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,E.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const v=x=>C.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),O=(Array.isArray(d)?d:o(d)).map(x=>{const B=this.pathService.resolvedUserHome;return B?(0,A.untildify)(x,B.scheme===P.Schemas.file?B.fsPath:B.path):x}),L=t.groupBy(O,x=>v(x)?"searchPaths":"exprSegments"),_=(L.exprSegments||[]).map(x=>F.rtrim(x,"/")).map(x=>F.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),n(x))),U={},M=this.expandSearchPathPatterns(L.searchPaths||[]);M&&M.length&&(U.searchPaths=M);const q=h.flatten(_),K=b(...q);return K&&(U.pattern=K),U}getExcludesForFolder(d,v){return v.disregardExcludeSettings?void 0:(0,c.getExcludes)(d,!v.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const v=h.flatten(d.map(O=>{let{pathPortion:L,globPortion:_}=s(O);_&&(_=r(_));const U=this.expandOneSearchPath(L);return h.flatten(U.map(M=>this.resolveOneSearchPathPattern(M,_)))})),R=new Map;return v.forEach(O=>{const L=O.searchPath.toString(),_=R.get(L);_?O.pattern&&(_.pattern=_.pattern||{},_.pattern[O.pattern]=!0):R.set(L,{searchPath:O.searchPath,pattern:O.pattern?b(O.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(d){if(C.isAbsolute(d)){const v=this.workspaceContextService.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==P.Schemas.file?[{searchPath:v[0].uri.with({path:d})}]:[{searchPath:g.URI.file(C.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const v=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=i(d),d.startsWith("../")||d===".."){const O=C.posix.resolve(v.path,d);return[{searchPath:v.with({path:O})}]}const R=r(d);return[{searchPath:v,pattern:R}]}else{if(d==="./"||d===".\\")return[];{const v=d.replace(/^\.[\/\\]/,""),O=this.workspaceContextService.getWorkspace().folders.map(L=>{const _=v.match(new RegExp(`^${F.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return _?{match:_,folder:L}:null}).filter(D.isDefined);if(O.length)return O.map(L=>{const _=L.match[1];return{searchPath:L.folder.uri,pattern:_&&r(_)}});{const L=d.match(/\.[\/\\](.+)[\/\\]?/),_=L?L[1]:d,U=f.localize(0,null,_);throw new Error(U)}}}}resolveOneSearchPathPattern(d,v){const R=d.pattern&&v?`${d.pattern}/${v}`:d.pattern||v,O=[{searchPath:d.searchPath,pattern:R}];return R&&!R.endsWith("**")&&O.push({searchPath:d.searchPath,pattern:R+"/**"}),O}getFolderQueryForSearchPath(d,v,R){const O=this.getFolderQueryForRoot((0,y.toWorkspaceFolder)(d.searchPath),v,R,!1);return O?{...O,includePattern:d.pattern}:null}getFolderQueryForRoot(d,v,R,O){let L;const _=g.URI.isUri(d)?d:d.uri;if(R.searchPaths){const x=R.searchPaths.filter(B=>(0,T.isEqual)(B.searchPath,_))[0];if(x&&!x.pattern)return null;x&&(L=x.pattern)}const U=this.configurationService.getValue({resource:_}),q={...this.getExcludesForFolder(U,v)||{},...L||{}},K=g.URI.isUri(d)?(0,T.basename)(d):d.name;return{folder:_,folderName:O?K:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!U.search.followSymlinks}}};m=Be([Fe(0,u.IConfigurationService),Fe(1,y.IWorkspaceContextService),Fe(2,I.IEditorGroupsService),Fe(3,w.ILogService),Fe(4,a.IPathService)],m),e.QueryBuilder=m;function s(p){const d=p.match(/[\*\{\}\(\)\[\]\?]/);if(d){const v=d.index,R=p.substr(0,v).match(/[/|\\][^/\\]*$/);if(R){let O=p.substr(0,R.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:p.substr((R.index||0)+1)}}}return{pathPortion:p}}function b(...p){return p.length?p.reduce((d,v)=>(d[v]=!0,d),Object.create(null)):void 0}function o(p){return k.splitGlobAware(p,",").map(d=>d.trim()).filter(d=>!!d.length)}function n(p){return[`**/${p}/**`,`**/${p}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function i(p){return p.replace(/\\/g,"/")}function r(p){return i(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(p,d){p=h.distinct(p,O=>O.toString());const v=[],R=d.getWorkspace();return p&&p.forEach(O=>{let L;if(d.getWorkbenchState()===2)L=(0,T.relativePath)(R.folders[0].uri,O),L&&L!=="."&&(L="./"+L);else{const _=d.getWorkspaceFolder(O);if(_){const U=_.name;if(R.folders.filter(q=>q.name===U).length===1){const q=(0,T.relativePath)(_.uri,O);q===""?L=`./${_.name}`:L=`./${_.name}/${q}`}else L=O.fsPath}}L&&v.push(L)}),v}e.resolveResourcesForSearchIncludes=l}),define(we[272],be([1,0,22,2,21,16,4,271,31,43]),function(te,e,h,t,k,A,S,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function D(u,w){const y=w.activationEvents;if(!y)return Promise.resolve(void 0);const I=[],a=[];for(const n of y)if(/^workspaceContains:/.test(n)){const i=n.substr("workspaceContains:".length);i.indexOf("*")>=0||i.indexOf("?")>=0||u.forceUsingSearch?a.push(i):I.push(i)}if(I.length===0&&a.length===0)return Promise.resolve(void 0);let c;const m=new Promise((n,i)=>{c=n}),s=n=>c({activationEvent:n}),b=Promise.all(I.map(n=>g(u,n,s))).then(()=>{}),o=E(u,w.identifier,a,s);return Promise.all([b,o]).then(()=>{c(void 0)}),m}e.checkActivateWorkspaceContainsExtension=D;async function g(u,w,y){for(const I of u.folders)if(await u.exists(h.joinPath(t.URI.revive(I),w))){y(`workspaceContains:${w}`);return}}async function E(u,w,y,I){if(y.length===0)return Promise.resolve(void 0);const a=new k.CancellationTokenSource,c=u.checkExists(u.folders,y,a.token),m=setTimeout(async()=>{a.cancel(),u.logService.info(`Not activating extension '${w.value}': Timed out while searching for 'workspaceContains' pattern ${y.join(",")}`)},F);let s=!1;try{s=await c}catch(b){A.isCancellationError(b)||A.onUnexpectedError(b)}a.dispose(),clearTimeout(m),s&&I(`workspaceContains:${y.join(",")}`)}function f(u,w,y,I){const a=u.get(S.IInstantiationService),c=u.get(C.ISearchService),s=a.createInstance(P.QueryBuilder).file(w.map(b=>(0,T.toWorkspaceFolder)(t.URI.revive(b))),{_reason:"checkExists",includePattern:y,exists:!0});return c.fileSearch(s,I).then(b=>!!b.limitHit,b=>A.isCancellationError(b)?!1:Promise.reject(b))}e.checkGlobFileExists=f});var Ke=this&&this.__classPrivateFieldSet||function(te,e,h,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,h):k?k.value=h:e.set(te,h),h},Te=this&&this.__classPrivateFieldGet||function(te,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(te):t?t.value:e.get(te)};define(we[39],be([1,0,169,9,71,22,13,6,24,2,11,5,36,228,90,35,30,227,16,27,23,202,7,122,4,26,67,14,82,51,34,3,272,89,204,10]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a,c,m,s,b,o,n,i,r,l,p,d,v,R,O,L,_){"use strict";var U,M,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let K=class Gn extends P.Disposable{constructor(V,Z,se,ce,ee,Q,oe,de,ve,ke){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Z,this._extHostContext=se,this._initData=oe,this._extHostWorkspace=ce,this._extHostConfiguration=ee,this._logService=Q,this._extHostTunnelService=ve,this._extHostTerminalService=ke,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new y.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=de,this._instaService=V.createChild(new l.ServiceCollection([f.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const Ne=new Set;this._initData.hostExtensions.forEach(_e=>Ne.add(a.ExtensionIdentifier.toKey(_e))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(_e,Ee,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(_e,I.transformErrorForSerialization(Ee),z)},actualActivateExtension:async(_e,Ee)=>{if(Ne.has(a.ExtensionIdentifier.toKey(_e)))return await this._mainThreadExtensionsProxy.$activateExtension(_e,Ee),new E.HostExtension;const z=this._registry.getExtensionDescription(_e);return this._activateExtension(z,Ee)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){I.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(ee=>ee.identifier).filter(ee=>this.isActivated(ee)).map(ee=>this._deactivate(ee))}catch{}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,Z){return this._activator.activateByEvent(V,Z)}_activateById(V,Z){return this._activator.activateById(V,Z)}activateByIdWithErrors(V,Z){return this._activateById(V,Z).then(()=>{const se=this._activator.getActivatedExtension(V);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==_.Schemas.file)return V;const Z=await this._hostUtils.realpath(V.fsPath);return T.URI.file(Z)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const V=C.TernarySearchTree.forUris(Z=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Z));for(const Z of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Z)){const se=await this._realPathExtensionUri(Z.extensionLocation);V.set(se,Z)}return V})()),this._extensionPathIndex}_deactivate(V){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return Z;const se=this._activator.getActivatedExtension(V);if(!se)return Z;try{typeof se.module.deactivate=="function"&&(Z=Promise.resolve(se.module.deactivate()).then(void 0,ce=>(this._logService.error(ce),Promise.resolve(void 0))))}catch(ce){this._logService.error(`An error occurred when deactivating the extension '${V.value}':`),this._logService.error(ce)}try{(0,P.dispose)(se.subscriptions)}catch(ce){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this._logService.error(ce)}return Z}async _activateExtension(V,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,Z).then(se=>{const ce=se.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,Z),this._logExtensionActivationTimes(V,Z,"success",ce),se},se=>{throw this._logExtensionActivationTimes(V,Z,"failure"),se})}_logExtensionActivationTimes(V,Z,se,ce){const ee=x(V,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ee,...ce||{},outcome:se})}_doActivateExtension(V,Z){const se=x(V,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",se);const ce=this._getEntryPoint(V);if(!ce)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${Z.startup}, activationEvent: '${Z.activationEvent}'${V.identifier.value!==Z.extensionId.value?`, root cause: ${Z.extensionId.value}`:""}`),this._logService.flush();const ee=new E.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,A.joinPath)(V.extensionLocation,ce),ee),this._loadExtensionContext(V)]).then(Q=>(k.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Gn._callActivate(this._logService,V.identifier,Q[0],Q[1],ee))).then(Q=>(k.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),Q))}_loadExtensionContext(V){const Z=new m.ExtensionGlobalMemento(V,this._storage),se=new m.ExtensionMemento(V.identifier.value,!1,this._storage),ce=new L.ExtensionSecrets(V,this._secretState),ee=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Q=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([Z.whenReady,se.whenReady,this._storagePath.whenReady]).then(()=>{const oe=this;let de,ve;const ke=(0,w.isProposedApiEnabled)(V,"ipc")?this._initData.messagePorts?.get(a.ExtensionIdentifier.toKey(V.identifier)):void 0;return Object.freeze({globalState:Z,workspaceState:se,secrets:ce,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Ne){return t.join(V.extensionLocation.fsPath,Ne)},get storagePath(){return oe._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return oe._storagePath.globalValue(V).fsPath},get logPath(){return t.join(oe._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return T.URI.joinPath(oe._initData.logsLocation,V.identifier.value)},get storageUri(){return oe._storagePath.workspaceValue(V)},get globalStorageUri(){return oe._storagePath.globalValue(V)},get extensionMode(){return ee},get extension(){return de===void 0&&(de=new B(oe,V.identifier,V,Q)),de},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(V,"extensionRuntime"),oe.extensionRuntime},get environmentVariableCollection(){return oe._extHostTerminalService.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!ve){if(!ke)return;const Ne=v.Event.buffer(v.Event.fromDOMEventEmitter(ke,"message",_e=>_e.data));ke.start(),ve={onDidReceiveMessage:Ne,postMessage:ke.postMessage.bind(ke)}}return ve}})})}static _callActivate(V,Z,se,ce,ee){return se=se||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,Z,se,ce,ee).then(Q=>new E.ActivatedExtension(!1,null,ee.build(),se,Q,ce.subscriptions))}static _callActivateOptional(V,Z,se,ce,ee){if(typeof se.activate=="function")try{ee.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const Q=typeof global=="object"?global:self,oe=se.activate.apply(Q,[ce]);return ee.activateCallStop(),ee.activateResolveStart(),Promise.resolve(oe).then(de=>(ee.activateResolveStop(),de))}catch(Q){return Promise.reject(Q)}else return Promise.resolve(se)}_activateOneStartupFinished(V,Z){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:Z}).then(void 0,se=>{this._logService.error(se)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const Z of V.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(V,Z)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,ee=>{this._logService.error(ee)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ee=>this._handleWorkspaceContainsEagerExtensions(ee.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],se=this._handleWorkspaceContainsEagerExtensions(Z),ce=Promise.all([V,se]).then(()=>{});return Promise.race([ce,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ce}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension(V,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,Z){if(this.isActivated(Z.identifier))return;const se=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ce={logService:this._logService,folders:V.map(Q=>Q.uri),forceUsingSearch:se,exists:Q=>this._hostUtils.exists(Q.fsPath),checkExists:(Q,oe,de)=>this._mainThreadWorkspaceProxy.$checkExists(Q,oe,de)},ee=await(0,R.checkActivateWorkspaceContainsExtension)(ce,Z);if(!!ee)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:ee.activationEvent}).then(void 0,Q=>this._logService.error(Q))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:Z}=this._initData.environment;if(!V||!Z)throw new Error(h.localize(0,null));const se=await this._loadCommonJSModule(null,Z,new E.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(h.localize(1,null,Z.toString()));return new Promise((ce,ee)=>{const Q=(ve,ke)=>{ve?ee(ve):ce(typeof ke=="number"&&ke>0?1:0)},oe=(0,A.originalFSPath)(Z),de=se.run(oe,Q);de&&de.then&&de.then(()=>{ce(0)}).catch(ve=>{ee(ve instanceof Error&&ve.stack?ve.stack:String(ve))})})}async $extensionTestsExit(V){this._logService.info(`Extension host terminating: test runner requested exit with code ${V}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,Z){return this._resolvers[V]=Z,(0,P.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const Z=V.indexOf("+");if(Z===-1)throw new Error("Not an authority that can be resolved!");const se=V.substr(0,Z);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this._resolvers[se]}}async $resolveAuthority(V,Z){this._logService.info(`$resolveAuthority invoked for authority (${G(V)})`);const{authorityPrefix:se,resolver:ce}=await this._activateAndGetResolver(V);if(!ce)return{type:"error",error:{code:b.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${se}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ce)),k.mark(`code/extHost/willResolveAuthority/${se}`);const ee=await ce.resolve(V,{resolveAttempt:Z});k.mark(`code/extHost/didResolveAuthorityOK/${se}`);const Q={authority:V,host:ee.host,port:ee.port,connectionToken:ee.connectionToken},oe={extensionHostEnv:ee.extensionHostEnv,isTrusted:ee.isTrusted,authenticationSession:ee.authenticationSessionForInitializingExtensions?{id:ee.authenticationSessionForInitializingExtensions.id,providerId:ee.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Q,options:oe,tunnelInformation:{environmentTunnels:ee.environmentTunnels,features:ee.tunnelFeatures}}}}catch(ee){if(k.mark(`code/extHost/didResolveAuthorityError/${se}`),ee instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee}}async $getCanonicalURI(V,Z){this._logService.info(`$getCanonicalURI invoked for authority (${G(V)})`);const{authorityPrefix:se,resolver:ce}=await this._activateAndGetResolver(V);if(!ce)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${se}`);const ee=T.URI.revive(Z);if(typeof ce.getCanonicalURI=="undefined")return ee;const Q=await(0,S.asPromise)(()=>ce.getCanonicalURI(ee));return Q||ee}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,Z){return Z===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(se=>this._activateByEvent(V,!1))}async $activate(V,Z){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,Z),!0):!1}async $deltaExtensions(V,Z){V.forEach(ce=>ce.extensionLocation=T.URI.revive(ce.extensionLocation));const se=await this.getExtensionPathIndex();return await Promise.all(Z.map(async ce=>{const ee=this._registry.getExtensionDescription(ce);ee&&se.delete(await this._realPathExtensionUri(ee.extensionLocation))})),await Promise.all(V.map(async ce=>{const ee=await this._realPathExtensionUri(ce.extensionLocation);se.set(ee,ce)})),this._registry.deltaExtensions(V,Z),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let Z=c.VSBuffer.alloc(V),se=Math.random()%256;for(let ce=0;ce<V;ce++)Z.writeUInt8(se,ce);return Z}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};K=Be([Fe(0,o.IInstantiationService),Fe(1,e.IHostUtils),Fe(2,r.IExtHostRpcService),Fe(3,u.IExtHostWorkspace),Fe(4,g.IExtHostConfiguration),Fe(5,F.ILogService),Fe(6,n.IExtHostInitDataService),Fe(7,i.IExtensionStoragePaths),Fe(8,p.IExtHostTunnelService),Fe(9,d.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function x(X,V){return{id:X.identifier.value,name:X.name,extensionVersion:X.version,publisherDisplayName:X.publisher,activationEvents:X.activationEvents?X.activationEvents.join(","):null,isBuiltin:X.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class B{constructor(V,Z,se,ce){U.set(this,void 0),M.set(this,void 0),q.set(this,void 0),Ke(this,U,V,"f"),Ke(this,M,Z,"f"),Ke(this,q,se.identifier,"f"),this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ce}get isActive(){return Te(this,U,"f").isActivated(Te(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,U,"f").getExtensionExports(Te(this,q,"f"))}activate(){return Te(this,U,"f").activateByIdWithErrors(Te(this,q,"f"),{startup:!1,extensionId:Te(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,U=new WeakMap,M=new WeakMap,q=new WeakMap;function G(X){const V=X.indexOf("+");return V===-1?X:X.substring(0,V)}}),define(we[54],be([1,0,9,2,3,13,5,7,127,35,39,45,220,36,213,14,4,18,40,53]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let c=class{constructor(l,p,d,v,R,O){this._workspaceService=p,this._extensionService=d,this._editorsService=v,this._configurationService=R,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=l.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new s(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(_=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,p){const d=l;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let v=`debug:${encodeURIComponent(d.path||"")}`,R="?";return p&&(v+=`${R}session=${encodeURIComponent(p.id)}`,R="&"),v+=`${R}ref=${d.sourceReference}`,t.URI.parse(v)}else{if(d.path)return t.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const p=[];for(const d of l.getAllExtensionDescriptions())if(d.contributes){const v=d.contributes.debuggers;if(v&&v.length>0)for(const R of v)(0,f.isDebuggerMainContribution)(R)&&p.push(R.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(p=>l.push(p)),l}addBreakpoints(l){this.startBreakpoints();const p=l.filter(R=>{const O=R.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,R),!0)});this.fireBreakpointChanges(p,[],[]);const d=[],v=new Map;for(const R of p)if(R instanceof P.SourceBreakpoint){let O=v.get(R.location.uri.toString());O||(O={type:"sourceMulti",uri:R.location.uri,lines:[]},v.set(R.location.uri.toString(),O),d.push(O)),O.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof P.FunctionBreakpoint&&d.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(d)}removeBreakpoints(l){this.startBreakpoints();const p=l.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],p,[]);const d=p.filter(O=>O instanceof P.SourceBreakpoint).map(O=>O.id),v=p.filter(O=>O instanceof P.FunctionBreakpoint).map(O=>O.id),R=p.filter(O=>O instanceof P.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(d,v,R)}startDebugging(l,p,d){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,p,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,debugUI:d.debugUI,suppressSaveBeforeStart:d.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,p,d){if(!p)return new P.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:v,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,d,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,v),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(l,p,d){if(!d)return new P.Disposable(()=>{});if(!this.definesDebugType(l,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:v,factory:d}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,v),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==d),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(l,p){if(!p)return new P.Disposable(()=>{});const d=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:d,factory:p}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==p)})}async $runInTerminal(l,p){return Promise.resolve(void 0)}async $substituteVariables(l,p){if(!this._variableResolver){const[R,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,O)}let d;const v=await this.getFolder(l);return v&&(d={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(d,p)}createDebugAdapter(l,p){if(l.type==="implementation")return new n(l.implementation)}createSignService(){}async $startDASession(l,p){const d=this,v=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const O=this.convertToDto(R),L=this.createDebugAdapter(O,v);if(!L)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const _=L;return this._debugAdapters.set(l,_),this.getDebugAdapterTrackers(v).then(U=>(U&&this._debugAdaptersTrackers.set(l,U),_.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const q=M,K={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const x=await this._signService.sign(q.arguments.value);K.body={signature:x},_.sendResponse(K)}else throw new Error("no signer")}catch(x){K.success=!1,K.message=x.message,_.sendResponse(K)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(M),M=(0,f.convertToVSCPaths)(M,!0),d._debugServiceProxy.$acceptDAMessage(l,M)}),_.onError(M=>{U&&U.onError&&U.onError(M),this._debugServiceProxy.$acceptDAError(l,M.name,M.message,M.stack)}),_.onExit(M=>{U&&U.onExit&&U.onExit((0,y.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,y.withNullAsUndefined)(M),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),_.startSession()))})}$sendDAMessage(l,p){p=(0,f.convertToDAPaths)(p,!1);const d=this._debugAdaptersTrackers.get(l);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(p);const v=this._debugAdapters.get(l);v&&v.sendMessage(p)}$stopDASession(l){const p=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),p&&p.onWillStopSession&&p.onWillStopSession();const d=this._debugAdapters.get(l);return this._debugAdapters.delete(l),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const p=[],d=[],v=[];if(l.added)for(const R of l.added){const O=R.id;if(O&&!this._breakpoints.has(O)){let L;if(R.type==="function")L=new P.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")L=new P.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const _=t.URI.revive(R.uri);L=new P.SourceBreakpoint(new P.Location(_,new P.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}L._id=O,this._breakpoints.set(O,L),p.push(L)}}if(l.removed)for(const R of l.removed){const O=this._breakpoints.get(R);O&&(this._breakpoints.delete(R),d.push(O))}if(l.changed){for(const R of l.changed)if(R.id){const O=this._breakpoints.get(R.id);if(O){if(O instanceof P.FunctionBreakpoint&&R.type==="function"){const L=O;L.enabled=R.enabled,L.condition=R.condition,L.hitCondition=R.hitCondition,L.logMessage=R.logMessage,L.functionName=R.functionName}else if(O instanceof P.SourceBreakpoint&&R.type==="source"){const L=O;L.enabled=R.enabled,L.condition=R.condition,L.hitCondition=R.hitCondition,L.logMessage=R.logMessage,L.location=new P.Location(t.URI.revive(R.uri),new P.Position(R.line,R.character))}v.push(O)}}}this.fireBreakpointChanges(p,d,v)}$provideDebugConfigurations(l,p,d){return(0,A.asPromise)(async()=>{const v=this.getConfigProviderByHandle(l);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(p);return v.provideDebugConfigurations(R,d)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(l,p,d,v){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(l);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(p);return R.resolveDebugConfiguration(O,d,v)})}$resolveDebugConfigurationWithSubstitutedVariables(l,p,d,v){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(l);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(p);return R.resolveDebugConfigurationWithSubstitutedVariables(O,d,v)})}async $provideDebugAdapter(l,p){const d=this.getAdapterDescriptorFactoryByHandle(l);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(p);return this.getAdapterDescriptor(d,v).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(l){const p=await this.getSession(l);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(l){const p=await this.getSession(l);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,p){const d=await this.getSession(l);d&&d._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(l,p){const v={session:await this.getSession(l),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(l){if(l instanceof P.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof P.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const p=this._adapterFactories.filter(d=>d.type===l);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(l){const p=this._adapterFactories.filter(d=>d.handle===l);if(p.length>0)return p[0].factory}getConfigProviderByHandle(l){const p=this._configProviders.filter(d=>d.handle===l);if(p.length>0)return p[0].provider}definesDebugType(l,p){if(l.contributes){const d=l.contributes.debuggers;if(d&&d.length>0){for(const v of d)if(v.label&&v.type&&v.type===p)return!0}}return!1}getDebugAdapterTrackers(l){const d=l.configuration.type,v=this._trackerFactories.filter(R=>R.type===d||R.type==="*").map(R=>(0,A.asPromise)(()=>R.factory.createDebugAdapterTracker(l)).then(O=>O,O=>null));return Promise.race([Promise.all(v).then(R=>{const O=R.filter(L=>!!L);if(O.length>0)return new o(O)}),new Promise((R,O)=>{const L=setTimeout(()=>{clearTimeout(L),O(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(l,p){const d=p.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new P.DebugAdapterServer(d));if(l){const R=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>l.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,R))).then(O=>{if(O)return O})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,v))}daExecutableFromPackage(l,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,p,d){(l.length>0||p.length>0||d.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:p,changed:d}))}async getSession(l){if(l)if(typeof l=="string"){const p=this._debugSessions.get(l);if(p)return p}else{let p=this._debugSessions.get(l.id);if(!p){const d=await this.getFolder(l.folderUri),v=l.parent?this._debugSessions.get(l.parent):void 0;p=new m(this._debugServiceProxy,l.id,l.type,l.name,d,l.configuration,v),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(l){if(l){const p=t.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};c=Be([Fe(0,u.IExtHostRpcService),Fe(1,T.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,E.IExtHostConfiguration),Fe(5,a.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class m{constructor(l,p,d,v,R,O,L){this._debugServiceProxy=l,this._id=p,this._type=d,this._name=v,this._workspaceFolder=R,this._configuration=O,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,p)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=m;class s{constructor(l){this.value=Object.freeze({append(p){l.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=s;class b extends g.AbstractVariableResolverService{constructor(l,p,d,v,R){function O(){if(p){const L=p.activeEditor();if(L)return L.document.uri;const _=v.tabs.filter(U=>U.isActive);if(_.length>0){const U=_[0].resource;return U&&(U.primary||U.secondary)?U.primary??U.secondary:_[0].resource}}}super({getFolderUri:L=>{const _=l.filter(U=>U.name===L);if(_&&_.length>0)return _[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(L,_)=>d.getConfiguration(void 0,L).get(_),getAppRoot:()=>I.cwd(),getExecPath:()=>I.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=O();if(L)return h.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const L=O();if(L){const _=R.getWorkspaceFolder(L);if(_)return h.normalize(_.uri.fsPath)}}},getSelectedText:()=>{if(p){const L=p.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(p){const L=p.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(I.env))}}e.ExtHostVariableResolverService=b;class o{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(p=>p.onError?p.onError(l):void 0)}onExit(l,p){this.trackers.forEach(d=>d.onExit?d.onExit(l,p):void 0)}}class n extends C.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends c{constructor(l,p,d,v,R,O){super(l,p,d,v,R,O)}createVariableResolver(l,p,d){return new b(l,p,d,this._editorTabs)}};i=Be([Fe(0,u.IExtHostRpcService),Fe(1,T.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,E.IExtHostConfiguration),Fe(5,a.IExtHostEditorTabs)],i),e.WorkerExtHostDebugService=i}),define(we[273],be([1,0,71,2,5,36,30,27,14,26,4,39,40,11,8]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(m,s,b,o,n,i,r){this._apiFactory=m,this._extensionRegistry=s,this._instaService=b,this._extHostConfiguration=o,this._extHostExtensionService=n,this._initData=i,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new y(this._apiFactory,s,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(I,s)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(a,s,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(let s of m.nodeModuleName)this._factories.set(s,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(s=>m.alternativeModuleName(s))}};u=Be([Fe(2,F.IInstantiationService),Fe(3,A.IExtHostConfiguration),Fe(4,D.IExtHostExtensionService),Fe(5,T.IExtHostInitDataService),Fe(6,E.ILogService)],u),e.RequireInterceptor=u;let w=class Hn{constructor(m){if(m.environment.appRoot&&Hn.aliased.size){const s=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),b="[a-z0-9_.-]",o=`@${b}+\\/${b}+|${b}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${n}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(m));if(!s)return;const[,b,o,n]=s,i=Hn.aliased.get(o);if(i!==void 0)return console.warn(`${o} as been renamed to ${i}, please update your imports`),b+i+n}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};w.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),w=Be([Fe(0,T.IExtHostInitDataService)],w);class y{constructor(m,s,b,o,n){this._apiFactory=m,this._extensionPaths=s,this._extensionRegistry=b,this._configProvider=o,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,s){const b=this._extensionPaths.findSubstr(s);if(b){let o=this._extApiImpl.get(P.ExtensionIdentifier.toKey(b.identifier));return o||(o=this._apiFactory(b,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(b.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((n,i)=>o+=`	${i} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let I=class{constructor(m,s,b){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(k.MainContext.MainThreadTelemetry);const{environment:o}=b,n=s.getProxy(k.MainContext.MainThreadKeytar);if(o.appRoot){let i=o.appRoot.fsPath;g.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,r)=>n.$getPassword(i,r),setPassword:(i,r,l)=>n.$setPassword(i,r,l),deletePassword:(i,r)=>n.$deletePassword(i,r),findPassword:i=>n.$findPassword(i),findCredentials(i){return n.$findCredentials(i)}}}load(m,s){const b=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:b?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const s=m.length;if(s<=7||!this.alternativeNames)return;const b=s-7;if((m.charAt(b)==="/"||m.charAt(b)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};I=Be([Fe(1,C.IExtHostRpcService),Fe(2,T.IExtHostInitDataService)],I);let a=class{constructor(m,s,b){this._extensionPaths=m,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=b.getProxy(k.MainContext.MainThreadTelemetry);const o=b.getProxy(k.MainContext.MainThreadWindow);this._impl=(n,i)=>{const r=t.URI.parse(n);return i?this.callOriginal(n,i):r.scheme==="http"||r.scheme==="https"?o.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?o.$openUri(r,n,{}):this.callOriginal(n,i)}}load(m,s,b){const o=this._extensionPaths.findSubstr(s);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=b(m),this._impl}callOriginal(m,s){return this.sendNoForwardTelemetry(),this._original(m,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};a=Be([Fe(2,C.IExtHostRpcService)],a)}),define(we[274],be([1,0,13,16,71,6,2,5,267,11,61,82,26,190,14,64,39,34]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class I{constructor(c,m,s,b,o){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=s,this._rpcProtocol=new C.RPCProtocol(c,null,b),m=I._transform(m,this._rpcProtocol);const n=new D.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());n.set(g.IExtHostInitDataService,{_serviceBrand:void 0,...m,messagePorts:o}),n.set(f.IExtHostRpcService,new f.ExtHostRpcService(this._rpcProtocol)),n.set(u.IURITransformerService,new u.URITransformerService(b)),n.set(w.IHostUtils,s);const i=new E.InstantiationService(n,!0);this._disposables.add(i.invokeFunction(d=>d.get(y.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(d=>d.get(w.IExtHostExtensionService))),this._logService=i.invokeFunction(d=>d.get(T.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",m),this._extensionService=i.invokeFunction(d=>d.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(d=>{Error.prepareStackTrace=(v,R)=>{let O="",L,_;for(const U of R)O+=`
	at ${U.toString()}`,_=U.getFileName(),!L&&_&&(L=d.findSubstr(S.URI.file(_)));return r.set(v,L),`${v.name||"Error"}: ${v.message||""}${O}`}});const l=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),p=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(d=>{const v=t.transformErrorForSerialization(d),R=r.get(d);R?l.$onExtensionRuntimeError(R.identifier,v):p.$onUnexpectedError(v)})}terminate(c){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(s=>{this._logService.error(s)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();Promise.race([(0,h.timeout)(5e3),m]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(c,m){c.extensions.forEach(b=>b.extensionLocation=S.URI.revive(m.transformIncomingURIs(b.extensionLocation))),c.environment.appRoot=S.URI.revive(m.transformIncomingURIs(c.environment.appRoot));const s=c.environment.extensionDevelopmentLocationURI;return s&&(c.environment.extensionDevelopmentLocationURI=s.map(b=>S.URI.revive(m.transformIncomingURIs(b)))),c.environment.extensionTestsLocationURI=S.URI.revive(m.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=S.URI.revive(m.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=S.URI.revive(m.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=S.URI.revive(m.transformIncomingURIs(c.logsLocation)),c.logFile=S.URI.revive(m.transformIncomingURIs(c.logFile)),c.workspace=m.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=I}),define(we[275],be([1,0,175,12,7,214,35,39,45,36,34,14,54,197,13,215,53,189]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let I=class extends g.ExtHostDebugServiceBase{constructor(b,o,n,i,r,l,p){super(b,o,n,i,r,p);this._terminalService=l,this._integratedTerminalInstances=new m}createDebugAdapter(b,o){switch(b.type){case"server":return new A.SocketDebugAdapter(b);case"pipeServer":return new A.NamedPipeDebugAdapter(b);case"executable":return new A.ExecutableDebugAdapter(b,o.type)}return super.createDebugAdapter(b,o)}daExecutableFromPackage(b,o){const n=A.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),b.type);if(n)return new k.DebugAdapterExecutable(n.command,n.args,n.options)}createSignService(){return new E.SignService}async $runInTerminal(b,o){if(b.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(U=>{this._integratedTerminalInstances.onTerminalClosed(U)}));const n=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),l=b.title||h.localize(0,null),p=JSON.stringify({shell:i,shellArgs:r});let d=await this._integratedTerminalInstances.checkout(p,l),v,R=!1;if(d)v=b.cwd;else{const U={shellPath:i,shellArgs:r,cwd:b.cwd,name:l,iconPath:new k.ThemeIcon("debug")};R=!0,d=this._terminalService.createTerminalFromOptions(U,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,p)}d.show(!0);const O=await d.processId;R?await new Promise(U=>setTimeout(U,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?d.sendText("cls"):i.indexOf("bash")>=0?d.sendText("clear"):t.isWindows?d.sendText("cls"):d.sendText("clear"));const L=(0,u.prepareCommand)(i,b.args,v,b.env);d.sendText(L);const _=this.onDidTerminateDebugSession(U=>{U.id===o&&(this._integratedTerminalInstances.free(d),_.dispose())});return O}else if(b.kind==="external")return c(b,await this._configurationService.getConfigProvider());return super.$runInTerminal(b,o)}createVariableResolver(b,o,n){return new g.ExtHostVariableResolverService(b,o,n,this._editorTabs,this._workspaceService)}};I=Be([Fe(0,D.IExtHostRpcService),Fe(1,S.IExtHostWorkspace),Fe(2,P.IExtHostExtensionService),Fe(3,C.IExtHostDocumentsAndEditors),Fe(4,T.IExtHostConfiguration),Fe(5,F.IExtHostTerminalService),Fe(6,w.IExtHostEditorTabs)],I),e.ExtHostDebugService=I;let a;function c(s,b){if(!a)if(t.isWindows)a=new y.WindowsExternalTerminalService;else if(t.isMacintosh)a=new y.MacExternalTerminalService;else if(t.isLinux)a=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=b.getConfiguration("terminal");return a.runInTerminal(s.title,s.cwd,s.args,s.env||{},o.external||{})}e.runInExternalTerminal=c;class m{constructor(){this._terminalInstances=new Map}async checkout(b,o){const i=[...this._terminalInstances.entries()].map(([r,l])=>(0,f.createCancelablePromise)(async p=>{if(r.name!==o||l.lastUsedAt!==-1&&await(0,u.hasChildProcesses)(await r.processId))return null;const d=Date.now();return l.lastUsedAt+m.minUseDelay>d||p.isCancellationRequested||l.config!==b?null:(l.lastUsedAt=d,r)}));return await(0,f.firstParallel)(i,r=>!!r)}insert(b,o){this._terminalInstances.set(b,{lastUsedAt:Date.now(),config:o})}free(b){const o=this._terminalInstances.get(b);o&&(o.lastUsedAt=-1)}onTerminalClosed(b){this._terminalInstances.delete(b)}}m.minUseDelay=1e3}),define(we[276],be([1,0,9,2,114,35,54,45,36,43,34,14,26,70,10,11,65,53,22,80]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let c=class extends E.ExtHostTaskBase{constructor(s,b,o,n,i,r,l,p,d){super(s,b,o,n,i,r,l,p);this.workspaceService=o,this.editorTabs=d,b.remote.isRemote&&b.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:b.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,b){const o=b;if(!b.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const n=E.TaskHandleDTO.from(o,this.workspaceService),i=await this._proxy.$getTaskExecution(n);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(i,b);return this._proxy.$executeTask(n).catch(()=>{}),r}else{const n=E.TaskDTO.from(b,s);if(n===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,b,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),b);return this._proxy.$executeTask(n).catch(()=>{}),i}}provideTasksInternal(s,b,o,n){const i=[];if(n)for(let r of n){this.checkDeprecation(r,o),(!r.definition||!s[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const l=E.TaskDTO.from(r,o.extension);l&&(i.push(l),E.CustomExecutionDTO.is(l.execution)&&b.push(this.addCustomExecution(l,r,!0)))}return{tasks:i,extension:o.extension}}async resolveTaskInternal(s){return s}async getVariableResolver(s){if(this._variableResolver===void 0){const b=await this._configurationService.getConfigProvider();this._variableResolver=new S.ExtHostVariableResolverService(s,this._editorService,b,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(s){let b=s&&s.length>0?s[0]:void 0;if(!b){const o=t.URI.file((0,a.homedir)());b=new T.WorkspaceFolder({uri:o,name:I.basename(o),index:0})}return{uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,b){const o=t.URI.revive(s),n={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(o),r=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.getVariableResolver(r),p=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(r);for(let d of b.variables)n.variables[d]=await l.resolveAsync(p,d);if(b.process!==void 0){let d;if(b.process.path!==void 0){d=b.process.path.split(h.delimiter);for(let v=0;v<d.length;v++)d[v]=await l.resolveAsync(p,d[v])}n.process=await k.win32.findExecutable(await l.resolveAsync(p,b.process.name),b.process.cwd!==void 0?await l.resolveAsync(p,b.process.cwd):void 0,d)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(s,b,o){return k.win32.findExecutable(s,b,o)}};c=Be([Fe(0,D.IExtHostRpcService),Fe(1,g.IExtHostInitDataService),Fe(2,A.IExtHostWorkspace),Fe(3,P.IExtHostDocumentsAndEditors),Fe(4,C.IExtHostConfiguration),Fe(5,F.IExtHostTerminalService),Fe(6,u.ILogService),Fe(7,w.IExtHostApiDeprecationService),Fe(8,y.IExtHostEditorTabs)],c),e.ExtHostTask=c}),define(we[138],be([1,0,17,13,21,49,32,10,9,22,18,2,31]),function(te,e,h,t,k,A,S,P,C,T,F,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(c,m,s,b){this.query=c,this.provider=m,this.fileUtils=s,this.processType=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,m){const s=this.query.folderQueries||[],b=new k.CancellationTokenSource;return m.onCancellationRequested(()=>b.cancel()),new Promise((o,n)=>{this.collector=new u(c);let i=!1;const r=(l,p)=>{if(!i&&!this.isLimitHit){const d=this.resultSize(l);y(l)&&typeof this.query.maxResults=="number"&&this.resultCount+d>this.query.maxResults&&(this.isLimitHit=!0,i=!0,b.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const v=this.resultSize(l);this.resultCount+=v,(v>0||!y(l))&&this.collector.add(l,p)}};Promise.all(s.map((l,p)=>this.searchInFolder(l,d=>r(d,p),b.token))).then(l=>{b.dispose(),this.collector.flush();const p=l.some(d=>!!d&&!!d.limitHit);o({limitHit:this.isLimitHit||p,messages:(0,h.flatten)(l.map(d=>d?.message?(0,F.isArray)(d.message)?d.message:[d.message]:[])),stats:{type:this.processType}})},l=>{b.dispose();const p=(0,A.toErrorMessage)(l);n(new Error(p))})})}resultSize(c){return y(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,m){const s=Array.isArray(c.ranges)?c.ranges:[c.ranges],b=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:s.slice(0,m),preview:{matches:b.slice(0,m),text:c.preview.text},uri:c.uri}}async searchInFolder(c,m,s){const b=new g.QueryGlobTester(this.query,c),o=[],n={report:l=>{if(!this.validateProviderResult(l))return;const p=c.folder.scheme===P.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(l.uri))):void 0,d=T.relativePath(c.folder,l.uri);if(d){const v=b.includedInQuery(d,C.basename(d),p);(0,t.isThenable)(v)?o.push(v.then(R=>{R&&m(l)})):v&&m(l)}}},i=this.getSearchOptionsForFolder(c),r=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,n,s);return o.length&&await Promise.all(o),r}validateProviderResult(c){if(y(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const m=(0,g.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),s=(0,g.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),b={folder:D.URI.from(c.folder),excludes:s,includes:m,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return b.usePCRE2=this.query.usePCRE2,b}}e.TextSearchManager=E;function f(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class u{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,m=>this.sendItems(m))}add(c,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!T.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(w(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=u;function w(a){return y(a)?{preview:{matches:(0,h.mapArrayOrNot)(a.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:a.preview.text},ranges:(0,h.mapArrayOrNot)(a.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function y(a){return!!a.preview}e.extensionResultIsMatch=y;class I{constructor(c,m){this.maxBatchSize=c,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,m){!c||this.addItemToBatch(c,m)}addItems(c,m){!c||this.addItemsToBatch(c,m)}addItemToBatch(c,m){this.batch.push(c),this.batchSize+=m,this.onUpdate()}addItemsToBatch(c,m){this.batch=this.batch.concat(c),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(we[72],be([1,0,6,5,4,270,14,64,11,2,138]),function(te,e,h,t,k,A,S,P,C,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let D=class{constructor(u,w,y){this.extHostRpc=u,this._uriTransformer=w,this._logService=y,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,w){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const y=this._handlePool++;return this._textSearchProvider.set(y,w),this._proxy.$registerTextSearchProvider(y,this._transformScheme(u)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(y),this._proxy.$unregisterProvider(y)})}registerFileSearchProvider(u,w){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const y=this._handlePool++;return this._fileSearchProvider.set(y,w),this._proxy.$registerFileSearchProvider(y,this._transformScheme(u)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(y),this._proxy.$unregisterProvider(y)})}$provideFileSearchResults(u,w,y,I){const a=g(y),c=this._fileSearchProvider.get(u);if(c)return this._fileSearchManager.fileSearch(a,c,m=>{this._proxy.$handleFileMatch(u,w,m.map(s=>s.resource))},I);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,w,y,I){const a=this._textSearchProvider.get(u);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const c=g(y);return this.createTextSearchManager(c,a).search(s=>this._proxy.$handleTextMatch(u,w,s),I)}$enableExtensionHostSearch(){}createTextSearchManager(u,w){return new F.TextSearchManager(u,w,{readdir:y=>Promise.resolve([]),toCanonicalName:y=>y},"textSearchProvider")}};D=Be([Fe(0,S.IExtHostRpcService),Fe(1,P.IURITransformerService),Fe(2,C.ILogService)],D),e.ExtHostSearch=D;function g(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(E),extraFileResources:f.extraFileResources&&f.extraFileResources.map(u=>T.URI.revive(u))}}e.reviveQuery=g;function E(f){return{...f,folder:T.URI.revive(f.folder)}}}),define(we[277],be([1,0,61,136,35,134,36,38,45,34,70,54,72,90,51,65,137,66,44,89,125,53,135,11,229]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a,c,m,s,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(b.ILoggerService,s.ExtHostLoggerService),(0,h.registerSingleton)(b.ILogService,o.ExtHostLogService),(0,h.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,h.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,h.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,h.registerSingleton)(y.IExtHostConsumerFileSystem,y.ExtHostConsumerFileSystem),(0,h.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService),(0,h.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,h.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(I.IExtHostFileSystemInfo,I.ExtHostFileSystemInfo),(0,h.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,h.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch),(0,h.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,h.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,h.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,h.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,h.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,h.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,h.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,h.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,h.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs)}),define(we[91],be([1,0,17,11,31,69]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function S(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.anchorGlob=S;function P(D,g,E,f){const u=(0,h.mapArrayOrNot)(E,C),w=new k.TextSearchMatch(g,u,f),y=w.preview.matches;return{ranges:(0,h.mapArrayOrNot)(u,T),uri:D,preview:{text:w.preview.text,matches:(0,h.mapArrayOrNot)(y,T)}}}e.createTextSearchResult=P;function C(D){return new k.SearchRange(D.start.line,D.start.character,D.end.line,D.end.character)}function T(D){return new A.Range(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let F=class{constructor(g,E){this.prefix=g,this.logService=E}appendLine(g){this.logService.debug(`${this.prefix}#search`,g)}};F=Be([Fe(1,t.ILogService)],F),e.OutputChannel=F}),define(we[278],be([1,0,37,9,78,28,12,8,91,279]),function(te,e,h,t,k,A,S,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const F=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(a,c,m,s){const b=g(a,c,m,s),o=c.folder.fsPath;return{cmd:h.spawn(F,b.args,{cwd:o}),rgDiskPath:F,siblingClauses:b.siblingClauses,rgArgs:b,cwd:o}}e.spawnRipgrepCmd=D;function g(a,c,m,s){const b=["--files","--hidden","--case-sensitive"];f([c],m,!1).forEach(n=>{const i=(0,C.anchorGlob)(n);if(b.push("-g",i),S.isMacintosh){const r=(0,k.normalizeNFD)(i);r!==i&&b.push("-g",r)}});const o=E([c],s,void 0,!1);return o.globArgs.forEach(n=>{const i=`!${(0,C.anchorGlob)(n)}`;if(b.push("-g",i),S.isMacintosh){const r=(0,k.normalizeNFD)(i);r!==i&&b.push("-g",r)}}),c.disregardIgnoreFiles!==!1?b.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&b.push("--no-ignore-parent"),c.ignoreSymlinks||b.push("--follow"),a.exists&&b.push("--quiet"),b.push("--no-config"),c.disregardGlobalIgnoreFiles&&b.push("--no-ignore-global"),{args:b,siblingClauses:o.siblingClauses}}function E(a,c,m,s=!0){const b=[];let o={};return a.forEach(n=>{const i=Object.assign({},n.excludePattern||{},c||{}),r=u(i,s?n.folder.fsPath:void 0,m);b.push(...r.globArgs),r.siblingClauses&&(o=Object.assign(o,r.siblingClauses))}),{globArgs:b,siblingClauses:o}}e.foldersToRgExcludeGlobs=E;function f(a,c,m=!0){const s=[];return a.forEach(b=>{const o=Object.assign({},c||{},b.includePattern||{}),n=u(o,m?b.folder.fsPath:void 0);s.push(...n.globArgs)}),s}e.foldersToIncludeGlobs=f;function u(a,c,m){const s=[],b={};return Object.keys(a).forEach(o=>{if(m&&m.has(o)||!o)return;const n=a[o];o=y(c?w(c,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof n=="boolean"&&n?(o.startsWith("\\\\")&&(o+="**"),s.push(I(o))):n&&n.when&&(b[o]=n)}),{globArgs:s,siblingClauses:b}}function w(a,c){return t.isAbsolute(c)?c:t.join(a,c)}e.getAbsoluteGlob=w;function y(a){return a=P.rtrim(a,"\\"),P.rtrim(a,"/")}function I(a){return A.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=I}),define(we[280],be([1,0,37,60,9,104,17,49,32,78,28,12,46,8,18,29,31,278,101]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(o=>o())});class c{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&C.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,I.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&C.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(i=>{const r=Object.assign({},i.excludePattern||{},this.config.excludePattern||{}),l=i.folder.fsPath;n.folderQueries.map(p=>p.folder.fsPath).filter(p=>p!==l).forEach(p=>{(0,F.isEqualOrParent)(p,l)&&(r[k.relative(l,p)]=!0)}),this.folderExcludePatterns.set(l,new s(r,l))})}cancel(){this.isCanceled=!0,a.forEach(n=>n())}walk(n,i,r,l,p){if(this.fileWalkSW=g.StopWatch.create(!1),this.isCanceled)return p(null,this.isLimitHit);i.forEach(d=>{const v=k.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,v)||this.matchFile(r,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=g.StopWatch.create(!1),this.parallel(n,(d,v)=>{this.call(this.cmdTraversal,this,d,r,l,R=>{if(R){const O=(0,P.toErrorMessage)(R);console.error(O),this.errors.push(O),v(R,void 0)}else v(null,void 0)})},(d,v)=>{this.fileWalkSW.stop();const R=d?S.coalesce(d)[0]:null;p(R,this.isLimitHit)})}parallel(n,i,r){const l=new Array(n.length),p=new Array(n.length);let d=!1,v=0;if(n.length===0)return r(null,[]);n.forEach((R,O)=>{i(R,(L,_)=>{if(L?(d=!0,l[O]=null,p[O]=L):(l[O]=_,p[O]=null),++v===n.length)return r(d?p:null,l)})})}call(n,i,...r){try{n.apply(i,r)}catch(l){r[r.length-1](l)}}cmdTraversal(n,i,r,l){const p=n.folder.fsPath,d=D.isMacintosh;let v;const R=()=>v&&v.kill();a.add(R);let O=x=>{a.delete(R),O=()=>{},l(x)},L="";const _=this.initDirectoryTree();let U;const M=(0,y.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);v=M.cmd,U=!Object.keys(M.siblingClauses).length;const q=M.rgArgs.args.map(x=>x.match(/^-/)?x:`'${x}'`).join(" ");let K=`${M.rgDiskPath} ${q}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(K+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),r({message:K}),this.cmdResultCount=0,this.collectStdout(v,"utf8",r,(x,B,G)=>{if(x){O(x);return}if(this.isLimitHit){O();return}const V=(L+(d?T.normalizeNFC(B||""):B)).split(`
`);if(G){const Z=V.length;V[Z-1]=V[Z-1].trim(),V[Z-1]||V.pop()}else L=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,U){for(const Z of V)if(this.matchFile(i,{base:p,relativePath:Z,searchPath:this.getSearchPath(n,Z)}),this.isLimitHit){R();break}(G||this.isLimitHit)&&O();return}this.addDirectoryEntries(n,_,p,V,i),G&&(this.matchDirectoryTree(_,p,i),O())})}spawnFindCmd(n){const i=this.folderExcludePatterns.get(n.folder.fsPath),r=i.getBasenameTerms(),l=i.getPathTerms(),p=["-L","."];if(r.length||l.length){p.push("-not","(","(");for(const d of r)p.push("-name",d),p.push("-o");for(const d of l)p.push("-path",d),p.push("-o");p.pop(),p.push(")","-prune",")")}return p.push("-type","f"),h.spawn("find",p,{cwd:n.folder.fsPath})}readStdout(n,i,r){let l="";this.collectStdout(n,i,()=>{},(p,d,v)=>{if(p){r(p);return}l+=d,v&&r(null,l)})}collectStdout(n,i,r,l){let p=(R,O,L)=>{(R||L)&&(p=()=>{},this.cmdSW&&this.cmdSW.stop()),l(R,O,L)},d=!1;n.stdout?(this.forwardData(n.stdout,i,p),n.stdout.once("data",()=>d=!0)):r({message:"stdout is null"});let v;n.stderr?v=this.collectData(n.stderr):r({message:"stderr is null"}),n.on("error",R=>{p(R)}),n.on("close",R=>{let O;!d&&(O=this.decodeData(v,i))&&b(O)?p(new Error(`command failed with error code ${R}: ${this.decodeData(v,i)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),p(null,"",!0))})}forwardData(n,i,r){const l=new A.StringDecoder(i);return n.on("data",p=>{r(null,l.write(p))}),l}collectData(n){const i=[];return n.on("data",r=>{i.push(r)}),i}decodeData(n,i){const r=new A.StringDecoder(i);return n.map(l=>r.write(l)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:i},r,l,p){l.indexOf(this.filePattern)!==-1&&this.matchFile(p,{base:r,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const d=v=>{const R=k.basename(v),O=k.dirname(v);let L=i[O];L||(L=i[O]=[],d(O)),L.push({base:r,relativePath:v,basename:R,searchPath:this.getSearchPath(n,v)})};l.forEach(d)}matchDirectoryTree({rootEntries:n,pathToEntries:i},r,l){const p=this,d=this.folderExcludePatterns.get(r),v=this.filePattern;function R(O){p.directoriesWalked++;const L=C.hasSiblingFn(()=>O.map(_=>_.basename));for(let _=0,U=O.length;_<U;_++){const M=O[_],{relativePath:q,basename:K}=M;if(d.test(q,K,v!==K?L:void 0))continue;const x=i[q];if(x)R(x);else{if(p.filesWalked++,q===v)continue;p.matchFile(l,M)}if(p.isLimitHit)break}}R(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,i,r,l,p){const d=n.folder,v=C.hasSiblingFn(()=>r);this.parallel(r,(R,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const L=i?[i,R].join(k.sep):R;if(this.folderExcludePatterns.get(n.folder.fsPath).test(L,R,this.config.filePattern!==R?v:void 0))return O(null);const _=[d.fsPath,L].join(k.sep);t.lstat(_,(U,M)=>{if(U||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(_,M,(q,K)=>q||this.isCanceled||this.isLimitHit?O(null):K.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(_,M,(x,B)=>x||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?O(null):(this.walkedPaths[B]=!0,u.Promises.readdir(_).then(G=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(n,L,G,l,X=>O(X||null))},G=>{O(null)})))):(this.filesWalked++,L===this.filePattern||this.maxFilesize&&f.isNumber(K.size)&&K.size>this.maxFilesize||this.matchFile(l,{base:d.fsPath,relativePath:L,searchPath:this.getSearchPath(n,L)}),O(null,void 0)))})},R=>{const O=R&&S.coalesce(R);return p(O&&O.length>0?O[0]:void 0)})}matchFile(n,i){this.isFileMatch(i)&&(!this.includePattern||this.includePattern(i.relativePath,k.basename(i.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(i))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,w.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,i,r){return i.isSymbolicLink()?t.stat(n,r):r(null,i)}realPathIfNeeded(n,i,r){return i.isSymbolicLink()?t.realpath(n,(l,p)=>l?r(l):r(null,p)):r(null,n)}getSearchPath(n,i){return n.folderName?k.join(n.folderName,i):i}}e.FileWalker=c;class m{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new c(n)}search(n,i,r){this.walker.walk(this.folderQueries,this.extraFiles,n,i,(l,p)=>{r(l,{limitHit:p,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class s{constructor(n,i){this.expression=n,this.root=i,this.init(n)}init(n){let i,r;Object.keys(n).filter(l=>n[l]).forEach(l=>{k.isAbsolute(l)?(i=i||C.getEmptyExpression(),i[l]=n[l]):(r=r||C.getEmptyExpression(),r[l]=n[l])}),this.absoluteParsedExpr=i&&C.parse(i,{trimForExclusions:!0}),this.relativeParsedExpr=r&&C.parse(r,{trimForExclusions:!0})}test(n,i,r){return this.relativeParsedExpr&&this.relativeParsedExpr(n,i,r)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,n),i,r)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...C.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...C.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...C.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...C.getPathTerms(this.relativeParsedExpr)),n}}function b(o){const n=o.trim().split(`
`),i=n[0].trim();if(i.startsWith("Error parsing regex"))return i;if(i.startsWith("regex parse error"))return E.uppercaseFirstLetter(n[n.length-1].trim());if(i.startsWith("error parsing glob")||i.startsWith("unsupported encoding"))return i.charAt(0).toUpperCase()+i.substr(1);if(i==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(i.startsWith("Literal "))return i}e.rgErrorMsgForDisplay=b}),define(we[281],be([1,0,97,23]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===o)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,S=512,P=512*8,C=512*128;var T;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(T=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class F extends Error{constructor(n,i){super(n);this.decodeStreamErrorKind=i}}e.DecodeStreamError=F;class D{constructor(n){this.iconvLiteDecoder=n}static async create(n){let i;if(n!==e.UTF8)i=(await new Promise((l,p)=>{te(["@vscode/iconv-lite-umd"],l,p)})).getDecoder(u(n));else{const r=new TextDecoder;i={write(l){return r.decode(l,{stream:!0})},end(){return r.decode()}}}return new D(i)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function g(o,n){const i=n.minBytesRequiredForDetection??n.guessEncoding?P:S;return new Promise((r,l)=>{const p=(0,h.newWriteableStream)(_=>_.join("")),d=[];let v=0,R,O;const L=async()=>{try{const _=await b({buffer:t.VSBuffer.concat(d),bytesRead:v},n.guessEncoding);if(_.seemsBinary&&n.acceptTextOnly)throw new F("Stream is binary but only text is accepted for decoding",1);_.encoding=await n.overwriteEncoding(_.encoding),R=await D.create(_.encoding);const U=R.write(t.VSBuffer.concat(d).buffer);p.write(U),d.length=0,v=0,r({stream:p,detected:_})}catch(_){O?.dispose(),p.destroy(),l(_)}};O=(0,h.listenStream)(o,{onData:async _=>{R?p.write(R.write(_.buffer)):(d.push(_),v+=_.byteLength,v>=i&&(o.pause(),await L(),setTimeout(()=>o.resume())))},onError:_=>p.error(_),onEnd:async()=>{R||await L(),p.end(R?.end())}})})}e.toDecodeStream=g;async function E(o,n,i){const l=(await new Promise((v,R)=>{te(["@vscode/iconv-lite-umd"],v,R)})).getEncoder(u(n),i);let p=!1,d=!1;return{read(){if(d)return null;const v=o.read();if(typeof v!="string"){if(d=!0,!p&&i?.addBOM)switch(n){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=l.end();return R&&R.length>0?(p=!0,t.VSBuffer.wrap(R)):null}return p=!0,t.VSBuffer.wrap(l.write(v))}}}e.toEncodeReadable=E;async function f(o){return(await new Promise((i,r)=>{te(["@vscode/iconv-lite-umd"],i,r)})).encodingExists(u(o))}e.encodingExists=f;function u(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=u;function w(o,n){if(!o||n<e.UTF16be_BOM.length)return null;const i=o.readUInt8(0),r=o.readUInt8(1);if(i===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const l=o.readUInt8(2);return i===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=w;const y=["ascii","utf-16","utf-32"];async function I(o){const n=await new Promise((d,v)=>{te(["jschardet"],d,v)}),i=o.slice(0,C),r=m(i.buffer),l=n.detect(r);if(!l||!l.encoding)return null;const p=l.encoding.toLowerCase();return 0<=y.indexOf(p)?null:c(l.encoding)}const a={ibm866:"cp866",big5:"cp950"};function c(o){const n=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[n]||n}function m(o){let n="";for(let i=0;i<o.length;i++)n+=String.fromCharCode(o[i]);return n}function s(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const n=o.match(/windows(\d+)/);return n?"windows-"+n[1]:o}}}e.toCanonicalName=s;function b({buffer:o,bytesRead:n},i){let r=w(o,n),l=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&o){let p=!0,d=!0,v=!1;for(let R=0;R<n&&R<A;R++){const O=R%2==1,L=o.readUInt8(R)===0;if(L&&(v=!0),p&&(O&&!L||!O&&L)&&(p=!1),d&&(O&&L||!O&&!L)&&(d=!1),L&&!p&&!d)break}v&&(p?r=e.UTF16le:d?r=e.UTF16be:l=!0)}return i&&!l&&!r&&o?I(o.slice(0,n)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:l,encoding:r}}e.detectEncodingFromBuffer=b,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(we[139],be([1,0,281,29,138]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends k.TextSearchManager{constructor(P,C,T=t,F="searchProcess"){super(P,C,{readdir:D=>T.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,h.toCanonicalName)(D)},F)}}e.NativeTextSearchManager=A}),define(we[282],be([1,0,61,4]),function(te,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class k{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(S){if(S&&this._dragOperations.has(S)){const P=this._dragOperations.get(S);return this._dragOperations.delete(S),P}}addDragOperationTransfer(S,P){this._dragOperations.set(S,P)}}e.TreeViewsDragAndDropService=k,(0,h.registerSingleton)(e.ITreeViewsDragAndDropService,k)}),define(we[283],be([1,0,173,22,2,3,6,13,7,18,17,15,21,208,282]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(I,a){if((0,T.isString)(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let c;return Array.isArray(I.highlights)&&(c=I.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),c=c.length?c:void 0),{label:I.label,highlights:c}}}class w{constructor(a,c,m){this._proxy=a,this.commands=c,this.logService=m,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeViewsDragAndDropService;function s(b){return b&&b.$treeViewId&&b.$treeItemHandle}c.registerArgumentProcessor({processArgument:b=>s(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(o=>s(o)?this.convertArgument(o):o):b})}registerTreeDataProvider(a,c,m){const s=this.createTreeView(a,{treeDataProvider:c},m);return{dispose:()=>s.dispose()}}createTreeView(a,c,m){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=c.dragAndDropController?.dropMimeTypes,b=c.dragAndDropController?.dragMimeTypes,o=!!c.dragAndDropController?.handleDrag,n=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,dropMimeTypes:s,dragMimeTypes:b,hasHandleDrag:o}),i=this.createExtHostTreeView(a,c,m);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(r){i.message=r},get title(){return i.title},set title(r){i.title=r},get description(){return i.description},set description(r){i.description=r},reveal:(r,l)=>i.reveal(r,l),dispose:async()=>{await n,this.treeViews.delete(a),i.dispose()}}}$getChildren(a,c){const m=this.treeViews.get(a);return m?m.getChildren(c):Promise.reject(new Error((0,h.localize)(0,null,a)))}async $handleDrop(a,c,m,s,b,o,n){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,h.localize)(1,null,a)));const r=E.TreeDataTransferConverter.toITreeDataTransfer(c);return o===a&&n&&await this.addAdditionalTransferItems(r,i,n,s,b),i.onDrop(r,m,s)}async addAdditionalTransferItems(a,c,m,s,b){const o=this.treeDragAndDropService.removeDragOperationTransfer(b);if(o)(await o)?.forEach((n,i)=>{n&&a.set(i,n)});else if(b&&c.handleDrag){const n=c.handleDrag(m,a,s);this.treeDragAndDropService.addDragOperationTransfer(b,n),await n}return a}async $handleDrag(a,c,m,s){const b=this.treeViews.get(a);if(!b)return Promise.reject(new Error((0,h.localize)(2,null,a)));const o=await this.addAdditionalTransferItems(new Map,b,c,s,m);if(!!o)return E.TreeDataTransferConverter.toTreeDataTransferDTO(o)}async $hasResolve(a){const c=this.treeViews.get(a);if(!c)throw new Error((0,h.localize)(3,null,a));return c.hasResolve}$resolve(a,c,m){const s=this.treeViews.get(a);if(!s)throw new Error((0,h.localize)(4,null,a));return s.resolveTreeItem(c,m)}$setExpanded(a,c,m){const s=this.treeViews.get(a);if(!s)throw new Error((0,h.localize)(5,null,a));s.setExpanded(c,m)}$setSelection(a,c){const m=this.treeViews.get(a);if(!m)throw new Error((0,h.localize)(6,null,a));m.setSelection(c)}$setVisible(a,c){const m=this.treeViews.get(a);if(!m)throw new Error((0,h.localize)(7,null,a));m.setVisible(c)}createExtHostTreeView(a,c,m){const s=new y(a,c,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(a,s),s}convertArgument(a){const c=this.treeViews.get(a.$treeViewId);return c?c.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=w;class y extends S.Disposable{constructor(a,c,m,s,b,o){super();if(this.viewId=a,this.proxy=m,this.commands=s,this.logService=b,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,o.contributes&&o.contributes.views)for(const r in o.contributes.views)for(const l of o.contributes.views[r])l.id===a&&(this._title=l.name);this.dataProvider=c.treeDataProvider,this.dndController=c.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(r=>this._onDidChangeData.fire({message:!1,element:r}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,i;this._register(A.Event.debounce(this._onDidChangeData.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(p=>i=p),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(l.element)?r.elements.push(...l.element):r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0)(({message:r,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=i;return n=null,this.refresh(l).then(()=>p())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,T.isUndefinedOrNull)(a))}async getChildren(a){const c=a?this.getExtensionElement(a):void 0;if(a&&!c)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let m=this.getChildrenNodes(a);return m||(m=await this.fetchChildrenNodes(c)),m?m.map(s=>s.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,c){c=c||{select:!0,focus:!1};const m=(0,T.isUndefinedOrNull)(c.select)?!0:c.select,s=(0,T.isUndefinedOrNull)(c.focus)?!1:c.focus,b=(0,T.isUndefinedOrNull)(c.expand)?!1:c.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(o=>this.resolveTreeNode(a,o[o.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:o.map(i=>i.item)},{select:m,focus:s,expand:b})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:s,expand:b})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,c){const m=this.getExtensionElement(a);m&&(c?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(a){(0,F.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a,c,m){const s=[];for(const b of a){const o=this.getExtensionElement(b);o&&s.push(o)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,c,m),c}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,c,m){const s=this.getExtensionElement(c);if(!!s)return(0,P.asPromise)(()=>this.dndController?.handleDrop(a,s,m))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,c){if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(a);if(m){const s=this.nodes.get(m);if(s){const b=await this.dataProvider.resolveTreeItem(s.extensionItem,m,c)??s.extensionItem;return s.item.tooltip=this.getTooltip(b.tooltip),s.item.command=this.getCommand(s.disposableStore,b.command),s.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(c=>c?this.resolveUnknownParentChain(c).then(m=>this.resolveTreeNode(c,m[m.length-1]).then(s=>(m.push(s),m))):Promise.resolve([]))}resolveParent(a){const c=this.nodes.get(a);return c?Promise.resolve(c.parent?this.elements.get(c.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,c){const m=this.nodes.get(a);return m?Promise.resolve(m):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(s=>this.createHandle(a,s,c,!0)).then(s=>this.getChildren(c?c.item.handle:void 0).then(()=>{const b=this.getExtensionElement(s);if(b){const o=this.nodes.get(b);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}getChildrenNodes(a){if(a){let c;if(typeof a=="string"){const m=this.getExtensionElement(a);c=m?this.nodes.get(m):void 0}else c=a;return c&&c.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const c=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=a?this.nodes.get(a):void 0,s=await this.dataProvider.getChildren(a);if(c.token.isCancellationRequested)return;const b=await Promise.all((0,F.coalesce)(s||[]).map(async o=>{const n=await this.dataProvider.getTreeItem(o);return n&&!c.token.isCancellationRequested?this.createAndRegisterTreeNode(o,n,m):null}));return c.token.isCancellationRequested?void 0:(0,F.coalesce)(b)}finally{c.dispose()}}refresh(a){if(a.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(a);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const c=new Set,m=a.map(b=>this.nodes.get(b));for(const b of m)if(b&&!c.has(b.item.handle)){let o=b;for(;o&&o.parent&&m.findIndex(n=>o&&o.parent&&n&&n.item.handle===o.parent.item.handle)===-1;){const n=this.elements.get(o.parent.item.handle);o=n?this.nodes.get(n):void 0}o&&!o.parent&&c.add(b.item.handle)}const s=[];return c.forEach(b=>{const o=this.elements.get(b);if(o){const n=this.nodes.get(o);n&&(!n.parent||!c.has(n.parent.item.handle))&&s.push(b)}}),s}refreshHandles(a){const c={};return Promise.all(a.map(m=>this.refreshNode(m).then(s=>{s&&(c[m]=s.item)}))).then(()=>Object.keys(c).length?this.proxy.$refresh(this.viewId,c):void 0)}refreshNode(a){const c=this.getExtensionElement(a);if(c){const m=this.nodes.get(c);if(m)return this.clearChildren(c),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(s=>{if(s){const b=this.createTreeNode(c,s,m.parent);return this.updateNodeCache(c,b,m,m.parent),m.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,c,m){const s=this.createTreeNode(a,c,m);if(c.id&&this.elements.has(s.item.handle))throw new Error((0,h.localize)(8,null,c.id));return this.addNodeToCache(a,s),this.addNodeToParentCache(s,m),s}getTooltip(a){return C.MarkdownString.isMarkdownString(a)?D.MarkdownString.from(a):a}getCommand(a,c){return c?this.commands.toInternal(c,a):void 0}createTreeNode(a,c,m){const s=new S.DisposableStore,b=this.createHandle(a,c,m),o=this.getLightIconPath(c);return{item:{handle:b,parentHandle:m?m.item.handle:void 0,label:u(c.label,this.extension),description:c.description,resourceUri:c.resourceUri,tooltip:this.getTooltip(c.tooltip),command:this.getCommand(s,c.command),contextValue:c.contextValue,icon:o,iconDark:this.getDarkIconPath(c)||o,themeIcon:this.getThemeIcon(c),collapsibleState:(0,T.isUndefinedOrNull)(c.collapsibleState)?C.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation},extensionItem:c,parent:m,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(a){return a.iconPath instanceof C.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:c,label:m,resourceUri:s},b,o){if(c)return`${y.ID_HANDLE_PREFIX}/${c}`;const n=u(m,this.extension),i=b?b.item.handle:y.LABEL_HANDLE_PREFIX;let r=n?n.label:s?(0,t.basename)(s):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const l=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,p=this.getChildrenNodes(b)||[];let d,v=0;do{if(d=`${i}/${v}:${r}`,o||!this.elements.has(d)||l===d)break;v++}while(v<=p.length);return d}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon))return typeof a.iconPath=="string"||k.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return k.URI.isUri(a)?a:k.URI.file(a)}addNodeToCache(a,c){this.elements.set(c.item.handle,a),this.nodes.set(a,c)}updateNodeCache(a,c,m,s){this.elements.delete(c.item.handle),this.nodes.delete(a),c.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(a,c);const b=this.getChildrenNodes(s)||[],o=b.filter(n=>n.item.handle===m.item.handle)[0];o&&b.splice(b.indexOf(o),1,c)}addNodeToParentCache(a,c){c?(c.children||(c.children=[]),c.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const c=this.nodes.get(a);if(c){if(c.children)for(const m of c.children){const s=this.elements.get(m.item.handle);s&&this.clear(s)}c.children=void 0}}else this.clearAll()}clear(a){const c=this.nodes.get(a);if(c){if(c.children)for(const m of c.children){const s=this.elements.get(m.item.handle);s&&this.clear(s)}this.nodes.delete(a),this.elements.delete(c.item.handle),c.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}y.LABEL_HANDLE_PREFIX="0",y.ID_HANDLE_PREFIX="1"}),define(we[284],be([1,0,21,16,3,47,2,115,111,151,110,42,5,133,234,233,38,235,36,236,237,238,222,239,45,39,240,241,244,245,246,136,224,251,252,253,90,34,255,283,15,7,258,68,137,35,74,211,243,83,134,70,54,72,11,64,14,26,247,206,51,65,231,256,205,67,66,261,259,260,232,44,254,257,89,53,125,249,69,250,10,119,248,203,242,6,30,212]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I,a,c,m,s,b,o,n,i,r,l,p,d,v,R,O,L,_,U,M,q,K,x,B,G,X,V,Z,se,ce,ee,Q,oe,de,ve,ke,Ne,_e,Ee,z,W,N,$,j,re,he,Ce,Ae,We,$e,je,He,Ue,Qe,et,Re,tt,ie,ae,J,pe,Se,Me,ze,Ye,st,pt,mt,Ve,ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function _t(nt){const lt=nt.get(z.IExtHostInitDataService),Rt=nt.get(Qe.IExtHostFileSystemInfo),It=nt.get(We.IExtHostConsumerFileSystem),kt=nt.get(n.IExtHostExtensionService),dt=nt.get(Z.IExtHostWorkspace),Ot=nt.get(ae.IExtHostTelemetry),Mt=nt.get(I.IExtHostConfiguration),Ft=nt.get(_e.IURITransformerService),fe=nt.get(Ee.IExtHostRpcService),Ie=nt.get(U.IExtHostStorage),ge=nt.get(Ae.IExtensionStoragePaths),ne=nt.get(Ne.ILoggerService),ye=nt.get(Ne.ILogService),Le=nt.get($.IExtHostTunnelService),xe=nt.get(j.IExtHostApiDeprecationService),Ge=nt.get(V.IExtHostWindow),ct=nt.get(tt.IExtHostSecretState),vt=nt.get(ie.IExtHostEditorTabs);fe.set(g.ExtHostContext.ExtHostFileSystemInfo,Rt),fe.set(g.ExtHostContext.ExtHostLogLevelServiceShape,ne),fe.set(g.ExtHostContext.ExtHostWorkspace,dt),fe.set(g.ExtHostContext.ExtHostConfiguration,Mt),fe.set(g.ExtHostContext.ExtHostExtensionService,kt),fe.set(g.ExtHostContext.ExtHostStorage,Ie),fe.set(g.ExtHostContext.ExtHostTunnelService,Le),fe.set(g.ExtHostContext.ExtHostWindow,Ge),fe.set(g.ExtHostContext.ExtHostSecretState,ct),fe.set(g.ExtHostContext.ExtHostTelemetry,Ot),fe.set(g.ExtHostContext.ExtHostEditorTabs,vt);const St=fe.set(g.ExtHostContext.ExtHostDecorations,nt.get(oe.IExtHostDecorations)),Et=fe.set(g.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(o.IExtHostDocumentsAndEditors)),rt=fe.set(g.ExtHostContext.ExtHostCommands,nt.get(w.IExtHostCommands)),ut=fe.set(g.ExtHostContext.ExtHostTerminalService,nt.get(M.IExtHostTerminalService)),wt=fe.set(g.ExtHostContext.ExtHostDebugService,nt.get(ve.IExtHostDebugService)),Nt=fe.set(g.ExtHostContext.ExtHostSearch,nt.get(ke.IExtHostSearch)),ht=fe.set(g.ExtHostContext.ExtHostTask,nt.get(de.IExtHostTask)),Pt=fe.set(g.ExtHostContext.ExtHostOutputService,nt.get(v.IExtHostOutputService)),Ut=fe.set(g.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(fe)),Ct=fe.set(g.ExtHostContext.ExtHostDocuments,new b.ExtHostDocuments(fe,Et)),Bt=fe.set(g.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(fe,Et,ye)),xt=fe.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(ye,Ct,fe.getProxy(g.MainContext.MainThreadBulkEdits))),gt=fe.set(g.ExtHostContext.ExtHostNotebook,new W.ExtHostNotebookController(fe,rt,Et,Ct,ge)),en=fe.set(g.ExtHostContext.ExtHostNotebookDocuments,new st.ExtHostNotebookDocuments(ye,gt)),Yt=fe.set(g.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(ye,fe,gt)),tn=fe.set(g.ExtHostContext.ExtHostNotebookKernels,new J.ExtHostNotebookKernels(fe,lt,gt,rt,ye)),an=fe.set(g.ExtHostContext.ExtHostNotebookRenderers,new Se.ExtHostNotebookRenderers(fe,gt)),Tt=fe.set(g.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(fe,Et)),nn=fe.set(g.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(fe.getProxy(g.MainContext.MainThreadTreeViews),rt,ye)),Sn=fe.set(g.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(fe.getProxy(g.MainContext.MainThreadEditorInsets),Tt,lt)),Kt=fe.set(g.ExtHostContext.ExtHostDiagnostics,new a.ExtHostDiagnostics(fe,ye,Rt)),Xt=fe.set(g.ExtHostContext.ExtHostLanguages,new p.ExtHostLanguages(fe,Ct,rt.converter,Ft)),at=fe.set(g.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(fe,Ft,Ct,rt,Kt,ye,xe)),ln=fe.set(g.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(fe,at)),Vt=fe.set(g.ExtHostContext.ExtHostFileSystemEventService,new r.ExtHostFileSystemEventService(fe,ye,Et)),jt=fe.set(g.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(fe,dt,rt)),rn=fe.set(g.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(fe,rt,ye)),Cn=fe.set(g.ExtHostContext.ExtHostComments,(0,y.createExtHostComments)(fe,rt,Ct)),pn=fe.set(g.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(fe.getProxy(g.MainContext.MainThreadProgress))),yn=fe.set(g.ExtHostContext.ExtHosLabelService,new ee.ExtHostLabelService(fe)),vn=fe.set(g.ExtHostContext.ExtHostTheming,new N.ExtHostTheming(fe)),sn=fe.set(g.ExtHostContext.ExtHostAuthentication,new re.ExtHostAuthentication(fe)),cn=fe.set(g.ExtHostContext.ExtHostTimeline,new he.ExtHostTimeline(fe,rt)),Jt=fe.set(g.ExtHostContext.ExtHostWebviews,new X.ExtHostWebviews(fe,{remote:lt.remote},dt,ye,xe)),un=fe.set(g.ExtHostContext.ExtHostWebviewPanels,new He.ExtHostWebviewPanels(fe,Jt,dt)),Dn=fe.set(g.ExtHostContext.ExtHostCustomEditors,new je.ExtHostCustomEditors(fe,Ct,ge,Jt,un)),In=fe.set(g.ExtHostContext.ExtHostWebviewViews,new $e.ExtHostWebviewViews(fe,Jt)),$t=fe.set(g.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(fe,rt)),kn=fe.set(g.ExtHostContext.ExtHostUriOpeners,new Re.ExtHostUriOpeners(fe));fe.set(g.ExtHostContext.ExtHostInteractive,new pt.ExtHostInteractive(fe,gt,Et,rt));const Pn=(0,se.values)(g.ExtHostContext);fe.assertRegistered(Pn);const Tn=new Ue.ExtHostBulkEdits(fe,Et),dn=new u.ExtHostClipboard(fe),hn=new d.ExtHostMessageService(fe,ye),Qt=new c.ExtHostDialogs(fe),zt=new _.ExtHostStatusBar(fe,rt.converter);return f.ExtHostApiCommands.register(rt),function(Oe,Lt,Zt){const ft=function(){let le=!Oe.isUnderDevelopment;function me(){le||(ye.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function Pe(Je){if(Array.isArray(Je))Je.forEach(Pe);else if(typeof Je=="string")me();else{const bt=Je;typeof bt.scheme=="undefined"&&me(),typeof bt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Oe,"documentFiltersExclusive")}return Je}}(),An={getSession(le,me,Pe){return sn.getSession(Oe,le,me,Pe)},async hasSession(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"authSession"),!!await sn.getSession(Oe,le,me,{silent:!0})},get onDidChangeSessions(){return sn.onDidChangeSessions},registerAuthenticationProvider(le,me,Pe,Je){return sn.registerAuthenticationProvider(le,me,Pe,Je)}},Rn={registerCommand(le,me,Pe){return rt.registerCommand(!0,le,me,Pe,void 0,Oe)},registerTextEditorCommand(le,me,Pe){return rt.registerCommand(!0,le,(...Je)=>{const bt=Tt.getActiveTextEditor();if(!bt){ye.warn("Cannot execute "+le+" because there is no active text editor.");return}return bt.edit(Dt=>{me.apply(Pe,[bt,Dt,...Je])}).then(Dt=>{Dt||ye.warn("Edits from command "+le+" were not applied.")},Dt=>{ye.warn("An error occurred while running command "+le,Dt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(le,me,Pe)=>((0,Ve.checkProposedApiEnabled)(Oe,"diffCommand"),rt.registerCommand(!0,le,async(...Je)=>{const bt=Et.activeEditor(!0);if(!bt){ye.warn("Cannot execute "+le+" because there is no active text editor.");return}const Dt=await Tt.getDiffInformation(bt.id);me.apply(Pe,[Dt,...Je])},void 0,void 0,Oe)),executeCommand(le,...me){return rt.executeCommand(le,...me)},getCommands(le=!1){return rt.getCommands(le)}},wn={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return dn.value},get shell(){return ut.getDefaultShell(!1)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ot.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Oe,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Oe,"telemetry"),Ot.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const le=Date.now()-new Date(lt.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,me){return Ge.openUri(le,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===lt.environment.appUriScheme)return Ut.createAppUri(le);try{return await Ge.asExternalUri(le,{allowTunneling:!!lt.remote.authority})}catch(me){if((0,ze.matchesScheme)(le,Me.Schemas.http)||(0,ze.matchesScheme)(le,Me.Schemas.https))return le;throw me}},get remoteName(){return(0,Q.getRemoteName)(lt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind}};lt.environment.extensionTestsLocationURI||Object.freeze(wn);const bn=lt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Ln={createTestController(le,me,Pe){return Pe&&(0,Ve.checkProposedApiEnabled)(Oe,"testRefresh"),$t.createTestController(le,me,Pe)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Oe,"testObserver"),$t.createTestObserver()},runTests(le){return(0,Ve.checkProposedApiEnabled)(Oe,"testObserver"),$t.runTests(le)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Oe,"testObserver"),$t.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Oe,"testObserver"),$t.results}},On={getExtension(le){const me=Lt.getExtensionDescription(le);if(me)return new n.Extension(kt,Oe.identifier,me,bn)},get all(){return Lt.getAllExtensionDescriptions().map(le=>new n.Extension(kt,Oe.identifier,le,bn))},get onDidChange(){return Lt.onDidChange}},fn={createDiagnosticCollection(le){return Kt.createDiagnosticCollection(Oe.identifier,le)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:le=>Kt.getDiagnostics(le),getLanguages(){return Xt.getLanguages()},setTextDocumentLanguage(le,me){return Xt.changeLanguage(le.uri,me)},match(le,me){return(0,F.score)(x.LanguageSelector.from(le),me.uri,me.languageId,!0)},registerCodeActionsProvider(le,me,Pe){return at.registerCodeActionProvider(Oe,ft(le),me,Pe)},registerCodeLensProvider(le,me){return at.registerCodeLensProvider(Oe,ft(le),me)},registerDefinitionProvider(le,me){return at.registerDefinitionProvider(Oe,ft(le),me)},registerDeclarationProvider(le,me){return at.registerDeclarationProvider(Oe,ft(le),me)},registerImplementationProvider(le,me){return at.registerImplementationProvider(Oe,ft(le),me)},registerTypeDefinitionProvider(le,me){return at.registerTypeDefinitionProvider(Oe,ft(le),me)},registerHoverProvider(le,me){return at.registerHoverProvider(Oe,ft(le),me,Oe.identifier)},registerEvaluatableExpressionProvider(le,me){return at.registerEvaluatableExpressionProvider(Oe,ft(le),me,Oe.identifier)},registerInlineValuesProvider(le,me){return at.registerInlineValuesProvider(Oe,ft(le),me,Oe.identifier)},registerDocumentHighlightProvider(le,me){return at.registerDocumentHighlightProvider(Oe,ft(le),me)},registerLinkedEditingRangeProvider(le,me){return at.registerLinkedEditingRangeProvider(Oe,ft(le),me)},registerReferenceProvider(le,me){return at.registerReferenceProvider(Oe,ft(le),me)},registerRenameProvider(le,me){return at.registerRenameProvider(Oe,ft(le),me)},registerDocumentSymbolProvider(le,me,Pe){return at.registerDocumentSymbolProvider(Oe,ft(le),me,Pe)},registerWorkspaceSymbolProvider(le){return at.registerWorkspaceSymbolProvider(Oe,le)},registerDocumentFormattingEditProvider(le,me){return at.registerDocumentFormattingEditProvider(Oe,ft(le),me)},registerDocumentRangeFormattingEditProvider(le,me){return at.registerDocumentRangeFormattingEditProvider(Oe,ft(le),me)},registerOnTypeFormattingEditProvider(le,me,Pe,...Je){return at.registerOnTypeFormattingEditProvider(Oe,ft(le),me,[Pe].concat(Je))},registerDocumentSemanticTokensProvider(le,me,Pe){return at.registerDocumentSemanticTokensProvider(Oe,ft(le),me,Pe)},registerDocumentRangeSemanticTokensProvider(le,me,Pe){return at.registerDocumentRangeSemanticTokensProvider(Oe,ft(le),me,Pe)},registerSignatureHelpProvider(le,me,Pe,...Je){return typeof Pe=="object"?at.registerSignatureHelpProvider(Oe,ft(le),me,Pe):at.registerSignatureHelpProvider(Oe,ft(le),me,typeof Pe=="undefined"?[]:[Pe,...Je])},registerCompletionItemProvider(le,me,...Pe){return at.registerCompletionItemProvider(Oe,ft(le),me,Pe)},registerInlineCompletionItemProvider(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"inlineCompletions"),at.registerInlineCompletionsProvider(Oe,ft(le),me)},registerDocumentLinkProvider(le,me){return at.registerDocumentLinkProvider(Oe,ft(le),me)},registerColorProvider(le,me){return at.registerColorProvider(Oe,ft(le),me)},registerFoldingRangeProvider(le,me){return at.registerFoldingRangeProvider(Oe,ft(le),me)},registerSelectionRangeProvider(le,me){return at.registerSelectionRangeProvider(Oe,le,me)},registerCallHierarchyProvider(le,me){return at.registerCallHierarchyProvider(Oe,le,me)},registerTypeHierarchyProvider(le,me){return at.registerTypeHierarchyProvider(Oe,le,me)},setLanguageConfiguration:(le,me)=>at.setLanguageConfiguration(Oe,le,me),getTokenInformationAtPosition(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"tokenInformation"),Xt.tokenAtPosition(le,me)},registerInlayHintsProvider(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"inlayHints"),at.registerInlayHintsProvider(Oe,le,me)},createLanguageStatusItem(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"languageStatus"),Xt.createLanguageStatusItem(Oe,le,me)}},Fn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(le,me,Pe){const Je=await(S.URI.isUri(le)?Promise.resolve(En.openTextDocument(le)):Promise.resolve(le));return Tt.showTextDocument(Je,me,Pe)},createTextEditorDecorationType(le){return Tt.createTextEditorDecorationType(Oe,le)},onDidChangeActiveTextEditor(le,me,Pe){return Tt.onDidChangeActiveTextEditor(le,me,Pe)},onDidChangeVisibleTextEditors(le,me,Pe){return Tt.onDidChangeVisibleTextEditors(le,me,Pe)},onDidChangeTextEditorSelection(le,me,Pe){return Tt.onDidChangeTextEditorSelection(le,me,Pe)},onDidChangeTextEditorOptions(le,me,Pe){return Tt.onDidChangeTextEditorOptions(le,me,Pe)},onDidChangeTextEditorVisibleRanges(le,me,Pe){return Tt.onDidChangeTextEditorVisibleRanges(le,me,Pe)},onDidChangeTextEditorViewColumn(le,me,Pe){return Tt.onDidChangeTextEditorViewColumn(le,me,Pe)},onDidCloseTerminal(le,me,Pe){return ut.onDidCloseTerminal(le,me,Pe)},onDidOpenTerminal(le,me,Pe){return ut.onDidOpenTerminal(le,me,Pe)},onDidChangeActiveTerminal(le,me,Pe){return ut.onDidChangeActiveTerminal(le,me,Pe)},onDidChangeTerminalDimensions(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"terminalDimensions"),ut.onDidChangeTerminalDimensions(le,me,Pe)},onDidChangeTerminalState(le,me,Pe){return ut.onDidChangeTerminalState(le,me,Pe)},onDidWriteTerminalData(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),ut.onDidWriteTerminalData(le,me,Pe)},get state(){return Ge.state},onDidChangeWindowState(le,me,Pe){return Ge.onDidChangeWindowState(le,me,Pe)},showInformationMessage(le,...me){return hn.showMessage(Oe,A.default.Info,le,me[0],me.slice(1))},showWarningMessage(le,...me){return hn.showMessage(Oe,A.default.Warning,le,me[0],me.slice(1))},showErrorMessage(le,...me){return hn.showMessage(Oe,A.default.Error,le,me[0],me.slice(1))},showQuickPick(le,me,Pe){return jt.showQuickPick(le,me,Pe)},showWorkspaceFolderPick(le){return jt.showWorkspaceFolderPick(le)},showInputBox(le,me){return jt.showInput(le,me)},showOpenDialog(le){return Qt.showOpenDialog(le)},showSaveDialog(le){return Qt.showSaveDialog(le)},createStatusBarItem(le,me,Pe){let Je,bt,Dt;return typeof le=="string"?(Je=le,bt=me,Dt=Pe):(bt=le,Dt=me),zt.createStatusBarEntry(Oe,Je,bt,Dt)},setStatusBarMessage(le,me){return zt.setStatusBarMessage(le,me)},withScmProgress(le){return xe.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),pn.withProgress(Oe,{location:B.ProgressLocation.SourceControl},(me,Pe)=>le({report(Je){}}))},withProgress(le,me){return pn.withProgress(Oe,le,me)},createOutputChannel(le){return Pt.createOutputChannel(le,Oe)},createWebviewPanel(le,me,Pe,Je){return un.createWebviewPanel(Oe,le,me,Pe,Je)},createWebviewTextEditorInset(le,me,Pe,Je){return(0,Ve.checkProposedApiEnabled)(Oe,"editorInsets"),Sn.createWebviewEditorInset(le,me,Pe,Je,Oe)},createTerminal(le,me,Pe){return typeof le=="object"?"pty"in le?ut.createExtensionTerminal(le):ut.createTerminalFromOptions(le):ut.createTerminal(le,me,Pe)},registerTerminalLinkProvider(le){return ut.registerLinkProvider(le)},registerTerminalProfileProvider(le,me){return ut.registerProfileProvider(Oe,le,me)},registerTreeDataProvider(le,me){return nn.registerTreeDataProvider(le,me,Oe)},createTreeView(le,me){return nn.createTreeView(le,me,Oe)},registerWebviewPanelSerializer:(le,me)=>un.registerWebviewPanelSerializer(Oe,le,me),registerCustomEditorProvider:(le,me,Pe={})=>Dn.registerCustomEditorProvider(Oe,le,me,Pe),registerFileDecorationProvider(le){return St.registerFileDecorationProvider(le,Oe.identifier)},registerUriHandler(le){return Ut.registerUriHandler(Oe.identifier,le)},createQuickPick(){return jt.createQuickPick(Oe)},createInputBox(){return jt.createInputBox(Oe.identifier)},get activeColorTheme(){return vn.activeColorTheme},onDidChangeActiveColorTheme(le,me,Pe){return vn.onDidChangeActiveColorTheme(le,me,Pe)},registerWebviewViewProvider(le,me,Pe){return In.registerWebviewViewProvider(Oe,le,me,Pe?.webviewOptions)},get activeNotebookEditor(){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeActiveNotebookEditor(le,me,Pe)},get visibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(le,me,Pe)},onDidChangeNotebookEditorVisibleRanges(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(le,me,Pe)},showNotebookDocument(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.showNotebookDocument(le,me)},registerExternalUriOpener(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"externalUriOpener"),kn.registerExternalUriOpener(Oe.identifier,le,me,Pe)},get tabs(){return(0,Ve.checkProposedApiEnabled)(Oe,"tabs"),vt.tabs},get activeTab(){return(0,Ve.checkProposedApiEnabled)(Oe,"tabs"),vt.activeTab},get onDidChangeTabs(){return(0,Ve.checkProposedApiEnabled)(Oe,"tabs"),vt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,Ve.checkProposedApiEnabled)(Oe,"tabs"),vt.onDidChangeActiveTab},getInlineCompletionItemController(le){return(0,Ve.checkProposedApiEnabled)(Oe,"inlineCompletions"),l.InlineCompletionController.get(le)}},En={get rootPath(){return xe.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(le){throw t.readonly()},getWorkspaceFolder(le){return dt.getWorkspaceFolder(le)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(le){throw t.readonly()},get workspaceFile(){return dt.workspaceFile},set workspaceFile(le){throw t.readonly()},updateWorkspaceFolders:(le,me,...Pe)=>dt.updateWorkspaceFolders(Oe,le,me||0,...Pe),onDidChangeWorkspaceFolders:function(le,me,Pe){return dt.onDidChangeWorkspace(le,me,Pe)},asRelativePath:(le,me)=>dt.getRelativePath(le,me),findFiles:(le,me,Pe,Je)=>dt.findFiles(le,me,Pe,Oe.identifier,Je),findTextInFiles:(le,me,Pe,Je)=>{(0,Ve.checkProposedApiEnabled)(Oe,"findTextInFiles");let bt,Dt;return typeof me=="object"?(bt=me,Dt=Pe):(bt={},Dt=me,Je=Pe),dt.findTextInFiles(le,bt||{},Dt,Oe.identifier,Je)},saveAll:le=>dt.saveAll(le),applyEdit(le){return Tn.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,me,Pe,Je)=>Vt.createFileSystemWatcher(dt,Oe,le,me,Pe,Je),get textDocuments(){return Ct.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw t.readonly()},openTextDocument(le){let me;const Pe=le;if(typeof le=="string")me=Promise.resolve(S.URI.file(le));else if(S.URI.isUri(le))me=Promise.resolve(le);else if(!Pe||typeof Pe=="object")me=Ct.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(Je=>Ct.ensureDocumentData(Je).then(bt=>bt.document))},onDidOpenTextDocument:(le,me,Pe)=>Ct.onDidAddDocument(le,me,Pe),onDidCloseTextDocument:(le,me,Pe)=>Ct.onDidRemoveDocument(le,me,Pe),onDidChangeTextDocument:(le,me,Pe)=>Ct.onDidChangeDocument(le,me,Pe),onDidSaveTextDocument:(le,me,Pe)=>Ct.onDidSaveDocument(le,me,Pe),onWillSaveTextDocument:(le,me,Pe)=>xt.getOnWillSaveTextDocumentEvent(Oe)(le,me,Pe),get notebookDocuments(){return gt.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,me){let Pe;if(S.URI.isUri(le))Pe=le,await gt.openNotebookDocument(le);else if(typeof le=="string")Pe=S.URI.revive(await gt.createNotebookDocument({viewType:le,content:me}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Pe).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(le,me,Pe,Je){return gt.registerNotebookSerializer(Oe,le,me,Pe,(0,Ve.isProposedApiEnabled)(Oe,"notebookLiveShare")?Je:void 0)},registerNotebookContentProvider:(le,me,Pe,Je)=>((0,Ve.checkProposedApiEnabled)(Oe,"notebookContentProvider"),gt.registerNotebookContentProvider(Oe,le,me,Pe,(0,Ve.isProposedApiEnabled)(Oe,"notebookLiveShare")?Je:void 0)),onDidChangeConfiguration:(le,me,Pe)=>Zt.onDidChangeConfiguration(le,me,Pe),getConfiguration(le,me){return me=arguments.length===1?void 0:me,Zt.getConfiguration(le,me,Oe)},registerTextDocumentContentProvider(le,me){return Bt.registerTextDocumentContentProvider(le,me)},registerTaskProvider:(le,me)=>(xe.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),ht.registerTaskProvider(Oe,le,me)),registerFileSystemProvider(le,me,Pe){return(0,mt.combinedDisposable)(ln.registerFileSystemProvider(Oe,le,me,Pe),It.addFileSystemProvider(le,me))},get fs(){return It.value},registerFileSearchProvider:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Nt.registerFileSearchProvider(le,me)),registerTextSearchProvider:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"textSearchProvider"),Nt.registerTextSearchProvider(le,me)),registerRemoteAuthorityResolver:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),kt.registerRemoteAuthorityResolver(le,me)),registerResourceLabelFormatter:le=>((0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),yn.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,me,Pe)=>Vt.onDidCreateFile(le,me,Pe),onDidDeleteFiles:(le,me,Pe)=>Vt.onDidDeleteFile(le,me,Pe),onDidRenameFiles:(le,me,Pe)=>Vt.onDidRenameFile(le,me,Pe),onWillCreateFiles:(le,me,Pe)=>Vt.getOnWillCreateFileEvent(Oe)(le,me,Pe),onWillDeleteFiles:(le,me,Pe)=>Vt.getOnWillDeleteFileEvent(Oe)(le,me,Pe),onWillRenameFiles:(le,me,Pe)=>Vt.getOnWillRenameFileEvent(Oe)(le,me,Pe),openTunnel:le=>((0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),Le.openTunnel(Oe,le).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),Le.getTunnels()},onDidChangeTunnels:(le,me,Pe)=>((0,Ve.checkProposedApiEnabled)(Oe,"resolvers"),Le.onDidChangeTunnels(le,me,Pe)),registerPortAttributesProvider:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"portsAttributes"),Le.registerPortsAttributesProvider(le,me)),registerTimelineProvider:(le,me)=>((0,Ve.checkProposedApiEnabled)(Oe,"timeline"),cn.registerTimelineProvider(le,me,Oe.identifier,rt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:le=>((0,Ve.checkProposedApiEnabled)(Oe,"workspaceTrust"),dt.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,me,Pe)=>dt.onDidGrantWorkspaceTrust(le,me,Pe)},Nn={get inputBox(){return xe.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),rn.getLastInputBox(Oe)},createSourceControl(le,me,Pe){return rn.createSourceControl(Oe,le,me,Pe)}},Mn={createCommentController(le,me){return Cn.createCommentController(Oe,le,me)}},Un={get activeDebugSession(){return wt.activeDebugSession},get activeDebugConsole(){return wt.activeDebugConsole},get breakpoints(){return wt.breakpoints},onDidStartDebugSession(le,me,Pe){return wt.onDidStartDebugSession(le,me,Pe)},onDidTerminateDebugSession(le,me,Pe){return wt.onDidTerminateDebugSession(le,me,Pe)},onDidChangeActiveDebugSession(le,me,Pe){return wt.onDidChangeActiveDebugSession(le,me,Pe)},onDidReceiveDebugSessionCustomEvent(le,me,Pe){return wt.onDidReceiveDebugSessionCustomEvent(le,me,Pe)},onDidChangeBreakpoints(le,me,Pe){return wt.onDidChangeBreakpoints(le,me,Pe)},registerDebugConfigurationProvider(le,me,Pe){return wt.registerDebugConfigurationProvider(le,me,Pe||ot.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,me){return wt.registerDebugAdapterDescriptorFactory(Oe,le,me)},registerDebugAdapterTrackerFactory(le,me){return wt.registerDebugAdapterTrackerFactory(le,me)},startDebugging(le,me,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?wt.startDebugging(le,me,{parentSession:Pe}):wt.startDebugging(le,me,Pe||{})},stopDebugging(le){return wt.stopDebugging(le)},addBreakpoints(le){return wt.addBreakpoints(le)},removeBreakpoints(le){return wt.removeBreakpoints(le)},asDebugSourceUri(le,me){return wt.asDebugSourceUri(le,me)}},Bn={registerTaskProvider:(le,me)=>ht.registerTaskProvider(Oe,le,me),fetchTasks:le=>ht.fetchTasks(le),executeTask:le=>ht.executeTask(Oe,le),get taskExecutions(){return ht.taskExecutions},onDidStartTask:(le,me,Pe)=>ht.onDidStartTask(le,me,Pe),onDidEndTask:(le,me,Pe)=>ht.onDidEndTask(le,me,Pe),onDidStartTaskProcess:(le,me,Pe)=>ht.onDidStartTaskProcess(le,me,Pe),onDidEndTaskProcess:(le,me,Pe)=>ht.onDidEndTaskProcess(le,me,Pe)},Wn={createNotebookController(le,me,Pe,Je,bt){return tn.createNotebookController(Oe,le,me,Pe,Je,(0,Ve.isProposedApiEnabled)(Oe,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(le,me)=>gt.registerNotebookCellStatusBarItemProvider(Oe,le,me),get onDidSaveNotebookDocument(){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),en.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return an.createRendererMessaging(Oe,le)},onDidChangeNotebookDocumentMetadata(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),en.onDidChangeNotebookDocumentMetadata(le,me,Pe)},onDidChangeNotebookCells(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeNotebookCells(le,me,Pe)},onDidChangeNotebookCellExecutionState(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),tn.onDidChangeNotebookCellExecutionState(le,me,Pe)},onDidChangeCellOutputs(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeCellOutputs(le,me,Pe)},onDidChangeCellMetadata(le,me,Pe){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookEditor"),gt.onDidChangeCellMetadata(le,me,Pe)},createConcatTextDocument(le,me){return(0,Ve.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new Ce.ExtHostNotebookConcatDocument(gt,Ct,le,me)}};return{version:lt.version,authentication:An,commands:Rn,comments:Mn,debug:Un,env:wn,extensions:On,languages:fn,notebooks:Wn,scm:Nn,tasks:Bn,tests:Ln,window:Fn,workspace:En,Breakpoint:B.Breakpoint,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:ot.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestions,Hover:B.Hover,IndentAction:T.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:E.UIKind,Uri:S.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TreeDataTransfer:B.TreeDataTransfer,TreeDataTransferItem:B.TreeDataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=_t}),define(we[285],be([1,0,286,295,296,2,297]),function(te,e,h,t,k,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(D,g,E,f,u,w){const y=w.environment.useHostProxy,I=typeof y=="boolean"?y:!w.remote.isRemote,a=(0,S.createProxyResolver)({resolveProxy:m=>D.resolveProxy(m),getHttpProxySetting:()=>g.getConfiguration("http").get("proxy"),log:(m,s,...b)=>{switch(m){case S.LogLevel.Trace:f.trace(s,...b);break;case S.LogLevel.Debug:f.debug(s,...b);break;case S.LogLevel.Info:f.info(s,...b);break;case S.LogLevel.Warning:f.warn(s,...b);break;case S.LogLevel.Error:f.error(s,...b);break;case S.LogLevel.Critical:f.critical(s,...b);break;case S.LogLevel.Off:break;default:o(m,s,b);break}function o(n,i,...r){f.error("Unknown log level",n),f.error(i,...r)}},getLogLevel:()=>f.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:I,env:process.env}),c=C(g,a);return F(E,c)}e.connectProxyResolver=P;function C(D,g){const E={config:D.getConfiguration("http").get("proxySupport")||"off"};D.onDidChangeConfiguration(u=>{E.config=D.getConfiguration("http").get("proxySupport")||"off"});const f={config:!!D.getConfiguration("http").get("systemCertificates")};return D.onDidChangeConfiguration(u=>{f.config=!!D.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},h,(0,S.createHttpPatch)(h,g,{config:"off"},f,!0)),on:Object.assign({},h,(0,S.createHttpPatch)(h,g,{config:"on"},f,!0)),override:Object.assign({},h,(0,S.createHttpPatch)(h,g,{config:"override"},f,!0)),onRequest:Object.assign({},h,(0,S.createHttpPatch)(h,g,E,f,!0)),default:Object.assign(h,(0,S.createHttpPatch)(h,g,E,f,!1))},https:{off:Object.assign({},t,(0,S.createHttpPatch)(t,g,{config:"off"},f,!0)),on:Object.assign({},t,(0,S.createHttpPatch)(t,g,{config:"on"},f,!0)),override:Object.assign({},t,(0,S.createHttpPatch)(t,g,{config:"override"},f,!0)),onRequest:Object.assign({},t,(0,S.createHttpPatch)(t,g,E,f,!0)),default:Object.assign(t,(0,S.createHttpPatch)(t,g,E,f,!1))},tls:Object.assign(k,(0,S.createTlsPatch)(k))}}const T=new Map;function F(D,g){return D.getExtensionPathIndex().then(E=>{const f=te.__$__nodeRequire("module"),u=f._load;f._load=function(y,I,a){if(y==="tls")return g.tls;if(y!=="http"&&y!=="https")return u.apply(this,arguments);const c=g[y],m=E.findSubstr(A.URI.file(I.filename));let s=T.get(m);if(s||T.set(m,s={}),!s[y]){let b=c.default;s[y]={...b}}return s[y]}})}}),define(we[140],be([1,0,37,298,104,17,74,32,9,8,2,31,69,299,279,91]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=f.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class y{constructor(d){this.outputChannel=d}provideTextSearchResults(d,v,R,O){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((L,_)=>{O.onCancellationRequested(()=>X());const U=b(d,v),M=v.folder.fsPath,q=U.map(ee=>ee.match(/^-/)?ee:`'${ee}'`).join(" ");this.outputChannel.appendLine(`${w} ${q}
 - cwd: ${M}`);let K=h.spawn(w,U,{cwd:M});K.on("error",ee=>{console.error(ee),this.outputChannel.appendLine("Error: "+(ee&&ee.message)),_((0,D.serializeSearchError)(new D.SearchError(ee&&ee.message,D.SearchErrorCode.rgProcessError)))});let x=!1;const B=new c(v.maxResults,M,v.previewOptions);B.on("result",ee=>{x=!0,Z="",R.report(ee)});let G=!1;const X=()=>{G=!0,K&&K.kill(),B&&B.cancel()};let V=!1;B.on("hitLimit",()=>{V=!0,X()});let Z="";K.stdout.on("data",ee=>{B.handleData(ee),x||(Z+=ee)});let se=!1;K.stdout.once("data",()=>se=!0);let ce="";K.stderr.on("data",ee=>{const Q=ee.toString();this.outputChannel.appendLine(Q),ce+=Q}),K.on("close",()=>{if(this.outputChannel.appendLine(se?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(x?"Got result from parser":"No result from parser"),Z&&this.outputChannel.appendLine(`Got data without result: ${Z}`),this.outputChannel.appendLine(""),G)L({limitHit:V});else{B.flush(),K=null;let ee;ce&&!se&&(ee=I(ce))?_((0,D.serializeSearchError)(new D.SearchError(ee.message,ee.code))):L({limitHit:V})}})})}}e.RipgrepTextSearchEngine=y;function I(p){const d=p.split(`
`),v=d[0].trim();if(d.some(O=>O.startsWith("regex parse error")))return new D.SearchError(a(d),D.SearchErrorCode.regexParseError);const R=v.match(/grep config error: unknown encoding: (.*)/);if(R)return new D.SearchError(`Unknown encoding: ${R[1]}`,D.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new D.SearchError(v.charAt(0).toUpperCase()+v.substr(1),D.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new D.SearchError(v.charAt(0).toUpperCase()+v.substr(1),D.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new D.SearchError(v,D.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=I;function a(p){const d=["Regex parse error"],v=p.filter(R=>R.startsWith("PCRE2:"));if(v.length>=1){const R=v[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const O=R.split(":")[1];d.push(":"+O)}}return d.join("")}e.buildRegexParseError=a;class c extends t.EventEmitter{constructor(d,v,R){super();this.maxResults=d,this.rootFolder=v,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,v){return super.on(d,v),this}handleData(d){if(this.isDone)return;const v=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(v)}handleDecodedData(d){let v=d.indexOf(`
`);const R=this.remainder+d;if(v>=0)v+=this.remainder.length;else{this.remainder=R;return}let O=0;for(;v>=0;)this.handleLine(R.substring(O,v).trim()),O=v+1,v=R.indexOf(`
`,O);this.remainder=R.substring(O)}handleLine(d){if(this.isDone||!d)return;let v;try{v=JSON.parse(d)}catch{throw new Error(`malformed line from rg: ${d}`)}if(v.type==="match"){const R=m(v.data.path),O=F.URI.file(C.join(this.rootFolder,R)),L=this.createTextSearchMatch(v.data,O);this.onResult(L),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const R=m(v.data.path),O=F.URI.file(C.join(this.rootFolder,R));this.createTextSearchContext(v.data,O).forEach(_=>this.onResult(_))}}createTextSearchMatch(d,v){const R=d.line_number-1,O=m(d.lines),L=Buffer.from(O);let _=0,U=0,M=R;d.submatches.length===0&&d.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const q=(0,A.coalesce)(d.submatches.map((K,x)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=m(K.match),G=L.slice(_,K.start).toString().length,X=U+G,V=s(B),Z=M,se=V.numLines+Z,ce=V.numLines>0?V.lastLineLength:V.lastLineLength+X;return _=K.end,U=ce,M=se,new g.Range(Z,X,se,ce)}));return(0,u.createTextSearchResult)(v,O,q,this.previewOptions)}createTextSearchContext(d,v){const R=m(d.lines),O=d.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((L,_)=>({text:L,uri:v,lineNumber:O+_}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=c;function m(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function s(p){const d=/\n/g;let v=0,R=-1,O;for(;O=d.exec(p);)v++,R=O.index;const L=R>=0?p.length-R-1:p.length;return{numLines:v,lastLineLength:L}}function b(p,d){const v=["--hidden"];v.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:O}=(0,S.groupBy)(d.includes,_=>_.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const _=new Set;O.forEach(U=>{_.add(U)}),v.push("-g","!*"),_.forEach(U=>{o(U).map(u.anchorGlob).forEach(M=>{v.push("-g",M)})})}R&&R.length&&R.forEach(_=>{v.push("-g",_)}),d.excludes.map(u.anchorGlob).forEach(_=>v.push("-g",`!${_}`)),d.maxFileSize&&v.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?d.useParentIgnoreFiles||v.push("--no-ignore-parent"):v.push("--no-ignore"),d.followSymlinks&&v.push("--follow"),d.encoding&&d.encoding!=="utf8"&&v.push("--encoding",d.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,T.escapeRegExpCharacters)(p.pattern),p.isRegExp=!0),d.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),p.isRegExp&&(p.pattern=n(p.pattern),v.push("--engine","auto"));let L;if(p.isWordMatch){const U=(0,T.createRegExp)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",U)}else if(p.isRegExp){let _=r(p.pattern);_=l(_),v.push("--regexp",_)}else L=p.pattern,v.push("--fixed-strings");return v.push("--no-config"),d.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),p.isMultiline&&v.push("--multiline"),d.beforeContext&&v.push("--before-context",d.beforeContext+""),d.afterContext&&v.push("--after-context",d.afterContext+""),v.push("--"),L&&v.push(L),v.push("."),v}function o(p){const d=(0,P.splitGlobAware)(p,"/");return d.map((v,R)=>d.slice(0,R+1).join("/"))}e.spreadGlobComponents=o;function n(p){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(d);)p=p.replace(d,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(v);)p=p.replace(v,"$1\\x{$2}");return p}e.unicodeEscapesToPCRE2=n;const i=p=>p.type==="Assertion"&&p.kind==="lookbehind";function r(p){let d;try{d=new E.RegExpParser().parsePattern(p)}catch{return p}let v="",R=0;const O=(U,M,q)=>{v+=p.slice(R,U)+q,R=M},L=[];return new E.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const M=L[0];if(!M)O(U.start,U.end,"\\r?\\n");else if(!L.some(i))if(M.type==="CharacterClass")if(M.negate){const q=p.slice(M.start+2,U.start)+p.slice(U.end,M.end-1);M.parent?.type==="Quantifier"?O(M.start,M.end,q?`[^${q}]`:"."):O(M.start,M.end,"(?!\\r?\\n"+(q?`|[${q}]`:"")+")")}else{const q=p.slice(M.start+1,U.start)+p.slice(U.end,M.end-1);O(M.start,M.end,q===""?"\\r?\\n":`(?:[${q}]|\\r?\\n)`)}else M.type==="Quantifier"&&O(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){L.unshift(U)},onQuantifierLeave(){L.shift()},onCharacterClassRangeEnter(U){L.unshift(U)},onCharacterClassRangeLeave(){L.shift()},onCharacterClassEnter(U){L.unshift(U)},onCharacterClassLeave(){L.shift()},onAssertionEnter(U){i(U)&&L.push(U)},onAssertionLeave(U){L[0]===U&&L.shift()}}).visit(d),v+=p.slice(R),v}e.fixRegexNewline=r;function l(p){return p.replace(/\n/g,"\\r?\\n")}e.fixNewline=l}),define(we[287],be([1,0,21,140,120,10]),function(te,e,h,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class S{constructor(T){this.outputChannel=T,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(T,F,D,g){const E=new t.RipgrepTextSearchEngine(this.outputChannel);if(F.folder.scheme===A.Schemas.userData){const f={...F,folder:F.folder.with({scheme:A.Schemas.file})},u=new k.Progress(w=>D.report({...w,uri:w.uri.with({scheme:F.folder.scheme})}));return this.withToken(g,w=>E.provideTextSearchResults(T,f,u,w))}else return this.withToken(g,f=>E.provideTextSearchResults(T,F,D,f))}async withToken(T,F){const D=P(T);this.inProgress.add(D);const g=await F(D.token);return this.inProgress.delete(D),g}dispose(){this.inProgress.forEach(T=>T.cancel())}}e.RipgrepSearchProvider=S;function P(C){const T=new h.CancellationTokenSource;return C.onCancellationRequested(()=>T.cancel()),T}}),define(we[288],be([1,0,29,140,139]),function(te,e,h,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(C){this.query=C}search(C,T,F){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(E){F({message:E})}},g=new k.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(D),h);return new Promise((E,f)=>g.search(u=>{T(u.map(S))},C).then(u=>E({limitHit:u.limitHit,type:"success",stats:u.stats}),f))}}e.TextSearchEngineAdapter=A;function S(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((C,T)=>{if(T.ranges){const F=T;return C+(Array.isArray(F.ranges)?F.ranges.length:1)}else return C+1},0)}}}),define(we[289],be([1,0,17,13,16,3,101,9,46,2,42,31,280,288]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class f{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let m;const s=y(c),b=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(g.Engine,s,n=>b.fire(n),o)),m.then(o=>b.fire(o),o=>b.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return b.event}textSearch(c){let m;const s=y(c),b=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(o=>this.ripgrepTextSearch(s,n=>b.fire(n),o)),m.then(o=>b.fire(o),o=>b.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return b.event}ripgrepTextSearch(c,m,s){return c.maxFileSize=(0,F.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(c).search(s,m,m)}doFileSearch(c,m,s){return this.doFileSearchWithEngine(g.Engine,c,m,s)}doFileSearchWithEngine(c,m,s,b,o=f.BATCH_SIZE){let n=0;const i=l=>{Array.isArray(l)?(n+=l.length,s(l.map(p=>this.rawMatchToSearchItem(p)))):l.relativePath?(n++,s(this.rawMatchToSearchItem(l))):s(l)};if(m.sortByScore){let l=this.trySortedSearchFromCache(m,i,b);if(!l){const p=m.maxResults?Object.assign({},m,{maxResults:null}):m,d=new c(p);l=this.doSortedSearch(d,m,s,i,b)}return new Promise((p,d)=>{l.then(([v,R])=>{const O=R.map(L=>this.rawMatchToSearchItem(L));this.sendProgress(O,s,o),p(v)},d)})}const r=new c(m);return this.doSearch(r,i,o,b).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:this.processType,fromCache:!1,resultCount:n,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,P.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,m,s,b,o){const n=new A.Emitter;let i=(0,t.createCancelablePromise)(l=>{let p=[];const d=v=>{Array.isArray(v)?p=v:(b(v),n.fire(v))};return this.doSearch(c,d,-1,l).then(v=>[v,p])}),r;if(m.cacheKey){r=this.getOrCreateCache(m.cacheKey);const l={promise:i,event:n.event,resolved:!1};r.resultsToSearchCache[m.filePattern||""]=l,i.then(()=>{l.resolved=!0},p=>{delete r.resultsToSearchCache[m.filePattern||""]}),i=this.preventCancellation(i)}return i.then(([l,p])=>{const d=r?r.scorerCache:Object.create(null),v=(typeof m.maxResults!="number"||m.maxResults>0)&&C.StopWatch.create(!1);return this.sortResults(m,p,d,o).then(R=>{const O=v?v.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:O,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:R.length},messages:l.messages,limitHit:l.limitHit||typeof m.maxResults=="number"&&p.length>m.maxResults},R]})})}getOrCreateCache(c){const m=this.caches[c];return m||(this.caches[c]=new u)}trySortedSearchFromCache(c,m,s){const b=c.cacheKey&&this.caches[c.cacheKey];if(!b)return;const o=this.getResultsFromCache(b,c.filePattern||"",m,s);if(o)return o.then(([n,i,r])=>{const l=C.StopWatch.create(!1);return this.sortResults(c,i,b.scorerCache,s).then(p=>{const d=l.elapsed(),v={fromCache:!0,detailStats:r,type:this.processType,resultCount:i.length,sortingTime:d};return[{type:"success",limitHit:n.limitHit||typeof c.maxResults=="number"&&i.length>c.maxResults,stats:v},p]})})}sortResults(c,m,s,b){const o=(0,S.prepareQuery)(c.filePattern||""),n=(r,l)=>(0,S.compareItemsByFuzzyScore)(r,l,o,!0,w,s),i=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return h.topAsync(m,n,i,1e4,b)}sendProgress(c,m,s){if(s&&s>0)for(let b=0;b<c.length;b+=s)m(c.slice(b,b+s));else m(c)}getResultsFromCache(c,m,s,b){const o=C.StopWatch.create(!1),n=m.indexOf(P.sep)>=0;let i;for(const d in c.resultsToSearchCache)if(m.startsWith(d)){if(n&&d.indexOf(P.sep)<0&&d!=="")continue;const v=c.resultsToSearchCache[d];i={promise:this.preventCancellation(v.promise),event:v.event,resolved:v.resolved};break}if(!i)return null;const r=o.elapsed(),l=C.StopWatch.create(!1),p=i.event(s);return b&&b.onCancellationRequested(()=>{p.dispose()}),i.promise.then(([d,v])=>{if(b&&b.isCancellationRequested)throw(0,k.canceled)();const R=[],O=(0,S.prepareQuery)(m).normalizedLowercase;for(const L of v)!(0,D.isFilePatternMatch)(L,O)||R.push(L);return[d,R,{cacheWasResolved:i.resolved,cacheLookupTime:r,cacheFilterTime:l.elapsed(),cacheEntryCount:v.length}]})}doSearch(c,m,s,b){return new Promise((o,n)=>{let i=[];b&&b.onCancellationRequested(()=>c.cancel()),c.search(r=>{r&&(s?(i.push(r),s>0&&i.length>=s&&(m(i),i=[])):m(r))},r=>{m(r)},(r,l)=>{i.length&&m(i),r?n(r):o(l)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,s){return c.then(m,s)}catch(m){return this.then(void 0,m)}finally(m){return c.finally(m)}}}}e.SearchService=f,f.BATCH_SIZE=512;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(a){return(0,P.basename)(a.relativePath)}getItemDescription(a){return(0,P.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function y(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(I),extraFileResources:a.extraFileResources&&a.extraFileResources.map(c=>T.URI.revive(c))}}function I(a){return{...a,folder:T.URI.revive(a.folder)}}}),define(we[290],be([1,0,6,10,2,29,11,26,14,72,64,31,289,287,91,139]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends T.ExtHostSearch{constructor(I,a,c,m){super(I,c,m);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const s=new f.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new E.RipgrepSearchProvider(s)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const I=new f.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new E.RipgrepSearchProvider(I)),this.registerInternalFileSearchProvider(t.Schemas.file,new g.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(I,a){const c=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(I)),(0,h.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(I,a,c,m){const s=(0,T.reviveQuery)(c);return I===this._internalFileSearchHandle?this.doInternalFileSearch(I,a,s,m):super.$provideFileSearchResults(I,a,c,m)}doInternalFileSearch(I,a,c,m){const s=b=>{if((0,D.isSerializedFileMatch)(b)&&(b=[b]),Array.isArray(b)){this._proxy.$handleFileMatch(I,a,b.map(o=>k.URI.file(o.path)));return}b.message&&this._logService.debug("ExtHostSearch",b.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,s,m)}$clearCache(I){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(I),super.$clearCache(I)}createTextSearchManager(I,a){return new u.NativeTextSearchManager(I,a,void 0,"textSearchProvider")}};w=Be([Fe(0,C.IExtHostRpcService),Fe(1,P.IExtHostInitDataService),Fe(2,F.IURITransformerService),Fe(3,S.ILogService)],w),e.NativeExtHostSearch=w}),define(we[141],be([1,0,300,128,80,23,16,3,6,9,12,33,106,107,301]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(v,R=""){this.debugLabel=R,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,S.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(v,R){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,R)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const R=O=>{this.traceSocketEvent("read",O),v(A.VSBuffer.wrap(O))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(v){const R=O=>{this.traceSocketEvent("close",{hadError:O}),v({type:0,hadError:O,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(v){const R=()=>{this.traceSocketEvent("nodeEndReceived"),v()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(v){if(!this.socket.destroyed)try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,S.onUnexpectedError)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,S.onUnexpectedError)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=u;var w;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var y;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(y||(y={}));class I extends C.Disposable{constructor(v,R,O,L){super();this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:O?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new a(this,R,O,L,this._onData,(_,U)=>this._write(_,U))),this._register(this._flowManager.onError(_=>{console.error(_),(0,S.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(v,R){this.socket.traceSocketEvent(v,R)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._flowManager.writeMessage(v)}_write(v,R){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let O=2;v.byteLength<126?O+=0:v.byteLength<2**16?O+=2:O+=8;const L=A.VSBuffer.alloc(O);if(R?L.writeUInt8(194,0):L.writeUInt8(130,0),v.byteLength<126)L.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){L.writeUInt8(126,1);let _=1;L.writeUInt8(v.byteLength>>>8&255,++_),L.writeUInt8(v.byteLength>>>0&255,++_)}else{L.writeUInt8(127,1);let _=1;L.writeUInt8(0,++_),L.writeUInt8(0,++_),L.writeUInt8(0,++_),L.writeUInt8(0,++_),L.writeUInt8(v.byteLength>>>24&255,++_),L.writeUInt8(v.byteLength>>>16&255,++_),L.writeUInt8(v.byteLength>>>8&255,++_),L.writeUInt8(v.byteLength>>>0&255,++_)}this.socket.write(A.VSBuffer.concat([L,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),O=R.readUInt8(0),L=(O&128)>>>7,_=(O&64)>>>6,U=R.readUInt8(1),M=(U&128)>>>7,q=U&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),O=R.readUInt8(1),L=(O&128)>>>7;let _=O&127,U=1;_===126?_=R.readUInt8(++U)*2**8+R.readUInt8(++U):_===127&&(_=R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U));let M=0;L&&(M=R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U)),this._state.state=3,this._state.readLen=_,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),s(R,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(R,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=I;class a extends C.Disposable{constructor(v,R,O,L,_,U){super();this._tracer=v,this._onData=_,this._writeFn=U,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,R?(this._zlibInflateStream=this._register(new c(this._tracer,L,O,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(v){this._writeQueue.push(v),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const v=this._writeQueue.shift();if(this._zlibDeflateStream){const R=await this._deflateMessage(this._zlibDeflateStream,v);this._writeFn(R,!0)}else this._writeFn(v,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(v,R){return new Promise((O,L)=>{v.write(R),v.flush(_=>O(_))})}acceptFrame(v,R,O){this._readQueue.push({data:v,isCompressed:R,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const v=this._readQueue.shift();if(this._zlibInflateStream&&v.isCompressed){const R=await this._inflateFrame(this._zlibInflateStream,v.data,v.isLastFrameOfMessage);this._onData.fire(R)}else this._onData.fire(v.data)}this._isProcessingReadQueue=!1}}_inflateFrame(v,R,O){return new Promise((L,_)=>{v.write(R),O&&v.write(A.VSBuffer.fromByteArray([0,0,255,255])),v.flush(U=>L(U))})}}class c extends C.Disposable{constructor(v,R,O,L){super();this._tracer=v,this._recordInflateBytes=R,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=f.createInflateRaw(L),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(A.VSBuffer.wrap(_))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(v){this._recordInflateBytes&&this._recordedInflateBytes.push(v.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",v),this._zlibInflate.write(v.buffer)}flush(v){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const R=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,v(R)})}}class m extends C.Disposable{constructor(v,R){super();this._tracer=v,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(A.VSBuffer.wrap(O))})}write(v){this._tracer.traceSocketEvent("zlibDeflateWrite",v.buffer),this._zlibDeflate.write(v.buffer)}flush(v){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let R=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.byteLength-4),v(R)})}}function s(d,v){if(v===0)return;let R=d.byteLength>>>2;for(let q=0;q<R;q++){const K=d.readUInt32BE(q*4);d.writeUInt32BE(K^v,q*4)}let O=R*4,L=d.byteLength-O;const _=v>>>24&255,U=v>>>16&255,M=v>>>8&255;L>=1&&d.writeUInt8(d.readUInt8(O)^_,O),L>=2&&d.writeUInt8(d.readUInt8(O+1)^U,O+1),L>=3&&d.writeUInt8(d.readUInt8(O+2)^M,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const b={[2]:107,[1]:103};function o(){const d=(0,D.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):v=(0,T.join)((0,k.tmpdir)(),`vscode-ipc-${d}.sock`),i(v),v}e.createRandomIPCHandle=o;function n(d,v,R){const O=(0,h.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${R}-${v}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${R}-${v}.sock`):L=(0,T.join)(d,`${R}-${v}.sock`),i(L),L}e.createStaticIPCHandle=n;function i(d){const v=b[F.platform];typeof v=="number"&&d.length>=v&&console.warn(`WARNING: IPC handle "${d}" is longer than ${v} chars, try a shorter --user-data-dir`)}class r extends g.IPCServer{constructor(v){super(r.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const R=P.Event.fromNodeEventEmitter(v,"connection");return P.Event.map(R,O=>({protocol:new E.Protocol(new u(O,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function l(d){return new Promise((v,R)=>{const O=(0,t.createServer)();O.on("error",R),O.listen(d,()=>{O.removeListener("error",R),v(new r(O))})})}e.serve=l;function p(d,v){return new Promise((R,O)=>{const L=(0,t.createConnection)(d,()=>{L.removeListener("error",O),R(E.Client.fromSocket(new u(L,`ipc-client${v}`),v))});L.once("error",O)})}e.connect=p}),define(we[291],be([1,0,141,286,60,38,2,201,11]),function(te,e,h,t,k,A,S,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class T{constructor(g,E,f){this._commands=g,this.logService=E,this._ipcHandlePath=f,this._server=t.createServer((u,w)=>this.onRequest(u,w)),this.setup().catch(u=>(E.error(u),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",g=>this.logService.error(g))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(g,E){const f=(w,y)=>{E.writeHead(w,{"content-type":"application/json"}),E.end(JSON.stringify(y),I=>I&&this.logService.error(I))},u=[];g.setEncoding("utf8"),g.on("data",w=>u.push(w)),g.on("end",async()=>{try{const w=JSON.parse(u.join(""));let y;switch(w.type){case"open":y=await this.open(w);break;case"openExternal":y=await this.openExternal(w);break;case"status":y=await this.getStatus(w);break;case"extensionManagement":y=await this.manageExtensions(w);break;default:f(404,`Unknown message type: ${w.type}`);break}f(200,y)}catch(w){const y=w instanceof Error?w.message:JSON.stringify(w);f(500,y),this.logService.error("Error while processing pipe request",w)}})}async open(g){const{fileURIs:E,folderURIs:f,forceNewWindow:u,diffMode:w,addMode:y,forceReuseWindow:I,gotoLineMode:a,waitMarkerFilePath:c,remoteAuthority:m}=g,s=[];if(Array.isArray(f))for(const i of f)try{s.push({folderUri:S.URI.parse(i)})}catch{}if(Array.isArray(E))for(const i of E)try{(0,P.hasWorkspaceFileExtension)(i)?s.push({workspaceUri:S.URI.parse(i)}):s.push({fileUri:S.URI.parse(i)})}catch{}const b=c?S.URI.file(c):void 0,n={forceNewWindow:u,diffMode:w,addMode:y,gotoLineMode:a,forceReuseWindow:I,preferNewWindow:!I&&!b&&!y,waitMarkerFileURI:b,remoteAuthority:m};return this._commands.executeCommand("_remoteCLI.windowOpen",s,n),""}async openExternal(g){for(const E of g.uris){const f=S.URI.parse(E),u=f.scheme==="file"?f:E;await this._commands.executeCommand("_remoteCLI.openExternal",u)}}async manageExtensions(g){const E=u=>u?.map(w=>/\.vsix$/i.test(w)?S.URI.parse(w):w),f={list:g.list,install:E(g.install),uninstall:E(g.uninstall),force:g.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",f)}async getStatus(g){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=T;let F=class extends T{constructor(g,E){super(g,E,(0,h.createRandomIPCHandle)())}};F=Be([Fe(0,A.IExtHostCommands),Fe(1,C.ILogService)],F),e.CLIServer=F}),define(we[292],be([1,0,71,284,273,5,285,39,262,2,10,7,291,105]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends k.RequireInterceptor{_installInterceptor(){const y=this,I=te.__$__nodeRequire("module"),a=I._load;I._load=function(b,o,n){return b=m(b),y._factories.has(b)?y._factories.get(b).load(b,T.URI.file((0,E.realpathSync)(o.filename)),i=>a.apply(this,[i,o,n])):a.apply(this,arguments)};const c=I._resolveLookupPaths;I._resolveLookupPaths=(s,b)=>c.call(this,m(s),b);const m=s=>{for(let b of y._alternatives){let o=b(s);if(o){s=o;break}}return s}}}class u extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const y=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(C.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const s=this._instaService.createInstance(g.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}await this._instaService.createInstance(f,y,this._registry).install(),h.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,S.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),h.mark("code/extHost/didInitProxyResolver");const c=process.send,m=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...s)=>s.length===0||!s[0]||s[0].type!=="__$console"?c.apply(process,s):(m.$logExtensionHostMessage(s[0]),!1)}_getEntryPoint(y){return y.main}_loadCommonJSModule(y,I,a){if(I.scheme!==F.Schemas.file)throw new Error(`Cannot load URI: '${I}', must be of file-scheme`);let c=null;a.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${I.toString(!0)}`),this._logService.flush();try{y&&h.mark(`code/extHost/willLoadExtensionCode/${y.value}`),c=te.__$__nodeRequire(I.fsPath)}catch(m){return Promise.reject(m)}finally{y&&h.mark(`code/extHost/didLoadExtensionCode/${y.value}`),a.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(y){if(!!this._initData.remote.isRemote)for(const I in y){const a=y[I];a===null?delete process.env[I]:process.env[I]=a}}}e.ExtHostExtensionService=u}),define(we[293],be([1,0,61,265,276,275,290,292,266,54,39,72,70,34,51,67,264,263,11]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(F.IExtHostExtensionService,P.ExtHostExtensionService),(0,h.registerSingleton)(I.ILoggerService,y.ExtHostLoggerService),(0,h.registerSingleton)(u.IExtensionStoragePaths,w.ExtensionStoragePaths),(0,h.registerSingleton)(T.IExtHostDebugService,A.ExtHostDebugService),(0,h.registerSingleton)(D.IExtHostSearch,S.NativeExtHostSearch),(0,h.registerSingleton)(g.IExtHostTask,k.ExtHostTask),(0,h.registerSingleton)(E.IExtHostTerminalService,t.ExtHostTerminalService),(0,h.registerSingleton)(f.IExtHostTunnelService,C.ExtHostTunnelService)}),define(we[302],be([1,0,128,303,71,16,107,141,193,133,274,23,29,105,13,115,209,277,293]),function(te,e,h,t,k,A,S,P,C,T,F,D,g,E,f,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const y=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock","useHostProxy"]});(function(){const n=te.__$__nodeRequire("module"),i=n._load;n._load=function(r){if(r==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return i.apply(this,arguments)}})();const I=process.exit.bind(process);function a(n){process.exit=function(i){if(n)I(i);else{const r=new Error("An extension called process.exit() and this was prevented.");console.warn(r.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let c=function(n){I()};function m(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,i)=>{let r=null,l=setTimeout(()=>{c("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const p=108e5,d=3e5,v=new f.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (1)"),p),R=new f.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (2)"),d);process.on("message",(L,_)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){_.setNoDelay(!0);const U=D.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let M;if(L.skipWebSocketFrames)M=new P.NodeSocket(_,"extHost-socket");else{const q=D.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));M=new P.WebSocketNodeSocket(new P.NodeSocket(_,"extHost-socket"),L.permessageDeflate,q,!1)}r?(v.cancel(),R.cancel(),r.beginAcceptReconnection(M,U),r.endAcceptReconnection(),r.sendResume()):(clearTimeout(l),r=new S.PersistentProtocol(M,U),r.sendResume(),r.onDidDispose(()=>c("renderer disconnected")),n(r),r.onSocketClose(()=>{v.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(R.isScheduled())return;v.isScheduled()&&R.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(O)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,r)=>{const l=h.createConnection(n,()=>{l.removeListener("error",r),i(new S.PersistentProtocol(new P.NodeSocket(l,"extHost-renderer")))});l.once("error",r),l.on("close",()=>{c("renderer closed the socket")})})}}async function s(){const n=await m();return new class{constructor(){this._onMessage=new S.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(i=>{(0,T.isMessageOfType)(i,2)?(this._terminating=!0,c("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||n.send(i)}drain(){return n.drain()}}}function b(n){return new Promise(i=>{const r=n.onMessage(l=>{r.dispose();const p=JSON.parse(l.toString()),d=p.commit,v=C.default.commit;d&&v&&d!==v&&I(55);let R=0;setInterval(function(){try{process.kill(p.parentPid,0),R=0}catch(L){L&&L.code==="EPERM"?(R++,R>=3&&c(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${L.message} (code: ${L.code}) (errno: ${L.errno})`)):c(`parent process ${p.parentPid} does not exist anymore: ${L.message} (code: ${L.code}) (errno: ${L.errno})`)}},1e3);let O;try{O=te.__$__nodeRequire("native-watchdog"),O.start(p.parentPid)}catch(L){(0,A.onUnexpectedError)(L)}n.send((0,T.createMessageOfType)(0)),i({protocol:n,initData:p})});n.send((0,T.createMessageOfType)(1))})}async function o(){const n=[];process.on("unhandledRejection",(R,O)=>{n.push(O),setTimeout(()=>{const L=n.indexOf(O);L>=0&&O.catch(_=>{n.splice(L,1),(0,A.isCancellationError)(_)||(console.warn(`rejected promise not handled within 1 second: ${_}`),_&&_.stack&&console.warn(`stack trace: ${_.stack}`),R&&(0,A.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const O=n.indexOf(R);O>=0&&n.splice(O,1)}),process.on("uncaughtException",function(R){(0,A.onUnexpectedError)(R)}),k.mark("code/extHost/willConnectToRenderer");const i=await s();k.mark("code/extHost/didConnectToRenderer");const r=await b(i);k.mark("code/extHost/didWaitForInitData");const{initData:l}=r;a(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=!!y.useHostProxy,l.environment.skipWorkspaceStorageLock=(0,u.boolean)(y.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(O){I(O)}exists(O){return g.Promises.exists(O)}realpath(O){return(0,E.realpath)(O)}};let d=null;l.remote.authority&&y.transformURIs&&(d=(0,w.createURITransformer)(l.remote.authority));const v=new F.ExtensionHostMain(r.protocol,l,p,d);c=R=>v.terminate(R)}e.startExtensionHostProcess=o,o().catch(n=>console.log(n))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/97c1e76d668d23d568044feb31083407f4c4b1ed/core/vs/workbench/api/node/extensionHostProcess.js.map
