/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/strings","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/languageSelector","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/editor/common/core/range","vs/editor/common/languages","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ee=function(Y){for(var e=[],r=0,I=Y.length;r<I;r++)e[r]=ve[Y[r]];return e};define(ve[42],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function r(I,_){if(!I)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=r}),define(ve[69],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const r=Object.prototype.hasOwnProperty;function I(N){const b=[];for(let s in N)r.call(N,s)&&b.push(N[s]);return b}e.values=I;function _(N,b){for(let s in N)if(r.call(N,s)&&b({key:s,value:N[s]},function(){delete N[s]})===!1)return}e.forEach=_;function x(N,b){const s=Object.create(null);for(const p of N){const n=b(p);let i=s[n];i||(i=s[n]=[]),i.push(p)}return s}e.groupBy=x;function y(N){const b=Object.create(null);return N&&N.forEach((s,p)=>{b[p]=s}),b}e.fromMap=y;function A(N,b){const s=[],p=[];for(let n of N)b.has(n)||s.push(n);for(let n of b)N.has(n)||p.push(n);return{removed:s,added:p}}e.diffSets=A;function C(N,b){const s=[],p=[];for(let[n,i]of N)b.has(n)||s.push(i);for(let[n,i]of b)N.has(n)||p.push(i);return{removed:s,added:p}}e.diffMaps=C;class R{constructor(){this.map=new Map}add(b,s){let p=this.map.get(b);p||(p=new Set,this.map.set(b,p)),p.add(s)}delete(b,s){const p=this.map.get(b);!p||(p.delete(s),p.size===0&&this.map.delete(b))}forEach(b,s){const p=this.map.get(b);!p||p.forEach(s)}}e.SetMap=R}),define(ve[52],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(y){return(A,C,R)=>{let N=null,b=null;if(typeof R.value=="function"?(N="value",b=R.value):typeof R.get=="function"&&(N="get",b=R.get),!b)throw new Error("not supported");R[N]=y(b,C)}}e.createDecorator=r;function I(y,A,C){let R=null,N=null;if(typeof C.value=="function"?(R="value",N=C.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(R="get",N=C.get),!N)throw new Error("not supported");const b=`$memoize$${A}`;C[R]=function(...s){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,s)}),this[b]}}e.memoize=I;function _(y,A,C){return r((R,N)=>{const b=`$debounce$${N}`,s=`$debounce$result$${N}`;return function(...p){this[s]||(this[s]=C?C():void 0),clearTimeout(this[b]),A&&(this[s]=A(this[s],...p),p=[this[s]]),this[b]=setTimeout(()=>{R.apply(this,p),this[s]=C?C():void 0},y)}})}e.debounce=_;function x(y,A,C){return r((R,N)=>{const b=`$throttle$timer$${N}`,s=`$throttle$result$${N}`,p=`$throttle$lastRun$${N}`,n=`$throttle$pending$${N}`;return function(...i){if(this[s]||(this[s]=C?C():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),A&&(this[s]=A(this[s],...i)),this[n])return;const d=this[p]+y;d<=Date.now()?(this[p]=Date.now(),R.apply(this,[this[s]]),this[s]=C?C():void 0):(this[n]=!0,this[b]=setTimeout(()=>{this[n]=!1,this[p]=Date.now(),R.apply(this,[this[s]]),this[s]=C?C():void 0},d-Date.now()))}})}e.throttle=x}),define(ve[53],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(ve[100],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var I;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var x;(function(a){a.DEFAULT={allowTrailingComma:!0}})(x=e.ParseOptions||(e.ParseOptions={}));function y(a,P=!1){let c=0,t=a.length,h="",o=0,l=16,E=0;function m(z){let q=0,j=0;for(;q<z;){const J=a.charCodeAt(c);if(J>=48&&J<=57)j=j*16+J-48;else if(J>=65&&J<=70)j=j*16+J-65+10;else if(J>=97&&J<=102)j=j*16+J-97+10;else break;c++,q++}return q<z&&(j=-1),j}function v(z){c=z,h="",o=0,l=16,E=0}function k(){const z=c;if(a.charCodeAt(c)===48)c++;else for(c++;c<a.length&&R(a.charCodeAt(c));)c++;if(c<a.length&&a.charCodeAt(c)===46)if(c++,c<a.length&&R(a.charCodeAt(c)))for(c++;c<a.length&&R(a.charCodeAt(c));)c++;else return E=3,a.substring(z,c);let q=c;if(c<a.length&&(a.charCodeAt(c)===69||a.charCodeAt(c)===101))if(c++,(c<a.length&&a.charCodeAt(c)===43||a.charCodeAt(c)===45)&&c++,c<a.length&&R(a.charCodeAt(c))){for(c++;c<a.length&&R(a.charCodeAt(c));)c++;q=c}else E=3;return a.substring(z,q)}function T(){let z="",q=c;for(;;){if(c>=t){z+=a.substring(q,c),E=2;break}const j=a.charCodeAt(c);if(j===34){z+=a.substring(q,c),c++;break}if(j===92){if(z+=a.substring(q,c),c++,c>=t){E=2;break}switch(a.charCodeAt(c++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=m(4);W>=0?z+=String.fromCharCode(W):E=4;break}default:E=5}q=c;continue}if(j>=0&&j<=31)if(C(j)){z+=a.substring(q,c),E=2;break}else E=6;c++}return z}function $(){if(h="",E=0,o=c,c>=t)return o=t,l=17;let z=a.charCodeAt(c);if(A(z)){do c++,h+=String.fromCharCode(z),z=a.charCodeAt(c);while(A(z));return l=15}if(C(z))return c++,h+=String.fromCharCode(z),z===13&&a.charCodeAt(c)===10&&(c++,h+=`
`),l=14;switch(z){case 123:return c++,l=1;case 125:return c++,l=2;case 91:return c++,l=3;case 93:return c++,l=4;case 58:return c++,l=6;case 44:return c++,l=5;case 34:return c++,h=T(),l=10;case 47:{const q=c-1;if(a.charCodeAt(c+1)===47){for(c+=2;c<t&&!C(a.charCodeAt(c));)c++;return h=a.substring(q,c),l=12}if(a.charCodeAt(c+1)===42){c+=2;const j=t-1;let J=!1;for(;c<j;){if(a.charCodeAt(c)===42&&a.charCodeAt(c+1)===47){c+=2,J=!0;break}c++}return J||(c++,E=1),h=a.substring(q,c),l=13}return h+=String.fromCharCode(z),c++,l=16}case 45:if(h+=String.fromCharCode(z),c++,c===t||!R(a.charCodeAt(c)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=k(),l=11;default:for(;c<t&&g(z);)c++,z=a.charCodeAt(c);if(o!==c){switch(h=a.substring(o,c),h){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return h+=String.fromCharCode(z),c++,l=16}}function g(z){if(A(z)||C(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=$();while(z>=12&&z<=15);return z}return{setPosition:v,getPosition:()=>c,scan:P?U:$,getToken:()=>l,getTokenValue:()=>h,getTokenOffset:()=>o,getTokenLength:()=>c-o,getTokenError:()=>E}}e.createScanner=y;function A(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function C(a){return a===10||a===13||a===8232||a===8233}function R(a){return a>=48&&a<=57}var N;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(N||(N={}));function b(a,P){const c=[],t=new Object;let h;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function E(m,v,k,T){o.value=m,o.offset=v,o.length=k,o.type=T,o.colonOffset=void 0,h=o}try{u(a,{onObjectBegin:(m,v)=>{if(P<=m)throw t;h=void 0,l=P>m,c.push("")},onObjectProperty:(m,v,k)=>{if(P<v||(E(m,v,k,"property"),c[c.length-1]=m,P<=v+k))throw t},onObjectEnd:(m,v)=>{if(P<=m)throw t;h=void 0,c.pop()},onArrayBegin:(m,v)=>{if(P<=m)throw t;h=void 0,c.push(0)},onArrayEnd:(m,v)=>{if(P<=m)throw t;h=void 0,c.pop()},onLiteralValue:(m,v,k)=>{if(P<v||(E(m,v,k,w(m)),P<=v+k))throw t},onSeparator:(m,v,k)=>{if(P<=v)throw t;if(m===":"&&h&&h.type==="property")h.colonOffset=v,l=!1,h=void 0;else if(m===","){const T=c[c.length-1];typeof T=="number"?c[c.length-1]=T+1:(l=!0,c[c.length-1]=""),h=void 0}}})}catch(m){if(m!==t)throw m}return{path:c,previousNode:h,isAtPropertyKey:l,matches:m=>{let v=0;for(let k=0;v<m.length&&k<c.length;k++)if(m[v]===c[k]||m[v]==="*")v++;else if(m[v]!=="**")return!1;return v===m.length}}}e.getLocation=b;function s(a,P=[],c=x.DEFAULT){let t=null,h=[];const o=[];function l(m){Array.isArray(h)?h.push(m):t!==null&&(h[t]=m)}return u(a,{onObjectBegin:()=>{const m={};l(m),o.push(h),h=m,t=null},onObjectProperty:m=>{t=m},onObjectEnd:()=>{h=o.pop()},onArrayBegin:()=>{const m=[];l(m),o.push(h),h=m,t=null},onArrayEnd:()=>{h=o.pop()},onLiteralValue:l,onError:(m,v,k)=>{P.push({error:m,offset:v,length:k})}},c),h[0]}e.parse=s;function p(a,P=[],c=x.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(m){t.type==="property"&&(t.length=m-t.offset,t=t.parent)}function o(m){return t.children.push(m),m}u(a,{onObjectBegin:m=>{t=o({type:"object",offset:m,length:-1,parent:t,children:[]})},onObjectProperty:(m,v,k)=>{t=o({type:"property",offset:v,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:m,offset:v,length:k,parent:t})},onObjectEnd:(m,v)=>{t.length=m+v-t.offset,t=t.parent,h(m+v)},onArrayBegin:(m,v)=>{t=o({type:"array",offset:m,length:-1,parent:t,children:[]})},onArrayEnd:(m,v)=>{t.length=m+v-t.offset,t=t.parent,h(m+v)},onLiteralValue:(m,v,k)=>{o({type:w(m),offset:v,length:k,parent:t,value:m}),h(v+k)},onSeparator:(m,v,k)=>{t.type==="property"&&(m===":"?t.colonOffset=v:m===","&&h(v))},onError:(m,v,k)=>{P.push({error:m,offset:v,length:k})}},c);const E=t.children[0];return E&&delete E.parent,E}e.parseTree=p;function n(a,P){if(!a)return;let c=a;for(let t of P)if(typeof t=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let h=!1;for(const o of c.children)if(Array.isArray(o.children)&&o.children[0].value===t){c=o.children[1],h=!0;break}if(!h)return}else{const h=t;if(c.type!=="array"||h<0||!Array.isArray(c.children)||h>=c.children.length)return;c=c.children[h]}return c}e.findNodeAtLocation=n;function i(a){if(!a.parent||!a.parent.children)return[];const P=i(a.parent);if(a.parent.type==="property"){const c=a.parent.children[0].value;P.push(c)}else if(a.parent.type==="array"){const c=a.parent.children.indexOf(a);c!==-1&&P.push(c)}return P}e.getNodePath=i;function d(a){switch(a.type){case"array":return a.children.map(d);case"object":{const P=Object.create(null);for(let c of a.children){const t=c.children[1];t&&(P[c.children[0].value]=d(t))}return P}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=d;function S(a,P,c=!1){return P>=a.offset&&P<a.offset+a.length||c&&P===a.offset+a.length}e.contains=S;function M(a,P,c=!1){if(S(a,P,c)){const t=a.children;if(Array.isArray(t))for(let h=0;h<t.length&&t[h].offset<=P;h++){const o=M(t[h],P,c);if(o)return o}return a}}e.findNodeAtOffset=M;function u(a,P,c=x.DEFAULT){const t=y(a,!1);function h(De){return De?()=>De(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(De){return De?fe=>De(fe,t.getTokenOffset(),t.getTokenLength()):()=>!0}const l=h(P.onObjectBegin),E=o(P.onObjectProperty),m=h(P.onObjectEnd),v=h(P.onArrayBegin),k=h(P.onArrayEnd),T=o(P.onLiteralValue),$=o(P.onSeparator),g=h(P.onComment),U=o(P.onError),z=c&&c.disallowComments,q=c&&c.allowTrailingComma;function j(){for(;;){const De=t.scan();switch(t.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:z||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(De){case 12:case 13:z?J(10):g();break;case 16:J(1);break;case 15:case 14:break;default:return De}}}function J(De,fe=[],ne=[]){if(U(De),fe.length+ne.length>0){let me=t.getToken();for(;me!==17;){if(fe.indexOf(me)!==-1){j();break}else if(ne.indexOf(me)!==-1)break;me=j()}}}function W(De){const fe=t.getTokenValue();return De?T(fe):E(fe),j(),!0}function ie(){switch(t.getToken()){case 11:{let De=0;try{De=JSON.parse(t.getTokenValue()),typeof De!="number"&&(J(2),De=0)}catch{J(2)}T(De);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return j(),!0}function le(){return t.getToken()!==10?(J(3,[],[2,5]),!1):(W(!1),t.getToken()===6?($(":"),j(),he()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function te(){l(),j();let De=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(De||J(4,[],[]),$(","),j(),t.getToken()===2&&q)break}else De&&J(6,[],[]);le()||J(4,[],[2,5]),De=!0}return m(),t.getToken()!==2?J(7,[2],[]):j(),!0}function ue(){v(),j();let De=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(De||J(4,[],[]),$(","),j(),t.getToken()===4&&q)break}else De&&J(6,[],[]);he()||J(4,[],[4,5]),De=!0}return k(),t.getToken()!==4?J(8,[4],[]):j(),!0}function he(){switch(t.getToken()){case 3:return ue();case 1:return te();case 10:return W(!0);default:return ie()}}return j(),t.getToken()===17?c.allowEmptyContent?!0:(J(4,[],[]),!1):he()?(t.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=u;function f(a,P){let c=y(a),t=[],h,o=0,l;do switch(l=c.getPosition(),h=c.scan(),h){case 12:case 13:case 17:o!==l&&t.push(a.substring(o,l)),P!==void 0&&t.push(c.getTokenValue().replace(/[^\r\n]/g,P)),o=c.getPosition();break}while(h!==17);return t.join("")}e.stripComments=f;function w(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[101],Ee([0]),e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,e(Y.marked={}))}(this,function(Y){"use strict";function e(ge,de){for(var L=0;L<de.length;L++){var F=de[L];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(ge,F.key,F)}}function r(ge,de,L){return de&&e(ge.prototype,de),L&&e(ge,L),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function I(ge,de){if(!!ge){if(typeof ge=="string")return _(ge,de);var L=Object.prototype.toString.call(ge).slice(8,-1);if(L==="Object"&&ge.constructor&&(L=ge.constructor.name),L==="Map"||L==="Set")return Array.from(ge);if(L==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(L))return _(ge,de)}}function _(ge,de){(de==null||de>ge.length)&&(de=ge.length);for(var L=0,F=new Array(de);L<de;L++)F[L]=ge[L];return F}function x(ge,de){var L=typeof Symbol!="undefined"&&ge[Symbol.iterator]||ge["@@iterator"];if(L)return(L=L.call(ge)).next.bind(L);if(Array.isArray(ge)||(L=I(ge))||de&&ge&&typeof ge.length=="number"){L&&(ge=L);var F=0;return function(){return F>=ge.length?{done:!0}:{done:!1,value:ge[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Y.defaults=y();function A(ge){Y.defaults=ge}var C=/[&<>"']/,R=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(de){return s[de]};function n(ge,de){if(de){if(C.test(ge))return ge.replace(R,p)}else if(N.test(ge))return ge.replace(b,p);return ge}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ge){return ge.replace(i,function(de,L){return L=L.toLowerCase(),L==="colon"?":":L.charAt(0)==="#"?L.charAt(1)==="x"?String.fromCharCode(parseInt(L.substring(2),16)):String.fromCharCode(+L.substring(1)):""})}var S=/(^|[^\[])\^/g;function M(ge,de){ge=ge.source||ge,de=de||"";var L={replace:function(D,O){return O=O.source||O,O=O.replace(S,"$1"),ge=ge.replace(D,O),L},getRegex:function(){return new RegExp(ge,de)}};return L}var u=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(ge,de,L){if(ge){var F;try{F=decodeURIComponent(d(L)).replace(u,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}de&&!f.test(L)&&(L=h(de,L));try{L=encodeURI(L).replace(/%25/g,"%")}catch{return null}return L}var a={},P=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(ge,de){a[" "+ge]||(P.test(ge)?a[" "+ge]=ge+"/":a[" "+ge]=m(ge,"/",!0)),ge=a[" "+ge];var L=ge.indexOf(":")===-1;return de.substring(0,2)==="//"?L?de:ge.replace(c,"$1")+de:de.charAt(0)==="/"?L?de:ge.replace(t,"$1")+de:ge+de}var o={exec:function(){}};function l(ge){for(var de=1,L,F;de<arguments.length;de++){L=arguments[de];for(F in L)Object.prototype.hasOwnProperty.call(L,F)&&(ge[F]=L[F])}return ge}function E(ge,de){var L=ge.replace(/\|/g,function(O,H,X){for(var re=!1,pe=H;--pe>=0&&X[pe]==="\\";)re=!re;return re?"|":" |"}),F=L.split(/ \|/),D=0;if(F[0].trim()||F.shift(),F[F.length-1].trim()||F.pop(),F.length>de)F.splice(de);else for(;F.length<de;)F.push("");for(;D<F.length;D++)F[D]=F[D].trim().replace(/\\\|/g,"|");return F}function m(ge,de,L){var F=ge.length;if(F===0)return"";for(var D=0;D<F;){var O=ge.charAt(F-D-1);if(O===de&&!L)D++;else if(O!==de&&L)D++;else break}return ge.substr(0,F-D)}function v(ge,de){if(ge.indexOf(de[1])===-1)return-1;for(var L=ge.length,F=0,D=0;D<L;D++)if(ge[D]==="\\")D++;else if(ge[D]===de[0])F++;else if(ge[D]===de[1]&&(F--,F<0))return D;return-1}function k(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(ge,de){if(de<1)return"";for(var L="";de>1;)de&1&&(L+=ge),de>>=1,ge+=ge;return L+ge}function $(ge,de,L,F){var D=de.href,O=de.title?n(de.title):null,H=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){F.state.inLink=!0;var X={type:"link",raw:L,href:D,title:O,text:H,tokens:F.inlineTokens(H,[])};return F.state.inLink=!1,X}else return{type:"image",raw:L,href:D,title:O,text:n(H)}}function g(ge,de){var L=ge.match(/^(\s+)(?:```)/);if(L===null)return de;var F=L[1];return de.split(`
`).map(function(D){var O=D.match(/^\s+/);if(O===null)return D;var H=O[0];return H.length>=F.length?D.slice(F.length):D}).join(`
`)}var U=function(){function ge(L){this.options=L||Y.defaults}var de=ge.prototype;return de.space=function(F){var D=this.rules.block.newline.exec(F);if(D&&D[0].length>0)return{type:"space",raw:D[0]}},de.code=function(F){var D=this.rules.block.code.exec(F);if(D){var O=D[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:D[0],codeBlockStyle:"indented",text:this.options.pedantic?O:m(O,`
`)}}},de.fences=function(F){var D=this.rules.block.fences.exec(F);if(D){var O=D[0],H=g(O,D[3]||"");return{type:"code",raw:O,lang:D[2]?D[2].trim():D[2],text:H}}},de.heading=function(F){var D=this.rules.block.heading.exec(F);if(D){var O=D[2].trim();if(/#$/.test(O)){var H=m(O,"#");(this.options.pedantic||!H||/ $/.test(H))&&(O=H.trim())}var X={type:"heading",raw:D[0],depth:D[1].length,text:O,tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},de.hr=function(F){var D=this.rules.block.hr.exec(F);if(D)return{type:"hr",raw:D[0]}},de.blockquote=function(F){var D=this.rules.block.blockquote.exec(F);if(D){var O=D[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:D[0],tokens:this.lexer.blockTokens(O,[]),text:O}}},de.list=function(F){var D=this.rules.block.list.exec(F);if(D){var O,H,X,re,pe,Ce,Me,Le,ze,xe,Oe,Xe,et=D[1].trim(),ke=et.length>1,tt={type:"list",raw:"",ordered:ke,start:ke?+et.slice(0,-1):"",loose:!1,items:[]};et=ke?"\\d{1,9}\\"+et.slice(-1):"\\"+et,this.options.pedantic&&(et=ke?et:"[*+-]");for(var G=new RegExp("^( {0,3}"+et+")((?: [^\\n]*)?(?:\\n|$))");F&&(Xe=!1,!(!(D=G.exec(F))||this.rules.block.hr.test(F)));){if(O=D[0],F=F.substring(O.length),Le=D[2].split(`
`,1)[0],ze=F.split(`
`,1)[0],this.options.pedantic?(re=2,Oe=Le.trimLeft()):(re=D[2].search(/[^ ]/),re=re>4?1:re,Oe=Le.slice(re),re+=D[1].length),Ce=!1,!Le&&/^ *$/.test(ze)&&(O+=ze+`
`,F=F.substring(ze.length+1),Xe=!0),!Xe)for(var Q=new RegExp("^ {0,"+Math.min(3,re-1)+"}(?:[*+-]|\\d{1,9}[.)])");F&&(xe=F.split(`
`,1)[0],Le=xe,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!Q.test(Le));){if(Le.search(/[^ ]/)>=re||!Le.trim())Oe+=`
`+Le.slice(re);else if(!Ce)Oe+=`
`+Le;else break;!Ce&&!Le.trim()&&(Ce=!0),O+=xe+`
`,F=F.substring(xe.length+1)}tt.loose||(Me?tt.loose=!0:/\n *\n *$/.test(O)&&(Me=!0)),this.options.gfm&&(H=/^\[[ xX]\] /.exec(Oe),H&&(X=H[0]!=="[ ] ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),tt.items.push({type:"list_item",raw:O,task:!!H,checked:X,loose:!1,text:Oe}),tt.raw+=O}tt.items[tt.items.length-1].raw=O.trimRight(),tt.items[tt.items.length-1].text=Oe.trimRight(),tt.raw=tt.raw.trimRight();var ce=tt.items.length;for(pe=0;pe<ce;pe++){this.lexer.state.top=!1,tt.items[pe].tokens=this.lexer.blockTokens(tt.items[pe].text,[]);var Re=tt.items[pe].tokens.filter(function(Ke){return Ke.type==="space"}),$e=Re.every(function(Ke){for(var Qe=Ke.raw.split(""),ht=0,_t=x(Qe),yt;!(yt=_t()).done;){var Tt=yt.value;if(Tt===`
`&&(ht+=1),ht>1)return!0}return!1});!tt.loose&&Re.length&&$e&&(tt.loose=!0,tt.items[pe].loose=!0)}return tt}},de.html=function(F){var D=this.rules.block.html.exec(F);if(D){var O={type:"html",raw:D[0],pre:!this.options.sanitizer&&(D[1]==="pre"||D[1]==="script"||D[1]==="style"),text:D[0]};return this.options.sanitize&&(O.type="paragraph",O.text=this.options.sanitizer?this.options.sanitizer(D[0]):n(D[0]),O.tokens=[],this.lexer.inline(O.text,O.tokens)),O}},de.def=function(F){var D=this.rules.block.def.exec(F);if(D){D[3]&&(D[3]=D[3].substring(1,D[3].length-1));var O=D[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:O,raw:D[0],href:D[2],title:D[3]}}},de.table=function(F){var D=this.rules.block.table.exec(F);if(D){var O={type:"table",header:E(D[1]).map(function(Me){return{text:Me}}),align:D[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:D[3]?D[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=D[0];var H=O.align.length,X,re,pe,Ce;for(X=0;X<H;X++)/^ *-+: *$/.test(O.align[X])?O.align[X]="right":/^ *:-+: *$/.test(O.align[X])?O.align[X]="center":/^ *:-+ *$/.test(O.align[X])?O.align[X]="left":O.align[X]=null;for(H=O.rows.length,X=0;X<H;X++)O.rows[X]=E(O.rows[X],O.header.length).map(function(Me){return{text:Me}});for(H=O.header.length,re=0;re<H;re++)O.header[re].tokens=[],this.lexer.inlineTokens(O.header[re].text,O.header[re].tokens);for(H=O.rows.length,re=0;re<H;re++)for(Ce=O.rows[re],pe=0;pe<Ce.length;pe++)Ce[pe].tokens=[],this.lexer.inlineTokens(Ce[pe].text,Ce[pe].tokens);return O}}},de.lheading=function(F){var D=this.rules.block.lheading.exec(F);if(D){var O={type:"heading",raw:D[0],depth:D[2].charAt(0)==="="?1:2,text:D[1],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.paragraph=function(F){var D=this.rules.block.paragraph.exec(F);if(D){var O={type:"paragraph",raw:D[0],text:D[1].charAt(D[1].length-1)===`
`?D[1].slice(0,-1):D[1],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.text=function(F){var D=this.rules.block.text.exec(F);if(D){var O={type:"text",raw:D[0],text:D[0],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.escape=function(F){var D=this.rules.inline.escape.exec(F);if(D)return{type:"escape",raw:D[0],text:n(D[1])}},de.tag=function(F){var D=this.rules.inline.tag.exec(F);if(D)return!this.lexer.state.inLink&&/^<a /i.test(D[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(D[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(D[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(D[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:D[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(D[0]):n(D[0]):D[0]}},de.link=function(F){var D=this.rules.inline.link.exec(F);if(D){var O=D[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var H=m(O.slice(0,-1),"\\");if((O.length-H.length)%2==0)return}else{var X=v(D[2],"()");if(X>-1){var re=D[0].indexOf("!")===0?5:4,pe=re+D[1].length+X;D[2]=D[2].substring(0,X),D[0]=D[0].substring(0,pe).trim(),D[3]=""}}var Ce=D[2],Me="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);Le&&(Ce=Le[1],Me=Le[3])}else Me=D[3]?D[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(O)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),$(D,{href:Ce&&Ce.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},D[0],this.lexer)}},de.reflink=function(F,D){var O;if((O=this.rules.inline.reflink.exec(F))||(O=this.rules.inline.nolink.exec(F))){var H=(O[2]||O[1]).replace(/\s+/g," ");if(H=D[H.toLowerCase()],!H||!H.href){var X=O[0].charAt(0);return{type:"text",raw:X,text:X}}return $(O,H,O[0],this.lexer)}},de.emStrong=function(F,D,O){O===void 0&&(O="");var H=this.rules.inline.emStrong.lDelim.exec(F);if(!!H&&!(H[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var X=H[1]||H[2]||"";if(!X||X&&(O===""||this.rules.inline.punctuation.exec(O))){var re=H[0].length-1,pe,Ce,Me=re,Le=0,ze=H[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ze.lastIndex=0,D=D.slice(-1*F.length+re);(H=ze.exec(D))!=null;)if(pe=H[1]||H[2]||H[3]||H[4]||H[5]||H[6],!!pe){if(Ce=pe.length,H[3]||H[4]){Me+=Ce;continue}else if((H[5]||H[6])&&re%3&&!((re+Ce)%3)){Le+=Ce;continue}if(Me-=Ce,!(Me>0)){if(Ce=Math.min(Ce,Ce+Me+Le),Math.min(re,Ce)%2){var xe=F.slice(1,re+H.index+Ce);return{type:"em",raw:F.slice(0,re+H.index+Ce+1),text:xe,tokens:this.lexer.inlineTokens(xe,[])}}var Oe=F.slice(2,re+H.index+Ce-1);return{type:"strong",raw:F.slice(0,re+H.index+Ce+1),text:Oe,tokens:this.lexer.inlineTokens(Oe,[])}}}}}},de.codespan=function(F){var D=this.rules.inline.code.exec(F);if(D){var O=D[2].replace(/\n/g," "),H=/[^ ]/.test(O),X=/^ /.test(O)&&/ $/.test(O);return H&&X&&(O=O.substring(1,O.length-1)),O=n(O,!0),{type:"codespan",raw:D[0],text:O}}},de.br=function(F){var D=this.rules.inline.br.exec(F);if(D)return{type:"br",raw:D[0]}},de.del=function(F){var D=this.rules.inline.del.exec(F);if(D)return{type:"del",raw:D[0],text:D[2],tokens:this.lexer.inlineTokens(D[2],[])}},de.autolink=function(F,D){var O=this.rules.inline.autolink.exec(F);if(O){var H,X;return O[2]==="@"?(H=n(this.options.mangle?D(O[1]):O[1]),X="mailto:"+H):(H=n(O[1]),X=H),{type:"link",raw:O[0],text:H,href:X,tokens:[{type:"text",raw:H,text:H}]}}},de.url=function(F,D){var O;if(O=this.rules.inline.url.exec(F)){var H,X;if(O[2]==="@")H=n(this.options.mangle?D(O[0]):O[0]),X="mailto:"+H;else{var re;do re=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(re!==O[0]);H=n(O[0]),O[1]==="www."?X="http://"+H:X=H}return{type:"link",raw:O[0],text:H,href:X,tokens:[{type:"text",raw:H,text:H}]}}},de.inlineText=function(F,D){var O=this.rules.inline.text.exec(F);if(O){var H;return this.lexer.state.inRawBlock?H=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):n(O[0]):O[0]:H=n(this.options.smartypants?D(O[0]):O[0]),{type:"text",raw:O[0],text:H}}},ge}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=M(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=M(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=M(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=M(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=M(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=M(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=l({},z),z.gfm=l({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=M(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=M(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=l({},z.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:M(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=M(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=M(z._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=M(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=M(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=M(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=M(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=M(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=M(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=M(q.reflink).replace("label",q._label).replace("ref",z._label).getRegex(),q.nolink=M(q.nolink).replace("ref",z._label).getRegex(),q.reflinkSearch=M(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=l({},q),q.pedantic=l({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=l({},q.normal,{escape:M(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=M(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=l({},q.gfm,{br:M(q.br).replace("{2,}","*").getRegex(),text:M(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(ge){var de="",L,F,D=ge.length;for(L=0;L<D;L++)F=ge.charCodeAt(L),Math.random()>.5&&(F="x"+F.toString(16)),de+="&#"+F+";";return de}var W=function(){function ge(L){this.tokens=[],this.tokens.links=Object.create(null),this.options=L||Y.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:z.normal,inline:q.normal};this.options.pedantic?(F.block=z.pedantic,F.inline=q.pedantic):this.options.gfm&&(F.block=z.gfm,this.options.breaks?F.inline=q.breaks:F.inline=q.gfm),this.tokenizer.rules=F}ge.lex=function(F,D){var O=new ge(D);return O.lex(F)},ge.lexInline=function(F,D){var O=new ge(D);return O.inlineTokens(F)};var de=ge.prototype;return de.lex=function(F){F=F.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(F,this.tokens);for(var D;D=this.inlineQueue.shift();)this.inlineTokens(D.src,D.tokens);return this.tokens},de.blockTokens=function(F,D){var O=this;D===void 0&&(D=[]),this.options.pedantic&&(F=F.replace(/^ +$/gm,""));for(var H,X,re,pe;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(H=Me.call({lexer:O},F,D))?(F=F.substring(H.raw.length),D.push(H),!0):!1}))){if(H=this.tokenizer.space(F)){F=F.substring(H.raw.length),H.raw.length===1&&D.length>0?D[D.length-1].raw+=`
`:D.push(H);continue}if(H=this.tokenizer.code(F)){F=F.substring(H.raw.length),X=D[D.length-1],X&&(X.type==="paragraph"||X.type==="text")?(X.raw+=`
`+H.raw,X.text+=`
`+H.text,this.inlineQueue[this.inlineQueue.length-1].src=X.text):D.push(H);continue}if(H=this.tokenizer.fences(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.heading(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.hr(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.blockquote(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.list(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.html(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.def(F)){F=F.substring(H.raw.length),X=D[D.length-1],X&&(X.type==="paragraph"||X.type==="text")?(X.raw+=`
`+H.raw,X.text+=`
`+H.raw,this.inlineQueue[this.inlineQueue.length-1].src=X.text):this.tokens.links[H.tag]||(this.tokens.links[H.tag]={href:H.href,title:H.title});continue}if(H=this.tokenizer.table(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.lheading(F)){F=F.substring(H.raw.length),D.push(H);continue}if(re=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Le=F.slice(1),ze=void 0;O.options.extensions.startBlock.forEach(function(xe){ze=xe.call({lexer:this},Le),typeof ze=="number"&&ze>=0&&(Me=Math.min(Me,ze))}),Me<1/0&&Me>=0&&(re=F.substring(0,Me+1))}(),this.state.top&&(H=this.tokenizer.paragraph(re))){X=D[D.length-1],pe&&X.type==="paragraph"?(X.raw+=`
`+H.raw,X.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=X.text):D.push(H),pe=re.length!==F.length,F=F.substring(H.raw.length);continue}if(H=this.tokenizer.text(F)){F=F.substring(H.raw.length),X=D[D.length-1],X&&X.type==="text"?(X.raw+=`
`+H.raw,X.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=X.text):D.push(H);continue}if(F){var Ce="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return this.state.top=!0,D},de.inline=function(F,D){this.inlineQueue.push({src:F,tokens:D})},de.inlineTokens=function(F,D){var O=this;D===void 0&&(D=[]);var H,X,re,pe=F,Ce,Me,Le;if(this.tokens.links){var ze=Object.keys(this.tokens.links);if(ze.length>0)for(;(Ce=this.tokenizer.rules.inline.reflinkSearch.exec(pe))!=null;)ze.includes(Ce[0].slice(Ce[0].lastIndexOf("[")+1,-1))&&(pe=pe.slice(0,Ce.index)+"["+T("a",Ce[0].length-2)+"]"+pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ce=this.tokenizer.rules.inline.blockSkip.exec(pe))!=null;)pe=pe.slice(0,Ce.index)+"["+T("a",Ce[0].length-2)+"]"+pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ce=this.tokenizer.rules.inline.escapedEmSt.exec(pe))!=null;)pe=pe.slice(0,Ce.index)+"++"+pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Me||(Le=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Oe){return(H=Oe.call({lexer:O},F,D))?(F=F.substring(H.raw.length),D.push(H),!0):!1}))){if(H=this.tokenizer.escape(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.tag(F)){F=F.substring(H.raw.length),X=D[D.length-1],X&&H.type==="text"&&X.type==="text"?(X.raw+=H.raw,X.text+=H.text):D.push(H);continue}if(H=this.tokenizer.link(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(H.raw.length),X=D[D.length-1],X&&H.type==="text"&&X.type==="text"?(X.raw+=H.raw,X.text+=H.text):D.push(H);continue}if(H=this.tokenizer.emStrong(F,pe,Le)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.codespan(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.br(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.del(F)){F=F.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.autolink(F,J)){F=F.substring(H.raw.length),D.push(H);continue}if(!this.state.inLink&&(H=this.tokenizer.url(F,J))){F=F.substring(H.raw.length),D.push(H);continue}if(re=F,this.options.extensions&&this.options.extensions.startInline&&function(){var Oe=1/0,Xe=F.slice(1),et=void 0;O.options.extensions.startInline.forEach(function(ke){et=ke.call({lexer:this},Xe),typeof et=="number"&&et>=0&&(Oe=Math.min(Oe,et))}),Oe<1/0&&Oe>=0&&(re=F.substring(0,Oe+1))}(),H=this.tokenizer.inlineText(re,j)){F=F.substring(H.raw.length),H.raw.slice(-1)!=="_"&&(Le=H.raw.slice(-1)),Me=!0,X=D[D.length-1],X&&X.type==="text"?(X.raw+=H.raw,X.text+=H.text):D.push(H);continue}if(F){var xe="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(xe);break}else throw new Error(xe)}}return D},r(ge,null,[{key:"rules",get:function(){return{block:z,inline:q}}}]),ge}(),ie=function(){function ge(L){this.options=L||Y.defaults}var de=ge.prototype;return de.code=function(F,D,O){var H=(D||"").match(/\S*/)[0];if(this.options.highlight){var X=this.options.highlight(F,H);X!=null&&X!==F&&(O=!0,F=X)}return F=F.replace(/\n$/,"")+`
`,H?'<pre><code class="'+this.options.langPrefix+n(H,!0)+'">'+(O?F:n(F,!0))+`</code></pre>
`:"<pre><code>"+(O?F:n(F,!0))+`</code></pre>
`},de.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},de.html=function(F){return F},de.heading=function(F,D,O,H){return this.options.headerIds?"<h"+D+' id="'+this.options.headerPrefix+H.slug(O)+'">'+F+"</h"+D+`>
`:"<h"+D+">"+F+"</h"+D+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(F,D,O){var H=D?"ol":"ul",X=D&&O!==1?' start="'+O+'"':"";return"<"+H+X+`>
`+F+"</"+H+`>
`},de.listitem=function(F){return"<li>"+F+`</li>
`},de.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(F){return"<p>"+F+`</p>
`},de.table=function(F,D){return D&&(D="<tbody>"+D+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+D+`</table>
`},de.tablerow=function(F){return`<tr>
`+F+`</tr>
`},de.tablecell=function(F,D){var O=D.header?"th":"td",H=D.align?"<"+O+' align="'+D.align+'">':"<"+O+">";return H+F+"</"+O+`>
`},de.strong=function(F){return"<strong>"+F+"</strong>"},de.em=function(F){return"<em>"+F+"</em>"},de.codespan=function(F){return"<code>"+F+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(F){return"<del>"+F+"</del>"},de.link=function(F,D,O){if(F=w(this.options.sanitize,this.options.baseUrl,F),F===null)return O;var H='<a href="'+n(F)+'"';return D&&(H+=' title="'+D+'"'),H+=">"+O+"</a>",H},de.image=function(F,D,O){if(F=w(this.options.sanitize,this.options.baseUrl,F),F===null)return O;var H='<img src="'+F+'" alt="'+O+'"';return D&&(H+=' title="'+D+'"'),H+=this.options.xhtml?"/>":">",H},de.text=function(F){return F},ge}(),le=function(){function ge(){}var de=ge.prototype;return de.strong=function(F){return F},de.em=function(F){return F},de.codespan=function(F){return F},de.del=function(F){return F},de.html=function(F){return F},de.text=function(F){return F},de.link=function(F,D,O){return""+O},de.image=function(F,D,O){return""+O},de.br=function(){return""},ge}(),te=function(){function ge(){this.seen={}}var de=ge.prototype;return de.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(F,D){var O=F,H=0;if(this.seen.hasOwnProperty(O)){H=this.seen[F];do H++,O=F+"-"+H;while(this.seen.hasOwnProperty(O))}return D||(this.seen[F]=H,this.seen[O]=0),O},de.slug=function(F,D){D===void 0&&(D={});var O=this.serialize(F);return this.getNextSafeSlug(O,D.dryrun)},ge}(),ue=function(){function ge(L){this.options=L||Y.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new te}ge.parse=function(F,D){var O=new ge(D);return O.parse(F)},ge.parseInline=function(F,D){var O=new ge(D);return O.parseInline(F)};var de=ge.prototype;return de.parse=function(F,D){D===void 0&&(D=!0);var O="",H,X,re,pe,Ce,Me,Le,ze,xe,Oe,Xe,et,ke,tt,G,Q,ce,Re,$e,Ke=F.length;for(H=0;H<Ke;H++){if(Oe=F[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&($e=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),$e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Oe.type))){O+=$e||"";continue}switch(Oe.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Oe.tokens),Oe.depth,d(this.parseInline(Oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Oe.text,Oe.lang,Oe.escaped);continue}case"table":{for(ze="",Le="",pe=Oe.header.length,X=0;X<pe;X++)Le+=this.renderer.tablecell(this.parseInline(Oe.header[X].tokens),{header:!0,align:Oe.align[X]});for(ze+=this.renderer.tablerow(Le),xe="",pe=Oe.rows.length,X=0;X<pe;X++){for(Me=Oe.rows[X],Le="",Ce=Me.length,re=0;re<Ce;re++)Le+=this.renderer.tablecell(this.parseInline(Me[re].tokens),{header:!1,align:Oe.align[re]});xe+=this.renderer.tablerow(Le)}O+=this.renderer.table(ze,xe);continue}case"blockquote":{xe=this.parse(Oe.tokens),O+=this.renderer.blockquote(xe);continue}case"list":{for(Xe=Oe.ordered,et=Oe.start,ke=Oe.loose,pe=Oe.items.length,xe="",X=0;X<pe;X++)G=Oe.items[X],Q=G.checked,ce=G.task,tt="",G.task&&(Re=this.renderer.checkbox(Q),ke?G.tokens.length>0&&G.tokens[0].type==="paragraph"?(G.tokens[0].text=Re+" "+G.tokens[0].text,G.tokens[0].tokens&&G.tokens[0].tokens.length>0&&G.tokens[0].tokens[0].type==="text"&&(G.tokens[0].tokens[0].text=Re+" "+G.tokens[0].tokens[0].text)):G.tokens.unshift({type:"text",text:Re}):tt+=Re),tt+=this.parse(G.tokens,ke),xe+=this.renderer.listitem(tt,ce,Q);O+=this.renderer.list(xe,Xe,et);continue}case"html":{O+=this.renderer.html(Oe.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Oe.tokens));continue}case"text":{for(xe=Oe.tokens?this.parseInline(Oe.tokens):Oe.text;H+1<Ke&&F[H+1].type==="text";)Oe=F[++H],xe+=`
`+(Oe.tokens?this.parseInline(Oe.tokens):Oe.text);O+=D?this.renderer.paragraph(xe):xe;continue}default:{var Qe='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return O},de.parseInline=function(F,D){D=D||this.renderer;var O="",H,X,re,pe=F.length;for(H=0;H<pe;H++){if(X=F[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(re=this.options.extensions.renderers[X.type].call({parser:this},X),re!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(X.type))){O+=re||"";continue}switch(X.type){case"escape":{O+=D.text(X.text);break}case"html":{O+=D.html(X.text);break}case"link":{O+=D.link(X.href,X.title,this.parseInline(X.tokens,D));break}case"image":{O+=D.image(X.href,X.title,X.text);break}case"strong":{O+=D.strong(this.parseInline(X.tokens,D));break}case"em":{O+=D.em(this.parseInline(X.tokens,D));break}case"codespan":{O+=D.codespan(X.text);break}case"br":{O+=D.br();break}case"del":{O+=D.del(this.parseInline(X.tokens,D));break}case"text":{O+=D.text(X.text);break}default:{var Ce='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return O},ge}();function he(ge,de,L){if(typeof ge=="undefined"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof de=="function"&&(L=de,de=null),de=l({},he.defaults,de||{}),k(de),L){var F=de.highlight,D;try{D=W.lex(ge,de)}catch(re){return L(re)}var O=function(pe){var Ce;if(!pe)try{de.walkTokens&&he.walkTokens(D,de.walkTokens),Ce=ue.parse(D,de)}catch(Me){pe=Me}return de.highlight=F,pe?L(pe):L(null,Ce)};if(!F||F.length<3||(delete de.highlight,!D.length))return O();var H=0;he.walkTokens(D,function(re){re.type==="code"&&(H++,setTimeout(function(){F(re.text,re.lang,function(pe,Ce){if(pe)return O(pe);Ce!=null&&Ce!==re.text&&(re.text=Ce,re.escaped=!0),H--,H===0&&O()})},0))}),H===0&&O();return}try{var X=W.lex(ge,de);return de.walkTokens&&he.walkTokens(X,de.walkTokens),ue.parse(X,de)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+n(re.message+"",!0)+"</pre>";throw re}}he.options=he.setOptions=function(ge){return l(he.defaults,ge),A(he.defaults),he},he.getDefaults=y,he.defaults=Y.defaults,he.use=function(){for(var ge=arguments.length,de=new Array(ge),L=0;L<ge;L++)de[L]=arguments[L];var F=l.apply(void 0,[{}].concat(de)),D=he.defaults.extensions||{renderers:{},childTokens:{}},O;de.forEach(function(H){if(H.extensions&&(O=!0,H.extensions.forEach(function(re){if(!re.name)throw new Error("extension name required");if(re.renderer){var pe=D.renderers?D.renderers[re.name]:null;pe?D.renderers[re.name]=function(){for(var Ce=arguments.length,Me=new Array(Ce),Le=0;Le<Ce;Le++)Me[Le]=arguments[Le];var ze=re.renderer.apply(this,Me);return ze===!1&&(ze=pe.apply(this,Me)),ze}:D.renderers[re.name]=re.renderer}if(re.tokenizer){if(!re.level||re.level!=="block"&&re.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");D[re.level]?D[re.level].unshift(re.tokenizer):D[re.level]=[re.tokenizer],re.start&&(re.level==="block"?D.startBlock?D.startBlock.push(re.start):D.startBlock=[re.start]:re.level==="inline"&&(D.startInline?D.startInline.push(re.start):D.startInline=[re.start]))}re.childTokens&&(D.childTokens[re.name]=re.childTokens)})),H.renderer&&function(){var re=he.defaults.renderer||new ie,pe=function(Le){var ze=re[Le];re[Le]=function(){for(var xe=arguments.length,Oe=new Array(xe),Xe=0;Xe<xe;Xe++)Oe[Xe]=arguments[Xe];var et=H.renderer[Le].apply(re,Oe);return et===!1&&(et=ze.apply(re,Oe)),et}};for(var Ce in H.renderer)pe(Ce);F.renderer=re}(),H.tokenizer&&function(){var re=he.defaults.tokenizer||new U,pe=function(Le){var ze=re[Le];re[Le]=function(){for(var xe=arguments.length,Oe=new Array(xe),Xe=0;Xe<xe;Xe++)Oe[Xe]=arguments[Xe];var et=H.tokenizer[Le].apply(re,Oe);return et===!1&&(et=ze.apply(re,Oe)),et}};for(var Ce in H.tokenizer)pe(Ce);F.tokenizer=re}(),H.walkTokens){var X=he.defaults.walkTokens;F.walkTokens=function(re){H.walkTokens.call(this,re),X&&X.call(this,re)}}O&&(F.extensions=D),he.setOptions(F)})},he.walkTokens=function(ge,de){for(var L=function(){var H=D.value;switch(de.call(he,H),H.type){case"table":{for(var X=x(H.header),re;!(re=X()).done;){var pe=re.value;he.walkTokens(pe.tokens,de)}for(var Ce=x(H.rows),Me;!(Me=Ce()).done;)for(var Le=Me.value,ze=x(Le),xe;!(xe=ze()).done;){var Oe=xe.value;he.walkTokens(Oe.tokens,de)}break}case"list":{he.walkTokens(H.items,de);break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[H.type]?he.defaults.extensions.childTokens[H.type].forEach(function(Xe){he.walkTokens(H[Xe],de)}):H.tokens&&he.walkTokens(H.tokens,de)}},F=x(ge),D;!(D=F()).done;)L()},he.parseInline=function(ge,de){if(typeof ge=="undefined"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");de=l({},he.defaults,de||{}),k(de);try{var L=W.lexInline(ge,de);return de.walkTokens&&he.walkTokens(L,de.walkTokens),ue.parseInline(L,de)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+n(F.message+"",!0)+"</pre>";throw F}},he.Parser=ue,he.parser=ue.parse,he.Renderer=ie,he.TextRenderer=le,he.Lexer=W,he.lexer=W.lex,he.Tokenizer=U,he.Slugger=te,he.parse=he;var De=he.options,fe=he.setOptions,ne=he.use,me=he.walkTokens,Ie=he.parseInline,Ae=he,Ue=ue.parse,Ge=W.lex;Y.Lexer=W,Y.Parser=ue,Y.Renderer=ie,Y.Slugger=te,Y.TextRenderer=le,Y.Tokenizer=U,Y.getDefaults=y,Y.lexer=Ge,Y.marked=he,Y.options=De,Y.parse=Ae,Y.parseInline=Ie,Y.parser=Ue,Y.setOptions=fe,Y.use=ne,Y.walkTokens=me,Object.defineProperty(Y,"__esModule",{value:!0})}),define(ve[102],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(A,C,R){return Math.min(Math.max(A,C),R)}e.clamp=r;function I(A,C){return(C+A%C)%C}e.rot=I;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class x{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=x;class y{constructor(C){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(C),this._values.fill(0,0,C)}update(C){const R=this._values[this._index];return this._values[this._index]=C,this._index=(this._index+1)%this._values.length,this._sum-=R,this._sum+=C,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function Y(_){const x=[];typeof _=="number"&&x.push("code/timeOrigin",_);function y(C){x.push(C,Date.now())}function A(){const C=[];for(let R=0;R<x.length;R+=2)C.push({name:x[R],startTime:x[R+1]});return C}return{mark:y,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const x=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const y of performance.getEntriesByType("mark"))x.push({name:y.name,startTime:Math.round(_+y.startTime)});return x}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function r(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=r(I))}(),define(ve[70],Ee([1,0,17]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var I;(function(b){b.text="text/plain",b.binary="application/octet-stream",b.unknown="application/unknown",b.markdown="text/markdown",b.latex="text/latex"})(I=e.Mimes||(e.Mimes={}));const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},x={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function y(b){const s=(0,r.extname)(b),p=_[s.toLowerCase()];return p!==void 0?p:A(b)}e.getMediaOrTextMime=y;function A(b){const s=(0,r.extname)(b);return x[s.toLowerCase()]}e.getMediaMime=A;function C(b){for(const s in x)if(x[s]===b)return s}e.getExtensionForMimeType=C;const R=/^(.+)\/(.+?)(;.+)?$/;function N(b,s){const p=R.exec(b);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:s?void 0:b}e.normalizeMimeType=N}),define(ve[103],Ee([1,0,15,6]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(u){const f=u;return f?[f.on,f.pause,f.resume,f.destroy].every(w=>typeof w=="function"):!1}e.isReadableStream=_;function x(u){const f=u;return f?_(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=x;function y(u,f){return new A(u,f)}e.newWriteableStream=y;class A{constructor(f,w){this.reducer=f,this.options=w,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(w=>this.pendingWritePromises.push(w))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(w=>w(f))}emitError(f){this.listeners.error.length===0?(0,r.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(w=>w(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,w){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(w),this.resume();break;case"end":this.listeners.end.push(w),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(w),this.state.flowing&&this.flowErrors();break}}removeListener(f,w){if(this.state.destroyed)return;let a;switch(f){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const P=a.indexOf(w);P>=0&&a.splice(P,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const w=[...this.pendingWritePromises];this.pendingWritePromises.length=0,w.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(u,f){const w=[];let a;for(;(a=u.read())!==null;)w.push(a);return f(w)}e.consumeReadable=C;function R(u,f,w){const a=[];let P;for(;(P=u.read())!==null&&a.length<w;)a.push(P);return P===null&&a.length>0?f(a):{read:()=>{if(a.length>0)return a.shift();if(typeof P!="undefined"){const c=P;return P=void 0,c}return u.read()}}}e.peekReadable=R;function N(u,f){return new Promise((w,a)=>{const P=[];b(u,{onData:c=>{f&&P.push(c)},onError:c=>{f?a(c):w(void 0)},onEnd:()=>{w(f?f(P):void 0)}})})}e.consumeStream=N;function b(u,f){let w=!1;return u.on("error",a=>{w||f.onError(a)}),u.on("end",()=>{w||f.onEnd()}),u.on("data",a=>{w||f.onData(a)}),(0,I.toDisposable)(()=>w=!0)}e.listenStream=b;function s(u,f){return new Promise((w,a)=>{const P=new I.DisposableStore,c=[],t=l=>{if(c.push(l),c.length>f)return P.dispose(),u.pause(),w({stream:u,buffer:c,ended:!1})},h=l=>a(l),o=()=>w({stream:u,buffer:c,ended:!0});P.add((0,I.toDisposable)(()=>u.removeListener("error",h))),u.on("error",h),P.add((0,I.toDisposable)(()=>u.removeListener("end",o))),u.on("end",o),P.add((0,I.toDisposable)(()=>u.removeListener("data",t))),u.on("data",t)})}e.peekStream=s;function p(u,f){const w=y(f);return w.end(u),w}e.toStream=p;function n(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=n;function i(u){let f=!1;return{read:()=>f?null:(f=!0,u)}}e.toReadable=i;function d(u,f,w){const a=y(w);return b(u,{onData:P=>a.write(f.data(P)),onError:P=>a.error(f.error?f.error(P):P),onEnd:()=>a.end()}),a}e.transform=d;function S(u,f,w){let a=!1;return{read:()=>{const P=f.read();return a?P:(a=!0,P!==null?w([u,P]):u)}}}e.prefixedReadable=S;function M(u,f,w){let a=!1;const P=y(w);return b(f,{onData:c=>a?P.write(c):(a=!0,P.write(w([u,c]))),onError:c=>P.error(c),onEnd:()=>{a||(a=!0,P.write(u)),P.end()}}),P}e.prefixedStream=M}),define(ve[21],Ee([1,0,103]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined";let _,x;class y{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return I?new y(Buffer.allocUnsafe(E)):new y(new Uint8Array(E))}static wrap(E){return I&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new y(E)}static fromString(E,m){return!(m?.dontUseNodeBuffer||!1)&&I?new y(Buffer.from(E)):(_||(_=new TextEncoder),new y(_.encode(E)))}static fromByteArray(E){const m=y.alloc(E.length);for(let v=0,k=E.length;v<k;v++)m.buffer[v]=E[v];return m}static concat(E,m){if(typeof m=="undefined"){m=0;for(let T=0,$=E.length;T<$;T++)m+=E[T].byteLength}const v=y.alloc(m);let k=0;for(let T=0,$=E.length;T<$;T++){const g=E[T];v.set(g,k),k+=g.byteLength}return v}clone(){const E=y.alloc(this.byteLength);return E.set(this),E}toString(){return I?this.buffer.toString():(x||(x=new TextDecoder),x.decode(this.buffer))}slice(E,m){return new y(this.buffer.subarray(E,m))}set(E,m){if(E instanceof y)this.buffer.set(E.buffer,m);else if(E instanceof Uint8Array)this.buffer.set(E,m);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),m);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return R(this.buffer,E)}writeUInt32BE(E,m){N(this.buffer,E,m)}readUInt32LE(E){return b(this.buffer,E)}writeUInt32LE(E,m){s(this.buffer,E,m)}readUInt8(E){return p(this.buffer,E)}writeUInt8(E,m){n(this.buffer,E,m)}}e.VSBuffer=y;function A(l,E){return l[E+0]<<0>>>0|l[E+1]<<8>>>0}e.readUInt16LE=A;function C(l,E,m){l[m+0]=E&255,E=E>>>8,l[m+1]=E&255}e.writeUInt16LE=C;function R(l,E){return l[E]*2**24+l[E+1]*2**16+l[E+2]*2**8+l[E+3]}e.readUInt32BE=R;function N(l,E,m){l[m+3]=E,E=E>>>8,l[m+2]=E,E=E>>>8,l[m+1]=E,E=E>>>8,l[m]=E}e.writeUInt32BE=N;function b(l,E){return l[E+0]<<0>>>0|l[E+1]<<8>>>0|l[E+2]<<16>>>0|l[E+3]<<24>>>0}e.readUInt32LE=b;function s(l,E,m){l[m+0]=E&255,E=E>>>8,l[m+1]=E&255,E=E>>>8,l[m+2]=E&255,E=E>>>8,l[m+3]=E&255}e.writeUInt32LE=s;function p(l,E){return l[E]}e.readUInt8=p;function n(l,E,m){l[m]=E}e.writeUInt8=n;function i(l){return r.consumeReadable(l,E=>y.concat(E))}e.readableToBuffer=i;function d(l){return r.toReadable(l)}e.bufferToReadable=d;function S(l){return r.consumeStream(l,E=>y.concat(E))}e.streamToBuffer=S;async function M(l){return l.ended?y.concat(l.buffer):y.concat([...l.buffer,await S(l.stream)])}e.bufferedStreamToBuffer=M;function u(l){return r.toStream(l,E=>y.concat(E))}e.bufferToStream=u;function f(l){return r.transform(l,{data:E=>typeof E=="string"?y.fromString(E):y.wrap(E)},E=>y.concat(E))}e.streamToBufferReadableStream=f;function w(l){return r.newWriteableStream(E=>y.concat(E),l)}e.newWriteableBufferStream=w;function a(l,E){return r.prefixedReadable(l,E,m=>y.concat(m))}e.prefixedBufferReadable=a;function P(l,E){return r.prefixedStream(l,E,m=>y.concat(m))}e.prefixedBufferStream=P;function c(l){let E=0,m=0,v=0;const k=new Uint8Array(Math.floor(l.length/4*3)),T=g=>{switch(m){case 3:k[v++]=E|g,m=0;break;case 2:k[v++]=E|g>>>2,E=g<<6,m=3;break;case 1:k[v++]=E|g>>>4,E=g<<4,m=2;break;default:E=g<<2,m=1}};for(let g=0;g<l.length;g++){const U=l.charCodeAt(g);if(U>=65&&U<=90)T(U-65);else if(U>=97&&U<=122)T(U-97+26);else if(U>=48&&U<=57)T(U-48+52);else if(U===43||U===45)T(62);else if(U===47||U===95)T(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${l[g]}`)}}const $=v;for(;m>0;)T(0);return y.wrap(k).slice(0,$)}e.decodeBase64=c;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:l},E=!0,m=!1){const v=m?h:t;let k="";const T=l.byteLength%3;let $=0;for(;$<l.byteLength-T;$+=3){const g=l[$+0],U=l[$+1],z=l[$+2];k+=v[g>>>2],k+=v[(g<<4|U>>>4)&63],k+=v[(U<<2|z>>>6)&63],k+=v[z&63]}if(T===1){const g=l[$+0];k+=v[g>>>2],k+=v[g<<4&63],E&&(k+="==")}else if(T===2){const g=l[$+0],U=l[$+1];k+=v[g>>>2],k+=v[(g<<4|U>>>4)&63],k+=v[U<<2&63],E&&(k+="=")}return k}e.encodeBase64=o});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[22],Ee([1,0,16,10]),function(Y,e,r,I){"use strict";var _,x,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(c,t,h){let o=c.get(t);return o===void 0&&(o=h,c.set(t,o)),o}e.getOrSet=A;function C(c){const t=[];return c.forEach((h,o)=>{t.push(`${o} => ${h}`)}),`Map(${c.size}) {${t.join(", ")}}`}e.mapToString=C;function R(c){const t=[];return c.forEach(h=>{t.push(h)}),`Set(${c.size}) {${t.join(", ")}}`}e.setToString=R;class N{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const h=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return h-o}value(){return this._value[this._pos]}}e.StringIterator=N;class b{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,I.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class s{constructor(t=!0,h=!0){this._splitOnBackslash=t,this._caseSensitive=h}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let h=t.length-1;h>=0;h--,this._valueLen--){const o=this._value.charCodeAt(h);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const h=this._value.charCodeAt(this._to);if(h===47||this._splitOnBackslash&&h===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,I.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=s;var p;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(p||(p={}));class n{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new s(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,I.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=n;class i{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(d||(d={}));class S{constructor(t){this._iter=t}static forUris(t=()=>!1){return new S(new n(t))}static forPaths(t=!1){return new S(new s(void 0,!t))}static forStrings(){return new S(new N)}static forConfigKeys(){return new S(new b)}clear(){this._root=void 0}fill(t,h){if(h){const o=h.slice(0);(0,r.shuffle)(o);for(let l of o)this.set(l,t)}else{const o=t.slice(0);(0,r.shuffle)(o);for(let l of o)this.set(l[0],l[1])}}set(t,h){const o=this._iter.reset(t);let l;this._root||(this._root=new i,this._root.segment=o.value());const E=[];for(l=this._root;;){const v=o.cmp(l.segment);if(v>0)l.left||(l.left=new i,l.left.segment=o.value()),E.push([-1,l]),l=l.left;else if(v<0)l.right||(l.right=new i,l.right.segment=o.value()),E.push([1,l]),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new i,l.mid.segment=o.value()),E.push([0,l]),l=l.mid;else break}const m=l.value;l.value=h,l.key=t;for(let v=E.length-1;v>=0;v--){const k=E[v][1];k.updateHeight();const T=k.balanceFactor();if(T<-1||T>1){const $=E[v][0],g=E[v+1][0];if($===1&&g===1)E[v][1]=k.rotateLeft();else if($===-1&&g===-1)E[v][1]=k.rotateRight();else if($===1&&g===-1)k.right=E[v+1][1]=E[v+1][1].rotateRight(),E[v][1]=k.rotateLeft();else if($===-1&&g===1)k.left=E[v+1][1]=E[v+1][1].rotateLeft(),E[v][1]=k.rotateRight();else throw new Error;if(v>0)switch(E[v-1][0]){case-1:E[v-1][1].left=E[v][1];break;case 1:E[v-1][1].right=E[v][1];break;case 0:E[v-1][1].mid=E[v][1];break}else this._root=E[0][1]}}return m}get(t){return this._getNode(t)?.value}_getNode(t){const h=this._iter.reset(t);let o=this._root;for(;o;){const l=h.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(h.hasNext())h.next(),o=o.mid;else break}return o}has(t){const h=this._getNode(t);return!(h?.value===void 0&&h?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,h){const o=this._iter.reset(t),l=[];let E=this._root;for(;E;){const m=o.cmp(E.segment);if(m>0)l.push([-1,E]),E=E.left;else if(m<0)l.push([1,E]),E=E.right;else if(o.hasNext())o.next(),l.push([0,E]),E=E.mid;else break}if(!!E){if(h?(E.left=void 0,E.mid=void 0,E.right=void 0,E.height=1):(E.key=void 0,E.value=void 0),!E.mid&&!E.value)if(E.left&&E.right){const m=this._min(E.right),{key:v,value:k,segment:T}=m;this._delete(m.key,!1),E.key=v,E.value=k,E.segment=T}else{const m=E.left??E.right;if(l.length>0){const[v,k]=l[l.length-1];switch(v){case-1:k.left=m;break;case 0:k.mid=m;break;case 1:k.right=m;break}}else this._root=m}for(let m=l.length-1;m>=0;m--){const v=l[m][1];v.updateHeight();const k=v.balanceFactor();if(k>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),l[m][1]=v.rotateLeft()):k<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),l[m][1]=v.rotateRight()),m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this._root=l[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const h=this._iter.reset(t);let o=this._root,l;for(;o;){const E=h.cmp(o.segment);if(E>0)o=o.left;else if(E<0)o=o.right;else if(h.hasNext())h.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(t){const h=this._iter.reset(t);let o=this._root;for(;o;){const l=h.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(h.hasNext())h.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[h,o]of this)t(o,h)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=h=>{if(!h)return!0;const o=h.balanceFactor();return o<-1||o>1?!1:t(h.left)&&t(h.right)};return t(this._root)}}e.TernarySearchTree=S;class M{constructor(t,h){this.uri=t,this.value=h}}class u{constructor(t,h){this[_]="ResourceMap",t instanceof u?(this.map=new Map(t.map),this.toKey=h??u.defaultToKey):(this.map=new Map,this.toKey=t??u.defaultToKey)}set(t,h){return this.map.set(this.toKey(t),new M(t,h)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,h){typeof h!="undefined"&&(t=t.bind(h));for(let[o,l]of this.map)t(l.value,l.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=u,u.defaultToKey=c=>c.toString();var f;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class w{constructor(){this[x]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,h=0){const o=this._map.get(t);if(!!o)return h!==0&&this.touch(o,h),o.value}set(t,h,o=0){let l=this._map.get(t);if(l)l.value=h,o!==0&&this.touch(l,o);else{switch(l={key:t,value:h,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(t,l),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const h=this._map.get(t);if(!!h)return this._map.delete(t),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,h){const o=this._state;let l=this._head;for(;l;){if(h?t.bind(h)(l.value,l.key,this):t(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const t=this,h=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==h)throw new Error("LinkedMap got modified during iteration.");if(o){const E={value:o.key,done:!1};return o=o.next,E}else return{value:void 0,done:!0}}};return l}values(){const t=this,h=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==h)throw new Error("LinkedMap got modified during iteration.");if(o){const E={value:o.value,done:!1};return o=o.next,E}else return{value:void 0,done:!0}}};return l}entries(){const t=this,h=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==h)throw new Error("LinkedMap got modified during iteration.");if(o){const E={value:[o.key,o.value],done:!1};return o=o.next,E}else return{value:void 0,done:!0}}};return l}[(x=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let h=this._head,o=this.size;for(;h&&o>t;)this._map.delete(h.key),h=h.next,o--;this._head=h,this._size=o,h&&(h.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const h=t.next,o=t.previous;if(!h||!o)throw new Error("Invalid list");h.previous=o,o.next=h}t.next=void 0,t.previous=void 0,this._state++}touch(t,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(t===this._head)return;const o=t.next,l=t.previous;t===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(h===2){if(t===this._tail)return;const o=t.next,l=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((h,o)=>{t.push([o,h])}),t}fromJSON(t){this.clear();for(const[h,o]of t)this.set(h,o)}}e.LinkedMap=w;class a extends w{constructor(t,h=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,h=2){return super.get(t,h)}peek(t){return super.get(t,0)}set(t,h){return super.set(t,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class P{constructor(t){y.set(this,void 0),je(this,y,t,"f")}get size(){return ye(this,y,"f").size}forEach(t,h){ye(this,y,"f").forEach(t,h)}get(t){return ye(this,y,"f").get(t)}has(t){return ye(this,y,"f").has(t)}entries(){return ye(this,y,"f").entries()}keys(){return ye(this,y,"f").keys()}values(){return ye(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return ye(this,y,"f").entries()}}e.ReadonlyMapView=P}),define(ve[104],Ee([1,0,22,10]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...D){return function(O,H){for(let X=0,re=D.length;X<re;X++){const pe=D[X](O,H);if(pe)return pe}return null}}e.or=_,e.matchesStrictPrefix=x.bind(void 0,!1),e.matchesPrefix=x.bind(void 0,!0);function x(D,O,H){if(!H||H.length<O.length)return null;let X;return D?X=I.startsWithIgnoreCase(H,O):X=H.indexOf(O)===0,X?O.length>0?[{start:0,end:O.length}]:[]:null}function y(D,O){const H=O.toLowerCase().indexOf(D.toLowerCase());return H===-1?null:[{start:H,end:H+D.length}]}e.matchesContiguousSubString=y;function A(D,O){return C(D.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=A;function C(D,O,H,X){if(H===D.length)return[];if(X===O.length)return null;if(D[H]===O[X]){let re=null;return(re=C(D,O,H+1,X+1))?S({start:X,end:X+1},re):null}return C(D,O,H,X+1)}function R(D){return 97<=D&&D<=122}function N(D){return 65<=D&&D<=90}e.isUpper=N;function b(D){return 48<=D&&D<=57}function s(D){return D===32||D===9||D===10||D===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(D=>p.add(D.charCodeAt(0)));function n(D){return s(D)||p.has(D)}function i(D,O){return D===O||n(D)&&n(O)}function d(D){return R(D)||N(D)||b(D)}function S(D,O){return O.length===0?O=[D]:D.end===O[0].start?O[0].start=D.start:O.unshift(D),O}function M(D,O){for(let H=O;H<D.length;H++){const X=D.charCodeAt(H);if(N(X)||b(X)||H>0&&!d(D.charCodeAt(H-1)))return H}return D.length}function u(D,O,H,X){if(H===D.length)return[];if(X===O.length)return null;if(D[H]!==O[X].toLowerCase())return null;{let re=null,pe=X+1;for(re=u(D,O,H+1,X+1);!re&&(pe=M(O,pe))<O.length;)re=u(D,O,H+1,pe),pe++;return re===null?null:S({start:X,end:X+1},re)}}function f(D){let O=0,H=0,X=0,re=0,pe=0;for(let xe=0;xe<D.length;xe++)pe=D.charCodeAt(xe),N(pe)&&O++,R(pe)&&H++,d(pe)&&X++,b(pe)&&re++;const Ce=O/D.length,Me=H/D.length,Le=X/D.length,ze=re/D.length;return{upperPercent:Ce,lowerPercent:Me,alphaPercent:Le,numericPercent:ze}}function w(D){const{upperPercent:O,lowerPercent:H}=D;return H===0&&O>.6}function a(D){const{upperPercent:O,lowerPercent:H,alphaPercent:X,numericPercent:re}=D;return H>.2&&O<.8&&X>.6&&re<.2}function P(D){let O=0,H=0,X=0,re=0;for(let pe=0;pe<D.length;pe++)X=D.charCodeAt(pe),N(X)&&O++,R(X)&&H++,s(X)&&re++;return(O===0||H===0)&&re===0?D.length<=30:O<=5}function c(D,O){if(!O||(O=O.trim(),O.length===0)||!P(D)||O.length>60)return null;const H=f(O);if(!a(H)){if(!w(H))return null;O=O.toLowerCase()}let X=null,re=0;for(D=D.toLowerCase();re<O.length&&(X=u(D,O,0,re))===null;)re=M(O,re+1);return X}e.matchesCamelCase=c;function t(D,O,H=!1){if(!O||O.length===0)return null;let X=null,re=0;for(D=D.toLowerCase(),O=O.toLowerCase();re<O.length&&(X=h(D,O,0,re,H))===null;)re=o(O,re+1);return X}e.matchesWords=t;function h(D,O,H,X,re){if(H===D.length)return[];if(X===O.length)return null;if(i(D.charCodeAt(H),O.charCodeAt(X))){let pe=null,Ce=X+1;if(pe=h(D,O,H+1,X+1,re),!re)for(;!pe&&(Ce=o(O,Ce))<O.length;)pe=h(D,O,H+1,Ce,re),Ce++;return pe===null?null:S({start:X,end:X+1},pe)}else return null}function o(D,O){for(let H=O;H<D.length;H++)if(n(D.charCodeAt(H))||H>0&&n(D.charCodeAt(H-1)))return H;return D.length}const l=_(e.matchesPrefix,c,y),E=_(e.matchesPrefix,c,A),m=new r.LRUCache(1e4);function v(D,O,H=!1){if(typeof D!="string"||typeof O!="string")return null;let X=m.get(D);X||(X=new RegExp(I.convertSimple2RegExpPattern(D),"i"),m.set(D,X));const re=X.exec(O);return re?[{start:re.index,end:re.index+re[0].length}]:H?E(D,O):l(D,O)}e.matchesFuzzy=v;function k(D,O){const H=Ae(D,D.toLowerCase(),0,O,O.toLowerCase(),0,!0);return H?$(H):null}e.matchesFuzzy2=k;function T(D,O,H,X,re,pe){const Ce=Math.min(13,D.length);for(;H<Ce;H++){const Me=Ae(D,O,H,X,re,pe,!1);if(Me)return Me}return[0,pe]}e.anyScore=T;function $(D){if(typeof D=="undefined")return[];const O=[],H=D[1];for(let X=D.length-1;X>1;X--){const re=D[X]+H,pe=O[O.length-1];pe&&pe.end===re?pe.end=re+1:O.push({start:re,end:re+1})}return O}e.createMatches=$;const g=128;function U(){const D=[],O=[];for(let H=0;H<=g;H++)O[H]=0;for(let H=0;H<=g;H++)D.push(O.slice(0));return D}function z(D){const O=[];for(let H=0;H<=D;H++)O[H]=0;return O}const q=z(2*g),j=z(2*g),J=U(),W=U(),ie=U(),le=!1;function te(D,O,H,X,re){function pe(Me,Le,ze=" "){for(;Me.length<Le;)Me=ze+Me;return Me}let Ce=` |   |${X.split("").map(Me=>pe(Me,3)).join("|")}
`;for(let Me=0;Me<=H;Me++)Me===0?Ce+=" |":Ce+=`${O[Me-1]}|`,Ce+=D[Me].slice(0,re+1).map(Le=>pe(Le.toString(),3)).join("|")+`
`;return Ce}function ue(D,O,H,X){D=D.substr(O),H=H.substr(X),console.log(te(W,D,D.length,H,H.length)),console.log(te(ie,D,D.length,H,H.length)),console.log(te(J,D,D.length,H,H.length))}function he(D,O){if(O<0||O>=D.length)return!1;const H=D.codePointAt(O);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(H)}}function De(D,O){if(O<0||O>=D.length)return!1;switch(D.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function fe(D,O,H){return O[D]!==H[D]}function ne(D,O,H,X,re,pe,Ce=!1){for(;O<H&&re<pe;)D[O]===X[re]&&(Ce&&(q[O]=re),O+=1),re+=1;return O===H}e.isPatternInWord=ne;var me;(function(D){D[D.Diag=1]="Diag",D[D.Left=2]="Left",D[D.LeftLeft=3]="LeftLeft"})(me||(me={}));var Ie;(function(D){D.Default=[-100,0];function O(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}D.isDefault=O})(Ie=e.FuzzyScore||(e.FuzzyScore={}));function Ae(D,O,H,X,re,pe,Ce){const Me=D.length>g?g:D.length,Le=X.length>g?g:X.length;if(H>=Me||pe>=Le||Me-H>Le-pe||!ne(O,H,Me,re,pe,Le,!0))return;Ue(Me,Le,H,pe,O,re);let ze=1,xe=1,Oe=H,Xe=pe;const et=[!1];for(ze=1,Oe=H;Oe<Me;ze++,Oe++){const ce=q[Oe],Re=j[Oe],$e=Oe+1<Me?j[Oe+1]:Le;for(xe=ce-pe+1,Xe=ce;Xe<$e;xe++,Xe++){let Ke=Number.MIN_SAFE_INTEGER,Qe=!1;Xe<=Re&&(Ke=Ge(D,O,Oe,H,X,re,Xe,Le,pe,J[ze-1][xe-1]===0,et));let ht=0;Ke!==Number.MAX_SAFE_INTEGER&&(Qe=!0,ht=Ke+W[ze-1][xe-1]);const _t=Xe>ce,yt=_t?W[ze][xe-1]+(J[ze][xe-1]>0?-5:0):0,Tt=Xe>ce+1&&J[ze][xe-1]>0,Ve=Tt?W[ze][xe-2]+(J[ze][xe-2]>0?-5:0):0;if(Tt&&(!_t||Ve>=yt)&&(!Qe||Ve>=ht))W[ze][xe]=Ve,ie[ze][xe]=3,J[ze][xe]=0;else if(_t&&(!Qe||yt>=ht))W[ze][xe]=yt,ie[ze][xe]=2,J[ze][xe]=0;else if(Qe)W[ze][xe]=ht,ie[ze][xe]=1,J[ze][xe]=J[ze-1][xe-1]+1;else throw new Error("not possible")}}if(le&&ue(D,H,X,pe),!et[0]&&!Ce)return;ze--,xe--;const ke=[W[ze][xe],pe];let tt=0,G=0;for(;ze>=1;){let ce=xe;do{const Re=ie[ze][ce];if(Re===3)ce=ce-2;else if(Re===2)ce=ce-1;else break}while(ce>=1);tt>1&&O[H+ze-1]===re[pe+xe-1]&&!fe(ce+pe-1,X,re)&&tt+1>J[ze][ce]&&(ce=xe),ce===xe?tt++:tt=1,G||(G=ce),ze--,xe=ce-1,ke.push(xe)}Le===Me&&(ke[0]+=2);const Q=G-Me;return ke[0]-=Q,ke}e.fuzzyScore=Ae;function Ue(D,O,H,X,re,pe){let Ce=D-1,Me=O-1;for(;Ce>=H&&Me>=X;)re[Ce]===pe[Me]&&(j[Ce]=Me,Ce--),Me--}function Ge(D,O,H,X,re,pe,Ce,Me,Le,ze,xe){if(O[H]!==pe[Ce])return Number.MIN_SAFE_INTEGER;let Oe=1,Xe=!1;return Ce===H-X?Oe=D[H]===re[Ce]?7:5:fe(Ce,re,pe)&&(Ce===0||!fe(Ce-1,re,pe))?(Oe=D[H]===re[Ce]?7:5,Xe=!0):he(pe,Ce)&&(Ce===0||!he(pe,Ce-1))?Oe=5:(he(pe,Ce-1)||De(pe,Ce-1))&&(Oe=5,Xe=!0),Oe>1&&H===X&&(xe[0]=!0),Xe||(Xe=fe(Ce,re,pe)||he(pe,Ce-1)||De(pe,Ce-1)),H===X?Ce>Le&&(Oe-=Xe?3:5):ze?Oe+=Xe?2:0:Oe+=Xe?0:1,Ce+1===Me&&(Oe-=Xe?3:5),Oe}function ge(D,O,H,X,re,pe,Ce){return L(D,O,H,X,re,pe,!0,Ce)}e.fuzzyScoreGracefulAggressive=ge;function de(D,O,H,X,re,pe,Ce){return L(D,O,H,X,re,pe,!1,Ce)}e.fuzzyScoreGraceful=de;function L(D,O,H,X,re,pe,Ce,Me){let Le=Ae(D,O,H,X,re,pe,Me);if(Le&&!Ce)return Le;if(D.length>=3){const ze=Math.min(7,D.length-1);for(let xe=H+1;xe<ze;xe++){const Oe=F(D,xe);if(Oe){const Xe=Ae(Oe,Oe.toLowerCase(),H,X,re,pe,Me);Xe&&(Xe[0]-=3,(!Le||Xe[0]>Le[0])&&(Le=Xe))}}}return Le}function F(D,O){if(O+1>=D.length)return;const H=D[O],X=D[O+1];if(H!==X)return D.slice(0,O)+X+H+D.slice(O+2)}}),define(ve[105],Ee([1,0,106,104,10]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const x=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(r.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${x.source}`,"g");function C(d){return d.replace(A,(S,M)=>M?S:`\\${S}`)}e.escapeIcons=C;const R=new RegExp(`\\\\${x.source}`,"g");function N(d){return d.replace(R,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=N;const b=new RegExp(`(\\s)?(\\\\)?${x.source}(\\s)?`,"g");function s(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(b,(S,M,u,f)=>u?S:M||f||"")}e.stripIcons=s;function p(d){const S=d.indexOf(e.iconStartMarker);return S===-1?{text:d}:n(d,S)}e.parseLabelWithIcons=p;function n(d,S){const M=[];let u="";function f(l){if(l){u+=l;for(const E of l)M.push(P)}}let w=-1,a="",P=0,c,t,h=S;const o=d.length;for(f(d.substr(0,S));h<o;)c=d[h],t=d[h+1],c===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(w=h,f(a),a=e.iconStartMarker,h++):c===")"&&w!==-1?(P+=h-w+1,w=-1,a=""):w!==-1?y.test(c)?a+=c:(f(a),w=-1,a=""):f(c),h++;return f(a),{text:u,iconOffsets:M}}function i(d,S,M=!1){const{text:u,iconOffsets:f}=S;if(!f||f.length===0)return(0,I.matchesFuzzy)(d,u,M);const w=(0,_.ltrim)(u," "),a=u.length-w.length,P=(0,I.matchesFuzzy)(d,w,M);if(P)for(const c of P){const t=f[c.start+a]+a;c.start+=t,c.end+=t}return P}e.matchesFuzzyIconAware=i}),define(ve[34],Ee([1,0,10]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(I||(I={})),function(_){const x="error",y="warning",A="warn",C="info",R="ignore";function N(s){return s?r.equalsIgnoreCase(x,s)?_.Error:r.equalsIgnoreCase(y,s)||r.equalsIgnoreCase(A,s)?_.Warning:r.equalsIgnoreCase(C,s)?_.Info:_.Ignore:_.Ignore}_.fromValue=N;function b(s){switch(s){case _.Error:return x;case _.Warning:return y;case _.Info:return C;default:return R}}_.toString=b}(I||(I={})),e.default=I}),define(ve[35],Ee([1,0,17,23,10,13]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(h){return h===47||h===92}e.isPathSeparator=y;function A(h){return h.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=A;function C(h){return h.indexOf("/")===-1&&(h=A(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.toPosixPath=C;function R(h,o=r.posix.sep){if(!h)return"";const l=h.length,E=h.charCodeAt(0);if(y(E)){if(y(h.charCodeAt(1))&&!y(h.charCodeAt(2))){let v=3;const k=v;for(;v<l&&!y(h.charCodeAt(v));v++);if(k!==v&&!y(h.charCodeAt(v+1))){for(v+=1;v<l;v++)if(y(h.charCodeAt(v)))return h.slice(0,v+1).replace(/[\\/]/g,o)}}return o}else if(S(E)&&h.charCodeAt(1)===58)return y(h.charCodeAt(2))?h.slice(0,2)+o:h.slice(0,2);let m=h.indexOf("://");if(m!==-1){for(m+=3;m<l;m++)if(y(h.charCodeAt(m)))return h.slice(0,m+1)}return""}e.getRoot=R;function N(h){if(!I.isWindows||!h||h.length<5)return!1;let o=h.charCodeAt(0);if(o!==92||(o=h.charCodeAt(1),o!==92))return!1;let l=2;const E=l;for(;l<h.length&&(o=h.charCodeAt(l),o!==92);l++);return!(E===l||(o=h.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=N;const b=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(h,o=I.isWindows){const l=o?b:s;return!(!h||h.length===0||/^\s+$/.test(h)||(l.lastIndex=0,l.test(h))||o&&p.test(h)||h==="."||h===".."||o&&h[h.length-1]==="."||o&&h.length!==h.trim().length||h.length>255)}e.isValidBasename=n;function i(h,o,l){const E=h===o;return!l||E?E:!h||!o?!1:(0,_.equalsIgnoreCase)(h,o)}e.isEqual=i;function d(h,o,l,E=r.sep){if(h===o)return!0;if(!h||!o||o.length>h.length)return!1;if(l){if(!(0,_.startsWithIgnoreCase)(h,o))return!1;if(o.length===h.length)return!0;let v=o.length;return o.charAt(o.length-1)===E&&v--,h.charAt(v)===E}return o.charAt(o.length-1)!==E&&(o+=E),h.indexOf(o)===0}e.isEqualOrParent=d;function S(h){return h>=65&&h<=90||h>=97&&h<=122}e.isWindowsDriveLetter=S;function M(h,o){return I.isWindows&&h.endsWith(":")&&(h+=r.sep),(0,r.isAbsolute)(h)||(h=(0,r.join)(o,h)),h=(0,r.normalize)(h),I.isWindows?(h=(0,_.rtrim)(h,r.sep),h.endsWith(":")&&(h+=r.sep)):(h=(0,_.rtrim)(h,r.sep),h||(h=r.sep)),h}e.sanitizeFilePath=M;function u(h){const o=(0,r.normalize)(h);return I.isWindows?h.length>3?!1:f(o)&&(h.length===2||o.charCodeAt(2)===92):o===r.posix.sep}e.isRootOrDriveLetter=u;function f(h,o){return(o!==void 0?o:I.isWindows)?S(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function w(h){return f(h)?h[0]:void 0}e.getDriveLetter=w;function a(h,o,l){return o.length>h.length?-1:h===o?0:(l&&(h=h.toLowerCase(),o=o.toLowerCase()),h.indexOf(o))}e.indexOfPath=a;function P(h){const o=h.split(":");let l,E,m;for(const v of o){const k=Number(v);(0,x.isNumber)(k)?E===void 0?E=k:m===void 0&&(m=k):l=l?[l,v].join(":"):v}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:E!==void 0?E:void 0,column:m!==void 0?m:E!==void 0?1:void 0}}e.parseLineAndColumnAware=P;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(h,o,l=8){let E="";for(let v=0;v<l;v++)E+=c.charAt(Math.floor(Math.random()*c.length));let m;return o?m=`${o}-${E}`:m=E,h?(0,r.join)(h,m):m}e.randomPath=t}),define(ve[54],Ee([1,0,21,10,2]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function x(N){return JSON.stringify(N,C)}e.stringify=x;function y(N){let b=JSON.parse(N);return b=R(b),b}e.parse=y;var A;(function(N){N[N.Uri=1]="Uri",N[N.Regexp=2]="Regexp",N[N.ScmResource=3]="ScmResource",N[N.ScmResourceGroup=4]="ScmResourceGroup",N[N.ScmProvider=5]="ScmProvider",N[N.CommentController=6]="CommentController",N[N.CommentThread=7]="CommentThread",N[N.CommentThreadReply=8]="CommentThreadReply",N[N.CommentNode=9]="CommentNode",N[N.CommentThreadNode=10]="CommentThreadNode",N[N.TimelineActionContext=11]="TimelineActionContext",N[N.NotebookCellActionContext=12]="NotebookCellActionContext",N[N.TestItemContext=13]="TestItemContext",N[N.Date=14]="Date"})(A=e.MarshalledId||(e.MarshalledId={}));function C(N,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,I.regExpFlags)(b)}:b}function R(N,b=0){if(!N||b>200)return N;if(typeof N=="object"){switch(N.$mid){case 1:return _.URI.revive(N);case 2:return new RegExp(N.source,N.flags);case 14:return new Date(N.source)}if(N instanceof r.VSBuffer||N instanceof Uint8Array)return N;if(Array.isArray(N))for(let s=0;s<N.length;++s)N[s]=R(N[s],b+1);else for(const s in N)Object.hasOwnProperty.call(N,s)&&(N[s]=R(N[s],b+1))}return N}e.revive=R}),define(ve[9],Ee([1,0,23,2]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var _;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls"})(_=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class x{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,R,N){this._hosts[C]=R,this._ports[C]=N}setConnectionToken(C,R){this._connectionTokens[C]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const R=C.authority;let N=this._hosts[R];N&&N.indexOf(":")!==-1&&(N=`[${N}]`);const b=this._ports[R],s=this._connectionTokens[R];let p=`path=${encodeURIComponent(C.path)}`;return typeof s=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(s)}`),I.URI.from({scheme:r.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${N}:${b}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new x;class y{asBrowserUri(C,R){const N=this.toUri(C,R);return N.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===_.file&&(r.isNative||typeof r.globals.importScripts=="function"&&r.globals.origin===`${_.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?N.with({scheme:_.vscodeFileResource,authority:N.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):N}asFileUri(C,R){const N=this.toUri(C,R);return N.scheme===_.vscodeFileResource?N.with({scheme:_.file,authority:N.authority!==y.FALLBACK_AUTHORITY?N.authority:null,query:null,fragment:null}):N}toUri(C,R){return I.URI.isUri(C)?C:I.URI.parse(R.toUrl(C))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y}),define(ve[24],Ee([1,0,35,9,17,23,10,2]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(p){return(0,A.uriToFsPath)(p,!0)}e.originalFSPath=C;class R{constructor(n){this._ignorePathCasing=n}compare(n,i,d=!1){return n===i?0:(0,y.compare)(this.getComparisonKey(n,d),this.getComparisonKey(i,d))}isEqual(n,i,d=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,d)===this.getComparisonKey(i,d)}getComparisonKey(n,i=!1){return n.with({path:this._ignorePathCasing(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this._ignorePathCasing(n)}isEqualOrParent(n,i,d=!1){if(n.scheme===i.scheme){if(n.scheme===I.Schemas.file)return r.isEqualOrParent(C(n),C(i),this._ignorePathCasing(n))&&n.query===i.query&&(d||n.fragment===i.fragment);if((0,e.isEqualAuthority)(n.authority,i.authority))return r.isEqualOrParent(n.path,i.path,this._ignorePathCasing(n),"/")&&n.query===i.query&&(d||n.fragment===i.fragment)}return!1}joinPath(n,...i){return A.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.basename)(n)||n.authority}basename(n){return _.posix.basename(n.path)}extname(n){return _.posix.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===I.Schemas.file?i=A.URI.file(_.dirname(C(n))).path:(i=_.posix.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===I.Schemas.file?i=A.URI.file(_.normalize(C(n))).path:i=_.posix.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.isEqualAuthority)(n.authority,i.authority))return;if(n.scheme===I.Schemas.file){const M=_.relative(C(n),C(i));return x.isWindows?r.toSlashes(M):M}let d=n.path||"/",S=i.path||"/";if(this._ignorePathCasing(n)){let M=0;for(const u=Math.min(d.length,S.length);M<u&&!(d.charCodeAt(M)!==S.charCodeAt(M)&&d.charAt(M).toLowerCase()!==S.charAt(M).toLowerCase());M++);d=S.substr(0,M)+d.substr(M)}return _.posix.relative(d,S)}resolvePath(n,i){if(n.scheme===I.Schemas.file){const d=A.URI.file(_.resolve(C(n),i));return n.with({authority:d.authority,path:d.path})}return i=r.toPosixPath(i),n.with({path:_.posix.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,y.equalsIgnoreCase)(n,i)}hasTrailingPathSeparator(n,i=_.sep){if(n.scheme===I.Schemas.file){const d=C(n);return d.length>r.getRoot(d).length&&d[d.length-1]===i}else{const d=n.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=_.sep){return(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=_.sep){let d=!1;if(n.scheme===I.Schemas.file){const S=C(n);d=S!==void 0&&S.length===r.getRoot(S).length&&S[S.length-1]===i}else{i="/";const S=n.path;d=S.length===1&&S.charCodeAt(S.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(n,i)?n.with({path:n.path+"/"}):n}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(p=>p.scheme===I.Schemas.file?!x.isLinux:!0),e.extUriIgnorePathCase=new R(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(p,n){const i=[];for(let d=0;d<p.length;d++){const S=n(p[d]);p.some((M,u)=>u===d?!1:(0,e.isEqualOrParent)(S,n(M)))||i.push(p[d])}return i}e.distinctParents=N;var b;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function n(i){const d=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(u=>{const[f,w]=u.split(":");f&&w&&d.set(f,w)});const M=i.path.substring(0,i.path.indexOf(";"));return M&&d.set(p.META_DATA_MIME,M),d}p.parseMetaData=n})(b=e.DataUri||(e.DataUri={}));function s(p,n,i){if(n){let d=p.path;return d&&d[0]!==_.posix.sep&&(d=_.posix.sep+d),p.with({scheme:i,authority:n,path:d})}return p.with({scheme:i})}e.toLocalResource=s}),define(ve[11],Ee([1,0,20,15,5,6,24,23]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=C;function R(fe){const ne=new r.CancellationTokenSource,me=fe(ne.token),Ie=new Promise((Ae,Ue)=>{const Ge=ne.token.onCancellationRequested(()=>{Ge.dispose(),ne.dispose(),Ue(new I.CancellationError)});Promise.resolve(me).then(ge=>{Ge.dispose(),ne.dispose(),Ae(ge)},ge=>{Ge.dispose(),ne.dispose(),Ue(ge)})});return new class{cancel(){ne.cancel()}then(Ae,Ue){return Ie.then(Ae,Ue)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return Ie.finally(Ae)}}}e.createCancelablePromise=R;function N(fe,ne,me){return new Promise((Ie,Ae)=>{const Ue=ne.onCancellationRequested(()=>{Ue.dispose(),Ie(me)});fe.then(Ie,Ae).finally(()=>Ue.dispose())})}e.raceCancellation=N;function b(fe,ne){return new Promise((me,Ie)=>{const Ae=ne.onCancellationRequested(()=>{Ae.dispose(),Ie(new I.CancellationError)});fe.then(me,Ie).finally(()=>Ae.dispose())})}e.raceCancellationError=b;async function s(fe){let ne=-1;const me=fe.map((Ae,Ue)=>Ae.then(Ge=>(ne=Ue,Ge))),Ie=await Promise.race(me);return fe.forEach((Ae,Ue)=>{Ue!==ne&&Ae.cancel()}),Ie}e.raceCancellablePromises=s;function p(fe,ne,me){let Ie;const Ae=setTimeout(()=>{Ie?.(void 0),me?.()},ne);return Promise.race([fe.finally(()=>clearTimeout(Ae)),new Promise(Ue=>Ie=Ue)])}e.raceTimeout=p;function n(fe){return new Promise((ne,me)=>{const Ie=fe();C(Ie)?Ie.then(ne,me):ne(Ie)})}e.asPromise=n;class i{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const Ie=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ie};this.queuedPromise=new Promise(Ie=>{this.activePromise.then(me,me).then(Ie)})}return new Promise((me,Ie)=>{this.queuedPromise.then(me,Ie)})}return this.activePromise=ne(),new Promise((me,Ie)=>{this.activePromise.then(Ae=>{this.activePromise=null,me(Ae)},Ae=>{this.activePromise=null,Ie(Ae)})})}}e.Throttler=i;class d{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=d;class S{constructor(){this.promiseMap=new Map}queue(ne,me){const Ae=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(ne)===Ae&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Ae),Ae}}e.SequencerByKey=S;const M=(fe,ne)=>{let me=!0;const Ie=setTimeout(()=>{me=!1,ne()},fe);return{isTriggered:()=>me,dispose:()=>{clearTimeout(Ie),me=!1}}},u=fe=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,fe())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,me=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ae,Ue)=>{this.doResolve=Ae,this.doReject=Ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ae=this.task;return this.task=null,Ae()}}));const Ie=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?u(Ie):M(me,Ie),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new I.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class w{constructor(ne){this.delayer=new f(ne),this.throttler=new i}trigger(ne,me){return this.delayer.trigger(()=>this.throttler.queue(ne),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class a{constructor(){this._isOpen=!1,this._promise=new Promise((ne,me)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class P extends a{constructor(ne){super();this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=P;function c(fe,ne){return ne?new Promise((me,Ie)=>{const Ae=setTimeout(()=>{Ue.dispose(),me()},fe),Ue=ne.onCancellationRequested(()=>{clearTimeout(Ae),Ue.dispose(),Ie(new I.CancellationError)})}):R(me=>c(fe,me))}e.timeout=c;function t(fe,ne=0){const me=setTimeout(fe,ne);return(0,x.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=t;function h(fe){const ne=[];let me=0;const Ie=fe.length;function Ae(){return me<Ie?fe[me++]():null}function Ue(Ge){Ge!=null&&ne.push(Ge);const ge=Ae();return ge?ge.then(Ue):Promise.resolve(ne)}return Promise.resolve(null).then(Ue)}e.sequence=h;function o(fe,ne=Ie=>!!Ie,me=null){let Ie=0;const Ae=fe.length,Ue=()=>{if(Ie>=Ae)return Promise.resolve(me);const Ge=fe[Ie++];return Promise.resolve(Ge()).then(de=>ne(de)?Promise.resolve(de):Ue())};return Ue()}e.first=o;function l(fe,ne=Ie=>!!Ie,me=null){if(fe.length===0)return Promise.resolve(me);let Ie=fe.length;const Ae=()=>{Ie=-1;for(const Ue of fe)Ue.cancel?.()};return new Promise((Ue,Ge)=>{for(const ge of fe)ge.then(de=>{--Ie>=0&&ne(de)?(Ae(),Ue(de)):Ie===0&&Ue(me)}).catch(de=>{--Ie>=0&&(Ae(),Ge(de))})})}e.firstParallel=l;class E{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(ne){return this._size++,new Promise((me,Ie)=>{this.outstandingPromises.push({factory:ne,c:me,e:Ie}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const me=ne.factory();me.then(ne.c,ne.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=E;class m extends E{constructor(){super(1)}}e.Queue=m;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new ie;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,me=y.extUri){const Ie=me.getComparisonKey(ne);let Ae=this.queues.get(Ie);return Ae||(Ae=new m,_.Event.once(Ae.onFinished)(()=>{Ae?.dispose(),this.queues.delete(Ie),this.onDidQueueFinish()}),this.queues.set(Ie,Ae)),Ae}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class k{constructor(ne,me){this._token=-1,typeof ne=="function"&&typeof me=="number"&&this.setIfNotSet(ne,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},me)}setIfNotSet(ne,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},me))}}e.TimeoutTimer=k;class T{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setInterval(()=>{ne()},me)}}e.IntervalTimer=T;class ${constructor(ne,me){this.timeoutToken=-1,this.runner=ne,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=$;class g{constructor(ne,me){me%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class U extends ${constructor(ne,me){super(ne,me);this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner&&this.runner(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class z extends x.Disposable{constructor(ne,me){super();this.options=ne,this.handler=me,this.pendingWork=[],this.throttler=this._register(new x.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(ne)return;const me=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(fe,ne)=>{const me=requestIdleCallback(fe,typeof ne=="number"?{timeout:ne}:void 0);let Ie=!1;return{dispose(){Ie||(Ie=!0,cancelIdleCallback(me))}}}}();class q{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function j(fe,ne,me){let Ie;for(let Ae=0;Ae<me;Ae++)try{return await fe()}catch(Ue){Ie=Ue,await c(ne)}throw Ie}e.retry=j;class J{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ne,me,Ie){return this._pending={taskId:ne,cancel:()=>Ie?.(),promise:me},me.then(()=>this.donePending(ne),()=>this.donePending(ne)),me}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let me,Ie;const Ae=new Promise((Ue,Ge)=>{me=Ue,Ie=Ge});this._next={run:ne,promise:Ae,promiseResolve:me,promiseReject:Ie}}return this._next.promise}}e.TaskSequentializer=J;class W{constructor(ne,me=()=>Date.now()){this.interval=ne,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class ie{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,me)=>{this.completeCallback=ne,this.errorCallback=me})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(me=>{this.completeCallback(ne),this.resolved=!0,me()})}error(ne){return new Promise(me=>{this.errorCallback(ne),this.rejected=!0,me()})}cancel(){new Promise(ne=>{this.errorCallback(new I.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=ie;var le;(function(fe){async function ne(Ie){let Ae;const Ue=await Promise.all(Ie.map(Ge=>Ge.then(ge=>ge,ge=>{Ae||(Ae=ge)})));if(typeof Ae!="undefined")throw Ae;return Ue}fe.settled=ne;function me(Ie){return new Promise(async(Ae,Ue)=>{try{await Ie(Ae,Ue)}catch(Ge){Ue(Ge)}})}fe.withAsyncBody=me})(le=e.Promises||(e.Promises={}));var te;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(te||(te={}));class ue{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new _.Emitter,queueMicrotask(async()=>{const me={emitOne:Ie=>this.emitOne(Ie),emitMany:Ie=>this.emitMany(Ie),reject:Ie=>this.reject(Ie)};try{await Promise.resolve(ne(me)),this.resolve()}catch(Ie){this.reject(Ie)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}static fromArray(ne){return new ue(me=>{me.emitMany(ne)})}static fromPromise(ne){return new ue(async me=>{me.emitMany(await ne)})}static fromPromises(ne){return new ue(async me=>{await Promise.all(ne.map(async Ie=>me.emitOne(await Ie)))})}static merge(ne){return new ue(async me=>{await Promise.all(ne.map(async Ie=>{for await(const Ae of Ie)me.emitOne(Ae)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await _.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,me){return new ue(async Ie=>{for await(const Ae of ne)Ie.emitOne(me(Ae))})}map(ne){return ue.map(this,ne)}static filter(ne,me){return new ue(async Ie=>{for await(const Ae of ne)me(Ae)&&Ie.emitOne(Ae)})}filter(ne){return ue.filter(this,ne)}static coalesce(ne){return ue.filter(ne,me=>!!me)}coalesce(){return ue.coalesce(this)}static async toPromise(ne){const me=[];for await(const Ie of ne)me.push(Ie);return me}toPromise(){return ue.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class he extends ue{constructor(ne,me){super(me);this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=he;function De(fe){const ne=new r.CancellationTokenSource,me=fe(ne.token);return new he(ne,async Ie=>{const Ae=ne.token.onCancellationRequested(()=>{Ae.dispose(),ne.dispose(),Ie.reject(new I.CancellationError)});try{for await(const Ue of me){if(ne.token.isCancellationRequested)return;Ie.emitOne(Ue)}Ae.dispose(),ne.dispose()}catch(Ue){Ae.dispose(),ne.dispose(),Ie.reject(Ue)}})}e.createCancelableAsyncIterable=De}),define(ve[107],Ee([1,0,11,17]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new r.IdleValue(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),x=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(m,v,k=!1){const T=m||"",$=v||"",g=_.value.collator.compare(T,$);return _.value.collatorIsNumeric&&g===0&&T!==$?T<$?-1:1:g}e.compareFileNames=A;function C(m,v){const k=x.value.collator;return m=m||"",v=v||"",w(k,m,v)}e.compareFileNamesDefault=C;function R(m,v){const k=x.value.collator;return m=m||"",v=v||"",t(m,v)||w(k,m,v)}e.compareFileNamesUpper=R;function N(m,v){const k=x.value.collator;return m=m||"",v=v||"",c(m,v)||w(k,m,v)}e.compareFileNamesLower=N;function b(m,v){return m=m||"",v=v||"",m===v?0:m<v?-1:1}e.compareFileNamesUnicode=b;function s(m,v,k=!1){k||(m=m&&m.toLowerCase(),v=v&&v.toLowerCase());const[T,$]=u(m),[g,U]=u(v);return T!==g?T<g?-1:1:$===U?0:$<U?-1:1}e.noIntlCompareFileNames=s;function p(m,v){const[k,T]=u(m),[$,g]=u(v);let U=_.value.collator.compare(T,g);if(U===0){if(_.value.collatorIsNumeric&&T!==g)return T<g?-1:1;if(U=_.value.collator.compare(k,$),_.value.collatorIsNumeric&&U===0&&k!==$)return k<$?-1:1}return U}e.compareFileExtensions=p;function n(m,v){m=m||"",v=v||"";const k=f(m),T=f(v),$=x.value.collator,g=y.value.collator;return w(g,k,T)||w($,m,v)}e.compareFileExtensionsDefault=n;function i(m,v){m=m||"",v=v||"";const k=f(m),T=f(v),$=x.value.collator,g=y.value.collator;return w(g,k,T)||t(m,v)||w($,m,v)}e.compareFileExtensionsUpper=i;function d(m,v){m=m||"",v=v||"";const k=f(m),T=f(v),$=x.value.collator,g=y.value.collator;return w(g,k,T)||c(m,v)||w($,m,v)}e.compareFileExtensionsLower=d;function S(m,v){m=m||"",v=v||"";const k=f(m).toLowerCase(),T=f(v).toLowerCase();return k!==T?k<T?-1:1:m!==v?m<v?-1:1:0}e.compareFileExtensionsUnicode=S;const M=/^(.*?)(\.([^.]*))?$/;function u(m,v=!1){const k=m?M.exec(m):[];let T=[k&&k[1]||"",k&&k[3]||""];return v&&(!T[0]&&T[1]||T[0]&&T[0].charAt(0)===".")&&(T=[T[0]+"."+T[1],""]),T}function f(m){const v=m?M.exec(m):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function w(m,v,k){let T=m.compare(v,k);return T!==0?T:v.length!==k.length?v.length<k.length?-1:1:0}function a(m){const v=m.charAt(0);return v.toLocaleUpperCase()!==v}function P(m){const v=m.charAt(0);return v.toLocaleLowerCase()!==v}function c(m,v){return a(m)&&P(v)?-1:P(m)&&a(v)?1:0}function t(m,v){return P(m)&&a(v)?-1:a(m)&&P(v)?1:0}function h(m,v,k=!1){return k||(m=m&&m.toLowerCase(),v=v&&v.toLowerCase()),m===v?0:m<v?-1:1}function o(m,v,k=!1){const T=m.split(I.sep),$=v.split(I.sep),g=T.length-1,U=$.length-1;let z,q;for(let j=0;;j++){if(z=g===j,q=U===j,z&&q)return A(T[j],$[j],k);if(z)return-1;if(q)return 1;const J=h(T[j],$[j],k);if(J!==0)return J}}e.comparePaths=o;function l(m,v,k){const T=m.toLowerCase(),$=v.toLowerCase(),g=E(m,v,k);if(g)return g;const U=T.endsWith(k),z=$.endsWith(k);if(U!==z)return U?-1:1;const q=A(T,$);return q!==0?q:T.localeCompare($)}e.compareAnything=l;function E(m,v,k){const T=m.toLowerCase(),$=v.toLowerCase(),g=T.startsWith(k),U=$.startsWith(k);if(g!==U)return g?-1:1;if(g&&U){if(T.length<$.length)return-1;if(T.length>$.length)return 1}return 0}e.compareByPrefix=E}),define(ve[29],Ee([1,0,11,35,22,17,23,10]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",N="[^/\\\\]",b=/\//g;function s(ie){switch(ie){case 0:return"";case 1:return`${N}*?`;default:return`(?:${R}|${N}+${R}|${R}${N}+)*?`}}function p(ie,le){if(!ie)return[];const te=[];let ue=!1,he=!1,De="";for(const fe of ie){switch(fe){case le:if(!ue&&!he){te.push(De),De="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":he=!0;break;case"]":he=!1;break}De+=fe}return De&&te.push(De),te}e.splitGlobAware=p;function n(ie){if(!ie)return"";let le="";const te=p(ie,e.GLOB_SPLIT);if(te.every(ue=>ue===e.GLOBSTAR))le=".*";else{let ue=!1;te.forEach((he,De)=>{if(he===e.GLOBSTAR){ue||(le+=s(2),ue=!0);return}let fe=!1,ne="",me=!1,Ie="";for(const Ae of he){if(Ae!=="}"&&fe){ne+=Ae;continue}if(me&&(Ae!=="]"||!Ie)){let Ue;Ae==="-"?Ue=Ae:(Ae==="^"||Ae==="!")&&!Ie?Ue="^":Ae===e.GLOB_SPLIT?Ue="":Ue=(0,A.escapeRegExpCharacters)(Ae),Ie+=Ue;continue}switch(Ae){case"{":fe=!0;continue;case"[":me=!0;continue;case"}":{le+=`(?:${p(ne,",").map(ge=>n(ge)).join("|")})`,fe=!1,ne="";break}case"]":le+="["+Ie+"]",me=!1,Ie="";break;case"?":le+=N;continue;case"*":le+=s(1);continue;default:le+=(0,A.escapeRegExpCharacters)(Ae)}}De<te.length-1&&(te[De+1]!==e.GLOBSTAR||De+2<te.length)&&(le+=R),ue=!1})}return le}const i=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,M=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,w=new _.LRUCache(1e4),a=function(){return!1},P=function(){return null};function c(ie,le){if(!ie)return P;let te;typeof ie!="string"?te=ie.pattern:te=ie,te=te.trim();const ue=`${te}_${!!le.trimForExclusions}`;let he=w.get(ue);if(he)return t(he,ie);let De;if(i.test(te)){const fe=te.substr(4);he=function(ne,me){return typeof ne=="string"&&ne.endsWith(fe)?te:null}}else(De=d.exec(h(te,le)))?he=o(De[1],te):(le.trimForExclusions?M:S).test(te)?he=l(te,le):(De=u.exec(h(te,le)))?he=E(De[1].substr(1),te,!0):(De=f.exec(h(te,le)))?he=E(De[1],te,!1):he=m(te);return w.set(ue,he),t(he,ie)}function t(ie,le){return typeof le=="string"?ie:function(te,ue){return(0,I.isEqualOrParent)(te,le.base,!y.isLinux)?ie(te.substr(le.base.length+1),ue):null}}function h(ie,le){return le.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function o(ie,le){const te=`/${ie}`,ue=`\\${ie}`,he=function(fe,ne){return typeof fe!="string"?null:ne?ne===ie?le:null:fe===ie||fe.endsWith(te)||fe.endsWith(ue)?le:null},De=[ie];return he.basenames=De,he.patterns=[le],he.allBasenames=De,he}function l(ie,le){const te=W(ie.slice(1,-1).split(",").map(ne=>c(ne,le)).filter(ne=>ne!==P),ie),ue=te.length;if(!ue)return P;if(ue===1)return te[0];const he=function(ne,me){for(let Ie=0,Ae=te.length;Ie<Ae;Ie++)if(te[Ie](ne,me))return ie;return null},De=te.find(ne=>!!ne.allBasenames);De&&(he.allBasenames=De.allBasenames);const fe=te.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return fe.length&&(he.allPaths=fe),he}function E(ie,le,te){const ue=x.sep===x.posix.sep,he=ue?ie:ie.replace(b,x.sep),De=x.sep+he,fe=x.posix.sep+ie,ne=te?function(me,Ie){return typeof me=="string"&&(me===he||me.endsWith(De)||!ue&&(me===ie||me.endsWith(fe)))?le:null}:function(me,Ie){return typeof me=="string"&&(me===he||!ue&&me===ie)?le:null};return ne.allPaths=[(te?"*/":"./")+ie],ne}function m(ie){try{const le=new RegExp(`^${n(ie)}$`);return function(te){return le.lastIndex=0,typeof te=="string"&&le.test(te)?ie:null}}catch{return P}}function v(ie,le,te){return!ie||typeof le!="string"?!1:k(ie)(le,void 0,te)}e.match=v;function k(ie,le={}){if(!ie)return a;if(typeof ie=="string"||U(ie)){const te=c(ie,le);if(te===P)return a;const ue=function(he,De){return!!te(he,De)};return te.allBasenames&&(ue.allBasenames=te.allBasenames),te.allPaths&&(ue.allPaths=te.allPaths),ue}return j(ie,le)}e.parse=k;function T(ie){if(!ie)return;let le;return te=>(le||(le=(ie()||Promise.resolve([])).then(ue=>ue?g(ue):{})),le.then(ue=>!!ue[te]))}e.hasSiblingPromiseFn=T;function $(ie){if(!ie)return;let le;return te=>{if(!le){const ue=ie();le=ue?g(ue):{}}return!!le[te]}}e.hasSiblingFn=$;function g(ie){const le={};for(const te of ie)le[te]=!0;return le}function U(ie){const le=ie;return le?typeof le.base=="string"&&typeof le.pattern=="string":!1}e.isRelativePattern=U;function z(ie){return ie.allBasenames||[]}e.getBasenameTerms=z;function q(ie){return ie.allPaths||[]}e.getPathTerms=q;function j(ie,le){const te=W(Object.getOwnPropertyNames(ie).map(ne=>J(ne,ie[ne],le)).filter(ne=>ne!==P)),ue=te.length;if(!ue)return P;if(!te.some(ne=>!!ne.requiresSiblings)){if(ue===1)return te[0];const ne=function(Ae,Ue){for(let Ge=0,ge=te.length;Ge<ge;Ge++){const de=te[Ge](Ae,Ue);if(de)return de}return null},me=te.find(Ae=>!!Ae.allBasenames);me&&(ne.allBasenames=me.allBasenames);const Ie=te.reduce((Ae,Ue)=>Ue.allPaths?Ae.concat(Ue.allPaths):Ae,[]);return Ie.length&&(ne.allPaths=Ie),ne}const he=function(ne,me,Ie){let Ae;for(let Ue=0,Ge=te.length;Ue<Ge;Ue++){const ge=te[Ue];ge.requiresSiblings&&Ie&&(me||(me=(0,x.basename)(ne)),Ae||(Ae=me.substr(0,me.length-(0,x.extname)(ne).length)));const de=ge(ne,me,Ae,Ie);if(de)return de}return null},De=te.find(ne=>!!ne.allBasenames);De&&(he.allBasenames=De.allBasenames);const fe=te.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return fe.length&&(he.allPaths=fe),he}function J(ie,le,te){if(le===!1)return P;const ue=c(ie,te);if(ue===P)return P;if(typeof le=="boolean")return ue;if(le){const he=le.when;if(typeof he=="string"){const De=(fe,ne,me,Ie)=>{if(!Ie||!ue(fe,ne))return null;const Ae=he.replace("$(basename)",me),Ue=Ie(Ae);return(0,r.isThenable)(Ue)?Ue.then(Ge=>Ge?ie:null):Ue?ie:null};return De.requiresSiblings=!0,De}}return ue}function W(ie,le){const te=ie.filter(ne=>!!ne.basenames);if(te.length<2)return ie;const ue=te.reduce((ne,me)=>{const Ie=me.basenames;return Ie?ne.concat(Ie):ne},[]);let he;if(le){he=[];for(let ne=0,me=ue.length;ne<me;ne++)he.push(le)}else he=te.reduce((ne,me)=>{const Ie=me.patterns;return Ie?ne.concat(Ie):ne},[]);const De=function(ne,me){if(typeof ne!="string")return null;if(!me){let Ae;for(Ae=ne.length;Ae>0;Ae--){const Ue=ne.charCodeAt(Ae-1);if(Ue===47||Ue===92)break}me=ne.substr(Ae)}const Ie=ue.indexOf(me);return Ie!==-1?he[Ie]:null};De.basenames=ue,De.patterns=he,De.allBasenames=ue;const fe=ie.filter(ne=>!ne.basenames);return fe.push(De),fe}}),define(ve[71],Ee([1,0,15,105,24,2]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(i="",d=!1){if(this.value=i,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(i,d=0){return this.value+=b(this.supportThemeIcons?(0,I.escapeIcons)(i):i).replace(/([ \t]+)/g,(S,M)=>"&nbsp;".repeat(M.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,d){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=A;function C(n){return R(n)?!n.value:Array.isArray(n)?n.every(C):!0}e.isEmptyMarkdownString=C;function R(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function N(n,i){return n===i?!0:!n||!i?!1:n.value===i.value&&n.isTrusted===i.isTrusted&&n.supportThemeIcons===i.supportThemeIcons&&n.supportHtml===i.supportHtml&&(n.baseUri===i.baseUri||!!n.baseUri&&!!i.baseUri&&(0,_.isEqual)(x.URI.from(n.baseUri),x.URI.from(i.baseUri)))}e.markdownStringEqual=N;function b(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function s(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=s;function p(n){const i=[],d=n.split("|").map(M=>M.trim());n=d[0];const S=d[1];if(S){const M=/height=(\d+)/.exec(S),u=/width=(\d+)/.exec(S),f=M?M[1]:"",w=u?u[1]:"",a=isFinite(parseInt(w)),P=isFinite(parseInt(f));a&&i.push(`width="${w}"`),P&&i.push(`height="${f}"`)}return{href:n,dimensions:i}}e.parseHrefAndDimensions=p}),define(ve[72],Ee([1,0,35,9,17,23,24,10,2]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(t,h,o){if(typeof t=="string"&&(t=C.URI.file(t)),o){const E=o.getWorkspaceFolder(t);if(E){const m=o.getWorkspace().folders.length>1;let v;if((0,y.isEqual)(E.uri,t)?v="":v=(0,y.relativePath)(E.uri,t),m){const k=E.name?E.name:(0,y.basename)(E.uri);v=v?k+" \u2022 "+v:k}return v}}if(t.scheme!==I.Schemas.file&&t.scheme!==I.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,r.hasDriveLetter)(t.fsPath))return(0,_.normalize)(b(t.fsPath));let l=(0,_.normalize)(t.fsPath);return!x.isWindows&&h?.userHome&&(l=p(l,h.userHome.fsPath)),l}e.getPathLabel=R;function N(t){if(!t)return;typeof t=="string"&&(t=C.URI.file(t));const h=(0,y.basename)(t)||(t.scheme===I.Schemas.file?t.fsPath:t.path);return x.isWindows&&(0,r.isRootOrDriveLetter)(h)?b(h):h}e.getBaseLabel=N;function b(t,h){return(0,r.hasDriveLetter)(t,h)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=b;let s=Object.create(null);function p(t,h){if(x.isWindows||!t||!h)return t;let o=s.original===h?s.normalized:void 0;return o||(o=`${(0,A.rtrim)(h,_.posix.sep)}${_.posix.sep}`,s={original:h,normalized:o}),(x.isLinux?t.startsWith(o):(0,A.startsWithIgnoreCase)(t,o))&&(t=`~/${t.substr(o.length)}`),t}e.tildify=p;function n(t,h){return t.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=n;const i="\u2026",d="\\\\",S="~";function M(t,h=_.sep){const o=new Array(t.length);let l=!1;for(let E=0;E<t.length;E++){let m=t[E];if(m===""){o[E]=`.${h}`;continue}if(!m){o[E]=m;continue}l=!0;let v="";m.indexOf(d)===0?(v=m.substr(0,m.indexOf(d)+d.length),m=m.substr(m.indexOf(d)+d.length)):m.indexOf(h)===0?(v=m.substr(0,m.indexOf(h)+h.length),m=m.substr(m.indexOf(h)+h.length)):m.indexOf(S)===0&&(v=m.substr(0,m.indexOf(S)+S.length),m=m.substr(m.indexOf(S)+S.length));const k=m.split(h);for(let T=1;l&&T<=k.length;T++)for(let $=k.length-T;l&&$>=0;$--){l=!1;let g=k.slice($,$+T).join(h);for(let U=0;!l&&U<t.length;U++)if(U!==E&&t[U]&&t[U].indexOf(g)>-1){const z=$+T===k.length,q=$>0&&t[U].indexOf(h)>-1?h+g:g,j=t[U].endsWith(q);l=!z||j}if(!l){let U="";(k[0].endsWith(":")||v!=="")&&($===1&&($=0,T++,g=k[0]+h+g),$>0&&(U=k[0]+h),U=v+U),$>0&&(U=U+i+h),U=U+g,$+T<k.length&&(U=U+h+i),o[E]=U}}l&&(o[E]=m)}return o}e.shorten=M;var u;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function f(t,h=Object.create(null)){const o=[];let l=!1,E="";for(const m of t)if(m==="$"||l&&m==="{")E&&o.push({value:E,type:u.TEXT}),E="",l=!0;else if(m==="}"&&l){const v=h[E];if(typeof v=="string")v.length&&o.push({value:v,type:u.VARIABLE});else if(v){const k=o[o.length-1];(!k||k.type!==u.SEPARATOR)&&o.push({value:v.label,type:u.SEPARATOR})}E="",l=!1}else E+=m;return E&&!l&&o.push({value:E,type:u.TEXT}),o.filter((m,v)=>{if(m.type===u.SEPARATOR){const k=o[v-1],T=o[v+1];return[k,T].every($=>$&&($.type===u.VARIABLE||$.type===u.TEXT)&&$.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=f;function w(t,h){return x.isMacintosh||h?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,x.isMacintosh?"&":"&&"):t.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function a(t,h){return x.isMacintosh||h?t.replace(/\(&&\w\)|&&/g,""):x.isWindows?t.replace(/&&|&/g,o=>o==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function P(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=P;function c(t){const h=t.indexOf("/")!==-1?_.posix:_.win32,o=h.basename(t),l=h.dirname(t);return o.length?{name:o,parentPath:l}:{name:l,parentPath:""}}e.splitName=c}),define(ve[108],Ee([1,0,2]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(N){return N.toJSON()}class _{constructor(b){this._uriTransformer=b}transformIncoming(b){const s=this._uriTransformer.transformIncoming(b);return s===b?b:I(r.URI.from(s))}transformOutgoing(b){const s=this._uriTransformer.transformOutgoing(b);return s===b?b:I(r.URI.from(s))}transformOutgoingURI(b){const s=this._uriTransformer.transformOutgoing(b);return s===b?b:r.URI.from(s)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(N){return N}transformOutgoing(N){return N}transformOutgoingURI(N){return N}transformOutgoingScheme(N){return N}};function x(N,b,s){if(!N||s>200)return null;if(typeof N=="object"){if(N instanceof r.URI)return b.transformOutgoing(N);for(let p in N)if(Object.hasOwnProperty.call(N,p)){const n=x(N[p],b,s+1);n!==null&&(N[p]=n)}}return null}function y(N,b){const s=x(N,b,0);return s===null?N:s}e.transformOutgoingURIs=y;function A(N,b,s,p){if(!N||p>200)return null;if(typeof N=="object"){if(N.$mid===1)return s?r.URI.revive(b.transformIncoming(N)):b.transformIncoming(N);for(let n in N)if(Object.hasOwnProperty.call(N,n)){const i=A(N[n],b,s,p+1);i!==null&&(N[n]=i)}}return null}function C(N,b){const s=A(N,b,!1,0);return s===null?N:s}e.transformIncomingURIs=C;function R(N,b){const s=A(N,b,!0,0);return s===null?N:s}e.transformAndReviveIncomingURIs=R}),define(ve[36],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(C){return r.test(C)}e.isUUID=I;const _=new Uint8Array(16),x=[];for(let C=0;C<256;C++)x.push(C.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(C){for(let R=0;R<C.length;R++)C[R]=Math.floor(Math.random()*256);return C};function A(){y(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let C=0,R="";return R+=x[_[C++]],R+=x[_[C++]],R+=x[_[C++]],R+=x[_[C++]],R+="-",R+=x[_[C++]],R+=x[_[C++]],R+="-",R+=x[_[C++]],R+=x[_[C++]],R+="-",R+=x[_[C++]],R+=x[_[C++]],R+="-",R+=x[_[C++]],R+=x[_[C++]],R+=x[_[C++]],R+=x[_[C++]],R+=x[_[C++]],R+=x[_[C++]],R}e.generateUuid=A}),define(ve[109],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(ve[73],Ee([1,0,29,17]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(x,y,A,C){if(Array.isArray(x)){let R=0;for(const N of x){const b=_(N,y,A,C);if(b===10)return b;b>R&&(R=b)}return R}else{if(typeof x=="string")return C?x==="*"?5:x===A?10:0:0;if(x){const{language:R,pattern:N,scheme:b,hasAccessToAllModels:s}=x;if(!C&&!s)return 0;let p=0;if(b)if(b===y.scheme)p=10;else if(b==="*")p=5;else return 0;if(R)if(R===A)p=10;else if(R==="*")p=Math.max(p,5);else return 0;if(N){let n;if(typeof N=="string"?n=N:n={...N,base:(0,I.normalize)(N.base)},n===y.fsPath||(0,r.match)(n,y.fsPath))p=10;else return 0}return p}else return 0}}e.score=_}),define(ve[110],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class I{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let C=0,R=A.notIn.length;C<R;C++)switch(A.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,C){if(A.getTokenCount()===0)return!0;const R=A.findTokenIndexAtOffset(C-2),N=A.getStandardTokenType(R);return this.isOK(N)}_findNeutralCharacterInRange(A,C){for(let R=A;R<=C;R++){const N=String.fromCharCode(R);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=I;class _{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of A)x(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),x(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),x(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),x(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&x(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=_;function x(y,A,C){y.has(A)?y.get(A).push(C):y.set(A,[C])}}),define(ve[74],Ee([1,0,21,23]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(_||(_={}));function x(b){for(let s=0,p=b.length;s<p;s+=4){const n=b[s+0],i=b[s+1],d=b[s+2],S=b[s+3];b[s+0]=S,b[s+1]=d,b[s+2]=i,b[s+3]=n}}function y(b){const s=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return I.isLittleEndian()||x(s),r.VSBuffer.wrap(s)}function A(b){const s=b.buffer;if(I.isLittleEndian()||x(s),s.byteOffset%4==0)return new Uint32Array(s.buffer,s.byteOffset,s.length/4);{const p=new Uint8Array(s.byteLength);return p.set(s),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function C(b){const s=new Uint32Array(R(b));let p=0;if(s[p++]=b.id,b.type==="full")s[p++]=1,s[p++]=b.data.length,s.set(b.data,p),p+=b.data.length;else{s[p++]=2,s[p++]=b.deltas.length;for(const n of b.deltas)s[p++]=n.start,s[p++]=n.deleteCount,n.data?(s[p++]=n.data.length,s.set(n.data,p),p+=n.data.length):s[p++]=0}return y(s)}e.encodeSemanticTokensDto=C;function R(b){let s=0;if(s+=1+1,b.type==="full")s+=1+b.data.length;else{s+=1,s+=(1+1+1)*b.deltas.length;for(const p of b.deltas)p.data&&(s+=p.data.length)}return s}function N(b){const s=A(b);let p=0;const n=s[p++];if(s[p++]===1){const M=s[p++],u=s.subarray(p,p+M);return p+=M,{id:n,type:"full",data:u}}const d=s[p++],S=[];for(let M=0;M<d;M++){const u=s[p++],f=s[p++],w=s[p++];let a;w>0&&(a=s.subarray(p,p+w),p+=w),S[M]={start:u,deleteCount:f,data:a}}return{id:n,type:"delta",deltas:S}}e.decodeSemanticTokensDto=N}),define(ve[111],Ee([18,19]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ve[112],Ee([1,0,111]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,_=I*60,x=_*24,y=x*7,A=x*30,C=x*365;function R(b,s,p){typeof b!="number"&&(b=b.getTime());const n=Math.round((new Date().getTime()-b)/1e3);if(n<-30)return(0,r.localize)(0,null,R(new Date().getTime()+n*1e3,!1));if(n<30)return(0,r.localize)(1,null);let i;return n<I?(i=n,s?i===1?p?(0,r.localize)(2,null,i):(0,r.localize)(3,null,i):p?(0,r.localize)(4,null,i):(0,r.localize)(5,null,i):i===1?p?(0,r.localize)(6,null,i):(0,r.localize)(7,null,i):p?(0,r.localize)(8,null,i):(0,r.localize)(9,null,i)):n<_?(i=Math.floor(n/I),s?i===1?p?(0,r.localize)(10,null,i):(0,r.localize)(11,null,i):p?(0,r.localize)(12,null,i):(0,r.localize)(13,null,i):i===1?p?(0,r.localize)(14,null,i):(0,r.localize)(15,null,i):p?(0,r.localize)(16,null,i):(0,r.localize)(17,null,i)):n<x?(i=Math.floor(n/_),s?i===1?p?(0,r.localize)(18,null,i):(0,r.localize)(19,null,i):p?(0,r.localize)(20,null,i):(0,r.localize)(21,null,i):i===1?p?(0,r.localize)(22,null,i):(0,r.localize)(23,null,i):p?(0,r.localize)(24,null,i):(0,r.localize)(25,null,i)):n<y?(i=Math.floor(n/x),s?i===1?(0,r.localize)(26,null,i):(0,r.localize)(27,null,i):i===1?(0,r.localize)(28,null,i):(0,r.localize)(29,null,i)):n<A?(i=Math.floor(n/y),s?i===1?p?(0,r.localize)(30,null,i):(0,r.localize)(31,null,i):p?(0,r.localize)(32,null,i):(0,r.localize)(33,null,i):i===1?p?(0,r.localize)(34,null,i):(0,r.localize)(35,null,i):p?(0,r.localize)(36,null,i):(0,r.localize)(37,null,i)):n<C?(i=Math.floor(n/A),s?i===1?p?(0,r.localize)(38,null,i):(0,r.localize)(39,null,i):p?(0,r.localize)(40,null,i):(0,r.localize)(41,null,i):i===1?p?(0,r.localize)(42,null,i):(0,r.localize)(43,null,i):p?(0,r.localize)(44,null,i):(0,r.localize)(45,null,i)):(i=Math.floor(n/C),s?i===1?p?(0,r.localize)(46,null,i):(0,r.localize)(47,null,i):p?(0,r.localize)(48,null,i):(0,r.localize)(49,null,i):i===1?p?(0,r.localize)(50,null,i):(0,r.localize)(51,null,i):p?(0,r.localize)(52,null,i):(0,r.localize)(53,null,i))}e.fromNow=R;function N(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(ve[113],Ee([18,19]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ve[43],Ee([1,0,16,13,113]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function x(R,N){return N&&(R.stack||R.stacktrace)?_.localize(0,null,A(R),y(R.stack)||y(R.stacktrace)):A(R)}function y(R){return Array.isArray(R)?R.join(`
`):R}function A(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?_.localize(1,null,R.message):R.message||_.localize(2,null)}function C(R=null,N=!1){if(!R)return _.localize(3,null);if(Array.isArray(R)){const b=r.coalesce(R),s=C(b[0],N);return b.length>1?_.localize(4,null,s,b.length):s}if(I.isString(R))return R;if(R.detail){const b=R.detail;if(b.error)return x(b.error,N);if(b.exception)return x(b.exception,N)}return R.stack?x(R,N):R.message?R.message:_.localize(5,null)}e.toErrorMessage=C}),define(ve[114],Ee([18,19]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(ve[115],Ee([1,0,114,23,116,16,26,109]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=R;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class b{constructor(Q,ce,Re,$e){this.id=Q,this.name=ce,this.defaultValue=Re,this.schema=$e}applyUpdate(Q,ce){return p(Q,ce)}compute(Q,ce,Re){return Re}}class s{constructor(Q,ce){this.newValue=Q,this.didChange=ce}}e.ApplyUpdateResult=s;function p(G,Q){if(typeof G!="object"||typeof Q!="object"||!G||!Q)return new s(Q,G!==Q);if(Array.isArray(G)||Array.isArray(Q)){const Re=Array.isArray(G)&&Array.isArray(Q)&&x.equals(G,Q);return new s(Q,Re)}let ce=!1;for(const Re in Q)if(Q.hasOwnProperty(Re)){const $e=p(G[Re],Q[Re]);$e.didChange&&(G[Re]=$e.newValue,ce=!0)}return new s(G,ce)}class n{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ce){return p(Q,ce)}validate(Q){return this.defaultValue}}class i{constructor(Q,ce,Re,$e){this.id=Q,this.name=ce,this.defaultValue=Re,this.schema=$e}applyUpdate(Q,ce){return p(Q,ce)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,ce,Re){return Re}}function d(G,Q){return typeof G=="undefined"?Q:G==="false"?!1:Boolean(G)}e.boolean=d;class S extends i{constructor(Q,ce,Re,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=Re);super(Q,ce,Re,$e)}validate(Q){return d(Q,this.defaultValue)}}function M(G,Q,ce,Re){if(typeof G=="undefined")return Q;let $e=parseInt(G,10);return isNaN($e)?Q:($e=Math.max(ce,$e),$e=Math.min(Re,$e),$e|0)}e.clampedInt=M;class u extends i{constructor(Q,ce,Re,$e,Ke,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="integer",Qe.default=Re,Qe.minimum=$e,Qe.maximum=Ke);super(Q,ce,Re,Qe);this.minimum=$e,this.maximum=Ke}static clampedInt(Q,ce,Re,$e){return M(Q,ce,Re,$e)}validate(Q){return u.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class f extends i{constructor(Q,ce,Re,$e,Ke){typeof Ke!="undefined"&&(Ke.type="number",Ke.default=Re);super(Q,ce,Re,Ke);this.validationFn=$e}static clamp(Q,ce,Re){return Q<ce?ce:Q>Re?Re:Q}static float(Q,ce){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return ce;const Re=parseFloat(Q);return isNaN(Re)?ce:Re}validate(Q){return this.validationFn(f.float(Q,this.defaultValue))}}class w extends i{static string(Q,ce){return typeof Q!="string"?ce:Q}constructor(Q,ce,Re,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=Re);super(Q,ce,Re,$e)}validate(Q){return w.string(Q,this.defaultValue)}}function a(G,Q,ce){return typeof G!="string"||ce.indexOf(G)===-1?Q:G}e.stringSet=a;class P extends i{constructor(Q,ce,Re,$e,Ke=void 0){typeof Ke!="undefined"&&(Ke.type="string",Ke.enum=$e,Ke.default=Re);super(Q,ce,Re,Ke);this._allowedValues=$e}validate(Q){return a(Q,this.defaultValue,this._allowedValues)}}class c extends b{constructor(Q,ce,Re,$e,Ke,Qe,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=Ke,ht.default=$e);super(Q,ce,Re,ht);this._allowedValues=Ke,this._convert=Qe}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function t(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ce,Re){return Re===0?Q.accessibilitySupport:Re}}class o extends b{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{insertSpace:d(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function E(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function v(G){switch(G){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function k(G){switch(G){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class T extends n{constructor(){super(128)}compute(Q,ce,Re){const $e=["monaco-editor"];return ce.get(33)&&$e.push(ce.get(33)),Q.extraEditorClassName&&$e.push(Q.extraEditorClassName),ce.get(66)==="default"?$e.push("mouse-default"):ce.get(66)==="copy"&&$e.push("mouse-copy"),ce.get(100)&&$e.push("showUnused"),ce.get(126)&&$e.push("showDeprecated"),$e.join(" ")}}class $ extends S{constructor(){super(32,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,ce,Re){return Re&&Q.emptySelectionClipboard}}class g extends b{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{cursorMoveOnType:d(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":a(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":a(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ce.loop,this.defaultValue.loop)}}}class U extends b{constructor(){super(45,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?U.OFF:Q==="true"?U.ON:Q:Boolean(Q)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class z extends n{constructor(){super(44)}compute(Q,ce,Re){return Q.fontInfo}}class q extends i{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Q){const ce=f.float(Q,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(ce,6,100)}compute(Q,ce,Re){return Q.fontInfo.fontSize}}class j extends b{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(u.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}j.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],j.MINIMUM_VALUE=1,j.MAXIMUM_VALUE=1e3;class J extends b{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...ce},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...ce},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Re,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Re,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Re,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Re,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Re,description:r.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{multiple:a(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??a(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??a(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??a(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??a(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??a(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends b{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:d(ce.enabled,this.defaultValue.enabled),delay:u.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:d(ce.sticky,this.defaultValue.sticky),above:d(ce.above,this.defaultValue.above)}}}var ie;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class le extends n{constructor(){super(131)}compute(Q,ce,Re){return le.computeLayout(ce,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ce=Q.height/Q.lineHeight,Re=Q.scrollBeyondLastLine?ce-1:0,$e=(Q.viewLineCount+Re)/(Q.pixelRatio*Q.height),Ke=Math.floor(Q.viewLineCount/$e);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Re,desiredRatio:$e,minimapLineCount:Ke}}static _computeMinimapLayout(Q,ce){const Re=Q.outerWidth,$e=Q.outerHeight,Ke=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ke*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Qe=ce.stableMinimapLayoutInput,ht=Qe&&Q.outerHeight===Qe.outerHeight&&Q.lineHeight===Qe.lineHeight&&Q.typicalHalfwidthCharacterWidth===Qe.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Qe.pixelRatio&&Q.scrollBeyondLastLine===Qe.scrollBeyondLastLine&&Q.minimap.enabled===Qe.minimap.enabled&&Q.minimap.side===Qe.minimap.side&&Q.minimap.size===Qe.minimap.size&&Q.minimap.showSlider===Qe.minimap.showSlider&&Q.minimap.renderCharacters===Qe.minimap.renderCharacters&&Q.minimap.maxColumn===Qe.minimap.maxColumn&&Q.minimap.scale===Qe.minimap.scale&&Q.verticalScrollbarWidth===Qe.verticalScrollbarWidth&&Q.isViewportWrapping===Qe.isViewportWrapping,_t=Q.lineHeight,yt=Q.typicalHalfwidthCharacterWidth,Tt=Q.scrollBeyondLastLine,Ve=Q.minimap.renderCharacters;let pt=Ke>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Nt=Q.minimap.maxColumn,nt=Q.minimap.size,ot=Q.minimap.side,At=Q.verticalScrollbarWidth,Dt=Q.viewLineCount,Ct=Q.remainingWidth,lt=Q.isViewportWrapping,Ot=Ve?2:3;let Lt=Math.floor(Ke*$e);const Ft=Lt/Ke;let se=!1,_e=!1,ae=Ot*pt,K=pt/Ke,be=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:it,desiredRatio:at,minimapLineCount:mt}=le.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Tt,height:$e,lineHeight:_t,pixelRatio:Ke});if(Dt/mt>1)se=!0,_e=!0,pt=1,ae=1,K=pt/Ke;else{let ct=!1,It=pt+1;if(nt==="fit"){const Ut=Math.ceil((Dt+it)*ae);lt&&ht&&Ct<=ce.stableFitRemainingWidth?(ct=!0,It=ce.stableFitMaxMinimapScale):ct=Ut>Lt}if(nt==="fill"||ct){se=!0;const Ut=pt;ae=Math.min(_t*Ke,Math.max(1,Math.floor(1/at))),lt&&ht&&Ct<=ce.stableFitRemainingWidth&&(It=ce.stableFitMaxMinimapScale),pt=Math.min(It,Math.max(1,Math.floor(ae/Ot))),pt>Ut&&(be=Math.min(2,pt/Ut)),K=pt/Ke/be,Lt=Math.ceil(Math.max(vt,Dt+it)*ae),lt?(ce.stableMinimapLayoutInput=Q,ce.stableFitRemainingWidth=Ct,ce.stableFitMaxMinimapScale=pt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const Te=Math.floor(Nt*K),Be=Math.min(Te,Math.max(0,Math.floor((Ct-At-2)*K/(yt+K)))+e.MINIMAP_GUTTER_WIDTH);let We=Math.floor(Ke*Be);const st=We/Ke;We=Math.floor(We*be);const ft=Ve?1:2,Et=ot==="left"?0:Re-Be-At;return{renderMinimap:ft,minimapLeft:Et,minimapWidth:Be,minimapHeightIsEditorHeight:se,minimapIsSampling:_e,minimapScale:pt,minimapLineHeight:ae,minimapCanvasInnerWidth:We,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:st,minimapCanvasOuterHeight:Ft}}static computeLayout(Q,ce){const Re=ce.outerWidth|0,$e=ce.outerHeight|0,Ke=ce.lineHeight|0,Qe=ce.lineNumbersDigitCount|0,ht=ce.typicalHalfwidthCharacterWidth,_t=ce.maxDigitWidth,yt=ce.pixelRatio,Tt=ce.viewLineCount,Ve=Q.get(123),pt=Ve==="inherit"?Q.get(122):Ve,Nt=pt==="inherit"?Q.get(118):pt,nt=Q.get(121),ot=Q.get(2),At=ce.isDominatedByLongLines,Dt=Q.get(50),Ct=Q.get(60).renderType!==0,lt=Q.get(61),Ot=Q.get(94),Lt=Q.get(65),Ft=Q.get(92),se=Ft.verticalScrollbarSize,_e=Ft.verticalHasArrows,ae=Ft.arrowSize,K=Ft.horizontalScrollbarSize,be=Q.get(58),Te=Q.get(37);let Be;if(typeof be=="string"&&/^\d+(\.\d+)?ch$/.test(be)){const Wt=parseFloat(be.substr(0,be.length-2));Be=u.clampedInt(Wt*ht,0,0,1e3)}else Be=u.clampedInt(be,0,0,1e3);Te&&(Be+=16);let We=0;if(Ct){const Wt=Math.max(Qe,lt);We=Math.round(Wt*_t)}let st=0;Dt&&(st=Ke);let ft=0,Et=ft+st,vt=Et+We,it=vt+Be;const at=Re-st-We-Be;let mt=!1,Mt=!1,ct=-1;ot!==2&&(pt==="inherit"&&At?(mt=!0,Mt=!0):Nt==="on"||Nt==="bounded"?Mt=!0:Nt==="wordWrapColumn"&&(ct=nt));const It=le._computeMinimapLayout({outerWidth:Re,outerHeight:$e,lineHeight:Ke,typicalHalfwidthCharacterWidth:ht,pixelRatio:yt,scrollBeyondLastLine:Ot,minimap:Lt,verticalScrollbarWidth:se,viewLineCount:Tt,remainingWidth:at,isViewportWrapping:Mt},ce.memory||new N);It.renderMinimap!==0&&It.minimapLeft===0&&(ft+=It.minimapWidth,Et+=It.minimapWidth,vt+=It.minimapWidth,it+=It.minimapWidth);const Ut=at-It.minimapWidth,bt=Math.max(1,Math.floor((Ut-se-2)/ht)),Bt=_e?ae:0;return Mt&&(ct=Math.max(1,bt),Nt==="bounded"&&(ct=Math.min(ct,nt))),{width:Re,height:$e,glyphMarginLeft:ft,glyphMarginWidth:st,lineNumbersLeft:Et,lineNumbersWidth:We,decorationsLeft:vt,decorationsWidth:Be,contentLeft:it,contentWidth:Ut,minimap:It,viewportColumn:bt,isWordWrapMinified:mt,isViewportWrapping:Mt,wrappingColumn:ct,verticalScrollbarWidth:se,horizontalScrollbarHeight:K,overviewRuler:{top:Bt,width:se,height:$e-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=le;class te extends b{constructor(){const Q={enabled:!0};super(57,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}class ue extends b{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:d(ce.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class he extends f{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>f.clamp(Q,0,150),{markdownDescription:r.localize(47,null)})}compute(Q,ce,Re){return Q.fontInfo.lineHeight}}class De extends b{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(49,null),r.localize(50,null),r.localize(51,null)],default:Q.size,description:r.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:d(ce.enabled,this.defaultValue.enabled),size:a(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(ce.side,this.defaultValue.side,["right","left"]),showSlider:a(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ce.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(ce.scale,1,1,3),maxColumn:u.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(G){return G==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ne extends b{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{top:u.clampedInt(ce.top,0,0,1e3),bottom:u.clampedInt(ce.bottom,0,0,1e3)}}}class me extends b{constructor(){const Q={enabled:!0,cycle:!1};super(76,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:d(ce.enabled,this.defaultValue.enabled),cycle:d(ce.cycle,this.defaultValue.cycle)}}}class Ie extends n{constructor(){super(129)}compute(Q,ce,Re){return Q.pixelRatio}}class Ae extends b{constructor(){const Q={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:r.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:r.localize(63,null)},other:{type:"boolean",default:Q.other,description:r.localize(64,null)}}}],default:Q,description:r.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const ce=Q,Re={other:d(ce.other,this.defaultValue.other),comments:d(ce.comments,this.defaultValue.comments),strings:d(ce.strings,this.defaultValue.strings)};return Re.other&&Re.comments&&Re.strings?!0:!Re.other&&!Re.comments&&!Re.strings?!1:Re}return this.defaultValue}}var Ue;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ge extends b{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(66,null),r.localize(67,null),r.localize(68,null),r.localize(69,null)],default:"on",description:r.localize(70,null)})}validate(Q){let ce=this.defaultValue.renderType,Re=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(ce=4,Re=Q):Q==="interval"?ce=3:Q==="relative"?ce=2:Q==="on"?ce=1:ce=0),{renderType:ce,renderFn:Re}}}function ge(G){const Q=G.get(87);return Q==="editable"?G.get(81):Q!=="on"}e.filterValidationDecorations=ge;class de extends b{constructor(){const Q=[],ce={type:"number",description:r.localize(71,null)};super(91,"rulers",Q,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:r.localize(72,null),format:"color-hex"}}}]},default:Q,description:r.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const ce=[];for(let Re of Q)if(typeof Re=="number")ce.push({column:u.clampedInt(Re,0,0,1e4),color:null});else if(Re&&typeof Re=="object"){const $e=Re;ce.push({column:u.clampedInt($e.column,0,0,1e4),color:$e.color})}return ce.sort((Re,$e)=>Re.column-$e.column),ce}return this.defaultValue}}function L(G,Q){if(typeof G!="string")return Q;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends b{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(74,null),r.localize(75,null),r.localize(76,null)],default:"auto",description:r.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"auto",description:r.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q,Re=u.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=u.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:L(ce.vertical,this.defaultValue.vertical),horizontal:L(ce.horizontal,this.defaultValue.horizontal),useShadows:d(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Re,horizontalSliderSize:u.clampedInt(ce.horizontalSliderSize,Re,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:u.clampedInt(ce.verticalSliderSize,$e,0,1e3),scrollByPage:d(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class D extends b{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(91,null)}})}applyUpdate(Q,ce){let Re=!1;ce.allowedCharacters&&(y.equals(Q.allowedCharacters,ce.allowedCharacters)||(Q={...Q,allowedCharacters:ce.allowedCharacters},Re=!0)),ce.allowedLocales&&(y.equals(Q.allowedLocales,ce.allowedLocales)||(Q={...Q,allowedLocales:ce.allowedLocales},Re=!0));const $e=super.applyUpdate(Q,ce);return Re?new s($e.newValue,!0):$e}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{nonBasicASCII:re(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:re(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:re(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,ce){if(typeof Q!="object"||!Q)return ce;const Re={};for(const[$e,Ke]of Object.entries(Q))Ke===!0&&(Re[$e]=!0);return Re}}class O extends b{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:d(ce.enabled,this.defaultValue.enabled),mode:a(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class H extends b{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:r.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}class X extends b{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(94,null),r.localize(95,null),r.localize(96,null)],default:Q.bracketPairs,description:r.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(98,null),r.localize(99,null),r.localize(100,null)],default:Q.bracketPairsHorizontal,description:r.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:r.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{bracketPairs:re(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:re(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:d(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function re(G,Q,ce){const Re=ce.indexOf(G);return Re===-1?Q:ce[Re]}class pe extends b{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(105,null),r.localize(106,null)],default:Q.insertMode,description:r.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{insertMode:a(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ce.showIcons,this.defaultValue.showIcons),showStatusBar:d(ce.showStatusBar,this.defaultValue.showStatusBar),preview:d(ce.preview,this.defaultValue.preview),previewMode:a(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ce.showMethods,this.defaultValue.showMethods),showFunctions:d(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ce.showDeprecated,this.defaultValue.showDeprecated),showFields:d(ce.showFields,this.defaultValue.showFields),showVariables:d(ce.showVariables,this.defaultValue.showVariables),showClasses:d(ce.showClasses,this.defaultValue.showClasses),showStructs:d(ce.showStructs,this.defaultValue.showStructs),showInterfaces:d(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ce.showModules,this.defaultValue.showModules),showProperties:d(ce.showProperties,this.defaultValue.showProperties),showEvents:d(ce.showEvents,this.defaultValue.showEvents),showOperators:d(ce.showOperators,this.defaultValue.showOperators),showUnits:d(ce.showUnits,this.defaultValue.showUnits),showValues:d(ce.showValues,this.defaultValue.showValues),showConstants:d(ce.showConstants,this.defaultValue.showConstants),showEnums:d(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ce.showKeywords,this.defaultValue.showKeywords),showWords:d(ce.showWords,this.defaultValue.showWords),showColors:d(ce.showColors,this.defaultValue.showColors),showFiles:d(ce.showFiles,this.defaultValue.showFiles),showReferences:d(ce.showReferences,this.defaultValue.showReferences),showFolders:d(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ce.showSnippets,this.defaultValue.showSnippets),showUsers:d(ce.showUsers,this.defaultValue.showUsers),showIssues:d(ce.showIssues,this.defaultValue.showIssues)}}}class Ce extends b{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Me extends n{constructor(){super(130)}compute(Q,ce,Re){return ce.get(81)?!0:Q.tabFocusMode}}var Le;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Le=e.WrappingIndent||(e.WrappingIndent={}));function ze(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class xe extends n{constructor(){super(132)}compute(Q,ce,Re){const $e=ce.get(131);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const Oe="Consolas, 'Courier New', monospace",Xe="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Xe:I.isLinux?et:Oe,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(G){return e.editorOptionsRegistry[G.id]=G,G}var tt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.foldingMaximumRegions=41]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=43]="fontFamily",G[G.fontInfo=44]="fontInfo",G[G.fontLigatures=45]="fontLigatures",G[G.fontSize=46]="fontSize",G[G.fontWeight=47]="fontWeight",G[G.formatOnPaste=48]="formatOnPaste",G[G.formatOnType=49]="formatOnType",G[G.glyphMargin=50]="glyphMargin",G[G.gotoLocation=51]="gotoLocation",G[G.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",G[G.hover=53]="hover",G[G.inDiffEditor=54]="inDiffEditor",G[G.inlineSuggest=55]="inlineSuggest",G[G.letterSpacing=56]="letterSpacing",G[G.lightbulb=57]="lightbulb",G[G.lineDecorationsWidth=58]="lineDecorationsWidth",G[G.lineHeight=59]="lineHeight",G[G.lineNumbers=60]="lineNumbers",G[G.lineNumbersMinChars=61]="lineNumbersMinChars",G[G.linkedEditing=62]="linkedEditing",G[G.links=63]="links",G[G.matchBrackets=64]="matchBrackets",G[G.minimap=65]="minimap",G[G.mouseStyle=66]="mouseStyle",G[G.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=68]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",G[G.multiCursorModifier=70]="multiCursorModifier",G[G.multiCursorPaste=71]="multiCursorPaste",G[G.occurrencesHighlight=72]="occurrencesHighlight",G[G.overviewRulerBorder=73]="overviewRulerBorder",G[G.overviewRulerLanes=74]="overviewRulerLanes",G[G.padding=75]="padding",G[G.parameterHints=76]="parameterHints",G[G.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",G[G.quickSuggestions=79]="quickSuggestions",G[G.quickSuggestionsDelay=80]="quickSuggestionsDelay",G[G.readOnly=81]="readOnly",G[G.renameOnType=82]="renameOnType",G[G.renderControlCharacters=83]="renderControlCharacters",G[G.renderFinalNewline=84]="renderFinalNewline",G[G.renderLineHighlight=85]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=87]="renderValidationDecorations",G[G.renderWhitespace=88]="renderWhitespace",G[G.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",G[G.roundedSelection=90]="roundedSelection",G[G.rulers=91]="rulers",G[G.scrollbar=92]="scrollbar",G[G.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=94]="scrollBeyondLastLine",G[G.scrollPredominantAxis=95]="scrollPredominantAxis",G[G.selectionClipboard=96]="selectionClipboard",G[G.selectionHighlight=97]="selectionHighlight",G[G.selectOnLineNumbers=98]="selectOnLineNumbers",G[G.showFoldingControls=99]="showFoldingControls",G[G.showUnused=100]="showUnused",G[G.snippetSuggestions=101]="snippetSuggestions",G[G.smartSelect=102]="smartSelect",G[G.smoothScrolling=103]="smoothScrolling",G[G.stickyTabStops=104]="stickyTabStops",G[G.stopRenderingLineAfter=105]="stopRenderingLineAfter",G[G.suggest=106]="suggest",G[G.suggestFontSize=107]="suggestFontSize",G[G.suggestLineHeight=108]="suggestLineHeight",G[G.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",G[G.suggestSelection=110]="suggestSelection",G[G.tabCompletion=111]="tabCompletion",G[G.tabIndex=112]="tabIndex",G[G.unicodeHighlighting=113]="unicodeHighlighting",G[G.unusualLineTerminators=114]="unusualLineTerminators",G[G.useShadowDOM=115]="useShadowDOM",G[G.useTabStops=116]="useTabStops",G[G.wordSeparators=117]="wordSeparators",G[G.wordWrap=118]="wordWrap",G[G.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=121]="wordWrapColumn",G[G.wordWrapOverride1=122]="wordWrapOverride1",G[G.wordWrapOverride2=123]="wordWrapOverride2",G[G.wrappingIndent=124]="wrappingIndent",G[G.wrappingStrategy=125]="wrappingStrategy",G[G.showDeprecated=126]="showDeprecated",G[G.inlayHints=127]="inlayHints",G[G.editorClassName=128]="editorClassName",G[G.pixelRatio=129]="pixelRatio",G[G.tabFocusMode=130]="tabFocusMode",G[G.layoutInfo=131]="layoutInfo",G[G.wrappingInfo=132]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new S(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(148,null)})),acceptSuggestionOnEnter:ke(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(149,null),""],markdownDescription:r.localize(150,null)})),accessibilitySupport:ke(new h),accessibilityPageSize:ke(new u(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(151,null)})),ariaLabel:ke(new w(4,"ariaLabel",r.localize(152,null))),autoClosingBrackets:ke(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(153,null),r.localize(154,null),""],description:r.localize(155,null)})),autoClosingDelete:ke(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(156,null),""],description:r.localize(157,null)})),autoClosingOvertype:ke(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(158,null),""],description:r.localize(159,null)})),autoClosingQuotes:ke(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(160,null),r.localize(161,null),""],description:r.localize(162,null)})),autoIndent:ke(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[r.localize(163,null),r.localize(164,null),r.localize(165,null),r.localize(166,null),r.localize(167,null)],description:r.localize(168,null)})),automaticLayout:ke(new S(10,"automaticLayout",!1)),autoSurround:ke(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(169,null),r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),bracketPairColorization:ke(new H),bracketPairGuides:ke(new X),stickyTabStops:ke(new S(104,"stickyTabStops",!1,{description:r.localize(173,null)})),codeLens:ke(new S(14,"codeLens",!0,{description:r.localize(174,null)})),codeLensFontFamily:ke(new w(15,"codeLensFontFamily","",{description:r.localize(175,null)})),codeLensFontSize:ke(new u(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(176,null)})),colorDecorators:ke(new S(17,"colorDecorators",!0,{description:r.localize(177,null)})),columnSelection:ke(new S(18,"columnSelection",!1,{description:r.localize(178,null)})),comments:ke(new o),contextmenu:ke(new S(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new S(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(179,null)})),cursorBlinking:ke(new c(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],E,{description:r.localize(180,null)})),cursorSmoothCaretAnimation:ke(new S(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(181,null)})),cursorStyle:ke(new c(24,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],k,{description:r.localize(182,null)})),cursorSurroundingLines:ke(new u(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(183,null)})),cursorSurroundingLinesStyle:ke(new P(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(184,null),r.localize(185,null)],description:r.localize(186,null)})),cursorWidth:ke(new u(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(187,null)})),disableLayerHinting:ke(new S(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new S(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new S(30,"domReadOnly",!1)),dragAndDrop:ke(new S(31,"dragAndDrop",!0,{description:r.localize(188,null)})),emptySelectionClipboard:ke(new $),extraEditorClassName:ke(new w(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new f(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:r.localize(189,null)})),find:ke(new g),fixedOverflowWidgets:ke(new S(36,"fixedOverflowWidgets",!1)),folding:ke(new S(37,"folding",!0,{description:r.localize(190,null)})),foldingStrategy:ke(new P(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(191,null),r.localize(192,null)],description:r.localize(193,null)})),foldingHighlight:ke(new S(39,"foldingHighlight",!0,{description:r.localize(194,null)})),foldingImportsByDefault:ke(new S(40,"foldingImportsByDefault",!1,{description:r.localize(195,null)})),foldingMaximumRegions:ke(new u(41,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(196,null)})),unfoldOnClickAfterEndOfLine:ke(new S(42,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(197,null)})),fontFamily:ke(new w(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(198,null)})),fontInfo:ke(new z),fontLigatures2:ke(new U),fontSize:ke(new q),fontWeight:ke(new j),formatOnPaste:ke(new S(48,"formatOnPaste",!1,{description:r.localize(199,null)})),formatOnType:ke(new S(49,"formatOnType",!1,{description:r.localize(200,null)})),glyphMargin:ke(new S(50,"glyphMargin",!0,{description:r.localize(201,null)})),gotoLocation:ke(new J),hideCursorInOverviewRuler:ke(new S(52,"hideCursorInOverviewRuler",!1,{description:r.localize(202,null)})),hover:ke(new W),inDiffEditor:ke(new S(54,"inDiffEditor",!1)),letterSpacing:ke(new f(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>f.clamp(G,-5,20),{description:r.localize(203,null)})),lightbulb:ke(new te),lineDecorationsWidth:ke(new i(58,"lineDecorationsWidth",10)),lineHeight:ke(new he),lineNumbers:ke(new Ge),lineNumbersMinChars:ke(new u(61,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new S(62,"linkedEditing",!1,{description:r.localize(204,null)})),links:ke(new S(63,"links",!0,{description:r.localize(205,null)})),matchBrackets:ke(new P(64,"matchBrackets","always",["always","near","never"],{description:r.localize(206,null)})),minimap:ke(new De),mouseStyle:ke(new P(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new f(67,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:r.localize(207,null)})),mouseWheelZoom:ke(new S(68,"mouseWheelZoom",!1,{markdownDescription:r.localize(208,null)})),multiCursorMergeOverlapping:ke(new S(69,"multiCursorMergeOverlapping",!0,{description:r.localize(209,null)})),multiCursorModifier:ke(new c(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[r.localize(210,null),r.localize(211,null)],markdownDescription:r.localize(212,null)})),multiCursorPaste:ke(new P(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(213,null),r.localize(214,null)],markdownDescription:r.localize(215,null)})),occurrencesHighlight:ke(new S(72,"occurrencesHighlight",!0,{description:r.localize(216,null)})),overviewRulerBorder:ke(new S(73,"overviewRulerBorder",!0,{description:r.localize(217,null)})),overviewRulerLanes:ke(new u(74,"overviewRulerLanes",3,0,3)),padding:ke(new ne),parameterHints:ke(new me),peekWidgetDefaultFocus:ke(new P(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(218,null),r.localize(219,null)],description:r.localize(220,null)})),definitionLinkOpensInPeek:ke(new S(78,"definitionLinkOpensInPeek",!1,{description:r.localize(221,null)})),quickSuggestions:ke(new Ae),quickSuggestionsDelay:ke(new u(80,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(222,null)})),readOnly:ke(new S(81,"readOnly",!1)),renameOnType:ke(new S(82,"renameOnType",!1,{description:r.localize(223,null),markdownDeprecationMessage:r.localize(224,null)})),renderControlCharacters:ke(new S(83,"renderControlCharacters",!0,{description:r.localize(225,null),restricted:!0})),renderFinalNewline:ke(new S(84,"renderFinalNewline",!0,{description:r.localize(226,null)})),renderLineHighlight:ke(new P(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(227,null)],description:r.localize(228,null)})),renderLineHighlightOnlyWhenFocus:ke(new S(86,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(229,null)})),renderValidationDecorations:ke(new P(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new P(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(230,null),r.localize(231,null),r.localize(232,null),""],description:r.localize(233,null)})),revealHorizontalRightPadding:ke(new u(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new S(90,"roundedSelection",!0,{description:r.localize(234,null)})),rulers:ke(new de),scrollbar:ke(new F),scrollBeyondLastColumn:ke(new u(93,"scrollBeyondLastColumn",5,0,1073741824,{description:r.localize(235,null)})),scrollBeyondLastLine:ke(new S(94,"scrollBeyondLastLine",!0,{description:r.localize(236,null)})),scrollPredominantAxis:ke(new S(95,"scrollPredominantAxis",!0,{description:r.localize(237,null)})),selectionClipboard:ke(new S(96,"selectionClipboard",!0,{description:r.localize(238,null),included:I.isLinux})),selectionHighlight:ke(new S(97,"selectionHighlight",!0,{description:r.localize(239,null)})),selectOnLineNumbers:ke(new S(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new P(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[r.localize(240,null),r.localize(241,null)],description:r.localize(242,null)})),showUnused:ke(new S(100,"showUnused",!0,{description:r.localize(243,null)})),showDeprecated:ke(new S(126,"showDeprecated",!0,{description:r.localize(244,null)})),inlayHints:ke(new ue),snippetSuggestions:ke(new P(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(245,null),r.localize(246,null),r.localize(247,null),r.localize(248,null)],description:r.localize(249,null)})),smartSelect:ke(new Ce),smoothScrolling:ke(new S(103,"smoothScrolling",!1,{description:r.localize(250,null)})),stopRenderingLineAfter:ke(new u(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new pe),inlineSuggest:ke(new O),suggestFontSize:ke(new u(107,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(251,null)})),suggestLineHeight:ke(new u(108,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(252,null)})),suggestOnTriggerCharacters:ke(new S(109,"suggestOnTriggerCharacters",!0,{description:r.localize(253,null)})),suggestSelection:ke(new P(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(254,null),r.localize(255,null),r.localize(256,null)],description:r.localize(257,null)})),tabCompletion:ke(new P(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(258,null),r.localize(259,null),r.localize(260,null)],description:r.localize(261,null)})),tabIndex:ke(new u(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new D),unusualLineTerminators:ke(new P(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(262,null),r.localize(263,null),r.localize(264,null)],description:r.localize(265,null)})),useShadowDOM:ke(new S(115,"useShadowDOM",!0)),useTabStops:ke(new S(116,"useTabStops",!0,{description:r.localize(266,null)})),wordSeparators:ke(new w(117,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:r.localize(267,null)})),wordWrap:ke(new P(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(268,null),r.localize(269,null),r.localize(270,null),r.localize(271,null)],description:r.localize(272,null)})),wordWrapBreakAfterCharacters:ke(new w(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new w(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new u(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(273,null)})),wordWrapOverride1:ke(new P(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new P(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new c(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ze,{enumDescriptions:[r.localize(274,null),r.localize(275,null),r.localize(276,null),r.localize(277,null)],description:r.localize(278,null)})),wrappingStrategy:ke(new P(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(279,null),r.localize(280,null)],description:r.localize(281,null)})),editorClassName:ke(new T),pixelRatio:ke(new Ie),tabFocusMode:ke(new Me),layoutInfo:ke(new le),wrappingInfo:ke(new xe)}}),define(ve[117],Ee([18,19]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[118],Ee([18,19]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[119],Ee([18,19]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ve[120],Ee([18,19]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(ve[121],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[122],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[123],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[124],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[125],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[126],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[127],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[128],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(ve[129],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[130],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/debug",e)}),define(ve[131],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[132],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[133],Ee([18,19]),function(Y,e){return Y.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ve[134],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var r;(function(y){y[y.ACTIVATE=1]="ACTIVATE",y[y.RESTORE=2]="RESTORE",y[y.PRESERVE=3]="PRESERVE"})(r=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=0]="PICK",y[y.DISABLED=1]="DISABLED",y[y.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(I=e.EditorResolution||(e.EditorResolution={}));var _;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var x;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(x=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[135],Ee([1,0,118]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function x(s){return s=s.trim(),s==="*"||I.test(s)}e.isValidVersionStr=x;function y(s){if(!x(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=s.match(I);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=y;function A(s){if(!s)return null;let p=s.majorBase,n=s.majorMustEqual,i=s.minorBase,d=s.minorMustEqual,S=s.patchBase,M=s.patchMustEqual;s.hasCaret&&(p===0||(d=!1),M=!1);let u=0;if(s.preRelease){const f=_.exec(s.preRelease);if(f){const[,w,a,P]=f;u=Date.UTC(Number(w),Number(a)-1,Number(P))}}return{majorBase:p,majorMustEqual:n,minorBase:i,minorMustEqual:d,patchBase:S,patchMustEqual:M,isMinimum:s.hasGreaterEquals,notBefore:u}}e.normalizeVersion=A;function C(s,p,n){let i;typeof s=="string"?i=A(y(s)):i=s;let d;p instanceof Date?d=p.getTime():typeof p=="string"&&(d=new Date(p).getTime());let S;if(typeof n=="string"?S=A(y(n)):S=n,!i||!S)return!1;let M=i.majorBase,u=i.minorBase,f=i.patchBase,w=S.majorBase,a=S.minorBase,P=S.patchBase,c=S.notBefore,t=S.majorMustEqual,h=S.minorMustEqual,o=S.patchMustEqual;return S.isMinimum?M>w?!0:M<w?!1:u>a?!0:u<a||d&&d<c?!1:f>=P:(M===1&&w===0&&(!t||!h||!o)&&(w=1,a=0,P=0,t=!0,h=!1,o=!1),M<w?!1:M>w?!t:u<a?!1:u>a?!h:f<P?!1:f>P?!o:!(d&&d<c))}e.isValidVersion=C;function R(s,p,n,i){return n.isBuiltin||typeof n.main=="undefined"?!0:b(s,p,n.engines.vscode,i)}e.isValidExtensionVersion=R;function N(s,p,n){return s==="*"||b(p,n,s)}e.isEngineValid=N;function b(s,p,n,i=[]){let d=A(y(n));if(!d)return i.push(r.localize(0,null,n)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return i.push(r.localize(1,null,n)),!1}else if(!d.majorMustEqual)return i.push(r.localize(2,null,n)),!1;return C(s,p,d)?!0:(i.push(r.localize(3,null,s,n)),!1)}}),define(ve[75],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(_,x=[],y=!1){this.ctor=_,this.staticArguments=x,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=r}),define(ve[44],Ee([1,0,75]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function _(y,A,C){A instanceof r.SyncDescriptor||(A=new r.SyncDescriptor(A,[],C)),I.push([y,A])}e.registerSingleton=_;function x(){return I}e.getSingletonServiceDescriptors=x}),define(ve[136],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(x){this.incoming=new Map,this.outgoing=new Map,this.data=x}}e.Node=r;class I{constructor(x){this._hashFn=x,this._nodes=new Map}roots(){const x=[];for(let y of this._nodes.values())y.outgoing.size===0&&x.push(y);return x}insertEdge(x,y){const A=this.lookupOrInsertNode(x),C=this.lookupOrInsertNode(y);A.outgoing.set(this._hashFn(y),C),C.incoming.set(this._hashFn(x),A)}removeNode(x){const y=this._hashFn(x);this._nodes.delete(y);for(let A of this._nodes.values())A.outgoing.delete(y),A.incoming.delete(y)}lookupOrInsertNode(x){const y=this._hashFn(x);let A=this._nodes.get(y);return A||(A=new r(x),this._nodes.set(y,A)),A}lookup(x){return this._nodes.get(this._hashFn(x))}isEmpty(){return this._nodes.size===0}toString(){let x=[];for(let[y,A]of this._nodes)x.push(`${y}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return x.join(`
`)}findCycleSlow(){for(let[x,y]of this._nodes){const A=new Set([x]),C=this._findCycle(y,A);if(C)return C}}_findCycle(x,y){for(let[A,C]of x.outgoing){if(y.has(A))return[...y,A].join(" -> ");y.add(A);const R=this._findCycle(C,y);if(R)return R;y.delete(A)}}}e.Graph=I}),define(ve[3],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function A(C){return C[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=A})(r=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function I(y,A,C,R){A[r.DI_TARGET]===A?A[r.DI_DEPENDENCIES].push({id:y,index:C,optional:R}):(A[r.DI_DEPENDENCIES]=[{id:y,index:C,optional:R}],A[r.DI_TARGET]=A)}function _(y){if(r.serviceIds.has(y))return r.serviceIds.get(y);const A=function(C,R,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(A,C,N,!1)};return A.toString=()=>y,r.serviceIds.set(y,A),A}e.createDecorator=_;function x(y){return y}e.refineServiceDecorator=x}),define(ve[76],Ee([1,0,13,2,3]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function x(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof I.URI)}e.isConfigurationOverrides=x;function y(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||r.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof I.URI)}e.isConfigurationUpdateOverrides=y;var A;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function R(d,S){const M=Object.create(null);for(let u in d)N(M,u,d[u],S);return M}e.toValuesTree=R;function N(d,S,M,u){const f=S.split("."),w=f.pop();let a=d;for(let P=0;P<f.length;P++){let c=f[P],t=a[c];switch(typeof t){case"undefined":t=a[c]=Object.create(null);break;case"object":break;default:u(`Ignoring ${S} as ${f.slice(0,P+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[w]=M}catch{u(`Ignoring ${S} as ${f.join(".")} is ${JSON.stringify(a)}`)}else u(`Ignoring ${S} as ${f.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=N;function b(d,S){const M=S.split(".");s(d,M)}e.removeFromValueTree=b;function s(d,S){const M=S.shift();if(S.length===0){delete d[M];return}if(Object.keys(d).indexOf(M)!==-1){const u=d[M];typeof u=="object"&&!Array.isArray(u)&&(s(u,S),Object.keys(u).length===0&&delete d[M])}}function p(d,S,M){function u(a,P){let c=a;for(const t of P){if(typeof c!="object"||c===null)return;c=c[t]}return c}const f=S.split("."),w=u(d,f);return typeof w=="undefined"?M:w}e.getConfigurationValue=p;function n(d,S,M){Object.keys(S).forEach(u=>{u!=="__proto__"&&(u in d?r.isObject(d[u])&&r.isObject(S[u])?n(d[u],S[u],M):M&&(d[u]=S[u]):d[u]=S[u])})}e.merge=n;function i(d,S,M){const u=d.inspect(S),f=d.inspect(M);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:u.defaultValue}e.getMigratedSettingValue=i}),define(ve[45],Ee([1,0,23,10,3]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const x=new Map;x.set("false",!1),x.set("true",!0),x.set("isMac",r.isMacintosh),x.set("isLinux",r.isLinux),x.set("isWindows",r.isWindows),x.set("isWeb",r.isWeb),x.set("isMacNative",r.isMacintosh&&!r.isWeb),x.set("isEdge",r.isEdge),x.set("isFirefox",r.isFirefox),x.set("isChrome",r.isChrome),x.set("isSafari",r.isSafari);const y=Object.prototype.hasOwnProperty;var A;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return b.INSTANCE}static true(){return s.INSTANCE}static has(g){return p.create(g)}static equals(g,U){return n.create(g,U)}static notEquals(g,U){return S.create(g,U)}static regex(g,U){return c.create(g,U)}static in(g,U){return i.create(g,U)}static not(g){return M.create(g)}static and(...g){return o.create(g,null)}static or(...g){return l.create(g,null,!0)}static greater(g,U){return f.create(g,U)}static greaterEquals(g,U){return w.create(g,U)}static smaller(g,U){return a.create(g,U)}static smallerEquals(g,U){return P.create(g,U)}static deserialize(g,U=!1){if(!!g)return this._deserializeOrExpression(g,U)}static _deserializeOrExpression(g,U){let z=g.split("||");return l.create(z.map(q=>this._deserializeAndExpression(q,U)),null,!0)}static _deserializeAndExpression(g,U){let z=g.split("&&");return o.create(z.map(q=>this._deserializeOne(q,U)),null)}static _deserializeOne(g,U){if(g=g.trim(),g.indexOf("!=")>=0){let z=g.split("!=");return S.create(z[0].trim(),this._deserializeValue(z[1],U))}if(g.indexOf("==")>=0){let z=g.split("==");return n.create(z[0].trim(),this._deserializeValue(z[1],U))}if(g.indexOf("=~")>=0){let z=g.split("=~");return c.create(z[0].trim(),this._deserializeRegexValue(z[1],U))}if(g.indexOf(" in ")>=0){let z=g.split(" in ");return i.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const z=g.split(">=");return w.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const z=g.split(">");return f.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const z=g.split("<=");return P.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const z=g.split("<");return a.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(g)?M.create(g.substr(1).trim()):p.create(g)}static _deserializeValue(g,U){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let z=/^'([^']*)'$/.exec(g);return z?z[1].trim():g}static _deserializeRegexValue(g,U){if((0,I.isFalsyOrWhitespace)(g)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=g.indexOf("/"),q=g.lastIndexOf("/");if(z===q||z<0){if(U)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let j=g.slice(z+1,q),J=g[q+1]==="i"?"i":"";try{return new RegExp(j,J)}catch(W){if(U)throw new Error(`bad regexp-value '${g}', parse error: ${W}`);return console.warn(`bad regexp-value '${g}', parse error: ${W}`),null}}}e.ContextKeyExpr=C;function R($,g){const U=$?$.substituteConstants():void 0,z=g?g.substituteConstants():void 0;return!U&&!z?!0:!U||!z?!1:U.equals(z)}e.expressionsAreEqualWithConstantSubstitution=R;function N($,g){return $.cmp(g)}class b{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return s.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class s{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=s,s.INSTANCE=new s;class p{constructor(g,U){this.key=g,this.negated=U,this.type=2}static create(g,U=null){const z=x.get(g);return typeof z=="boolean"?z?s.INSTANCE:b.INSTANCE:new p(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:m(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=x.get(this.key);return typeof g=="boolean"?g?s.INSTANCE:b.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.negated||(this.negated=M.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class n{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=4}static create(g,U,z=null){if(typeof U=="boolean")return U?p.create(g,z):M.create(g,z);const q=x.get(g);return typeof q=="boolean"?U===(q?"true":"false")?s.INSTANCE:b.INSTANCE:new n(g,U,z)}cmp(g){return g.type!==this.type?this.type-g.type:v(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){const g=x.get(this.key);if(typeof g=="boolean"){const U=g?"true":"false";return this.value===U?s.INSTANCE:b.INSTANCE}return this}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=n;class i{constructor(g,U){this.key=g,this.valueKey=U,this.type=10,this.negated=null}static create(g,U){return new i(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:v(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}substituteConstants(){return this}evaluate(g){const U=g.getValue(this.valueKey),z=g.getValue(this.key);return Array.isArray(U)?U.indexOf(z)>=0:typeof z=="string"&&typeof U=="object"&&U!==null?y.call(U,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyInExpr=i;class d{constructor(g){this._actual=g,this.type=11}static create(g){return new d(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}substituteConstants(){return this}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new d(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=d;class S{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=5}static create(g,U,z=null){if(typeof U=="boolean")return U?M.create(g,z):p.create(g,z);const q=x.get(g);return typeof q=="boolean"?U===(q?"true":"false")?b.INSTANCE:s.INSTANCE:new S(g,U,z)}cmp(g){return g.type!==this.type?this.type-g.type:v(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){const g=x.get(this.key);if(typeof g=="boolean"){const U=g?"true":"false";return this.value===U?b.INSTANCE:s.INSTANCE}return this}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class M{constructor(g,U){this.key=g,this.negated=U,this.type=3}static create(g,U=null){const z=x.get(g);return typeof z=="boolean"?z?b.INSTANCE:s.INSTANCE:new M(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:m(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=x.get(this.key);return typeof g=="boolean"?g?b.INSTANCE:s.INSTANCE:this}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=M;function u($,g){if(typeof $=="string"){const U=parseFloat($);isNaN(U)||($=U)}return typeof $=="string"||typeof $=="number"?g($):b.INSTANCE}class f{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=12}static create(g,U,z=null){return u(U,q=>new f(g,q,z))}cmp(g){return g.type!==this.type?this.type-g.type:v(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class w{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=13}static create(g,U,z=null){return u(U,q=>new w(g,q,z))}cmp(g){return g.type!==this.type?this.type-g.type:v(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=w;class a{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=14}static create(g,U,z=null){return u(U,q=>new a(g,q,z))}cmp(g){return g.type!==this.type?this.type-g.type:v(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class P{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=15}static create(g,U,z=null){return u(U,q=>new P(g,q,z))}cmp(g){return g.type!==this.type?this.type-g.type:v(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=P;class c{constructor(g,U){this.key=g,this.regexp=U,this.type=7,this.negated=null}static create(g,U){return new c(g,U)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const U=this.regexp?this.regexp.source:"",z=g.regexp?g.regexp.source:"";return U<z?-1:U>z?1:0}equals(g){if(g.type===this.type){const U=this.regexp?this.regexp.source:"",z=g.regexp?g.regexp.source:"";return this.key===g.key&&U===z}return!1}substituteConstants(){return this}evaluate(g){let U=g.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=c;class t{constructor(g){this._actual=g,this.type=8}static create(g){return new t(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}substituteConstants(){return this}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new t(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function h($){let g=null;for(let U=0,z=$.length;U<z;U++){const q=$[U].substituteConstants();if($[U]!==q&&g===null){g=[];for(let j=0;j<U;j++)g[j]=$[j]}g!==null&&(g[U]=q)}return g===null?$:g}class o{constructor(g,U){this.expr=g,this.negated=U,this.type=6}static create(g,U){return o._normalizeArr(g,U)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const q=N(this.expr[U],g.expr[U]);if(q!==0)return q}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(g.expr[U]))return!1;return!0}return!1}substituteConstants(){const g=h(this.expr);return g===this.expr?this:o.create(g,this.negated)}evaluate(g){for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].evaluate(g))return!1;return!0}static _normalizeArr(g,U){const z=[];let q=!1;for(const j of g)if(!!j){if(j.type===1){q=!0;continue}if(j.type===0)return b.INSTANCE;if(j.type===6){z.push(...j.expr);continue}z.push(j)}if(z.length===0&&q)return s.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(N);for(let j=1;j<z.length;j++)z[j-1].equals(z[j])&&(z.splice(j,1),j--);if(z.length===1)return z[0];for(;z.length>1;){const j=z[z.length-1];if(j.type!==9)break;z.pop();const J=z.pop(),W=z.length===0,ie=l.create(j.expr.map(le=>o.create([le,J],null)),null,W);ie&&(z.push(ie),z.sort(N))}return z.length===1?z[0]:new o(z,U)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let U of this.expr)g.push(...U.keys());return g}map(g){return new o(this.expr.map(U=>U.map(g)),null)}negate(){if(!this.negated){const g=[];for(let U of this.expr)g.push(U.negate());this.negated=l.create(g,this,!0)}return this.negated}}class l{constructor(g,U){this.expr=g,this.negated=U,this.type=9}static create(g,U,z){return l._normalizeArr(g,U,z)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const q=N(this.expr[U],g.expr[U]);if(q!==0)return q}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(g.expr[U]))return!1;return!0}return!1}substituteConstants(){const g=h(this.expr);return g===this.expr?this:l.create(g,this.negated,!1)}evaluate(g){for(let U=0,z=this.expr.length;U<z;U++)if(this.expr[U].evaluate(g))return!0;return!1}static _normalizeArr(g,U,z){let q=[],j=!1;if(g){for(let J=0,W=g.length;J<W;J++){const ie=g[J];if(!!ie){if(ie.type===0){j=!0;continue}if(ie.type===1)return s.INSTANCE;if(ie.type===9){q=q.concat(ie.expr);continue}q.push(ie)}}if(q.length===0&&j)return b.INSTANCE;q.sort(N)}if(q.length!==0){if(q.length===1)return q[0];for(let J=1;J<q.length;J++)q[J-1].equals(q[J])&&(q.splice(J,1),J--);if(q.length===1)return q[0];if(z){for(let J=0;J<q.length;J++)for(let W=J+1;W<q.length;W++)k(q[J],q[W])&&(q.splice(W,1),W--);if(q.length===1)return q[0]}return new l(q,U)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let U of this.expr)g.push(...U.keys());return g}map(g){return new l(this.expr.map(U=>U.map(g)),null)}negate(){if(!this.negated){let g=[];for(let U of this.expr)g.push(U.negate());for(;g.length>1;){const U=g.shift(),z=g.shift(),q=[];for(const J of T(U))for(const W of T(z))q.push(o.create([J,W],null));const j=g.length===0;g.unshift(l.create(q,null,j))}this.negated=g[0]}return this.negated}}class E extends p{constructor(g,U,z){super(g,null);this._defaultValue=U,typeof z=="object"?E._info.push({...z,key:g}):z!==!0&&E._info.push({key:g,description:z,type:U!=null?typeof U:void 0})}static all(){return E._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return n.create(this.key,g)}notEqualsTo(g){return S.create(this.key,g)}}e.RawContextKey=E,E._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m($,g){return $<g?-1:$>g?1:0}function v($,g,U,z){return $<U?-1:$>U?1:g<z?-1:g>z?1:0}function k($,g){if(g.type===6&&$.type!==9&&$.type!==6){for(const q of g.expr)if($.equals(q))return!0}const U=$.negate(),z=T(U).concat(T(g));z.sort(N);for(let q=0;q<z.length;q++){const J=z[q].negate();for(let W=q+1;W<z.length;W++){const ie=z[W];if(J.equals(ie))return!0}}return!1}e.implies=k;function T($){return $.type===9?$.expr:[$]}}),define(ve[137],Ee([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[46],Ee([1,0,22,17,10,13,2,119,3]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function R(j){return j.create===!0}e.isFileOpenForWriteOptions=R;var N;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(N=e.FileType||(e.FileType={}));var b;(function(j){j[j.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var s;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead"})(s=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=p;function n(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=n;function i(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=i;function d(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=d;function S(j){return p(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var M;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(M=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(J,W){super(J);this.code=W}}e.FileSystemProviderError=u;function f(j,J){const W=new u(j.toString(),J);return a(W,J),W}e.createFileSystemProviderError=f;function w(j){return j||f((0,A.localize)(0,null),M.Unknown)}e.ensureFileSystemProviderError=w;function a(j,J){return j.name=J?`${J} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=a;function P(j){if(!j)return M.Unknown;if(j instanceof u)return j.code;const J=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!J)return M.Unknown;switch(J[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileExceedsMemoryLimit:return M.FileExceedsMemoryLimit;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}e.toFileSystemProviderErrorCode=P;function c(j){if(j instanceof m)return j.fileOperationResult;switch(P(j)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 10;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileExceedsMemoryLimit:return 9;case M.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var t;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class h{constructor(J,W,ie){this.resource=J,this.operation=W,this.target=ie}isOperation(J){return this.operation===J}}e.FileOperationEvent=h;var o;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(J,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=J;const ie=new Map;for(const le of J){const te=ie.get(le.type);switch(te?te.push([le.resource,le]):ie.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,te]of ie)switch(le){case 1:this.added=r.TernarySearchTree.forUris(()=>W),this.added.fill(te);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>W),this.updated.fill(te);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>W),this.deleted.fill(te);break}}contains(J,...W){return this.doContains(J,{includeChildren:!1},...W)}affects(J,...W){return this.doContains(J,{includeChildren:!0},...W)}doContains(J,W,...ie){if(!J)return!1;const le=ie.length>0;return!!((!le||ie.includes(1))&&(this.added?.get(J)||W.includeChildren&&this.added?.findSuperstr(J))||(!le||ie.includes(0))&&(this.updated?.get(J)||W.includeChildren&&this.updated?.findSuperstr(J))||(!le||ie.includes(2))&&(this.deleted?.findSubstr(J)||W.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function E(j,J,W){return!j||!J||j===J||J.length>j.length?!1:(J.charAt(J.length-1)!==I.sep&&(J+=I.sep),W?(0,_.startsWithIgnoreCase)(j,J):j.indexOf(J)===0)}e.isParent=E;class m extends Error{constructor(J,W,ie){super(J);this.fileOperationResult=W,this.options=ie}}e.FileOperationError=m;class v extends m{constructor(J,W,ie){super(J,2,ie);this.stat=W}}e.NotModifiedSinceFileOperationError=v;var k;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=$;async function g(j,J){if(!J.hasProvider(y.URI.from({scheme:j.scheme})))return new Promise(W=>{const ie=J.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===j.scheme&&le.added&&(ie.dispose(),W())})})}e.whenProviderRegistered=g,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(J){return(0,x.isNumber)(J)||(J=0),J<U.KB?(0,A.localize)(1,null,J.toFixed(0)):J<U.MB?(0,A.localize)(2,null,(J/U.KB).toFixed(2)):J<U.GB?(0,A.localize)(3,null,(J/U.MB).toFixed(2)):J<U.TB?(0,A.localize)(4,null,(J/U.GB).toFixed(2)):(0,A.localize)(5,null,(J/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var z;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function q(j){return{maxFileSize:j===0?300*U.MB:16*U.GB,maxHeapSize:j===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=q}),define(ve[55],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(..._){this._entries=new Map;for(let[x,y]of _)this.set(x,y)}set(_,x){const y=this._entries.get(_);return this._entries.set(_,x),y}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=r}),define(ve[138],Ee([1,0,11,15,75,136,3,55]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class R extends Error{constructor(n){super("cyclic dependency between services");this.message=n.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${n.toString()}`}}class N{constructor(n=new A.ServiceCollection,i=!1,d){this._activeInstantiations=new Set,this._services=n,this._strict=i,this._parent=d,this._services.set(y.IInstantiationService,this)}createChild(n){return new N(n,this._strict,this)}invokeFunction(n,...i){let d=s.traceInvocation(n),S=!1;try{return n({get:u=>{if(S)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(u,d);if(!f)throw new Error(`[invokeFunction] unknown service '${u}'`);return f}},...i)}finally{S=!0,d.stop()}}createInstance(n,...i){let d,S;return n instanceof _.SyncDescriptor?(d=s.traceCreation(n.ctor),S=this._createInstance(n.ctor,n.staticArguments.concat(i),d)):(d=s.traceCreation(n),S=this._createInstance(n,i,d)),d.stop(),S}_createInstance(n,i=[],d){let S=y._util.getServiceDependencies(n).sort((f,w)=>f.index-w.index),M=[];for(const f of S){let w=this._getOrCreateServiceInstance(f.id,d);if(!w&&this._strict&&!f.optional)throw new Error(`[createInstance] ${n.name} depends on UNKNOWN service ${f.id}.`);M.push(w)}let u=S.length>0?S[0].index:i.length;if(i.length!==u){console.warn(`[createInstance] First service dependency of ${n.name} at position ${u+1} conflicts with ${i.length} static arguments`);let f=u-i.length;f>0?i=i.concat(new Array(f)):i=i.slice(0,u)}return new n(...[...i,...M])}_setServiceInstance(n,i){if(this._services.get(n)instanceof _.SyncDescriptor)this._services.set(n,i);else if(this._parent)this._parent._setServiceInstance(n,i);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(n){let i=this._services.get(n);return!i&&this._parent?this._parent._getServiceInstanceOrDescriptor(n):i}_getOrCreateServiceInstance(n,i){let d=this._getServiceInstanceOrDescriptor(n);return d instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(n,d,i.branch(n,!0)):(i.branch(n,!1),d)}_safeCreateAndCacheServiceInstance(n,i,d){if(this._activeInstantiations.has(n))throw new Error(`illegal state - RECURSIVELY instantiating service '${n}'`);this._activeInstantiations.add(n);try{return this._createAndCacheServiceInstance(n,i,d)}finally{this._activeInstantiations.delete(n)}}_createAndCacheServiceInstance(n,i,d){const S=new x.Graph(f=>f.id.toString());let M=0;const u=[{id:n,desc:i,_trace:d}];for(;u.length;){const f=u.pop();if(S.lookupOrInsertNode(f),M++>1e3)throw new R(S);for(let w of y._util.getServiceDependencies(f.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(w.id);if(!a&&!w.optional&&console.warn(`[createInstance] ${n} depends on ${w.id} which is NOT registered.`),a instanceof _.SyncDescriptor){const P={id:w.id,desc:a,_trace:f._trace.branch(w.id,!0)};S.insertEdge(f,P),u.push(P)}}}for(;;){const f=S.roots();if(f.length===0){if(!S.isEmpty())throw new R(S);break}for(const{data:w}of f){if(this._getServiceInstanceOrDescriptor(w.id)instanceof _.SyncDescriptor){const P=this._createServiceInstanceWithOwner(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this._setServiceInstance(w.id,P)}S.removeNode(w)}}return this._getServiceInstanceOrDescriptor(n)}_createServiceInstanceWithOwner(n,i,d=[],S,M){if(this._services.get(n)instanceof _.SyncDescriptor)return this._createServiceInstance(i,d,S,M);if(this._parent)return this._parent._createServiceInstanceWithOwner(n,i,d,S,M);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}_createServiceInstance(n,i=[],d,S){if(d){const M=new r.IdleValue(()=>this._createInstance(n,i,S));return new Proxy(Object.create(null),{get(u,f){if(f in u)return u[f];let w=M.value,a=w[f];return typeof a!="function"||(a=a.bind(w),u[f]=a),a},set(u,f,w){return M.value[f]=w,!0}})}else return this._createInstance(n,i,S)}}e.InstantiationService=N;var b;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(b||(b={}));class s{constructor(n,i){this.type=n,this.name=i,this._start=Date.now(),this._dep=[]}static traceInvocation(n){return C?new s(1,n.name||n.toString().substring(0,42).replace(/\n/g,"")):s._None}static traceCreation(n){return C?new s(0,n.name):s._None}branch(n,i){let d=new s(2,n.toString());return this._dep.push([n,i,d]),d}stop(){let n=Date.now()-this._start;s._totals+=n;let i=!1;function d(M,u){let f=[],w=new Array(M+1).join("	");for(const[a,P,c]of u._dep)if(P&&c){i=!0,f.push(`${w}CREATES -> ${a}`);let t=d(M+1,c);t&&f.push(t)}else f.push(`${w}uses -> ${a}`);return f.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${n.toFixed(2)}ms (grand total ${s._totals.toFixed(2)}ms)`];(n>2||i)&&console.log(S.join(`
`))}}e.Trace=s,s._None=new class extends s{constructor(){super(-1,null)}stop(){}branch(){return this}},s._totals=0}),define(ve[12],Ee([1,0,43,5,6,23,3]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function A(){return new Date().toISOString()}var C;(function(P){P[P.Trace=0]="Trace",P[P.Debug=1]="Debug",P[P.Info=2]="Info",P[P.Warning=3]="Warning",P[P.Error=4]="Error",P[P.Critical=5]="Critical",P[P.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function R(P,c,t){switch(c){case C.Trace:P.trace(t);break;case C.Debug:P.debug(t);break;case C.Info:P.info(t);break;case C.Warning:P.warn(t);break;case C.Error:P.error(t);break;case C.Critical:P.critical(t);break;default:throw new Error("Invalid log level")}}e.log=R;function N(P){let c="";for(let t=0;t<P.length;t++){let h=P[t];if(typeof h=="object")try{h=JSON.stringify(h)}catch{}c+=(t>0?" ":"")+h}return c}e.format=N;class b extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(c){this.level!==c&&(this.level=c,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class s extends b{constructor(c){super();this.logAlways=c}checkLogLevel(c){return this.logAlways||this.getLevel()<=c}trace(c,...t){this.checkLogLevel(C.Trace)&&this.log(C.Trace,N([c,...t]))}debug(c,...t){this.checkLogLevel(C.Debug)&&this.log(C.Debug,N([c,...t]))}info(c,...t){this.checkLogLevel(C.Info)&&this.log(C.Info,N([c,...t]))}warn(c,...t){this.checkLogLevel(C.Warning)&&this.log(C.Warning,N([c,...t]))}error(c,...t){if(this.checkLogLevel(C.Error))if(c instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=c.stack,this.log(C.Error,N(h))}else this.log(C.Error,N([c,...t]))}critical(c,...t){this.checkLogLevel(C.Critical)&&this.log(C.Critical,N([c,...t]))}flush(){}}e.AbstractMessageLogger=s;class p extends b{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c),this.useColors=!x.isWindows}trace(c,...t){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,c,...t):console.log(`[main ${A()}]`,c,...t))}debug(c,...t){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,c,...t):console.log(`[main ${A()}]`,c,...t))}info(c,...t){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,c,...t):console.log(`[main ${A()}]`,c,...t))}warn(c,...t){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,c,...t):console.warn(`[main ${A()}]`,c,...t))}error(c,...t){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,c,...t):console.error(`[main ${A()}]`,c,...t))}critical(c,...t){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,c,...t):console.error(`[main ${A()}]`,c,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class n extends b{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c)}trace(c,...t){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",c,...t)}debug(c,...t){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",c,...t)}info(c,...t){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",c,...t)}warn(c,...t){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",c,...t)}error(c,...t){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",c,...t)}critical(c,...t){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",c,...t)}dispose(){}flush(){}}e.ConsoleLogger=n;class i extends b{constructor(c,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=c,this.setLevel(t)}trace(c,...t){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(c),...t])}debug(c,...t){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(c),...t])}info(c,...t){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(c),...t])}warn(c,...t){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(c),...t])}error(c,...t){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(c),...t])}critical(c,...t){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(c),...t])}extractMessage(c){return typeof c=="string"?c:(0,r.toErrorMessage)(c,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=i;class d extends b{constructor(c){super();this.logServices=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const t of this.logServices)t.setLevel(c);super.setLevel(c)}trace(c,...t){for(const h of this.logServices)h.trace(c,...t)}debug(c,...t){for(const h of this.logServices)h.debug(c,...t)}info(c,...t){for(const h of this.logServices)h.info(c,...t)}warn(c,...t){for(const h of this.logServices)h.warn(c,...t)}error(c,...t){for(const h of this.logServices)h.error(c,...t)}critical(c,...t){for(const h of this.logServices)h.critical(c,...t)}flush(){for(const c of this.logServices)c.flush()}dispose(){for(const c of this.logServices)c.dispose()}}e.MultiplexLogService=d;class S extends _.Disposable{constructor(c){super();this.logger=c,this._register(c)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(c){this.logger.setLevel(c)}getLevel(){return this.logger.getLevel()}trace(c,...t){this.logger.trace(c,...t)}debug(c,...t){this.logger.debug(c,...t)}info(c,...t){this.logger.info(c,...t)}warn(c,...t){this.logger.warn(c,...t)}error(c,...t){this.logger.error(c,...t)}critical(c,...t){this.logger.critical(c,...t)}flush(){this.logger.flush()}}e.LogService=S;class M extends _.Disposable{constructor(c,t){super();this.logLevel=c,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(h=>{this.logLevel=h,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(h))}))}getLogger(c){return this.loggers.get(c.toString())}createLogger(c,t){let h=this.loggers.get(c.toString());return h||(h=this.doCreateLogger(c,t?.always?C.Trace:this.logLevel,t),this.loggers.set(c.toString(),h),t?.always||this.logLevelChangeableLoggers.push(h)),h}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(c=>c.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=M;class u{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(c){}getLevel(){return C.Info}trace(c,...t){}debug(c,...t){}info(c,...t){}warn(c,...t){}error(c,...t){}critical(c,...t){}dispose(){}flush(){}}e.NullLogService=u;function f(P){if(P.verbose)return C.Trace;if(typeof P.logLevel=="string"){const c=w(P.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function w(P){switch(P){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=w;function a(P){switch(P){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=a}),define(ve[77],Ee([1,0,34,120,3]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var x;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(x=e.MarkerTag||(e.MarkerTag={}));var y;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function R(n,i){return i-n}C.compare=R;const N=Object.create(null);N[C.Error]=(0,I.localize)(0,null),N[C.Warning]=(0,I.localize)(1,null),N[C.Info]=(0,I.localize)(2,null);function b(n){return N[n]||""}C.toString=b;function s(n){switch(n){case r.default.Error:return C.Error;case r.default.Warning:return C.Warning;case r.default.Info:return C.Info;case r.default.Ignore:return C.Hint}}C.fromSeverity=s;function p(n){switch(n){case C.Error:return r.default.Error;case C.Warning:return r.default.Warning;case C.Info:return r.default.Info;case C.Hint:return r.default.Ignore}}C.toSeverity=p}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(C){const R="";function N(s){return b(s,!0)}C.makeKey=N;function b(s,p){let n=[R];return s.source?n.push(s.source.replace("\xA6","\\\xA6")):n.push(R),s.code?typeof s.code=="string"?n.push(s.code.replace("\xA6","\\\xA6")):n.push(s.code.value.replace("\xA6","\\\xA6")):n.push(R),s.severity!==void 0&&s.severity!==null?n.push(y.toString(s.severity)):n.push(R),s.message&&p?n.push(s.message.replace("\xA6","\\\xA6")):n.push(R),s.startLineNumber!==void 0&&s.startLineNumber!==null?n.push(s.startLineNumber.toString()):n.push(R),s.startColumn!==void 0&&s.startColumn!==null?n.push(s.startColumn.toString()):n.push(R),s.endLineNumber!==void 0&&s.endLineNumber!==null?n.push(s.endLineNumber.toString()):n.push(R),s.endColumn!==void 0&&s.endColumn!==null?n.push(s.endColumn.toString()):n.push(R),n.push(R),n.join("\xA6")}C.makeKeyOptionalMessage=b})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ve[139],Ee([1,0,5,34,3]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=I.default,e.INotificationService=(0,_.createDecorator)("notificationService");var x;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(x=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new C,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=A;class C{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=C}),define(ve[78],Ee([1,0,6,10,2,3]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,x.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function y(R,N){return _.URI.isUri(R)?(0,I.equalsIgnoreCase)(R.scheme,N):(0,I.startsWithIgnoreCase)(R,N+":")}e.matchesScheme=y;function A(R,...N){return N.some(b=>y(R,b))}e.matchesSomeScheme=A;function C(R){let N;const b=/^L?(\d+)(?:,(\d+))?/.exec(R.fragment);return b&&(N={startLineNumber:parseInt(b[1]),startColumn:b[2]?parseInt(b[2]):1}),N}e.selectionFragment=C});var Fe=this&&this.__decorate||function(Y,e,r,I){var _=arguments.length,x=_<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,r):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")x=Reflect.decorate(Y,e,r,I);else for(var A=Y.length-1;A>=0;A--)(y=Y[A])&&(x=(_<3?y(x):_>3?y(e,r,x):y(e,r))||x);return _>3&&x&&Object.defineProperty(e,r,x),x},Ne=this&&this.__param||function(Y,e){return function(r,I){e(r,I,Y)}};define(ve[140],Ee([1,0,11,20,6,3]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,x.createDecorator)("progressService");var y;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let C=class extends _.Disposable{constructor(b,s){super();this.deferred=new r.DeferredPromise,s.withProgress(b,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};C=Fe([Ne(1,e.IProgressService)],C),e.UnmanagedProgress=C;class R extends _.Disposable{constructor(b){super();this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(b){this.stop();const s=++this.currentOperationId,p=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{s===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:s,token:p.token,stop:()=>this.doStop(s),isCurrent:()=>this.currentOperationId===s}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,x.createDecorator)("editorProgressService")}),define(ve[37],Ee([1,0,42,13]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(y,A){r.ok(I.isString(y)),r.ok(I.isObject(A)),r.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,A)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new _}),define(ve[141],Ee([1,0,5,37]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class x{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,R){this.schemasById[_(C)]=R,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new x;I.Registry.add(e.Extensions.JSONContribution,y)}),define(ve[79],Ee([1,0,16,5,13,117,141,37]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const N=A.Registry.as(y.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:x.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(w,a=!0){this.registerConfigurations([w],a)}registerConfigurations(w,a=!0){const P=this.doRegisterConfigurations(w,a);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:P})}deregisterConfigurations(w){const a=this.doDeregisterConfigurations(w);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:w,remove:a}){const P=[];P.push(...this.doDeregisterConfigurations(a)),P.push(...this.doRegisterConfigurations(w,!1)),N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(P)})}registerDefaultConfigurations(w){const a=[],P=[];for(const{overrides:c,source:t}of w)for(const h in c)if(a.push(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const o={...this.configurationDefaultsOverrides.get(h)?.value||{},...c[h]};this.configurationDefaultsOverrides.set(h,{source:t,value:o});const l={type:"object",default:o,description:x.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:_.isString(t)?void 0:t};P.push(...n(h)),this.configurationProperties[h]=l,this.defaultLanguageConfigurationOverridesNode.properties[h]=l}else{this.configurationDefaultsOverrides.set(h,{value:c[h],source:t});const o=this.configurationProperties[h];o&&(this.updatePropertyDefaultValue(h,o),this.updateSchema(h,o))}this.registerOverrideIdentifiers(P),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(w){const a=[];for(const{overrides:P,source:c}of w)for(const t in P){const h=this.configurationDefaultsOverrides.get(t),o=_.isString(c)?c:c?.id,l=_.isString(h?.source)?h?.source:h?.source?.id;if(o===l)if(a.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const E=this.configurationProperties[t];E&&(this.updatePropertyDefaultValue(t,E),this.updateSchema(t,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const a of w)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(w,a){const P=[];return w.forEach(c=>{P.push(...this.validateAndRegisterProperties(c,a,c.extensionInfo,c.restrictedProperties)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),P}doDeregisterConfigurations(w){const a=[],P=c=>{if(c.properties)for(const t in c.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,c.properties[t]);c.allOf&&c.allOf.forEach(t=>P(t))};for(const c of w){P(c);const t=this.configurationContributors.indexOf(c);t!==-1&&this.configurationContributors.splice(t,1)}return a}validateAndRegisterProperties(w,a=!0,P,c,t=3){t=_.isUndefinedOrNull(w.scope)?t:w.scope;let h=[],o=w.properties;if(o)for(let E in o){if(a&&M(E)){delete o[E];continue}const m=o[E];if(m.source=P,m.defaultDefaultValue=o[E].default,this.updatePropertyDefaultValue(E,m),e.OVERRIDE_PROPERTY_REGEX.test(E)?m.scope=void 0:(m.scope=_.isUndefinedOrNull(m.scope)?t:m.scope,m.restricted=_.isUndefinedOrNull(m.restricted)?!!c?.includes(E):m.restricted),o[E].hasOwnProperty("included")&&!o[E].included){this.excludedConfigurationProperties[E]=o[E],delete o[E];continue}else this.configurationProperties[E]=o[E];!o[E].deprecationMessage&&o[E].markdownDeprecationMessage&&(o[E].deprecationMessage=o[E].markdownDeprecationMessage),h.push(E)}let l=w.allOf;if(l)for(let E of l)h.push(...this.validateAndRegisterProperties(E,a,P,c,t));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(w){const a=P=>{let c=P.properties;if(c)for(const h in c)this.updateSchema(h,c[h]);let t=P.allOf;t&&t.forEach(a)};a(w)}updateSchema(w,a){switch(e.allSettings.properties[w]=a,a.scope){case 1:e.applicationSettings.properties[w]=a;break;case 2:e.machineSettings.properties[w]=a;break;case 6:e.machineOverridableSettings.properties[w]=a;break;case 3:e.windowSettings.properties[w]=a;break;case 4:e.resourceSettings.properties[w]=a;break;case 5:e.resourceSettings.properties[w]=a,this.resourceLanguageSettingsSchema.properties[w]=a;break}}removeFromSchema(w,a){switch(delete e.allSettings.properties[w],a.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w],delete this.resourceLanguageSettingsSchema.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const a=`[${w}]`,P={type:"object",description:x.localize(2,null),errorMessage:x.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,P),e.allSettings.properties[a]=P,e.applicationSettings.properties[a]=P,e.machineSettings.properties[a]=P,e.machineOverridableSettings.properties[a]=P,e.windowSettings.properties[a]=P,e.resourceSettings.properties[a]=P}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const w={type:"object",description:x.localize(4,null),errorMessage:x.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,a){const P=this.configurationDefaultsOverrides.get(w);let c=P?.value,t=P?.source;_.isUndefined(c)&&(c=a.defaultDefaultValue,t=void 0),_.isUndefined(c)&&(c=d(a.type)),a.default=c,a.defaultValueSource=t}}const s="\\[([^\\]]+)\\]",p=new RegExp(s,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${s})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function n(f){const w=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let a=p.exec(f);for(;a?.length;){const P=a[1].trim();P&&w.push(P),a=p.exec(f)}}return(0,r.distinct)(w)}e.overrideIdentifiersFromKey=n;function i(f){return f.reduce((w,a)=>`${w}[${a}]`,"")}e.keyFromOverrideIdentifiers=i;function d(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const S=new b;A.Registry.add(e.Extensions.Configuration,S);function M(f){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?x.localize(7,null,f):S.getConfigurationProperties()[f]!==void 0?x.localize(8,null,f):null:x.localize(6,null)}e.validateProperty=M;function u(){const f=[],w=S.getConfigurationProperties();for(const a of Object.keys(w))f.push([a,w[a].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=u}),define(ve[142],Ee([1,0,16,5,100,6,22,26,13,2,76,79,37]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(c={},t=[],h=[]){this._contents=c,this._keys=t,this._overrides=h,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(c){return c?(0,N.getConfigurationValue)(this.contents,c):this.contents}getOverrideValue(c,t){const h=this.getContentsForOverrideIdentifer(t);return h?c?(0,N.getConfigurationValue)(h,c):h:void 0}getKeysForOverrideIdentifier(c){const t=[];for(const h of this.overrides)h.identifiers.includes(c)&&t.push(...h.keys);return r.distinct(t)}getAllOverrideIdentifiers(){const c=[];for(const t of this.overrides)c.push(...t.identifiers);return r.distinct(c)}override(c){let t=this.overrideConfigurations.get(c);return t||(t=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,t)),t}merge(...c){const t=A.deepClone(this.contents),h=A.deepClone(this.overrides),o=[...this.keys];for(const l of c){this.mergeContents(t,l.contents);for(const E of l.overrides){const[m]=h.filter(v=>r.equals(v.identifiers,E.identifiers));m?(this.mergeContents(m.contents,E.contents),m.keys.push(...E.keys),m.keys=r.distinct(m.keys)):h.push(A.deepClone(E))}for(const E of l.keys)o.indexOf(E)===-1&&o.push(E)}return new p(t,o,h)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(c){const t=this.getContentsForOverrideIdentifer(c);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let h={};for(const o of r.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[o],E=t[o];E&&(typeof l=="object"&&typeof E=="object"?(l=A.deepClone(l),this.mergeContents(l,E)):l=E),h[o]=l}return new p(h,this.keys,this.overrides)}mergeContents(c,t){for(const h of Object.keys(t)){if(h in c&&C.isObject(c[h])&&C.isObject(t[h])){this.mergeContents(c[h],t[h]);continue}c[h]=A.deepClone(t[h])}}checkAndFreeze(c){return this.isFrozen&&!Object.isFrozen(c)?A.deepFreeze(c):c}getContentsForOverrideIdentifer(c){let t=null,h=null;const o=l=>{l&&(h?this.mergeContents(h,l):h=A.deepClone(l))};for(const l of this.overrides)r.equals(l.identifiers,[c])?t=l.contents:l.identifiers.includes(c)&&o(l.contents);return o(t),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(c,t){this.addKey(c),(0,N.addToValueTree)(this.contents,c,t,h=>{throw new Error(h)})}removeValue(c){this.removeKey(c)&&(0,N.removeFromValueTree)(this.contents,c)}addKey(c){let t=this.keys.length;for(let h=0;h<t;h++)c.indexOf(this.keys[h])===0&&(t=h);this.keys.splice(t,1,c)}removeKey(c){let t=this.keys.indexOf(c);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class n extends p{constructor(c={}){const t=s.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(t),o=Object.create(null),l=[];for(const E in t){const m=c[E],v=m!==void 0?m:t[E].default;(0,N.addToValueTree)(o,E,v,k=>console.error(`Conflict in default settings: ${k}`))}for(const E of Object.keys(o))b.OVERRIDE_PROPERTY_REGEX.test(E)&&l.push({identifiers:(0,b.overrideIdentifiersFromKey)(E),keys:Object.keys(o[E]),contents:(0,N.toValuesTree)(o[E],m=>console.error(`Conflict in default settings file: ${m}`))});super(o,h,l)}}e.DefaultConfigurationModel=n;class i{constructor(c){this._name=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,t){if(!C.isUndefinedOrNull(c)){const h=this.doParseContent(c);this.parseRaw(h,t)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,t){this._raw=c;const{contents:h,keys:o,overrides:l,restricted:E}=this.doParseRaw(c,t);this._configurationModel=new p(h,o,l),this._restrictedConfigurations=E||[]}doParseContent(c){let t={},h=null,o=[],l=[],E=[];function m(k){Array.isArray(o)?o.push(k):h!==null&&(o[h]=k)}let v={onObjectBegin:()=>{let k={};m(k),l.push(o),o=k,h=null},onObjectProperty:k=>{h=k},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let k=[];m(k),l.push(o),o=k,h=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:m,onError:(k,T,$)=>{E.push({error:k,offset:T,length:$})}};if(c)try{_.visit(c,v),t=o[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return t}doParseRaw(c,t){const h=s.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(c,h,!0,t);c=o.raw;const l=(0,N.toValuesTree)(c,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),E=Object.keys(c),m=this.toOverrides(c,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:l,keys:E,overrides:m,restricted:o.restricted}}filter(c,t,h,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:c,restricted:[]};const l={},E=[];for(let m in c)if(b.OVERRIDE_PROPERTY_REGEX.test(m)&&h){const v=this.filter(c[m],t,!1,o);l[m]=v.raw,E.push(...v.restricted)}else{const v=t[m],k=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&E.push(m),(k===void 0||o.scopes===void 0||o.scopes.includes(k))&&(o.skipRestricted&&v?.restricted||(l[m]=c[m]))}return{raw:l,restricted:E}}toOverrides(c,t){const h=[];for(const o of Object.keys(c))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const E in c[o])l[E]=c[o][E];h.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,N.toValuesTree)(l,t)})}return h}}e.ConfigurationModelParser=i;class d extends x.Disposable{constructor(c,t,h,o){super();this.userSettingsResource=c,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new i(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(h.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class S{constructor(c,t,h=new p,o=new p,l=new y.ResourceMap,E=new p,m=new y.ResourceMap,v=!0){this._defaultConfiguration=c,this._localUserConfiguration=t,this._remoteUserConfiguration=h,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=E,this._memoryConfigurationByResource=m,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(c,t,h){return this.getConsolidateConfigurationModel(t,h).getValue(c)}updateValue(c,t,h={}){let o;h.resource?(o=this._memoryConfigurationByResource.get(h.resource),o||(o=new p,this._memoryConfigurationByResource.set(h.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(c):o.setValue(c,t),h.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,t,h){const o=this.getConsolidateConfigurationModel(t,h),l=this.getFolderConfigurationModelForResource(t.resource,h),E=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,m=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this._defaultConfiguration.freeze().getValue(c),v=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this.userConfiguration.freeze().getValue(c),k=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this.localUserConfiguration.freeze().getValue(c),T=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this.remoteUserConfiguration.freeze().getValue(c),$=h?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this._workspaceConfiguration.freeze().getValue(c):void 0,g=l?t.overrideIdentifier?l.freeze().override(t.overrideIdentifier).getValue(c):l.freeze().getValue(c):void 0,U=t.overrideIdentifier?E.override(t.overrideIdentifier).getValue(c):E.getValue(c),z=o.getValue(c),q=r.distinct(r.flatten(o.overrides.map(j=>j.identifiers))).filter(j=>o.getOverrideValue(c,j)!==void 0);return{defaultValue:m,userValue:v,userLocalValue:k,userRemoteValue:T,workspaceValue:$,workspaceFolderValue:g,memoryValue:U,value:z,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,userLocal:k!==void 0?{value:this.localUserConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,workspace:$!==void 0?{value:this._workspaceConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,workspaceFolder:g!==void 0?{value:l?.freeze().getValue(c),override:t.overrideIdentifier?l?.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:E.getValue(c),override:t.overrideIdentifier?E.getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(c){const t=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,t){this._folderConfigurations.set(c,t),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,t){const h=[];if(!t){const{added:o,updated:l,removed:E}=w(this._defaultConfiguration,c);t=[...o,...l,...E]}for(const o of t)for(const l of(0,b.overrideIdentifiersFromKey)(o)){const E=this._defaultConfiguration.getKeysForOverrideIdentifier(l),m=c.getKeysForOverrideIdentifier(l),v=[...m.filter(k=>E.indexOf(k)===-1),...E.filter(k=>m.indexOf(k)===-1),...E.filter(k=>!A.equals(this._defaultConfiguration.override(l).getValue(k),c.override(l).getValue(k)))];h.push([l,v])}return this.updateDefaultConfiguration(c),{keys:t,overrides:h}}compareAndUpdateLocalUserConfiguration(c){const{added:t,updated:h,removed:o,overrides:l}=w(this.localUserConfiguration,c),E=[...t,...h,...o];return E.length&&this.updateLocalUserConfiguration(c),{keys:E,overrides:l}}compareAndUpdateRemoteUserConfiguration(c){const{added:t,updated:h,removed:o,overrides:l}=w(this.remoteUserConfiguration,c);let E=[...t,...h,...o];return E.length&&this.updateRemoteUserConfiguration(c),{keys:E,overrides:l}}compareAndUpdateWorkspaceConfiguration(c){const{added:t,updated:h,removed:o,overrides:l}=w(this.workspaceConfiguration,c);let E=[...t,...h,...o];return E.length&&this.updateWorkspaceConfiguration(c),{keys:E,overrides:l}}compareAndUpdateFolderConfiguration(c,t){const h=this.folderConfigurations.get(c),{added:o,updated:l,removed:E,overrides:m}=w(h,t);let v=[...o,...l,...E];return(v.length||!h)&&this.updateFolderConfiguration(c,t),{keys:v,overrides:m}}compareAndDeleteFolderConfiguration(c){const t=this.folderConfigurations.get(c);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:h,updated:o,removed:l,overrides:E}=w(t,void 0);return{keys:[...h,...o,...l],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(c,t){let h=this.getConsolidatedConfigurationModelForResource(c,t);return c.overrideIdentifier?h.override(c.overrideIdentifier):h}getConsolidatedConfigurationModelForResource({resource:c},t){let h=this.getWorkspaceConsolidatedConfiguration();if(t&&c){const o=t.getFolder(c);o&&(h=this.getFolderConsolidatedConfiguration(o.uri)||h);const l=this._memoryConfigurationByResource.get(c);l&&(h=h.merge(l))}return h}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let t=this._foldersConsolidatedConfigurations.get(c);if(!t){const h=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(c);o?(t=h.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(c,t)):t=h}return t}getFolderConfigurationModelForResource(c,t){if(t&&c){const h=t.getFolder(c);if(h)return this._folderConfigurations.get(h.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,t)=>{const{contents:h,overrides:o,keys:l}=this._folderConfigurations.get(t);return c.push([t,{contents:h,overrides:o,keys:l}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>c.add(t)),this.userConfiguration.freeze().keys.forEach(t=>c.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>c.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(h=>c.add(h))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>c.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>c.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>c.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(h=>c.add(h))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(h=>t.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(h=>t.add(h)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(h=>t.add(h)),this._folderConfigurations.forEach(h=>h.getKeysForOverrideIdentifier(c).forEach(o=>t.add(o))),[...t.values()]}static parse(c){const t=this.parseConfigurationModel(c.defaults),h=this.parseConfigurationModel(c.user),o=this.parseConfigurationModel(c.workspace),l=c.folders.reduce((E,m)=>(E.set(R.URI.revive(m[0]),this.parseConfigurationModel(m[1])),E),new y.ResourceMap);return new S(t,h,new p,o,l,new p,new y.ResourceMap,!1)}static parseConfigurationModel(c){return new p(c.contents,c.keys,c.overrides).freeze()}}e.Configuration=S;function M(...P){if(P.length===0)return{keys:[],overrides:[]};if(P.length===1)return P[0];const c=new Set,t=new Map;for(const o of P)o.keys.forEach(l=>c.add(l)),o.overrides.forEach(([l,E])=>{const m=(0,y.getOrSet)(t,l,new Set);E.forEach(v=>m.add(v))});const h=[];return t.forEach((o,l)=>h.push([l,[...o.values()]])),{keys:[...c.values()],overrides:h}}e.mergeChanges=M;class u{constructor(c,t,h,o){this.change=c,this.previous=t,this.currentConfiguraiton=h,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;c.keys.forEach(m=>l.add(m)),c.overrides.forEach(([,m])=>m.forEach(v=>l.add(v))),this.affectedKeys=[...l.values()];const E=new p;this.affectedKeys.forEach(m=>E.setValue(m,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(c,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,c)){if(t){const h=this.previousConfiguration?this.previousConfiguration.getValue(c,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(c,t,this.currentWorkspace);return!A.equals(h,o)}return!0}return!1}doesAffectedKeysTreeContains(c,t){let h=(0,N.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof h=="object"&&(o=Object.keys(h)[0]);){if(c=c[o],!c)return!1;h=h[o]}return!0}}e.ConfigurationChangeEvent=u;class f extends u{constructor(c,t,h,o){super({keys:c.allKeys(),overrides:[]},void 0,c,t);this.source=h,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=f;function w(P,c){const{added:t,removed:h,updated:o}=a(c,P),l=[],E=P?.getAllOverrideIdentifiers()||[],m=c?.getAllOverrideIdentifiers()||[];if(c){const v=m.filter(k=>!E.includes(k));for(const k of v)l.push([k,c.getKeysForOverrideIdentifier(k)])}if(P){const v=E.filter(k=>!m.includes(k));for(const k of v)l.push([k,P.getKeysForOverrideIdentifier(k)])}if(c&&P){for(const v of E)if(m.includes(v)){const k=a({contents:P.getOverrideValue(void 0,v)||{},keys:P.getKeysForOverrideIdentifier(v)},{contents:c.getOverrideValue(void 0,v)||{},keys:c.getKeysForOverrideIdentifier(v)});l.push([v,[...k.added,...k.removed,...k.updated]])}}return{added:t,removed:h,updated:o,overrides:l}}function a(P,c){const t=P?c?P.keys.filter(l=>c.keys.indexOf(l)===-1):[...P.keys]:[],h=c?P?c.keys.filter(l=>P.keys.indexOf(l)===-1):[...c.keys]:[],o=[];if(P&&c){for(const l of c.keys)if(P.keys.indexOf(l)!==-1){const E=(0,N.getConfigurationValue)(c.contents,l),m=(0,N.getConfigurationValue)(P.contents,l);A.equals(E,m)||o.push(l)}}return{added:t,removed:h,updated:o}}}),define(ve[80],Ee([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var I;(function(x){x.Unknown="Unknown",x.NotAvailable="NotAvailable",x.TemporarilyNotAvailable="TemporarilyNotAvailable",x.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(y,A=I.Unknown,C){super(y);this._message=y,this._code=A,this._detail=C,this.isHandled=A===I.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(y){return y instanceof _&&y._code===I.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof _&&y._code===I.NoResolverFound}static isHandled(y){return y instanceof _&&y.isHandled}}e.RemoteAuthorityResolverError=_}),define(ve[81],Ee([1,0,9]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function I(x){return x.scheme===r.Schemas.vscodeRemote?x.authority:void 0}e.getRemoteAuthority=I;function _(x){if(!x)return;const y=x.indexOf("+");return y<0?x:x.substr(0,y)}e.getRemoteName=_}),define(ve[25],Ee([1,0,10,3,81]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function x(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.getWorkspaceSupportTypeMessage=x;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,n){if(typeof p=="undefined"||p===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof p=="string"||typeof n=="string"){let i=typeof p=="string"?p:p.value,d=typeof n=="string"?n:n.value;return r.equalsIgnoreCase(i,d)}return p._lower===n._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=C;function R(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function N(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=N;function b(s,p){if(p){const n=`onResolveRemoteAuthority:${(0,_.getRemoteName)(p)}`;return s.activationEvents?.indexOf(n)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[143],Ee([1,0,10,25]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,r.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=_;class x{constructor(i,d){this.version=d,this.id=i.id,this.uuid=i.uuid}key(){return`${this.id}-${this.version}`}equals(i){return i instanceof x?_(this,i)&&this.version===i.version:!1}}e.ExtensionIdentifierWithVersion=x;function y(n,i){return`${n}.${i}`}e.getExtensionId=y;function A(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function C(n,i){return A(y(n,i))}e.getGalleryExtensionId=C;function R(n,i){const d=[],S=M=>{for(const u of d)if(u.some(f=>_(i(f),i(M))))return u;return null};for(const M of n){const u=S(M);u?u.push(M):d.push([M])}return d}e.groupByExtension=R;function N(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=N;function b(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function s(n){const i=new Set;if(n.malicious)for(const d of n.malicious)i.add(d.id);return i}e.getMaliciousExtensionsSet=s;function p(n,i){const d=[],S=i.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const M=S.shift();if(M&&d.every(u=>!_(u.identifier,{id:M}))){const u=n.filter(f=>_(f.identifier,{id:M}));u.length===1&&(d.push(u[0]),S.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=p}),define(ve[144],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,x,y=5){let A;return A=x(C=>{const R=typeof C=="string"?C:C.data;let N=this._terminalBufferMap.get(_);if(N){N.data.push(R);return}const b=setTimeout(()=>this.flushBuffer(_),y);N={data:[R],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(_),A.dispose()}},this._terminalBufferMap.set(_,N)}),A}stopBuffering(_){const x=this._terminalBufferMap.get(_);x&&x.dispose()}flushBuffer(_){const x=this._terminalBufferMap.get(_);x&&(this._terminalBufferMap.delete(_),this._callback(_,x.data.join("")))}}e.TerminalDataBufferer=r}),define(ve[145],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var r;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(r=e.ColorScheme||(e.ColorScheme={}))}),define(ve[56],Ee([1,0,106,5,6,3,37,145]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,x.createDecorator)("themeService");var C;(function(d){function S(M){return M&&typeof M=="object"&&typeof M.id=="string"}d.isThemeColor=S})(C=e.ThemeColor||(e.ThemeColor={}));function R(d){return{id:d}}e.themeColorFromId=R;var N;(function(d){function S(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||C.isThemeColor(t.color))}d.isThemeIcon=S;const M=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function u(t){const h=M.exec(t);if(!h)return;let[,o]=h;return{id:o}}d.fromString=u;function f(t){return{id:t}}d.fromId=f;function w(t,h){let o=t.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),h&&(o=`${o}~${h}`),{id:o}}d.modify=w;function a(t){const h=t.id.lastIndexOf("~");if(h!==-1)return t.id.substring(h+1)}d.getModifier=a;function P(t,h){return t.id===h.id&&t.color?.id===h.color?.id}d.isEqual=P;function c(t,h){return{id:t.id,color:h?R(h):void 0}}d.asThemeIcon=c,d.asClassNameArray=r.CSSIcon.asClassNameArray,d.asClassName=r.CSSIcon.asClassName,d.asCSSSelector=r.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function b(d){switch(d){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class s{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,_.toDisposable)(()=>{const M=this.themingParticipants.indexOf(S);this.themingParticipants.splice(M,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new s;y.Registry.add(e.Extensions.ThemingContribution,p);function n(d){return p.onColorThemeChange(d)}e.registerThemingParticipant=n;class i extends _.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(M=>this.onThemeChange(M)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,M){let u=this.theme.getColor(S);return u&&M&&(u=M(u,this.theme)),u?u.toString():null}}e.Themable=i}),define(ve[146],Ee([1,0,5,23,3,12]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,_.createDecorator)("sharedTunnelsService");var y;(function(n){n.Http="http",n.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(!!i)return{address:i[1],port:+i[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(n){return e.LOCALHOST_ADDRESSES.indexOf(n)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(n){return e.ALL_INTERFACES_ADDRESSES.indexOf(n)>=0}e.isAllInterfaces=b;function s(n,i){return i?i!==1&&n<1024:!I.isWindows&&n<1024}e.isPortPrivileged=s;let p=class{constructor(i){this.logService=i,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],d=Array.from(this._tunnels.values());for(let S of d){const M=Array.from(S.values());for(let u of M){const f=await u.value;f&&i.push(f)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:d}of i.values())await d.then(S=>S?.dispose());i.clear()}this._tunnels.clear()}openTunnel(i,d,S,M,u=!1,f=A.Private,w){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${S} on local port ${M}.`),!i)return;d||(d="localhost");const a=this.retainOrCreateTunnel(i,d,S,M,u,f,w);return a?a.then(P=>{if(!P){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(P);return(P.tunnelRemoteHost!==d||P.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const d=this._tunnels.get(i.tunnelRemoteHost);if(d){const S=d.get(i.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,S))}}}}async tryDisposeTunnel(i,d,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${d}.`);const M=S.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(d),M}}async closeTunnel(i,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${d} `);const S=this._tunnels.get(i);if(S&&S.has(d)){const M=S.get(d);M.refcount=0,await this.tryDisposeTunnel(i,d,M)}}addTunnelToMap(i,d,S){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(d,{refcount:1,value:S})}async removeEmptyTunnelFromMap(i,d){const S=this._tunnels.get(i);S&&(await S.get(d)||S.delete(d),S.size===0&&this._tunnels.delete(i))}getTunnelFromMap(i,d){let S=[i];N(i)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):b(i)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const M=S.map(u=>this._tunnels.get(u));for(const u of M){const f=u?.get(d);if(f)return f}}canTunnel(i){return!!R(i)}createWithProvider(i,d,S,M,u,f,w){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${S} on local port ${M}.`);const P={elevationRequired:u?s(M===void 0?S:M):!1},c={remoteAddress:{host:d,port:S},localAddressPort:M,privacy:f,public:f!==A.Private,protocol:w},t=i.forwardPort(c,P);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,S,t),t}};p=Fe([Ne(0,x.ILogService)],p),e.AbstractTunnelService=p}),define(ve[147],Ee([1,0,9]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function I(A){return A.scheme!==r.Schemas.file&&A.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=I;function _(A){if(A.folders.length)return A.folders.every(C=>I(C.uri))?A.folders[0].uri:void 0;if(A.configuration&&I(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=_;function x(A){return _(A)?.scheme}e.getVirtualWorkspaceScheme=x;function y(A){return _(A)!==void 0}e.isVirtualWorkspace=y}),define(ve[47],Ee([1,0,22,24,2,3]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,x.createDecorator)("contextService");var y;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function A(s){const p=s;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=A;function C(s){const p=s;return!!(p&&typeof p=="object"&&_.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=C;class R{constructor(p,n,i,d,S){this._id=p,this._transient=i,this._configuration=d,this._ignorePathCasing=S,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=n}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=R;class N{constructor(p,n){this.raw=n,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,I.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=N;function b(s){return new N({uri:s,index:0,name:(0,I.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=b}),define(ve[57],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const x=this._idPool++;return this._data.set(x,_),this.logDebugInfo(),x}get(_,x){return this._data.has(_)?this._data.get(_)[x]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(ve[30],Ee([1,0,9,24,3]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class x{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new I.ExtUri(A=>{const C=this._providerInfo.get(A.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(A,C){C===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,C)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=x,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(ve[28],Ee([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(ve[148],Ee([1,0,11]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,A,C){this._deferredPromises=new Map,this._id=y,this._shared=A,this._storage=C,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const N of R.values())N.complete()}catch(N){for(const b of R.values())b.error(N)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,A){let C=this._value[y];return typeof C=="undefined"&&(C=A),C}update(y,A){this._value[y]=A;let C=this._deferredPromises.get(y);if(C!==void 0)return C.p;const R=new r.DeferredPromise;return this._deferredPromises.set(y,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class _ extends I{constructor(y,A){super(y.identifier.value,!0,A);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=_}),define(ve[149],Ee([1,0,5,2,12]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let x=class{constructor(A,C){this._logService=A,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new r.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(A,C,R){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A)).acceptModelChanged(C.value,R)}$acceptDirtyStateChanged(A,C){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A)).acceptDirty(C)}$acceptModelSaved(A){const C=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(A,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",A.path,C);const R=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A));R.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};x=Fe([Ne(0,_.ILogService)],x),e.ExtHostNotebookDocuments=x}),define(ve[14],Ee([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class I{constructor(x){this.getProxy=x.getProxy.bind(x),this.set=x.set.bind(x),this.assertRegistered=x.assertRegistered.bind(x),this.drain=x.drain.bind(x)}}e.ExtHostRpcService=I});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[150],Ee([1,0,25,5]),function(Y,e,r,I){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class x{constructor(A,C){_.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(A.identifier),je(this,_,C,"f"),ye(this,_,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(A){return ye(this,_,"f").get(this._id,A)}store(A,C){return ye(this,_,"f").store(this._id,A,C)}delete(A){return ye(this,_,"f").delete(this._id,A)}}e.ExtensionSecrets=x,_=new WeakMap}),define(ve[82],Ee([1,0,3,5]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new I.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(y){this._level=y}$onDidChangeTelemetryLevel(y){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=y,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(ve[48],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var r;(function(M){M[M.Upsert=0]="Upsert",M[M.RemoveChild=1]="RemoveChild",M[M.Invalidated=2]="Invalidated",M[M.SetProp=3]="SetProp",M[M.Bulk=4]="Bulk"})(r=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const I=new WeakMap,_=(M,u)=>{const f={controllerId:u};return I.set(M,f),f};e.createPrivateApiFor=_;const x=M=>I.get(M);e.getPrivateApiFor=x;const y=(M,u,f,w)=>{let a=f;return{enumerable:!0,configurable:!1,get(){return a},set(P){if(!w(a,P)){const c=a;a=P,M.listener?.({op:3,key:u,value:P,previous:c})}}}},A=(M,u)=>M===u,C={range:(M,u)=>M===u?!0:!M||!u?!1:M.isEqual(u),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(M,u)=>!(M.length!==u.length||M.some(f=>!u.find(w=>f.id===w.id)))},R=Object.keys(C),N=(M,u)=>({range:y(M,"range",void 0,C.range),label:y(M,"label",u,C.label),description:y(M,"description",void 0,C.description),sortText:y(M,"sortText",void 0,C.sortText),canResolveChildren:y(M,"canResolveChildren",!1,C.canResolveChildren),busy:y(M,"busy",!1,C.busy),error:y(M,"error",void 0,C.error),tags:y(M,"tags",[],C.tags)}),b=(M,u)=>{const f=new Map;for(const w of R)C[w](M[w],u[w])||f.set(w,u[w]);return f};e.diffTestItems=b;class s extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.DuplicateTestItemError=s;class p extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class n extends Error{constructor(u,f,w){super(`TestItem with ID "${u}" is from controller "${f}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=n;const i=M=>{const u=(0,e.getPrivateApiFor)(M);let f=new Map;return{get size(){return f.size},forEach(w,a){for(const P of f.values())w.call(a,P,this)},replace(w){const a=new Map,P=new Set(f.keys()),c={op:4,ops:[]};for(const t of w){if(!(t instanceof d))throw new p(t.id);const h=(0,e.getPrivateApiFor)(t).controllerId;if(h!==u.controllerId)throw new n(t.id,h,u.controllerId);if(a.has(t.id))throw new s(t.id);a.set(t.id,t),P.delete(t.id),c.ops.push({op:0,item:t})}for(const t of P.keys())c.ops.push({op:1,id:t});u.listener?.(c),f=a},add(w){if(!(w instanceof d))throw new p(w.id);f.set(w.id,w),u.listener?.({op:0,item:w})},delete(w){f.delete(w)&&u.listener?.({op:1,id:w})},get(w){return f.get(w)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class d{constructor(u,f,w,a){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const P=(0,e.createPrivateApiFor)(this,u);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return P.parent instanceof S?void 0:P.parent}},children:{value:i(this),enumerable:!0,writable:!1},...N(P,w)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=d;class S extends d{constructor(u,f){super(u,u,f,void 0)}}e.TestItemRootImpl=S}),define(ve[58],Ee([1,0,3,146,5,14]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(C){function R(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?I.TunnelPrivacyId.Public:I.TunnelPrivacyId.Private),protocol:b.protocol}}C.fromApiTunnel=R;function N(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==I.TunnelPrivacyId.ConstantPrivate&&b.privacy!==I.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}C.fromServiceTunnel=N})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let A=class{constructor(R){this.onDidChangeTunnels=new _.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,N){}async getTunnels(){return[]}async setTunnelFactory(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,N){return{dispose:()=>{}}}async $providePortAttributes(R,N,b,s,p){return[]}async $forwardPort(R,N){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Fe([Ne(0,x.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[7],Ee([1,0,16,15,71,22,70,10,13,2,36,46,80]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s){"use strict";var p,n,i,d,S,M,u,f,w,a,P,c,t,h,o,l,E,m,v,k;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function T(V){function B(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(B,V),Object.setPrototypeOf(B.prototype,V.prototype),B}let $=S=class{constructor(B){p.set(this,void 0),je(this,p,B,"f")}static from(...B){let ee=B;return new S(function(){if(ee){for(const we of ee)we&&typeof we.dispose=="function"&&we.dispose();ee=void 0}})}dispose(){typeof ye(this,p,"f")=="function"&&(ye(this,p,"f").call(this),je(this,p,void 0,"f"))}};p=new WeakMap,$=S=Fe([T],$),e.Disposable=$;let g=M=class{constructor(B,ee){if(B<0)throw(0,I.illegalArgument)("line must be non-negative");if(ee<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=B,this._character=ee}static Min(...B){if(B.length===0)throw new TypeError;let ee=B[0];for(let we=1;we<B.length;we++){const He=B[we];He.isBefore(ee)&&(ee=He)}return ee}static Max(...B){if(B.length===0)throw new TypeError;let ee=B[0];for(let we=1;we<B.length;we++){const He=B[we];He.isAfter(ee)&&(ee=He)}return ee}static isPosition(B){if(!B)return!1;if(B instanceof M)return!0;let{line:ee,character:we}=B;return typeof ee=="number"&&typeof we=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,ee=0){if(B===null||ee===null)throw(0,I.illegalArgument)();let we;return typeof B=="undefined"?we=0:typeof B=="number"?we=B:(we=typeof B.lineDelta=="number"?B.lineDelta:0,ee=typeof B.characterDelta=="number"?B.characterDelta:0),we===0&&ee===0?this:new M(this.line+we,this.character+ee)}with(B,ee=this.character){if(B===null||ee===null)throw(0,I.illegalArgument)();let we;return typeof B=="undefined"?we=this.line:typeof B=="number"?we=B:(we=typeof B.line=="number"?B.line:this.line,ee=typeof B.character=="number"?B.character:this.character),we===this.line&&ee===this.character?this:new M(we,ee)}toJSON(){return{line:this.line,character:this.character}}};g=M=Fe([T],g),e.Position=g;let U=u=class{constructor(B,ee,we,He){let qe,Je;if(typeof B=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"?(qe=new g(B,ee),Je=new g(we,He)):B instanceof g&&ee instanceof g&&(qe=B,Je=ee),!qe||!Je)throw new Error("Invalid arguments");qe.isBefore(Je)?(this._start=qe,this._end=Je):(this._start=Je,this._end=qe)}static isRange(B){return B instanceof u?!0:B?g.isPosition(B.start)&&g.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof u?this.contains(B._start)&&this.contains(B._end):B instanceof g?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const ee=g.Max(B.start,this._start),we=g.Min(B.end,this._end);if(!ee.isAfter(we))return new u(ee,we)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ee=g.Min(B.start,this._start),we=g.Max(B.end,this.end);return new u(ee,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,ee=this.end){if(B===null||ee===null)throw(0,I.illegalArgument)();let we;return B?g.isPosition(B)?we=B:(we=B.start||this.start,ee=B.end||this.end):we=this.start,we.isEqual(this._start)&&ee.isEqual(this.end)?this:new u(we,ee)}toJSON(){return[this.start,this.end]}};U=u=Fe([T],U),e.Range=U;let z=f=class extends U{constructor(B,ee,we,He){let qe,Je;if(typeof B=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"?(qe=new g(B,ee),Je=new g(we,He)):B instanceof g&&ee instanceof g&&(qe=B,Je=ee),!qe||!Je)throw new Error("Invalid arguments");super(qe,Je);this._anchor=qe,this._active=Je}static isSelection(B){return B instanceof f?!0:B?U.isRange(B)&&g.isPosition(B.anchor)&&g.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=f=Fe([T],z),e.Selection=z;class q{constructor(B,ee,we){if(typeof B!="string"||B.length===0)throw(0,I.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,I.illegalArgument)("port");if(typeof we!="undefined"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,I.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(ee),this.connectionToken=we}}e.ResolvedAuthority=q;class j extends Error{constructor(B,ee=s.RemoteAuthorityResolverErrorCode.Unknown,we){super(B);this._message=B,this._code=ee,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,j.prototype)}static NotAvailable(B,ee){return new j(B,s.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(B){return new j(B,s.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=j;var J;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(J=e.EndOfLine||(e.EndOfLine={}));var W;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=w=class{constructor(B,ee){this._range=B,this._newText=ee}static isTextEdit(B){return B instanceof w?!0:B?U.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ee){return new w(B,ee)}static insert(B,ee){return w.replace(new U(B,B),ee)}static delete(B){return w.replace(B,"")}static setEndOfLine(B){const ee=new w(new U(new g(0,0),new g(0,0)),"");return ee.newEol=B,ee}get range(){return this._range}set range(B){if(B&&!U.isRange(B))throw(0,I.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,I.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,I.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ie=w=Fe([T],ie),e.TextEdit=ie;var le;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(le=e.FileEditType||(e.FileEditType={}));let te=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,ee,we,He){this._edits.push({_type:1,from:B,to:ee,options:we,metadata:He})}createFile(B,ee,we){this._edits.push({_type:1,from:void 0,to:B,options:ee,metadata:we})}deleteFile(B,ee,we){this._edits.push({_type:1,from:B,to:void 0,options:ee,metadata:we})}replaceNotebookMetadata(B,ee,we){this._edits.push({_type:3,metadata:we,uri:B,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(B,ee,we,He,qe){let Je,Ze,wt=[],Pt;if(Qt.isNotebookRange(ee)&&Ht.isNotebookCellDataArray(we)&&!Ht.isNotebookCellDataArray(He)?(Je=ee.start,Ze=ee.end,wt=we,Pt=He):typeof ee=="number"&&typeof we=="number"&&Ht.isNotebookCellDataArray(He)&&(Je=ee,Ze=we,wt=He,Pt=qe),Je===void 0||Ze===void 0)throw new Error("Invalid arguments");(Je!==Ze||wt.length>0)&&this._edits.push({_type:5,uri:B,index:Je,count:Ze-Je,cells:wt,metadata:Pt})}replaceNotebookCellMetadata(B,ee,we,He){this._edits.push({_type:3,metadata:He,uri:B,edit:{editType:8,index:ee,metadata:we}})}replace(B,ee,we,He){this._edits.push({_type:2,uri:B,edit:new ie(ee,we),metadata:He})}insert(B,ee,we,He){this.replace(B,new U(ee,ee),we,He)}delete(B,ee,we){this.replace(B,ee,"",we)}has(B){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===B.toString())}set(B,ee){if(ee)for(const we of ee)we&&this._edits.push({_type:2,uri:B,edit:we});else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];He._type===2&&He.uri.toString()===B.toString()&&(this._edits[we]=void 0)}(0,r.coalesceInPlace)(this._edits)}}get(B){const ee=[];for(let we of this._edits)we._type===2&&we.uri.toString()===B.toString()&&ee.push(we.edit);return ee}entries(){const B=new x.ResourceMap;for(let ee of this._edits)if(ee._type===2){let we=B.get(ee.uri);we||(we=[ee.uri,[]],B.set(ee.uri,we)),we[1].push(ee.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};te=Fe([T],te),e.WorkspaceEdit=te;let ue=a=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof a?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=a._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ee=this._tabstop++){if(typeof B=="function"){const we=new a;we._tabstop=this._tabstop,B(we),this._tabstop=we._tabstop,B=we.value}else B=a._escape(B);return this.value+="${",this.value+=ee,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ee=this._tabstop++){const we=B.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(B,ee){if(typeof ee=="function"){const we=new a;we._tabstop=this._tabstop,ee(we),this._tabstop=we._tabstop,ee=we.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};ue=a=Fe([T],ue),e.SnippetString=ue;var he;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(he=e.DiagnosticTag||(e.DiagnosticTag={}));var De;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(De=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=P=class{constructor(B,ee){if(this.uri=B,ee)if(ee instanceof U)this.range=ee;else if(ee instanceof g)this.range=new U(ee,ee);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof P?!0:B?U.isRange(B.range)&&R.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};fe=P=Fe([T],fe),e.Location=fe;let ne=class{constructor(B,ee){this.location=B,this.message=ee}static is(B){return B?typeof B.message=="string"&&B.location&&U.isRange(B.location.range)&&R.URI.isUri(B.location.uri):!1}static isEqual(B,ee){return B===ee?!0:!B||!ee?!1:B.message===ee.message&&B.location.range.isEqual(ee.location.range)&&B.location.uri.toString()===ee.location.uri.toString()}};ne=Fe([T],ne),e.DiagnosticRelatedInformation=ne;let me=class{constructor(B,ee,we=De.Error){if(!U.isRange(B))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=B,this.message=ee,this.severity=we}toJSON(){return{severity:De[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ee){return B===ee?!0:!B||!ee?!1:B.message===ee.message&&B.severity===ee.severity&&B.code===ee.code&&B.severity===ee.severity&&B.source===ee.source&&B.range.isEqual(ee.range)&&(0,r.equals)(B.tags,ee.tags)&&(0,r.equals)(B.relatedInformation,ee.relatedInformation,ne.isEqual)}};me=Fe([T],me),e.Diagnostic=me;let Ie=class{constructor(B,ee){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=ee}};Ie=Fe([T],Ie),e.Hover=Ie;var Ae;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ue=class{constructor(B,ee=Ae.Text){this.range=B,this.kind=ee}toJSON(){return{range:this.range,kind:Ae[this.kind]}}};Ue=Fe([T],Ue),e.DocumentHighlight=Ue;var Ge;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(Ge=e.SymbolKind||(e.SymbolKind={}));var ge;(function(V){V[V.Deprecated=1]="Deprecated"})(ge=e.SymbolTag||(e.SymbolTag={}));let de=c=class{constructor(B,ee,we,He,qe){this.name=B,this.kind=ee,this.containerName=qe,typeof we=="string"&&(this.containerName=we),He instanceof fe?this.location=He:we instanceof U&&(this.location=new fe(He,we)),c.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ge[this.kind],location:this.location,containerName:this.containerName}}};de=c=Fe([T],de),e.SymbolInformation=de;let L=t=class{constructor(B,ee,we,He,qe){this.name=B,this.detail=ee,this.kind=we,this.range=He,this.selectionRange=qe,this.children=[],t.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(t.validate)}};L=t=Fe([T],L),e.DocumentSymbol=L;var F;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(F=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let D=class{constructor(B,ee){this.title=B,this.kind=ee}};D=Fe([T],D),e.CodeAction=D;let O=h=class{constructor(B){this.value=B}append(B){return new h(this.value?this.value+h.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+h.sep)}};O.sep=".",O=h=Fe([T],O),e.CodeActionKind=O,O.Empty=new O(""),O.QuickFix=O.Empty.append("quickfix"),O.Refactor=O.Empty.append("refactor"),O.RefactorExtract=O.Refactor.append("extract"),O.RefactorInline=O.Refactor.append("inline"),O.RefactorRewrite=O.Refactor.append("rewrite"),O.Source=O.Empty.append("source"),O.SourceOrganizeImports=O.Source.append("organizeImports"),O.SourceFixAll=O.Source.append("fixAll");let H=class{constructor(B,ee){if(this.range=B,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};H=Fe([T],H),e.SelectionRange=H;class X{constructor(B,ee,we,He,qe,Je){this.kind=B,this.name=ee,this.detail=we,this.uri=He,this.range=qe,this.selectionRange=Je}}e.CallHierarchyItem=X;class re{constructor(B,ee){this.fromRanges=ee,this.from=B}}e.CallHierarchyIncomingCall=re;class pe{constructor(B,ee){this.fromRanges=ee,this.to=B}}e.CallHierarchyOutgoingCall=pe;var Ce;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Ce=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(B,ee){this.range=B,this.command=ee}get isResolved(){return!!this.command}};Me=Fe([T],Me),e.CodeLens=Me;let Le=o=class{constructor(B,ee=!1){n.set(this,void 0),je(this,n,new _.MarkdownString(B,{supportThemeIcons:ee}),"f")}static isMarkdownString(B){return B instanceof o?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return ye(this,n,"f").value}set value(B){ye(this,n,"f").value=B}get isTrusted(){return ye(this,n,"f").isTrusted}set isTrusted(B){ye(this,n,"f").isTrusted=B}get supportThemeIcons(){return ye(this,n,"f").supportThemeIcons}set supportThemeIcons(B){ye(this,n,"f").supportThemeIcons=B}get supportHtml(){return ye(this,n,"f").supportHtml}set supportHtml(B){ye(this,n,"f").supportHtml=B}get baseUri(){return ye(this,n,"f").baseUri}set baseUri(B){ye(this,n,"f").baseUri=B}appendText(B){return ye(this,n,"f").appendText(B),this}appendMarkdown(B){return ye(this,n,"f").appendMarkdown(B),this}appendCodeblock(B,ee){return ye(this,n,"f").appendCodeblock(ee??"",B),this}};n=new WeakMap,Le=o=Fe([T],Le),e.MarkdownString=Le;let ze=class{constructor(B,ee){this.label=B,this.documentation=ee}};ze=Fe([T],ze),e.ParameterInformation=ze;let xe=class{constructor(B,ee){this.label=B,this.documentation=ee,this.parameters=[]}};xe=Fe([T],xe),e.SignatureInformation=xe;let Oe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Oe=Fe([T],Oe),e.SignatureHelp=Oe;var Xe;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let ke=class{constructor(B){this.value=B}};ke=Fe([T],ke),e.InlayHintLabelPart=ke;let tt=class{constructor(B,ee,we){this.position=B,this.label=ee,this.kind=we}};tt=Fe([T],tt),e.InlayHint=tt;var G;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(G=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(V){V[V.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let Re=class{constructor(B,ee){this.label=B,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Re=Fe([T],Re),e.CompletionItem=Re;let $e=class{constructor(B=[],ee=!1){this.items=B,this.isIncomplete=ee}};$e=Fe([T],$e),e.CompletionList=$e;let Ke=class{constructor(B,ee,we){this.text=B,this.range=ee,this.command=we}};Ke=Fe([T],Ke),e.InlineSuggestion=Ke;let Qe=class{constructor(B){this.items=B}};Qe=Fe([T],Qe),e.InlineSuggestions=Qe;var ht;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ht=e.ViewColumn||(e.ViewColumn={}));var _t;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(_t=e.StatusBarAlignment||(e.StatusBarAlignment={}));var yt;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(yt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Tt;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ve;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function B(ee){switch(ee){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=B}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ot=class{constructor(B,ee){if(ee&&!R.URI.isUri(ee))throw(0,I.illegalArgument)("target");if(!U.isRange(B)||B.isEmpty)throw(0,I.illegalArgument)("range");this.range=B,this.target=ee}};ot=Fe([T],ot),e.DocumentLink=ot;let At=class{constructor(B,ee,we,He){this.red=B,this.green=ee,this.blue=we,this.alpha=He}};At=Fe([T],At),e.Color=At;let Dt=class{constructor(B,ee){if(ee&&!(ee instanceof At))throw(0,I.illegalArgument)("color");if(!U.isRange(B)||B.isEmpty)throw(0,I.illegalArgument)("range");this.range=B,this.color=ee}};Dt=Fe([T],Dt),e.ColorInformation=Dt;let Ct=class{constructor(B){if(!B||typeof B!="string")throw(0,I.illegalArgument)("label");this.label=B}};Ct=Fe([T],Ct),e.ColorPresentation=Ct;var lt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(lt=e.ColorFormat||(e.ColorFormat={}));var Ot;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Lt{constructor(B,ee,we){if(this.startIndex=B,this.length=ee,this.tooltip=we,typeof B!="number"||B<0)throw(0,I.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,I.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,I.illegalArgument)("tooltip")}}e.TerminalLink=Lt;var Ft;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class se{constructor(B){this.options=B,typeof B!="object"&&(0,I.illegalArgument)("options")}}e.TerminalProfile=se;var _e;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var ae;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(ae=e.TaskPanelKind||(e.TaskPanelKind={}));let K=l=class{constructor(B,ee){if(this.label=ee,typeof B!="string"||typeof ee!="string")throw(0,I.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};K.Clean=new l("clean","Clean"),K.Build=new l("build","Build"),K.Rebuild=new l("rebuild","Rebuild"),K.Test=new l("test","Test"),K=l=Fe([T],K),e.TaskGroup=K;function be(V){let B="";for(let ee=0;ee<V.length;ee++)B+=V[ee].replace(/,/g,",,")+",";return B}let Te=class{constructor(B,ee,we){if(typeof B!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=B,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=we):this._options=ee)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,I.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)B.push(ee);return be(B)}};Te=Fe([T],Te),e.ProcessExecution=Te;let Be=class{constructor(B,ee,we){if(this._args=[],Array.isArray(ee)){if(!B)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,I.illegalArgument)("command");this._command=B,this._args=ee,this._options=we}else{if(typeof B!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=B,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,I.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)B.push(typeof ee=="string"?ee:ee.value);return be(B)}};Be=Fe([T],Be),e.ShellExecution=Be;var We;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(We=e.ShellQuoting||(e.ShellQuoting={}));var st;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(st=e.TaskScope||(e.TaskScope={}));class ft{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=ft;let Et=E=class{constructor(B,ee,we,He,qe,Je){this.__deprecated=!1,this._definition=this.definition=B;let Ze;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=we,this.execution=He,Ze=qe,this.__deprecated=!0):ee===st.Global||ee===st.Workspace?(this.target=ee,this._name=this.name=we,this._source=this.source=He,this.execution=qe,Ze=Je):(this.target=ee,this._name=this.name=we,this._source=this.source=He,this.execution=qe,Ze=Je),typeof Ze=="string"?(this._problemMatchers=[Ze],this._hasDefinedMatchers=!0):Array.isArray(Ze)?(this._problemMatchers=Ze,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Te?this._definition={type:E.ProcessType,id:this._execution.computeId()}:this._execution instanceof Be?this._definition={type:E.ShellType,id:this._execution.computeId()}:this._execution instanceof ft?this._definition={type:E.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:E.EmptyType,id:(0,N.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const ee=this._definition.type;(E.EmptyType===ee||E.ProcessType===ee||E.ShellType===ee||E.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};Et.ExtensionCallbackType="customExecution",Et.ProcessType="process",Et.ShellType="shell",Et.EmptyType="$empty",Et=E=Fe([T],Et),e.Task=Et;var vt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let it=class{constructor(B,ee=at.None){this.collapsibleState=ee,R.URI.isUri(B)?this.resourceUri=B:this.label=B}};it=Fe([T],it),e.TreeItem=it;var at;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(at=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let mt=class{constructor(B){this.value=B}async asString(){return JSON.stringify(this.value)}};mt=Fe([T],mt),e.TreeDataTransferItem=mt;let Mt=class{constructor(){this._items=new Map}get(B){return this._items.get(B)}set(B,ee){this._items.set(B,ee)}forEach(B){this._items.forEach(B)}};Mt=Fe([T],Mt),e.TreeDataTransfer=Mt;let ct=class{constructor(B,ee){this.id=B,this.color=ee}};ct=Fe([T],ct),e.ThemeIcon=ct,ct.File=new ct("file"),ct.Folder=new ct("folder");let It=class{constructor(B){this.id=B}};It=Fe([T],It),e.ThemeColor=It;var Ut;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let bt=class{constructor(B,ee){if(typeof B!="string"&&(!B||!R.URI.isUri(B)&&!R.URI.isUri(B.uri)))throw(0,I.illegalArgument)("base");if(typeof ee!="string")throw(0,I.illegalArgument)("pattern");typeof B=="string"?this.baseUri=R.URI.file(B):R.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=ee}get base(){return this._base}set base(B){this._base=B,this._baseUri=R.URI.file(B)}get baseUri(){return this._baseUri}set baseUri(B){this._baseUri=B,this._base=B.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};bt=Fe([T],bt),e.RelativePattern=bt;let Bt=class{constructor(B,ee,we,He){this.enabled=typeof B=="boolean"?B:!0,typeof ee=="string"&&(this.condition=ee),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,N.generateUuid)()),this._id}};Bt=Fe([T],Bt),e.Breakpoint=Bt;let Wt=class extends Bt{constructor(B,ee,we,He,qe){super(ee,we,He,qe);if(B===null)throw(0,I.illegalArgument)("location");this.location=B}};Wt=Fe([T],Wt),e.SourceBreakpoint=Wt;let dt=class extends Bt{constructor(B,ee,we,He,qe){super(ee,we,He,qe);this.functionName=B}};dt=Fe([T],dt),e.FunctionBreakpoint=dt;let ei=class extends Bt{constructor(B,ee,we,He,qe,Je,Ze){super(He,qe,Je,Ze);if(!ee)throw(0,I.illegalArgument)("dataId");this.label=B,this.dataId=ee,this.canPersist=we}};ei=Fe([T],ei),e.DataBreakpoint=ei;let Yt=class{constructor(B,ee,we){this.command=B,this.args=ee||[],this.options=we}};Yt=Fe([T],Yt),e.DebugAdapterExecutable=Yt;let ti=class{constructor(B,ee){this.port=B,this.host=ee}};ti=Fe([T],ti),e.DebugAdapterServer=ti;let oi=class{constructor(B){this.path=B}};oi=Fe([T],oi),e.DebugAdapterNamedPipeServer=oi;let kt=class{constructor(B){this.implementation=B}};kt=Fe([T],kt),e.DebugAdapterInlineImplementation=kt;let ii=class{constructor(B,ee){this.range=B,this.expression=ee}};ii=Fe([T],ii),e.EvaluatableExpression=ii;var _i;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(_i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Gt=class{constructor(B,ee){this.range=B,this.text=ee}};Gt=Fe([T],Gt),e.InlineValueText=Gt;let Xt=class{constructor(B,ee,we=!0){this.range=B,this.variableName=ee,this.caseSensitiveLookup=we}};Xt=Fe([T],Xt),e.InlineValueVariableLookup=Xt;let rt=class{constructor(B,ee){this.range=B,this.expression=ee}};rt=Fe([T],rt),e.InlineValueEvaluatableExpression=rt;let ai=class{constructor(B,ee){this.frameId=B,this.stoppedLocation=ee}};ai=Fe([T],ai),e.InlineValueContext=ai;var Vt;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let jt=m=class extends Error{constructor(B,ee=b.FileSystemProviderErrorCode.Unknown,we){super(R.URI.isUri(B)?B.toString(!0):B);this.code=we?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}static FileExists(B){return new m(B,b.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(B){return new m(B,b.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(B){return new m(B,b.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(B){return new m(B,b.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(B){return new m(B,b.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(B){return new m(B,b.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}};jt=m=Fe([T],jt),e.FileSystemError=jt;let ni=class{constructor(B,ee,we){this.start=B,this.end=ee,this.kind=we}};ni=Fe([T],ni),e.FoldingRange=ni;var Si;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Si=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gi;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(gi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var yi;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(yi=e.CommentMode||(e.CommentMode={}));class pi{constructor(B,ee=[]){this.tokenTypes=B,this.tokenModifiers=ee}}e.SemanticTokensLegend=pi;function ri(V){return typeof V=="undefined"||(0,C.isStringArray)(V)}class li{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let ee=0,we=B.tokenTypes.length;ee<we;ee++)this._tokenTypeStrToInt.set(B.tokenTypes[ee],ee);for(let ee=0,we=B.tokenModifiers.length;ee<we;ee++)this._tokenModifierStrToInt.set(B.tokenModifiers[ee],ee)}}push(B,ee,we,He,qe){if(typeof B=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof qe=="number"||typeof qe=="undefined"))return typeof qe=="undefined"&&(qe=0),this._pushEncoded(B,ee,we,He,qe);if(U.isRange(B)&&typeof ee=="string"&&ri(we))return this._push(B,ee,we);throw(0,I.illegalArgument)()}_push(B,ee,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const He=B.start.line,qe=B.start.character,Je=B.end.character-B.start.character,Ze=this._tokenTypeStrToInt.get(ee);let wt=0;if(we)for(const Pt of we){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Pt);wt|=1<<xt>>>0}this._pushEncoded(He,qe,Je,Ze,wt)}_pushEncoded(B,ee,we,He,qe){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const wt=this._data.length/5|0;let Pt=0,xt=0;for(let zt=0;zt<wt;zt++){let qt=this._data[5*zt],fi=this._data[5*zt+1];qt===0?(qt=Pt,fi+=xt):qt+=Pt,this._data[5*zt]=qt,this._data[5*zt+1]=fi,Pt=qt,xt=fi}}let Je=B,Ze=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Je-=this._prevLine,Je===0&&(Ze-=this._prevChar)),this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=qe,this._prevLine=B,this._prevChar=ee}static _sortAndDeltaEncode(B){let ee=[];const we=B.length/5|0;for(let Ze=0;Ze<we;Ze++)ee[Ze]=Ze;ee.sort((Ze,wt)=>{const Pt=B[5*Ze],xt=B[5*wt];if(Pt===xt){const zt=B[5*Ze+1],qt=B[5*wt+1];return zt-qt}return Pt-xt});const He=new Uint32Array(B.length);let qe=0,Je=0;for(let Ze=0;Ze<we;Ze++){const wt=5*ee[Ze],Pt=B[wt+0],xt=B[wt+1],zt=B[wt+2],qt=B[wt+3],fi=B[wt+4],zi=Pt-qe,Yi=zi===0?xt-Je:xt,mi=5*Ze;He[mi+0]=zi,He[mi+1]=Yi,He[mi+2]=zt,He[mi+3]=qt,He[mi+4]=fi,qe=Pt,Je=xt}return He}build(B){return this._dataIsSortedAndDeltaEncoded?new Jt(new Uint32Array(this._data),B):new Jt(li._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=li;class Jt{constructor(B,ee){this.resultId=ee,this.data=B}}e.SemanticTokens=Jt;class ci{constructor(B,ee,we){this.start=B,this.deleteCount=ee,this.data=we}}e.SemanticTokensEdit=ci;class Di{constructor(B,ee){this.resultId=ee,this.edits=B}}e.SemanticTokensEdits=Di;var Ci;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Ci=e.DebugConsoleMode||(e.DebugConsoleMode={}));let $t=class{constructor(){}};$t.Back={iconPath:new ct("arrow-left")},$t=Fe([T],$t),e.QuickInputButtons=$t;var Ii;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Ti{constructor(B,ee,we){this.badge=B,this.tooltip=ee,this.color=we}static validate(B){if(B.badge){let ee=(0,A.nextCharLength)(B.badge,0);if(ee<B.badge.length&&(ee+=(0,A.nextCharLength)(B.badge,ee)),B.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ti;let ui=class{constructor(B){this.kind=B}};ui=Fe([T],ui),e.ColorTheme=ui;var di;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(di=e.ColorThemeKind||(e.ColorThemeKind={}));class Qt{constructor(B,ee){if(B<0)throw(0,I.illegalArgument)("start must be positive");if(ee<0)throw(0,I.illegalArgument)("end must be positive");B<=ee?(this._start=B,this._end=ee):(this._start=ee,this._end=B)}static isNotebookRange(B){return B instanceof Qt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let ee=this._start,we=this._end;return B.start!==void 0&&(ee=B.start),B.end!==void 0&&(we=B.end),ee===this._start&&we===this._end?this:new Qt(ee,we)}}e.NotebookRange=Qt;class Ht{constructor(B,ee,we,He,qe,Je,Ze){this.kind=B,this.value=ee,this.languageId=we,this.mime=He,this.outputs=qe??[],this.metadata=Je,this.executionSummary=Ze,Ht.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ee=>Ht.isNotebookCellData(ee))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Ht;class Pe{constructor(B){this.cells=B}}e.NotebookData=Pe;class Rt{constructor(B,ee){this.data=B,this.mime=ee;const we=(0,y.normalizeMimeType)(ee,!0);if(!we)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}static isNotebookCellOutputItem(B){return B instanceof Rt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const ee={name:B.name,message:B.message,stack:B.stack};return Rt.json(ee,"application/vnd.code.notebook.error")}static stdout(B){return Rt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Rt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,ee="application/octet-stream"){return new Rt(B,ee)}static text(B,ee=y.Mimes.text){const we=ye(Rt,i,"f",d).encode(String(B));return new Rt(we,ee)}static json(B,ee="application/json"){const we=JSON.stringify(B,void 0,"	");return Rt.text(we,ee)}}e.NotebookCellOutputItem=Rt,i=Rt,d={value:new TextEncoder};class Zt{constructor(B,ee,we){this.items=Zt.ensureUniqueMimeTypes(B,!0),typeof ee=="string"?(this.id=ee,this.metadata=we):(this.id=(0,N.generateUuid)(),this.metadata=ee??we)}static isNotebookCellOutput(B){return B instanceof Zt?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&(0,C.isArray)(B.items)}static ensureUniqueMimeTypes(B,ee=!1){const we=new Set,He=new Set;for(let qe=0;qe<B.length;qe++){const Je=B[qe],Ze=(0,y.normalizeMimeType)(Je.mime);if(!we.has(Ze)){we.add(Ze);continue}He.add(qe),ee&&console.warn(`DUPLICATED mime type '${Je.mime}' will be dropped`)}return He.size===0?B:B.filter((qe,Je)=>!He.has(Je))}}e.NotebookCellOutput=Zt;var ut;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(ut=e.NotebookCellKind||(e.NotebookCellKind={}));var Pi;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Pi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ei{constructor(B,ee){this.text=B,this.alignment=ee}}e.NotebookCellStatusBarItem=Ei;var Ri;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Ri=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Oi{constructor(B,ee=[]){this.uri=B,this.provides=(0,r.asArray)(ee)}}e.NotebookRendererScript=Oi;let hi=class{constructor(B,ee){this.label=B,this.timestamp=ee}};hi=Fe([T],hi),e.TimelineItem=hi;var Fi;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var bi;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(bi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Ni{constructor(B,ee){this.ranges=B,this.wordPattern=ee}}e.LinkedEditingRanges=Ni;class Li{constructor(B,ee){this._port=B,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Li;var Ui;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Ui=e.TestResultState||(e.TestResultState={}));var Bi;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(Bi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Z=class{constructor(B=void 0,ee=void 0,we=void 0){this.include=B,this.exclude=ee,this.profile=we}};Z=Fe([T],Z),e.TestRunRequest=Z;let oe=v=class{constructor(B){this.message=B}static diff(B,ee,we){const He=new v(B);return He.expectedOutput=ee,He.actualOutput=we,He}};oe=v=Fe([T],oe),e.TestMessage=oe;let Se=class{constructor(B){this.id=B}};Se=Fe([T],Se),e.TestTag=Se;let Ye=class{constructor(B,ee){this.covered=B,this.total=ee}};Ye=Fe([T],Ye),e.CoveredCount=Ye;let gt=k=class{constructor(B,ee,we,He){this.uri=B,this.statementCoverage=ee,this.branchCoverage=we,this.functionCoverage=He}static fromDetails(B,ee){const we=new Ye(0,0),He=new Ye(0,0),qe=new Ye(0,0);for(const Ze of ee)if("branches"in Ze){we.total+=1,we.covered+=Ze.executionCount>0?1:0;for(const wt of Ze.branches)He.total+=1,He.covered+=wt.executionCount>0?1:0}else qe.total+=1,qe.covered+=Ze.executionCount>0?1:0;const Je=new k(B,we,He.total>0?He:void 0,qe.total>0?qe:void 0);return Je.detailedCoverage=ee,Je}};gt=k=Fe([T],gt),e.FileCoverage=gt;let St=class{constructor(B,ee,we=[]){this.executionCount=B,this.location=ee,this.branches=we}};St=Fe([T],St),e.StatementCoverage=St;let xi=class{constructor(B,ee){this.executionCount=B,this.location=ee}};xi=Fe([T],xi),e.BranchCoverage=xi;let $i=class{constructor(B,ee){this.executionCount=B,this.location=ee}};$i=Fe([T],$i),e.FunctionCoverage=$i;var Ki;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(B,ee,we,He,qe,Je){this.kind=B,this.name=ee,this.detail=we,this.uri=He,this.range=qe,this.selectionRange=Je}}e.TypeHierarchyItem=Qi}),define(ve[83],Ee([1,0,42,9,10,225,116,7,16]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function N(n,i){i?R.set(n,i):R.delete(n)}e.setWordDefinitionFor=N;function b(n){return R.get(n)}e.getWordDefinitionFor=b;class s extends x.MirrorTextModel{constructor(i,d,S,M,u,f,w,a){super(d,S,M,u);this._proxy=i,this._languageId=f,this._isDirty=w,this._notebook=a,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(i){return(0,C.equals)(this._lines,i)}get document(){if(!this._document){const i=this;this._document={get uri(){return i._uri},get fileName(){return i._uri.fsPath},get isUntitled(){return i._uri.scheme===I.Schemas.untitled},get languageId(){return i._languageId},get version(){return i._versionId},get isClosed(){return i._isDisposed},get isDirty(){return i._isDirty},get notebook(){return i._notebook},save(){return i._save()},getText(d){return d?i._getTextInRange(d):i.getText()},get eol(){return i._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return i._lines.length},lineAt(d){return i._lineAt(d)},offsetAt(d){return i._offsetAt(d)},positionAt(d){return i._positionAt(d)},validateRange(d){return i._validateRange(d)},validatePosition(d){return i._validatePosition(d)},getWordRangeAtPosition(d,S){return i._getWordRangeAtPosition(d,S)}}}return Object.freeze(this._document)}_acceptLanguageId(i){(0,r.ok)(!this._isDisposed),this._languageId=i}_acceptIsDirty(i){(0,r.ok)(!this._isDisposed),this._isDirty=i}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(i){const d=this._validateRange(i);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const S=this._eol,M=d.start.line,u=d.end.line,f=[];f.push(this._lines[M].substring(d.start.character));for(let w=M+1;w<u;w++)f.push(this._lines[w]);return f.push(this._lines[u].substring(0,d.end.character)),f.join(S)}_lineAt(i){let d;if(i instanceof A.Position?d=i.line:typeof i=="number"&&(d=i),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new p(d,this._lines[d],d===this._lines.length-1)}_offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.line-1)+i.character}_positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(i),S=this._lines[d.index].length;return new A.Position(d.index,Math.min(d.remainder,S))}_validateRange(i){if(!(i instanceof A.Range))throw new Error("Invalid argument");const d=this._validatePosition(i.start),S=this._validatePosition(i.end);return d===i.start&&S===i.end?i:new A.Range(d.line,d.character,S.line,S.character)}_validatePosition(i){if(!(i instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return i.with(0,0);let{line:d,character:S}=i,M=!1;if(d<0)d=0,S=0,M=!0;else if(d>=this._lines.length)d=this._lines.length-1,S=this._lines[d].length,M=!0;else{const u=this._lines[d].length;S<0?(S=0,M=!0):S>u&&(S=u,M=!0)}return M?new A.Position(d,S):i}_getWordRangeAtPosition(i,d){const S=this._validatePosition(i);if(!d)d=b(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const M=(0,y.getWordAtText)(S.character+1,(0,y.ensureValidWordDefinition)(d),this._lines[S.line],0);if(M)return new A.Range(S.line,M.startColumn-1,S.line,M.endColumn-1)}}e.ExtHostDocumentData=s;class p{constructor(i,d,S){this._line=i,this._text=d,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(ve[151],Ee([1,0,7,5,226,6,73,22,2,36]),function(Y,e,r,I,_,x,y,A,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class N{constructor(s,p,n,i){this._notebook=n,this._selector=i,this._disposables=new x.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(S=>{const M=this._cellUris.get(S.document.uri);M!==void 0&&(this._cellLengths.setValue(M,this._cells[M].document.getText().length+1),this._cellLines.setValue(M,this._cells[M].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const d=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(s.onDidChangeNotebookCells(S=>d(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const s=[],p=[];for(const n of this._notebook.getCells())n.kind===r.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,n.document.uri,n.document.languageId,!0))&&(this._cellUris.set(n.document.uri,this._cells.length),this._cells.push(n),s.push(n.document.getText().length+1),p.push(n.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(s)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(s){if(!s){let M="";for(const u of this._cells)M+=u.document.getText()+`
`;return M=M.slice(0,-1),M}if(s.isEmpty)return"";const p=this.locationAt(s.start),n=this.locationAt(s.end),i=this._cellUris.get(p.uri),d=this._cellUris.get(n.uri);if(i===void 0||d===void 0)return"";if(i===d)return this._cells[i].document.getText(new r.Range(p.range.start,n.range.end));const S=[this._cells[i].document.getText(new r.Range(p.range.start,new r.Position(this._cells[i].document.lineCount,0)))];for(let M=i+1;M<d;M++)S.push(this._cells[M].document.getText());return S.push(this._cells[d].document.getText(new r.Range(new r.Position(0,0),n.range.end))),S.join(`
`)}offsetAt(s){const p=this._cellLines.getIndexOf(s.line),n=this._cellLengths.getPrefixSum(p.index-1),i=this._cells[p.index].document.offsetAt(s.with(p.remainder));return n+i}positionAt(s){if(typeof s=="number"){const n=this._cellLengths.getIndexOf(s),i=this._cellLines.getPrefixSum(n.index-1);return this._cells[n.index].document.positionAt(n.remainder).translate(i)}const p=this._cellUris.get(s.uri);if(p!==void 0){const n=this._cellLines.getPrefixSum(p-1);return new r.Position(n+s.range.start.line,s.range.start.character)}return new r.Position(0,0)}locationAt(s){r.Range.isRange(s)||(s=new r.Range(s,s));const p=this._cellLines.getIndexOf(s.start.line);let n=p;s.isEmpty||(n=this._cellLines.getIndexOf(s.end.line));const i=new r.Position(p.remainder,s.start.character),d=new r.Position(n.remainder,s.end.character),S=new r.Range(i,d),M=this._cells[p.index];return new r.Location(M.document.uri,M.document.validateRange(S))}contains(s){return this._cellUris.has(s)}validateRange(s){const p=this.validatePosition(s.start),n=this.validatePosition(s.end);return s.with(p,n)}validatePosition(s){const p=this._cellLines.getIndexOf(s.line),n=new r.Position(p.remainder,s.character),i=this._cells[p.index].document.validatePosition(n),d=this._cellLines.getPrefixSum(p.index-1);return new r.Position(d+i.line,i.character)}}e.ExtHostNotebookConcatDocument=N}),define(ve[152],Ee([1,0,7,14,5]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let x=class{constructor(A){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let C=A==="light"?r.ColorThemeKind.Light:A==="dark"?r.ColorThemeKind.Dark:r.ColorThemeKind.HighContrast;this._actual=new r.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};x=Fe([Ne(0,I.IExtHostRpcService)],x),e.ExtHostTheming=x}),define(ve[59],Ee([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class I{constructor(x){x?(this.transformIncoming=x.transformIncoming.bind(x),this.transformOutgoing=x.transformOutgoing.bind(x),this.transformOutgoingURI=x.transformOutgoingURI.bind(x),this.transformOutgoingScheme=x.transformOutgoingScheme.bind(x)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(ve[153],Ee([1,0,21]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(C){let R=this.buffers.indexOf(C);return R<0&&(R=this.buffers.length,this.buffers.push(C)),R}}function _(A,C){if(C.serializeBuffersForPostMessage){const R=new I,N=(p,n)=>{if(n instanceof ArrayBuffer){const i=R.add(n);return{$$vscode_array_buffer_reference$$:!0,index:i}}else if(ArrayBuffer.isView(n)){const i=x(n);if(i){const d=R.add(n.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:i,byteLength:n.byteLength,byteOffset:n.byteOffset}}}}return n},b=JSON.stringify(A,N),s=R.buffers.map(p=>{const n=new Uint8Array(p);return r.VSBuffer.wrap(n)});return{message:b,buffers:s}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=_;function x(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(A,C){const R=C.map(s=>{const p=new ArrayBuffer(s.byteLength);return new Uint8Array(p).set(s.buffer),p}),N=C.length?(s,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const n=p,{index:i}=n,d=R[i];if(n.view)switch(n.view.type){case 1:return new Int8Array(d,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return p}:void 0;return{message:JSON.parse(A,N),arrayBuffers:R}}e.deserializeWebviewMessage=y}),define(ve[154],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var r;(function(I){function _(y){const A=new Map;return y.types.forEach((C,R)=>{A.set(C,{asString:async()=>y.items[R].asString,value:void 0})}),A}I.toITreeDataTransfer=_;async function x(y){const A={types:[],items:[]},C=Array.from(y.entries());for(const R of C)A.types.push(R[0]),A.items.push({asString:await R[1].asString()});return A}I.toTreeDataTransferDTO=x})(r=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[155],Ee([1,0,128,13,2,6,3,37,46,16,9]),function(Y,e,r,I,_,x,y,A,C,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function b(g,U,z){for(const q of z.visibleEditorPanes)if(q.group.id===U&&g.matches(q.input))return q.getViewState()}e.findViewStateForEditor=b;function s(g){if(f(g))return!1;const U=g;return _.URI.isUri(U?.resource)}e.isResourceEditorInput=s;function p(g){if(f(g))return!1;const U=g;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=p;function n(g){if(f(g)||p(g))return!1;const U=g;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=n;function i(g){if(f(g))return!1;const U=g;return U?U.resource===void 0||U.resource.scheme===N.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=i;var d;(function(g){g[g.SHORT=0]="SHORT",g[g.MEDIUM=1]="MEDIUM",g[g.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var S;(function(g){g[g.EXPLICIT=1]="EXPLICIT",g[g.AUTO=2]="AUTO",g[g.FOCUS_CHANGE=3]="FOCUS_CHANGE",g[g.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var M;(function(g){g[g.None=0]="None",g[g.Readonly=2]="Readonly",g[g.Untitled=4]="Untitled",g[g.Singleton=8]="Singleton",g[g.RequiresTrust=16]="RequiresTrust",g[g.CanSplitInGroup=32]="CanSplitInGroup",g[g.ForceDescription=64]="ForceDescription"})(M=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends x.Disposable{}e.AbstractEditorInput=u;function f(g){return g instanceof u}e.isEditorInput=f;function w(g){const U=g;return _.URI.isUri(U?.preferredResource)}function a(g){const U=g;return f(U?.primary)&&f(U?.secondary)}e.isSideBySideEditorInput=a;function P(g){const U=g;return f(U?.modified)&&f(U?.original)}e.isDiffEditorInput=P;function c(g){return f(g?.editor)}e.isEditorInputWithOptions=c;function t(g){const U=g;return c(g)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=t;function h(g){const U=g;return typeof U?.groupId=="number"&&f(U.editor)}e.isEditorIdentifier=h;var o;(function(g){g[g.UNKNOWN=0]="UNKNOWN",g[g.REPLACE=1]="REPLACE",g[g.MOVE=2]="MOVE",g[g.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var l;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.GROUP_LOCKED=2]="GROUP_LOCKED",g[g.EDITOR_OPEN=3]="EDITOR_OPEN",g[g.EDITOR_CLOSE=4]="EDITOR_CLOSE",g[g.EDITOR_MOVE=5]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=7]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=9]="EDITOR_PIN",g[g.EDITOR_STICKY=10]="EDITOR_STICKY",g[g.EDITOR_DIRTY=11]="EDITOR_DIRTY",g[g.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(l=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var E;(function(g){g[g.PRIMARY=1]="PRIMARY",g[g.SECONDARY=2]="SECONDARY",g[g.BOTH=3]="BOTH",g[g.ANY=4]="ANY"})(E=e.SideBySideEditor||(e.SideBySideEditor={}));class m{getOriginalUri(U,z){if(!U)return;if(z?.supportSideBySide){const{primary:j,secondary:J}=this.getSideEditors(U);if(j&&J){if(z?.supportSideBySide===E.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(J,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===E.ANY)return this.getOriginalUri(j,{filterByScheme:z.filterByScheme})??this.getOriginalUri(J,{filterByScheme:z.filterByScheme});U=z.supportSideBySide===E.PRIMARY?j:J}}if(p(U)||n(U))return;const q=w(U)?U.preferredResource:U.resource;return!q||!z||!z.filterByScheme?q:this.filterUri(q,z.filterByScheme)}getSideEditors(U){return a(U)||n(U)?{primary:U.primary,secondary:U.secondary}:P(U)||p(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,z){if(!U)return;if(z?.supportSideBySide){const{primary:j,secondary:J}=this.getSideEditors(U);if(j&&J){if(z?.supportSideBySide===E.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(J,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===E.ANY)return this.getCanonicalUri(j,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(J,{filterByScheme:z.filterByScheme});U=z.supportSideBySide===E.PRIMARY?j:J}}if(p(U)||n(U))return;const q=U.resource;return!q||!z||!z.filterByScheme?q:this.filterUri(q,z.filterByScheme)}filterUri(U,z){if(Array.isArray(z)){if(z.some(q=>U.scheme===q))return U}else if(z===U.scheme)return U}}e.EditorResourceAccessor=new m;var v;(function(g){g[g.LEFT=0]="LEFT",g[g.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class k{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const z=this.instantiationService=U.get(y.IInstantiationService);for(const[q,j]of this.editorSerializerConstructors)this.createEditorSerializer(q,j,z);this.editorSerializerConstructors.clear()}createEditorSerializer(U,z,q){const j=q.createInstance(z);this.editorSerializerInstances.set(U,j)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,I.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,z){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,z,this.instantiationService):this.editorSerializerConstructors.set(U,z),(0,x.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new k);async function T(g,U){if(!g||!g.length)return[];const z=await Promise.all(g.map(async q=>{const j=_.URI.revive(q.fileUri);if(!j||!await U.canHandleResource(j))return;let W=q.exists,ie=q.type;if(typeof W!="boolean"||typeof ie!="number")try{ie=(await U.resolve(j)).isDirectory?C.FileType.Directory:C.FileType.Unknown,W=!0}catch{W=!1}if(!W&&q.openOnlyIfExists||ie===C.FileType.Directory)return;const le={selection:W?q.selection:void 0,pinned:!0,override:q.editorOverrideId};let te;return W?te={resource:j,options:le}:te={resource:j,options:le,forceUntitled:!0},te}));return(0,R.coalesce)(z)}e.pathsToEditors=T;var $;(function(g){g[g.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",g[g.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[60],Ee([1,0,9,2]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(A,C){return A.scheme===r.Schemas.http||A.scheme===r.Schemas.https?A:(C&&C.authority&&C.isRemote&&A.scheme===r.Schemas.file&&(A=I.URI.from({scheme:r.Schemas.vscodeRemote,authority:C.authority,path:A.path})),I.URI.from({scheme:r.Schemas.https,authority:`${A.scheme}+${x(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=_;function x(A){return A.replace(/./g,C=>{const R=C.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?C:"-"+R.toString(16).padStart(4,"0")})}function y(A){return A.replace(/-([0-9a-f]{4})/g,(C,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=y}),define(ve[156],Ee([1,0,5,6,60]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class x{constructor(A,C,R){this._proxy=A,this._editors=C,this._initData=R,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const N=C.getVisibleTextEditors();for(const b of this._insets.values())N.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,C,R,N,b){let s;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===A){s=u;break}if(!s)throw new Error("not a visible editor");const p=this,n=this._handlePool++,i=new r.Emitter,d=new r.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,_.asWebviewUri)(u,p._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(u){this._options=u,p._proxy.$setOptions(n,u)}get options(){return this._options}set html(u){this._html=u,p._proxy.$setHtml(n,u)}get html(){return this._html}get onDidReceiveMessage(){return i.event}postMessage(u){return p._proxy.$postMessage(n,u)}},M=new class{constructor(){this.editor=A,this.line=C,this.height=R,this.webview=S,this.onDidDispose=d.event}dispose(){p._insets.has(n)&&(p._insets.delete(n),p._proxy.$disposeEditorInset(n),d.fire(),d.dispose(),i.dispose())}};return this._proxy.$createEditorInset(n,s.id,s.value.document.uri,C+1,R,N||{},b.identifier,b.extensionLocation),this._insets.set(n,{editor:A,inset:M,onDidReceiveMessage:i}),M}$onDidDispose(A){const C=this._insets.get(A);C&&C.inset.dispose()}$onDidReceiveMessage(A,C){const R=this._insets.get(A);R&&R.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=x}),define(ve[157],Ee([1,0,5,11,129]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class x{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,C,R,N){const b={command:A};if(C&&Object.keys(C).length>0&&(b.arguments=C),this.internalSend("request",b),typeof N=="number"){const s=setTimeout(()=>{clearTimeout(s);const p=this.pendingRequests.get(b.seq);if(p){this.pendingRequests.delete(b.seq);const n={type:"response",seq:0,request_seq:b.seq,success:!1,command:A,message:(0,_.localize)(0,null,N,A)};p(n)}},N)}return R&&this.pendingRequests.set(b.seq,R),b.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,C){return A.type!=="event"||C.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,I.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":{const C=A,R=this.pendingRequests.get(C.request_seq);R&&(this.pendingRequests.delete(C.request_seq),R(C));break}}}}internalSend(A,C){C.type=A,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((C,R)=>A.set(R,C)),await(0,I.timeout)(500),A.forEach((C,R)=>{C({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=x}),define(ve[158],Ee([1,0,130,45,3]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new I.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new I.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new I.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new I.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new I.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new I.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new I.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new I.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new I.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new I.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new I.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new I.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new I.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new I.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new I.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new I.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new I.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new I.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new I.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new I.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new I.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new I.RawContextKey("breakpointAccessType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new I.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new I.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new I.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new I.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new I.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new I.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new I.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new I.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new I.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new I.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new I.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new I.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new I.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new I.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new I.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new I.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new I.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new I.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new I.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new I.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new I.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new I.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new I.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new I.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new I.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new I.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new I.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new I.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(49,null)});const x=b=>r.localize(50,null,b);e.debuggerDisabledMessage=x,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(51,null)};var y;(function(b){b[b.Inactive=0]="Inactive",b[b.Initializing=1]="Initializing",b[b.Stopped=2]="Stopped",b[b.Running=3]="Running"})(y=e.State||(e.State={}));function A(b){switch(b){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var C;(function(b){b[b.Valid=0]="Valid",b[b.Unreadable=1]="Unreadable",b[b.Error=2]="Error"})(C=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(b){b[b.Initial=1]="Initial",b[b.Dynamic=2]="Dynamic"})(R=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,_.createDecorator)(e.DEBUG_SERVICE_ID);var N;(function(b){b[b.CONDITION=0]="CONDITION",b[b.HIT_COUNT=1]="HIT_COUNT",b[b.LOG_MESSAGE=2]="LOG_MESSAGE"})(N=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ve[159],Ee([1,0,10,2,17,26,9]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function C(c,t,h){return c.replace(A,function(o,l){return t&&l.length>0&&l[0]!=="_"?o:h&&h.hasOwnProperty(l)?h[l]:o})}e.formatPII=C;function R(c){const t={};for(const h of Object.keys(c))h.startsWith("!")||(t[h]=c[h]);return t}e.filterExceptionsFromTelemetry=R;function N(c){return c.configuration.request==="attach"&&!b(c)&&(!c.parentSession||N(c.parentSession))}e.isSessionAttach=N;function b(c){let t=c.configuration.type;if(!!t)return t==="vslsShare"&&(t=c.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(t,"extensionhost")||(0,r.equalsIgnoreCase)(t,"pwa-extensionhost")?c:c.parentSession?b(c.parentSession):void 0}e.getExtensionHostDebugSession=b;function s(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=s;function p(c,t,h){let o,l=0;const E=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=E.exec(c);){const v=m.index+1,k=v+m[0].length;if(v<=t&&k>=h){o=m[0],l=v;break}}if(o){const v=/\w+/g;let k=null;for(;(k=v.exec(o))&&!(k.index+1+l+k[0].length>=h););k&&(o=o.substring(0,v.lastIndex))}return o?{start:l,end:l+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(c){return!!(c&&c.match(n))}e.isUri=i;function d(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(i(c.path))return I.URI.parse(c.path);if((0,_.isAbsolute)(c.path))return I.URI.file(c.path)}return c.path}function S(c){if(typeof c.path=="object"){const t=I.URI.revive(c.path);if(t)return t.scheme===y.Schemas.file?t.fsPath:t.toString()}return c.path}function M(c,t){const h=t?d:S,o=(0,x.deepClone)(c);return f(o,(l,E)=>{l&&E&&(E.path=h(E))}),o}e.convertToDAPaths=M;function u(c,t){const h=t?d:S,o=(0,x.deepClone)(c);return f(o,(l,E)=>{!l&&E&&(E.path=h(E))}),o}e.convertToVSCPaths=u;function f(c,t){switch(c.type){case"event":{const h=c;switch(h.event){case"output":t(!1,h.body.source);break;case"loadedSource":t(!1,h.body.source);break;case"breakpoint":t(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=c;switch(h.command){case"setBreakpoints":t(!0,h.arguments.source);break;case"breakpointLocations":t(!0,h.arguments.source);break;case"source":t(!0,h.arguments.source);break;case"gotoTargets":t(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(o=>t(!1,o));break;default:break}break}case"response":{const h=c;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(o=>t(!1,o.source));break;case"loadedSources":h.body.sources.forEach(o=>t(!1,o));break;case"scopes":h.body.scopes.forEach(o=>t(!1,o.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(o=>t(!1,o.source));break;case"setBreakpoints":h.body.breakpoints.forEach(o=>t(!1,o.source));break;case"disassemble":{const o=h;o.body&&o.body.instructions.forEach(l=>t(!1,l.location))}break;default:break}break}}}function w(c){return c.filter(t=>!t.presentation?.hidden).sort((t,h)=>t.presentation?h.presentation?t.presentation.group?h.presentation.group?t.presentation.group!==h.presentation.group?t.presentation.group.localeCompare(h.presentation.group):a(t.presentation.order,h.presentation.order):-1:h.presentation.group?1:a(t.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=w;function a(c,t){return typeof c!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:c-t}async function P(c,t){const h=c.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(h!=="none"&&(await t.saveAll(),h==="allEditorsInActiveGroup")){const o=t.activeEditorPane;o&&o.input.resource?.scheme===y.Schemas.untitled&&await t.save({editor:o.input,groupId:o.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=P}),define(ve[84],Ee([1,0,29,160,70,9,17,23,45]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(v){v[v.Markup=1]="Markup",v[v.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",_.Mimes.latex,_.Mimes.markdown,"image/png","image/jpeg",_.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[_.Mimes.latex,_.Mimes.markdown,"application/json",_.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var N;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(N=e.NotebookRunState||(e.NotebookRunState={}));var b;(function(v){v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(b=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var s;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(s=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(v){v.Always="always",v.Never="never",v.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var n;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",v[v.ChangeCellMime=13]="ChangeCellMime",v[v.Unknown=100]="Unknown"})(n=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var i;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(i=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata",v[v.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var S;(function(v){v.scheme=x.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function T(j,J){return j.with({scheme:v.scheme,fragment:`ch${J.toString().padStart(7,"0")}${j.scheme!==x.Schemas.file?j.scheme:""}`})}v.generate=T;function $(j){if(j.scheme!==v.scheme)return;const J=k.exec(j.fragment);return J?{handle:Number(J[1]),notebook:j.with({scheme:j.fragment.substring(J[0].length)||x.Schemas.file,fragment:null})}:void 0}v.parse=$;function g(j,J,W){return j.with({scheme:x.Schemas.vscodeNotebookCellOutput,fragment:`ch${J.toString().padStart(7,"0")},${W??""},${j.scheme!==x.Schemas.file?j.scheme:""}`})}v.generateCellOutputUri=g;function U(j){if(j.scheme!==x.Schemas.vscodeNotebookCellOutput)return;const J=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(j.fragment);if(!J)return;const W=Number(J[1]),ie=J[2]&&J[2]!==""?J[2]:void 0,le=J[3];return{handle:W,outputId:ie,notebook:j.with({scheme:le||x.Schemas.file,fragment:null})}}v.parseCellOutputUri=U;function z(j,J,W){return j.with({scheme:W,fragment:`ch${J.toString().padStart(7,"0")}${j.scheme!==x.Schemas.file?j.scheme:""}`})}v.generateCellUri=z;function q(j,J){if(j.scheme!==J)return;const W=k.exec(j.fragment);return W?{handle:Number(W[1]),notebook:j.with({scheme:j.fragment.substring(W[0].length)||x.Schemas.file,fragment:null})}:void 0}v.parseCellUri=q})(S=e.CellUri||(e.CellUri={}));const M=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function u(v){return M.get(v)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=u;function f(v){return M.get(v)?.supportedByCore??!1}e.mimeTypeSupportedByCore=f;function w(v){return M.get(v)?.mergeable??!1}e.mimeTypeIsMergeable=w;const a=v=>A.isWindows?v.replace(/\//g,"\\"):v;class P{constructor(k=[],T=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=T,this.order=[...new Set(k)].map($=>({pattern:$,matches:r.parse(a($))}))}sort(k){const T=new Map(I.Iterable.map(k,g=>[g,a(g)]));let $=[];for(const{matches:g}of this.order)for(const[U,z]of T)if(g(z)){$.push(U),T.delete(U);break}return T.size&&($=$.concat([...T.keys()].sort((g,U)=>this.defaultOrder.indexOf(g)-this.defaultOrder.indexOf(U)))),$}prioritize(k,T){const $=this.findIndex(k);if($===-1){this.order.unshift({pattern:k,matches:r.parse(a(k))});return}const g=new Set(T.map(z=>this.findIndex(z,$)));g.delete(-1);const U=Array.from(g).sort();this.order.splice($+1,0,...U.map(z=>this.order[z]));for(let z=U.length-1;z>=0;z--)this.order.splice(U[z],1)}toArray(){return this.order.map(k=>k.pattern)}findIndex(k,T=this.order.length){const $=a(k);for(let g=0;g<T;g++)if(this.order[g].matches($))return g;return-1}}e.MimeTypeDisplayOrder=P;function c(v,k,T,$=(g,U)=>g===U){const g=[];function U(j,J,W){if(J===0&&W.length===0)return;const ie=g[g.length-1];ie&&ie.start+ie.deleteCount===j?(ie.deleteCount+=J,ie.toInsert.push(...W)):g.push({start:j,deleteCount:J,toInsert:W})}let z=0,q=0;for(;;){if(z===v.length){U(z,0,k.slice(q));break}if(q===k.length){U(z,v.length-z,[]);break}const j=v[z],J=k[q];if($(j,J)){z+=1,q+=1;continue}T(J)?(U(z,1,[]),z+=1):(U(z,0,[J]),q+=1)}return g}e.diff=c,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(v){v.default="default",v.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(v){const k=v;return!!((typeof k.include=="string"||r.isRelativePattern(k.include))&&(typeof k.exclude=="string"||r.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=h;function o(v,k,T){if(Array.isArray(v.viewType)&&v.viewType.indexOf(k)>=0||v.viewType===k)return!0;if(v.filenamePattern){const $=h(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,g=h(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(r.match($,(0,y.basename)(T.fsPath).toLowerCase()))return!(g&&r.match(g,(0,y.basename)(T.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class l{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let T=0;T<this.textModel.cells.length;T++)k[T]=this.textModel.cells[T].getHashValue();return k}}e.CellSequence=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var E;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(E=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class m{static create(k){return`${m._prefix}${k}`}static parse(k){if(k.startsWith(m._prefix))return k.substring(m._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=m,m._prefix="notebook/"}),define(ve[161],Ee([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var I;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState"})(I=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(ve[162],Ee([1,0,3,45]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,r.createDecorator)(e.OUTPUT_SERVICE_ID);var _;(function(x){x[x.Append=1]="Append",x[x.Replace=2]="Replace",x[x.Clear=3]="Clear"})(_=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[163],Ee([1,0,131,3,45]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,r.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,r.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,r.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[164],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=r;function I(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=I}),define(ve[61],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.denamespaceTestTag=e.namespaceTestTag=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var r;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(r=e.TestResultState||(e.TestResultState={}));var I;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(n){n[n.Error=0]="Error",n[n.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));const x="\0",y=(n,i)=>n+x+i;e.namespaceTestTag=y;const A=n=>{const i=n.indexOf(x);return{ctrlId:n.slice(0,i),tagId:n.slice(i+1)}};e.denamespaceTestTag=A;var C;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(n,i)=>{i.expand!==void 0&&(n.expand=i.expand),i.item!==void 0&&(n.item=n.item?Object.assign(n.item,i.item):i.item)};e.applyTestItemUpdate=R;var N;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(N=e.DetailType||(e.DetailType={}));var b;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire",n[n.AddTag=5]="AddTag",n[n.RemoveTag=6]="RemoveTag"})(b=e.TestDiffOpType||(e.TestDiffOpType={}));class s{add(i){}update(i){}remove(i,d){}complete(){}}e.IncrementalChangeCollector=s;class p{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const d=this.createChangeCollector();for(const S of i)switch(S[0]){case 0:{const M=S[1];if(M.parent){if(this.items.has(M.parent)){const u=this.items.get(M.parent);u.children.add(M.item.extId);const f=this.createItem(M,u);this.items.set(M.item.extId,f),d.add(f)}}else{const u=this.createItem(M);this.roots.add(u),this.items.set(M.item.extId,u),d.add(u)}M.expand===2&&this.busyControllerCount++;break}case 1:{const M=S[1],u=this.items.get(M.extId);if(!u)break;M.expand!==void 0&&(u.expand===2&&this.busyControllerCount--,M.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(u,M),d.update(u);break}case 2:{const M=this.items.get(S[1]);if(!M)break;M.parent?this.items.get(M.parent).children.delete(M.item.extId):this.roots.delete(M);const u=[[S[1]]];for(;u.length;)for(const f of u.pop()){const w=this.items.get(f);w&&(u.push(w.children),this.items.delete(f),d.remove(w,w!==M),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(S[1]);break;case 3:this.updatePendingRoots(S[1]);break;case 5:this._tags.set(S[1].id,S[1]);break;case 6:this._tags.delete(S[1]);break}d.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=p}),define(ve[62],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(x){x.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var I;(function(x){x[x.IsSame=0]="IsSame",x[x.Disconnected=1]="Disconnected",x[x.IsChild=2]="IsChild",x[x.IsParent=3]="IsParent"})(I=e.TestPosition||(e.TestPosition={}));class _{constructor(y,A=y.length){if(this.path=y,this.viewEnd=A,y.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(y,A,C=y.parent){if(y.id===A)return new _([A]);let R=[y.id];for(let N=C;N&&N.id!==A;N=N.parent)R.push(N.id);return R.push(A),new _(R.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const A=y.indexOf("\0");return A===-1?y:y.slice(0,A)}static fromString(y){return new _(y.split("\0"))}static join(y,A){return new _([...y.path,A])}static joinToString(y,A){return y.toString()+"\0"+A}static compare(y,A){return y===A?0:A.startsWith(y+"\0")?2:y.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new _(this.path,y)}compare(y){if(typeof y=="string")return _.compare(this.toString(),y);for(let A=0;A<y.viewEnd&&A<this.viewEnd;A++)if(y.path[A]!==this.path[A])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=_}),define(ve[165],Ee([1,0,17,85,13,26,23,72,132]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(b,s,p){this._contributedVariables=new Map,this._context=b,this._labelService=s,p&&(this._envVariablesPromise=p.then(n=>this.prepareEnv(n)))}prepareEnv(b){if(y.isWindows){const s=Object.create(null);return Object.keys(b).forEach(p=>{s[p.toLowerCase()]=b[p]}),s}return b}resolveWithEnvironment(b,s,p){return this.recursiveResolve(this.prepareEnv(b),s?s.uri:void 0,p)}async resolveAsync(b,s){return this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,s)}async resolveAnyBase(b,s,p,n){const i=x.deepClone(s);return y.isWindows&&i.windows?Object.keys(i.windows).forEach(d=>i[d]=i.windows[d]):y.isMacintosh&&i.osx?Object.keys(i.osx).forEach(d=>i[d]=i.osx[d]):y.isLinux&&i.linux&&Object.keys(i.linux).forEach(d=>i[d]=i.linux[d]),delete i.windows,delete i.osx,delete i.linux,this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,i,p,n)}async resolveAnyAsync(b,s,p){return this.resolveAnyBase(b,s,p)}async resolveAnyMap(b,s,p){const n=new Map;return{newConfig:await this.resolveAnyBase(b,s,p,n),resolvedVariables:n}}resolveWithInteractionReplace(b,s,p,n){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,s,p,n){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,s){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,s)}recursiveResolve(b,s,p,n,i){if(_.isString(p))return this.resolveString(b,s,p,n,i);if(_.isArray(p))return p.map(d=>this.recursiveResolve(b,s,d,n,i));if(_.isObject(p)){let d=Object.create(null);return Object.keys(p).forEach(S=>{const M=this.resolveString(b,s,S,n,i);d[M]=this.recursiveResolve(b,s,p[S],n,i)}),d}return p}resolveString(b,s,p,n,i){return p.replace(R.VARIABLE_REGEXP,(S,M)=>{if(M.includes(R.VARIABLE_LHS))return S;let u=this.evaluateSingleVariable(b,S,M,s,n);return i&&i.set(M,u),u!==S&&_.isString(u)&&u.match(R.VARIABLE_REGEXP)&&(u=this.resolveString(b,s,u,n,i)),u})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,s,p,n,i){let d;const S=p.split(":");S.length>1&&(p=S[0],d=S[1]);const M=()=>{const w=this._context.getFilePath();if(w)return w;throw new Error((0,C.localize)(0,null,s))},u=()=>{const w=M();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,C.localize)(1,null,s,r.basename(w)))},f=()=>{if(d){const w=this._context.getFolderUri(d);if(w)return w;throw new Error((0,C.localize)(2,null,s,d))}if(n)return n;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,s)):new Error((0,C.localize)(4,null,s))};switch(p){case"env":if(d){if(b){const w=b[y.isWindows?d.toLowerCase():d];if(_.isString(w))return w}return""}throw new Error((0,C.localize)(5,null,s));case"config":if(d){const w=this._context.getConfigurationValue(n,d);if(_.isUndefinedOrNull(w))throw new Error((0,C.localize)(6,null,s,d));if(_.isObject(w))throw new Error((0,C.localize)(7,null,s,d));return w}throw new Error((0,C.localize)(8,null,s));case"command":return this.resolveFromMap(s,d,i,"command");case"input":return this.resolveFromMap(s,d,i,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return n||d?(0,A.normalizeDriveLetter)(this.fsPath(f())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(f()));case"lineNumber":{const w=this._context.getLineNumber();if(w)return w;throw new Error((0,C.localize)(9,null,s))}case"selectedText":{const w=this._context.getSelectedText();if(w)return w;throw new Error((0,C.localize)(10,null,s))}case"file":return M();case"fileWorkspaceFolder":return u();case"relativeFile":return n||d?r.relative(this.fsPath(f()),M()):M();case"relativeFileDirname":{const w=r.dirname(M());if(n||d){const a=r.relative(this.fsPath(f()),w);return a.length===0?".":a}return w}case"fileDirname":return r.dirname(M());case"fileExtname":return r.extname(M());case"fileBasename":return r.basename(M());case"fileBasenameNoExtension":{const w=r.basename(M());return w.slice(0,w.length-r.extname(w).length)}case"fileDirnameBasename":return r.basename(r.dirname(M()));case"execPath":{const w=this._context.getExecPath();return w||s}case"execInstallFolder":{const w=this._context.getAppRoot();return w||s}case"pathSeparator":return r.sep;default:try{const w=d?`${p}:${d}`:p;return this.resolveFromMap(s,w,i,void 0)}catch{return s}}}}resolveFromMap(b,s,p,n){if(s&&p){const i=n===void 0?p[s]:p[n+":"+s];if(typeof i=="string")return i;throw new Error((0,C.localize)(11,null,b))}return b}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[86],Ee([1,0,3,155]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var _;(function(n){n[n.UP=0]="UP",n[n.DOWN=1]="DOWN",n[n.LEFT=2]="LEFT",n[n.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var x;(function(n){n[n.HORIZONTAL=0]="HORIZONTAL",n[n.VERTICAL=1]="VERTICAL"})(x=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(n){n[n.FIRST=0]="FIRST",n[n.LAST=1]="LAST",n[n.NEXT=2]="NEXT",n[n.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var A;(function(n){n[n.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",n[n.EVEN=1]="EVEN",n[n.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(n){n[n.COPY_EDITORS=0]="COPY_EDITORS",n[n.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function R(n){const i=n;return(0,I.isEditorInput)(i?.editor)&&(0,I.isEditorInput)(i?.replacement)}e.isEditorReplacement=R;var N;(function(n){n[n.CREATION_TIME=0]="CREATION_TIME",n[n.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",n[n.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(n){n[n.NEW_EDITOR=1]="NEW_EDITOR",n[n.MOVE_EDITOR=2]="MOVE_EDITOR",n[n.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function s(n){const i=n;return!!i&&typeof i.id=="number"&&Array.isArray(i.editors)}e.isEditorGroup=s;function p(n){return n.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(ve[166],Ee([1,0,3,86]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(x){const y=x;return typeof x=="number"||(0,I.isEditorGroup)(y)}e.isPreferredGroup=_}),define(ve[8],Ee([1,0,16,21,71,101,54,26,13,2,87,88,134,77,48,84,61,62,166,7]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(se){function _e(K){const{selectionStartLineNumber:be,selectionStartColumn:Te,positionLineNumber:Be,positionColumn:We}=K,st=new u.Position(be-1,Te-1),ft=new u.Position(Be-1,We-1);return new u.Selection(st,ft)}se.to=_e;function ae(K){const{anchor:be,active:Te}=K;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}se.from=ae})(f=e.Selection||(e.Selection={}));var w;(function(se){function _e(K){if(!K)return;const{start:be,end:Te}=K;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}se.from=_e;function ae(K){if(!K)return;const{startLineNumber:be,startColumn:Te,endLineNumber:Be,endColumn:We}=K;return new u.Range(be-1,Te-1,Be-1,We-1)}se.to=ae})(w=e.Range||(e.Range={}));var a;(function(se){function _e(ae){switch(ae){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}se.to=_e})(a=e.TokenType||(e.TokenType={}));var P;(function(se){function _e(K){return new u.Position(K.lineNumber-1,K.column-1)}se.to=_e;function ae(K){return{lineNumber:K.line+1,column:K.character+1}}se.from=ae})(P=e.Position||(e.Position={}));var c;(function(se){function _e(be,Te){return(0,r.coalesce)((0,r.asArray)(be).map(Be=>ae(Be,Te)))}se.from=_e;function ae(be,Te){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:K(be.scheme,Te),pattern:ce.from(be.pattern)??void 0,exclusive:be.exclusive}}function K(be,Te){return Te&&typeof be=="string"?Te.transformOutgoingScheme(be):be}})(c=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(se){function _e(K){switch(K){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}se.from=_e;function ae(K){switch(K){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}se.to=ae})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(se){function _e(K){let be;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?be=String(K.code):be={value:String(K.code.value),target:K.code.target}),{...w.from(K.range),message:K.message,source:K.source,code:be,severity:l.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(o.from),tags:Array.isArray(K.tags)?(0,r.coalesce)(K.tags.map(t.from)):void 0}}se.from=_e;function ae(K){const be=new u.Diagnostic(w.to(K),K.message,l.to(K.severity));return be.source=K.source,be.code=(0,C.isString)(K.code)?K.code:K.code?.value,be.relatedInformation=K.relatedInformation&&K.relatedInformation.map(o.to),be.tags=K.tags&&(0,r.coalesce)(K.tags.map(t.to)),be}se.to=ae})(h=e.Diagnostic||(e.Diagnostic={}));var o;(function(se){function _e(K){return{...w.from(K.location.range),message:K.message,resource:K.location.uri}}se.from=_e;function ae(K){return new u.DiagnosticRelatedInformation(new u.Location(K.resource,w.to(K)),K.message)}se.to=ae})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(se){function _e(K){switch(K){case u.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}se.from=_e;function ae(K){switch(K){case p.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}se.to=ae})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var E;(function(se){function _e(K){return typeof K=="number"&&K>=u.ViewColumn.One?K-1:K===u.ViewColumn.Beside?M.SIDE_GROUP:M.ACTIVE_GROUP}se.from=_e;function ae(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}se.to=ae})(E=e.ViewColumn||(e.ViewColumn={}));function m(se){return typeof se.range!="undefined"}function v(se){return se.length===0?!0:!!m(se[0])}e.isDecorationOptionsArr=v;var k;(function(se){function _e(We){return We.map(se.from)}se.fromMany=_e;function ae(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function K(We){let st;if(ae(We)){const{language:it,value:at}=We;st={value:"```"+it+`
`+at+"\n```\n"}}else u.MarkdownString.isMarkdownString(We)?st={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?st={value:We}:st={value:""};const ft=Object.create(null);st.uris=ft;const Et=it=>{try{let at=R.URI.parse(it,!0);at=at.with({query:be(at.query,ft)}),ft[it]=at}catch{}return""},vt=new x.marked.Renderer;return vt.link=Et,vt.image=it=>typeof it=="string"?Et(_.parseHrefAndDimensions(it).href):"",(0,x.marked)(st.value,{renderer:vt}),st}se.from=K;function be(We,st){if(!We)return We;let ft;try{ft=(0,y.parse)(We)}catch{}if(!ft)return We;let Et=!1;return ft=(0,A.cloneAndChange)(ft,vt=>{if(R.URI.isUri(vt)){const it=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[it]=vt,Et=!0,it}else return}),Et?JSON.stringify(ft):We}function Te(We){const st=new u.MarkdownString(We.value,We.supportThemeIcons);return st.isTrusted=We.isTrusted,st.supportHtml=We.supportHtml,st.baseUri=We.baseUri?R.URI.from(We.baseUri):void 0,st}se.to=Te;function Be(We){if(!!We)return typeof We=="string"?We:se.from(We)}se.fromStrict=Be})(k=e.MarkdownString||(e.MarkdownString={}));function T(se){return v(se)?se.map(_e=>({range:w.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?k.fromMany(_e.hoverMessage):_e.hoverMessage?k.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):se.map(_e=>({range:w.from(_e)}))}e.fromRangeOrRangeWithMessage=T;function $(se){return typeof se=="undefined"?se:typeof se=="string"?R.URI.file(se):se}e.pathOrURIToURI=$;var g;(function(se){function _e(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?$(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}se.from=_e})(g=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(se){function _e(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?$(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?g.from(ae.before):void 0,after:ae.after?g.from(ae.after):void 0}}se.from=_e})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(se){function _e(ae){if(typeof ae=="undefined")return ae;switch(ae){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}se.from=_e})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(se){function _e(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?z.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?U.from(ae.light):void 0,dark:ae.dark?U.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?$(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?g.from(ae.before):void 0,after:ae.after?g.from(ae.after):void 0}}se.from=_e})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(se){function _e(K){return{text:K.newText,eol:K.newEol&&et.from(K.newEol),range:w.from(K.range)}}se.from=_e;function ae(K){const be=new u.TextEdit(w.to(K.range),K.text);return be.newEol=typeof K.eol=="undefined"?void 0:et.to(K.eol),be}se.to=ae})(j=e.TextEdit||(e.TextEdit={}));var J;(function(se){function _e(K,be){const Te={edits:[]};if(K instanceof u.WorkspaceEdit)for(let Be of K._allEntries())Be._type===1?Te.edits.push({_type:1,oldUri:Be.from,newUri:Be.to,options:Be.options,metadata:Be.metadata}):Be._type===2?Te.edits.push({_type:2,resource:Be.uri,edit:j.from(Be.edit),modelVersionId:be?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Te.edits.push({_type:3,metadata:Be.metadata,resource:Be.uri,edit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:be?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Te.edits.push({_type:3,metadata:Be.metadata,resource:Be.uri,notebookVersionId:be?.getNotebookDocumentVersion(Be.uri),edit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(_t.from)}});return Te}se.from=_e;function ae(K){const be=new u.WorkspaceEdit;for(const Te of K.edits)Te.edit?be.replace(R.URI.revive(Te.resource),w.to(Te.edit.range),Te.edit.text):be.renameFile(R.URI.revive(Te.oldUri),R.URI.revive(Te.newUri),Te.options);return be}se.to=ae})(J=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(se){const _e=Object.create(null);_e[u.SymbolKind.File]=0,_e[u.SymbolKind.Module]=1,_e[u.SymbolKind.Namespace]=2,_e[u.SymbolKind.Package]=3,_e[u.SymbolKind.Class]=4,_e[u.SymbolKind.Method]=5,_e[u.SymbolKind.Property]=6,_e[u.SymbolKind.Field]=7,_e[u.SymbolKind.Constructor]=8,_e[u.SymbolKind.Enum]=9,_e[u.SymbolKind.Interface]=10,_e[u.SymbolKind.Function]=11,_e[u.SymbolKind.Variable]=12,_e[u.SymbolKind.Constant]=13,_e[u.SymbolKind.String]=14,_e[u.SymbolKind.Number]=15,_e[u.SymbolKind.Boolean]=16,_e[u.SymbolKind.Array]=17,_e[u.SymbolKind.Object]=18,_e[u.SymbolKind.Key]=19,_e[u.SymbolKind.Null]=20,_e[u.SymbolKind.EnumMember]=21,_e[u.SymbolKind.Struct]=22,_e[u.SymbolKind.Event]=23,_e[u.SymbolKind.Operator]=24,_e[u.SymbolKind.TypeParameter]=25;function ae(be){return typeof _e[be]=="number"?_e[be]:6}se.from=ae;function K(be){for(const Te in _e)if(_e[Te]===be)return Number(Te);return u.SymbolKind.Property}se.to=K})(W=e.SymbolKind||(e.SymbolKind={}));var ie;(function(se){function _e(K){switch(K){case u.SymbolTag.Deprecated:return 1}}se.from=_e;function ae(K){switch(K){case 1:return u.SymbolTag.Deprecated}}se.to=ae})(ie=e.SymbolTag||(e.SymbolTag={}));var le;(function(se){function _e(K){return{name:K.name,kind:W.from(K.kind),tags:K.tags&&K.tags.map(ie.from),containerName:K.containerName,location:fe.from(K.location)}}se.from=_e;function ae(K){const be=new u.SymbolInformation(K.name,W.to(K.kind),K.containerName,fe.to(K.location));return be.tags=K.tags&&K.tags.map(ie.to),be}se.to=ae})(le=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(se){function _e(K){const be={name:K.name||"!!MISSING: name!!",detail:K.detail,range:w.from(K.range),selectionRange:w.from(K.selectionRange),kind:W.from(K.kind),tags:K.tags?.map(ie.from)??[]};return K.children&&(be.children=K.children.map(_e)),be}se.from=_e;function ae(K){const be=new u.DocumentSymbol(K.name,K.detail,W.to(K.kind),w.to(K.range),w.to(K.selectionRange));return(0,r.isNonEmptyArray)(K.tags)&&(be.tags=K.tags.map(ie.to)),K.children&&(be.children=K.children.map(ae)),be}se.to=ae})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var ue;(function(se){function _e(K){const be=new u.CallHierarchyItem(W.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return be._sessionId=K._sessionId,be._itemId=K._itemId,be}se.to=_e;function ae(K,be,Te){if(be=be??K._sessionId,Te=Te??K._itemId,be===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Te,name:K.name,detail:K.detail,kind:W.from(K.kind),uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(ie.from)}}se.from=ae})(ue=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(se){function _e(ae){return new u.CallHierarchyIncomingCall(ue.to(ae.from),ae.fromRanges.map(K=>w.to(K)))}se.to=_e})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var De;(function(se){function _e(ae){return new u.CallHierarchyOutgoingCall(ue.to(ae.to),ae.fromRanges.map(K=>w.to(K)))}se.to=_e})(De=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var fe;(function(se){function _e(K){return{range:K.range&&w.from(K.range),uri:K.uri}}se.from=_e;function ae(K){return new u.Location(R.URI.revive(K.uri),w.to(K.range))}se.to=ae})(fe=e.location||(e.location={}));var ne;(function(se){function _e(K){const be=K,Te=K;return{originSelectionRange:be.originSelectionRange?w.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:Te.uri,range:w.from(be.targetRange?be.targetRange:Te.range),targetSelectionRange:be.targetSelectionRange?w.from(be.targetSelectionRange):void 0}}se.from=_e;function ae(K){return{targetUri:R.URI.revive(K.uri),targetRange:w.to(K.range),targetSelectionRange:K.targetSelectionRange?w.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?w.to(K.originSelectionRange):void 0}}se.to=ae})(ne=e.DefinitionLink||(e.DefinitionLink={}));var me;(function(se){function _e(K){return{range:w.from(K.range),contents:k.fromMany(K.contents)}}se.from=_e;function ae(K){return new u.Hover(K.contents.map(k.to),w.to(K.range))}se.to=ae})(me=e.Hover||(e.Hover={}));var Ie;(function(se){function _e(K){return{range:w.from(K.range),expression:K.expression}}se.from=_e;function ae(K){return new u.EvaluatableExpression(w.to(K.range),K.expression)}se.to=ae})(Ie=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ae;(function(se){function _e(K){if(K instanceof u.InlineValueText)return{type:"text",range:w.from(K.range),text:K.text};if(K instanceof u.InlineValueVariableLookup)return{type:"variable",range:w.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}se.from=_e;function ae(K){switch(K.type){case"text":return{range:w.to(K.range),text:K.text};case"variable":return{range:w.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:w.to(K.range),expression:K.expression}}}se.to=ae})(Ae=e.InlineValue||(e.InlineValue={}));var Ue;(function(se){function _e(K){return{frameId:K.frameId,stoppedLocation:w.from(K.stoppedLocation)}}se.from=_e;function ae(K){return new u.InlineValueContext(K.frameId,w.to(K.stoppedLocation))}se.to=ae})(Ue=e.InlineValueContext||(e.InlineValueContext={}));var Ge;(function(se){function _e(K){return{range:w.from(K.range),kind:K.kind}}se.from=_e;function ae(K){return new u.DocumentHighlight(w.to(K.range),K.kind)}se.to=ae})(Ge=e.DocumentHighlight||(e.DocumentHighlight={}));var ge;(function(se){function _e(ae){switch(ae){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}se.to=_e})(ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var de;(function(se){function _e(ae){return{triggerKind:ge.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}se.to=_e})(de=e.CompletionContext||(e.CompletionContext={}));var L;(function(se){function _e(K){switch(K){case u.CompletionItemTag.Deprecated:return 1}}se.from=_e;function ae(K){switch(K){case 1:return u.CompletionItemTag.Deprecated}}se.to=ae})(L=e.CompletionItemTag||(e.CompletionItemTag={}));var F;(function(se){const _e=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ae(Te){return _e.get(Te)??9}se.from=ae;const K=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function be(Te){return K.get(Te)??u.CompletionItemKind.Property}se.to=be})(F=e.CompletionItemKind||(e.CompletionItemKind={}));var D;(function(se){function _e(ae,K){const be=new u.CompletionItem(ae.label);return be.insertText=ae.insertText,be.kind=F.to(ae.kind),be.tags=ae.tags?.map(L.to),be.detail=ae.detail,be.documentation=_.isMarkdownString(ae.documentation)?k.to(ae.documentation):ae.documentation,be.sortText=ae.sortText,be.filterText=ae.filterText,be.preselect=ae.preselect,be.commitCharacters=ae.commitCharacters,N.Range.isIRange(ae.range)?be.range=w.to(ae.range):typeof ae.range=="object"&&(be.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),be.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?be.insertText=new u.SnippetString(ae.insertText):(be.insertText=ae.insertText,be.textEdit=be.range instanceof u.Range?new u.TextEdit(be.range,be.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(be.additionalTextEdits=ae.additionalTextEdits.map(Te=>j.to(Te))),be.command=K&&ae.command?K.fromInternal(ae.command):void 0,be}se.to=_e})(D=e.CompletionItem||(e.CompletionItem={}));var O;(function(se){function _e(K){return{label:K.label,documentation:k.fromStrict(K.documentation)}}se.from=_e;function ae(K){return{label:K.label,documentation:_.isMarkdownString(K.documentation)?k.to(K.documentation):K.documentation}}se.to=ae})(O=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(se){function _e(K){return{label:K.label,documentation:k.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(O.from):[],activeParameter:K.activeParameter}}se.from=_e;function ae(K){return{label:K.label,documentation:_.isMarkdownString(K.documentation)?k.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(O.to):[],activeParameter:K.activeParameter}}se.to=ae})(H=e.SignatureInformation||(e.SignatureInformation={}));var X;(function(se){function _e(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.from):[]}}se.from=_e;function ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.to):[]}}se.to=ae})(X=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(se){function _e(ae,K){const be=new u.InlayHint(P.to(K.position),typeof K.label=="string"?K.label:K.label.map(pe.to.bind(void 0,ae)),Ce.to(K.kind));return be.tooltip=_.isMarkdownString(K.tooltip)?k.to(K.tooltip):K.tooltip,be.command=K.command&&ae.fromInternal(K.command),be.paddingLeft=K.paddingLeft,be.paddingRight=K.paddingRight,be}se.to=_e})(re=e.InlayHint||(e.InlayHint={}));var pe;(function(se){function _e(ae,K){const be=new u.InlayHintLabelPart(K.label);return be.tooltip=_.isMarkdownString(K.tooltip)?k.to(K.tooltip):K.tooltip,b.Command.is(K.command)&&(be.command=ae.fromInternal(K.command)),K.location&&(be.location=fe.to(K.location)),be}se.to=_e})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(se){function _e(K){return K}se.from=_e;function ae(K){return K}se.to=ae})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(se){function _e(K){return{range:w.from(K.range),url:K.target,tooltip:K.tooltip}}se.from=_e;function ae(K){let be;if(K.url)try{be=typeof K.url=="string"?R.URI.parse(K.url,!0):R.URI.revive(K.url)}catch{}return new u.DocumentLink(w.to(K.range),be)}se.to=ae})(Me=e.DocumentLink||(e.DocumentLink={}));var Le;(function(se){function _e(K){const be=new u.ColorPresentation(K.label);return K.textEdit&&(be.textEdit=j.to(K.textEdit)),K.additionalTextEdits&&(be.additionalTextEdits=K.additionalTextEdits.map(Te=>j.to(Te))),be}se.to=_e;function ae(K){return{label:K.label,textEdit:K.textEdit?j.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(be=>j.from(be)):void 0}}se.from=ae})(Le=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(se){function _e(K){return new u.Color(K[0],K[1],K[2],K[3])}se.to=_e;function ae(K){return[K.red,K.green,K.blue,K.alpha]}se.from=ae})(ze=e.Color||(e.Color={}));var xe;(function(se){function _e(K){return{range:w.from(K.range)}}se.from=_e;function ae(K){return new u.SelectionRange(w.to(K.range))}se.to=ae})(xe=e.SelectionRange||(e.SelectionRange={}));var Oe;(function(se){function _e(ae){switch(ae){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}se.to=_e})(Oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Xe;(function(se){function _e(K){switch(K){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}se.from=_e;function ae(K){switch(K){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}se.to=ae})(Xe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var et;(function(se){function _e(K){if(K===u.EndOfLine.CRLF)return 1;if(K===u.EndOfLine.LF)return 0}se.from=_e;function ae(K){if(K===1)return u.EndOfLine.CRLF;if(K===0)return u.EndOfLine.LF}se.to=ae})(et=e.EndOfLine||(e.EndOfLine={}));var ke;(function(se){function _e(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}se.from=_e})(ke=e.ProgressLocation||(e.ProgressLocation={}));var tt;(function(se){function _e(ae){const K={start:ae.start+1,end:ae.end+1};return ae.kind&&(K.kind=G.from(ae.kind)),K}se.from=_e})(tt=e.FoldingRange||(e.FoldingRange={}));var G;(function(se){function _e(ae){if(ae)switch(ae){case u.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}se.from=_e})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(se){function _e(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?s.EditorResolution.DISABLED:void 0}}se.from=_e})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ce;(function(se){function _e(Te){return Te instanceof u.RelativePattern?Te.toJSON():typeof Te=="string"?Te:ae(Te)||K(Te)?new u.RelativePattern(Te.baseUri??Te.base,Te.pattern).toJSON():Te}se.from=_e;function ae(Te){const Be=Te;return Be?R.URI.isUri(Be.baseUri)&&typeof Be.pattern=="string":!1}function K(Te){const Be=Te;return Be?typeof Be.base=="string"&&typeof Be.pattern=="string":!1}function be(Te){return typeof Te=="string"?Te:new u.RelativePattern(R.URI.revive(Te.baseUri),Te.pattern)}se.to=be})(ce=e.GlobPattern||(e.GlobPattern={}));var Re;(function(se){function _e(ae){if(ae){if(Array.isArray(ae))return ae.map(_e);if(typeof ae=="string")return ae;{const K=ae;return{language:K.language,scheme:K.scheme,pattern:ce.from(K.pattern),exclusive:K.exclusive}}}else return}se.from=_e})(Re=e.LanguageSelector||(e.LanguageSelector={}));var $e;(function(se){function _e(K){return{start:K.start,end:K.end}}se.from=_e;function ae(K){return new u.NotebookRange(K.start,K.end)}se.to=ae})($e=e.NotebookRange||(e.NotebookRange={}));var Ke;(function(se){function _e(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}se.to=_e;function ae(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}se.from=ae})(Ke=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Qe;(function(se){function _e(K){switch(K){case u.NotebookCellKind.Markup:return i.CellKind.Markup;case u.NotebookCellKind.Code:default:return i.CellKind.Code}}se.from=_e;function ae(K){switch(K){case i.CellKind.Markup:return u.NotebookCellKind.Markup;case i.CellKind.Code:default:return u.NotebookCellKind.Code}}se.to=ae})(Qe=e.NotebookCellKind||(e.NotebookCellKind={}));var ht;(function(se){function _e(K){const be={metadata:K.metadata??Object.create(null),cells:[]};for(let Te of K.cells)u.NotebookCellData.validate(Te),be.cells.push(_t.from(Te));return be}se.from=_e;function ae(K){const be=new u.NotebookData(K.cells.map(_t.to));return(0,C.isEmptyObject)(K.metadata)||(be.metadata=K.metadata),be}se.to=ae})(ht=e.NotebookData||(e.NotebookData={}));var _t;(function(se){function _e(K){return{cellKind:Qe.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ke.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Tt.from):[]}}se.from=_e;function ae(K){return new u.NotebookCellData(Qe.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Tt.to):void 0,K.metadata,K.internalMetadata?Ke.to(K.internalMetadata):void 0)}se.to=ae})(_t=e.NotebookCellData||(e.NotebookCellData={}));var yt;(function(se){function _e(K){return{mime:K.mime,valueBytes:I.VSBuffer.wrap(K.data)}}se.from=_e;function ae(K){return new u.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}se.to=ae})(yt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Tt;(function(se){function _e(K){return{outputId:K.id,items:K.items.map(yt.from),metadata:K.metadata}}se.from=_e;function ae(K){const be=K.items.map(yt.to);return new u.NotebookCellOutput(be,K.outputId,K.metadata)}se.to=ae})(Tt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ve;(function(se){function _e(be){return K(be)?{include:(0,C.withNullAsUndefined)(ce.from(be.include)),exclude:(0,C.withNullAsUndefined)(ce.from(be.exclude))}:(0,C.withNullAsUndefined)(ce.from(be))}se.from=_e;function ae(be){return K(be)?{include:ce.to(be.include),exclude:ce.to(be.exclude)}:ce.to(be)}se.to=ae;function K(be){const Te=be;return Te?!!Te.include&&!!Te.exclude:!1}})(Ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var pt;(function(se){function _e(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?g.from(ae.top):void 0}}se.from=_e})(pt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Nt;(function(se){function _e(ae,K,be){const Te=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Te,be),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}se.from=_e})(Nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(se){function _e(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}se.from=_e})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ot;(function(se){function _e(K){return{uri:K.uri,provides:K.provides}}se.from=_e;function ae(K){return new u.NotebookRendererScript(R.URI.revive(K.uri),K.provides)}se.to=ae})(ot=e.NotebookRendererScript||(e.NotebookRendererScript={}));var At;(function(se){function _e(K){return{message:k.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?fe.from(K.location):void 0}}se.from=_e;function ae(K){const be=new u.TestMessage(typeof K.message=="string"?K.message:k.to(K.message));return be.actualOutput=K.actual,be.expectedOutput=K.expected,be.location=K.location?fe.to(K.location):void 0,be}se.to=ae})(At=e.TestMessage||(e.TestMessage={}));var Dt;(function(se){se.namespace=d.namespaceTestTag,se.denamespace=d.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Ct;(function(se){function _e(Te){const Be=(0,n.getPrivateApiFor)(Te).controllerId;return{extId:S.TestId.fromExtHostTestItem(Te,Be).toString(),label:Te.label,uri:Te.uri,tags:Te.tags.map(We=>Dt.namespace(Be,We.id)),range:w.from(Te.range)||null,description:Te.description||null,sortText:Te.sortText||null,error:Te.error&&k.fromStrict(Te.error)||null}}se.from=_e;function ae(Te){return{parent:void 0,error:void 0,id:S.TestId.fromString(Te.extId).localId,label:Te.label,uri:R.URI.revive(Te.uri),tags:(Te.tags||[]).map(Be=>{const{tagId:We}=Dt.denamespace(Be);return new u.TestTag(We)}),range:w.to(Te.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Te.description||void 0,sortText:Te.sortText||void 0}}se.toPlain=ae;function K(Te){const Be=S.TestId.fromString(Te.extId),We=new n.TestItemImpl(Be.controllerId,Be.localId,Te.label,R.URI.revive(Te.uri));return We.range=w.to(Te.range||void 0),We.description=Te.description||void 0,We.sortText=Te.sortText||void 0,We}function be(Te){let Be;for(const We of Te.tests){const st=K(We.item);(0,n.getPrivateApiFor)(st).parent=Be,Be=st}return Be}se.toItemFromContext=be})(Ct=e.TestItem||(e.TestItem={})),function(se){function _e(K){return{id:K.id}}se.from=_e;function ae(K){return new u.TestTag(K.id)}se.to=ae}(Dt=e.TestTag||(e.TestTag={}));var lt;(function(se){const _e=(K,be)=>{const Te={...Ct.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(We=>We.type===0).map(At.to)})),children:K.children.map(Be=>be.get(Be)).filter(C.isDefined).map(Be=>_e(Be,be))};for(const Be of Te.children)Be.parent=Te;return Te};function ae(K){const be=[],Te=new Map;for(const Be of K.items)Te.set(Be.item.extId,Be),K.request.targets.some(We=>We.controllerId===Be.controllerId&&We.testIds.includes(Be.item.extId))&&be.push(Be);return{completedAt:K.completedAt,results:be.map(Be=>_e(Be,Te))}}se.to=ae})(lt=e.TestResults||(e.TestResults={}));var Ot;(function(se){function _e(Te){return{covered:Te.covered,total:Te.covered}}function ae(Te){return"line"in Te?P.from(Te):w.from(Te)}function K(Te){return"branches"in Te?{count:Te.executionCount,location:ae(Te.location),type:1,branches:Te.branches.length?Te.branches.map(Be=>({count:Be.executionCount,location:Be.location&&ae(Be.location)})):void 0}:{type:0,count:Te.executionCount,location:ae(Te.location)}}se.fromDetailed=K;function be(Te){return{uri:Te.uri,statement:_e(Te.statementCoverage),branch:Te.branchCoverage&&_e(Te.branchCoverage),function:Te.functionCoverage&&_e(Te.functionCoverage),details:Te.detailedCoverage?.map(K)}}se.fromFile=be})(Ot=e.TestCoverage||(e.TestCoverage={}));var Lt;(function(se){function _e(ae){switch(ae){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}se.to=_e})(Lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(se){function _e(K){const be=new u.TypeHierarchyItem(W.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return be._sessionId=K._sessionId,be._itemId=K._itemId,be}se.to=_e;function ae(K,be,Te){if(be=be??K._sessionId,Te=Te??K._itemId,be===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Te,kind:W.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(ie.from)}}se.from=ae})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[167],Ee([1,0,2,15,7,8,227]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(R,N,b,s={timeout:1500,errors:3}){this._logService=R,this._documents=N,this._mainThreadBulkEdits=b,this._thresholds=s,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(N,b,s)=>{const n={dispose:this._callbacks.push([N,b,R])};return Array.isArray(s)&&s.push(n),n}}async $participateInSave(R,N){const b=r.URI.revive(R);let s=!1;const p=setTimeout(()=>s=!0,this._thresholds.timeout),n=[];try{for(let i of[...this._callbacks]){if(s)break;const d=this._documents.getDocument(b),S=await this._deliverEventAsyncAndBlameBadListeners(i,{document:d,reason:x.TextDocumentSaveReason.to(N)});n.push(S)}}finally{clearTimeout(p)}return n}_deliverEventAsyncAndBlameBadListeners([R,N,b],s){const p=this._badListeners.get(R);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,R,N,s).then(()=>!0,n=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const i=this._badListeners.get(R);this._badListeners.set(R,i?i+1:1),typeof i=="number"&&i>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,N,b,s){const p=[],n=Date.now(),{document:i,reason:d}=s,{version:S}=i,M=Object.freeze({document:i,reason:d,waitUntil(u){if(Object.isFrozen(p))throw(0,I.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(u))}});try{N.apply(b,[M])}catch(u){return Promise.reject(u)}return Object.freeze(p),new Promise((u,f)=>{const w=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(w),u(a)}).catch(a=>{clearTimeout(w),f(a)})}).then(u=>{const f={edits:[]};for(const w of u)if(Array.isArray(w)&&w.every(a=>a instanceof _.TextEdit))for(const{newText:a,newEol:P,range:c}of w)f.edits.push({_type:2,resource:i.uri,edit:{range:c&&x.Range.from(c),text:a,eol:P&&x.EndOfLine.from(P)}});if(f.edits.length!==0)return S===i.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ve[168],Ee([1,0,9,26,2,8,84]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(b,s,p,n){this.start=b,this.deletedCount=s,this.deletedItems=p,this.items=n}static asApiEvents(b){return b.map(s=>({start:s.start,deletedCount:s.deletedCount,deletedItems:s.deletedItems,items:s.items.map(p=>p.apiCell)}))}}class C{constructor(b,s,p){this.notebook=b,this._extHostDocument=s,this._cellData=p,this.handle=p.handle,this.uri=_.URI.revive(p.uri),this.cellKind=p.cellKind,this._outputs=p.outputs.map(x.NotebookCellOutput.to),this._internalMetadata=p.internalMetadata??{},this._metadata=Object.freeze(p.metadata??{}),this._previousResult=Object.freeze(x.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}static asModelAddData(b,s){return{EOL:s.eol,lines:s.source,languageId:s.language,uri:s.uri,isDirty:!1,versionId:1,notebook:b}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,s=this._extHostDocument.getDocument(this.uri);if(!s)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:x.NotebookCellKind.to(this._cellData.cellKind),document:s.document,get mime(){return b._mime},set mime(p){b._mime=p},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}})}return this._apiCell}setOutputs(b){this._outputs=b.map(x.NotebookCellOutput.to)}setOutputItems(b,s,p){const n=p.map(x.NotebookCellOutputItem.to),i=this._outputs.find(d=>d.id===b);i&&(s||(i.items.length=0),i.items.push(...n))}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(x.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=C;class R{constructor(b,s,p,n,i,d){this._proxy=b,this._textDocumentsAndEditors=s,this._textDocuments=p,this._emitter=n,this.uri=i,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=d.viewType,this._metadata=Object.freeze(d.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,d.cells]],!0),this._versionId=d.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this;this._notebook={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===r.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(s){return s=b._validateIndex(s),b._cells[s].apiCell},getCells(s){return(s?b._getCells(s):b._cells).map(n=>n.apiCell)},save(){return b._save()}}}return this._notebook}updateBackup(b){this._backup?.delete(),this._backup=b}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,s){this._versionId=b.versionId,this._isDirty=s;for(const p of b.rawEvents)p.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(p.changes,!1):p.kind===y.NotebookCellsChangeType.Move?this._moveCell(p.index,p.newIdx):p.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(p.index,p.outputs):p.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(p.index,p.outputId,p.append,p.outputItems):p.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(p.index,p.language):p.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(p.index,p.mime):p.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(p.index,p.metadata):p.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(p.index,p.internalMetadata)}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let s=b.start|0,p=b.end|0;return s<0&&(s=0),p>this._cells.length&&(p=this._cells.length),b.with({start:s,end:p})}_getCells(b){b=this._validateRange(b);const s=[];for(let p=b.start;p<b.end;p++)s.push(this._cells[p]);return s}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,s){if(this._disposed)return;const p=[],n=[],i=[];b.reverse().forEach(d=>{const M=d[2].map(w=>{const a=new C(this,this._textDocumentsAndEditors,w);return s||n.push(C.asModelAddData(this.apiNotebook,w)),a}),u=new A(d[0],d[1],[],M),f=this._cells.splice(d[0],d[1],...M);for(const w of f)i.push(w.uri),u.deletedItems.push(w.apiCell);p.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:i}),s||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:A.asApiEvents(p)}))}_moveCell(b,s){const p=this._cells.splice(b,1);this._cells.splice(s,0,...p);const n=[new A(b,1,p.map(i=>i.apiCell),[]),new A(s,0,[],p)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:A.asApiEvents(n)}))}_setCellOutputs(b,s){const p=this._cells[b];p.setOutputs(s),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_setCellOutputItems(b,s,p,n){const i=this._cells[b];i.setOutputItems(s,p,n),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[i.apiCell]}))}_changeCellLanguage(b,s){const p=this._cells[b];p.apiCell.document.languageId!==s&&this._textDocuments.$acceptModelLanguageChanged(p.uri,s)}_changeCellMime(b,s){const p=this._cells[b];p.apiCell.mime=s}_changeCellMetadata(b,s){const p=this._cells[b],n=p.apiCell.metadata;p.setMetadata(s);const i=p.apiCell.metadata;(0,I.equals)(n,i)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:p.apiCell}))}_changeCellInternalMetadata(b,s){this._cells[b].setInternalMetadata(s)}getCellFromApiCell(b){return this._cells.find(s=>s.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(s=>s.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(ve[89],Ee([1,0,7,8,15]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class x{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:R})}replaceCells(C,R,N){this._throwIfFinalized(),!(C===R&&N.length===0)&&this._collectedEdits.push({editType:1,index:C,count:R-C,cells:N.map(I.NotebookCellData.from)})}}class y{constructor(C,R,N,b,s,p){this.id=C,this._proxy=R,this.notebookData=N,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=s,this._visibleRanges=b,this._viewColumn=p}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(R){if(!Array.isArray(R)||!R.every(r.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");C._selections=R,C._trySetSelections(R)},get visibleRanges(){return C._visibleRanges},revealRange(R,N){C._proxy.$tryRevealRange(C.id,I.NotebookRange.from(R),N??r.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(R){const N=new x(this.document.version);return R(N),C._applyEdit(N.finalize())},setDecorations(R,N){return C.setDecorations(R,N)}},y.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(I.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const R=[];let N=-1;for(let b=0;b<C.cellEdits.length;b++){if(N<0){R.push(C.cellEdits[b]),N++;continue}const p=R[N],n=C.cellEdits[b];if(p.editType===1&&n.editType===1&&p.index===n.index){p.cells.push(...C.cellEdits[b].cells),p.count+=C.cellEdits[b].count;continue}R.push(C.cellEdits[b]),N++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,R)}setDecorations(C,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return R.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(R),C.key)}}e.ExtHostNotebookEditor=y,y.apiEditorsToExtHost=new WeakMap}),define(ve[169],Ee([1,0,8,140,123,20,52,15]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(s){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=s}async withProgress(s,p,n){const i=this._handles++,{title:d,location:S,cancellable:M}=p,u={label:(0,_.localize)(0,null,s.displayName||s.name),id:s.identifier.value};return this._proxy.$startProgress(i,{location:r.ProgressLocation.from(S),title:d,source:u,cancellable:M},s.isUnderDevelopment?void 0:s.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(i,n,!!M)}_withProgress(s,p,n){let i;n&&(i=new x.CancellationTokenSource,this._mapHandleToCancellationSource.set(s,i));const d=M=>{this._proxy.$progressEnd(M),this._mapHandleToCancellationSource.delete(M),i&&i.dispose()};let S;try{S=p(new N(this._proxy,s),n&&i?i.token:x.CancellationToken.None)}catch(M){throw d(s),M}return S.then(M=>d(s),M=>d(s)),S}$acceptProgressCanceled(s){const p=this._mapHandleToCancellationSource.get(s);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(s))}}e.ExtHostProgress=C;function R(b,s){return b.message=s.message,typeof s.increment=="number"&&(typeof b.increment=="number"?b.increment+=s.increment:b.increment=s.increment),b}class N extends I.Progress{constructor(s,p){super(n=>this.throttledReport(n));this._proxy=s,this._handle=p}throttledReport(s){this._proxy.$progressReport(this._handle,s)}}Fe([(0,y.throttle)(100,(b,s)=>R(b,s),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(ve[90],Ee([1,0,42,15,53,8,7]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(s,p,n){const i=A._Keys.nextId();s.$registerTextEditorDecorationType(p.identifier,i,x.DecorationRenderOptions.from(n)),this.value=Object.freeze({key:i,dispose(){s.$removeTextEditorDecorationType(i)}})}}e.TextEditorDecorationType=A,A._Keys=new _.IdGenerator("TextEditorDecorationType");class C{constructor(s,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=s,this._documentVersionId=s.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(s,p){this._throwIfFinalized();let n=null;if(s instanceof y.Position)n=new y.Range(s,s);else if(s instanceof y.Range)n=s;else throw new Error("Unrecognized location");this._pushEdit(n,p,!1)}insert(s,p){this._throwIfFinalized(),this._pushEdit(new y.Range(s,s),p,!0)}delete(s){this._throwIfFinalized();let p=null;if(s instanceof y.Range)p=s;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(s,p,n){const i=this._document.validateRange(s);this._collectedEdits.push({range:i,text:p,forceMoveMarkers:n})}setEndOfLine(s){if(this._throwIfFinalized(),s!==y.EndOfLine.LF&&s!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=s}}e.TextEditorEdit=C;class R{constructor(s,p,n,i){this._proxy=s,this._id=p,this._accept(n),this._logService=i;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(S){d._setTabSize(S)},get insertSpaces(){return d._insertSpaces},set insertSpaces(S){d._setInsertSpaces(S)},get cursorStyle(){return d._cursorStyle},set cursorStyle(S){d._setCursorStyle(S)},get lineNumbers(){return d._lineNumbers},set lineNumbers(S){d._setLineNumbers(S)}}}_accept(s){this._tabSize=s.tabSize,this._insertSpaces=s.insertSpaces,this._cursorStyle=s.cursorStyle,this._lineNumbers=x.TextEditorLineNumbersStyle.to(s.lineNumbers)}_validateTabSize(s){if(s==="auto")return"auto";if(typeof s=="number"){const p=Math.floor(s);return p>0?p:null}if(typeof s=="string"){const p=parseInt(s,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(s){const p=this._validateTabSize(s);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(s){return s==="auto"?"auto":s==="false"?!1:Boolean(s)}_setInsertSpaces(s){const p=this._validateInsertSpaces(s);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(s){this._cursorStyle!==s&&(this._cursorStyle=s,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:s})))}_setLineNumbers(s){this._lineNumbers!==s&&(this._lineNumbers=s,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:x.TextEditorLineNumbersStyle.from(s)})))}assign(s){const p={};let n=!1;if(typeof s.tabSize!="undefined"){const i=this._validateTabSize(s.tabSize);i==="auto"?(n=!0,p.tabSize=i):typeof i=="number"&&this._tabSize!==i&&(this._tabSize=i,n=!0,p.tabSize=i)}if(typeof s.insertSpaces!="undefined"){const i=this._validateInsertSpaces(s.insertSpaces);i==="auto"?(n=!0,p.insertSpaces=i):this._insertSpaces!==i&&(this._insertSpaces=i,n=!0,p.insertSpaces=i)}typeof s.cursorStyle!="undefined"&&this._cursorStyle!==s.cursorStyle&&(this._cursorStyle=s.cursorStyle,n=!0,p.cursorStyle=s.cursorStyle),typeof s.lineNumbers!="undefined"&&this._lineNumbers!==s.lineNumbers&&(this._lineNumbers=s.lineNumbers,n=!0,p.lineNumbers=x.TextEditorLineNumbersStyle.from(s.lineNumbers)),n&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,p))}_warnOnError(s,p){p.catch(n=>{this._logService.warn(`ExtHostTextEditorOptions '${s}' failed:'`),this._logService.warn(n)})}}e.ExtHostTextEditorOptions=R;class N{constructor(s,p,n,i,d,S,M,u){this.id=s,this._proxy=p,this._logService=n,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new R(this._proxy,this.id,S,n),this._visibleRanges=M,this._viewColumn=u;const f=this;this.value=Object.freeze({get document(){return i.getValue()},set document(w){throw(0,I.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(w){if(!(w instanceof y.Selection))throw(0,I.illegalArgument)("selection");f._selections=[w],f._trySetSelection()},get selections(){return f._selections},set selections(w){if(!Array.isArray(w)||w.some(a=>!(a instanceof y.Selection)))throw(0,I.illegalArgument)("selections");f._selections=w,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(w){throw(0,I.readonly)("visibleRanges")},get options(){return f._options.value},set options(w){f._disposed||f._options.assign(w)},get viewColumn(){return f._viewColumn},set viewColumn(w){throw(0,I.readonly)("viewColumn")},edit(w,a={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const P=new C(i.getValue(),a);return w(P),f._applyEdit(P)},insertSnippet(w,a,P={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!a||Array.isArray(a)&&a.length===0)c=f._selections.map(t=>x.Range.from(t));else if(a instanceof y.Position){const{lineNumber:t,column:h}=x.Position.from(a);c=[{startLineNumber:t,startColumn:h,endLineNumber:t,endColumn:h}]}else if(a instanceof y.Range)c=[x.Range.from(a)];else{c=[];for(const t of a)if(t instanceof y.Range)c.push(x.Range.from(t));else{const{lineNumber:h,column:o}=x.Position.from(t);c.push({startLineNumber:h,startColumn:o,endLineNumber:h,endColumn:o})}}return p.$tryInsertSnippet(s,w.value,c,P)},setDecorations(w,a){const P=a.length===0;P&&!f._hasDecorationsForKey.has(w.key)||(P?f._hasDecorationsForKey.delete(w.key):f._hasDecorationsForKey.add(w.key),f._runOnProxy(()=>{if(x.isDecorationOptionsArr(a))return p.$trySetDecorations(s,w.key,x.fromRangeOrRangeWithMessage(a));{const c=new Array(4*a.length);for(let t=0,h=a.length;t<h;t++){const o=a[t];c[4*t]=o.start.line+1,c[4*t+1]=o.start.character+1,c[4*t+2]=o.end.line+1,c[4*t+3]=o.end.character+1}return p.$trySetDecorationsFast(s,w.key,c)}}))},revealRange(w,a){f._runOnProxy(()=>p.$tryRevealRange(s,x.Range.from(w),a||y.TextEditorRevealType.Default))},show(w){p.$tryShowEditor(s,x.ViewColumn.from(w))},hide(){p.$tryHideEditor(s)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(s){(0,r.ok)(!this._disposed),this._options._accept(s)}_acceptVisibleRanges(s){(0,r.ok)(!this._disposed),this._visibleRanges=s}_acceptViewColumn(s){(0,r.ok)(!this._disposed),this._viewColumn=s}_acceptSelections(s){(0,r.ok)(!this._disposed),this._selections=s}async _trySetSelection(){const s=this._selections.map(x.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,s)),this.value}_applyEdit(s){const p=s.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const n=p.edits.map(d=>d.range);n.sort((d,S)=>d.end.line===S.end.line?d.end.character===S.end.character?d.start.line===S.start.line?d.start.character-S.start.character:d.start.line-S.start.line:d.end.character-S.end.character:d.end.line-S.end.line);for(let d=0,S=n.length-1;d<S;d++){const M=n[d].end;if(n[d+1].start.isBefore(M))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const i=p.edits.map(d=>({range:x.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,i,{setEndOfLine:typeof p.setEndOfLine=="number"?x.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(s){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):s().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=N}),define(ve[170],Ee([1,0,11,5,6,13,48,8,61,62]),function(Y,e,r,I,_,x,y,A,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class N extends _.Disposable{constructor(s){super();this.controllerId=s,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new I.Emitter),this.root=new y.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(s){this._resolveHandler=s;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const s=this.diff;return this.diff=[],s}pushDiff(s){const p=this.diff[this.diff.length-1];if(p&&s[0]===1){if(p[0]===1&&p[1].extId===s[1].extId){(0,C.applyTestItemUpdate)(p[1],s[1]);return}if(p[0]===0&&p[1].item.extId===s[1].extId){(0,C.applyTestItemUpdate)(p[1],s[1]);return}}this.diff.push(s),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(s,p){const n=this.tree.get(s);if(!!n){if((n.expandLevels===void 0||p>n.expandLevels)&&(n.expandLevels=p),n.expand===1){const i=this.resolveChildren(n);return i.isOpen()?this.expandChildren(n,p-1):i.wait().then(()=>this.expandChildren(n,p-1))}else if(n.expand===3)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.expandChildren(n,p-1)):this.expandChildren(n,p-1)}}dispose(){for(const s of this.tree.values())(0,y.getPrivateApiFor)(s.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(s,p){switch(p.op){case 2:this.pushDiff([4,s.fullId.toString()]);break;case 1:this.removeItem(R.TestId.joinToString(s.fullId,p.id));break;case 0:this.upsertItem(p.item,s);break;case 4:for(const n of p.ops)this.onTestItemEvent(s,n);break;case 3:{const{key:n,value:i,previous:d}=p,S=s.fullId.toString();switch(n){case"canResolveChildren":this.updateExpandability(s);break;case"tags":this.diffTagRefs(i,d,S);break;case"range":this.pushDiff([1,{extId:S,item:{range:A.Range.from(i)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:A.MarkdownString.fromStrict(i)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[n]:i??null}}]);break}break}default:(0,x.assertNever)(p)}}upsertItem(s,p){if(!(s instanceof y.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${s.id} did not`);const n=R.TestId.fromExtHostTestItem(s,this.root.id,p?.actual),i=(0,y.getPrivateApiFor)(s);i.parent&&i.parent!==p?.actual&&i.parent.children.delete(s.id);let d=this.tree.get(n.toString());if(!d){d={fullId:n,actual:s,parent:p?n.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},s.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(s,p),this.pushDiff([0,{parent:d.parent&&d.parent.toString(),controllerId:this.controllerId,expand:d.expand,item:A.TestItem.from(s)}]),this.connectItemAndChildren(s,d,p);return}if(d.actual===s){this.connectItem(s,d,p);return}const S=d.actual.children,M=d.actual,u=(0,y.diffTestItems)(M,s);(0,y.getPrivateApiFor)(M).listener=void 0,d.actual=s,d.expand=0;for(const[f,w]of u)this.onTestItemEvent(d,{op:3,key:f,value:w,previous:M[f]});this.connectItemAndChildren(s,d,p);for(const f of S)s.children.get(f.id)||this.removeItem(R.TestId.joinToString(n,f.id))}diffTagRefs(s,p,n){const i=new Set(p.map(d=>d.id));for(const d of s)i.delete(d.id)||this.incrementTagRefs(d);this.pushDiff([1,{extId:n,item:{tags:s.map(d=>A.TestTag.namespace(this.controllerId,d.id))}}]),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(s){const p=this.tags.get(s.id);p?p.refCount++:(this.tags.set(s.id,{refCount:1}),this.pushDiff([5,{id:A.TestTag.namespace(this.controllerId,s.id),ctrlLabel:this.root.label}]))}decrementTagRefs(s){const p=this.tags.get(s);p&&!--p.refCount&&(this.tags.delete(s),this.pushDiff([6,A.TestTag.namespace(this.controllerId,s)]))}setItemParent(s,p){(0,y.getPrivateApiFor)(s).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(s,p,n){this.setItemParent(s,n);const i=(0,y.getPrivateApiFor)(s);i.parent=n?.actual,i.listener=d=>this.onTestItemEvent(p,d),this.updateExpandability(p)}connectItemAndChildren(s,p,n){this.connectItem(s,p,n);for(const i of s.children)this.upsertItem(i,p)}updateExpandability(s){let p;this._resolveHandler?s.resolveBarrier?p=s.resolveBarrier.isOpen()?3:2:p=s.actual.canResolveChildren?1:0:p=0,p!==s.expand&&(s.expand=p,this.pushDiff([1,{extId:s.fullId.toString(),expand:p}]),p===1&&s.expandLevels!==void 0&&this.resolveChildren(s))}expandChildren(s,p){if(p<0)return;const n=[];for(const i of s.actual.children){const d=this.expand(R.TestId.joinToString(s.fullId,i.id),p);(0,r.isThenable)(d)&&n.push(d)}if(n.length)return Promise.all(n).then(()=>{})}resolveChildren(s){if(s.resolveBarrier)return s.resolveBarrier;if(!this._resolveHandler){const d=new r.Barrier;return d.open(),d}s.expand=2,this.pushExpandStateUpdate(s);const p=s.resolveBarrier=new r.Barrier,n=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),s.actual!==this.root&&(s.actual.error=d.stack||d.message||String(d))};let i;try{i=this._resolveHandler(s.actual===this.root?void 0:s.actual)}catch(d){n(d)}return(0,r.isThenable)(i)?i.catch(n).then(()=>{p.open(),this.updateExpandability(s)}):(p.open(),this.updateExpandability(s)),s.resolveBarrier}pushExpandStateUpdate(s){this.pushDiff([1,{extId:s.fullId.toString(),expand:s.expand}])}removeItem(s){const p=this.tree.get(s);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,s]);const n=[p];for(;n.length;){const i=n.pop();if(!!i){(0,y.getPrivateApiFor)(i.actual).listener=void 0;for(const d of i.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(i.fullId.toString());for(const d of i.actual.children)n.push(this.tree.get(R.TestId.joinToString(i.fullId,d.id)))}}}flushDiff(){const s=this.collectDiff();s.length&&this.diffOpEmitter.fire(s)}}e.SingleUseTestCollection=N}),define(ve[171],Ee([1,0,3,137]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(I.IEnvironmentService)}),define(ve[172],Ee([1,0,25,5,17]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class x{constructor(N){this.removedDueToLooping=N}}e.DeltaExtensionsResult=x;class y{constructor(N){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=N,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const N of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(N.identifier))){console.error("Extension `"+N.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(N.identifier),N),this._extensionsArr.push(N),Array.isArray(N.activationEvents))for(let b of N.activationEvents)b==="onUri"&&(b=`onUri:${r.ExtensionIdentifier.toKey(N.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(N)}}keepOnly(N){const b=new Set;N.forEach(s=>b.add(r.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>b.has(r.ExtensionIdentifier.toKey(s.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(N,b){N.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(N));const s=y._findLoopingExtensions(this._extensionDescriptions);if(b=b.concat(s.map(p=>p.identifier)),b.length>0){const p=new Set;b.forEach(n=>p.add(r.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>!p.has(r.ExtensionIdentifier.toKey(n.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new x(s)}static _findLoopingExtensions(N){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,S){this.addNode(d),this.addNode(S),this._arcs.has(d)?this._arcs.get(d).push(S):this._arcs.set(d,[S])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,S){const M=b.getArcs(d);for(let u=0;u<M.length;u++)if(!S.has(M[u]))return!1;return!0}getNodes(){return this._nodesArr}};let s=new Map;for(let d of N){const S=r.ExtensionIdentifier.toKey(d.identifier);if(s.set(S,d),d.extensionDependencies)for(let M of d.extensionDependencies){const u=r.ExtensionIdentifier.toKey(M);b.addArc(S,u)}}let p=new Set;b.getNodes().filter(d=>b.getArcs(d).length===0).forEach(d=>p.add(d));let n=b.getNodes().filter(d=>!p.has(d)),i;do{i=!1;for(let d=0;d<n.length;d++){const S=n[d];b.hasOnlyGoodArcs(S,p)&&(n.splice(d,1),d--,p.add(S),i=!0)}}while(i);return n.map(d=>s.get(d))}containsActivationEvent(N){return this._activationMap.has(N)}containsExtension(N){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(N))}getExtensionDescriptionsForActivationEvent(N){const b=this._activationMap.get(N);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(N){const b=this._extensionsMap.get(r.ExtensionIdentifier.toKey(N));return b||void 0}}e.ExtensionDescriptionRegistry=y;var A;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(A||(A={}));function C(R,N){const b=R.isBuiltin?0:R.isUnderDevelopment?2:1,s=N.isBuiltin?0:N.isUnderDevelopment?2:1;if(b!==s)return b-s;const p=_.posix.basename(R.extensionLocation.path),n=_.posix.basename(N.extensionLocation.path);return p<n?-1:p>n?1:0}}),define(ve[91],Ee([1,0,21]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var I;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var _;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(_=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var x;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(x=e.MessageType||(e.MessageType={}));function y(C){const R=r.VSBuffer.alloc(1);switch(C){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=y;function A(C,R){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=A}),define(ve[27],Ee([1,0,5,2,3,25,143]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new x.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var A;(function(f){f[f.None=0]="None",f[f.LocalProcess=1]="LocalProcess",f[f.LocalWebWorker=2]="LocalWebWorker",f[f.Remote=3]="Remote"})(A=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(f){switch(f){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class R{constructor(w){this.dependency=w}}e.MissingExtensionDependency=R;var N;(function(f){f[f.LocalProcess=0]="LocalProcess",f[f.LocalWebWorker=1]="LocalWebWorker",f[f.Remote=2]="Remote"})(N=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(f){switch(f){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=b;function s(f,w){return f.enabledApiProposals?f.enabledApiProposals.includes(w):!1}e.isProposedApiEnabled=s;function p(f,w){if(!s(f,w))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${w}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${w}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.checkProposedApiEnabled=p;class n{constructor(w,a,P,c){this.codeLoadingTime=w,this.activateCallTime=a,this.activateResolvedTime=P,this.activationReason=c}}e.ActivationTimes=n;class i{constructor(w,a){this.description=w,this.value=a}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var d;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function S(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation}}e.toExtension=S;function M(f,w){return{identifier:new x.ExtensionIdentifier((0,y.getExtensionId)(f.manifest.publisher,f.manifest.name)),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!w,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid}}e.toExtensionDescription=M;class u{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None}activateByEvent(w){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(w,a){return Promise.resolve()}}e.NullExtensionService=u}),define(ve[173],Ee([1,0,15,25,27,12]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(i,d,S,M){this.startup=i,this.codeLoadingTime=d,this.activateCallTime=S,this.activateResolvedTime=M}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class C{constructor(i){this._startup=i,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(i,d){return i===-1||d===-1?-1:d-i}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class R{constructor(i,d,S,M,u,f){this.activationFailed=i,this.activationFailedError=d,this.activationTimes=S,this.module=M,this.exports=u,this.subscriptions=f}}e.ActivatedExtension=R;class N extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=N;class b extends R{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class s extends R{constructor(i){super(!0,i,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=s;let p=class{constructor(i,d,S,M,u){this._logService=u,this._isDisposed=!1,this._registry=i,this._resolvedExtensionsSet=new Set,d.forEach(f=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(f))),this._hostExtensionsMap=new Map,S.forEach(f=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(f),f)),this._host=M,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(i){const d=I.ExtensionIdentifier.toKey(i);return this._activatedExtensions.has(d)}getActivatedExtension(i){const d=I.ExtensionIdentifier.toKey(i),S=this._activatedExtensions.get(d);if(!S)throw new Error("Extension `"+i.value+"` is not known or not activated");return S}activateByEvent(i,d){if(this._alreadyActivatedEvents[i])return y;const S=this._registry.getExtensionDescriptionsForActivationEvent(i);return this._activateExtensions(S.map(M=>({id:M.identifier,reason:{startup:d,extensionId:M.identifier,activationEvent:i}}))).then(()=>{this._alreadyActivatedEvents[i]=!0})}activateById(i,d){const S=this._registry.getExtensionDescription(i);if(!S)throw new Error("Extension `"+i+"` is not known");return this._activateExtensions([{id:S.identifier,reason:d}])}_handleActivateRequest(i,d,S){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(i.id))){d[I.ExtensionIdentifier.toKey(i.id)]=i;return}const M=this._registry.getExtensionDescription(i.id);if(!M){const w=new Error(`Cannot activate unknown extension '${i.id.value}'`);this._host.onExtensionActivationError(i.id,w,new _.MissingExtensionDependency(i.id.value)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(i.id),new s(w));return}const u=typeof M.extensionDependencies=="undefined"?[]:M.extensionDependencies;let f=!0;for(let w=0,a=u.length;w<a;w++){const P=u[w];if(this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(P)))continue;const c=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(P));if(c&&!c.activationFailed)continue;if(c&&c.activationFailed){const l=M.displayName||M.identifier.value,E=this._registry.getExtensionDescription(P),m=E&&E.displayName||P,v=new Error(`Cannot activate the '${l}' extension because its dependency '${m}' failed to activate`);v.detail=c.activationFailedError,this._host.onExtensionActivationError(M.identifier,v,null),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(M.identifier),new s(v));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(P))){f=!1,d[I.ExtensionIdentifier.toKey(P)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(P)),reason:i.reason};continue}const t=this._registry.getExtensionDescription(P);if(t){if(!t.main&&!t.browser)continue;f=!1,d[I.ExtensionIdentifier.toKey(P)]={id:t.identifier,reason:i.reason};continue}const h=M.displayName||M.identifier.value,o=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${P}'`);this._host.onExtensionActivationError(M.identifier,o,new _.MissingExtensionDependency(P)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(M.identifier),new s(o));return}f?d[I.ExtensionIdentifier.toKey(M.identifier)]=i:S.push(i)}_activateExtensions(i){if(i.length===0||(i=i.filter(u=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(u.id))),i.length===0))return Promise.resolve(void 0);const d=Object.create(null),S=[];for(let u=0,f=i.length;u<f;u++)this._handleActivateRequest(i[u],d,S);for(let u=0,f=S.length;u<f;u++){const w=I.ExtensionIdentifier.toKey(S[u].id);d[w]&&delete d[w]}const M=Object.keys(d).map(u=>d[u]);return S.length===0?Promise.all(M.map(u=>this._activateExtension(u.id,u.reason))).then(u=>{}):this._activateExtensions(M).then(u=>this._activateExtensions(S))}_activateExtension(i,d){const S=I.ExtensionIdentifier.toKey(i);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const M=this._activatingExtensions.get(S);if(M)return M;const u=this._host.actualActivateExtension(i,d).then(void 0,f=>{const w=new Error;return f&&f.name&&(w.name=f.name),f&&f.message?w.message=`Activating extension '${i.value}' failed: ${f.message}.`:w.message=`Activating extension '${i.value}' failed: ${f}.`,f&&f.stack&&(w.stack=f.stack),this._isDisposed&&r.isCancellationError(f)?new s(f):(this._host.onExtensionActivationError(i,w,null),this._logService.error(`Activating extension ${i.value} failed due to an error:`),this._logService.error(f),new s(f))}).then(f=>{this._activatedExtensions.set(S,f),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,u),u}};p=Fe([Ne(4,x.ILogService)],p),e.ExtensionsActivator=p}),define(ve[174],Ee([1,0,12,28,27]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let x=class extends r.LogService{constructor(A,C){super(A.createLogger(C.logFile,{name:_.ExtensionHostLogFileName}))}};x=Fe([Ne(0,r.ILoggerService),Ne(1,I.IExtHostInitDataService)],x),e.ExtHostLogService=x}),define(ve[175],Ee([1,0,15]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((x,y)=>{this._actualOk=x,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(x){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=x,this._actual&&this._actualOk(x))}resolveErr(x){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=x,this._actual?this._actualErr(x):(0,r.onUnexpectedError)(x))}then(x,y){return this._ensureActual().then(x,y)}catch(x){return this._ensureActual().then(void 0,x)}finally(x){return this._ensureActual().finally(x)}}e.LazyPromise=I}),define(ve[38],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(C){this._proxyIdentifierBrand=void 0,this.sid=C,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const I=[];function _(A){const C=new r(A);return I[C.nid]=C,C}e.createProxyIdentifier=_;function x(A){return I[A].sid}e.getStringIdentifierForProxy=x;class y{constructor(C){this.value=C}}e.SerializableObjectWithBuffers=y}),define(ve[4],Ee([1,0,54,2,38]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=void 0;var x;(function(S){S[S.Default=0]="Default",S[S.InCenter=1]="InCenter",S[S.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",S[S.AtTop=3]="AtTop"})(x=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(S){S[S.Editable=0]="Editable",S[S.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(S){S[S.Int8Array=1]="Int8Array",S[S.Uint8Array=2]="Uint8Array",S[S.Uint8ClampedArray=3]="Uint8ClampedArray",S[S.Int16Array=4]="Int16Array",S[S.Uint16Array=5]="Uint16Array",S[S.Int32Array=6]="Int32Array",S[S.Uint32Array=7]="Uint32Array",S[S.Float32Array=8]="Float32Array",S[S.Float64Array=9]="Float64Array",S[S.BigInt64Array=10]="BigInt64Array",S[S.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(S){S[S.Text=1]="Text",S[S.Error=2]="Error",S[S.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(S){S[S.Default=0]="Default",S[S.InCenter=1]="InCenter",S[S.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",S[S.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(S){S[S.None=0]="None",S[S.Process=1]="Process",S[S.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(M){return M._id=b._n++,M}}e.IdObject=b,b._n=0;var s;(function(S){S.label="a",S.kind="b",S.detail="c",S.documentation="d",S.sortText="e",S.filterText="f",S.preselect="g",S.insertText="h",S.insertTextRules="i",S.range="j",S.commitCharacters="k",S.additionalTextEdits="l",S.command="m",S.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(S){S.defaultRanges="a",S.completions="b",S.isIncomplete="c",S.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var n;(function(S){S[S.File=1]="File",S[S.Text=2]="Text",S[S.Cell=3]="Cell"})(n=e.WorkspaceEditType||(e.WorkspaceEditType={}));function i(S){if(S&&S.edits)for(const M of S.edits)typeof M.resource=="object"?M.resource=I.URI.revive(M.resource):(M.newUri=I.URI.revive(M.newUri),M.oldUri=I.URI.revive(M.oldUri)),M.metadata&&M.metadata.iconPath&&(M.metadata=(0,r.revive)(M.metadata));return S}e.reviveWorkspaceEditDto=i;var d;(function(S){S[S.Workspace=0]="Workspace",S[S.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,_.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,_.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,_.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,_.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createProxyIdentifier)("ExtHostTelemetry")}}),define(ve[63],Ee([1,0,4,5,3]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class x{constructor(A){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,C){return this._proxy.$getPassword(A,C)}store(A,C,R){return this._proxy.$setPassword(A,C,R)}delete(A,C){return this._proxy.$deletePassword(A,C)}}e.ExtHostSecretState=x,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(ve[64],Ee([1,0,3,12,4,14]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(C,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(_.MainContext.MainThreadTelemetry)}report(C,R,N){const b=this.getUsageKey(C,R);this._reportedUsages.has(b)||(this._reportedUsages.add(b),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${N}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:C}))}getUsageKey(C,R){return`${C}-${R.identifier.value}`}};y=Fe([Ne(0,x.IExtHostRpcService),Ne(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(A,C,R){}})}),define(ve[176],Ee([1,0,5,4,7,25]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,R,N,b={}){const s=x.ExtensionIdentifier.toKey(C.identifier),p=this._inFlightRequests.get(s)||[],n=[...N].sort().join(" ");let i=p.find(d=>d.scopes===n);if(i)return i.result;{const d=this._getSession(C,s,R,N,b);i={scopes:n,result:d},p.push(i),this._inFlightRequests.set(s,p);try{await d}finally{const S=p.findIndex(M=>M.scopes===n);S>-1&&(p.splice(S),this._inFlightRequests.set(s,p))}return d}}async _getSession(C,R,N,b,s={}){await this._proxy.$ensureProvider(N);const p=C.displayName||C.name;return this._proxy.$getSession(N,b,R,p,s)}async removeSession(C,R){const N=this._authenticationProviders.get(C);return N?N.provider.removeSession(R):this._proxy.$removeSession(C,R)}registerAuthenticationProvider(C,R,N,b){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:R,provider:N,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===C)||this._providers.push({id:C,label:R});const s=N.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(C,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,R,b?.supportsMultipleAccounts??!1),new _.Disposable(()=>{s.dispose(),this._authenticationProviders.delete(C);const p=this._providers.findIndex(n=>n.id===C);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,R){const N=this._authenticationProviders.get(C);if(N)return Promise.resolve(N.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,R){const N=this._authenticationProviders.get(C);if(N)return Promise.resolve(N.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,R){const N=this._authenticationProviders.get(C);if(N)return Promise.resolve(N.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,R){return this._onDidChangeSessions.fire({provider:{id:C,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ve[177],Ee([1,0,4,14,8]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let x=class{constructor(A,C){this._proxy=A.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>C.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A){const C=_.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(C)}};x=Fe([Ne(0,I.IExtHostRpcService)],x),e.ExtHostBulkEdits=x}),define(ve[178],Ee([1,0,4]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(x){const y=x.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(A){return y.$writeText(A)}})}}e.ExtHostClipboard=I});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[39],Ee([1,0,13,7,8,26,4,16,12,54,87,228,2,6,3,14,48,21,38,43]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(o,l){f.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,je(this,f,o.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=l,this.converter=new a(this,E=>{const m=this._apiCommands.get(E);return m?.result===c.Void?m:void 0},l),this._argumentProcessors=[{processArgument(E){return(0,R.revive)(E)}},{processArgument(E){return(0,x.cloneAndChange)(E,function(m){if(N.Range.isIRange(m))return _.Range.to(m);if(b.Position.isIPosition(m))return _.Position.to(m);if(N.Range.isIRange(m.range)&&s.URI.isUri(m.uri))return _.location.to(m);if(m instanceof S.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const l=this.registerCommand(!1,o.id,async(...E)=>{const m=o.args.map((k,T)=>{if(!k.validate(E[T]))throw new Error(`Invalid argument '${k.name}' when running '${o.id}', received: ${E[T]}`);return k.convert(E[T])}),v=await this.executeCommand(o.internalId,...m);return o.result.convert(v,E,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new I.Disposable(()=>{l.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,l,E,m,v,k){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:E,thisArg:m,description:v,extension:k}),o&&ye(this,f,"f").$registerCommand(l),new I.Disposable(()=>{this._commands.delete(l)&&o&&ye(this,f,"f").$unregisterCommand(l)})}executeCommand(o,...l){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,l,!0)}async _doExecuteCommand(o,l,E){if(this._commands.has(o))return this._executeContributedCommand(o,l,!1);{let m=!1;const v=(0,x.cloneAndChange)(l,function(k){if(k instanceof I.Position)return _.Position.from(k);if(k instanceof I.Range)return _.Range.from(k);if(k instanceof I.Location)return _.location.from(k);if(I.NotebookRange.isNotebookRange(k))return _.NotebookRange.from(k);if(k instanceof ArrayBuffer)return m=!0,S.VSBuffer.wrap(new Uint8Array(k));if(k instanceof Uint8Array)return m=!0,S.VSBuffer.wrap(k);if(!Array.isArray(k))return k});try{const k=await ye(this,f,"f").$executeCommand(o,m?new M.SerializableObjectWithBuffers(v):v,E);return(0,R.revive)(k)}catch(k){if(k instanceof Error&&k.message==="$executeCommand:retry")return this._doExecuteCommand(o,l,!1);throw k}}}async _executeContributedCommand(o,l,E){const m=this._commands.get(o);if(!m)throw new Error("Unknown command");let{callback:v,thisArg:k,description:T}=m;if(T)for(let $=0;$<T.args.length;$++)try{(0,r.validateConstraint)(l[$],T.args[$].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${T.args[$].name}' - ${T.args[$].description}`)}try{return await v.apply(k,l)}catch($){if(o===this.converter.delegatingCommandId){const g=this.converter.getActualCommand(...l);g&&(o=g.command)}throw this._logService.error($,o,m.extension?.identifier),E?new class extends Error{constructor(){super((0,u.toErrorMessage)($));this.id=o,this.source=m.extension?.displayName??m.extension?.name}}:$}}$executeContributedCommand(o,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(l=l.map(E=>this._argumentProcessors.reduce((m,v)=>v.processArgument(m),E)),this._executeContributedCommand(o,l,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),ye(this,f,"f").$getCommands().then(l=>(o&&(l=l.filter(E=>E[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(let[l,E]of this._commands){let{description:m}=E;m&&(o[l]=m)}return Promise.resolve(o)}};f=new WeakMap,w=Fe([Ne(0,i.IExtHostRpcService),Ne(1,C.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=(0,n.createDecorator)("IExtHostCommands");class a{constructor(o,l,E){this._commands=o,this._lookupApiCommand=l,this._logService=E,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,l){if(!o)return;const E={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return E;const m=this._lookupApiCommand(o.command);if(m)E.id=m.internalId,E.arguments=m.args.map((v,k)=>v.convert(o.arguments&&o.arguments[k]));else if((0,A.isNonEmptyArray)(o.arguments)){const v=++this._cachIdPool;this._cache.set(v,o),l.add((0,p.toDisposable)(()=>{this._cache.delete(v),this._logService.trace("CommandsConverter#DISPOSE",v)})),E.$ident=v,E.id=this.delegatingCommandId,E.arguments=[v],this._logService.trace("CommandsConverter#CREATE",o.command,v)}return E}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const l=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class P{constructor(o,l,E,m){this.name=o,this.description=l,this.validate=E,this.convert=m}optional(){return new P(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,l){return new P(o??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",h=>s.URI.isUri(h),h=>h),P.Position=new P("position","A position in a text document",h=>I.Position.isPosition(h),_.Position.from),P.Range=new P("range","A range in a text document",h=>I.Range.isRange(h),_.Range.from),P.Selection=new P("selection","A selection in a text document",h=>I.Selection.isSelection(h),_.Selection.from),P.Number=new P("number","",h=>typeof h=="number",h=>h),P.String=new P("string","",h=>typeof h=="string",h=>h),P.CallHierarchyItem=new P("item","A call hierarchy item",h=>h instanceof I.CallHierarchyItem,_.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",h=>h instanceof I.TypeHierarchyItem,_.TypeHierarchyItem.from),P.TestItem=new P("testItem","A VS Code TestItem",h=>h instanceof d.TestItemImpl,_.TestItem.from);class c{constructor(o,l){this.description=o,this.convert=l}}e.ApiCommandResult=c,c.Void=new c("no result",h=>h);class t{constructor(o,l,E,m,v){this.id=o,this.internalId=l,this.description=E,this.args=m,this.result=v}}e.ApiCommand=t}),define(ve[179],Ee([1,0,2,8,7,88,39,16,74,78,9]),function(Y,e,r,I,_,x,y,A,C,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,d)=>{if((0,A.isFalsyOrEmpty)(i))return;class S extends _.SymbolInformation{static to(u){const f=new S(u.name,I.SymbolKind.to(u.kind),u.containerName||"",new _.Location(d[0],I.Range.to(u.range)));return f.detail=u.detail,f.range=f.location.range,f.selectionRange=I.Range.to(u.selectionRange),f.children=u.children?u.children.map(S.to):[],f}}return i.map(S.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new y.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",n)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",n)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",n)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",n)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(d=>_.Position.isPosition(d)),i=>i.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(d=>{let S;for(const M of d.reverse())S=new _.SelectionRange(I.Range.to(M),S);return S}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(I.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:I.Range.to(i.range),placeholder:i.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return I.WorkspaceEdit.to(i)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new _.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const d=(0,C.decodeSemanticTokensDto)(i);if(d.type==="full")return new _.SemanticTokens(d.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new _.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const d=(0,C.decodeSemanticTokensDto)(i);if(d.type==="full")return new _.SemanticTokens(d.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,d,S)=>{if(!i)return new _.CompletionList([]);const M=i.suggestions.map(u=>I.CompletionItem.to(u,S));return new _.CompletionList(M,i.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return I.SignatureHelp.to(i)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,d,S)=>p(M=>new _.CodeLens(I.Range.to(M.range),M.command&&S.fromInternal(M.command)))(i))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>_.Range.isRange(i),i=>_.Selection.isSelection(i)?I.Selection.from(i):I.Range.from(i)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,d,S)=>p(M=>{if(M._isSynthetic){if(!M.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(M.command)}else{const u=new _.CodeAction(M.title,M.kind?new _.CodeActionKind(M.kind):void 0);return M.edit&&(u.edit=I.WorkspaceEdit.to(M.edit)),M.command&&(u.command=S.fromInternal(M.command)),u.isPreferred=M.isPreferred,u}})(i))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(d=>new _.ColorInformation(I.Range.to(d.range),I.Color.to(d.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",i=>i instanceof _.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:I.Range.from(i.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,d,S)=>i.map(I.InlayHint.to.bind(void 0,S)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(d=>I.NotebookExclusiveDocumentPattern.to(d))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",i=>r.URI.isUri(i)||typeof i=="string"&&(0,R.matchesSomeScheme)(i,N.Schemas.http,N.Schemas.https),i=>i),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[I.ViewColumn.from(i),void 0]:[I.ViewColumn.from(i.viewColumn),I.TextEditorOpenOptions.from(i)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[I.ViewColumn.from(i),void 0]:[I.ViewColumn.from(i.viewColumn),I.TextEditorOpenOptions.from(i)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[I.ViewColumn.from(i.viewColumn),I.TextEditorOpenOptions.from(i)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(I.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(I.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(I.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void)];class s{static register(d){b.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=s;function p(i){return d=>{if(Array.isArray(d))return d.map(i)}}function n(i){if(!Array.isArray(i))return;const d=[];for(const S of i)x.isLocationLink(S)?d.push(I.DefinitionLink.to(S)):d.push(I.location.to(S));return d}}),define(ve[180],Ee([1,0,11,52,5,6,2,88,25,8,7,27,4]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(n,i,d){const S=n.getProxy(s.MainContext.MainThreadComments);class M{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,i.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const o=this._commentControllers.get(h.handle);return o||h}else if(h&&h.$mid===7){const o=this._commentControllers.get(h.commentControlHandle);if(!o)return h;const l=o.getCommentThread(h.commentThreadHandle);return l||h}else if(h&&h.$mid===8){const o=this._commentControllers.get(h.thread.commentControlHandle);if(!o)return h;const l=o.getCommentThread(h.thread.commentThreadHandle);return l?{thread:l,text:h.text}:h}else if(h&&h.$mid===9){const o=this._commentControllers.get(h.thread.commentControlHandle);if(!o)return h;const l=o.getCommentThread(h.thread.commentThreadHandle);if(!l)return h;let E=h.commentUniqueId,m=l.getCommentByUniqueId(E);return m||h}else if(h&&h.$mid===10){const o=this._commentControllers.get(h.thread.commentControlHandle);if(!o)return h;const l=o.getCommentThread(h.thread.commentThreadHandle);if(!l)return h;let E=h.text,m=h.commentUniqueId,v=l.getCommentByUniqueId(m);return v?(v.body=E,v):h}return h}})}createCommentController(h,o,l){const E=M.handlePool++,m=new f(h,E,o,l);this._commentControllers.set(m.handle,m);const v=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(h.identifier))||[];return v.push(m),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(h.identifier),v),m.value}$createCommentThreadTemplate(h,o,l){const E=this._commentControllers.get(h);!E||E.$createCommentThreadTemplate(o,l)}async $updateCommentThreadTemplate(h,o,l){const E=this._commentControllers.get(h);!E||E.$updateCommentThreadTemplate(o,l)}$deleteCommentThread(h,o){const l=this._commentControllers.get(h);l&&l.$deleteCommentThread(o)}$provideCommentingRanges(h,o,l){const E=this._commentControllers.get(h);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const m=d.getDocument(y.URI.revive(o));return(0,r.asPromise)(()=>E.commentingRangeProvider.provideCommentingRanges(m,l)).then(v=>v?v.map(k=>R.Range.from(k)):void 0)}$toggleReaction(h,o,l,E,m){const v=this._commentControllers.get(h);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const k=v.getCommentThread(o);if(k){const T=k.getCommentByUniqueId(E.uniqueIdInThread);if(v!==void 0&&T&&v.reactionHandler)return v.reactionHandler(T,P(m))}return Promise.resolve(void 0)})}dispose(){}}M.handlePool=0;class u{constructor(h,o,l,E,m,v,k){this._commentControllerHandle=o,this._id=l,this._uri=E,this._range=m,this._comments=v,this.extensionDescription=k,this.handle=u._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new x.MutableDisposable,this._acceptInputDisposables.value=new x.DisposableStore,this._id===void 0&&(this._id=`${h}.${this.handle}`),S.$createCommentThread(o,this.handle,this._id,this._uri,R.Range.from(this._range),k.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(o,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range($){T.range=$},get comments(){return T.comments},set comments($){T.comments=$},get collapsibleState(){return T.collapsibleState},set collapsibleState($){T.collapsibleState=$},get canReply(){return T.canReply},set canReply($){T.canReply=$},get contextValue(){return T.contextValue},set contextValue($){T.contextValue=$},get label(){return T.label},set label($){T.label=$},dispose:()=>{T.dispose()}}}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new x.DisposableStore);const h=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),o={};h("range")&&(o.range=R.Range.from(this._range)),h("label")&&(o.label=this.label),h("contextValue")&&(o.contextValue=this.contextValue??null),h("comments")&&(o.comments=this._comments.map(l=>w(this,l,this._commentsMap))),h("collapsibleState")&&(o.collapseState=c(this._collapseState)),h("canReply")&&(o.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(h){for(let o of this._commentsMap){let l=o[0],E=o[1];if(h===E)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose())}}u._handlePool=0,Fe([(0,I.debounce)(100)],u.prototype,"eventuallyUpdateCommentThread",null);class f{constructor(h,o,l,E){this._extension=h,this._handle=o,this._id=l,this._label=E,this._threads=new Map,S.$registerCommentController(this.handle,l,E);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(v){m.options=v},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(v){m.commentingRangeProvider=v},get reactionHandler(){return m.reactionHandler},set reactionHandler(v){m.reactionHandler=v},createCommentThread(v,k,T){return m.createCommentThread(v,k,T).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(h){this._commentingRangeProvider=h,S.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(h,o,l,E){if(typeof h=="string"){const m=new u(this.id,this.handle,h,o,l,E,this._extension);return this._threads.set(m.handle,m),m}else{const m=new u(this.id,this.handle,void 0,h,o,l,this._extension);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(h,o){const l=new u(this.id,this.handle,void 0,y.URI.revive(h),R.Range.to(o),[],this._extension);return l.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(h,o){let l=this._threads.get(h);l&&(l.range=R.Range.to(o))}$deleteCommentThread(h){let o=this._threads.get(h);o&&o.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._localDisposables.forEach(h=>h.dispose())}}function w(t,h,o){let l=o.get(h);l||(l=++t.commentHandle,o.set(h,l));const E=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;h.timestamp&&(0,b.checkProposedApiEnabled)(t.extensionDescription,"commentTimestamp");let m;return h.timestamp&&(m={source:h.timestamp,$mid:14}),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:l,body:typeof h.body=="string"?h.body:R.MarkdownString.from(h.body),userName:h.author.name,userIconPath:E,label:h.label,commentReactions:h.reactions?h.reactions.map(v=>a(v)):void 0,timestamp:m}}function a(t){return{label:t.label,iconPath:t.iconPath?R.pathOrURIToURI(t.iconPath):void 0,count:t.count,hasReacted:t.authorHasReacted}}function P(t){return{label:t.label||"",count:t.count||0,iconPath:t.iconPath?y.URI.revive(t.iconPath):"",authorHasReacted:t.hasReacted||!1}}function c(t){if(t!==void 0)switch(t){case N.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}return new M}e.createExtHostComments=p}),define(ve[92],Ee([1,0,2,4,7,3,14,12,16,10,17]),function(Y,e,r,I,_,x,y,A,C,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class wi{constructor(p,n){this._logService=n,this._provider=new Map,this._proxy=p.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,n){const i=wi._handlePool++;this._provider.set(i,{provider:p,extensionId:n}),this._proxy.$registerDecorationProvider(i,n.value);const d=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(i,null);return}let M=(0,C.asArray)(S);if(M.length<=wi._maxEventSize){this._proxy.$onDidChange(i,M);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",n.value,M.length);const u=M.map(a=>({uri:a,rank:(0,R.count)(a.path,"/")})),f=(0,C.groupBy)(u,(a,P)=>a.rank-P.rank||(0,R.compare)(a.uri.path,P.uri.path));let w=[];e:for(let a of f){let P;for(let c of a){let t=(0,N.dirname)(c.uri.path);if(P!==t&&(P=t,w.push(c.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(i,w)});return new _.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(i),this._provider.delete(i)})}async $provideDecorations(p,n,i){if(!this._provider.has(p))return Object.create(null);const d=Object.create(null),{provider:S,extensionId:M}=this._provider.get(p);return await Promise.all(n.map(async u=>{try{const{uri:f,id:w}=u,a=await Promise.resolve(S.provideFileDecoration(r.URI.revive(f),i));if(!a)return;try{_.FileDecoration.validate(a),d[w]=[a.propagate,a.tooltip,a.badge,a.color]}catch(P){this._logService.warn(`INVALID decoration from extension '${M.value}': ${P}`)}}catch(f){this._logService.error(f)}})),d}};b._handlePool=0,b._maxEventSize=250,b=Fe([Ne(0,y.IExtHostRpcService),Ne(1,A.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,x.createDecorator)("IExtHostDecorations")});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[181],Ee([1,0,121,77,2,4,7,8,5,12,22,30]),function(Y,e,r,I,_,x,y,A,C,R,N,b){"use strict";var s,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class i{constructor(M,u,f,w,a,P){this._name=M,this._owner=u,this._maxDiagnosticsPerFile=f,s.set(this,void 0),p.set(this,void 0),n.set(this,void 0),this._isDisposed=!1,je(this,n,new N.ResourceMap(c=>w.getComparisonKey(c)),"f"),je(this,s,a,"f"),je(this,p,P,"f")}dispose(){this._isDisposed||(ye(this,p,"f").fire([...ye(this,n,"f").keys()]),ye(this,s,"f")&&ye(this,s,"f").$clear(this._owner),ye(this,n,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(M,u){if(!M){this.clear();return}this._checkDisposed();let f=[];if(_.URI.isUri(M)){if(!u){this.delete(M);return}ye(this,n,"f").set(M,u.slice()),f=[M]}else if(Array.isArray(M)){f=[];let a;M=[...M].sort(i._compareIndexedTuplesByUri);for(const P of M){const[c,t]=P;if((!a||c.toString()!==a.toString())&&(a&&ye(this,n,"f").get(a).length===0&&ye(this,n,"f").delete(a),a=c,f.push(c),ye(this,n,"f").set(c,[])),t){const h=ye(this,n,"f").get(c);h&&h.push(...t)}else{const h=ye(this,n,"f").get(c);h&&(h.length=0)}}}if(ye(this,p,"f").fire(f),!ye(this,s,"f"))return;const w=[];for(let a of f){let P=[];const c=ye(this,n,"f").get(a);if(c)if(c.length>this._maxDiagnosticsPerFile){P=[];const t=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let o of c)if(o.severity===t[h]&&P.push(A.Diagnostic.from(o))===this._maxDiagnosticsPerFile)break e;P.push({severity:I.MarkerSeverity.Info,message:(0,r.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:P[P.length-1].startLineNumber,startColumn:P[P.length-1].startColumn,endLineNumber:P[P.length-1].endLineNumber,endColumn:P[P.length-1].endColumn})}else P=c.map(t=>A.Diagnostic.from(t));w.push([a,P])}ye(this,s,"f").$changeMany(this._owner,w)}delete(M){this._checkDisposed(),ye(this,p,"f").fire([M]),ye(this,n,"f").delete(M),ye(this,s,"f")&&ye(this,s,"f").$changeMany(this._owner,[[M,void 0]])}clear(){this._checkDisposed(),ye(this,p,"f").fire([...ye(this,n,"f").keys()]),ye(this,n,"f").clear(),ye(this,s,"f")&&ye(this,s,"f").$clear(this._owner)}forEach(M,u){this._checkDisposed();for(let f of ye(this,n,"f").keys())M.apply(u,[f,this.get(f),this])}get(M){this._checkDisposed();const u=ye(this,n,"f").get(M);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(M){return this._checkDisposed(),Array.isArray(ye(this,n,"f").get(M))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(M,u){return M[0].toString()<u[0].toString()?-1:M[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=i,s=new WeakMap,p=new WeakMap,n=new WeakMap;let d=class si{constructor(M,u,f){this._logService=u,this._fileSystemInfoService=f,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=M.getProxy(x.MainContext.MainThreadDiagnostics)}static _mapper(M){const u=new N.ResourceMap;for(const f of M)u.set(f,f);return{uris:Object.freeze(Array.from(u.values()))}}createDiagnosticCollection(M,u){const{_collections:f,_proxy:w,_onDidChangeDiagnostics:a,_logService:P,_fileSystemInfoService:c}=this,t=new class{$changeMany(l,E){w.$changeMany(l,E),P.trace("[DiagnosticCollection] change many (extension, owner, uris)",M.value,l,E.length===0?"CLEARING":E)}$clear(l){w.$clear(l),P.trace("[DiagnosticCollection] remove all (extension, owner)",M.value,l)}dispose(){w.dispose()}};let h;if(!u)u="_generated_diagnostic_collection_name_#"+si._idPool++,h=u;else if(!f.has(u))h=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do h=u+si._idPool++;while(f.has(h))}return new class extends i{constructor(){super(u,h,si._maxDiagnosticsPerFile,c.extUri,t,a);f.set(h,this)}dispose(){super.dispose(),f.delete(h)}}}getDiagnostics(M){if(M)return this._getDiagnostics(M);{const u=new Map,f=[];for(const w of this._collections.values())w.forEach((a,P)=>{let c=u.get(a.toString());typeof c=="undefined"&&(c=f.length,u.set(a.toString(),c),f.push([a,[]])),f[c][1]=f[c][1].concat(...P)});return f}}_getDiagnostics(M){let u=[];for(let f of this._collections.values())f.has(M)&&(u=u.concat(f.get(M)));return u}$acceptMarkersChange(M){if(!this._mirrorCollection){const u="_generated_mirror",f=new i(u,u,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(u,f),this._mirrorCollection=f}for(const[u,f]of M)this._mirrorCollection.set(_.URI.revive(u),f.map(A.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Fe([Ne(1,R.ILogService),Ne(2,b.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ve[182],Ee([1,0,2,4]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(A=>A?A.map(C=>r.URI.revive(C)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(A=>A?r.URI.revive(A):void 0)}}e.ExtHostDialogs=_}),define(ve[183],Ee([1,0,15,2,7,4,9,20,10]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(b,s,p){this._documentsAndEditors=s,this._logService=p,this._documentContentProviders=new Map,this._proxy=b.getProxy(x.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,s){if(Object.keys(y.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const p=R._handlePool++;this._documentContentProviders.set(p,s),this._proxy.$registerTextContentProvider(p,b);let n;return typeof s.onDidChange=="function"&&(n=s.onDidChange(i=>{if(i.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${i.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(i)&&this.$provideTextDocumentContent(p,i).then(d=>{if(!d&&typeof d!="string")return;const S=this._documentsAndEditors.getDocument(i);if(!S)return;const M=(0,C.splitLines)(d);if(!S.equalLines(M))return this._proxy.$onVirtualDocumentChange(i,d)},r.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),n&&(n.dispose(),n=void 0)})}$provideTextDocumentContent(b,s){const p=this._documentContentProviders.get(b);return p?Promise.resolve(p.provideTextDocumentContent(I.URI.revive(s),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${s.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(ve[184],Ee([1,0,5,6,2,4,83,8,13,26,7]),function(Y,e,r,I,_,x,y,A,C,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(p,n){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(x.MainContext.MainThreadDocuments),this._documentsAndEditors=n,this._documentsAndEditors.onDidRemoveDocuments(i=>{for(const d of i)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(i=>{for(const d of i)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const n=this._documentsAndEditors.getDocument(p);if(n)return n}getDocument(p){const n=this.getDocumentData(p);if(!n?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return n.document}ensureDocumentData(p){const n=this._documentsAndEditors.getDocument(p);if(n)return Promise.resolve(n);let i=this._documentLoader.get(p.toString());return i||(i=this._proxy.$tryOpenDocument(p).then(d=>{this._documentLoader.delete(p.toString());const S=_.URI.revive(d);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(S))},d=>(this._documentLoader.delete(p.toString()),Promise.reject(d))),this._documentLoader.set(p.toString(),i)),i}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(n=>_.URI.revive(n))}$acceptModelLanguageChanged(p,n){const i=_.URI.revive(p),d=this._documentsAndEditors.getDocument(i);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(n),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(p){const n=_.URI.revive(p),i=this._documentsAndEditors.getDocument(n);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(i.document)}$acceptDirtyStateChanged(p,n){const i=_.URI.revive(p),d=this._documentsAndEditors.getDocument(i);if(!d)throw new Error("unknown document");d._acceptIsDirty(n),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,n,i){const d=_.URI.revive(p),S=this._documentsAndEditors.getDocument(d);if(!S)throw new Error("unknown document");S._acceptIsDirty(i),S.onEvents(n);let M;n.isUndoing?M=N.TextDocumentChangeReason.Undo:n.isRedoing&&(M=N.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:S.document,contentChanges:n.changes.map(u=>({range:A.Range.to(u.range),rangeOffset:u.rangeOffset,rangeLength:u.rangeLength,text:u.text})),reason:M}))}setWordDefinitionFor(p,n){(0,y.setWordDefinitionFor)(p,n)}}e.ExtHostDocuments=b}),define(ve[49],Ee([1,0,42,5,6,2,3,4,83,14,90,8,12,22,9,160,229]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let M=class{constructor(f,w){this._extHostRpc=f,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const w=[],a=[],P=[];if(f.removedDocuments)for(const c of f.removedDocuments){const t=x.URI.revive(c),h=this._documents.get(t);h?.unref()&&(this._documents.delete(t),w.push(h.value))}if(f.addedDocuments)for(const c of f.addedDocuments){const t=x.URI.revive(c.uri);let h=this._documents.get(t);if(h&&t.scheme!==n.Schemas.vscodeNotebookCell&&t.scheme!==n.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);h||(h=new S(new C.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),t,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this._documents.set(t,h),a.push(h.value)),h.ref()}if(f.removedEditors)for(const c of f.removedEditors){const t=this._editors.get(c);this._editors.delete(c),t&&P.push(t)}if(f.addedEditors)for(const c of f.addedEditors){const t=x.URI.revive(c.documentUri);r.ok(this._documents.has(t),`document '${t}' does not exist`),r.ok(!this._editors.has(c.id),`editor '${c.id}' already exists!`);const h=this._documents.get(t).value,o=new N.ExtHostTextEditor(c.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>h.document),c.selections.map(b.Selection.to),c.options,c.visibleRanges.map(l=>b.Range.to(l)),typeof c.editorPosition=="number"?b.ViewColumn.to(c.editorPosition):void 0);this._editors.set(c.id,o)}f.newActiveEditor!==void 0&&(r.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,_.dispose)(w),(0,_.dispose)(P),f.removedDocuments&&this._onDidRemoveDocuments.fire(w),f.addedDocuments&&this._onDidAddDocuments.fire(a),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(c=>c.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return i.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const w=this._editors.get(this._activeEditorId);return f?w:w?.value}allEditors(){return[...this._editors.values()]}};M=Fe([Ne(0,R.IExtHostRpcService),Ne(1,s.ILogService)],M),e.ExtHostDocumentsAndEditors=M,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[65],Ee([1,0,8,4,2,5,3,14,11]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");let R=class{constructor(b){this._onDidChangeTabs=new x.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new x.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=b.getProxy(I.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(b){let s=-1;this._tabs=b.map((n,i)=>(n.isActive&&(s=i),Object.freeze({label:n.label,viewColumn:r.ViewColumn.to(n.viewColumn),index:i,resource:_.URI.revive(n.resource),additionalResourcesAndViewIds:n.additionalResourcesAndViewIds.map(({resource:d,viewId:S})=>({resource:_.URI.revive(d),viewId:S})),viewId:n.editorId,isActive:n.isActive,move:async(d,S)=>{this._proxy.$moveTab(n,d,r.ViewColumn.from(S)),await(0,C.raceTimeout)(x.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(n),await(0,C.raceTimeout)(x.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((n,i)=>n.viewColumn===i.viewColumn?n.index-i.index:n.viewColumn-i.viewColumn);const p=this._activeTab;this._activeTab=s===-1?void 0:this._tabs[s],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};R=Fe([Ne(0,A.IExtHostRpcService)],R),e.ExtHostEditorTabs=R}),define(ve[185],Ee([1,0,2,4,6,7,8,230,10,21,27]),function(Y,e,r,I,_,x,y,A,C,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(n){this._stateMachine=void 0,this._schemes.push(n)}delete(n){const i=this._schemes.indexOf(n);i>=0&&(this._schemes.splice(i,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const n=this._schemes.sort(),i=[];let d,S,M=14,u=14;for(const f of n){let w=d?(0,C.commonPrefixLength)(d,f):0;for(w===0?S=1:S=u;w<f.length;w++)w+1===f.length?(M=u,u=9):u+=1,i.push([S,f.toUpperCase().charCodeAt(w),u]),i.push([S,f.toLowerCase().charCodeAt(w),u]),S=u;d=f,u=M}i.push([9,58,10]),i.push([10,47,12]),this._stateMachine=new A.StateMachine(i)}}provideDocumentLinks(n){this._initStateMachine();const i=[],d=A.LinkComputer.computeLinks({getLineContent(S){return n.lineAt(S-1).text},getLineCount(){return n.lineCount}},this._stateMachine);for(const S of d){const M=y.DocumentLink.to(S);M.target&&i.push(M)}return i}}class s{constructor(n,i){this._extHostLanguageFeatures=i,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=n.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(n,i,d,S={}){if(this._registeredSchemes.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(n,"*",this._linkProvider));const M=this._handlePool++;this._linkProvider.add(i),this._registeredSchemes.add(i),this._fsProvider.set(M,d);let u=2;S.isCaseSensitive&&(u+=1024),S.isReadonly&&(u+=2048),typeof d.copy=="function"&&(u+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,N.checkProposedApiEnabled)(n,"fsChunks"),u+=4),this._proxy.$registerFileSystemProvider(M,i,u).catch(w=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${i}`),console.error(w)});const f=d.onDidChangeFile(w=>{const a=[];for(const P of w){let{uri:c,type:t}=P;if(c.scheme!==i)continue;let h;switch(t){case x.FileChangeType.Changed:h=0;break;case x.FileChangeType.Created:h=1;break;case x.FileChangeType.Deleted:h=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:c,type:h})}this._proxy.$onFileSystemChange(M,a)});return(0,_.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(i),this._registeredSchemes.delete(i),this._fsProvider.delete(M),this._proxy.$unregisterProvider(M)})}static _asIStat(n){const{type:i,ctime:d,mtime:S,size:M,permissions:u}=n;return{type:i,ctime:d,mtime:S,size:M,permissions:u}}$stat(n,i){return Promise.resolve(this._getFsProvider(n).stat(r.URI.revive(i))).then(d=>s._asIStat(d))}$readdir(n,i){return Promise.resolve(this._getFsProvider(n).readDirectory(r.URI.revive(i)))}$readFile(n,i){return Promise.resolve(this._getFsProvider(n).readFile(r.URI.revive(i))).then(d=>R.VSBuffer.wrap(d))}$writeFile(n,i,d,S){return Promise.resolve(this._getFsProvider(n).writeFile(r.URI.revive(i),d.buffer,S))}$delete(n,i,d){return Promise.resolve(this._getFsProvider(n).delete(r.URI.revive(i),d))}$rename(n,i,d,S){return Promise.resolve(this._getFsProvider(n).rename(r.URI.revive(i),r.URI.revive(d),S))}$copy(n,i,d,S){const M=this._getFsProvider(n);if(!M.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(M.copy(r.URI.revive(i),r.URI.revive(d),S))}$mkdir(n,i){return Promise.resolve(this._getFsProvider(n).createDirectory(r.URI.revive(i)))}$watch(n,i,d,S){const M=this._getFsProvider(n).watch(r.URI.revive(d),S);this._watches.set(i,M)}$unwatch(n,i){const d=this._watches.get(i);d&&(d.dispose(),this._watches.delete(i))}$open(n,i,d){const S=this._getFsProvider(n);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(r.URI.revive(i),d))}$close(n,i){const d=this._getFsProvider(n);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(i))}$read(n,i,d,S){const M=this._getFsProvider(n);if(!M.read)throw new Error('FileSystemProvider does not implement "read"');const u=R.VSBuffer.alloc(S);return Promise.resolve(M.read(i,d,u.buffer,0,S)).then(f=>u.slice(0,f))}$write(n,i,d,S){const M=this._getFsProvider(n);if(!M.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(M.write(i,d,S.buffer,0,S.byteLength))}_getFsProvider(n){const i=this._fsProvider.get(n);if(!i){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return i}}e.ExtHostFileSystem=s}),define(ve[50],Ee([1,0,4,46,7,21,3,14,30,6]),function(Y,e,r,I,_,x,y,A,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Kt{constructor(s,p){this._fileSystemProvider=new Map,this._proxy=s.getProxy(r.MainContext.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{const d=n._fileSystemProvider.get(i.scheme);if(!d)return await n._proxy.$stat(i);await n._proxy.$ensureActivation(i.scheme);const S=await d.stat(i);return{type:S.type,ctime:S.ctime,mtime:S.mtime,size:S.size,permissions:S.permissions}}catch(d){Kt._handleError(d)}},async readDirectory(i){try{const d=n._fileSystemProvider.get(i.scheme);return d?(await n._proxy.$ensureActivation(i.scheme),(await d.readDirectory(i)).slice()):await n._proxy.$readdir(i)}catch(d){return Kt._handleError(d)}},async createDirectory(i){try{return await n._proxy.$mkdir(i)}catch(d){return Kt._handleError(d)}},async readFile(i){try{const d=n._fileSystemProvider.get(i.scheme);return d?(await n._proxy.$ensureActivation(i.scheme),(await d.readFile(i)).slice()):(await n._proxy.$readFile(i)).buffer}catch(d){return Kt._handleError(d)}},async writeFile(i,d){try{return await n._proxy.$writeFile(i,x.VSBuffer.wrap(d))}catch(S){return Kt._handleError(S)}},async delete(i,d){try{const S=n._fileSystemProvider.get(i.scheme);return S?(await n._proxy.$ensureActivation(i.scheme),await S.delete(i,{recursive:!1,...d})):await n._proxy.$delete(i,{recursive:!1,useTrash:!1,...d})}catch(S){return Kt._handleError(S)}},async rename(i,d,S){try{return await n._proxy.$rename(i,d,{overwrite:!1,...S})}catch(M){return Kt._handleError(M)}},async copy(i,d,S){try{return await n._proxy.$copy(i,d,{overwrite:!1,...S})}catch(M){return Kt._handleError(M)}},isWritableFileSystem(i){const d=p.getCapabilities(i);if(typeof d=="number")return!(d&2048)}})}static _handleError(s){if(s instanceof _.FileSystemError)throw s;if(!(s instanceof Error))throw new _.FileSystemError(String(s));if(s.name==="ENOPRO")throw _.FileSystemError.Unavailable(s.message);switch(s.name){case I.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(s.message);case I.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(s.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(s.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(s.message);case I.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(s.message);case I.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(s.message);default:throw new _.FileSystemError(s.message,s.name)}}addFileSystemProvider(s,p){return this._fileSystemProvider.set(s,p),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(s))}};N=Fe([Ne(0,A.IExtHostRpcService),Ne(1,C.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[186],Ee([1,0,5,29,2,4,8,7]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(b,s,p,n,i,d,S,M){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const u=this.ensureWatching(b,p,i);this._config=0,d&&(this._config+=1),S&&(this._config+=2),M&&(this._config+=4);const f=(0,I.parse)(i),w=typeof i=="string",a=n(P=>{if(!d)for(let c of P.created){const t=_.URI.revive(c);f(t.fsPath)&&(!w||s.getWorkspaceFolder(t))&&this._onDidCreate.fire(t)}if(!S)for(let c of P.changed){const t=_.URI.revive(c);f(t.fsPath)&&(!w||s.getWorkspaceFolder(t))&&this._onDidChange.fire(t)}if(!M)for(let c of P.deleted){const t=_.URI.revive(c);f(t.fsPath)&&(!w||s.getWorkspaceFolder(t))&&this._onDidDelete.fire(t)}});this._disposable=A.Disposable.from(u,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(b,s,p){let n=A.Disposable.from();if(typeof p=="string")return n;const i=b.getProxy(x.MainContext.MainThreadFileSystem);let d=!1;(p.pattern.includes(I.GLOBSTAR)||p.pattern.includes(I.GLOB_SPLIT))&&(d=!0);const S=Math.random();return i.$watch(s.identifier.value,S,p.baseUri,{recursive:d,excludes:[]}),A.Disposable.from({dispose:()=>i.$unwatch(S)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(b,s,p){this._mainContext=b,this._logService=s,this._extHostDocumentsAndEditors=p,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,s,p,n,i,d){return new C(this._mainContext,b,s,this._onFileSystemEvent.event,y.GlobPattern.from(p),n,i,d)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,s){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:s.map(p=>({oldUri:_.URI.revive(p.source),newUri:_.URI.revive(p.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:s.map(p=>_.URI.revive(p.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:s.map(p=>_.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,s){return(p,n,i)=>{const d=function(M){p.call(n,M)};return d.extension=b,s.event(d,void 0,i)}}async $onWillRunFileOperation(b,s,p,n){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:s.map(i=>({oldUri:_.URI.revive(i.source),newUri:_.URI.revive(i.target)}))},p,n);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:s.map(i=>_.URI.revive(i.target))},p,n);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:s.map(i=>_.URI.revive(i.target))},p,n)}}async _fireWillEvent(b,s,p,n){const i=new Set,d=[];if(await b.fireAsync(s,n,async(M,u)=>{const f=Date.now(),w=await Promise.resolve(M);w instanceof A.WorkspaceEdit&&(d.push(w),i.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-f>p&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),n.isCancellationRequested||d.length===0)return;const S={edits:[]};for(let M of d){let{edits:u}=y.WorkspaceEdit.from(M,{getTextDocumentVersion:f=>this._extHostDocumentsAndEditors.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}});S.edits=S.edits.concat(u)}return{edit:S,extensionNames:Array.from(i)}}}e.ExtHostFileSystemEventService=R}),define(ve[187],Ee([1,0,2,39]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(y,A,C,R){this._extHostNotebooks=A,this._textDocumentsAndEditors=C,this._commands=R;const N=new I.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new I.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new I.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new I.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new I.ApiCommandResult("Notebook and input URI",b=>{if(b.notebookEditorId!==void 0){const s=this._extHostNotebooks.getEditorById(b.notebookEditorId);return{notebookUri:r.URI.revive(b.notebookUri),inputUri:r.URI.revive(b.inputUri),notebookEditor:s.apiEditor}}return{notebookUri:r.URI.revive(b.notebookUri),inputUri:r.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(N)}$willAddInteractiveDocument(y,A,C,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:C,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=_}),define(ve[188],Ee([1,0,6,4]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,y),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=_}),define(ve[189],Ee([1,0,2,26,8,7,4,10,87,16,13,231,20,6,74,53,57,190,15,5,11]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class w{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentSymbols(L,F){const D=this._documents.getDocument(L),O=await this._provider.provideDocumentSymbols(D,F);if(!(0,R.isFalsyOrEmpty)(O))return O[0]instanceof x.DocumentSymbol?O.map(_.DocumentSymbol.from):w._asDocumentSymbolTree(O)}static _asDocumentSymbolTree(L){L=L.slice(0).sort((O,H)=>{let X=O.location.range.start.compareTo(H.location.range.start);return X===0&&(X=H.location.range.end.compareTo(O.location.range.end)),X});const F=[],D=[];for(const O of L){const H={name:O.name||"!!MISSING: name!!",kind:_.SymbolKind.from(O.kind),tags:O.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:O.containerName,range:_.Range.from(O.location.range),selectionRange:_.Range.from(O.location.range),children:[]};for(;;){if(D.length===0){D.push(H),F.push(H);break}const X=D[D.length-1];if(C.Range.containsRange(X.range,H.range)&&!C.Range.equalsRange(X.range,H.range)){X.children&&X.children.push(H),D.push(H);break}D.pop()}}return F}}class a{constructor(L,F,D){this._documents=L,this._commands=F,this._provider=D,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(L,F){const D=this._documents.getDocument(L),O=await this._provider.provideCodeLenses(D,F);if(!O||F.isCancellationRequested)return;const H=this._cache.add(O),X=new p.DisposableStore;this._disposables.set(H,X);const re={cacheId:H,lenses:[]};for(let pe=0;pe<O.length;pe++)re.lenses.push({cacheId:[H,pe],range:_.Range.from(O[pe].range),command:this._commands.toInternal(O[pe].command,X)});return re}async resolveCodeLens(L,F){const D=L.cacheId&&this._cache.get(...L.cacheId);if(!D)return;let O;if(typeof this._provider.resolveCodeLens!="function"||D.isResolved?O=D:O=await this._provider.resolveCodeLens(D,F),O||(O=D),F.isCancellationRequested)return;const H=L.cacheId&&this._disposables.get(L.cacheId[0]);if(!!H)return L.command=this._commands.toInternal(O.command??a._badCmd,H),L}releaseCodeLenses(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function P(de){return Array.isArray(de)?de.map(_.DefinitionLink.from):de?[_.DefinitionLink.from(de)]:[]}class c{constructor(L,F){this._documents=L,this._provider=F}async provideDefinition(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.provideDefinition(O,H,D);return P(X)}}class t{constructor(L,F){this._documents=L,this._provider=F}async provideDeclaration(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.provideDeclaration(O,H,D);return P(X)}}class h{constructor(L,F){this._documents=L,this._provider=F}async provideImplementation(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.provideImplementation(O,H,D);return P(X)}}class o{constructor(L,F){this._documents=L,this._provider=F}async provideTypeDefinition(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.provideTypeDefinition(O,H,D);return P(X)}}class l{constructor(L,F){this._documents=L,this._provider=F}async provideHover(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.provideHover(O,H,D);if(!(!X||(0,R.isFalsyOrEmpty)(X.contents)))return X.range||(X.range=O.getWordRangeAtPosition(H)),X.range||(X.range=new x.Range(H,H)),_.Hover.from(X)}}class E{constructor(L,F){this._documents=L,this._provider=F}async provideEvaluatableExpression(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.provideEvaluatableExpression(O,H,D);if(X)return _.EvaluatableExpression.from(X)}}class m{constructor(L,F){this._documents=L,this._provider=F}async provideInlineValues(L,F,D,O){const H=this._documents.getDocument(L),X=await this._provider.provideInlineValues(H,_.Range.to(F),_.InlineValueContext.to(D),O);if(Array.isArray(X))return X.map(re=>_.InlineValue.from(re))}}class v{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentHighlights(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.provideDocumentHighlights(O,H,D);if(Array.isArray(X))return X.map(_.DocumentHighlight.from)}}class k{constructor(L,F){this._documents=L,this._provider=F}async provideLinkedEditingRanges(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.provideLinkedEditingRanges(O,H,D);if(X&&Array.isArray(X.ranges))return{ranges:(0,R.coalesce)(X.ranges.map(_.Range.from)),wordPattern:X.wordPattern}}}class T{constructor(L,F){this._documents=L,this._provider=F}async provideReferences(L,F,D,O){const H=this._documents.getDocument(L),X=_.Position.to(F),re=await this._provider.provideReferences(H,X,D,O);if(Array.isArray(re))return re.map(_.location.from)}}class ${constructor(L,F,D,O,H,X,re){this._documents=L,this._commands=F,this._diagnostics=D,this._provider=O,this._logService=H,this._extension=X,this._apiDeprecation=re,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(L,F,D,O){const H=this._documents.getDocument(L),X=b.Selection.isISelection(F)?_.Selection.to(F):_.Range.to(F),re=[];for(const xe of this._diagnostics.getDiagnostics(L))if(X.intersection(xe.range)&&re.push(xe)>$._maxCodeActionsPerFile)break;const pe={diagnostics:re,only:D.only?new x.CodeActionKind(D.only):void 0,triggerKind:_.CodeActionTriggerKind.to(D.trigger)},Ce=await this._provider.provideCodeActions(H,X,pe,O);if(!(0,R.isNonEmptyArray)(Ce)||O.isCancellationRequested)return;const Me=this._cache.add(Ce),Le=new p.DisposableStore;this._disposables.set(Me,Le);const ze=[];for(let xe=0;xe<Ce.length;xe++){const Oe=Ce[xe];!Oe||($._isCommand(Oe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Oe.title,command:this._commands.toInternal(Oe,Le)})):(pe.only&&(Oe.kind?pe.only.contains(Oe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Oe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[Me,xe],title:Oe.title,command:Oe.command&&this._commands.toInternal(Oe.command,Le),diagnostics:Oe.diagnostics&&Oe.diagnostics.map(_.Diagnostic.from),edit:Oe.edit&&_.WorkspaceEdit.from(Oe.edit),kind:Oe.kind&&Oe.kind.value,isPreferred:Oe.isPreferred,disabled:Oe.disabled?.reason})))}return{cacheId:Me,actions:ze}}async resolveCodeAction(L,F){const[D,O]=L,H=this._cache.get(D,O);if(!H||$._isCommand(H)||!this._provider.resolveCodeAction)return;const X=await this._provider.resolveCodeAction(H,F)??H;return X?.edit?_.WorkspaceEdit.from(X.edit):void 0}releaseCodeActions(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}static _isCommand(L){return typeof L.command=="string"&&typeof L.title=="string"}}$._maxCodeActionsPerFile=1e3;class g{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentFormattingEdits(L,F,D){const O=this._documents.getDocument(L),H=await this._provider.provideDocumentFormattingEdits(O,F,D);if(Array.isArray(H))return H.map(_.TextEdit.from)}}class U{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentRangeFormattingEdits(L,F,D,O){const H=this._documents.getDocument(L),X=_.Range.to(F),re=await this._provider.provideDocumentRangeFormattingEdits(H,X,D,O);if(Array.isArray(re))return re.map(_.TextEdit.from)}}class z{constructor(L,F){this._documents=L,this._provider=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(L,F,D,O,H){const X=this._documents.getDocument(L),re=_.Position.to(F),pe=await this._provider.provideOnTypeFormattingEdits(X,re,D,O,H);if(Array.isArray(pe))return pe.map(_.TextEdit.from)}}class q{constructor(L,F){this._provider=L,this._logService=F,this._cache=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(L,F){const D=await this._provider.provideWorkspaceSymbols(L,F);if(!(0,R.isNonEmptyArray)(D))return{symbols:[]};const O=this._cache.add(D),H={cacheId:O,symbols:[]};for(let X=0;X<D.length;X++){const re=D[X];if(!re||!re.name){this._logService.warn("INVALID SymbolInformation",re);continue}H.symbols.push({..._.WorkspaceSymbol.from(re),cacheId:[O,X]})}return H}async resolveWorkspaceSymbol(L,F){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!L.cacheId)return L;const D=this._cache.get(...L.cacheId);if(D){const O=await this._provider.resolveWorkspaceSymbol(D,F);return O&&(0,I.mixin)(L,_.WorkspaceSymbol.from(O),!0)}}releaseWorkspaceSymbols(L){this._cache.delete(L)}}class j{constructor(L,F,D){this._documents=L,this._provider=F,this._logService=D}static supportsResolving(L){return typeof L.prepareRename=="function"}async provideRenameEdits(L,F,D,O){const H=this._documents.getDocument(L),X=_.Position.to(F);try{const re=await this._provider.provideRenameEdits(H,X,D,O);return re?_.WorkspaceEdit.from(re):void 0}catch(re){const pe=j._asMessage(re);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(re)}}async resolveRenameLocation(L,F,D){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const O=this._documents.getDocument(L),H=_.Position.to(F);try{const X=await this._provider.prepareRename(O,H,D);let re,pe;if(x.Range.isRange(X)?(re=X,pe=O.getText(X)):(0,N.isObject)(X)&&(re=X.range,pe=X.placeholder),!re||!pe)return;if(re.start.line>H.line||re.end.line<H.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(re),text:pe}}catch(X){const re=j._asMessage(X);return re?{rejectReason:re,range:void 0,text:void 0}:Promise.reject(X)}}static _asMessage(L){return typeof L=="string"?L:L instanceof Error&&typeof L.message=="string"?L.message:void 0}}class J{constructor(L,F){this.resultId=L,this.tokens=F}}class W{constructor(L,F){this._documents=L,this._provider=F,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(L,F,D){const O=this._documents.getDocument(L),H=F!==0?this._previousResults.get(F):null;let X=typeof H?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(O,H.resultId,D):await this._provider.provideDocumentSemanticTokens(O,D);return H&&this._previousResults.delete(F),X?(X=W._fixProvidedSemanticTokens(X),this._send(W._convertToEdits(H,X),X)):null}async releaseDocumentSemanticColoring(L){this._previousResults.delete(L)}static _fixProvidedSemanticTokens(L){return W._isSemanticTokens(L)?W._isCorrectSemanticTokens(L)?L:new x.SemanticTokens(new Uint32Array(L.data),L.resultId):W._isSemanticTokensEdits(L)?W._isCorrectSemanticTokensEdits(L)?L:new x.SemanticTokensEdits(L.edits.map(F=>new x.SemanticTokensEdit(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),L.resultId):L}static _isSemanticTokens(L){return L&&!!L.data}static _isCorrectSemanticTokens(L){return L.data instanceof Uint32Array}static _isSemanticTokensEdits(L){return L&&Array.isArray(L.edits)}static _isCorrectSemanticTokensEdits(L){for(const F of L.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(L,F){if(!W._isSemanticTokens(F)||!L||!L.tokens)return F;const D=L.tokens,O=D.length,H=F.data,X=H.length;let re=0;const pe=Math.min(O,X);for(;re<pe&&D[re]===H[re];)re++;if(re===O&&re===X)return new x.SemanticTokensEdits([],F.resultId);let Ce=0;const Me=pe-re;for(;Ce<Me&&D[O-Ce-1]===H[X-Ce-1];)Ce++;return new x.SemanticTokensEdits([{start:re,deleteCount:O-re-Ce,data:H.subarray(re,X-Ce)}],F.resultId)}_send(L,F){if(W._isSemanticTokens(L)){const D=this._nextResultId++;return this._previousResults.set(D,new J(L.resultId,L.data)),(0,n.encodeSemanticTokensDto)({id:D,type:"full",data:L.data})}if(W._isSemanticTokensEdits(L)){const D=this._nextResultId++;return W._isSemanticTokens(F)?this._previousResults.set(D,new J(F.resultId,F.data)):this._previousResults.set(D,new J(L.resultId)),(0,n.encodeSemanticTokensDto)({id:D,type:"delta",deltas:(L.edits||[]).map(O=>({start:O.start,deleteCount:O.deleteCount,data:O.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class ie{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentRangeSemanticTokens(L,F,D){const O=this._documents.getDocument(L),H=await this._provider.provideDocumentRangeSemanticTokens(O,_.Range.to(F),D);return H?this._send(H):null}_send(L){return(0,n.encodeSemanticTokensDto)({id:0,type:"full",data:L.data})}}e.DocumentRangeSemanticTokensAdapter=ie;class le{constructor(L,F,D,O,H){this._documents=L,this._commands=F,this._provider=D,this._apiDeprecation=O,this._extension=H,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(L){return typeof L.resolveCompletionItem=="function"}async provideCompletionItems(L,F,D,O){const H=this._documents.getDocument(L),X=_.Position.to(F),re=H.getWordRangeAtPosition(X)||new x.Range(X,X),pe=re.with({end:X}),Ce=new S.StopWatch(!0),Me=await this._provider.provideCompletionItems(H,X,O,_.CompletionContext.to(D));if(!Me||O.isCancellationRequested)return;const Le=Array.isArray(Me)?new x.CompletionList(Me):Me,ze=le.supportsResolving(this._provider)?this._cache.add(Le.items):this._cache.add([]),xe=new p.DisposableStore;this._disposables.set(ze,xe);const Oe=[],Xe={x:ze,b:Oe,a:{replace:_.Range.from(re),insert:_.Range.from(pe)},c:Le.isIncomplete||void 0,d:Ce.elapsed()};for(let et=0;et<Le.items.length;et++){const ke=Le.items[et],tt=this._convertCompletionItem(ke,[ze,et],pe,re);Oe.push(tt)}return Xe}async resolveCompletionItem(L,F){if(typeof this._provider.resolveCompletionItem!="function")return;const D=this._cache.get(...L);if(!D)return;const O=await this._provider.resolveCompletionItem(D,F);if(!!O)return this._convertCompletionItem(O,L)}releaseCompletionItems(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}_convertCompletionItem(L,F,D,O){const H=this._disposables.get(F[0]);if(!H)throw Error("DisposableStore is missing...");const X={x:F,a:L.label,b:L.kind!==void 0?_.CompletionItemKind.from(L.kind):void 0,n:L.tags&&L.tags.map(_.CompletionItemTag.from),c:L.detail,d:typeof L.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(L.documentation),e:L.sortText!==L.label?L.sortText:void 0,f:L.filterText!==L.label?L.filterText:void 0,g:L.preselect||void 0,i:L.keepWhitespace?1:0,k:L.commitCharacters,l:L.additionalTextEdits&&L.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(L.command,H)};L.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),X.h=L.textEdit.newText):typeof L.insertText=="string"?X.h=L.insertText:L.insertText instanceof x.SnippetString&&(X.h=L.insertText.value,X.i|=4);let re;return L.textEdit?re=L.textEdit.range:L.range&&(re=L.range),x.Range.isRange(re)?X.j=_.Range.from(re):re&&(!D?.isEqual(re.inserting)||!O?.isEqual(re.replacing))&&(X.j={insert:_.Range.from(re.inserting),replace:_.Range.from(re.replacing)}),X}}class te{constructor(L,F,D){this._documents=L,this._provider=F,this._commands=D,this._cache=new d.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(L,F,D,O){const H=this._documents.getDocument(L),X=_.Position.to(F),re=await this._provider.provideInlineCompletionItems(H,X,{selectedCompletionInfo:D.selectedSuggestionInfo?{range:_.Range.to(D.selectedSuggestionInfo.range),text:D.selectedSuggestionInfo.text,isSnippetText:D.selectedSuggestionInfo.isSnippetText,completionKind:_.CompletionItemKind.to(D.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:D.triggerKind},O);if(!re||O.isCancellationRequested)return;const pe=(0,N.isArray)(re)?{items:re}:re,Ce=this._cache.add(pe.items);let Me;return{pid:Ce,items:pe.items.map((Le,ze)=>{let xe;return Le.command&&(Me||(Me=new p.DisposableStore,this._disposables.set(Ce,Me)),xe=this._commands.toInternal(Le.command,Me)),{text:Le.text,range:Le.range?_.Range.from(Le.range):void 0,command:xe,idx:ze,completeBracketPairs:Le.completeBracketPairs}})}}disposeCompletions(L){this._cache.delete(L);const F=this._disposables.get(L);F&&F.clear(),this._disposables.delete(L)}handleDidShowCompletionItem(L,F){const D=this._cache.get(L,F);D&&ue.get(this._provider).fireOnDidShowCompletionItem({completionItem:D})}}class ue{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(L){let F=ue.map.get(L);return F||(F=new ue,ue.map.set(L,F)),F}fireOnDidShowCompletionItem(L){this._onDidShowCompletionItemEmitter.fire(L)}}e.InlineCompletionController=ue,ue.map=new WeakMap;class he{constructor(L,F){this._documents=L,this._provider=F,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(L,F,D,O){const H=this._documents.getDocument(L),X=_.Position.to(F),re=this.reviveContext(D),pe=await this._provider.provideSignatureHelp(H,X,O,re);if(pe){const Ce=this._cache.add([pe]);return{..._.SignatureHelp.from(pe),id:Ce}}}reviveContext(L){let F;if(L.activeSignatureHelp){const D=_.SignatureHelp.to(L.activeSignatureHelp),O=this._cache.get(L.activeSignatureHelp.id,0);O?(F=O,F.activeSignature=D.activeSignature,F.activeParameter=D.activeParameter):F=D}return{...L,activeSignatureHelp:F}}releaseSignatureHelp(L){this._cache.delete(L)}}class De{constructor(L,F,D,O,H){this._documents=L,this._commands=F,this._provider=D,this._logService=O,this._extension=H,this._cache=new d.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(L,F,D){const O=this._documents.getDocument(L),H=_.Range.to(F),X=await this._provider.provideInlayHints(O,H,D);if(!Array.isArray(X)||X.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${F}`);return}if(D.isCancellationRequested)return;const re=this._cache.add(X);this._disposables.set(re,new p.DisposableStore);const pe={hints:[],cacheId:re};for(let Ce=0;Ce<X.length;Ce++)this._isValidInlayHint(X[Ce],H)&&pe.hints.push(this._convertInlayHint(X[Ce],[re,Ce]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${F}`),pe}async resolveInlayHint(L,F){if(typeof this._provider.resolveInlayHint!="function")return;const D=this._cache.get(...L);if(!D)return;const O=await this._provider.resolveInlayHint(D,F);if(!!O&&!!this._isValidInlayHint(O))return this._convertInlayHint(O,L)}releaseHints(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}_isValidInlayHint(L,F){return L.label.length===0||Array.isArray(L.label)&&L.label.every(D=>D.value.length===0)?(console.log("INVALID inlay hint, empty label",L),!1):!(F&&!F.contains(L.position))}_convertInlayHint(L,F){const D=this._disposables.get(F[0]);if(!D)throw Error("DisposableStore is missing...");const O={label:"",cacheId:F,tooltip:_.MarkdownString.fromStrict(L.tooltip),command:L.command&&this._commands.toInternal(L.command,D),position:_.Position.from(L.position),kind:_.InlayHintKind.from(L.kind??x.InlayHintKind.Other),paddingLeft:L.paddingLeft,paddingRight:L.paddingRight};return typeof L.label=="string"?O.label=L.label:O.label=L.label.map(H=>{let X={label:H.value};return X.tooltip=_.MarkdownString.fromStrict(H.tooltip),x.Location.isLocation(H.location)&&(X.location=_.location.from(H.location)),H.command&&(X.command=this._commands.toInternal(H.command,D)),X}),O}}class fe{constructor(L,F){this._documents=L,this._provider=F,this._cache=new d.Cache("DocumentLink")}async provideLinks(L,F){const D=this._documents.getDocument(L),O=await this._provider.provideDocumentLinks(D,F);if(!(!Array.isArray(O)||O.length===0)&&!F.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:O.filter(fe._validateLink).map(_.DocumentLink.from)};{const H=this._cache.add(O),X={links:[],cacheId:H};for(let re=0;re<O.length;re++){if(!fe._validateLink(O[re]))continue;const pe=_.DocumentLink.from(O[re]);pe.cacheId=[H,re],X.links.push(pe)}return X}}}static _validateLink(L){return L.target&&L.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(L,F){if(typeof this._provider.resolveDocumentLink!="function")return;const D=this._cache.get(...L);if(!D)return;const O=await this._provider.resolveDocumentLink(D,F);if(!(!O||!fe._validateLink(O)))return _.DocumentLink.from(O)}releaseLinks(L){this._cache.delete(L)}}class ne{constructor(L,F){this._documents=L,this._provider=F}async provideColors(L,F){const D=this._documents.getDocument(L),O=await this._provider.provideDocumentColors(D,F);return Array.isArray(O)?O.map(X=>({color:_.Color.from(X.color),range:_.Range.from(X.range)})):[]}async provideColorPresentations(L,F,D){const O=this._documents.getDocument(L),H=_.Range.to(F.range),X=_.Color.to(F.color),re=await this._provider.provideColorPresentations(X,{document:O,range:H},D);if(!!Array.isArray(re))return re.map(_.ColorPresentation.from)}}class me{constructor(L,F){this._documents=L,this._provider=F}async provideFoldingRanges(L,F,D){const O=this._documents.getDocument(L),H=await this._provider.provideFoldingRanges(O,F,D);if(!!Array.isArray(H))return H.map(_.FoldingRange.from)}}class Ie{constructor(L,F,D){this._documents=L,this._provider=F,this._logService=D}async provideSelectionRanges(L,F,D){const O=this._documents.getDocument(L),H=F.map(_.Position.to),X=await this._provider.provideSelectionRanges(O,H,D);if(!(0,R.isNonEmptyArray)(X))return[];if(X.length!==H.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const re=[];for(let pe=0;pe<H.length;pe++){const Ce=[];re.push(Ce);let Me=H[pe],Le=X[pe];for(;;){if(!Le.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(_.SelectionRange.from(Le)),!Le.parent)break;Me=Le.range,Le=Le.parent}}return re}}class Ae{constructor(L,F){this._documents=L,this._provider=F,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.prepareCallHierarchy(O,H,D);if(!X)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(X)?X.map(pe=>this._cacheAndConvertItem(re,pe)):[this._cacheAndConvertItem(re,X)]}async provideCallsTo(L,F,D){const O=this._itemFromCache(L,F);if(!O)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyIncomingCalls(O,D);if(!!H)return H.map(X=>({from:this._cacheAndConvertItem(L,X.from),fromRanges:X.fromRanges.map(re=>_.Range.from(re))}))}async provideCallsFrom(L,F,D){const O=this._itemFromCache(L,F);if(!O)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyOutgoingCalls(O,D);if(!!H)return H.map(X=>({to:this._cacheAndConvertItem(L,X.to),fromRanges:X.fromRanges.map(re=>_.Range.from(re))}))}releaseSession(L){this._cache.delete(L)}_cacheAndConvertItem(L,F){const D=this._cache.get(L),O=_.CallHierarchyItem.from(F,L,D.size.toString(36));return D.set(O._itemId,F),O}_itemFromCache(L,F){return this._cache.get(L)?.get(F)}}class Ue{constructor(L,F){this._documents=L,this._provider=F,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(L,F,D){const O=this._documents.getDocument(L),H=_.Position.to(F),X=await this._provider.prepareTypeHierarchy(O,H,D);if(!X)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(X)?X.map(pe=>this._cacheAndConvertItem(re,pe)):[this._cacheAndConvertItem(re,X)]}async provideSupertypes(L,F,D){const O=this._itemFromCache(L,F);if(!O)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySupertypes(O,D);if(!!H)return H.map(X=>this._cacheAndConvertItem(L,X))}async provideSubtypes(L,F,D){const O=this._itemFromCache(L,F);if(!O)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySubtypes(O,D);if(!!H)return H.map(X=>this._cacheAndConvertItem(L,X))}releaseSession(L){this._cache.delete(L)}_cacheAndConvertItem(L,F){const D=this._cache.get(L),O=_.TypeHierarchyItem.from(F,L,D.size.toString(36));return D.set(O._itemId,F),O}_itemFromCache(L,F){return this._cache.get(L)?.get(F)}}class Ge{constructor(L,F){this.adapter=L,this.extension=F}}class ge{constructor(L,F,D,O,H,X,re){this._adapter=new Map,this._uriTransformer=F,this._proxy=L.getProxy(y.MainContext.MainThreadLanguageFeatures),this._documents=D,this._commands=O,this._diagnostics=H,this._logService=X,this._apiDeprecation=re}_transformDocumentSelector(L){return _.DocumentSelector.from(L,this._uriTransformer)}_createDisposable(L){return new x.Disposable(()=>{this._adapter.delete(L),this._proxy.$unregister(L)})}_nextHandle(){return ge._handlePool++}async _withAdapter(L,F,D,O,H){const X=this._adapter.get(L);if(!X||!(X.adapter instanceof F))return O;const re=Date.now();this._logService.trace(`[${X.extension.identifier.value}] INVOKE provider '${D.toString().replace(/[\r\n]/g,"")}'`);const pe=D(X.adapter,X.extension);return Promise.resolve(pe).catch(Ce=>{(0,M.isCancellationError)(Ce)||(this._logService.error(`[${X.extension.identifier.value}] provider FAILED`),this._logService.error(Ce))}).finally(()=>{this._logService.trace(`[${X.extension.identifier.value}] provider DONE after ${Date.now()-re}ms`)}),s.CancellationToken.isCancellationToken(H)?(0,f.raceCancellationError)(pe,H):pe}_addNewAdapter(L,F){const D=this._nextHandle();return this._adapter.set(D,new Ge(L,F)),D}static _extLabel(L){return L.displayName||L.name}registerDocumentSymbolProvider(L,F,D,O){const H=this._addNewAdapter(new w(this._documents,D),L),X=O&&O.label||ge._extLabel(L);return this._proxy.$registerDocumentSymbolProvider(H,this._transformDocumentSelector(F),X),this._createDisposable(H)}$provideDocumentSymbols(L,F,D){return this._withAdapter(L,w,O=>O.provideDocumentSymbols(r.URI.revive(F),D),void 0,D)}registerCodeLensProvider(L,F,D){const O=this._nextHandle(),H=typeof D.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(O,new Ge(new a(this._documents,this._commands.converter,D),L)),this._proxy.$registerCodeLensSupport(O,this._transformDocumentSelector(F),H);let X=this._createDisposable(O);if(H!==void 0){const re=D.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(H));X=x.Disposable.from(X,re)}return X}$provideCodeLenses(L,F,D){return this._withAdapter(L,a,O=>O.provideCodeLenses(r.URI.revive(F),D),void 0,D)}$resolveCodeLens(L,F,D){return this._withAdapter(L,a,O=>O.resolveCodeLens(F,D),void 0,void 0)}$releaseCodeLenses(L,F){this._withAdapter(L,a,D=>Promise.resolve(D.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(L,F,D){const O=this._addNewAdapter(new c(this._documents,D),L);return this._proxy.$registerDefinitionSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDefinition(L,F,D,O){return this._withAdapter(L,c,H=>H.provideDefinition(r.URI.revive(F),D,O),[],O)}registerDeclarationProvider(L,F,D){const O=this._addNewAdapter(new t(this._documents,D),L);return this._proxy.$registerDeclarationSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDeclaration(L,F,D,O){return this._withAdapter(L,t,H=>H.provideDeclaration(r.URI.revive(F),D,O),[],O)}registerImplementationProvider(L,F,D){const O=this._addNewAdapter(new h(this._documents,D),L);return this._proxy.$registerImplementationSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideImplementation(L,F,D,O){return this._withAdapter(L,h,H=>H.provideImplementation(r.URI.revive(F),D,O),[],O)}registerTypeDefinitionProvider(L,F,D){const O=this._addNewAdapter(new o(this._documents,D),L);return this._proxy.$registerTypeDefinitionSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideTypeDefinition(L,F,D,O){return this._withAdapter(L,o,H=>H.provideTypeDefinition(r.URI.revive(F),D,O),[],O)}registerHoverProvider(L,F,D,O){const H=this._addNewAdapter(new l(this._documents,D),L);return this._proxy.$registerHoverProvider(H,this._transformDocumentSelector(F)),this._createDisposable(H)}$provideHover(L,F,D,O){return this._withAdapter(L,l,H=>H.provideHover(r.URI.revive(F),D,O),void 0,O)}registerEvaluatableExpressionProvider(L,F,D,O){const H=this._addNewAdapter(new E(this._documents,D),L);return this._proxy.$registerEvaluatableExpressionProvider(H,this._transformDocumentSelector(F)),this._createDisposable(H)}$provideEvaluatableExpression(L,F,D,O){return this._withAdapter(L,E,H=>H.provideEvaluatableExpression(r.URI.revive(F),D,O),void 0,O)}registerInlineValuesProvider(L,F,D,O){const H=typeof D.onDidChangeInlineValues=="function"?this._nextHandle():void 0,X=this._addNewAdapter(new m(this._documents,D),L);this._proxy.$registerInlineValuesProvider(X,this._transformDocumentSelector(F),H);let re=this._createDisposable(X);if(H!==void 0){const pe=D.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(H));re=x.Disposable.from(re,pe)}return re}$provideInlineValues(L,F,D,O,H){return this._withAdapter(L,m,X=>X.provideInlineValues(r.URI.revive(F),D,O,H),void 0,H)}registerDocumentHighlightProvider(L,F,D){const O=this._addNewAdapter(new v(this._documents,D),L);return this._proxy.$registerDocumentHighlightProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDocumentHighlights(L,F,D,O){return this._withAdapter(L,v,H=>H.provideDocumentHighlights(r.URI.revive(F),D,O),void 0,O)}registerLinkedEditingRangeProvider(L,F,D){const O=this._addNewAdapter(new k(this._documents,D),L);return this._proxy.$registerLinkedEditingRangeProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideLinkedEditingRanges(L,F,D,O){return this._withAdapter(L,k,async H=>{const X=await H.provideLinkedEditingRanges(r.URI.revive(F),D,O);if(X)return{ranges:X.ranges,wordPattern:X.wordPattern?ge._serializeRegExp(X.wordPattern):void 0}},void 0,O)}registerReferenceProvider(L,F,D){const O=this._addNewAdapter(new T(this._documents,D),L);return this._proxy.$registerReferenceSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideReferences(L,F,D,O,H){return this._withAdapter(L,T,X=>X.provideReferences(r.URI.revive(F),D,O,H),void 0,H)}registerCodeActionProvider(L,F,D,O){const H=new p.DisposableStore,X=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,D,this._logService,L,this._apiDeprecation),L);return this._proxy.$registerQuickFixSupport(X,this._transformDocumentSelector(F),{providedKinds:O?.providedCodeActionKinds?.map(re=>re.value),documentation:O?.documentation?.map(re=>({kind:re.kind.value,command:this._commands.converter.toInternal(re.command,H)}))},ge._extLabel(L),Boolean(D.resolveCodeAction)),H.add(this._createDisposable(X)),H}$provideCodeActions(L,F,D,O,H){return this._withAdapter(L,$,X=>X.provideCodeActions(r.URI.revive(F),D,O,H),void 0,H)}$resolveCodeAction(L,F,D){return this._withAdapter(L,$,O=>O.resolveCodeAction(F,D),void 0,void 0)}$releaseCodeActions(L,F){this._withAdapter(L,$,D=>Promise.resolve(D.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(L,F,D){const O=this._addNewAdapter(new g(this._documents,D),L);return this._proxy.$registerDocumentFormattingSupport(O,this._transformDocumentSelector(F),L.identifier,L.displayName||L.name),this._createDisposable(O)}$provideDocumentFormattingEdits(L,F,D,O){return this._withAdapter(L,g,H=>H.provideDocumentFormattingEdits(r.URI.revive(F),D,O),void 0,O)}registerDocumentRangeFormattingEditProvider(L,F,D){const O=this._addNewAdapter(new U(this._documents,D),L);return this._proxy.$registerRangeFormattingSupport(O,this._transformDocumentSelector(F),L.identifier,L.displayName||L.name),this._createDisposable(O)}$provideDocumentRangeFormattingEdits(L,F,D,O,H){return this._withAdapter(L,U,X=>X.provideDocumentRangeFormattingEdits(r.URI.revive(F),D,O,H),void 0,H)}registerOnTypeFormattingEditProvider(L,F,D,O){const H=this._addNewAdapter(new z(this._documents,D),L);return this._proxy.$registerOnTypeFormattingSupport(H,this._transformDocumentSelector(F),O,L.identifier),this._createDisposable(H)}$provideOnTypeFormattingEdits(L,F,D,O,H,X){return this._withAdapter(L,z,re=>re.provideOnTypeFormattingEdits(r.URI.revive(F),D,O,H,X),void 0,X)}registerWorkspaceSymbolProvider(L,F){const D=this._addNewAdapter(new q(F,this._logService),L);return this._proxy.$registerNavigateTypeSupport(D,typeof F.resolveWorkspaceSymbol=="function"),this._createDisposable(D)}$provideWorkspaceSymbols(L,F,D){return this._withAdapter(L,q,O=>O.provideWorkspaceSymbols(F,D),{symbols:[]},D)}$resolveWorkspaceSymbol(L,F,D){return this._withAdapter(L,q,O=>O.resolveWorkspaceSymbol(F,D),void 0,void 0)}$releaseWorkspaceSymbols(L,F){this._withAdapter(L,q,D=>D.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(L,F,D){const O=this._addNewAdapter(new j(this._documents,D,this._logService),L);return this._proxy.$registerRenameSupport(O,this._transformDocumentSelector(F),j.supportsResolving(D)),this._createDisposable(O)}$provideRenameEdits(L,F,D,O,H){return this._withAdapter(L,j,X=>X.provideRenameEdits(r.URI.revive(F),D,O,H),void 0,H)}$resolveRenameLocation(L,F,D,O){return this._withAdapter(L,j,H=>H.resolveRenameLocation(r.URI.revive(F),D,O),void 0,O)}registerDocumentSemanticTokensProvider(L,F,D,O){const H=this._addNewAdapter(new W(this._documents,D),L),X=typeof D.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(H,this._transformDocumentSelector(F),O,X);let re=this._createDisposable(H);if(X){const pe=D.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(X));re=x.Disposable.from(re,pe)}return re}$provideDocumentSemanticTokens(L,F,D,O){return this._withAdapter(L,W,H=>H.provideDocumentSemanticTokens(r.URI.revive(F),D,O),null,O)}$releaseDocumentSemanticTokens(L,F){this._withAdapter(L,W,D=>D.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(L,F,D,O){const H=this._addNewAdapter(new ie(this._documents,D),L);return this._proxy.$registerDocumentRangeSemanticTokensProvider(H,this._transformDocumentSelector(F),O),this._createDisposable(H)}$provideDocumentRangeSemanticTokens(L,F,D,O){return this._withAdapter(L,ie,H=>H.provideDocumentRangeSemanticTokens(r.URI.revive(F),D,O),null,O)}registerCompletionItemProvider(L,F,D,O){const H=this._addNewAdapter(new le(this._documents,this._commands.converter,D,this._apiDeprecation,L),L);return this._proxy.$registerSuggestSupport(H,this._transformDocumentSelector(F),O,le.supportsResolving(D),`${L.identifier.value}(${O.join("")})`),this._createDisposable(H)}$provideCompletionItems(L,F,D,O,H){return this._withAdapter(L,le,X=>X.provideCompletionItems(r.URI.revive(F),D,O,H),void 0,H)}$resolveCompletionItem(L,F,D){return this._withAdapter(L,le,O=>O.resolveCompletionItem(F,D),void 0,D)}$releaseCompletionItems(L,F){this._withAdapter(L,le,D=>D.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(L,F,D){const O=this._addNewAdapter(new te(this._documents,D,this._commands.converter),L);return this._proxy.$registerInlineCompletionsSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideInlineCompletions(L,F,D,O,H){return this._withAdapter(L,te,X=>X.provideInlineCompletions(r.URI.revive(F),D,O,H),void 0,H)}$handleInlineCompletionDidShow(L,F,D){this._withAdapter(L,te,async O=>{O.handleDidShowCompletionItem(F,D)},void 0,void 0)}$freeInlineCompletionsList(L,F){this._withAdapter(L,te,async D=>{D.disposeCompletions(F)},void 0,void 0)}registerSignatureHelpProvider(L,F,D,O){const H=Array.isArray(O)?{triggerCharacters:O,retriggerCharacters:[]}:O,X=this._addNewAdapter(new he(this._documents,D),L);return this._proxy.$registerSignatureHelpProvider(X,this._transformDocumentSelector(F),H),this._createDisposable(X)}$provideSignatureHelp(L,F,D,O,H){return this._withAdapter(L,he,X=>X.provideSignatureHelp(r.URI.revive(F),D,O,H),void 0,H)}$releaseSignatureHelp(L,F){this._withAdapter(L,he,D=>D.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(L,F,D){const O=typeof D.onDidChangeInlayHints=="function"?this._nextHandle():void 0,H=this._addNewAdapter(new De(this._documents,this._commands.converter,D,this._logService,L),L);this._proxy.$registerInlayHintsProvider(H,this._transformDocumentSelector(F),typeof D.resolveInlayHint=="function",O,ge._extLabel(L));let X=this._createDisposable(H);if(O!==void 0){const re=D.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(O));X=x.Disposable.from(X,re)}return X}$provideInlayHints(L,F,D,O){return this._withAdapter(L,De,H=>H.provideInlayHints(r.URI.revive(F),D,O),void 0,O)}$resolveInlayHint(L,F,D){return this._withAdapter(L,De,O=>O.resolveInlayHint(F,D),void 0,D)}$releaseInlayHints(L,F){this._withAdapter(L,De,D=>D.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(L,F,D){const O=this._addNewAdapter(new fe(this._documents,D),L);return this._proxy.$registerDocumentLinkProvider(O,this._transformDocumentSelector(F),typeof D.resolveDocumentLink=="function"),this._createDisposable(O)}$provideDocumentLinks(L,F,D){return this._withAdapter(L,fe,O=>O.provideLinks(r.URI.revive(F),D),void 0,D)}$resolveDocumentLink(L,F,D){return this._withAdapter(L,fe,O=>O.resolveLink(F,D),void 0,void 0)}$releaseDocumentLinks(L,F){this._withAdapter(L,fe,D=>D.releaseLinks(F),void 0,void 0)}registerColorProvider(L,F,D){const O=this._addNewAdapter(new ne(this._documents,D),L);return this._proxy.$registerDocumentColorProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDocumentColors(L,F,D){return this._withAdapter(L,ne,O=>O.provideColors(r.URI.revive(F),D),[],D)}$provideColorPresentations(L,F,D,O){return this._withAdapter(L,ne,H=>H.provideColorPresentations(r.URI.revive(F),D,O),void 0,O)}registerFoldingRangeProvider(L,F,D){const O=this._nextHandle(),H=typeof D.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(O,new Ge(new me(this._documents,D),L)),this._proxy.$registerFoldingRangeProvider(O,this._transformDocumentSelector(F),H);let X=this._createDisposable(O);if(H!==void 0){const re=D.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(H));X=x.Disposable.from(X,re)}return X}$provideFoldingRanges(L,F,D,O){return this._withAdapter(L,me,H=>H.provideFoldingRanges(r.URI.revive(F),D,O),void 0,O)}registerSelectionRangeProvider(L,F,D){const O=this._addNewAdapter(new Ie(this._documents,D,this._logService),L);return this._proxy.$registerSelectionRangeProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideSelectionRanges(L,F,D,O){return this._withAdapter(L,Ie,H=>H.provideSelectionRanges(r.URI.revive(F),D,O),[],O)}registerCallHierarchyProvider(L,F,D){const O=this._addNewAdapter(new Ae(this._documents,D),L);return this._proxy.$registerCallHierarchyProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$prepareCallHierarchy(L,F,D,O){return this._withAdapter(L,Ae,H=>Promise.resolve(H.prepareSession(r.URI.revive(F),D,O)),void 0,O)}$provideCallHierarchyIncomingCalls(L,F,D,O){return this._withAdapter(L,Ae,H=>H.provideCallsTo(F,D,O),void 0,O)}$provideCallHierarchyOutgoingCalls(L,F,D,O){return this._withAdapter(L,Ae,H=>H.provideCallsFrom(F,D,O),void 0,O)}$releaseCallHierarchy(L,F){this._withAdapter(L,Ae,D=>Promise.resolve(D.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(L,F,D){const O=this._addNewAdapter(new Ue(this._documents,D),L);return this._proxy.$registerTypeHierarchyProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$prepareTypeHierarchy(L,F,D,O){return this._withAdapter(L,Ue,H=>Promise.resolve(H.prepareSession(r.URI.revive(F),D,O)),void 0,O)}$provideTypeHierarchySupertypes(L,F,D,O){return this._withAdapter(L,Ue,H=>H.provideSupertypes(F,D,O),void 0,O)}$provideTypeHierarchySubtypes(L,F,D,O){return this._withAdapter(L,Ue,H=>H.provideSubtypes(F,D,O),void 0,O)}$releaseTypeHierarchy(L,F){this._withAdapter(L,Ue,D=>Promise.resolve(D.releaseSession(F)),void 0,void 0)}static _serializeRegExp(L){return{pattern:L.source,flags:(0,A.regExpFlags)(L)}}static _serializeIndentationRule(L){return{decreaseIndentPattern:ge._serializeRegExp(L.decreaseIndentPattern),increaseIndentPattern:ge._serializeRegExp(L.increaseIndentPattern),indentNextLinePattern:L.indentNextLinePattern?ge._serializeRegExp(L.indentNextLinePattern):void 0,unIndentedLinePattern:L.unIndentedLinePattern?ge._serializeRegExp(L.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(L){return{beforeText:ge._serializeRegExp(L.beforeText),afterText:L.afterText?ge._serializeRegExp(L.afterText):void 0,previousLineText:L.previousLineText?ge._serializeRegExp(L.previousLineText):void 0,action:L.action}}static _serializeOnEnterRules(L){return L.map(ge._serializeOnEnterRule)}setLanguageConfiguration(L,F,D){let{wordPattern:O}=D;if(O&&(0,A.regExpLeadsToEndlessLoop)(O))throw new Error(`Invalid language configuration: wordPattern '${O}' is not allowed to match the empty string.`);O?this._documents.setWordDefinitionFor(F,O):this._documents.setWordDefinitionFor(F,void 0),D.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",L,"Do not use."),D.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",L,"Do not use.");const H=this._nextHandle(),X={comments:D.comments,brackets:D.brackets,wordPattern:D.wordPattern?ge._serializeRegExp(D.wordPattern):void 0,indentationRules:D.indentationRules?ge._serializeIndentationRule(D.indentationRules):void 0,onEnterRules:D.onEnterRules?ge._serializeOnEnterRules(D.onEnterRules):void 0,__electricCharacterSupport:D.__electricCharacterSupport,__characterPairSupport:D.__characterPairSupport};return this._proxy.$setLanguageConfiguration(H,F,X),this._createDisposable(H)}$setWordDefinitions(L){for(const F of L)this._documents.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.ExtHostLanguageFeatures=ge,ge._handlePool=0}),define(ve[191],Ee([1,0,4,8,7,34,11,6]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(N,b,s,p){this._documents=b,this._commands=s,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=N.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this._languageIds=N}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(N,b){await this._proxy.$changeLanguage(N,b);const s=this._documents.getDocumentData(N);if(!s)throw new Error(`document '${N.toString}' NOT found`);return s.document}async tokenAtPosition(N,b){const s=N.version,p=I.Position.from(b),n=await this._proxy.$tokensAtPosition(N.uri,p),i={type:_.StandardTokenType.Other,range:N.getWordRangeAtPosition(b)??new _.Range(b.line,b.character,b.line,b.character)};if(!n)return i;const d={range:I.Range.to(n.range),type:I.TokenType.to(n.type)};return!d.range.contains(b)||s!==N.version?i:d}createLanguageStatusItem(N,b,s){const p=this._handlePool++,n=this._proxy,i=this._ids,d=`${N.identifier.value}/${b}`;if(i.has(d))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);i.add(d);const S={selector:s,id:b,name:N.displayName??N.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let M,u=new A.DisposableStore;const f=()=>{M?.dispose(),M=(0,y.disposableTimeout)(()=>{u.clear(),this._proxy.$setLanguageStatus(p,{id:d,name:S.name??N.displayName??N.name,source:N.displayName??N.name,selector:I.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===_.LanguageStatusSeverity.Error?x.default.Error:S.severity===_.LanguageStatusSeverity.Warning?x.default.Warning:x.default.Info,command:S.command&&this._commands.toInternal(S.command,u),accessibilityInfo:S.accessibilityInformation,busy:S.busy})},0)},w={dispose(){u.dispose(),M?.dispose(),n.$removeLanguageStatus(p),i.delete(d)},get id(){return S.id},get name(){return S.name},set name(a){S.name=a,f()},get selector(){return S.selector},set selector(a){S.selector=a,f()},get text(){return S.text},set text(a){S.text=a,f()},get detail(){return S.detail},set detail(a){S.detail=a,f()},get severity(){return S.severity},set severity(a){S.severity=a,f()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(a){S.accessibilityInformation=a,f()},get command(){return S.command},set command(a){S.command=a,f()},get busy(){return S.busy},set busy(a){S.busy=a,f()}};return f(),w}}e.ExtHostLanguages=C}),define(ve[192],Ee([1,0,12,4,28,14,5]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends r.AbstractLoggerService{constructor(N,b){const s=new y.Emitter;super(b.logLevel,s.event);this._proxy=N.getProxy(I.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(s)}$setLevel(N){this._onDidChangeLogLevel.fire(N)}doCreateLogger(N,b,s){return new C(this._proxy,N,b,s)}};A=Fe([Ne(0,x.IExtHostRpcService),Ne(1,_.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class C extends r.AbstractMessageLogger{constructor(N,b,s,p){super(p?.always);this.proxy=N,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(s),this.proxy.$createLogger(b,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(N,b){const s=[[N,b]];this.isLoggerCreated?this.doLog(s):this.buffer.push(...s)}doLog(N){this.proxy.$log(this.file,N)}}}),define(ve[193],Ee([1,0,4,12,27]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function x(A){return A&&A.title}let y=class{constructor(C,R){this._logService=R,this._proxy=C.getProxy(r.MainContext.MainThreadMessageService)}showMessage(C,R,N,b,s){const p={source:{identifier:C.identifier,label:C.displayName||C.name}};let n;typeof b=="string"||x(b)?n=[b,...s]:(p.modal=b?.modal,p.useCustom=b?.useCustom,p.detail=b?.detail,n=s),p.useCustom&&(0,_.checkProposedApiEnabled)(C,"resolvers");const i=[];for(let d=0;d<n.length;d++){const S=n[d];if(typeof S=="string")i.push({title:S,handle:d,isCloseAffordance:!1});else if(typeof S=="object"){let{title:M,isCloseAffordance:u}=S;i.push({title:M,isCloseAffordance:!!u,handle:d})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(R,N,p,i).then(d=>{if(typeof d=="number")return n[d]})}};y=Fe([Ne(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(ve[194],Ee([1,0,21,5,93,6,22,10,13,2,57,4,8,7,38,168,89]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(u,f,w,a,P){this._textDocumentsAndEditors=w,this._textDocuments=a,this._extensionStoragePaths=P,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new y.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new N.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=u.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=u.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=u.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===12){const t=c.notebookEditor?.notebookUri,h=c.cell.handle,l=this._documents.get(t)?.getCell(h);if(l)return l.apiCell}return c}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(u=>u.apiEditor)}getEditorById(u){const f=this._editors.get(u);if(!f)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(u){for(const[f,w]of this._editors)if(w.apiEditor===u)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(u,f){const w=this._documents.get(u);if(!w&&!f)throw new Error(`NO notebook document for '${u}'`);return w}_getProviderData(u){const f=this._notebookContentProviders.get(u);if(!f)throw new Error(`NO provider for '${u}'`);return f}registerNotebookContentProvider(u,f,w,a,P){if((0,A.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(f))throw new Error(`Notebook provider for '${f}' already registered`);this._notebookContentProviders.set(f,{extension:u,provider:w});let c;return w.onDidChangeNotebookContentOptions&&(c=w.onDidChangeNotebookContentOptions(()=>{const t=s.NotebookDocumentContentOptions.from(w.options);this._notebookProxy.$updateNotebookProviderOptions(f,t)})),this._notebookProxy.$registerNotebookProvider({id:u.identifier,location:u.extensionLocation},f,s.NotebookDocumentContentOptions.from(a),S._convertNotebookRegistrationData(u,P)),new p.Disposable(()=>{c?.dispose(),this._notebookContentProviders.delete(f),this._notebookProxy.$unregisterNotebookProvider(f)})}static _convertNotebookRegistrationData(u,f){if(!f)return;const w=f.filenamePattern.map(a=>s.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(f.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:f.displayName,filenamePattern:w,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,f,w){const a=S._notebookStatusBarItemProviderHandlePool++,P=typeof w.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,P,f);let c;return P!==void 0&&(c=w.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(P))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,P),c&&c.dispose()})}async createNotebookDocument(u){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:u.viewType,content:u.content&&s.NotebookData.from(u.content)});return R.URI.revive(f)}async openNotebookDocument(u){const f=this._documents.get(u);if(f)return f.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenNotebook(u),a=this._documents.get(R.URI.revive(w));return(0,C.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(u,f){R.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let w;typeof f=="object"?w={position:s.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(s.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:w={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(u.uri,u.notebookType,w),P=a&&this._editors.get(a)?.apiEditor;if(P)return P;throw a?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,f,w,a){const P=this._notebookStatusBarItemProviders.get(u),c=R.URI.revive(f),t=this._documents.get(c);if(!t||!P)return;const h=t.getCellFromIndex(w);if(!h)return;const o=await P.provideCellStatusBarItems(h.apiCell,a);if(!o)return;const l=new x.DisposableStore,E=this._statusBarCache.add([l]),v=(Array.isArray(o)?o:[o]).map(k=>s.NotebookStatusBarItem.from(k,this._commandsConverter,l));return{cacheId:E,items:v}}$releaseNotebookCellStatusBarItems(u){this._statusBarCache.delete(u)}registerNotebookSerializer(u,f,w,a,P){if((0,A.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const c=this._handlePool++;return this._notebookSerializer.set(c,w),this._notebookProxy.$registerNotebookSerializer(c,{id:u.identifier,location:u.extensionLocation},f,s.NotebookDocumentContentOptions.from(a),S._convertNotebookRegistrationData(u,P)),(0,x.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(c)})}async $dataToNotebook(u,f,w){const a=this._notebookSerializer.get(u);if(!a)throw new Error("NO serializer found");const P=await a.deserializeNotebook(f.buffer,w);return new n.SerializableObjectWithBuffers(s.NotebookData.from(P))}async $notebookToData(u,f,w){const a=this._notebookSerializer.get(u);if(!a)throw new Error("NO serializer found");const P=await a.serializeNotebook(s.NotebookData.to(f.value),w);return r.VSBuffer.wrap(P)}async $openNotebook(u,f,w,a,P){const{provider:c}=this._getProviderData(u),t=await c.openNotebook(R.URI.revive(f),{backupId:w,untitledDocumentData:a?.buffer},P);return new n.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(s.NotebookCellData.from)})}async $saveNotebook(u,f,w){const a=this.getNotebookDocument(R.URI.revive(f)),{provider:P}=this._getProviderData(u);return await P.saveNotebook(a.apiNotebook,w),!0}async $saveNotebookAs(u,f,w,a){const P=this.getNotebookDocument(R.URI.revive(f)),{provider:c}=this._getProviderData(u);return await c.saveNotebookAs(R.URI.revive(w),P.apiNotebook,a),!0}async $backupNotebook(u,f,w){const a=this.getNotebookDocument(R.URI.revive(f)),P=this._getProviderData(u),c=this._extensionStoragePaths.workspaceValue(P.extension)??this._extensionStoragePaths.globalValue(P.extension),t=String((0,_.hash)([a.uri.toString(),this._backupIdPool++])),h=R.URI.joinPath(c,t),o=await P.provider.backupNotebook(a.apiNotebook,{destination:h},w);return a.updateBackup(o),o.id}_createExtHostEditor(u,f,w){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const a=new d.ExtHostNotebookEditor(f,this._notebookEditorsProxy,u,w.visibleRanges.map(s.NotebookRange.to),w.selections.map(s.NotebookRange.to),typeof w.viewColumn=="number"?s.ViewColumn.to(w.viewColumn):void 0);this._editors.set(f,a)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const w of u.value.removedDocuments){const a=R.URI.revive(w),P=this._documents.get(a);P&&(P.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:P.apiNotebook.getCells().map(c=>c.document.uri)}),this._onDidCloseNotebookDocument.fire(P.apiNotebook));for(const c of this._editors.values())c.notebookData.uri.toString()===a.toString()&&this._editors.delete(c.id)}if(u.value.addedDocuments){const w=[];for(const a of u.value.addedDocuments){const P=R.URI.revive(a.uri);if(this._documents.has(P))throw new Error(`adding EXISTING notebook ${P} `);const c=this,t=new i.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(h){c._onDidChangeNotebookCells.fire(h)},emitCellOutputsChange(h){c._onDidChangeCellOutputs.fire(h)},emitCellMetadataChange(h){c._onDidChangeCellMetadata.fire(h)}},P,a);w.push(...a.cells.map(h=>i.ExtHostCell.asModelAddData(t.apiNotebook,h))),this._documents.get(P)?.dispose(),this._documents.set(P,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(u.value.addedEditors)for(const w of u.value.addedEditors){if(this._editors.has(w.id))return;const a=R.URI.revive(w.documentUri),P=this._documents.get(a);P&&this._createExtHostEditor(P,w.id,w)}const f=[];if(u.value.removedEditors)for(const w of u.value.removedEditors){const a=this._editors.get(w);a&&(this._editors.delete(w),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),f.push(a))}if(u.value.visibleEditors){this._visibleNotebookEditors=u.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const w=new Set;this._visibleNotebookEditors.forEach(a=>w.add(a.id));for(const a of this._editors.values()){const P=w.has(a.id);a._acceptVisibility(P)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this._activeNotebookEditor=void 0:u.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(ve[195],Ee([1,0,5,53,12,4,14,8]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(b,s){const p=C._Keys.nextId();b.$registerNotebookEditorDecorationType(p,A.NotebookDecorationRenderOptions.from(s)),this.value={key:p,dispose(){b.$removeNotebookEditorDecorationType(p)}}}}C._Keys=new I.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(b,s,p){this._logService=b,this._extHostRpc=s,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(b){return new C(this._extHostRpc.getProxy(x.MainContext.MainThreadNotebookEditors),b).value}$acceptEditorPropertiesChanged(b,s){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,s);const p=this._notebooksAndEditors.getEditorById(b);s.visibleRanges&&p._acceptVisibleRanges(s.visibleRanges.ranges.map(A.NotebookRange.to)),s.selections&&p._acceptSelections(s.selections.selections.map(A.NotebookRange.to)),s.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),s.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const s in b)this._notebooksAndEditors.getEditorById(s)._acceptViewColumn(A.ViewColumn.to(b[s]))}};R=Fe([Ne(0,_.ILogService),Ne(1,y.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(ve[196],Ee([1,0,16,11,20,5,6,22,2,25,12,4,39,8,7,60,161,27,38]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let u=class{constructor(t,h,o,l,E){this._initData=h,this._extHostNotebook=o,this._commands=l,this._logService=E,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new x.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=t.getProxy(b.MainContext.MainThreadNotebookKernels);const m=new s.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new s.ApiCommandArgument("options","Select kernel options",v=>!0,v=>{if(v&&"notebookEditor"in v&&"id"in v){const k=this._extHostNotebook.getIdByEditor(v.notebookEditor);return{id:v.id,extension:v.extension,notebookEditorId:k}}else if(v&&"notebookEditor"in v){const k=this._extHostNotebook.getIdByEditor(v.notebookEditor);if(k===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${v.notebookEditor.document.uri.toString()}`);return{notebookEditorId:k}}return v})],s.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(t,h,o,l,E,m){for(const ue of this._kernelData.values())if(ue.controller.id===h&&R.ExtensionIdentifier.equals(t.identifier,ue.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const v=this._handlePool++,k=this;this._logService.trace(`NotebookController[${v}], CREATED by ${t.identifier.value}, ${h}`);const T=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${t.identifier}'`);let $=!1;const g=new y.DisposableStore,U=new x.Emitter,z=new x.Emitter,q={id:P(t,h),notebookType:o,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:l||t.identifier.value,preloads:m?m.map(p.NotebookRendererScript.from):[]};let j=E??T,J;this._proxy.$addKernel(v,q).catch(ue=>{console.log(ue),$=!0});let W=0;const ie=()=>{if($)return;const ue=++W;Promise.resolve().then(()=>{ue===W&&this._proxy.$updateKernel(v,q)})},le=new A.ResourceMap,te={get id(){return h},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return q.label},set label(ue){q.label=ue??t.displayName??t.name,ie()},get detail(){return q.detail??""},set detail(ue){q.detail=ue,ie()},get description(){return q.description??""},set description(ue){q.description=ue,ie()},get kind(){return(0,S.checkProposedApiEnabled)(t,"notebookControllerKind"),q.kind??""},set kind(ue){(0,S.checkProposedApiEnabled)(t,"notebookControllerKind"),q.kind=ue,ie()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(ue){q.supportedLanguages=ue,ie()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){q.supportsExecutionOrder=ue,ie()},get rendererScripts(){return q.preloads?q.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return j},set executeHandler(ue){j=ue??T},get interruptHandler(){return J},set interruptHandler(ue){J=ue,q.supportsInterrupt=Boolean(ue),ie()},createNotebookCellExecution(ue){if($)throw new Error("notebook controller is DISPOSED");if(!le.has(ue.notebook.uri))throw k._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(he=>he.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return k._createNotebookCellExecution(ue,P(t,this.id))},dispose:()=>{$||(this._logService.trace(`NotebookController[${v}], DISPOSED`),$=!0,this._kernelData.delete(v),g.dispose(),U.dispose(),z.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(ue,he){k._proxy.$updateNotebookPriority(v,ue.uri,he)},onDidReceiveMessage:z.event,postMessage(ue,he){return(0,S.checkProposedApiEnabled)(t,"notebookMessaging"),k._proxy.$postMessage(v,he&&k._extHostNotebook.getIdByEditor(he),ue)},asWebviewUri(ue){return(0,S.checkProposedApiEnabled)(t,"notebookMessaging"),(0,i.asWebviewUri)(ue,k._initData.remote)}};return this._kernelData.set(v,{extensionId:t.identifier,controller:te,onDidReceiveMessage:z,onDidChangeSelection:U,associatedNotebooks:le}),te}$acceptNotebookAssociation(t,h,o){const l=this._kernelData.get(t);if(l){const E=this._extHostNotebook.getNotebookDocument(C.URI.revive(h));o?l.associatedNotebooks.set(E.uri,!0):l.associatedNotebooks.delete(E.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,E.uri.toString(),o),l.onDidChangeSelection.fire({selected:o,notebook:E.apiNotebook})}}async $executeCells(t,h,o){const l=this._kernelData.get(t);if(!l)return;const E=this._extHostNotebook.getNotebookDocument(C.URI.revive(h)),m=[];for(const v of o){const k=E.getCell(v);k&&m.push(k.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,E.uri.toString(),m.length),await l.controller.executeHandler.call(l.controller,m,E.apiNotebook,l.controller)}catch(v){this._logService.error(`NotebookController[${t}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(t,h,o){const l=this._kernelData.get(t);if(!l)return;const E=this._extHostNotebook.getNotebookDocument(C.URI.revive(h));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,E.apiNotebook);else for(const m of o){const v=E.getCell(m);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,h,o){const l=this._kernelData.get(t);if(!l)return;const E=this._extHostNotebook.getEditorById(h);l.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:o}))}$cellExecutionChanged(t,h,o){const E=this._extHostNotebook.getNotebookDocument(C.URI.revive(t)).getCell(h);E&&this._onDidChangeCellExecutionState.fire({cell:E.apiCell,state:o??n.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(t,h){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const E=new w(h,l,this._proxy);this._activeExecutions.set(l.uri,E);const m=E.onDidChangeState(()=>{E.state===f.Resolved&&(E.dispose(),m.dispose(),this._activeExecutions.delete(l.uri))});return E.asApiObject()}};u=Fe([Ne(4,N.ILogService)],u),e.ExtHostNotebookKernels=u;var f;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(f||(f={}));class w extends y.Disposable{constructor(t,h,o){super();this._cell=h,this._proxy=o,this._handle=w.HANDLE++,this._onDidChangeState=new x.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new a(10,l=>this.update(l)),this._executionOrder=h.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,t,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(t){await this._collector.addItem(t)}async update(t){const h=Array.isArray(t)?t:[t];return this._proxy.$updateExecution(this._handle,new M.SerializableObjectWithBuffers(h))}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(t){return t.map(h=>{const o=n.NotebookCellOutput.ensureUniqueMimeTypes(h.items,!0);return o===h.items?p.NotebookCellOutput.from(h):p.NotebookCellOutput.from({items:o,id:h.id,metadata:h.metadata})})}async updateOutputs(t,h,o){const l=this.validateAndConvertOutputs((0,r.asArray)(t));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,append:o,outputs:l})}async updateOutputItems(t,h,o){return t=n.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(t),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:t.map(p.NotebookCellOutputItem.from),outputId:h.id,append:o})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(o){t._executionOrder=o,t.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:t._executionOrder}])},start(o){if(t._state===f.Resolved||t._state===f.Started)throw new Error("Cannot call start again");t._state=f.Started,t._onDidChangeState.fire(),t.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:o})},end(o,l){if(t._state===f.Resolved)throw new Error("Cannot call resolve twice");t._state=f.Resolved,t._onDidChangeState.fire(),t._collector.flush(),t._proxy.$completeExecution(t._handle,new M.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:o}))},clearOutput(o){return t.verifyStateForOutput(),t.updateOutputs([],o,!1)},appendOutput(o,l){return t.verifyStateForOutput(),t.updateOutputs(o,l,!0)},replaceOutput(o,l){return t.verifyStateForOutput(),t.updateOutputs(o,l,!1)},appendOutputItems(o,l){return t.verifyStateForOutput(),t.updateOutputItems(o,l,!0)},replaceOutputItems(o,l){return t.verifyStateForOutput(),t.updateOutputItems(o,l,!1)}})}}w.HANDLE=0;class a{constructor(t,h){this.delay=t,this.callback=h,this.batch=[],this.startedTimer=Date.now()}addItem(t){return this.batch.push(t),this.currentDeferred||(this.currentDeferred=new I.DeferredPromise,this.startedTimer=Date.now(),(0,I.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const t=this.currentDeferred;this.currentDeferred=void 0;const h=this.batch;return this.batch=[],this.callback(h).finally(()=>t.complete())}}function P(c,t){return`${c.identifier.value}/${t}`}}),define(ve[197],Ee([1,0,5,4,89,27]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(C,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(I.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,R,N){const b=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(R)?.fire({editor:b.apiEditor,message:N})}createRendererMessaging(C,R){if(!C.contributes?.notebookRenderer?.some(p=>p.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const N=(0,x.isProposedApiEnabled)(C,"notebookEditor"),b=new WeakMap;return{onDidReceiveMessage:(p,n,i)=>{const d=N?p:S=>{const M={};b.set(M,S.editor),p({editor:M,message:S.message})};return this.getOrCreateEmitterFor(R).event(d,n,i)},postMessage:(p,n)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(p)&&([p,n]=[n,p]);const i=N?n:b.get(n),d=i&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(i);return this.proxy.$postMessage(d?.id,R,p)}}}getOrCreateEmitterFor(C){let R=this._rendererMessageEmitters.get(C);return R||(R=new r.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,R),R)}}e.ExtHostNotebookRenderers=y}),define(ve[94],Ee([1,0,4,6,3,14,12,162,50,28,30,112,21]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class p extends I.Disposable{constructor(d,S,M,u){super();this.id=d,this.name=S,this.logger=M,this.proxy=u,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(d){this.append(d+`
`)}append(d){this.write(d),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,d)}replace(d){const S=this.offset;this.write(d),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,S),this.visible&&this.logger.flush()}show(d,S){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:S))}hide(){this.proxy.$close(this.id)}write(d){this.offset+=s.VSBuffer.fromString(d).byteLength,this.logger.info(d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=p;let n=class{constructor(d,S,M,u,f){this.extHostFileSystem=M,this.extHostFileSystemInfo=u,this.loggerService=f,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(S.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[S,M]of this.channels)M.visible=S===this.visibleChannelId}createOutputChannel(d,S){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const M=this.doCreateOutputChannel(d,S);return M.then(u=>{this.channels.set(u.id,u),u.visible=u.id===this.visibleChannelId}),this.createExtHostOutputChannel(d,M)}async doCreateOutputChannel(d,S){const M=await this.createOutputDirectory(),u=this.extHostFileSystemInfo.extUri.joinPath(M,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),w=await this.proxy.$register(d,!1,u,S.identifier.value);return new p(w,d,f,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(d,S){let M=!1;const u=()=>{if(M)throw new Error("Channel has been closed")};return{get name(){return d},append(f){u(),S.then(w=>w.append(f))},appendLine(f){u(),S.then(w=>w.appendLine(f))},clear(){u(),S.then(f=>f.clear())},replace(f){u(),S.then(w=>w.replace(f))},show(f,w){u(),S.then(a=>a.show(f,w))},hide(){u(),S.then(f=>f.hide())},dispose(){M=!0,S.then(f=>f.dispose())}}}};n=Fe([Ne(0,x.IExtHostRpcService),Ne(1,R.IExtHostInitDataService),Ne(2,C.IExtHostConsumerFileSystem),Ne(3,N.IExtHostFileSystemInfo),Ne(4,y.ILoggerService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,_.createDecorator)("IExtHostOutputService")}),define(ve[198],Ee([1,0,11,20,5,6,4,2,7,15,16,34,56]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(n,i,d){const S=n.getProxy(y.MainContext.MainThreadQuickOpen);class M{constructor(o,l){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=l}showQuickPick(o,l,E=I.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(o),v=++this._instances,k=S.$show(v,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},E),T={},$=k.then(()=>T);return Promise.race([$,m]).then(g=>{if(g!==T)return m.then(U=>{const z=[];for(let q=0;q<U.length;q++){const j=U[q];typeof j=="string"?z.push({label:j,handle:q}):j.kind===C.QuickPickItemKind.Separator?z.push({type:"separator",label:j.label}):z.push({label:j.label,description:j.description,detail:j.detail,picked:j.picked,alwaysShow:j.alwaysShow,handle:q})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{l.onDidSelectItem(U[q])}),S.$setItems(v,z),k.then(q=>{if(typeof q=="number")return U[q];if(Array.isArray(q))return q.map(j=>U[j])})})}).then(void 0,g=>{if(!(0,R.isCancellationError)(g))return S.$setError(v,g),Promise.reject(g)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,l=I.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,S.$input(o,typeof this._validateInput=="function",l).then(void 0,E=>{if(!(0,R.isCancellationError)(E))return Promise.reject(E)})}$validateInput(o){return this._validateInput?(0,r.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,l=I.CancellationToken.None){const E=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!E)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(v=>v.uri.toString()===E.uri.toString())}createQuickPick(o){const l=new c(o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(o){const l=new t(o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(o,l){const E=this._sessions.get(o);E&&E._fireDidChangeValue(l)}$onDidAccept(o){const l=this._sessions.get(o);l&&l._fireDidAccept()}$onDidChangeActive(o,l){const E=this._sessions.get(o);E instanceof c&&E._fireDidChangeActive(l)}$onDidChangeSelection(o,l){const E=this._sessions.get(o);E instanceof c&&E._fireDidChangeSelection(l)}$onDidTriggerButton(o,l){const E=this._sessions.get(o);E&&E._fireDidTriggerButton(l)}$onDidTriggerItemButton(o,l,E){const m=this._sessions.get(o);m instanceof c&&m._fireDidTriggerItemButton(l,E)}$onDidHide(o){const l=this._sessions.get(o);l&&l._fireDidHide()}}class u{constructor(o,l){this._extensionId=o,this._onDidDispose=l,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((l,E)=>{const m=l===C.QuickInputButtons.Back?-1:E;this._handlesToButtons.set(m,l)}),this.update({buttons:o.map((l,E)=>({...P(l),tooltip:l.tooltip,handle:l===C.QuickInputButtons.Back?-1:E}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const l=this._handlesToButtons.get(o);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,x.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(o){if(!this._disposed){for(const l of Object.keys(o)){const E=o[l];this._pendingUpdate[l]=E===void 0?null:E}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}u._nextId=1;function f(h){if(h instanceof C.ThemeIcon)return{id:h.id};const o=a(h),l=w(h);return{dark:typeof o=="string"?A.URI.file(o):o,light:typeof l=="string"?A.URI.file(l):l}}function w(h){return typeof h=="object"&&"light"in h?h.light:h}function a(h){return typeof h=="object"&&"dark"in h?h.dark:h}function P(h){const o=f(h.iconPath);let l,E;return"id"in o?E=s.ThemeIcon.asClassName(o):l=o,{iconPath:l,iconClass:E}}class c extends u{constructor(o,l){super(o.identifier,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((E,m)=>{this._handlesToItems.set(m,E),this._itemsToHandles.set(E,m)});const l=[];for(let E=0;E<o.length;E++){const m=o[E];m.kind===C.QuickPickItemKind.Separator?l.push({type:"separator",label:m.label}):l.push({handle:E,label:m.label,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons?.map((v,k)=>({...P(v),tooltip:v.tooltip,handle:k}))})}this.update({items:l})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(o){const l=(0,N.coalesce)(o.map(E=>this._handlesToItems.get(E)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(o){const l=(0,N.coalesce)(o.map(E=>this._handlesToItems.get(E)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(o,l){const E=this._handlesToItems.get(o);if(!E||!E.buttons||!E.buttons.length)return;const m=E.buttons[l];m&&this._onDidTriggerItemButtonEmitter.fire({button:m,item:E})}}class t extends u{constructor(o,l){super(o,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?b.default.Error:b.default.Ignore})}}return new M(i,d)}e.createExtHostQuickOpen=p});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[199],Ee([1,0,2,5,52,6,11,4,16,107,12,25,56,8,27]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n){"use strict";var i,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function S(E){if(E)return typeof E.iconPath=="string"?r.URI.file(E.iconPath):r.URI.isUri(E.iconPath)||s.ThemeIcon.isThemeIcon(E.iconPath)?E.iconPath:void 0}function M(E,m){if(!E.iconPath&&!m.iconPath)return 0;if(E.iconPath){if(!m.iconPath)return 1}else return-1;const v=typeof E.iconPath=="string"?E.iconPath:r.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id,k=typeof m.iconPath=="string"?m.iconPath:r.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,R.comparePaths)(v,k)}function u(E,m){let v=0;if(E.strikeThrough!==m.strikeThrough)return E.strikeThrough?1:-1;if(E.faded!==m.faded)return E.faded?1:-1;if(E.tooltip!==m.tooltip)return(E.tooltip||"").localeCompare(m.tooltip||"");if(v=M(E,m),v!==0)return v;if(E.light&&m.light)v=M(E.light,m.light);else{if(E.light)return 1;if(m.light)return-1}if(v!==0)return v;if(E.dark&&m.dark)v=M(E.dark,m.dark);else{if(E.dark)return 1;if(m.dark)return-1}return v}function f(E,m){if(E.command!==m.command)return E.command<m.command?-1:1;if(E.title!==m.title)return E.title<m.title?-1:1;if(E.tooltip!==m.tooltip){if(E.tooltip!==void 0&&m.tooltip!==void 0)return E.tooltip<m.tooltip?-1:1;if(E.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(E.arguments===m.arguments)return 0;if(E.arguments)if(m.arguments){if(E.arguments.length!==m.arguments.length)return E.arguments.length-m.arguments.length}else return 1;else return-1;for(let v=0;v<E.arguments.length;v++){const k=E.arguments[v],T=m.arguments[v];if(k!==T)return k<T?-1:1}return 0}function w(E,m){let v=(0,R.comparePaths)(E.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(v!==0)return v;if(E.command&&m.command)v=f(E.command,m.command);else{if(E.command)return 1;if(m.command)return-1}if(v!==0)return v;if(E.decorations&&m.decorations)v=u(E.decorations,m.decorations);else{if(E.decorations)return 1;if(m.decorations)return-1}return v}function a(E,m){for(let v=0;v<E.length;v++)if(E[v]!==m[v])return!1;return!0}function P(E,m){return E.command===m.command&&E.title===m.title&&E.tooltip===m.tooltip&&(E.arguments&&m.arguments?a(E.arguments,m.arguments):E.arguments===m.arguments)}function c(E,m){return(0,C.equals)(E,m,P)}class t{constructor(m,v,k){this._extension=m,this._sourceControlHandle=k,i.set(this,void 0),this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0,je(this,i,v,"f")}get value(){return this._value}set value(m){m=m??"",ye(this,i,"f").$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){ye(this,i,"f").$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,n.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,ye(this,i,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,ye(this,i,"f").$setInputBoxVisibility(this._sourceControlHandle,m))}showValidationMessage(m,v){(0,n.checkProposedApiEnabled)(this._extension,"scmValidation"),ye(this,i,"f").$showValidationMessage(this._sourceControlHandle,m,v)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=t,i=new WeakMap;class h{constructor(m,v,k,T,$){this._proxy=m,this._commands=v,this._sourceControlHandle=k,this._id=T,this._label=$,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=h._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,v){const k=this._resourceStatesCommandsMap.get(m);return k?(0,y.asPromise)(()=>this._commands.executeCommand(k.command,...k.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(w),k=(0,C.sortedDiff)(this._resourceSnapshot,m,w).map(g=>{const U=g.toInsert.map(z=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,z);const j=z.resourceUri;let J;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const me=new x.DisposableStore;J=this._commands.converter.toInternal(z.command,me),this._resourceStatesDisposablesMap.set(q,me)}else this._resourceStatesCommandsMap.set(q,z.command);const W=S(z.decorations),ie=z.decorations&&S(z.decorations.light)||W,le=z.decorations&&S(z.decorations.dark)||W,te=[ie,le],ue=z.decorations&&z.decorations.tooltip||"",he=z.decorations&&!!z.decorations.strikeThrough,De=z.decorations&&!!z.decorations.faded,fe=z.contextValue||"";return{rawResource:[q,j,te,ue,he,De,fe,J],handle:q}});return{start:g.start,deleteCount:g.deleteCount,toInsert:U}}),T=k.map(({start:g,deleteCount:U,toInsert:z})=>[g,U,z.map(q=>q.rawResource)]),$=k.reverse();for(const{start:g,deleteCount:U,toInsert:z}of $){const q=z.map(J=>J.handle),j=this._handlesSnapshot.splice(g,U,...q);for(const J of j)this._resourceStatesMap.delete(J),this._resourceStatesCommandsMap.delete(J),this._resourceStatesDisposablesMap.get(J)?.dispose(),this._resourceStatesDisposablesMap.delete(J)}return this._resourceSnapshot=m,T}dispose(){this._disposed=!0,this._onDidDispose.fire()}}h._handlePool=0;class o{constructor(m,v,k,T,$,g){this._extension=m,this._commands=k,this._id=T,this._label=$,this._rootUri=g,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new x.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new x.MutableDisposable,this._statusBarDisposables=new x.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,je(this,d,v,"f"),this._inputBox=new t(m,ye(this,d,"f"),this.handle),ye(this,d,"f").$registerSourceControl(this.handle,T,$,g)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,ye(this,d,"f").$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,ye(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,ye(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new x.DisposableStore,this._acceptInputCommand=m;const v=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);ye(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,n.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new x.DisposableStore,this._actionButton=m;const v=m!==void 0?{command:this._commands.converter.toInternal(m.command,this._actionButtonDisposables.value),description:m.description}:void 0;ye(this,d,"f").$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&c(this._statusBarCommands,m))return;this._statusBarDisposables.value=new x.DisposableStore,this._statusBarCommands=m;const v=(m||[]).map(k=>this._commands.converter.toInternal(k,this._statusBarDisposables.value));ye(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(m,v){const k=new h(ye(this,d,"f"),this._commands,this.handle,m,v),T=I.Event.once(k.onDidDispose)(()=>this.createdResourceGroups.delete(k));return this.createdResourceGroups.set(k,T),this.eventuallyAddResourceGroups(),k}eventuallyAddResourceGroups(){const m=[],v=[];for(const[k,T]of this.createdResourceGroups){T.dispose();const $=k.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(k),this.eventuallyUpdateResourceStates()});I.Event.once(k.onDidDispose)(()=>{this.updatedResourceGroups.delete(k),$.dispose(),this._groups.delete(k.handle),ye(this,d,"f").$unregisterGroup(this.handle,k.handle)}),m.push([k.handle,k.id,k.label,k.features]);const g=k._takeResourceStateSnapshot();g.length>0&&v.push([k.handle,g]),this._groups.set(k.handle,k)}ye(this,d,"f").$registerGroups(this.handle,m,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(v=>{const k=v._takeResourceStateSnapshot();k.length!==0&&m.push([v.handle,k])}),m.length>0&&ye(this,d,"f").$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),ye(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,o._handlePool=0,Fe([(0,_.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Fe([(0,_.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let l=class Wi{constructor(m,v,k){this._commands=v,this.logService=k,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=m.getProxy(A.MainContext.MainThreadSCM),this._telemetry=m.getProxy(A.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===3){const $=this._sourceControls.get(T.sourceControlHandle);if(!$)return T;const g=$.getResourceGroup(T.groupHandle);return g?g.getResourceState(T.handle):T}else if(T&&T.$mid===4){const $=this._sourceControls.get(T.sourceControlHandle);return $?$.getResourceGroup(T.groupHandle):T}else if(T&&T.$mid===5){const $=this._sourceControls.get(T.handle);return $||T}return T}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,v,k,T){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,v,k,T),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const $=Wi._handlePool++,g=new o(m,this._proxy,this._commands,v,k,T);this._sourceControls.set($,g);const U=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(m.identifier))||[];return U.push(g),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(m.identifier),U),g}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const v=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(m.identifier)),k=v&&v[v.length-1];return k&&k.inputBox}$provideOriginalResource(m,v,k){const T=r.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,T.toString());const $=this._sourceControls.get(m);return!$||!$.quickDiffProvider||!$.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>$.quickDiffProvider.provideOriginalResource(T,k)).then(g=>g||null)}$onInputBoxValueChange(m,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const k=this._sourceControls.get(m);return k&&k.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(m,v,k,T){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,v,k);const $=this._sourceControls.get(m);if(!$)return Promise.resolve(void 0);const g=$.getResourceGroup(v);return g?g.$executeResourceCommand(k,T):Promise.resolve(void 0)}$validateInput(m,v,k){this.logService.trace("ExtHostSCM#$validateInput",m);const T=this._sourceControls.get(m);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>T.inputBox.validateInput(v,k)).then($=>{if(!$)return Promise.resolve(void 0);const g=p.MarkdownString.fromStrict($.message);return g?Promise.resolve([g,$.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};l._handlePool=0,l=Fe([Ne(2,N.ILogService)],l),e.ExtHostSCM=l});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[200],Ee([1,0,7,4,124,6,8,13]),function(Y,e,r,I,_,x,y,A){"use strict";var C,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(n,i,d,S,M=r.StatusBarAlignment.Left,u){C.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new x.DisposableStore,je(this,C,n,"f"),je(this,R,i,"f"),this._entryId=N.ID_GEN++,this._extension=d,this._id=S,this._alignment=M,this._priority=this.validatePriority(u)}validatePriority(n){if(!!(0,A.isNumber)(n))return n===Number.POSITIVE_INFINITY?Number.MAX_VALUE:n===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:n}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(n){this._text=n,this.update()}set name(n){this._name=n,this.update()}set tooltip(n){this._tooltip=n,this.update()}set color(n){this._color=n,this.update()}set backgroundColor(n){n&&!N.ALLOWED_BACKGROUND_COLORS.has(n.id)&&(n=void 0),this._backgroundColor=n,this.update()}set command(n){this._command?.fromApi!==n&&(this._internalCommandRegistration.clear(),typeof n=="string"?this._command={fromApi:n,internal:ye(this,R,"f").toInternal({title:"",command:n},this._internalCommandRegistration)}:n?this._command={fromApi:n,internal:ye(this,R,"f").toInternal(n,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(n){this._accessibilityInformation=n,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,ye(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let n;this._extension?this._id?n=`${this._extension.identifier.value}.${this._id}`:n=this._extension.identifier.value:n=this._id;let i;this._name?i=this._name:i=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=N.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=y.MarkdownString.fromStrict(this._tooltip);ye(this,C,"f").$setEntry(this._entryId,n,i,this._text,S,this._command?.internal,d,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=N,C=new WeakMap,R=new WeakMap,N.ID_GEN=0,N.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(n){this._messages=[],this._item=n.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(n){const i={message:n};return this._messages.unshift(i),this._update(),new r.Disposable(()=>{const d=this._messages.indexOf(i);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class s{constructor(n,i){this._proxy=n.getProxy(I.MainContext.MainThreadStatusBar),this._commands=i,this._statusMessage=new b(this)}createStatusBarEntry(n,i,d,S){return new N(this._proxy,this._commands,n,i,d,S)}setStatusBarMessage(n,i){const d=this._statusMessage.setMessage(n);let S;return typeof i=="number"?S=setTimeout(()=>d.dispose(),i):typeof i!="undefined"&&i.then(()=>d.dispose(),()=>d.dispose()),new r.Disposable(()=>{d.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=s}),define(ve[66],Ee([1,0,4,5,3]),function(Y,e,r,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class x{constructor(A){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,C){this._proxy.$registerExtensionStorageKeysToSync(A,C)}initializeExtensionStorage(A,C,R){return this._proxy.$initializeExtensionStorage(A,C).then(N=>N||R)}setValue(A,C,R){return this._proxy.$setValue(A,C,R)}$acceptValue(A,C,R){this._onDidChangeStorage.fire({shared:A,key:C,value:R})}}e.ExtHostStorage=x,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(ve[67],Ee([1,0,3,28,12,50,2]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let A=class{constructor(R,N,b){this._logService=N,this._extHostFileSystem=b,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(s=>this._value=s)}async _getWorkspaceStorageURI(R){return y.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,N=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(N),this._logService.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",N),await this._extHostFileSystem.value.createDirectory(N),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),N}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(R){if(this._value)return y.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return y.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=Fe([Ne(0,I.IExtHostInitDataService),Ne(1,_.ILogService),Ne(2,x.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ve[40],Ee([1,0,5,4,3,2,14,6,7,125,15,164,20,36,144,56,13,11]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class M{constructor(o,l,E,m){this._proxy=o,this._id=l,this._creationOptions=E,this._name=m,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(k=>this._pidPromiseComplete=k);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},get state(){return v._state},sendText(k,T=!0){v._checkDisposed(),v._proxy.$sendText(v._id,k,T)},show(k){v._checkDisposed(),v._proxy.$show(v._id,k)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(o,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,d.withNullAsUndefined)(o.shellPath),shellArgs:(0,d.withNullAsUndefined)(o.shellArgs),cwd:(0,d.withNullAsUndefined)(o.cwd),env:(0,d.withNullAsUndefined)(o.env),icon:(0,d.withNullAsUndefined)(c(o.iconPath)),color:i.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,d.withNullAsUndefined)(o.message),strictEnv:(0,d.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(o.location,l?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,l,E,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:E,color:i.ThemeColor.isThemeColor(m)?m.id:void 0,location:this._serializeParentTerminal(o,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,l){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in o?{viewColumn:o.viewColumn,preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitCode(o){this._exitStatus=Object.freeze({code:o})}setDimensions(o,l){return o===this._cols&&l===this._rows||o===0||l===0?!1:(this._cols=o,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=M;class u{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,l){this._pty.setDimensions?.({columns:o,rows:l})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=u;let f=1,w=class extends A.Disposable{constructor(o,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new n.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[E,m]of this._terminalProcesses)m.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,l){const E=new M(this._proxy,(0,p.generateUuid)(),o,o.name),m=new u(o.pty);return E.createExtensionTerminal(o.location,this._serializeParentTerminal(o,l).resolvedExtHostIdentifier,c(o.iconPath),t(o.color)).then(v=>{const k=this._setupExtHostProcessListeners(v,m);this._terminalProcessDisposables[v]=k}),this._terminals.push(E),E.value}_serializeParentTerminal(o,l){if(l=l||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const E=o.location.parentTerminal;if(E){const m=this._terminals.find(v=>v.value===E);m&&(l.resolvedExtHostIdentifier=m._id)}}else o.location&&typeof o.location!="object"?l.location=o.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(o,l){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const m=new u(l),v=this._setupExtHostProcessListeners(o,m);this._terminalProcessDisposables[o]=v}async $acceptActiveTerminalChanged(o){const l=this._activeTerminal;if(o===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const E=this._getTerminalById(o);E&&(this._activeTerminal=E,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,l){const E=this._getTerminalById(o);E&&this._onDidWriteTerminalData.fire({terminal:E.value,data:l})}async $acceptTerminalDimensions(o,l,E){const m=this._getTerminalById(o);m&&m.setDimensions(l,E)&&this._onDidChangeTerminalDimensions.fire({terminal:m.value,dimensions:m.value.dimensions})}async $acceptTerminalMaximumDimensions(o,l,E){this._terminalProcesses.get(o)?.resize(l,E)}async $acceptTerminalTitleChange(o,l){const E=this._getTerminalById(o);E&&(E.name=l)}async $acceptTerminalClosed(o,l){const E=this._getTerminalObjectIndexById(this._terminals,o);if(E!==null){const m=this._terminals.splice(E,1)[0];m.setExitCode(l),this._onDidCloseTerminal.fire(m.value)}}$acceptTerminalOpened(o,l,E,m){if(l){const T=this._getTerminalObjectIndexById(this._terminals,l);if(T!==null){this._terminals[T]._id=o,this._onDidOpenTerminal.fire(this.terminals[T]),this._terminals[T].isOpen=!0;return}}const v={name:m.name,shellPath:m.executable,shellArgs:m.args,cwd:typeof m.cwd=="string"?m.cwd:x.URI.revive(m.cwd),env:m.env,hideFromUser:m.hideFromUser},k=new M(this._proxy,o,v,E);this._terminals.push(k),this._onDidOpenTerminal.fire(k.value),k.isOpen=!0}async $acceptTerminalProcessId(o,l){const E=this._getTerminalById(o);E&&E._setProcessId(l)}async $startExtensionTerminal(o,l){const E=this._getTerminalById(o);if(!E)return{message:(0,R.localize)(0,null,o)};E.isOpen||await new Promise(v=>{const k=this.onDidOpenTerminal(async T=>{T===E.value&&(k.dispose(),v())})});const m=this._terminalProcesses.get(o);m?m.startSendingEvents(l):this._extensionTerminalAwaitingStart[o]={initialDimensions:l}}_setupExtHostProcessListeners(o,l){const E=new A.DisposableStore;E.add(l.onProcessReady(v=>this._proxy.$sendProcessReady(o,v.pid,v.cwd))),E.add(l.onDidChangeProperty(v=>this._proxy.$sendProcessProperty(o,v))),this._bufferer.startBuffering(o,l.onProcessData),E.add(l.onProcessExit(v=>this._onProcessExit(o,v))),this._terminalProcesses.set(o,l);const m=this._extensionTerminalAwaitingStart[o];return m&&l instanceof u&&(l.startSendingEvents(m.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),E}$acceptProcessAckDataEvent(o,l){this._terminalProcesses.get(o)?.acknowledgeDataEvent(l)}$acceptProcessInput(o,l){this._terminalProcesses.get(o)?.input(l)}$acceptTerminalInteraction(o){const l=this._getTerminalById(o);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(o,l,E){try{this._terminalProcesses.get(o)?.resize(l,E)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(o,l){this._terminalProcesses.get(o)?.shutdown(l)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(l=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:l}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,l,E){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,E),this._proxy.$registerProfileProvider(l,o.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(o,l){const E=new s.CancellationTokenSource().token;let m=await this._profileProviders.get(o)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(m&&!("options"in m)&&(m={options:m}),!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,l);return}this.createTerminalFromOptions(m.options,l)}}async $provideLinks(o,l){const E=this._getTerminalById(o);if(!E)return[];this._terminalLinkCache.delete(o);const m=this._terminalLinkCancellationSource.get(o);m&&m.dispose(!0);const v=new s.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,v);const k=[],T={terminal:E.value,line:l},$=[];for(const z of this._linkProviders)$.push(S.Promises.withAsyncBody(async q=>{v.token.onCancellationRequested(()=>q({provider:z,links:[]}));const j=await z.provideTerminalLinks(T,v.token)||[];v.token.isCancellationRequested||q({provider:z,links:j})}));const g=await Promise.all($);if(v.token.isCancellationRequested)return[];const U=new Map;for(const z of g)z&&z.links.length>0&&k.push(...z.links.map(q=>{const j={id:f++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return U.set(j.id,{provider:z.provider,link:q}),j}));return this._terminalLinkCache.set(o,U),k}$activateLink(o,l){const E=this._terminalLinkCache.get(o)?.get(l);!E||E.provider.handleTerminalLink(E.link)}_onProcessExit(o,l){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const E=this._terminalProcessDisposables[o];E&&(E.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,l)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,l){const E=this._getTerminalObjectIndexById(o,l);return E!==null?o[E]:null}_getTerminalObjectIndexById(o,l){let E=null;return o.some((m,v)=>m._id===l?(E=v,!0):!1),E}getEnvironmentVariableCollection(o){let l=this._environmentVariableCollections.get(o.identifier.value);return l||(l=new a,this._setEnvironmentVariableCollection(o.identifier.value,l)),l}_syncEnvironmentVariableCollection(o,l){const E=(0,b.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(o,l.persistent,E.length===0?void 0:E)}$initEnvironmentVariableCollections(o){o.forEach(l=>{const E=l[0],m=new a(l[1]);this._setEnvironmentVariableCollection(E,m)})}$acceptDefaultProfile(o,l){this._defaultProfile=o,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(o,l){this._environmentVariableCollections.set(o,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,l)})}};w=Fe([Ne(1,y.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class a{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,l){this._setIfDiffers(o,{value:l,type:C.EnvironmentVariableMutatorType.Replace})}append(o,l){this._setIfDiffers(o,{value:l,type:C.EnvironmentVariableMutatorType.Append})}prepend(o,l){this._setIfDiffers(o,{value:l,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,l){const E=this.map.get(o);(!E||E.value!==l.value||E.type!==l.type)&&(this.map.set(o,l),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,l){this.map.forEach((E,m)=>o.call(l,m,E,this))}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let P=class extends w{constructor(o){super(!1,o)}createTerminal(o,l,E){throw new N.NotSupportedError}createTerminalFromOptions(o,l){throw new N.NotSupportedError}};P=Fe([Ne(0,y.IExtHostRpcService)],P),e.WorkerExtHostTerminalService=P;function c(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function t(h){return i.ThemeColor.isThemeColor(h)?h:void 0}});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[201],Ee([1,0,16,21,20,5,232,93,6,26,13,36,4,14,48,8,7,170,61,62]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let w=class{constructor(T,$){this.resultsChangedEmitter=new x.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(s.MainContext.MainThreadTesting),this.observer=new E(this.proxy),this.runTracker=new P(this.proxy),$.registerArgumentProcessor({processArgument:g=>g?.$mid===13?i.TestItem.toItemFromContext(g):g})}createTestController(T,$,g){if(this.controllers.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const U=new C.DisposableStore,z=U.add(new S.SingleUseTestCollection(T));z.root.label=$;const q=new Map,j=this.proxy,J={items:z.root.children,get label(){return $},set label(ie){$=ie,z.root.label=ie,j.$updateController(T,{label:$})},get refreshHandler(){return g},set refreshHandler(ie){g=ie,j.$updateController(T,{canRefresh:!!ie})},get id(){return T},createRunProfile:(ie,le,te,ue,he)=>{let De=(0,A.hash)(ie);for(;q.has(De);)De++;const fe=new m(this.proxy,T,De,ie,le,te,ue,he);return q.set(De,fe),fe},createTestItem(ie,le,te){return new n.TestItemImpl(T,ie,le,te)},createTestRun:(ie,le,te=!0)=>this.runTracker.createTestRun(T,z,ie,le,te),set resolveHandler(ie){z.resolveHandler=ie},get resolveHandler(){return z.resolveHandler},dispose:()=>{U.dispose()}};j.$registerTestController(T,$,!!g),U.add((0,C.toDisposable)(()=>j.$unregisterTestController(T)));const W={controller:J,collection:z,profiles:q};return this.controllers.set(T,W),U.add((0,C.toDisposable)(()=>this.controllers.delete(T))),U.add(z.onDidGenerateDiff(ie=>j.$publishDiff(T,ie))),J}createTestObserver(){return this.observer.checkout()}async runTests(T,$=_.CancellationToken.None){const g=c(T);if(!g)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(g.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(z=>z.id)??[U.collection.root.id],profileGroup:v[g.kind],profileId:g.profileId,controllerId:g.controllerId}],exclude:T.exclude?.map(z=>z.id)},$)}$provideFileCoverage(T,$,g){return(0,r.mapFind)(this.runTracker.trackers,z=>z.id===T?z.getCoverage($):void 0)?.provideFileCoverage(g)??Promise.resolve([])}$resolveFileCoverage(T,$,g,U){return(0,r.mapFind)(this.runTracker.trackers,q=>q.id===T?q.getCoverage($):void 0)?.resolveFileCoverage(g,U)??Promise.resolve([])}$configureRunProfile(T,$){this.controllers.get(T)?.profiles.get($)?.configureHandler?.()}async $refreshTests(T,$){await this.controllers.get(T)?.controller.refreshHandler?.($)}$publishTestResults(T){this.results=Object.freeze(T.map($=>(0,R.deepFreeze)(i.TestResults.to($))).concat(this.results).sort(($,g)=>g.completedAt-$.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(T,$){const g=this.controllers.get(u.TestId.fromString(T).controllerId)?.collection;g&&(await g.expand(T,$<0?1/0:$),g.flushDiff())}$acceptDiff(T){this.observer.applyDiff(T)}async $runControllerTests(T,$){const g=this.controllers.get(T.controllerId);if(!g)return;const{collection:U,profiles:z}=g,q=z.get(T.profileId);if(!q)return;const j=T.testIds.map(le=>U.tree.get(le)).filter(N.isDefined),J=T.excludeExtIds.map(le=>g.collection.tree.get(le)).filter(N.isDefined).filter(le=>j.some(te=>te.fullId.compare(le.fullId)===2));if(!j.length)return;const W=new d.TestRunRequest(j.some(le=>le.actual instanceof n.TestItemRootImpl)?void 0:j.map(le=>le.actual),J.map(le=>le.actual),q),ie=this.runTracker.prepareForMainThreadTestRun(W,t.fromInternal(T,g.collection),$);try{await q.runHandler(W,$)}finally{ie.isRunning&&!$.isCancellationRequested&&await x.Event.toPromise(ie.onEnd),ie.dispose()}}$cancelExtensionTestRun(T){T===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(T)}};w=Fe([Ne(0,p.IExtHostRpcService)],w),e.ExtHostTesting=w;class a extends C.Disposable{constructor(T,$,g){super();this.dto=T,this.proxy=$,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new x.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(g)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(T){return this.tasks.get(T)?.coverage}createRun(T){const $=this.dto.id,g=this.dto.controllerId,U=(0,b.generateUuid)(),z=new h(this.proxy,$,U),q=ie=>(le,...te)=>{if(J){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(le)||(this.ensureTestIsKnown(le),ie(le,...te))},j=(ie,le)=>{const te=le instanceof Array?le.map(i.TestMessage.from):[i.TestMessage.from(le)];if(ie.uri&&ie.range){const ue={range:i.Range.from(ie.range),uri:ie.uri};for(const he of te)he.location=he.location||ue}this.proxy.$appendTestMessagesInRun($,U,u.TestId.fromExtHostTestItem(ie,g).toString(),te)};let J=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:T,get coverageProvider(){return z.coverageProvider},set coverageProvider(ie){z.coverageProvider=ie},enqueued:q(ie=>{this.proxy.$updateTestStateInRun($,U,u.TestId.fromExtHostTestItem(ie,g).toString(),1)}),skipped:q(ie=>{this.proxy.$updateTestStateInRun($,U,u.TestId.fromExtHostTestItem(ie,g).toString(),5)}),started:q(ie=>{this.proxy.$updateTestStateInRun($,U,u.TestId.fromExtHostTestItem(ie,g).toString(),2)}),errored:q((ie,le,te)=>{j(ie,le),this.proxy.$updateTestStateInRun($,U,u.TestId.fromExtHostTestItem(ie,g).toString(),6,te)}),failed:q((ie,le,te)=>{j(ie,le),this.proxy.$updateTestStateInRun($,U,u.TestId.fromExtHostTestItem(ie,g).toString(),4,te)}),passed:q((ie,le)=>{this.proxy.$updateTestStateInRun($,U,u.TestId.fromExtHostTestItem(ie,this.dto.controllerId).toString(),3,le)}),appendOutput:(ie,le,te)=>{J||(te&&(this.dto.isIncluded(te)?this.ensureTestIsKnown(te):te=void 0),this.proxy.$appendOutputToRun($,U,I.VSBuffer.fromString(ie),le&&i.location.from(le),te&&u.TestId.fromExtHostTestItem(te,g).toString()))},end:()=>{J||(J=!0,this.proxy.$finishedTestRunTask($,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:W,coverage:z}),this.proxy.$startedTestRunTask($,{id:U,name:T,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(T){if(!(T instanceof n.TestItemImpl))throw new n.InvalidTestItemError(T.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(T,this.dto.controllerId).toString()))return;const $=[],g=this.dto.colllection.root;for(;;){const U=i.TestItem.from(T);if($.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),T===g))break;T=T.parent||g}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,$)}}class P{constructor(T){this.proxy=T,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(T,$,g){return this.getTracker(T,$,g)}cancelRunById(T){for(const $ of this.tracked.values())if($.id===T){$.dispose();return}}cancelAllRuns(){for(const T of this.tracked.values())T.dispose()}createTestRun(T,$,g,U,z){const q=this.tracked.get(g);if(q)return q.createRun(U);const j=t.fromPublic(T,$,g,z),J=c(g);this.proxy.$startedExtensionTestRun({controllerId:T,profile:J&&{group:v[J.kind],id:J.profileId},exclude:g.exclude?.map(ie=>ie.id)??[],id:j.id,include:g.include?.map(ie=>ie.id)??[$.root.id],persist:z});const W=this.getTracker(g,j);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(j.id)),W.createRun(U)}getTracker(T,$,g){const U=new a($,this.proxy,g);return this.tracked.set(T,U),U.onEnd(()=>this.tracked.delete(T)),U}}e.TestRunCoordinator=P;const c=k=>{if(!!k.profile){if(!(k.profile instanceof m))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return k.profile}};class t{constructor(T,$,g,U,z,q){this.controllerId=T,this.id=$,this.isPersisted=z,this.colllection=q,this.includePrefix=g.map(j=>j+"\0"),this.excludePrefix=U.map(j=>j+"\0")}static fromPublic(T,$,g,U){return new t(T,(0,b.generateUuid)(),g.include?.map(z=>u.TestId.fromExtHostTestItem(z,T).toString())??[T],g.exclude?.map(z=>u.TestId.fromExtHostTestItem(z,T).toString())??[],U,$)}static fromInternal(T,$){return new t(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,$)}isIncluded(T){const $=u.TestId.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const g of this.excludePrefix)if($===g||$.startsWith(g))return!1;for(const g of this.includePrefix)if($===g||$.startsWith(g))return!0;return!1}}e.TestRunDto=t;class h{constructor(T,$,g){this.proxy=T,this.runId=$,this.taskId=g}set coverageProvider(T){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this._coverageProvider=T,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(T){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(T))());try{return(await this.fileCoverage)?.map(i.TestCoverage.fromFile)??[]}catch($){throw this.fileCoverage=void 0,$}}async resolveFileCoverage(T,$){const g=await this.fileCoverage;let U=g?.[T];return!this._coverageProvider||!g||!U?[]:(U.detailedCoverage||(U=g[T]=await this._coverageProvider.resolveFileCoverage?.(U,$)??U),U.detailedCoverage?.map(i.TestCoverage.fromDetailed)??[])}}class o extends M.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,i.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:$,removed:g}=this;return{get added(){return[...T].map(U=>U.revived)},get updated(){return[...$].map(U=>U.revived)},get removed(){return[...g].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends M.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new x.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,$){return{...T,revived:i.TestItem.toPlain(T.item),depth:$?$.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=l;class E{constructor(T){this.proxy=T}checkout(){this.current||(this.current=this.createObserverData());const T=this.current;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map($=>$.revived)},dispose:(0,y.once)(()=>{--T.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(T){return this.current?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.current?.tests.apply(T)}createObserverData(){const T=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:T}}}class m{constructor(T,$,g,U,z,q,j=!1,J=void 0){this.controllerId=$,this.profileId=g,this._label=U,this.kind=z,this.runHandler=q,this._isDefault=j,this._tag=J,f.set(this,void 0),je(this,f,T,"f");const W=v[z];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);ye(this,f,"f").$publishTestRunProfile({profileId:g,controllerId:$,tag:J?i.TestTag.namespace(this.controllerId,J.id):null,label:U,group:W,isDefault:j,hasConfigurationHandler:!1})}get label(){return this._label}set label(T){T!==this._label&&(this._label=T,ye(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get isDefault(){return this._isDefault}set isDefault(T){T!==this._isDefault&&(this._isDefault=T,ye(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,ye(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?i.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(T){T!==this._configureHandler&&(this._configureHandler=T,ye(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}dispose(){ye(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=m,f=new WeakMap;const v={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(ve[202],Ee([1,0,5,16,4,90,8,7]),function(Y,e,r,I,_,x,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(N,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new r.Emitter,this._onDidChangeTextEditorOptions=new r.Emitter,this._onDidChangeTextEditorVisibleRanges=new r.Emitter,this._onDidChangeTextEditorViewColumn=new r.Emitter,this._onDidChangeActiveTextEditor=new r.Emitter,this._onDidChangeVisibleTextEditors=new r.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=N.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(s=>this._onDidChangeVisibleTextEditors.fire(s)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(s=>this._onDidChangeActiveTextEditor.fire(s))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(N){const b=this._extHostDocumentsAndEditors.allEditors();return N?b:b.map(s=>s.value)}async showTextDocument(N,b,s){let p;typeof b=="number"?p={position:y.ViewColumn.from(b),preserveFocus:s}:typeof b=="object"?p={position:y.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?y.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:p={preserveFocus:!1};const n=await this._proxy.$tryShowTextDocument(N.uri,p),i=n&&this._extHostDocumentsAndEditors.getEditor(n);if(i)return i.value;throw n?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,b){return new x.TextEditorDecorationType(this._proxy,N,b).value}$acceptEditorPropertiesChanged(N,b){const s=this._extHostDocumentsAndEditors.getEditor(N);if(!s)throw new Error("unknown text editor");if(b.options&&s._acceptOptions(b.options),b.selections){const p=b.selections.selections.map(y.Selection.to);s._acceptSelections(p)}if(b.visibleRanges){const p=I.coalesce(b.visibleRanges.map(y.Range.to));s._acceptVisibleRanges(p)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:s.value,options:{...b.options,lineNumbers:y.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const p=A.TextEditorSelectionChangeKind.fromValue(b.selections.source),n=b.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:s.value,selections:n,kind:p})}if(b.visibleRanges){const p=I.coalesce(b.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:s.value,visibleRanges:p})}}$acceptEditorPositionData(N){for(const b in N){const s=this._extHostDocumentsAndEditors.getEditor(b);if(!s)throw new Error("Unknown text editor");const p=y.ViewColumn.to(N[b]);s.value.viewColumn!==p&&(s._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:s.value,viewColumn:p}))}}getDiffInformation(N){return Promise.resolve(this._proxy.$getDiffInformation(N))}}e.ExtHostEditors=C}),define(ve[203],Ee([1,0,2,3,4,6,7]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class A{constructor(N,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=N.getProxy(_.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===11){const p=s.uri===void 0?void 0:r.URI.revive(s.uri);return this._itemsBySourceAndUriMap.get(s.source)?.get(C(p))?.get(s.handle)}return s}})}async $getTimeline(N,b,s,p,n){return this._providers.get(N)?.provideTimeline(r.URI.revive(b),s,p,n)}registerTimelineProvider(N,b,s,p){const n=new x.DisposableStore,i=this.convertTimelineItem(b.id,p,n).bind(this);let d;b.onDidChange&&(d=b.onDidChange(M=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...M,id:b.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:N,onDidChange:void 0,async provideTimeline(M,u,f,w){w?.resetCache&&(n.clear(),S.get(b.id)?.clear());const a=await b.provideTimeline(M,u,f);if(a==null)return;const P=i(M,w);return{...a,source:b.id,items:a.items.map(P)}},dispose(){for(const M of S.values())M.get(b.id)?.clear();d?.dispose(),n.dispose()}})}convertTimelineItem(N,b,s){return(p,n)=>{let i;if(n?.cacheResults){let d=this._itemsBySourceAndUriMap.get(N);d===void 0&&(d=new Map,this._itemsBySourceAndUriMap.set(N,d));const S=C(p);i=d.get(S),i===void 0&&(i=new Map,d.set(S,i))}return d=>{const{iconPath:S,...M}=d,u=`${N}|${d.id??d.timestamp}`;i?.set(u,d);let f,w,a;return d.iconPath&&(S instanceof y.ThemeIcon?a={id:S.id,color:S.color}:r.URI.isUri(S)?(f=S,w=S):{light:f,dark:w}=S),{...M,id:M.id??void 0,handle:u,source:N,command:d.command?b.toInternal(d.command,s):void 0,icon:f,iconDark:w,themeIcon:a,accessibilityInformation:d.accessibilityInformation}}}}registerTimelineProviderCore(N){if(this._providers.get(N.id))throw new Error(`Timeline Provider ${N.id} already exists.`);return this._proxy.$registerTimelineProvider({id:N.id,label:N.label,scheme:N.scheme}),this._providers.set(N.id,N),(0,x.toDisposable)(()=>{for(const s of this._itemsBySourceAndUriMap.values())s.get(N.id)?.clear();this._providers.delete(N.id),this._proxy.$unregisterTimelineProvider(N.id),N.dispose()})}}e.ExtHostTimeline=A;function C(R){return R?.toString()}}),define(ve[204],Ee([1,0,6,9,2,4]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(C){this._openers=new Map,this._proxy=C.getProxy(x.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,R,N,b){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const s=b.schemes.find(p=>!y.supportedSchemes.has(p));if(s)throw new Error(`Scheme '${s}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,N),this._proxy.$registerUriOpener(R,b.schemes,C,b.label),(0,r.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(C,R,N){const b=this._openers.get(C);if(!b)throw new Error(`Unknown opener with id: ${C}`);const s=_.URI.revive(R);return b.canOpenExternalUri(s,N)}async $openUri(C,R,N){const b=this._openers.get(C);if(!b)throw new Error(`Unknown opener id: '${C}'`);return b.openExternalUri(_.URI.revive(R.resolvedUri),{sourceUri:_.URI.revive(R.sourceUri)},N)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(ve[205],Ee([1,0,4,2,6,15,25]),function(Y,e,r,I,_,x,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(R,N){if(this.handles.has(y.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const b=A.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(R)),this.handlers.set(b,N),this._proxy.$registerUriHandler(b,R),(0,_.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(R)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(R,N){const b=this.handlers.get(R);if(!b)return Promise.resolve(void 0);try{b.handleUri(I.URI.revive(N))}catch(s){(0,x.onUnexpectedError)(s)}return Promise.resolve(void 0)}async createAppUri(R){return I.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=A,A.HandlePool=0});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[51],Ee([1,0,5,9,2,135,153,60,4]),function(Y,e,r,I,_,x,y,A,C){"use strict";var R,N,b,s,p,n,i,d,S,M,u,f;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(E,m,v,k,T,$,g){R.set(this,void 0),N.set(this,void 0),b.set(this,void 0),s.set(this,void 0),p.set(this,void 0),n.set(this,void 0),i.set(this,""),d.set(this,void 0),S.set(this,!1),M.set(this,!1),u.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new r.Emitter),this._onDidDispose=ye(this,f,"f").event,je(this,R,E,"f"),je(this,N,m,"f"),je(this,d,v,"f"),je(this,s,k,"f"),je(this,p,T,"f"),je(this,n,$,"f"),je(this,u,a($),"f"),je(this,b,g,"f")}dispose(){je(this,S,!0,"f"),ye(this,f,"f").fire(),ye(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return je(this,M,!0,"f"),(0,A.asWebviewUri)(E,ye(this,s,"f").remote)}get cspSource(){const E=ye(this,n,"f").extensionLocation;if(E.scheme===I.Schemas.https||E.scheme===I.Schemas.http){let m=E.toString();return m.endsWith("/")||(m+="/"),m+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),ye(this,i,"f")}set html(E){this.assertNotDisposed(),ye(this,i,"f")!==E&&(je(this,i,E,"f"),!ye(this,M,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(je(this,M,!0,"f"),ye(this,b,"f").report("Webview vscode-resource: uris",ye(this,n,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),ye(this,N,"f").$setHtml(ye(this,R,"f"),E))}get options(){return this.assertNotDisposed(),ye(this,d,"f")}set options(E){this.assertNotDisposed(),ye(this,N,"f").$setOptions(ye(this,R,"f"),t(ye(this,n,"f"),ye(this,p,"f"),E)),je(this,d,E,"f")}async postMessage(E){if(ye(this,S,"f"))return!1;const m=(0,y.serializeWebviewMessage)(E,{serializeBuffersForPostMessage:ye(this,u,"f")});return ye(this,N,"f").$postMessage(ye(this,R,"f"),m.message,...m.buffers)}assertNotDisposed(){if(ye(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,R=new WeakMap,N=new WeakMap,b=new WeakMap,s=new WeakMap,p=new WeakMap,n=new WeakMap,i=new WeakMap,d=new WeakMap,S=new WeakMap,M=new WeakMap,u=new WeakMap,f=new WeakMap;function a(l){try{const E=(0,x.normalizeVersion)((0,x.parseVersion)(l.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class P{constructor(E,m,v,k,T){this.initData=m,this.workspace=v,this._logService=k,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=E.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(E,m,v){const k=this.getWebview(E);if(k){const{message:T}=(0,y.deserializeWebviewMessage)(m,v.value);k._onMessageEmitter.fire(T)}}$onMissingCsp(E,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,m,v){const k=new w(E,this._webviewProxy,h(m),this.initData,this.workspace,v,this._deprecationService);return this._webviews.set(E,k),k._onDidDispose(()=>{this._webviews.delete(E)}),k}deleteWebview(E){this._webviews.delete(E)}getWebview(E){return this._webviews.get(E)}}e.ExtHostWebviews=P;function c(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=c;function t(l,E,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||o(l,E)}}e.serializeWebviewOptions=t;function h(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(E=>_.URI.from(E))}}e.reviveOptions=h;function o(l,E){return[...(E?.getWorkspaceFolders()||[]).map(m=>m.uri),l.extensionLocation]}}),define(ve[206],Ee([1,0,20,93,6,9,24,2,8,51,57,4,7]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(a,P){this.document=a,this._storagePath=P,this._backupCounter=1,this._edits=new N.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,P){await this.getEdit(a).undo(),P||this.disposeBackup()}async redo(a,P){await this.getEdit(a).redo(),P||this.disposeBackup()}disposeEdits(a){for(const P of a)this._edits.delete(P)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=f(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const P=this._edits.get(a,0);if(!P)throw new Error("No edit found");return P}}class n{constructor(){this._documents=new Map}get(a,P){return this._documents.get(this.key(a,P))}add(a,P,c){const t=this.key(a,P.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${a} resource:${P.uri}`);const h=new p(P,c);return this._documents.set(t,h),h}delete(a,P){const c=this.key(a,P.uri);this._documents.delete(c)}key(a,P){return`${a}@@@${P}`}}var i;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(i||(i={}));class d{constructor(){this._providers=new Map}addTextProvider(a,P,c){return this.add(0,a,P,c)}addCustomProvider(a,P,c){return this.add(1,a,P,c)}get(a){return this._providers.get(a)}add(a,P,c,t){if(this._providers.has(P))throw new Error(`Provider for viewType:${P} already registered`);return this._providers.set(P,{type:a,extension:c,provider:t}),new s.Disposable(()=>this._providers.delete(P))}}class S{constructor(a,P,c,t,h){this._extHostDocuments=P,this._extensionStoragePaths=c,this._extHostWebview=t,this._extHostWebviewPanels=h,this._editorProviders=new d,this._documents=new n,this._proxy=a.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,P,c,t){const h=new _.DisposableStore;return M(c)?(h.add(this._editorProviders.addTextProvider(P,a,c)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(a),P,t.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(a))):(h.add(this._editorProviders.addCustomProvider(P,a,c)),this.supportEditing(c)&&h.add(c.onDidChangeCustomDocument(o=>{const l=this.getCustomDocumentEntry(P,o.document.uri);if(u(o)){const E=l.addEdit(o);this._proxy.$onDidEdit(o.document.uri,P,E,o.label)}else this._proxy.$onContentChange(o.document.uri,P)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(a),P,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(a))),s.Disposable.from(h,new s.Disposable(()=>{this._proxy.$unregisterEditorProvider(P)}))}async $createCustomDocument(a,P,c,t,h){const o=this._editorProviders.get(P);if(!o)throw new Error(`No provider found for '${P}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${P}'`);const l=A.URI.revive(a),E=await o.provider.openCustomDocument(l,{backupId:c,untitledDocumentData:t?.buffer},h);let m;return this.supportEditing(o.provider)&&this._extensionStoragePaths&&(m=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension)),this._documents.add(P,E,m),{editable:this.supportEditing(o.provider)}}async $disposeCustomDocument(a,P){const c=this._editorProviders.get(P);if(!c)throw new Error(`No provider found for '${P}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${P}'`);const t=A.URI.revive(a),{document:h}=this.getCustomDocumentEntry(P,t);this._documents.delete(P,h),h.dispose()}async $resolveWebviewEditor(a,P,c,t,h,o){const l=this._editorProviders.get(c);if(!l)throw new Error(`No provider found for '${c}'`);const E=C.ViewColumn.to(h),m=this._extHostWebview.createNewWebview(P,t.webviewOptions,l.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(P,c,t.title,E,t.panelOptions,m),k=A.URI.revive(a);switch(l.type){case 1:{const{document:T}=this.getCustomDocumentEntry(c,k);return l.provider.resolveCustomEditor(T,v,o)}case 0:{const T=this._extHostDocuments.getDocument(k);return l.provider.resolveCustomTextEditor(T,v,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,P,c){this.getCustomDocumentEntry(P,a).disposeEdits(c)}async $onMoveCustomEditor(a,P,c){const t=this._editorProviders.get(c);if(!t)throw new Error(`No provider found for '${c}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const h=this._extHostWebviewPanels.getWebviewPanel(a);if(!h)throw new Error("No webview found");const o=A.URI.revive(P),l=this._extHostDocuments.getDocument(o);await t.provider.moveCustomTextEditor(l,h,r.CancellationToken.None)}async $undo(a,P,c,t){return this.getCustomDocumentEntry(P,a).undo(c,t)}async $redo(a,P,c,t){return this.getCustomDocumentEntry(P,a).redo(c,t)}async $revert(a,P,c){const t=this.getCustomDocumentEntry(P,a);await this.getCustomEditorProvider(P).revertCustomDocument(t.document,c),t.disposeBackup()}async $onSave(a,P,c){const t=this.getCustomDocumentEntry(P,a);await this.getCustomEditorProvider(P).saveCustomDocument(t.document,c),t.disposeBackup()}async $onSaveAs(a,P,c,t){const h=this.getCustomDocumentEntry(P,a);return this.getCustomEditorProvider(P).saveCustomDocumentAs(h.document,A.URI.revive(c),t)}async $backup(a,P,c){const t=this.getCustomDocumentEntry(P,a),o=await this.getCustomEditorProvider(P).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},c);return t.updateBackup(o),o.id}getCustomDocumentEntry(a,P){const c=this._documents.get(a,A.URI.revive(P));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(a){const c=this._editorProviders.get(a)?.provider;if(!c||!this.supportEditing(c))throw new Error("Custom document is not editable");return c}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function M(w){return typeof w.resolveCustomTextEditor=="function"}function u(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function f(w){const a=w.scheme===x.Schemas.file||w.scheme===x.Schemas.untitled?w.fsPath:w.toString();return(0,I.hash)(a)+""}});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[207],Ee([1,0,5,6,2,36,8,51,4,7]),function(Y,e,r,I,_,x,y,A,C,R){"use strict";var N,b,s,p,n,i,d,S,M,u,f,w,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends I.Disposable{constructor(o,l,E,m,v,k,T){super();N.set(this,void 0),b.set(this,void 0),s.set(this,void 0),p.set(this,void 0),n.set(this,void 0),i.set(this,void 0),d.set(this,void 0),S.set(this,void 0),M.set(this,!0),u.set(this,!0),f.set(this,!1),w.set(this,this._register(new r.Emitter)),this.onDidDispose=ye(this,w,"f").event,a.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=ye(this,a,"f").event,je(this,N,o,"f"),je(this,b,l,"f"),je(this,s,E,"f"),je(this,n,k,"f"),je(this,S,v,"f"),je(this,i,m,"f"),je(this,p,T,"f")}dispose(){ye(this,f,"f")||(je(this,f,!0,"f"),ye(this,w,"f").fire(),ye(this,b,"f").$disposeWebview(ye(this,N,"f")),ye(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),ye(this,p,"f")}get viewType(){return this.assertNotDisposed(),ye(this,s,"f")}get title(){return this.assertNotDisposed(),ye(this,i,"f")}set title(o){this.assertNotDisposed(),ye(this,i,"f")!==o&&(je(this,i,o,"f"),ye(this,b,"f").$setTitle(ye(this,N,"f"),o))}get iconPath(){return this.assertNotDisposed(),ye(this,d,"f")}set iconPath(o){this.assertNotDisposed(),ye(this,d,"f")!==o&&(je(this,d,o,"f"),ye(this,b,"f").$setIconPath(ye(this,N,"f"),_.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return ye(this,n,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof ye(this,S,"f")=="number"&&ye(this,S,"f")<0))return ye(this,S,"f")}get active(){return this.assertNotDisposed(),ye(this,u,"f")}get visible(){return this.assertNotDisposed(),ye(this,M,"f")}_updateViewState(o){ye(this,f,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(je(this,u,o.active,"f"),je(this,M,o.visible,"f"),je(this,S,o.viewColumn,"f"),ye(this,a,"f").fire({webviewPanel:this}))}reveal(o,l){this.assertNotDisposed(),ye(this,b,"f").$reveal(ye(this,N,"f"),{viewColumn:typeof o=="undefined"?void 0:y.ViewColumn.from(o),preserveFocus:!!l})}assertNotDisposed(){if(ye(this,f,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,b=new WeakMap,s=new WeakMap,p=new WeakMap,n=new WeakMap,i=new WeakMap,d=new WeakMap,S=new WeakMap,M=new WeakMap,u=new WeakMap,f=new WeakMap,w=new WeakMap,a=new WeakMap;class c{constructor(o,l,E){this.webviews=l,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,x.generateUuid)()}createWebviewPanel(o,l,E,m,v={}){const k=typeof m=="object"?m.viewColumn:m,T={viewColumn:y.ViewColumn.from(k),preserveFocus:typeof m=="object"&&!!m.preserveFocus},$=(0,A.shouldSerializeBuffersForPostMessage)(o),g=c.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(o),g,l,{title:E,panelOptions:t(v),webviewOptions:(0,A.serializeWebviewOptions)(o,this.workspace,v),serializeBuffersForPostMessage:$},T);const U=this.webviews.createNewWebview(g,v,o);return this.createNewWebviewPanel(g,l,E,k,v,U)}$onDidChangeWebviewPanelViewStates(o){const l=Object.keys(o);l.sort((E,m)=>{const v=o[E],k=o[m];return v.active?1:k.active?-1:+v.visible-+k.visible});for(const E of l){const m=this.getWebviewPanel(E);if(!m)continue;const v=o[E];m._updateViewState({active:v.active,visible:v.visible,viewColumn:y.ViewColumn.to(v.position)})}}async $onDidDisposeWebviewPanel(o){this.getWebviewPanel(o)?.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,l,E){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:E,extension:o}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(o)}),new R.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(o,l,E,m){const v=this._serializers.get(l);if(!v)throw new Error(`No serializer found for '${l}'`);const{serializer:k,extension:T}=v,$=this.webviews.createNewWebview(o,E.webviewOptions,T),g=this.createNewWebviewPanel(o,l,E.title,m,E.panelOptions,$);await k.deserializeWebviewPanel(g,E.state)}createNewWebviewPanel(o,l,E,m,v,k){const T=new P(o,this._proxy,l,E,m,v,k);return this._webviewPanels.set(o,T),T}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=c;function t(h){return{enableFindWidget:h.enableFindWidget,retainContextWhenHidden:h.retainContextWhenHidden}}});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[208],Ee([1,0,5,6,51,4,7]),function(Y,e,r,I,_,x,y){"use strict";var A,C,R,N,b,s,p,n,i,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends I.Disposable{constructor(f,w,a,P,c,t){super();A.set(this,void 0),C.set(this,void 0),R.set(this,void 0),N.set(this,void 0),b.set(this,!1),s.set(this,void 0),p.set(this,void 0),n.set(this,void 0),i.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=ye(this,i,"f").event,d.set(this,this._register(new r.Emitter)),this.onDidDispose=ye(this,d,"f").event,je(this,R,a,"f"),je(this,p,P,"f"),je(this,A,f,"f"),je(this,C,w,"f"),je(this,N,c,"f"),je(this,s,t,"f")}dispose(){ye(this,b,"f")||(je(this,b,!0,"f"),ye(this,d,"f").fire(),ye(this,N,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),ye(this,p,"f")}set title(f){this.assertNotDisposed(),ye(this,p,"f")!==f&&(je(this,p,f,"f"),ye(this,C,"f").$setWebviewViewTitle(ye(this,A,"f"),f))}get description(){return this.assertNotDisposed(),ye(this,n,"f")}set description(f){this.assertNotDisposed(),ye(this,n,"f")!==f&&(je(this,n,f,"f"),ye(this,C,"f").$setWebviewViewDescription(ye(this,A,"f"),f))}get visible(){return ye(this,s,"f")}get webview(){return ye(this,N,"f")}get viewType(){return ye(this,R,"f")}_setVisible(f){f===ye(this,s,"f")||ye(this,b,"f")||(je(this,s,f,"f"),ye(this,i,"f").fire())}show(f){this.assertNotDisposed(),ye(this,C,"f").$show(ye(this,A,"f"),!!f)}assertNotDisposed(){if(ye(this,b,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,C=new WeakMap,R=new WeakMap,N=new WeakMap,b=new WeakMap,s=new WeakMap,p=new WeakMap,n=new WeakMap,i=new WeakMap,d=new WeakMap;class M{constructor(f,w){this._extHostWebview=w,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(x.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,w,a,P){if(this._viewProviders.has(w))throw new Error(`View provider for '${w}' already registered`);return this._viewProviders.set(w,{provider:a,extension:f}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(f),w,{retainContextWhenHidden:P?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(w),this._proxy.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(f,w,a,P,c){const t=this._viewProviders.get(w);if(!t)throw new Error(`No view provider found for '${w}'`);const{provider:h,extension:o}=t,l=this._extHostWebview.createNewWebview(f,{},o),E=new S(f,this._proxy,w,a,l,!0);this._webviewViews.set(f,E),await h.resolveWebviewView(E,{state:P},c)}async $onDidChangeWebviewViewVisibility(f,w){this.getWebviewView(f)._setVisible(w)}async $disposeWebviewView(f){const w=this.getWebviewView(f);this._webviewViews.delete(f),w.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const w=this._webviewViews.get(f);if(!w)throw new Error("No webview found");return w}}e.ExtHostWebviewViews=M}),define(ve[95],Ee([1,0,5,4,2,9,10,3,14]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class Vi{constructor(b){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Vi.InitialState,this._proxy=b.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(s=>this.$onDidChangeWindowFocus(s))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,s){let p;if(typeof b=="string"){p=b;try{b=_.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,y.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===x.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,p,s)}async asExternalUri(b,s){if((0,y.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(b,s);return _.URI.from(p)}};R.InitialState={focused:!0},R=Fe([Ne(0,C.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ve[209],Ee([1,0,11,21,20,15,5,6,108,175,38]),function(Y,e,r,I,_,x,y,A,C,R,N){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function s(v,k){try{return JSON.stringify(v,k)}catch{return"null"}}const p="$$ref$$",n={[p]:-1};class i{constructor(k,T){this.jsonString=k,this.referencedBuffers=T}}function d(v,k=null,T=!1){const $=[];return{jsonString:(T?s:JSON.stringify)(v,(U,z)=>{if(typeof z=="undefined")return n;if(typeof z=="object"){if(z instanceof I.VSBuffer){const q=$.push(z)-1;return{[p]:q}}if(k)return k(U,z)}return z}),referencedBuffers:$}}e.stringifyJsonWithBufferRefs=d;function S(v,k,T){return JSON.parse(v,($,g)=>{if(g){const U=g[p];if(typeof U=="number")return k[U];if(T&&g.$mid===1)return T.transformIncoming(g)}return g})}e.parseJsonAndRestoreBufferRefs=S;function M(v,k){return JSON.stringify(v,k)}function u(v){return v?(k,T)=>T&&T.$mid===1?v.transformOutgoing(T):T:null}var f;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},P=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class t extends A.Disposable{constructor(k,T=null,$=null){super();this[b]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=k,this._logger=T,this._uriTransformer=$,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let g=0,U=N.ProxyIdentifier.count;g<U;g++)this._locals[g]=null,this._proxies[g]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(g=>this._receiveOneMessage(g))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(k=>{this._pendingRPCReplies[k].resolveErr(x.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(k){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(k){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(k){this._responsiveState!==k&&(this._responsiveState=k,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(k){return this._uriTransformer?(0,C.transformIncomingURIs)(k,this._uriTransformer):k}getProxy(k){const{nid:T,sid:$}=k;return this._proxies[T]||(this._proxies[T]=this._createProxy(T,$)),this._proxies[T]}_createProxy(k,T){let $={get:(g,U)=>(typeof U=="string"&&!g[U]&&U.charCodeAt(0)===36&&(g[U]=(...z)=>this._remoteCall(k,U,z)),U===c?T:g[U])};return new Proxy(Object.create(null),$)}set(k,T){return this._locals[k.nid]=T,T}assertRegistered(k){for(let T=0,$=k.length;T<$;T++){const g=k[T];if(!this._locals[g.nid])throw new Error(`Missing proxy instance ${g.sid}`)}}_receiveOneMessage(k){if(this._isDisposed)return;const T=k.byteLength,$=h.read(k,0),g=$.readUInt8(),U=$.readUInt32();switch(g){case 1:case 2:{let{rpcId:z,method:q,args:j}=l.deserializeRequestJSONArgs($);this._uriTransformer&&(j=(0,C.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(T,U,z,q,j,g===2);break}case 3:case 4:{let{rpcId:z,method:q,args:j}=l.deserializeRequestMixedArgs($);this._uriTransformer&&(j=(0,C.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(T,U,z,q,j,g===4);break}case 5:{this._logger&&this._logger.logIncoming(T,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(T,U);break}case 7:{this._receiveReply(T,U,void 0);break}case 9:{let z=l.deserializeReplyOKJSON($);this._uriTransformer&&(z=(0,C.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(T,U,z);break}case 10:{const z=l.deserializeReplyOKJSONWithBuffers($,this._uriTransformer);this._receiveReply(T,U,z);break}case 8:{let z=l.deserializeReplyOKVSBuffer($);this._receiveReply(T,U,z);break}case 11:{let z=l.deserializeReplyErrError($);this._uriTransformer&&(z=(0,C.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(T,U,z);break}case 12:{this._receiveReplyErr(T,U,void 0);break}default:console.error("received unexpected message"),console.error(k)}}_receiveRequest(k,T,$,g,U,z){this._logger&&this._logger.logIncoming(k,T,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)($)}.${g}(`,U);const q=String(T);let j,J;if(z){const ie=new _.CancellationTokenSource;U.push(ie.token),j=this._invokeHandler($,g,U),J=()=>ie.cancel()}else j=this._invokeHandler($,g,U),J=a;this._cancelInvokedHandlers[q]=J;const W=l.serializeAcknowledged(T);this._logger&&this._logger.logOutgoing(W.byteLength,T,1,"ack"),this._protocol.send(W),j.then(ie=>{delete this._cancelInvokedHandlers[q];const le=l.serializeReplyOK(T,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(le.byteLength,T,1,"reply:",ie),this._protocol.send(le)},ie=>{delete this._cancelInvokedHandlers[q];const le=l.serializeReplyErr(T,ie);this._logger&&this._logger.logOutgoing(le.byteLength,T,1,"replyErr:",ie),this._protocol.send(le)})}_receiveCancel(k,T){this._logger&&this._logger.logIncoming(k,T,1,"receiveCancel");const $=String(T);this._cancelInvokedHandlers[$]&&this._cancelInvokedHandlers[$]()}_receiveReply(k,T,$){this._logger&&this._logger.logIncoming(k,T,0,"receiveReply:",$);const g=String(T);if(!this._pendingRPCReplies.hasOwnProperty(g))return;const U=this._pendingRPCReplies[g];delete this._pendingRPCReplies[g],U.resolveOk($)}_receiveReplyErr(k,T,$){this._logger&&this._logger.logIncoming(k,T,0,"receiveReplyErr:",$);const g=String(T);if(!this._pendingRPCReplies.hasOwnProperty(g))return;const U=this._pendingRPCReplies[g];delete this._pendingRPCReplies[g];let z;$&&($.$isError?(z=new Error,z.name=$.name,z.message=$.message,z.stack=$.stack):z=$),U.resolveErr(z)}_invokeHandler(k,T,$){try{return Promise.resolve(this._doInvokeHandler(k,T,$))}catch(g){return Promise.reject(g)}}_doInvokeHandler(k,T,$){const g=this._locals[k];if(!g)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(k));let U=g[T];if(typeof U!="function")throw new Error("Unknown method "+T+" on actor "+(0,N.getStringIdentifierForProxy)(k));return U.apply(g,$)}_remoteCall(k,T,$){if(this._isDisposed)return Promise.reject(x.canceled());let g=null;if($.length>0&&_.CancellationToken.isCancellationToken($[$.length-1])&&(g=$.pop()),g&&g.isCancellationRequested)return Promise.reject(x.canceled());const U=l.serializeRequestArguments($,this._uriReplacer),z=++this._lastMessageId,q=String(z),j=new R.LazyPromise;g&&g.onCancellationRequested(()=>{const W=l.serializeCancel(z);this._logger&&this._logger.logOutgoing(W.byteLength,z,0,"cancel"),this._protocol.send(l.serializeCancel(z))}),this._pendingRPCReplies[q]=j,this._onWillSendRequest(z);const J=l.serializeRequest(z,k,T,U,!!g);return this._logger&&this._logger.logOutgoing(J.byteLength,z,0,`request: ${(0,N.getStringIdentifierForProxy)(k)}.${T}(`,$),this._protocol.send(J),j}}e.RPCProtocol=t,b=P,t.UNRESPONSIVE_TIME=3*1e3;class h{constructor(k,T){this._buff=k,this._offset=T}static alloc(k,T,$){let g=new h(I.VSBuffer.alloc($+1+4),0);return g.writeUInt8(k),g.writeUInt32(T),g}static read(k,T){return new h(k,T)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(k){this._buff.writeUInt8(k,this._offset),this._offset+=1}readUInt8(){const k=this._buff.readUInt8(this._offset);return this._offset+=1,k}writeUInt32(k){this._buff.writeUInt32BE(k,this._offset),this._offset+=4}readUInt32(){const k=this._buff.readUInt32BE(this._offset);return this._offset+=4,k}static sizeShortString(k){return 1+k.byteLength}writeShortString(k){this._buff.writeUInt8(k.byteLength,this._offset),this._offset+=1,this._buff.set(k,this._offset),this._offset+=k.byteLength}readShortString(){const k=this._buff.readUInt8(this._offset);this._offset+=1;const $=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,$}static sizeLongString(k){return 4+k.byteLength}writeLongString(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readLongString(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,$}writeBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}static sizeVSBuffer(k){return 4+k.byteLength}writeVSBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readVSBuffer(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const T=this._buff.slice(this._offset,this._offset+k);return this._offset+=k,T}static sizeMixedArray(k){let T=0;T+=1;for(let $=0,g=k.length;$<g;$++){const U=k[$];switch(T+=1,U.type){case 1:T+=this.sizeLongString(U.value);break;case 2:T+=this.sizeVSBuffer(U.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(U.value);for(let z=0;z<U.buffers.length;++z)T+=this.sizeVSBuffer(U.buffers[z]);break;case 4:break}}return T}writeMixedArray(k){this._buff.writeUInt8(k.length,this._offset),this._offset+=1;for(let T=0,$=k.length;T<$;T++){const g=k[T];switch(g.type){case 1:this.writeUInt8(1),this.writeLongString(g.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(g.value);break;case 3:this.writeUInt8(3),this.writeUInt32(g.buffers.length),this.writeLongString(g.value);for(let U=0;U<g.buffers.length;++U)this.writeBuffer(g.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const k=this._buff.readUInt8(this._offset);this._offset+=1;let T=new Array(k);for(let $=0;$<k;$++)switch(this.readUInt8()){case 1:T[$]=this.readLongString();break;case 2:T[$]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),z=this.readLongString(),q=[];for(let j=0;j<U;++j)q.push(this.readVSBuffer());T[$]=new N.SerializableObjectWithBuffers(S(z,q,null));break}case 4:T[$]=void 0;break}return T}}h.sizeUInt32=4;var o;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(o||(o={}));class l{static _useMixedArgSerialization(k){for(let T=0,$=k.length;T<$;T++)if(k[T]instanceof I.VSBuffer||k[T]instanceof N.SerializableObjectWithBuffers||typeof k[T]=="undefined")return!0;return!1}static serializeRequestArguments(k,T){if(this._useMixedArgSerialization(k)){const $=[];for(let g=0,U=k.length;g<U;g++){const z=k[g];if(z instanceof I.VSBuffer)$[g]={type:2,value:z};else if(typeof z=="undefined")$[g]={type:4};else if(z instanceof N.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:j}=d(z.value,T);$[g]={type:3,value:I.VSBuffer.fromString(q),buffers:j}}else $[g]={type:1,value:I.VSBuffer.fromString(M(z,T))}}return{type:1,args:$}}return{type:0,args:M(k,T)}}static serializeRequest(k,T,$,g,U){switch(g.type){case 0:return this._requestJSONArgs(k,T,$,g.args,U);case 1:return this._requestMixedArgs(k,T,$,g.args,U)}}static _requestJSONArgs(k,T,$,g,U){const z=I.VSBuffer.fromString($),q=I.VSBuffer.fromString(g);let j=0;j+=h.sizeUInt8(),j+=h.sizeShortString(z),j+=h.sizeLongString(q);let J=h.alloc(U?2:1,k,j);return J.writeUInt8(T),J.writeShortString(z),J.writeLongString(q),J.buffer}static deserializeRequestJSONArgs(k){const T=k.readUInt8(),$=k.readShortString(),g=k.readLongString();return{rpcId:T,method:$,args:JSON.parse(g)}}static _requestMixedArgs(k,T,$,g,U){const z=I.VSBuffer.fromString($);let q=0;q+=h.sizeUInt8(),q+=h.sizeShortString(z),q+=h.sizeMixedArray(g);let j=h.alloc(U?4:3,k,q);return j.writeUInt8(T),j.writeShortString(z),j.writeMixedArray(g),j.buffer}static deserializeRequestMixedArgs(k){const T=k.readUInt8(),$=k.readShortString(),g=k.readMixedArray(),U=new Array(g.length);for(let z=0,q=g.length;z<q;z++){const j=g[z];typeof j=="string"?U[z]=JSON.parse(j):U[z]=j}return{rpcId:T,method:$,args:U}}static serializeAcknowledged(k){return h.alloc(5,k,0).buffer}static serializeCancel(k){return h.alloc(6,k,0).buffer}static serializeReplyOK(k,T,$){if(typeof T=="undefined")return this._serializeReplyOKEmpty(k);if(T instanceof I.VSBuffer)return this._serializeReplyOKVSBuffer(k,T);if(T instanceof N.SerializableObjectWithBuffers){const{jsonString:g,referencedBuffers:U}=d(T.value,$,!0);return this._serializeReplyOKJSONWithBuffers(k,g,U)}else return this._serializeReplyOKJSON(k,s(T,$))}static _serializeReplyOKEmpty(k){return h.alloc(7,k,0).buffer}static _serializeReplyOKVSBuffer(k,T){let $=0;$+=h.sizeVSBuffer(T);let g=h.alloc(8,k,$);return g.writeVSBuffer(T),g.buffer}static deserializeReplyOKVSBuffer(k){return k.readVSBuffer()}static _serializeReplyOKJSON(k,T){const $=I.VSBuffer.fromString(T);let g=0;g+=h.sizeLongString($);let U=h.alloc(9,k,g);return U.writeLongString($),U.buffer}static _serializeReplyOKJSONWithBuffers(k,T,$){const g=I.VSBuffer.fromString(T);let U=0;U+=h.sizeUInt32,U+=h.sizeLongString(g);for(const q of $)U+=h.sizeVSBuffer(q);let z=h.alloc(10,k,U);z.writeUInt32($.length),z.writeLongString(g);for(const q of $)z.writeBuffer(q);return z.buffer}static deserializeReplyOKJSON(k){const T=k.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(k,T){const $=k.readUInt32(),g=k.readLongString(),U=[];for(let z=0;z<$;++z)U.push(k.readVSBuffer());return new N.SerializableObjectWithBuffers(S(g,U,T))}static serializeReplyErr(k,T){return T?this._serializeReplyErrEror(k,T):this._serializeReplyErrEmpty(k)}static _serializeReplyErrEror(k,T){const $=I.VSBuffer.fromString(s(x.transformErrorForSerialization(T),null));let g=0;g+=h.sizeLongString($);let U=h.alloc(11,k,g);return U.writeLongString($),U.buffer}static deserializeReplyErrError(k){const T=k.readLongString();return JSON.parse(T)}static _serializeReplyErrEmpty(k){return h.alloc(12,k,0).buffer}}var E;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(E||(E={}));var m;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(m||(m={}))}),define(ve[210],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(x){const y=A=>{self.removeEventListener("message",y);const C=A.data;Object.defineProperties(self,{postMessage:{value(R,N){C.postMessage(R,N)}},onmessage:{get(){return C.onmessage},set(R){C.onmessage=R}}}),C.addEventListener("message",R=>{self.dispatchEvent(new MessageEvent("message",{data:R.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(x)};self.addEventListener("message",y)}.toString();class I extends EventTarget{constructor(x,y,A){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${r})('${y}'))`,R=new Blob([C],{type:"application/javascript"}),N=URL.createObjectURL(R),b=new MessageChannel,s=N,p={type:"_newWorker",id:s,port:b.port2,url:N,options:A};x(p,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{const n={type:"_terminateWorker",id:s};b.port1.postMessage(n),URL.revokeObjectURL(N),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(n){b.port1.onmessage=n}},onmessageerror:{get(){return b.port1.onmessageerror},set(n){b.port1.onmessageerror=n}}}),b.port1.addEventListener("messageerror",n=>{const i=new MessageEvent("messageerror",{data:n.data});this.dispatchEvent(i)}),b.port1.addEventListener("message",n=>{const i=new MessageEvent("message",{data:n.data});this.dispatchEvent(i)}),b.port1.start()}}e.NestedWorker=I}),define(ve[211],Ee([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(ve[212],Ee([1,0,35,9,17,23,24,2,3,147,47,171,211]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let p=class ji{constructor(i,d,S,M){this.localUserHome=i,this.remoteAgentService=d,this.environmentService=S,this.contextService=M,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||x.OS)(),this.resolveUserHome=(async()=>{const u=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=u?.userHome||i})()}hasValidBasename(i,d,S){return typeof d=="string"||typeof d=="undefined"?this.resolveOS.then(M=>this.doHasValidBasename(i,M,d)):this.doHasValidBasename(i,d,S)}doHasValidBasename(i,d,S){return i.scheme===I.Schemas.file||i.scheme===I.Schemas.vscodeRemote?(0,r.isValidBasename)(S??(0,y.basename)(i),d===1):!0}get defaultUriScheme(){return ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(i,d){if(i.remoteAuthority)return I.Schemas.vscodeRemote;const S=(0,R.getVirtualWorkspaceScheme)(d.getWorkspace());if(S)return S;const M=d.getWorkspace().folders[0];if(M)return M.uri.scheme;const u=d.getWorkspace().configuration;return u?u.scheme:I.Schemas.file}async userHome(i){return i?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?_.win32:_.posix)}async fileURI(i){let d="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const M=i.indexOf("/",2);M===-1?(d=i.substring(2),i="/"):(d=i.substring(2,M),i=i.substring(M)||"/")}return A.URI.from({scheme:I.Schemas.file,authority:d,path:i,query:"",fragment:""})}};p=Fe([Ne(1,s.IRemoteAgentService),Ne(2,b.IWorkbenchEnvironmentService),Ne(3,N.IWorkspaceContextService)],p),e.AbstractPathService=p}),define(ve[96],Ee([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(y,A){this.line=y,this.character=A}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,A){return new r(0,0)}with(y){return new r(0,0)}}e.Position=r;class I{constructor(y,A,C,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(y,A),this.end=new r(C,R)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var _;(function(x){x[x.Information=1]="Information",x[x.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[41],Ee([1,0,16,29,26,35,10,3,17,15,96,11]),function(Y,e,r,I,_,x,y,A,C,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const s="\u27EA ",p=" characters skipped \u27EB",n=(s.length+p.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var i;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(i=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function S(W){return!!W.preview}e.resultIsMatch=S;function M(W){return!!W.resource}e.isFileMatch=M;function u(W){return!!W.message}e.isProgressMessage=u;var f;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=w;class a{constructor(ie,le,te){this.ranges=le;const ue=Array.isArray(le)?le:[le];if(te&&te.matchLines===1&&P(ue)){ie=(0,y.getNLines)(ie,te.matchLines);let he="",De=0,fe=0;const ne=Math.floor(te.charsPerLine/5),me=[];for(const Ie of ue){const Ae=Math.max(Ie.startColumn-ne,0),Ue=Ie.startColumn+te.charsPerLine;if(Ae>fe+ne+n){const Ge=s+(Ae-fe)+p;he+=Ge+ie.slice(Ae,Ue),De+=Ae-(fe+Ge.length)}else he+=ie.slice(fe,Ue);me.push(new t(0,Ie.startColumn-De,Ie.endColumn-De)),fe=Ue}this.preview={text:he,matches:Array.isArray(this.ranges)?me:me[0]}}else{const he=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:ie,matches:(0,r.mapArrayOrNot)(le,De=>new c(De.startLineNumber-he,De.startColumn,De.endLineNumber-he,De.endColumn))}}}}e.TextSearchMatch=a;function P(W){const ie=W[0].startLineNumber;for(const le of W)if(le.startLineNumber!==ie||le.endLineNumber!==ie)return!1;return!0}class c{constructor(ie,le,te,ue){this.startLineNumber=ie,this.startColumn=le,this.endLineNumber=te,this.endColumn=ue}}e.SearchRange=c;class t extends c{constructor(ie,le,te){super(ie,le,ie,te)}}e.OneLineRange=t;var h;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function o(W,ie=!0){const le=W&&W.files&&W.files.exclude,te=ie&&W&&W.search&&W.search.exclude;if(!le&&!te)return;if(!le||!te)return le||te;let ue=Object.create(null);return ue=_.mixin(ue,_.deepClone(le)),ue=_.mixin(ue,_.deepClone(te),!0),ue}e.getExcludes=o;function l(W,ie){return W.excludePattern&&I.match(W.excludePattern,ie)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&I.match(W.includePattern,ie)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(le=>{const te=le.folder.fsPath;if(x.isEqualOrParent(ie,te)){const ue=C.relative(te,ie);return!le.includePattern||!!I.match(le.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var E;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(E=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(ie,le){super(ie);this.code=le}}e.SearchError=m;function v(W){const ie=W.message;if((0,R.isCancellationError)(W))return new m(ie,E.canceled);try{const le=JSON.parse(ie);return new m(le.message,le.code)}catch{return new m(ie,E.other)}}e.deserializeSearchError=v;function k(W){const ie={message:W.message,code:W.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=k;function T(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=T;function $(W){return W.type==="success"}e.isSerializedSearchSuccess=$;function g(W){return!!W.path}e.isSerializedFileMatch=g;function U(W,ie){const le=W.searchPath?W.searchPath:W.relativePath;return(0,y.fuzzyContains)(le,ie)}e.isFilePatternMatch=U;class z{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=z;function q(W,ie){const le={...W||{},...ie||{}};return Object.keys(le).filter(te=>{const ue=le[te];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=q;class j{constructor(ie,le){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=I.parse(this._excludeExpression);let te=ie.includePattern;le.includePattern&&(te?te={...te,...le.includePattern}:te=le.includePattern),te&&(this._parsedIncludeExpression=I.parse(te))}matchesExcludesSync(ie,le,te){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,le,te))}includedInQuerySync(ie,le,te){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,le,te)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,le,te))}includedInQuery(ie,le,te){const ue=this._parsedExcludeExpression(ie,le,te),he=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,le,te):!0;return(0,b.isThenable)(ue)?ue.then(De=>De?!1:he()):he()}hasSiblingExcludeClauses(){return J(this._excludeExpression)}}e.QueryGlobTester=j;function J(W){for(const ie in W)if(typeof W[ie]!="boolean")return!0;return!1}}),define(ve[31],Ee([1,0,16,11,20,5,22,9,102,24,10,13,2,127,3,12,139,47,30,28,14,8,7,41,4]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u,f,w,a,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function t(T,$,g){return new R.ExtUri(U=>E(U,g)).isEqual(T,$)}function h(T,$,g){return t(T.uri,$.uri,g)?0:(0,N.compare)(T.uri.toString(),$.uri.toString())}function o(T,$,g){return T.index!==$.index?T.index<$.index?-1:1:t(T.uri,$.uri,g)?(0,N.compare)(T.name,$.name):(0,N.compare)(T.uri.toString(),$.uri.toString())}function l(T,$,g,U){const z=T.slice(0).sort((j,J)=>g(j,J,U)),q=$.slice(0).sort((j,J)=>g(j,J,U));return(0,r.delta)(z,q,(j,J)=>g(j,J,U))}function E(T,$){const g=$.getCapabilities(T.scheme);return!(g&&g&1024)}class m extends S.Workspace{constructor($,g,U,z,q,j,J){super($,U.map(W=>new S.WorkspaceFolder(W)),z,q,J);this._name=g,this._isUntitled=j,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(J),U.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace($,g,U,z){if(!$)return{workspace:null,added:[],removed:[]};const{id:q,name:j,folders:J,configuration:W,transient:ie,isUntitled:le}=$,te=[],ue=g;g?J.forEach((ne,me)=>{const Ie=s.URI.revive(ne.uri),Ae=m._findFolder(U||g,Ie,z);Ae?(Ae.name=ne.name,Ae.index=ne.index,te.push(Ae)):te.push({uri:Ie,name:ne.name,index:me})}):te.push(...J.map(({uri:ne,name:me,index:Ie})=>({uri:s.URI.revive(ne),name:me,index:Ie}))),te.sort((ne,me)=>ne.index<me.index?-1:1);const he=new m(q,j,te,!!ie,W?s.URI.revive(W):null,!!le,ne=>E(ne,z)),{added:De,removed:fe}=l(ue?ue.workspaceFolders:[],he.workspaceFolders,h,z);return{workspace:he,added:De,removed:fe}}static _findFolder($,g,U){for(let z=0;z<$.folders.length;z++){const q=$.workspaceFolders[z];if(t(q.uri,g,U))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,g){return g&&this._structure.get($)&&($=(0,R.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let v=class{constructor($,g,U,z){this._onDidChangeWorkspace=new x.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new x.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=U,this._requestIdProvider=new C.Counter,this._barrier=new I.Barrier,this._proxy=$.getProxy(c.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(c.MainContext.MainThreadMessageService);const q=g.workspace;this._confirmedWorkspace=q?new m(q.id,q.name,[],!!q.transient,q.configuration?s.URI.revive(q.configuration):null,!!q.isUntitled,j=>E(j,U)):void 0}$initializeWorkspace($,g){this._trusted=g,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?s.URI.from({scheme:A.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,g,U,...z){const q=[];if(Array.isArray(z)&&z.forEach(le=>{s.URI.isUri(le.uri)&&!q.some(te=>t(te.uri,le.uri,this._extHostFileSystemInfo))&&q.push({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[g,U].some(le=>typeof le!="number"||le<0)||U===0&&q.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(g+U>j.length)return!1;const J=j.slice(0);J.splice(g,U,...q.map(le=>({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<J.length;le++){const te=J[le];if(J.some((ue,he)=>he!==le&&t(te.uri,ue.uri,this._extHostFileSystemInfo)))return!1}J.forEach((le,te)=>le.index=te);const{added:W,removed:ie}=l(j,J,o,this._extHostFileSystemInfo);if(W.length===0&&ie.length===0)return!1;if(this._proxy){const le=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(le,g,U,q).then(void 0,te=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:$.identifier,label:$.displayName||$.name}};this._messageService.$showMessage(d.Severity.Error,(0,p.localize)(0,null,le,te.toString()),ue,[])})}return this.trySetWorkspaceFolders(J),!0}getWorkspaceFolder($,g){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,g)}async getWorkspaceFolder2($,g){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,g)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!this._actualWorkspace)return;const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}getRelativePath($,g){let U,z="";if(typeof $=="string"?(U=s.URI.file($),z=$):typeof $!="undefined"&&(U=$,z=$.fsPath),!U)return z;const q=this.getWorkspaceFolder(U,!0);if(!q)return z;typeof g=="undefined"&&this._actualWorkspace&&(g=this._actualWorkspace.folders.length>1);let j=(0,R.relativePath)(q.uri,U);return g&&q.name&&(j=`${q.name}/${j}`),j}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:g,added:U,removed:z}=m.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=g||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:z}))}findFiles($,g,U,z,q=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let j;if(g===null?j=!1:g&&(typeof g=="string"?j=g:j=g.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:J,folder:W}=k(w.GlobPattern.from($));return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(J),(0,b.withUndefinedAsNull)(W),(0,b.withUndefinedAsNull)(j),(0,b.withUndefinedAsNull)(U),q).then(ie=>Array.isArray(ie)?ie.map(le=>s.URI.revive(le)):[])}async findTextInFiles($,g,U,z,q=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),J=typeof g.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:g.previewOptions,{includePattern:W,folder:ie}=k(w.GlobPattern.from(g.include)),le=typeof g.exclude=="string"?g.exclude:g.exclude?g.exclude.pattern:void 0,te={ignoreSymlinks:typeof g.followSymlinks=="boolean"?!g.followSymlinks:void 0,disregardIgnoreFiles:typeof g.useIgnoreFiles=="boolean"?!g.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof g.useGlobalIgnoreFiles=="boolean"?!g.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof g.useParentIgnoreFiles=="boolean"?!g.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof g.useDefaultExcludes=="boolean"?!g.useDefaultExcludes:!0,fileEncoding:g.encoding,maxResults:g.maxResults,previewOptions:J,afterContext:g.afterContext,beforeContext:g.beforeContext,includePattern:W,excludePattern:le},ue=!1;if(this._activeSearchCallbacks[j]=he=>{if(ue)return;const De=s.URI.revive(he.resource);he.results.forEach(fe=>{(0,P.resultIsMatch)(fe)?U({uri:De,preview:{text:fe.preview.text,matches:(0,r.mapArrayOrNot)(fe.preview.matches,ne=>new a.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,r.mapArrayOrNot)(fe.ranges,ne=>new a.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):U({uri:De,text:fe.text,lineNumber:fe.lineNumber})})},q.isCancellationRequested)return{};try{const he=await this._proxy.$startTextSearch($,(0,b.withUndefinedAsNull)(ie),te,j,q);return delete this._activeSearchCallbacks[j],he||{}}catch(he){throw delete this._activeSearchCallbacks[j],he}}$handleTextSearchResult($,g){this._activeSearchCallbacks[g]&&this._activeSearchCallbacks[g]($)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=Fe([Ne(0,f.IExtHostRpcService),Ne(1,u.IExtHostInitDataService),Ne(2,M.IExtHostFileSystemInfo),Ne(3,i.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,n.createDecorator)("IExtHostWorkspace");function k(T){let $,g;return T&&(typeof T=="string"?$=T:($=T.pattern,g=s.URI.revive(T.baseUri))),{includePattern:$,folder:g}}}),define(ve[32],Ee([1,0,26,5,31,4,7,142,79,13,11,3,14,12,2]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function i(P,c){if(c){const t=c.split(".");let h=P;for(let o=0;h&&o<t.length;o++)h=h[t[o]];return h}}function d(P){return P instanceof n.URI}function S(P){return P&&P.uri instanceof n.URI&&P.languageId&&typeof P.languageId=="string"}function M(P){return P&&!P.uri&&P.languageId&&typeof P.languageId=="string"}function u(P){return P&&P.uri instanceof n.URI&&(!P.name||typeof P.name=="string")&&(!P.index||typeof P.index=="number")}function f(P){if(d(P))return{resource:P};if(S(P))return{resource:P.uri,overrideIdentifier:P.languageId};if(M(P))return{overrideIdentifier:P.languageId};if(u(P))return{resource:P.uri};if(P===null)return{resource:null}}let w=class{constructor(c,t,h){this._proxy=c.getProxy(x.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=h,this._barrier=new N.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(c=>this._actual)}$initializeConfiguration(c){this._actual=new a(this._proxy,this._extHostWorkspace,c,this._logService),this._barrier.open()}$acceptConfigurationChanged(c,t){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(c,t))}};w=Fe([Ne(0,s.IExtHostRpcService),Ne(1,_.IExtHostWorkspace),Ne(2,p.ILogService)],w),e.ExtHostConfiguration=w;class a{constructor(c,t,h,o){this._onDidChangeConfiguration=new I.Emitter,this._proxy=c,this._logService=o,this._extHostWorkspace=t,this._configuration=A.Configuration.parse(h),this._configurationScopes=this._toMap(h.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(c,t){const h={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,h))}getConfiguration(c,t,h){const o=f(t)||{},l=this._toReadonlyValue(c?i(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),c):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));c&&this._validateConfigurationAccess(c,o,h?.identifier);function E(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const m={has(v){return typeof i(l,v)!="undefined"},get:(v,k)=>{this._validateConfigurationAccess(c?`${c}.${v}`:v,o,h?.identifier);let T=i(l,v);if(typeof T=="undefined")T=k;else{let $;const g=(U,z)=>{let q;const j=()=>{$=$||(0,r.deepClone)(l),q=q||i($,z)};return(0,R.isObject)(U)?new Proxy(U,{get:(J,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return j(),()=>q;if($)return q=q||i($,z),q[W];const ie=J[W];return typeof W=="string"?g(ie,`${z}.${W}`):ie},set:(J,W,ie)=>(j(),q&&(q[W]=ie),!0),deleteProperty:(J,W)=>(j(),q&&delete q[W],!0),defineProperty:(J,W,ie)=>(j(),q&&Object.defineProperty(q,W,ie),!0)}):U};T=g(T,v)}return T},update:(v,k,T,$)=>{v=c?`${c}.${v}`:v;const g=E(T);return k!==void 0?this._proxy.$updateConfigurationOption(g,v,k,o,$):this._proxy.$removeConfigurationOption(g,v,o,$)},inspect:v=>{v=c?`${c}.${v}`:v;const k=(0,r.deepClone)(this._configuration.inspect(v,o,this._extHostWorkspace.workspace));if(k)return{key:v,defaultValue:k.default?.value,globalValue:k.user?.value,workspaceValue:k.workspace?.value,workspaceFolderValue:k.workspaceFolder?.value,defaultLanguageValue:k.default?.override,globalLanguageValue:k.user?.override,workspaceLanguageValue:k.workspace?.override,workspaceFolderLanguageValue:k.workspaceFolder?.override,languageIds:k.overrideIdentifiers}}};return typeof l=="object"&&(0,r.mixin)(m,l,!1),Object.freeze(m)}_toReadonlyValue(c){const t=h=>(0,R.isObject)(h)?new Proxy(h,{get:(o,l)=>t(o[l]),set:(o,l,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(o,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(o,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return t(c)}_validateConfigurationAccess(c,t,h){const o=C.OVERRIDE_PROPERTY_REGEX.test(c)?4:this._configurationScopes.get(c),l=h?`[${h.value}] `:"";if(o===4){typeof t?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){t?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(c,t){const h=new A.ConfigurationChangeEvent(c,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,l)=>h.affectsConfiguration(o,f(l))})}_toMap(c){return c.reduce((t,h)=>(t.set(h[0],h[1]),t),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[97],Ee([1,0,2,11,5,4,7,31,49,32,20,40,14,28,3,9,23,12,64,163,15]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u,f){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(z){function q(J){if(J!=null)return J}z.from=q;function j(J){if(J!=null)return J}z.to=j})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var P;(function(z){function q(J){if(J!=null)return J}z.from=q;function j(J){if(J!=null)return J}z.to=j})(P=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var c;(function(z){function q(J){if(J!=null)return J}z.from=q;function j(J){if(J!=null)return J}z.to=j})(c=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(z){function q(W){if(W){const ie=W;return ie&&!!ie.process}else return!1}z.is=q;function j(W){if(W==null)return;const ie={process:W.process,args:W.args};return W.options&&(ie.options=c.from(W.options)),ie}z.from=j;function J(W){if(W!=null)return new y.ProcessExecution(W.process,W.args,W.options)}z.to=J})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var h;(function(z){function q(J){if(J!=null)return J}z.from=q;function j(J){if(J!=null)return J}z.to=j})(h=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(z){function q(W){if(W){const ie=W;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}z.is=q;function j(W){if(W==null)return;const ie={};return W.commandLine!==void 0?ie.commandLine=W.commandLine:(ie.command=W.command,ie.args=W.args),W.options&&(ie.options=h.from(W.options)),ie}z.from=j;function J(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new y.ShellExecution(W.commandLine,W.options):new y.ShellExecution(W.command,W.args?W.args:[],W.options)}z.to=J})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(z){function q(W){if(W){let ie=W;return ie&&ie.customExecution==="customExecution"}else return!1}z.is=q;function j(W){return{customExecution:"customExecution"}}z.from=j;function J(W,ie){return ie.get(W)}z.to=J})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(z){function q(j,J){let W;return j.scope!==void 0&&typeof j.scope!="number"?W=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===y.TaskScope.Workspace&&J&&J.workspaceFile?W=J.workspaceFile:W=u.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:W}}z.from=q})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(z){function q(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}z.from=q})(m=e.TaskGroupDTO||(e.TaskGroupDTO={}));var v;(function(z){function q(W,ie){if(W==null)return[];const le=[];for(let te of W){const ue=j(te,ie);ue&&le.push(ue)}return le}z.fromMany=q;function j(W,ie){if(W==null)return;let le;W.execution instanceof y.ProcessExecution?le=t.from(W.execution):W.execution instanceof y.ShellExecution?le=o.from(W.execution):W.execution&&W.execution instanceof y.CustomExecution&&(le=l.from(W.execution));const te=a.from(W.definition);let ue;return W.scope?typeof W.scope=="number"?ue=W.scope:ue=W.scope.uri:ue=y.TaskScope.Workspace,!te||!ue?void 0:{_id:W._id,definition:te,name:W.name,source:{extensionId:ie.identifier.value,label:W.source,scope:ue},execution:le,isBackground:W.isBackground,group:m.from(W.group),presentationOptions:P.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}z.from=j;async function J(W,ie,le){if(W==null)return;let te;t.is(W.execution)?te=t.to(W.execution):o.is(W.execution)?te=o.to(W.execution):l.is(W.execution)&&(te=l.to(W._id,le));const ue=a.to(W.definition);let he;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?he=W.source.scope:he=await ie.resolveWorkspaceFolder(r.URI.revive(W.source.scope)):he=y.TaskScope.Workspace),!ue||!he)return;const De=new y.Task(ue,he,W.name,W.source.label,te,W.problemMatchers);return W.isBackground!==void 0&&(De.isBackground=W.isBackground),W.group!==void 0&&(De.group=y.TaskGroup.from(W.group._id),De.group&&W.group.isDefault&&(De.group=new y.TaskGroup(De.group.id,De.group.label),W.group.isDefault&&(De.group.isDefault=W.group.isDefault))),W.presentationOptions&&(De.presentationOptions=P.to(W.presentationOptions)),W._id&&(De._id=W._id),W.detail&&(De.detail=W.detail),De}z.to=J})(v=e.TaskDTO||(e.TaskDTO={}));var k;(function(z){function q(J){return J}z.from=q;function j(J){if(!!J)return Object.assign(Object.create(null),J)}z.to=j})(k=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(q,j,J){this._id=j,this._task=J,w.set(this,void 0),je(this,w,q,"f")}get task(){return this._task}terminate(){ye(this,w,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}w=new WeakMap;var $;(function(z){function q(j){return{id:j._id,task:void 0}}z.from=q})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let g=class{constructor(q,j,J,W,ie,le,te,ue){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=q.getProxy(x.MainContext.MainThreadTask),this._workspaceProvider=J,this._editorService=W,this._configurationService=ie,this._terminalService=le,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=te,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,j,J){if(!J)return new y.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:j,provider:J,extension:q}),this._proxy.$registerTaskProvider(W,j),new y.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(q,j){this._proxy.$registerTaskSystem(q,j)}fetchTasks(q){return this._proxy.$fetchTasks(k.from(q)).then(async j=>{const J=[];for(let W of j){const ie=await v.to(W,this._workspaceProvider,this._providedCustomExecutions2);ie&&J.push(ie)}return J})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(j=>q.push(j)),q}terminateTask(q){if(!(q instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,j,J){const W=this._providedCustomExecutions2.get(q.id);W&&(this._activeCustomExecutions2.set(q.id,W),this._terminalService.attachPtyToTerminal(j,await W.callback(J))),this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const j=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const j=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:j,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const j=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:q.exitCode})}$provideTasks(q,j){const J=this._handlers.get(q);if(!J)return Promise.reject(new Error("no handler found"));const W=[],ie=(0,I.asPromise)(()=>J.provider.provideTasks(N.CancellationToken.None)).then(le=>this.provideTasksInternal(j,W,J,le));return new Promise(le=>{ie.then(te=>{Promise.all(W).then(()=>{le(te)})})})}async $resolveTask(q,j){const J=this._handlers.get(q);if(!J)return Promise.reject(new Error("no handler found"));if(j.definition.type!==J.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${J.type}].`);const W=await v.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const ie=await J.provider.resolveTask(W,N.CancellationToken.None);if(!ie)return;this.checkDeprecation(ie,J);const le=v.from(ie,J.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(le.execution)&&await this.addCustomExecution(le,ie,!0),await this.resolveTaskInternal(le)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,j,J){const W=await this._proxy.$createTaskId(q);!J&&!this._providedCustomExecutions2.has(W)&&(this._notProvidedCustomExecutions.add(W),this._activeCustomExecutions2.set(W,j.execution)),this._providedCustomExecutions2.set(W,j.execution)}async getTaskExecution(q,j){if(typeof q=="string"){const ie=this._taskExecutionPromises.get(q);if(!ie)throw new Error("Unexpected: The specified task is missing an execution");return ie}let J=this._taskExecutionPromises.get(q.id);if(J)return J;const W=new Promise((ie,le)=>{function te(ue,he,De){De?ie(new T(ue,he.id,De)):le("Unexpected: Task does not exist.")}j?te(this,q,j):v.to(q.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>te(this,q,ue))});return this._taskExecutionPromises.set(q.id,W),W.then(ie=>(this._taskExecutions.set(q.id,ie),ie),ie=>Promise.reject(ie))}checkDeprecation(q,j){q._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let J=this._notProvidedCustomExecutions.values(),W=J.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=J.next()}};g=Fe([Ne(0,s.IExtHostRpcService),Ne(1,p.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,C.IExtHostDocumentsAndEditors),Ne(4,R.IExtHostConfiguration),Ne(5,b.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,M.IExtHostApiDeprecationService)],g),e.ExtHostTaskBase=g;let U=class extends g{constructor(q,j,J,W,ie,le,te,ue){super(q,j,J,W,ie,le,te,ue);this.registerTaskSystem(i.Schemas.vscodeRemote,{scheme:i.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(q,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const J=v.from(j,q);if(J===void 0)throw new Error("Task is not valid");if(l.is(J.execution))await this.addCustomExecution(J,j,!1);else throw new f.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(J),j);return this._proxy.$executeTask(J).catch(ie=>{throw new Error(ie)}),W}provideTasksInternal(q,j,J,W){const ie=[];if(W)for(let le of W){this.checkDeprecation(le,J),(!le.definition||!q[le.definition.type])&&this._logService.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const te=v.from(le,J.extension);te&&l.is(te.execution)?(ie.push(te),j.push(this.addCustomExecution(te,le,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:J.extension}}async resolveTaskInternal(q){if(l.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,j,J){}};U=Fe([Ne(0,s.IExtHostRpcService),Ne(1,p.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,C.IExtHostDocumentsAndEditors),Ne(4,R.IExtHostConfiguration),Ne(5,b.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,M.IExtHostApiDeprecationService)],U),e.WorkerExtHostTask=U,e.IExtHostTask=(0,n.createDecorator)("IExtHostTask")}),define(ve[213],Ee([1,0,17,20,43,29,24,190,41]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(s,p,n){this.config=s,this.provider=p,this.sessionToken=n,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=s.filePattern,this.includePattern=s.includePattern&&x.parse(s.includePattern),this.maxResults=s.maxResults||void 0,this.exists=s.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=s.excludePattern&&x.parse(s.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(s=>s.cancel()),this.activeCancellationTokens=new Set}search(s){const p=this.config.folderQueries||[];return new Promise((n,i)=>{const d=S=>{this.resultCount++,s(S)};if(this.isCanceled)return n({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const M=S.toString(),u=r.basename(M);this.globalExcludePattern&&this.globalExcludePattern(M,u)||this.matchFile(d,{base:S,basename:u})}),Promise.all(p.map(S=>this.searchInFolder(S,d))).then(S=>{n({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{i(new Error((0,_.toErrorMessage)(S)))})})}async searchInFolder(s,p){const n=new I.CancellationTokenSource,i=this.getSearchOptionsForFolder(s),d=this.initDirectoryTree(),S=new C.QueryGlobTester(this.config,s),M=!S.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(n),u=A.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},i,n.token),w=u.elapsed(),a=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(P=>{const c=r.posix.relative(s.folder.path,P.path);if(M){const t=r.basename(P.path);this.matchFile(p,{base:s.folder,relativePath:c,basename:t});return}this.addDirectoryEntries(d,s.folder,c,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,S,p),{providerTime:w,postProcessTime:a.elapsed()})}finally{n.dispose(),this.activeCancellationTokens.delete(n)}}getSearchOptionsForFolder(s){const p=(0,C.resolvePatternsForProvider)(this.config.includePattern,s.includePattern),n=(0,C.resolvePatternsForProvider)(this.config.excludePattern,s.excludePattern);return{folder:s.folder,excludes:n,includes:p,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries({pathToEntries:s},p,n,i){if(n===this.filePattern){const S=r.basename(this.filePattern);this.matchFile(i,{base:p,relativePath:this.filePattern,basename:S})}function d(S){const M=r.basename(S),u=r.dirname(S);let f=s[u];f||(f=s[u]=[],d(u)),f.push({base:p,relativePath:S,basename:M})}d(n)}matchDirectoryTree({rootEntries:s,pathToEntries:p},n,i){const d=this,S=this.filePattern;function M(u){const f=x.hasSiblingFn(()=>u.map(w=>w.basename));for(let w=0,a=u.length;w<a;w++){const P=u[w],{relativePath:c,basename:t}=P;if(n.matchesExcludesSync(c,t,S!==t?f:void 0))continue;const h=p[c];if(h)M(h);else{if(c===S)continue;d.matchFile(i,P)}if(d.isLimitHit)break}}M(s)}matchFile(s,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||s(p))}}class N{constructor(){this.sessions=new Map}fileSearch(s,p,n,i){const d=this.getSessionTokenSource(s.cacheKey),S=new R(s,p,d&&d.token);let M=0;const u=f=>{M+=f.length,n(f.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(S,N.BATCH_SIZE,u,i).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:M,detailStats:f.stats}}))}clearCache(s){const p=this.getSessionTokenSource(s);p&&p.cancel()}getSessionTokenSource(s){if(!!s)return this.sessions.has(s)||this.sessions.set(s,new I.CancellationTokenSource),this.sessions.get(s)}rawMatchToSearchItem(s){return s.relativePath?{resource:y.joinPath(s.base,s.relativePath)}:{resource:s.base}}doSearch(s,p,n,i){i.onCancellationRequested(()=>{s.cancel()});const d=M=>{M&&(S.push(M),p>0&&S.length>=p&&(n(S),S=[]))};let S=[];return s.search(d).then(M=>(S.length&&n(S),M),M=>(S.length&&n(S),Promise.reject(M)))}}e.FileSearchManager=N,N.BATCH_SIZE=512}),define(ve[214],Ee([1,0,16,69,29,72,22,9,17,24,10,13,2,233,133,76,12,47,86,212,41]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(m,v,k,T,$){this.configurationService=m,this.workspaceContextService=v,this.editorGroupsService=k,this.logService=T,this.pathService=$}text(m,v,k={}){m=this.getContentPattern(m,k);const T=this.configurationService.getValue(),$=v&&v.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(v?.map(S.toWorkspaceFolder),k),type:2,contentPattern:m,previewOptions:k.previewOptions,maxFileSize:k.maxFileSize,usePCRE2:T.search.usePCRE2||$||!1,beforeContext:k.beforeContext,afterContext:k.afterContext,userDisabledExcludesAndIgnoreFiles:k.disregardExcludeSettings&&k.disregardIgnoreFiles}}getContentPattern(m,v){const k=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const T={...m,wordSeparators:k.editor.wordSeparators};return this.isCaseSensitive(m,v)&&(T.isCaseSensitive=!0),this.isMultiline(m)&&(T.isMultiline=!0),T}file(m,v={}){return{...this.commonQuery(m,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}handleIncludeExclude(m,v){return m?(m=Array.isArray(m)?m.map(h):h(m),v?this.parseSearchPaths(m):{pattern:P(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],v={}){const k=this.handleIncludeExclude(v.includePattern,v.expandPatterns),T=this.handleIncludeExclude(v.excludePattern,v.expandPatterns),$=m.length>1,g=(k.searchPaths&&k.searchPaths.length?k.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,v,T)):m.map(q=>this.getFolderQueryForRoot(q,v,T,$))).filter(q=>!!q),U={_reason:v._reason,folderQueries:g,usingSearchPaths:!!(k.searchPaths&&k.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:T.pattern,includePattern:k.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const q=r.coalesce(r.flatten(this.editorGroupsService.groups.map(W=>W.editors.map(ie=>ie.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const j=q.filter(W=>(0,f.pathIncludedInQuery)(U,W.fsPath)),J=this.commonQueryFromFileList(j);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...U,...J}}const z=v.extraFileResources&&v.extraFileResources.filter(q=>(0,f.pathIncludedInQuery)(U,q.fsPath));return U.extraFileResources=z&&z.length?z:void 0,U}commonQueryFromFileList(m){const v=[],k=new y.ResourceMap,T={};let $=!1;return m.forEach(g=>{if(g.scheme===A.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(g)){const z=this.workspaceContextService.getWorkspaceFolder(g)?.uri??g.with({path:C.dirname(g.fsPath)});let q=k.get(z);q||($=!0,q={folder:z,includePattern:{}},v.push(q),k.set(z,q));const j=C.relative(z.fsPath,g.fsPath);(0,b.assertIsDefined)(q.includePattern)[j.replace(/\\/g,"/")]=!0}else g.fsPath&&($=!0,T[g.fsPath]=!0)}),{folderQueries:v,includePattern:T,usingSearchPaths:!0,excludePattern:$?void 0:{"**/*":!0}}}isCaseSensitive(m,v){if(v.isSmartCase){if(m.isRegExp){if(N.containsUppercaseCharacter(m.pattern,!0))return!0}else if(N.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,p.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const v=J=>C.isAbsolute(J)||/^\.\.?([\/\\]|$)/.test(J),T=(Array.isArray(m)?m:c(m)).map(J=>{const W=this.pathService.resolvedUserHome;return W?(0,x.untildify)(J,W.scheme===A.Schemas.file?W.fsPath:W.path):J}),$=I.groupBy(T,J=>v(J)?"searchPaths":"exprSegments"),g=($.exprSegments||[]).map(J=>N.rtrim(J,"/")).map(J=>N.rtrim(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),t(J))),U={},z=this.expandSearchPathPatterns($.searchPaths||[]);z&&z.length&&(U.searchPaths=z);const q=r.flatten(g),j=P(...q);return j&&(U.pattern=j),U}getExcludesForFolder(m,v){return v.disregardExcludeSettings?void 0:(0,f.getExcludes)(m,!v.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const v=r.flatten(m.map(T=>{let{pathPortion:$,globPortion:g}=a(T);g&&(g=o(g));const U=this.expandOneSearchPath($);return r.flatten(U.map(z=>this.resolveOneSearchPathPattern(z,g)))})),k=new Map;return v.forEach(T=>{const $=T.searchPath.toString(),g=k.get($);g?T.pattern&&(g.pattern=g.pattern||{},g.pattern[T.pattern]=!0):k.set($,{searchPath:T.searchPath,pattern:T.pattern?P(T.pattern):void 0})}),Array.from(k.values())}expandOneSearchPath(m){if(C.isAbsolute(m)){const v=this.workspaceContextService.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==A.Schemas.file?[{searchPath:v[0].uri.with({path:m})}]:[{searchPath:s.URI.file(C.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const v=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=h(m),m.startsWith("../")||m===".."){const T=C.posix.resolve(v.path,m);return[{searchPath:v.with({path:T})}]}const k=o(m);return[{searchPath:v,pattern:k}]}else{if(m==="./"||m===".\\")return[];{const v=m.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map($=>{const g=v.match(new RegExp(`^${N.escapeRegExpCharacters($.name)}(?:/(.*)|$)`));return g?{match:g,folder:$}:null}).filter(b.isDefined);if(T.length)return T.map($=>{const g=$.match[1];return{searchPath:$.folder.uri,pattern:g&&o(g)}});{const $=m.match(/\.[\/\\](.+)[\/\\]?/),g=$?$[1]:m,U=n.localize(0,null,g);throw new Error(U)}}}}resolveOneSearchPathPattern(m,v){const k=m.pattern&&v?`${m.pattern}/${v}`:m.pattern||v,T=[{searchPath:m.searchPath,pattern:k}];return k&&!k.endsWith("**")&&T.push({searchPath:m.searchPath,pattern:k+"/**"}),T}getFolderQueryForSearchPath(m,v,k){const T=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(m.searchPath),v,k,!1);return T?{...T,includePattern:m.pattern}:null}getFolderQueryForRoot(m,v,k,T){let $;const g=s.URI.isUri(m)?m:m.uri;if(k.searchPaths){const J=k.searchPaths.filter(W=>(0,R.isEqual)(W.searchPath,g))[0];if(J&&!J.pattern)return null;J&&($=J.pattern)}const U=this.configurationService.getValue({resource:g}),q={...this.getExcludesForFolder(U,v)||{},...$||{}},j=s.URI.isUri(m)?(0,R.basename)(m):m.name;return{folder:g,folderName:T?j:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!U.search.followSymlinks}}};w=Fe([Ne(0,i.IConfigurationService),Ne(1,S.IWorkspaceContextService),Ne(2,M.IEditorGroupsService),Ne(3,d.ILogService),Ne(4,u.IPathService)],w),e.QueryBuilder=w;function a(E){const m=E.match(/[\*\{\}\(\)\[\]\?]/);if(m){const v=m.index,k=E.substr(0,v).match(/[/|\\][^/\\]*$/);if(k){let T=E.substr(0,k.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:E.substr((k.index||0)+1)}}}return{pathPortion:E}}function P(...E){return E.length?E.reduce((m,v)=>(m[v]=!0,m),Object.create(null)):void 0}function c(E){return _.splitGlobAware(E,",").map(m=>m.trim()).filter(m=>!!m.length)}function t(E){return[`**/${E}/**`,`**/${E}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function h(E){return E.replace(/\\/g,"/")}function o(E){return h(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(E,m){E=r.distinct(E,T=>T.toString());const v=[],k=m.getWorkspace();return E&&E.forEach(T=>{let $;if(m.getWorkbenchState()===2)$=(0,R.relativePath)(k.folders[0].uri,T),$&&$!=="."&&($="./"+$);else{const g=m.getWorkspaceFolder(T);if(g){const U=g.name;if(k.folders.filter(q=>q.name===U).length===1){const q=(0,R.relativePath)(g.uri,T);q===""?$=`./${g.name}`:$=`./${g.name}/${q}`}else $=T.fsPath}}$&&v.push($)}),v}e.resolveResourcesForSearchIncludes=l}),define(ve[215],Ee([1,0,24,2,20,15,3,214,41,47]),function(Y,e,r,I,_,x,y,A,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function b(i,d){const S=d.activationEvents;if(!S)return Promise.resolve(void 0);const M=[],u=[];for(const t of S)if(/^workspaceContains:/.test(t)){const h=t.substr("workspaceContains:".length);h.indexOf("*")>=0||h.indexOf("?")>=0||i.forceUsingSearch?u.push(h):M.push(h)}if(M.length===0&&u.length===0)return Promise.resolve(void 0);let f;const w=new Promise((t,h)=>{f=t}),a=t=>f({activationEvent:t}),P=Promise.all(M.map(t=>s(i,t,a))).then(()=>{}),c=p(i,d.identifier,u,a);return Promise.all([P,c]).then(()=>{f(void 0)}),w}e.checkActivateWorkspaceContainsExtension=b;async function s(i,d,S){for(const M of i.folders)if(await i.exists(r.joinPath(I.URI.revive(M),d))){S(`workspaceContains:${d}`);return}}async function p(i,d,S,M){if(S.length===0)return Promise.resolve(void 0);const u=new _.CancellationTokenSource,f=i.checkExists(i.folders,S,u.token),w=setTimeout(async()=>{u.cancel(),i.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${S.join(",")}`)},N);let a=!1;try{a=await f}catch(P){x.isCancellationError(P)||x.onUnexpectedError(P)}u.dispose(),clearTimeout(w),a&&M(`workspaceContains:${S.join(",")}`)}function n(i,d,S,M){const u=i.get(y.IInstantiationService),f=i.get(C.ISearchService),a=u.createInstance(A.QueryBuilder).file(d.map(P=>(0,R.toWorkspaceFolder)(I.URI.revive(P))),{_reason:"checkExists",includePattern:S,exists:!0});return f.fileSearch(a,M).then(P=>!!P.limitHit,P=>x.isCancellationError(P)?!1:Promise.reject(P))}e.checkGlobFileExists=n});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,I,_){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!_:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?_.call(Y,r):_?_.value=r:e.set(Y,r),r},ye=this&&this.__classPrivateFieldGet||function(Y,e,r,I){if(r==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?I:r==="a"?I.call(Y):I?I.value:e.get(Y)};define(ve[33],Ee([1,0,122,17,68,24,11,6,22,2,12,4,32,173,66,31,27,172,15,25,21,148,7,80,3,28,67,14,55,58,40,5,215,63,150,9]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u,f,w,a,P,c,t,h,o,l,E,m,v,k,T,$,g){"use strict";var U,z,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,c.createDecorator)("IHostUtils");let j=class qi extends A.Disposable{constructor(te,ue,he,De,fe,ne,me,Ie,Ae,Ue){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ue,this._extHostContext=he,this._initData=me,this._extHostWorkspace=De,this._extHostConfiguration=fe,this._logService=ne,this._extHostTunnelService=Ae,this._extHostTerminalService=Ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new n.ExtHostStorage(this._extHostContext),this._secretState=new T.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=te.createChild(new l.ServiceCollection([n.IExtHostStorage,this._storage],[T.IExtHostSecretState,this._secretState]));const Ge=new Set;this._initData.hostExtensions.forEach(ge=>Ge.add(u.ExtensionIdentifier.toKey(ge))),this._activator=this._register(new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ge,de,L)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ge,M.transformErrorForSerialization(de),L)},actualActivateExtension:async(ge,de)=>{if(Ge.has(u.ExtensionIdentifier.toKey(ge)))return await this._mainThreadExtensionsProxy.$activateExtension(ge,de),new p.HostExtension;const L=this._registry.getExtensionDescription(ge);return this._activateExtension(L,de)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){M.onUnexpectedError(te)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch{}await Promise.all(te)}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}_activateByEvent(te,ue){return this._activator.activateByEvent(te,ue)}_activateById(te,ue){return this._activator.activateById(te,ue)}activateByIdWithErrors(te,ue){return this._activateById(te,ue).then(()=>{const he=this._activator.getActivatedExtension(te);if(he.activationFailed)return Promise.reject(he.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._registry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==g.Schemas.file)return te;const ue=await this._hostUtils.realpath(te.fsPath);return R.URI.file(ue)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const te=C.TernarySearchTree.forUris(ue=>x.extUriBiasedIgnorePathCase.ignorePathCasing(ue));for(const ue of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ue)){const he=await this._realPathExtensionUri(ue.extensionLocation);te.set(he,ue)}return te})()),this._extensionPathIndex}_deactivate(te){let ue=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return ue;const he=this._activator.getActivatedExtension(te);if(!he)return ue;try{typeof he.module.deactivate=="function"&&(ue=Promise.resolve(he.module.deactivate()).then(void 0,De=>(this._logService.error(De),Promise.resolve(void 0))))}catch(De){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(De)}try{(0,A.dispose)(he.subscriptions)}catch(De){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(De)}return ue}async _activateExtension(te,ue){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,ue).then(he=>{const De=he.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,De.codeLoadingTime,De.activateCallTime,De.activateResolvedTime,ue),this._logExtensionActivationTimes(te,ue,"success",De),he},he=>{throw this._logExtensionActivationTimes(te,ue,"failure"),he})}_logExtensionActivationTimes(te,ue,he,De){const fe=J(te,ue);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...fe,...De||{},outcome:he})}_doActivateExtension(te,ue){const he=J(te,ue);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",he);const De=this._getEntryPoint(te);if(!De)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${te.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this._logService.flush();const fe=new p.ExtensionActivationTimesBuilder(ue.startup);return Promise.all([this._loadCommonJSModule(te.identifier,(0,x.joinPath)(te.extensionLocation,De),fe),this._loadExtensionContext(te)]).then(ne=>(_.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),qi._callActivate(this._logService,te.identifier,ne[0],ne[1],fe))).then(ne=>(_.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ne))}_loadExtensionContext(te){const ue=new w.ExtensionGlobalMemento(te,this._storage),he=new w.ExtensionMemento(te.identifier.value,!1,this._storage),De=new $.ExtensionSecrets(te,this._secretState),fe=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,ne=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([ue.whenReady,he.whenReady,this._storagePath.whenReady]).then(()=>{const me=this;let Ie,Ae;const Ue=(0,d.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(u.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:he,secrets:De,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(Ge){return I.join(te.extensionLocation.fsPath,Ge)},get storagePath(){return me._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return me._storagePath.globalValue(te).fsPath},get logPath(){return I.join(me._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return R.URI.joinPath(me._initData.logsLocation,te.identifier.value)},get storageUri(){return me._storagePath.workspaceValue(te)},get globalStorageUri(){return me._storagePath.globalValue(te)},get extensionMode(){return fe},get extension(){return Ie===void 0&&(Ie=new W(me,te.identifier,te,ne)),Ie},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(te,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Ae){if(!Ue)return;const Ge=v.Event.buffer(v.Event.fromDOMEventEmitter(Ue,"message",ge=>ge.data));Ue.start(),Ae={onDidReceiveMessage:Ge,postMessage:Ue.postMessage.bind(Ue)}}return Ae}})})}static _callActivate(te,ue,he,De,fe){return he=he||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,ue,he,De,fe).then(ne=>new p.ActivatedExtension(!1,null,fe.build(),he,ne,De.subscriptions))}static _callActivateOptional(te,ue,he,De,fe){if(typeof he.activate=="function")try{fe.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const ne=typeof global=="object"?global:self,me=he.activate.apply(ne,[De]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(me).then(Ie=>(fe.activateResolveStop(),Ie))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(he)}_activateOneStartupFinished(te,ue){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:ue}).then(void 0,he=>{this._logService.error(he)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const te of this._registry.getAllExtensionDescriptions())if(te.activationEvents)for(const ue of te.activationEvents)ue==="onStartupFinished"&&this._activateOneStartupFinished(te,ue)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const ue=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],he=this._handleWorkspaceContainsEagerExtensions(ue),De=Promise.all([te,he]).then(()=>{});return Promise.race([De,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),De}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ue=>this._handleWorkspaceContainsEagerExtension(te,ue))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,ue){if(this.isActivated(ue.identifier))return;const he=!this._initData.remote.isRemote&&!!this._initData.remote.authority,De={logService:this._logService,folders:te.map(ne=>ne.uri),forceUsingSearch:he,exists:ne=>this._hostUtils.exists(ne.fsPath),checkExists:(ne,me,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(ne,me,Ie)},fe=await(0,k.checkActivateWorkspaceContainsExtension)(De,ue);if(!!fe)return this._activateById(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:fe.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:ue}=this._initData.environment;if(!te||!ue)throw new Error(r.localize(0,null));const he=await this._loadCommonJSModule(null,ue,new p.ExtensionActivationTimesBuilder(!1));if(!he||typeof he.run!="function")throw new Error(r.localize(1,null,ue.toString()));return new Promise((De,fe)=>{const ne=(Ae,Ue)=>{Ae?fe(Ae):De(typeof Ue=="number"&&Ue>0?1:0)},me=(0,x.originalFSPath)(ue),Ie=he.run(me,ne);Ie&&Ie.then&&Ie.then(()=>{De(0)}).catch(Ae=>{fe(Ae instanceof Error&&Ae.stack?Ae.stack:String(Ae))})})}async $extensionTestsExit(te){this._logService.info(`Extension host terminating: test runner requested exit with code ${te}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${te}`),this._logService.flush(),this._hostUtils.exit(te)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,ue){return this._resolvers[te]=ue,(0,A.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const ue=te.indexOf("+");if(ue===-1)throw new Error("Not an authority that can be resolved!");const he=te.substr(0,ue);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${he}`,!1),{authorityPrefix:he,resolver:this._resolvers[he]}}async $resolveAuthority(te,ue){this._logService.info(`$resolveAuthority invoked for authority (${ie(te)})`);const{authorityPrefix:he,resolver:De}=await this._activateAndGetResolver(te);if(!De)return{type:"error",error:{code:P.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${he}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(De)),_.mark(`code/extHost/willResolveAuthority/${he}`);const fe=await De.resolve(te,{resolveAttempt:ue});_.mark(`code/extHost/didResolveAuthorityOK/${he}`);const ne={authority:te,host:fe.host,port:fe.port,connectionToken:fe.connectionToken},me={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:me,tunnelInformation:{environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures}}}}catch(fe){if(_.mark(`code/extHost/didResolveAuthorityError/${he}`),fe instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe}}async $getCanonicalURI(te,ue){this._logService.info(`$getCanonicalURI invoked for authority (${ie(te)})`);const{authorityPrefix:he,resolver:De}=await this._activateAndGetResolver(te);if(!De)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${he}`);const fe=R.URI.revive(ue);if(typeof De.getCanonicalURI=="undefined")return fe;const ne=await(0,y.asPromise)(()=>De.getCanonicalURI(fe));return ne||fe}$startExtensionHost(te){return this._registry.keepOnly(te),this._startExtensionHost()}$activateByEvent(te,ue){return ue===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(he=>this._activateByEvent(te,!1))}async $activate(te,ue){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(te)?(await this._activateById(te,ue),!0):!1}async $deltaExtensions(te,ue){te.forEach(De=>De.extensionLocation=R.URI.revive(De.extensionLocation));const he=await this.getExtensionPathIndex();return await Promise.all(ue.map(async De=>{const fe=this._registry.getExtensionDescription(De);fe&&he.delete(await this._realPathExtensionUri(fe.extensionLocation))})),await Promise.all(te.map(async De=>{const fe=await this._realPathExtensionUri(De.extensionLocation);he.set(fe,De)})),this._registry.deltaExtensions(te,ue),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){let ue=f.VSBuffer.alloc(te),he=Math.random()%256;for(let De=0;De<te;De++)ue.writeUInt8(he,De);return ue}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};j=Fe([Ne(0,c.IInstantiationService),Ne(1,e.IHostUtils),Ne(2,o.IExtHostRpcService),Ne(3,i.IExtHostWorkspace),Ne(4,s.IExtHostConfiguration),Ne(5,N.ILogService),Ne(6,t.IExtHostInitDataService),Ne(7,h.IExtensionStoragePaths),Ne(8,E.IExtHostTunnelService),Ne(9,m.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function J(le,te){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,c.createDecorator)("IExtHostExtensionService");class W{constructor(te,ue,he,De){U.set(this,void 0),z.set(this,void 0),q.set(this,void 0),je(this,U,te,"f"),je(this,z,ue,"f"),je(this,q,he.identifier,"f"),this.id=he.identifier.value,this.extensionUri=he.extensionLocation,this.extensionPath=I.normalize((0,x.originalFSPath)(he.extensionLocation)),this.packageJSON=he,this.extensionKind=De}get isActive(){return ye(this,U,"f").isActivated(ye(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return ye(this,U,"f").getExtensionExports(ye(this,q,"f"))}activate(){return ye(this,U,"f").activateByIdWithErrors(ye(this,q,"f"),{startup:!1,extensionId:ye(this,z,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,U=new WeakMap,z=new WeakMap,q=new WeakMap;function ie(le){const te=le.indexOf("+");return te===-1?le:le.substring(0,te)}}),define(ve[98],Ee([1,0,17,2,5,11,4,7,157,31,33,49,165,32,159,14,3,13,85,65]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,d.createDecorator)("IExtHostDebugService");let f=class{constructor(l,E,m,v,k,T){this._workspaceService=E,this._extensionService=m,this._editorsService=v,this._configurationService=k,this._editorTabs=T,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=l.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(g=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,E){const m=l;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let v=`debug:${encodeURIComponent(m.path||"")}`,k="?";return E&&(v+=`${k}session=${encodeURIComponent(E.id)}`,k="&"),v+=`${k}ref=${m.sourceReference}`,I.URI.parse(v)}else{if(m.path)return I.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const E=[];for(const m of l.getAllExtensionDescriptions())if(m.contributes){const v=m.contributes.debuggers;if(v&&v.length>0)for(const k of v)(0,n.isDebuggerMainContribution)(k)&&E.push(k.type)}this._debugServiceProxy.$registerDebugTypes(E)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(E=>l.push(E)),l}addBreakpoints(l){this.startBreakpoints();const E=l.filter(k=>{const T=k.id;return this._breakpoints.has(T)?!1:(this._breakpoints.set(T,k),!0)});this.fireBreakpointChanges(E,[],[]);const m=[],v=new Map;for(const k of E)if(k instanceof A.SourceBreakpoint){let T=v.get(k.location.uri.toString());T||(T={type:"sourceMulti",uri:k.location.uri,lines:[]},v.set(k.location.uri.toString(),T),m.push(T)),T.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character})}else k instanceof A.FunctionBreakpoint&&m.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName});return this._debugServiceProxy.$registerBreakpoints(m)}removeBreakpoints(l){this.startBreakpoints();const E=l.filter(T=>this._breakpoints.delete(T.id));this.fireBreakpointChanges([],E,[]);const m=E.filter(T=>T instanceof A.SourceBreakpoint).map(T=>T.id),v=E.filter(T=>T instanceof A.FunctionBreakpoint).map(T=>T.id),k=E.filter(T=>T instanceof A.DataBreakpoint).map(T=>T.id);return this._debugServiceProxy.$unregisterBreakpoints(m,v,k)}startDebugging(l,E,m){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,E,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,debugUI:m.debugUI,suppressSaveBeforeStart:m.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,E,m){if(!E)return new A.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:v,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,m,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,v),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(k=>k.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(l,E,m){if(!m)return new A.Disposable(()=>{});if(!this.definesDebugType(l,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:v,factory:m}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,v),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(k=>k.factory!==m),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(l,E){if(!E)return new A.Disposable(()=>{});const m=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:m,factory:E}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==E)})}async $runInTerminal(l,E){return Promise.resolve(void 0)}async $substituteVariables(l,E){if(!this._variableResolver){const[k,T]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(k||[],this._editorsService,T)}let m;const v=await this.getFolder(l);return v&&(m={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(m,E)}createDebugAdapter(l,E){if(l.type==="implementation")return new t(l.implementation)}createSignService(){}async $startDASession(l,E){const m=this,v=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const T=this.convertToDto(k),$=this.createDebugAdapter(T,v);if(!$)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const g=$;return this._debugAdapters.set(l,g),this.getDebugAdapterTrackers(v).then(U=>(U&&this._debugAdaptersTrackers.set(l,U),g.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const q=z,j={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const J=await this._signService.sign(q.arguments.value);j.body={signature:J},g.sendResponse(j)}else throw new Error("no signer")}catch(J){j.success=!1,j.message=J.message,g.sendResponse(j)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(z),z=(0,n.convertToVSCPaths)(z,!0),m._debugServiceProxy.$acceptDAMessage(l,z)}),g.onError(z=>{U&&U.onError&&U.onError(z),this._debugServiceProxy.$acceptDAError(l,z.name,z.message,z.stack)}),g.onExit(z=>{U&&U.onExit&&U.onExit((0,S.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,S.withNullAsUndefined)(z),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),g.startSession()))})}$sendDAMessage(l,E){E=(0,n.convertToDAPaths)(E,!1);const m=this._debugAdaptersTrackers.get(l);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(E);const v=this._debugAdapters.get(l);v&&v.sendMessage(E)}$stopDASession(l){const E=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),E&&E.onWillStopSession&&E.onWillStopSession();const m=this._debugAdapters.get(l);return this._debugAdapters.delete(l),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const E=[],m=[],v=[];if(l.added)for(const k of l.added){const T=k.id;if(T&&!this._breakpoints.has(T)){let $;if(k.type==="function")$=new A.FunctionBreakpoint(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage);else if(k.type==="data")$=new A.DataBreakpoint(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage);else{const g=I.URI.revive(k.uri);$=new A.SourceBreakpoint(new A.Location(g,new A.Position(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage)}$._id=T,this._breakpoints.set(T,$),E.push($)}}if(l.removed)for(const k of l.removed){const T=this._breakpoints.get(k);T&&(this._breakpoints.delete(k),m.push(T))}if(l.changed){for(const k of l.changed)if(k.id){const T=this._breakpoints.get(k.id);if(T){if(T instanceof A.FunctionBreakpoint&&k.type==="function"){const $=T;$.enabled=k.enabled,$.condition=k.condition,$.hitCondition=k.hitCondition,$.logMessage=k.logMessage,$.functionName=k.functionName}else if(T instanceof A.SourceBreakpoint&&k.type==="source"){const $=T;$.enabled=k.enabled,$.condition=k.condition,$.hitCondition=k.hitCondition,$.logMessage=k.logMessage,$.location=new A.Location(I.URI.revive(k.uri),new A.Position(k.line,k.character))}v.push(T)}}}this.fireBreakpointChanges(E,m,v)}$provideDebugConfigurations(l,E,m){return(0,x.asPromise)(async()=>{const v=this.getConfigProviderByHandle(l);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.getFolder(E);return v.provideDebugConfigurations(k,m)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(l,E,m,v){return(0,x.asPromise)(async()=>{const k=this.getConfigProviderByHandle(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const T=await this.getFolder(E);return k.resolveDebugConfiguration(T,m,v)})}$resolveDebugConfigurationWithSubstitutedVariables(l,E,m,v){return(0,x.asPromise)(async()=>{const k=this.getConfigProviderByHandle(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const T=await this.getFolder(E);return k.resolveDebugConfigurationWithSubstitutedVariables(T,m,v)})}async $provideDebugAdapter(l,E){const m=this.getAdapterDescriptorFactoryByHandle(l);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(E);return this.getAdapterDescriptor(m,v).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(k)})}async $acceptDebugSessionStarted(l){const E=await this.getSession(l);this._onDidStartDebugSession.fire(E)}async $acceptDebugSessionTerminated(l){const E=await this.getSession(l);E&&(this._onDidTerminateDebugSession.fire(E),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,E){const m=await this.getSession(l);m&&m._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(l,E){const v={session:await this.getSession(l),event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(l){if(l instanceof A.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof A.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const E=this._adapterFactories.filter(m=>m.type===l);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(l){const E=this._adapterFactories.filter(m=>m.handle===l);if(E.length>0)return E[0].factory}getConfigProviderByHandle(l){const E=this._configProviders.filter(m=>m.handle===l);if(E.length>0)return E[0].provider}definesDebugType(l,E){if(l.contributes){const m=l.contributes.debuggers;if(m&&m.length>0){for(const v of m)if(v.label&&v.type&&v.type===E)return!0}}return!1}getDebugAdapterTrackers(l){const m=l.configuration.type,v=this._trackerFactories.filter(k=>k.type===m||k.type==="*").map(k=>(0,x.asPromise)(()=>k.factory.createDebugAdapterTracker(l)).then(T=>T,T=>null));return Promise.race([Promise.all(v).then(k=>{const T=k.filter($=>!!$);if(T.length>0)return new c(T)}),new Promise((k,T)=>{const $=setTimeout(()=>{clearTimeout($),T(new Error("timeout"))},1e3)})]).catch(k=>{})}async getAdapterDescriptor(l,E){const m=E.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new A.DebugAdapterServer(m));if(l){const k=await this._extensionService.getExtensionRegistry();return(0,x.asPromise)(()=>l.createDebugAdapterDescriptor(E,this.daExecutableFromPackage(E,k))).then(T=>{if(T)return T})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,v))}daExecutableFromPackage(l,E){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,E,m){(l.length>0||E.length>0||m.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:E,changed:m}))}async getSession(l){if(l)if(typeof l=="string"){const E=this._debugSessions.get(l);if(E)return E}else{let E=this._debugSessions.get(l.id);if(!E){const m=await this.getFolder(l.folderUri),v=l.parent?this._debugSessions.get(l.parent):void 0;E=new w(this._debugServiceProxy,l.id,l.type,l.name,m,l.configuration,v),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(l){if(l){const E=I.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}};f=Fe([Ne(0,i.IExtHostRpcService),Ne(1,R.IExtHostWorkspace),Ne(2,N.IExtHostExtensionService),Ne(3,b.IExtHostDocumentsAndEditors),Ne(4,p.IExtHostConfiguration),Ne(5,u.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class w{constructor(l,E,m,v,k,T,$){this._debugServiceProxy=l,this._id=E,this._type=m,this._name=v,this._workspaceFolder=k,this._configuration=T,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,E){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,E)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=w;class a{constructor(l){this.value=Object.freeze({append(E){l.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=a;class P extends s.AbstractVariableResolverService{constructor(l,E,m,v,k){function T(){if(E){const $=E.activeEditor();if($)return $.document.uri;const g=v.tabs.filter(U=>U.isActive);if(g.length>0){const U=g[0].resource;return U&&(U.primary||U.secondary)?U.primary??U.secondary:g[0].resource}}}super({getFolderUri:$=>{const g=l.filter(U=>U.name===$);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:($,g)=>m.getConfiguration(void 0,$).get(g),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=T();if($)return r.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const $=T();if($){const g=k.getWorkspaceFolder($);if(g)return r.normalize(g.uri.fsPath)}}},getSelectedText:()=>{if(E){const $=E.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(E){const $=E.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(M.env))}}e.ExtHostVariableResolverService=P;class c{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(E=>E.onError?E.onError(l):void 0)}onExit(l,E){this.trackers.forEach(m=>m.onExit?m.onExit(l,E):void 0)}}class t extends C.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let h=class extends f{constructor(l,E,m,v,k,T){super(l,E,m,v,k,T)}createVariableResolver(l,E,m){return new P(l,E,m,this._editorTabs)}};h=Fe([Ne(0,i.IExtHostRpcService),Ne(1,R.IExtHostWorkspace),Ne(2,N.IExtHostExtensionService),Ne(3,b.IExtHostDocumentsAndEditors),Ne(4,p.IExtHostConfiguration),Ne(5,u.IExtHostEditorTabs)],h),e.WorkerExtHostDebugService=h}),define(ve[216],Ee([1,0,68,2,4,32,27,25,14,28,3,33,85,12,10]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let i=class{constructor(w,a,P,c,t,h,o){this._apiFactory=w,this._extensionRegistry=a,this._instaService=P,this._extHostConfiguration=c,this._extHostExtensionService=t,this._initData=h,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const w=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new S(this._apiFactory,a,this._extensionRegistry,w,this._logService)),this.register(this._instaService.createInstance(M,a)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(u,a,this._initData.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(let a of w.nodeModuleName)this._factories.set(a,w);else this._factories.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this._alternatives.push(a=>w.alternativeModuleName(a))}};i=Fe([Ne(2,N.IInstantiationService),Ne(3,x.IExtHostConfiguration),Ne(4,b.IExtHostExtensionService),Ne(5,R.IExtHostInitDataService),Ne(6,p.ILogService)],i),e.RequireInterceptor=i;let d=class Hi{constructor(w){if(w.environment.appRoot&&Hi.aliased.size){const a=(0,n.escapeRegExpCharacters)(this.forceForwardSlashes(w.environment.appRoot.fsPath)),P="[a-z0-9_.-]",c=`@${P}+\\/${P}+|${P}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${t}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(w){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(w));if(!a)return;const[,P,c,t]=a,h=Hi.aliased.get(c);if(h!==void 0)return console.warn(`${c} as been renamed to ${h}, please update your imports`),P+h+t}forceForwardSlashes(w){return w.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=Fe([Ne(0,R.IExtHostInitDataService)],d);class S{constructor(w,a,P,c,t){this._apiFactory=w,this._extensionPaths=a,this._extensionRegistry=P,this._configProvider=c,this._logService=t,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(w,a){const P=this._extensionPaths.findSubstr(a);if(P){let c=this._extApiImpl.get(A.ExtensionIdentifier.toKey(P.identifier));return c||(c=this._apiFactory(P,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(P.identifier),c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((t,h)=>c+=`	${h} -> ${t.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let M=class{constructor(w,a,P){this._extensionPaths=w,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(_.MainContext.MainThreadTelemetry);const{environment:c}=P,t=a.getProxy(_.MainContext.MainThreadKeytar);if(c.appRoot){let h=c.appRoot.fsPath;s.platform==="win32"&&(h=h.replace(/\\/g,"/")),h[h.length-1]==="/"&&(h=h.substr(0,h.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${h}/node_modules.asar/keytar`),this.alternativeNames.add(`${h}/node_modules/keytar`)}this._impl={getPassword:(h,o)=>t.$getPassword(h,o),setPassword:(h,o,l)=>t.$setPassword(h,o,l),deletePassword:(h,o)=>t.$deletePassword(h,o),findPassword:h=>t.$findPassword(h),findCredentials(h){return t.$findCredentials(h)}}}load(w,a){const P=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:P?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(w){const a=w.length;if(a<=7||!this.alternativeNames)return;const P=a-7;if((w.charAt(P)==="/"||w.charAt(P)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.alternativeNames.has(w)))return"keytar"}};M=Fe([Ne(1,C.IExtHostRpcService),Ne(2,R.IExtHostInitDataService)],M);let u=class{constructor(w,a,P){this._extensionPaths=w,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=P.getProxy(_.MainContext.MainThreadTelemetry);const c=P.getProxy(_.MainContext.MainThreadWindow);this._impl=(t,h)=>{const o=I.URI.parse(t);return h?this.callOriginal(t,h):o.scheme==="http"||o.scheme==="https"?c.$openUri(o,t,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?c.$openUri(o,t,{}):this.callOriginal(t,h)}}load(w,a,P){const c=this._extensionPaths.findSubstr(a);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=P(w),this._impl}callOriginal(w,a){return this.sendNoForwardTelemetry(),this._original(w,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};u=Fe([Ne(2,C.IExtHostRpcService)],u)}),define(ve[217],Ee([1,0,11,15,68,6,2,4,209,12,44,55,28,138,14,59,33,40]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class M{constructor(f,w,a,P,c){this._disposables=new x.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new C.RPCProtocol(f,null,P),w=M._transform(w,this._rpcProtocol);const t=new b.ServiceCollection(...(0,N.getSingletonServiceDescriptors)());t.set(s.IExtHostInitDataService,{_serviceBrand:void 0,...w,messagePorts:c}),t.set(n.IExtHostRpcService,new n.ExtHostRpcService(this._rpcProtocol)),t.set(i.IURITransformerService,new i.URITransformerService(P)),t.set(d.IHostUtils,a);const h=new p.InstantiationService(t,!0);this._disposables.add(h.invokeFunction(m=>m.get(S.IExtHostTerminalService))),this._disposables.add(h.invokeFunction(m=>m.get(d.IExtHostExtensionService))),this._logService=h.invokeFunction(m=>m.get(R.ILogService)),_.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",w),this._extensionService=h.invokeFunction(m=>m.get(d.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(m=>{Error.prepareStackTrace=(v,k)=>{let T="",$,g;for(const U of k)T+=`
	at ${U.toString()}`,g=U.getFileName(),!$&&g&&($=m.findSubstr(y.URI.file(g)));return o.set(v,$),`${v.name||"Error"}: ${v.message||""}${T}`}});const l=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),E=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(m=>{const v=I.transformErrorForSerialization(m),k=o.get(m);k?l.$onExtensionRuntimeError(k.identifier,v):E.$onUnexpectedError(v)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const w=this._extensionService.deactivateAll();Promise.race([(0,r.timeout)(5e3),w]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(f,w){f.extensions.forEach(P=>P.extensionLocation=y.URI.revive(w.transformIncomingURIs(P.extensionLocation))),f.environment.appRoot=y.URI.revive(w.transformIncomingURIs(f.environment.appRoot));const a=f.environment.extensionDevelopmentLocationURI;return a&&(f.environment.extensionDevelopmentLocationURI=a.map(P=>y.URI.revive(w.transformIncomingURIs(P)))),f.environment.extensionTestsLocationURI=y.URI.revive(w.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=y.URI.revive(w.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=y.URI.revive(w.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=y.URI.revive(w.transformIncomingURIs(f.logsLocation)),f.logFile=y.URI.revive(w.transformIncomingURIs(f.logFile)),f.workspace=w.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=M}),define(ve[218],Ee([1,0,16,11,20,43,29,9,17,24,13,2,41]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class p{constructor(f,w,a,P){this.query=f,this.provider=w,this.fileUtils=a,this.processType=P,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,w){const a=this.query.folderQueries||[],P=new _.CancellationTokenSource;return w.onCancellationRequested(()=>P.cancel()),new Promise((c,t)=>{this.collector=new i(f);let h=!1;const o=(l,E)=>{if(!h&&!this.isLimitHit){const m=this.resultSize(l);S(l)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,h=!0,P.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const v=this.resultSize(l);this.resultCount+=v,(v>0||!S(l))&&this.collector.add(l,E)}};Promise.all(a.map((l,E)=>this.searchInFolder(l,m=>o(m,E),P.token))).then(l=>{P.dispose(),this.collector.flush();const E=l.some(m=>!!m&&!!m.limitHit);c({limitHit:this.isLimitHit||E,messages:(0,r.flatten)(l.map(m=>m?.message?(0,N.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},l=>{P.dispose();const E=(0,x.toErrorMessage)(l);t(new Error(E))})})}resultSize(f){return S(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,w){const a=Array.isArray(f.ranges)?f.ranges:[f.ranges],P=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:a.slice(0,w),preview:{matches:P.slice(0,w),text:f.preview.text},uri:f.uri}}async searchInFolder(f,w,a){const P=new s.QueryGlobTester(this.query,f),c=[],t={report:l=>{if(!this.validateProviderResult(l))return;const E=f.folder.scheme===A.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(R.dirname(l.uri))):void 0,m=R.relativePath(f.folder,l.uri);if(m){const v=P.includedInQuery(m,C.basename(m),E);(0,I.isThenable)(v)?c.push(v.then(k=>{k&&w(l)})):v&&w(l)}}},h=this.getSearchOptionsForFolder(f),o=await this.provider.provideTextSearchResults(n(this.query.contentPattern),h,t,a);return c.length&&await Promise.all(c),o}validateProviderResult(f){if(S(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const w=(0,s.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),a=(0,s.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),P={folder:b.URI.from(f.folder),excludes:a,includes:w,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return P.usePCRE2=this.query.usePCRE2,P}}e.TextSearchManager=p;function n(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class i{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new M(512,w=>this.sendItems(w))}add(f,w){this._currentFileMatch&&(this._currentFolderIdx!==w||!R.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=w,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(d(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=i;function d(u){return S(u)?{preview:{matches:(0,r.mapArrayOrNot)(u.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:u.preview.text},ranges:(0,r.mapArrayOrNot)(u.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function S(u){return!!u.preview}e.extensionResultIsMatch=S;class M{constructor(f,w){this.maxBatchSize=f,this.cb=w,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,w){!f||this.addItemToBatch(f,w)}addItems(f,w){!f||this.addItemsToBatch(f,w)}addItemToBatch(f,w){this.batch.push(f),this.batchSize+=w,this.onUpdate()}addItemsToBatch(f,w){this.batch=this.batch.concat(f),this.batchSize+=w,this.onUpdate()}onUpdate(){this.totalNumberCompleted<M.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},M.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=M,M.TIMEOUT=4e3,M.START_BATCH_AFTER_COUNT=50}),define(ve[99],Ee([1,0,6,4,3,213,14,59,12,2,218]),function(Y,e,r,I,_,x,y,A,C,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let b=class{constructor(i,d,S){this.extHostRpc=i,this._uriTransformer=d,this._logService=S,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new x.FileSearchManager}_transformScheme(i){return this._uriTransformer.transformOutgoingScheme(i)}registerTextSearchProvider(i,d){if(this._textSearchUsedSchemes.has(i))throw new Error(`a text search provider for the scheme '${i}' is already registered`);this._textSearchUsedSchemes.add(i);const S=this._handlePool++;return this._textSearchProvider.set(S,d),this._proxy.$registerTextSearchProvider(S,this._transformScheme(i)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(i),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(i,d){if(this._fileSearchUsedSchemes.has(i))throw new Error(`a file search provider for the scheme '${i}' is already registered`);this._fileSearchUsedSchemes.add(i);const S=this._handlePool++;return this._fileSearchProvider.set(S,d),this._proxy.$registerFileSearchProvider(S,this._transformScheme(i)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(i),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(i,d,S,M){const u=s(S),f=this._fileSearchProvider.get(i);if(f)return this._fileSearchManager.fileSearch(u,f,w=>{this._proxy.$handleFileMatch(i,d,w.map(a=>a.resource))},M);throw new Error("unknown provider: "+i)}$clearCache(i){return this._fileSearchManager.clearCache(i),Promise.resolve(void 0)}$provideTextSearchResults(i,d,S,M){const u=this._textSearchProvider.get(i);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${i}`);const f=s(S);return this.createTextSearchManager(f,u).search(a=>this._proxy.$handleTextMatch(i,d,a),M)}$enableExtensionHostSearch(){}createTextSearchManager(i,d){return new N.TextSearchManager(i,d,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};b=Fe([Ne(0,y.IExtHostRpcService),Ne(1,A.IURITransformerService),Ne(2,C.ILogService)],b),e.ExtHostSearch=b;function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(p),extraFileResources:n.extraFileResources&&n.extraFileResources.map(i=>R.URI.revive(i))}}e.reviveQuery=s;function p(n){return{...n,folder:R.URI.revive(n.folder)}}}),define(ve[219],Ee([1,0,44,94,31,92,32,39,49,40,97,98,99,66,58,64,95,50,30,63,82,65,192,12,174]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u,f,w,a,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(P.ILoggerService,a.ExtHostLoggerService),(0,r.registerSingleton)(P.ILogService,c.ExtHostLogService),(0,r.registerSingleton)(i.IExtHostApiDeprecationService,i.ExtHostApiDeprecationService),(0,r.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,r.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,r.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,r.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService),(0,r.registerSingleton)(x.IExtHostDecorations,x.ExtHostDecorations),(0,r.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,r.registerSingleton)(M.IExtHostFileSystemInfo,M.ExtHostFileSystemInfo),(0,r.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,r.registerSingleton)(s.IExtHostSearch,s.ExtHostSearch),(0,r.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,r.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask),(0,r.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,r.registerSingleton)(n.IExtHostTunnelService,n.ExtHostTunnelService),(0,r.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,r.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,r.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,r.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,r.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs)}),define(ve[220],Ee([1,0,44,3]),function(Y,e,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,I.createDecorator)("treeViewsDragAndDropService");class _{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(y){if(y&&this._dragOperations.has(y)){const A=this._dragOperations.get(y);return this._dragOperations.delete(y),A}}addDragOperationTransfer(y,A){this._dragOperations.set(y,A)}}e.TreeViewsDragAndDropService=_,(0,r.registerSingleton)(e.ITreeViewsDragAndDropService,_)}),define(ve[221],Ee([1,0,126,24,2,5,6,11,7,13,16,8,20,154,220]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function i(M,u){if((0,R.isString)(M))return{label:M};if(M&&typeof M=="object"&&typeof M.label=="string"){let f;return Array.isArray(M.highlights)&&(f=M.highlights.filter(w=>w.length===2&&typeof w[0]=="number"&&typeof w[1]=="number"),f=f.length?f:void 0),{label:M.label,highlights:f}}}class d{constructor(u,f,w){this._proxy=u,this.commands=f,this.logService=w,this.treeViews=new Map,this.treeDragAndDropService=new n.TreeViewsDragAndDropService;function a(P){return P&&P.$treeViewId&&P.$treeItemHandle}f.registerArgumentProcessor({processArgument:P=>a(P)?this.convertArgument(P):Array.isArray(P)&&P.length>0?P.map(c=>a(c)?this.convertArgument(c):c):P})}registerTreeDataProvider(u,f,w){const a=this.createTreeView(u,{treeDataProvider:f},w);return{dispose:()=>a.dispose()}}createTreeView(u,f,w){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=f.dragAndDropController?.dropMimeTypes,P=f.dragAndDropController?.dragMimeTypes,c=!!f.dragAndDropController?.handleDrag,t=this._proxy.$registerTreeViewDataProvider(u,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,dropMimeTypes:a,dragMimeTypes:P,hasHandleDrag:c}),h=this.createExtHostTreeView(u,f,w);return{get onDidCollapseElement(){return h.onDidCollapseElement},get onDidExpandElement(){return h.onDidExpandElement},get selection(){return h.selectedElements},get onDidChangeSelection(){return h.onDidChangeSelection},get visible(){return h.visible},get onDidChangeVisibility(){return h.onDidChangeVisibility},get message(){return h.message},set message(o){h.message=o},get title(){return h.title},set title(o){h.title=o},get description(){return h.description},set description(o){h.description=o},reveal:(o,l)=>h.reveal(o,l),dispose:async()=>{await t,this.treeViews.delete(u),h.dispose()}}}$getChildren(u,f){const w=this.treeViews.get(u);return w?w.getChildren(f):Promise.reject(new Error((0,r.localize)(0,null,u)))}async $handleDrop(u,f,w,a,P,c,t){const h=this.treeViews.get(u);if(!h)return Promise.reject(new Error((0,r.localize)(1,null,u)));const o=p.TreeDataTransferConverter.toITreeDataTransfer(f);return c===u&&t&&await this.addAdditionalTransferItems(o,h,t,a,P),h.onDrop(o,w,a)}async addAdditionalTransferItems(u,f,w,a,P){const c=this.treeDragAndDropService.removeDragOperationTransfer(P);if(c)(await c)?.forEach((t,h)=>{t&&u.set(h,t)});else if(P&&f.handleDrag){const t=f.handleDrag(w,u,a);this.treeDragAndDropService.addDragOperationTransfer(P,t),await t}return u}async $handleDrag(u,f,w,a){const P=this.treeViews.get(u);if(!P)return Promise.reject(new Error((0,r.localize)(2,null,u)));const c=await this.addAdditionalTransferItems(new Map,P,f,a,w);if(!!c)return p.TreeDataTransferConverter.toTreeDataTransferDTO(c)}async $hasResolve(u){const f=this.treeViews.get(u);if(!f)throw new Error((0,r.localize)(3,null,u));return f.hasResolve}$resolve(u,f,w){const a=this.treeViews.get(u);if(!a)throw new Error((0,r.localize)(4,null,u));return a.resolveTreeItem(f,w)}$setExpanded(u,f,w){const a=this.treeViews.get(u);if(!a)throw new Error((0,r.localize)(5,null,u));a.setExpanded(f,w)}$setSelection(u,f){const w=this.treeViews.get(u);if(!w)throw new Error((0,r.localize)(6,null,u));w.setSelection(f)}$setVisible(u,f){const w=this.treeViews.get(u);if(!w)throw new Error((0,r.localize)(7,null,u));w.setVisible(f)}createExtHostTreeView(u,f,w){const a=new S(u,f,this._proxy,this.commands.converter,this.logService,w);return this.treeViews.set(u,a),a}convertArgument(u){const f=this.treeViews.get(u.$treeViewId);return f?f.getExtensionElement(u.$treeItemHandle):null}}e.ExtHostTreeViews=d;class S extends y.Disposable{constructor(u,f,w,a,P,c){super();if(this.viewId=u,this.proxy=w,this.commands=a,this.logService=P,this.extension=c,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new x.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new x.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new x.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new x.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new x.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new s.CancellationTokenSource,c.contributes&&c.contributes.views)for(const o in c.contributes.views)for(const l of c.contributes.views[o])l.id===u&&(this._title=l.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(o=>this._onDidChangeData.fire({message:!1,element:o}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let t,h;this._register(x.Event.debounce(this._onDidChangeData.event,(o,l)=>(o||(o={message:!1,elements:[]}),l.element!==!1&&(t||(t=new Promise(E=>h=E),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(l.element)?o.elements.push(...l.element):o.elements.push(l.element)),l.message&&(o.message=!0),o),200,!0)(({message:o,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const E=h;return t=null,this.refresh(l).then(()=>E())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(u=>this.getExtensionElement(u)).filter(u=>!(0,R.isUndefinedOrNull)(u))}async getChildren(u){const f=u?this.getExtensionElement(u):void 0;if(u&&!f)return this.logService.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let w=this.getChildrenNodes(u);return w||(w=await this.fetchChildrenNodes(f)),w?w.map(a=>a.item):void 0}getExtensionElement(u){return this.elements.get(u)}reveal(u,f){f=f||{select:!0,focus:!1};const w=(0,R.isUndefinedOrNull)(f.select)?!0:f.select,a=(0,R.isUndefinedOrNull)(f.focus)?!1:f.focus,P=(0,R.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.refreshPromise.then(()=>this.resolveUnknownParentChain(u)).then(c=>this.resolveTreeNode(u,c[c.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:c.map(h=>h.item)},{select:w,focus:a,expand:P})),c=>this.logService.error(c)):this.proxy.$reveal(this.viewId,void 0,{select:w,focus:a,expand:P})}get message(){return this._message}set message(u){this._message=u,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(u){this._title=u,this.proxy.$setTitle(this.viewId,u,this._description)}get description(){return this._description}set description(u){this._description=u,this.proxy.$setTitle(this.viewId,this._title,u)}setExpanded(u,f){const w=this.getExtensionElement(u);w&&(f?this._onDidExpandElement.fire(Object.freeze({element:w})):this._onDidCollapseElement.fire(Object.freeze({element:w})))}setSelection(u){(0,N.equals)(this._selectedHandles,u)||(this._selectedHandles=u,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(u){u!==this._visible&&(this._visible=u,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(u,f,w){const a=[];for(const P of u){const c=this.getExtensionElement(P);c&&a.push(c)}if(!(!this.dndController?.handleDrag||a.length===0))return await this.dndController.handleDrag(a,f,w),f}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(u,f,w){const a=this.getExtensionElement(f);if(!!a)return(0,A.asPromise)(()=>this.dndController?.handleDrop(u,a,w))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(u,f){if(!this.dataProvider.resolveTreeItem)return;const w=this.elements.get(u);if(w){const a=this.nodes.get(w);if(a){const P=await this.dataProvider.resolveTreeItem(a.extensionItem,w,f)??a.extensionItem;return a.item.tooltip=this.getTooltip(P.tooltip),a.item.command=this.getCommand(a.disposableStore,P.command),a.item}}}resolveUnknownParentChain(u){return this.resolveParent(u).then(f=>f?this.resolveUnknownParentChain(f).then(w=>this.resolveTreeNode(f,w[w.length-1]).then(a=>(w.push(a),w))):Promise.resolve([]))}resolveParent(u){const f=this.nodes.get(u);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(u))}resolveTreeNode(u,f){const w=this.nodes.get(u);return w?Promise.resolve(w):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(a=>this.createHandle(u,a,f,!0)).then(a=>this.getChildren(f?f.item.handle:void 0).then(()=>{const P=this.getExtensionElement(a);if(P){const c=this.nodes.get(P);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(u){if(u){let f;if(typeof u=="string"){const w=this.getExtensionElement(u);f=w?this.nodes.get(w):void 0}else f=u;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(u){this.clearChildren(u);const f=new s.CancellationTokenSource(this._refreshCancellationSource.token);try{const w=u?this.nodes.get(u):void 0,a=await this.dataProvider.getChildren(u);if(f.token.isCancellationRequested)return;const P=await Promise.all((0,N.coalesce)(a||[]).map(async c=>{const t=await this.dataProvider.getTreeItem(c);return t&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(c,t,w):null}));return f.token.isCancellationRequested?void 0:(0,N.coalesce)(P)}finally{f.dispose()}}refresh(u){if(u.some(w=>!w))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new s.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const w=this.getHandlesToRefresh(u);if(w.length)return this.refreshHandles(w)}return Promise.resolve(void 0)}getHandlesToRefresh(u){const f=new Set,w=u.map(P=>this.nodes.get(P));for(const P of w)if(P&&!f.has(P.item.handle)){let c=P;for(;c&&c.parent&&w.findIndex(t=>c&&c.parent&&t&&t.item.handle===c.parent.item.handle)===-1;){const t=this.elements.get(c.parent.item.handle);c=t?this.nodes.get(t):void 0}c&&!c.parent&&f.add(P.item.handle)}const a=[];return f.forEach(P=>{const c=this.elements.get(P);if(c){const t=this.nodes.get(c);t&&(!t.parent||!f.has(t.parent.item.handle))&&a.push(P)}}),a}refreshHandles(u){const f={};return Promise.all(u.map(w=>this.refreshNode(w).then(a=>{a&&(f[w]=a.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(u){const f=this.getExtensionElement(u);if(f){const w=this.nodes.get(f);if(w)return this.clearChildren(f),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(a=>{if(a){const P=this.createTreeNode(f,a,w.parent);return this.updateNodeCache(f,P,w,w.parent),w.dispose(),P}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(u,f,w){const a=this.createTreeNode(u,f,w);if(f.id&&this.elements.has(a.item.handle))throw new Error((0,r.localize)(8,null,f.id));return this.addNodeToCache(u,a),this.addNodeToParentCache(a,w),a}getTooltip(u){return C.MarkdownString.isMarkdownString(u)?b.MarkdownString.from(u):u}getCommand(u,f){return f?this.commands.toInternal(f,u):void 0}createTreeNode(u,f,w){const a=new y.DisposableStore,P=this.createHandle(u,f,w),c=this.getLightIconPath(f);return{item:{handle:P,parentHandle:w?w.item.handle:void 0,label:i(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(a,f.command),contextValue:f.contextValue,icon:c,iconDark:this.getDarkIconPath(f)||c,themeIcon:this.getThemeIcon(f),collapsibleState:(0,R.isUndefinedOrNull)(f.collapsibleState)?C.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:w,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(u){return u.iconPath instanceof C.ThemeIcon?u.iconPath:void 0}createHandle(u,{id:f,label:w,resourceUri:a},P,c){if(f)return`${S.ID_HANDLE_PREFIX}/${f}`;const t=i(w,this.extension),h=P?P.item.handle:S.LABEL_HANDLE_PREFIX;let o=t?t.label:a?(0,I.basename)(a):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const l=this.nodes.has(u)?this.nodes.get(u).item.handle:void 0,E=this.getChildrenNodes(P)||[];let m,v=0;do{if(m=`${h}/${v}:${o}`,c||!this.elements.has(m)||l===m)break;v++}while(v<=E.length);return m}getLightIconPath(u){if(u.iconPath&&!(u.iconPath instanceof C.ThemeIcon))return typeof u.iconPath=="string"||_.URI.isUri(u.iconPath)?this.getIconPath(u.iconPath):this.getIconPath(u.iconPath.light)}getDarkIconPath(u){if(u.iconPath&&!(u.iconPath instanceof C.ThemeIcon)&&u.iconPath.dark)return this.getIconPath(u.iconPath.dark)}getIconPath(u){return _.URI.isUri(u)?u:_.URI.file(u)}addNodeToCache(u,f){this.elements.set(f.item.handle,u),this.nodes.set(u,f)}updateNodeCache(u,f,w,a){this.elements.delete(f.item.handle),this.nodes.delete(u),f.item.handle!==w.item.handle&&this.elements.delete(w.item.handle),this.addNodeToCache(u,f);const P=this.getChildrenNodes(a)||[],c=P.filter(t=>t.item.handle===w.item.handle)[0];c&&P.splice(P.indexOf(c),1,f)}addNodeToParentCache(u,f){f?(f.children||(f.children=[]),f.children.push(u)):(this.roots||(this.roots=[]),this.roots.push(u))}clearChildren(u){if(u){const f=this.nodes.get(u);if(f){if(f.children)for(const w of f.children){const a=this.elements.get(w.item.handle);a&&this.clear(a)}f.children=void 0}}else this.clearAll()}clear(u){const f=this.nodes.get(u);if(f){if(f.children)for(const w of f.children){const a=this.elements.get(w.item.handle);a&&this.clear(a)}this.nodes.delete(u),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(u=>u.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(ve[222],Ee([1,0,20,15,5,34,2,115,234,110,73,46,4,91,179,178,39,180,32,181,182,183,167,184,49,33,185,186,189,191,193,94,169,198,199,200,66,40,202,221,8,7,205,51,95,31,69,156,188,81,92,97,98,99,12,59,14,28,194,152,58,64,176,203,151,67,50,208,206,207,177,30,201,204,63,65,82,196,96,197,9,78,195,149,187,6,27,158]),function(Y,e,r,I,_,x,y,A,C,R,N,b,s,p,n,i,d,S,M,u,f,w,a,P,c,t,h,o,l,E,m,v,k,T,$,g,U,z,q,j,J,W,ie,le,te,ue,he,De,fe,ne,me,Ie,Ae,Ue,Ge,ge,de,L,F,D,O,H,X,re,pe,Ce,Me,Le,ze,xe,Oe,Xe,et,ke,tt,G,Q,ce,Re,$e,Ke,Qe,ht,_t,yt,Tt,Ve,pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(nt){const ot=nt.get(L.IExtHostInitDataService),At=nt.get(Xe.IExtHostFileSystemInfo),Dt=nt.get(Me.IExtHostConsumerFileSystem),Ct=nt.get(t.IExtHostExtensionService),lt=nt.get(ue.IExtHostWorkspace),Ot=nt.get(Q.IExtHostTelemetry),Lt=nt.get(M.IExtHostConfiguration),Ft=nt.get(ge.IURITransformerService),se=nt.get(de.IExtHostRpcService),_e=nt.get(U.IExtHostStorage),ae=nt.get(Ce.IExtensionStoragePaths),K=nt.get(Ge.ILoggerService),be=nt.get(Ge.ILogService),Te=nt.get(O.IExtHostTunnelService),Be=nt.get(H.IExtHostApiDeprecationService),We=nt.get(te.IExtHostWindow),st=nt.get(tt.IExtHostSecretState),ft=nt.get(G.IExtHostEditorTabs);se.set(s.ExtHostContext.ExtHostFileSystemInfo,At),se.set(s.ExtHostContext.ExtHostLogLevelServiceShape,K),se.set(s.ExtHostContext.ExtHostWorkspace,lt),se.set(s.ExtHostContext.ExtHostConfiguration,Lt),se.set(s.ExtHostContext.ExtHostExtensionService,Ct),se.set(s.ExtHostContext.ExtHostStorage,_e),se.set(s.ExtHostContext.ExtHostTunnelService,Te),se.set(s.ExtHostContext.ExtHostWindow,We),se.set(s.ExtHostContext.ExtHostSecretState,st),se.set(s.ExtHostContext.ExtHostTelemetry,Ot),se.set(s.ExtHostContext.ExtHostEditorTabs,ft);const Et=se.set(s.ExtHostContext.ExtHostDecorations,nt.get(me.IExtHostDecorations)),vt=se.set(s.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(c.IExtHostDocumentsAndEditors)),it=se.set(s.ExtHostContext.ExtHostCommands,nt.get(d.IExtHostCommands)),at=se.set(s.ExtHostContext.ExtHostTerminalService,nt.get(z.IExtHostTerminalService)),mt=se.set(s.ExtHostContext.ExtHostDebugService,nt.get(Ae.IExtHostDebugService)),Mt=se.set(s.ExtHostContext.ExtHostSearch,nt.get(Ue.IExtHostSearch)),ct=se.set(s.ExtHostContext.ExtHostTask,nt.get(Ie.IExtHostTask)),It=se.set(s.ExtHostContext.ExtHostOutputService,nt.get(v.IExtHostOutputService)),Ut=se.set(s.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(se)),bt=se.set(s.ExtHostContext.ExtHostDocuments,new P.ExtHostDocuments(se,vt)),Bt=se.set(s.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(se,vt,be)),Wt=se.set(s.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(be,bt,se.getProxy(s.MainContext.MainThreadBulkEdits))),dt=se.set(s.ExtHostContext.ExtHostNotebook,new F.ExtHostNotebookController(se,it,vt,bt,ae)),ei=se.set(s.ExtHostContext.ExtHostNotebookDocuments,new _t.ExtHostNotebookDocuments(be,dt)),Yt=se.set(s.ExtHostContext.ExtHostNotebookEditors,new ht.ExtHostNotebookEditors(be,se,dt)),ti=se.set(s.ExtHostContext.ExtHostNotebookKernels,new ce.ExtHostNotebookKernels(se,ot,dt,it,be)),oi=se.set(s.ExtHostContext.ExtHostNotebookRenderers,new $e.ExtHostNotebookRenderers(se,dt)),kt=se.set(s.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(se,vt)),ii=se.set(s.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(se.getProxy(s.MainContext.MainThreadTreeViews),it,be)),_i=se.set(s.ExtHostContext.ExtHostEditorInsets,new De.ExtHostEditorInsets(se.getProxy(s.MainContext.MainThreadEditorInsets),kt,ot)),Gt=se.set(s.ExtHostContext.ExtHostDiagnostics,new u.ExtHostDiagnostics(se,be,At)),Xt=se.set(s.ExtHostContext.ExtHostLanguages,new E.ExtHostLanguages(se,bt,it.converter,Ft)),rt=se.set(s.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(se,Ft,bt,it,Gt,be,Be)),ai=se.set(s.ExtHostContext.ExtHostFileSystem,new h.ExtHostFileSystem(se,rt)),Vt=se.set(s.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(se,be,vt)),jt=se.set(s.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(se,lt,it)),ni=se.set(s.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(se,it,be)),Si=se.set(s.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(se,it,bt)),gi=se.set(s.ExtHostContext.ExtHostProgress,new k.ExtHostProgress(se.getProxy(s.MainContext.MainThreadProgress))),yi=se.set(s.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(se)),pi=se.set(s.ExtHostContext.ExtHostTheming,new D.ExtHostTheming(se)),ri=se.set(s.ExtHostContext.ExtHostAuthentication,new X.ExtHostAuthentication(se)),li=se.set(s.ExtHostContext.ExtHostTimeline,new re.ExtHostTimeline(se,it)),Jt=se.set(s.ExtHostContext.ExtHostWebviews,new le.ExtHostWebviews(se,{remote:ot.remote},lt,be,Be)),ci=se.set(s.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(se,Jt,lt)),Di=se.set(s.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(se,bt,ae,Jt,ci)),Ci=se.set(s.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(se,Jt)),$t=se.set(s.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(se,it)),Ii=se.set(s.ExtHostContext.ExtHostUriOpeners,new ke.ExtHostUriOpeners(se));se.set(s.ExtHostContext.ExtHostInteractive,new yt.ExtHostInteractive(se,dt,vt,it));const ki=(0,he.values)(s.ExtHostContext);se.assertRegistered(ki);const Ti=new Oe.ExtHostBulkEdits(se,vt),ui=new i.ExtHostClipboard(se),di=new m.ExtHostMessageService(se,be),Qt=new f.ExtHostDialogs(se),Ht=new g.ExtHostStatusBar(se,it.converter);return n.ExtHostApiCommands.register(it),function(Pe,Rt,Zt){const ut=function(){let Z=!Pe.isUnderDevelopment;function oe(){Z||(be.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Se(Ye){if(Array.isArray(Ye))Ye.forEach(Se);else if(typeof Ye=="string")oe();else{const gt=Ye;typeof gt.scheme=="undefined"&&oe(),typeof gt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Pe,"documentFiltersExclusive")}return Ye}}(),Pi={getSession(Z,oe,Se){return ri.getSession(Pe,Z,oe,Se)},async hasSession(Z,oe){return(0,Ve.checkProposedApiEnabled)(Pe,"authSession"),!!await ri.getSession(Pe,Z,oe,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(Z,oe,Se,Ye){return ri.registerAuthenticationProvider(Z,oe,Se,Ye)}},Ai={registerCommand(Z,oe,Se){return it.registerCommand(!0,Z,oe,Se,void 0,Pe)},registerTextEditorCommand(Z,oe,Se){return it.registerCommand(!0,Z,(...Ye)=>{const gt=kt.getActiveTextEditor();if(!gt){be.warn("Cannot execute "+Z+" because there is no active text editor.");return}return gt.edit(St=>{oe.apply(Se,[gt,St,...Ye])}).then(St=>{St||be.warn("Edits from command "+Z+" were not applied.")},St=>{be.warn("An error occurred while running command "+Z,St)})},void 0,void 0,Pe)},registerDiffInformationCommand:(Z,oe,Se)=>((0,Ve.checkProposedApiEnabled)(Pe,"diffCommand"),it.registerCommand(!0,Z,async(...Ye)=>{const gt=vt.activeEditor(!0);if(!gt){be.warn("Cannot execute "+Z+" because there is no active text editor.");return}const St=await kt.getDiffInformation(gt.id);oe.apply(Se,[St,...Ye])},void 0,void 0,Pe)),executeCommand(Z,...oe){return it.executeCommand(Z,...oe)},getCommands(Z=!1){return it.getCommands(Z)}},vi={get machineId(){return ot.telemetryInfo.machineId},get sessionId(){return ot.telemetryInfo.sessionId},get language(){return ot.environment.appLanguage},get appName(){return ot.environment.appName},get appRoot(){return ot.environment.appRoot?.fsPath??""},get appHost(){return ot.environment.appHost},get uriScheme(){return ot.environment.appUriScheme},get clipboard(){return ui.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return Ot.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ot.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Pe,"telemetry"),Ot.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Pe,"telemetry"),Ot.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const Z=Date.now()-new Date(ot.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,oe){return We.openUri(Z,{allowTunneling:!!ot.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===ot.environment.appUriScheme)return Ut.createAppUri(Z);try{return await We.asExternalUri(Z,{allowTunneling:!!ot.remote.authority})}catch(oe){if((0,Qe.matchesScheme)(Z,Ke.Schemas.http)||(0,Qe.matchesScheme)(Z,Ke.Schemas.https))return Z;throw oe}},get remoteName(){return(0,ne.getRemoteName)(ot.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),ot.remote.authority},get uiKind(){return ot.uiKind}};ot.environment.extensionTestsLocationURI||Object.freeze(vi);const Ei=ot.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Ri={createTestController(Z,oe,Se){return Se&&(0,Ve.checkProposedApiEnabled)(Pe,"testRefresh"),$t.createTestController(Z,oe,Se)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.createTestObserver()},runTests(Z){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.runTests(Z)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.results}},Oi={getExtension(Z){const oe=Rt.getExtensionDescription(Z);if(oe)return new t.Extension(Ct,Pe.identifier,oe,Ei)},get all(){return Rt.getAllExtensionDescriptions().map(Z=>new t.Extension(Ct,Pe.identifier,Z,Ei))},get onDidChange(){return Rt.onDidChange}},hi={createDiagnosticCollection(Z){return Gt.createDiagnosticCollection(Pe.identifier,Z)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:Z=>Gt.getDiagnostics(Z),getLanguages(){return Xt.getLanguages()},setTextDocumentLanguage(Z,oe){return Xt.changeLanguage(Z.uri,oe)},match(Z,oe){return(0,N.score)(J.LanguageSelector.from(Z),oe.uri,oe.languageId,!0)},registerCodeActionsProvider(Z,oe,Se){return rt.registerCodeActionProvider(Pe,ut(Z),oe,Se)},registerCodeLensProvider(Z,oe){return rt.registerCodeLensProvider(Pe,ut(Z),oe)},registerDefinitionProvider(Z,oe){return rt.registerDefinitionProvider(Pe,ut(Z),oe)},registerDeclarationProvider(Z,oe){return rt.registerDeclarationProvider(Pe,ut(Z),oe)},registerImplementationProvider(Z,oe){return rt.registerImplementationProvider(Pe,ut(Z),oe)},registerTypeDefinitionProvider(Z,oe){return rt.registerTypeDefinitionProvider(Pe,ut(Z),oe)},registerHoverProvider(Z,oe){return rt.registerHoverProvider(Pe,ut(Z),oe,Pe.identifier)},registerEvaluatableExpressionProvider(Z,oe){return rt.registerEvaluatableExpressionProvider(Pe,ut(Z),oe,Pe.identifier)},registerInlineValuesProvider(Z,oe){return rt.registerInlineValuesProvider(Pe,ut(Z),oe,Pe.identifier)},registerDocumentHighlightProvider(Z,oe){return rt.registerDocumentHighlightProvider(Pe,ut(Z),oe)},registerLinkedEditingRangeProvider(Z,oe){return rt.registerLinkedEditingRangeProvider(Pe,ut(Z),oe)},registerReferenceProvider(Z,oe){return rt.registerReferenceProvider(Pe,ut(Z),oe)},registerRenameProvider(Z,oe){return rt.registerRenameProvider(Pe,ut(Z),oe)},registerDocumentSymbolProvider(Z,oe,Se){return rt.registerDocumentSymbolProvider(Pe,ut(Z),oe,Se)},registerWorkspaceSymbolProvider(Z){return rt.registerWorkspaceSymbolProvider(Pe,Z)},registerDocumentFormattingEditProvider(Z,oe){return rt.registerDocumentFormattingEditProvider(Pe,ut(Z),oe)},registerDocumentRangeFormattingEditProvider(Z,oe){return rt.registerDocumentRangeFormattingEditProvider(Pe,ut(Z),oe)},registerOnTypeFormattingEditProvider(Z,oe,Se,...Ye){return rt.registerOnTypeFormattingEditProvider(Pe,ut(Z),oe,[Se].concat(Ye))},registerDocumentSemanticTokensProvider(Z,oe,Se){return rt.registerDocumentSemanticTokensProvider(Pe,ut(Z),oe,Se)},registerDocumentRangeSemanticTokensProvider(Z,oe,Se){return rt.registerDocumentRangeSemanticTokensProvider(Pe,ut(Z),oe,Se)},registerSignatureHelpProvider(Z,oe,Se,...Ye){return typeof Se=="object"?rt.registerSignatureHelpProvider(Pe,ut(Z),oe,Se):rt.registerSignatureHelpProvider(Pe,ut(Z),oe,typeof Se=="undefined"?[]:[Se,...Ye])},registerCompletionItemProvider(Z,oe,...Se){return rt.registerCompletionItemProvider(Pe,ut(Z),oe,Se)},registerInlineCompletionItemProvider(Z,oe){return(0,Ve.checkProposedApiEnabled)(Pe,"inlineCompletions"),rt.registerInlineCompletionsProvider(Pe,ut(Z),oe)},registerDocumentLinkProvider(Z,oe){return rt.registerDocumentLinkProvider(Pe,ut(Z),oe)},registerColorProvider(Z,oe){return rt.registerColorProvider(Pe,ut(Z),oe)},registerFoldingRangeProvider(Z,oe){return rt.registerFoldingRangeProvider(Pe,ut(Z),oe)},registerSelectionRangeProvider(Z,oe){return rt.registerSelectionRangeProvider(Pe,Z,oe)},registerCallHierarchyProvider(Z,oe){return rt.registerCallHierarchyProvider(Pe,Z,oe)},registerTypeHierarchyProvider(Z,oe){return rt.registerTypeHierarchyProvider(Pe,Z,oe)},setLanguageConfiguration:(Z,oe)=>rt.setLanguageConfiguration(Pe,Z,oe),getTokenInformationAtPosition(Z,oe){return(0,Ve.checkProposedApiEnabled)(Pe,"tokenInformation"),Xt.tokenAtPosition(Z,oe)},registerInlayHintsProvider(Z,oe){return(0,Ve.checkProposedApiEnabled)(Pe,"inlayHints"),rt.registerInlayHintsProvider(Pe,Z,oe)},createLanguageStatusItem(Z,oe){return(0,Ve.checkProposedApiEnabled)(Pe,"languageStatus"),Xt.createLanguageStatusItem(Pe,Z,oe)}},Fi={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(Z,oe,Se){const Ye=await(y.URI.isUri(Z)?Promise.resolve(bi.openTextDocument(Z)):Promise.resolve(Z));return kt.showTextDocument(Ye,oe,Se)},createTextEditorDecorationType(Z){return kt.createTextEditorDecorationType(Pe,Z)},onDidChangeActiveTextEditor(Z,oe,Se){return kt.onDidChangeActiveTextEditor(Z,oe,Se)},onDidChangeVisibleTextEditors(Z,oe,Se){return kt.onDidChangeVisibleTextEditors(Z,oe,Se)},onDidChangeTextEditorSelection(Z,oe,Se){return kt.onDidChangeTextEditorSelection(Z,oe,Se)},onDidChangeTextEditorOptions(Z,oe,Se){return kt.onDidChangeTextEditorOptions(Z,oe,Se)},onDidChangeTextEditorVisibleRanges(Z,oe,Se){return kt.onDidChangeTextEditorVisibleRanges(Z,oe,Se)},onDidChangeTextEditorViewColumn(Z,oe,Se){return kt.onDidChangeTextEditorViewColumn(Z,oe,Se)},onDidCloseTerminal(Z,oe,Se){return at.onDidCloseTerminal(Z,oe,Se)},onDidOpenTerminal(Z,oe,Se){return at.onDidOpenTerminal(Z,oe,Se)},onDidChangeActiveTerminal(Z,oe,Se){return at.onDidChangeActiveTerminal(Z,oe,Se)},onDidChangeTerminalDimensions(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"terminalDimensions"),at.onDidChangeTerminalDimensions(Z,oe,Se)},onDidChangeTerminalState(Z,oe,Se){return at.onDidChangeTerminalState(Z,oe,Se)},onDidWriteTerminalData(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),at.onDidWriteTerminalData(Z,oe,Se)},get state(){return We.state},onDidChangeWindowState(Z,oe,Se){return We.onDidChangeWindowState(Z,oe,Se)},showInformationMessage(Z,...oe){return di.showMessage(Pe,x.default.Info,Z,oe[0],oe.slice(1))},showWarningMessage(Z,...oe){return di.showMessage(Pe,x.default.Warning,Z,oe[0],oe.slice(1))},showErrorMessage(Z,...oe){return di.showMessage(Pe,x.default.Error,Z,oe[0],oe.slice(1))},showQuickPick(Z,oe,Se){return jt.showQuickPick(Z,oe,Se)},showWorkspaceFolderPick(Z){return jt.showWorkspaceFolderPick(Z)},showInputBox(Z,oe){return jt.showInput(Z,oe)},showOpenDialog(Z){return Qt.showOpenDialog(Z)},showSaveDialog(Z){return Qt.showSaveDialog(Z)},createStatusBarItem(Z,oe,Se){let Ye,gt,St;return typeof Z=="string"?(Ye=Z,gt=oe,St=Se):(gt=Z,St=oe),Ht.createStatusBarEntry(Pe,Ye,gt,St)},setStatusBarMessage(Z,oe){return Ht.setStatusBarMessage(Z,oe)},withScmProgress(Z){return Be.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),gi.withProgress(Pe,{location:W.ProgressLocation.SourceControl},(oe,Se)=>Z({report(Ye){}}))},withProgress(Z,oe){return gi.withProgress(Pe,Z,oe)},createOutputChannel(Z){return It.createOutputChannel(Z,Pe)},createWebviewPanel(Z,oe,Se,Ye){return ci.createWebviewPanel(Pe,Z,oe,Se,Ye)},createWebviewTextEditorInset(Z,oe,Se,Ye){return(0,Ve.checkProposedApiEnabled)(Pe,"editorInsets"),_i.createWebviewEditorInset(Z,oe,Se,Ye,Pe)},createTerminal(Z,oe,Se){return typeof Z=="object"?"pty"in Z?at.createExtensionTerminal(Z):at.createTerminalFromOptions(Z):at.createTerminal(Z,oe,Se)},registerTerminalLinkProvider(Z){return at.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,oe){return at.registerProfileProvider(Pe,Z,oe)},registerTreeDataProvider(Z,oe){return ii.registerTreeDataProvider(Z,oe,Pe)},createTreeView(Z,oe){return ii.createTreeView(Z,oe,Pe)},registerWebviewPanelSerializer:(Z,oe)=>ci.registerWebviewPanelSerializer(Pe,Z,oe),registerCustomEditorProvider:(Z,oe,Se={})=>Di.registerCustomEditorProvider(Pe,Z,oe,Se),registerFileDecorationProvider(Z){return Et.registerFileDecorationProvider(Z,Pe.identifier)},registerUriHandler(Z){return Ut.registerUriHandler(Pe.identifier,Z)},createQuickPick(){return jt.createQuickPick(Pe)},createInputBox(){return jt.createInputBox(Pe.identifier)},get activeColorTheme(){return pi.activeColorTheme},onDidChangeActiveColorTheme(Z,oe,Se){return pi.onDidChangeActiveColorTheme(Z,oe,Se)},registerWebviewViewProvider(Z,oe,Se){return Ci.registerWebviewViewProvider(Pe,Z,oe,Se?.webviewOptions)},get activeNotebookEditor(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeActiveNotebookEditor(Z,oe,Se)},get visibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(Z,oe,Se)},onDidChangeNotebookEditorVisibleRanges(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(Z,oe,Se)},showNotebookDocument(Z,oe){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.showNotebookDocument(Z,oe)},registerExternalUriOpener(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"externalUriOpener"),Ii.registerExternalUriOpener(Pe.identifier,Z,oe,Se)},get tabs(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),ft.tabs},get activeTab(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),ft.activeTab},get onDidChangeTabs(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),ft.onDidChangeTabs},get onDidChangeActiveTab(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),ft.onDidChangeActiveTab},getInlineCompletionItemController(Z){return(0,Ve.checkProposedApiEnabled)(Pe,"inlineCompletions"),l.InlineCompletionController.get(Z)}},bi={get rootPath(){return Be.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),lt.getPath()},set rootPath(Z){throw I.readonly()},getWorkspaceFolder(Z){return lt.getWorkspaceFolder(Z)},get workspaceFolders(){return lt.getWorkspaceFolders()},get name(){return lt.name},set name(Z){throw I.readonly()},get workspaceFile(){return lt.workspaceFile},set workspaceFile(Z){throw I.readonly()},updateWorkspaceFolders:(Z,oe,...Se)=>lt.updateWorkspaceFolders(Pe,Z,oe||0,...Se),onDidChangeWorkspaceFolders:function(Z,oe,Se){return lt.onDidChangeWorkspace(Z,oe,Se)},asRelativePath:(Z,oe)=>lt.getRelativePath(Z,oe),findFiles:(Z,oe,Se,Ye)=>lt.findFiles(Z,oe,Se,Pe.identifier,Ye),findTextInFiles:(Z,oe,Se,Ye)=>{(0,Ve.checkProposedApiEnabled)(Pe,"findTextInFiles");let gt,St;return typeof oe=="object"?(gt=oe,St=Se):(gt={},St=oe,Ye=Se),lt.findTextInFiles(Z,gt||{},St,Pe.identifier,Ye)},saveAll:Z=>lt.saveAll(Z),applyEdit(Z){return Ti.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,oe,Se,Ye)=>Vt.createFileSystemWatcher(lt,Pe,Z,oe,Se,Ye),get textDocuments(){return bt.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw I.readonly()},openTextDocument(Z){let oe;const Se=Z;if(typeof Z=="string")oe=Promise.resolve(y.URI.file(Z));else if(y.URI.isUri(Z))oe=Promise.resolve(Z);else if(!Se||typeof Se=="object")oe=bt.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(Ye=>bt.ensureDocumentData(Ye).then(gt=>gt.document))},onDidOpenTextDocument:(Z,oe,Se)=>bt.onDidAddDocument(Z,oe,Se),onDidCloseTextDocument:(Z,oe,Se)=>bt.onDidRemoveDocument(Z,oe,Se),onDidChangeTextDocument:(Z,oe,Se)=>bt.onDidChangeDocument(Z,oe,Se),onDidSaveTextDocument:(Z,oe,Se)=>bt.onDidSaveDocument(Z,oe,Se),onWillSaveTextDocument:(Z,oe,Se)=>Wt.getOnWillSaveTextDocumentEvent(Pe)(Z,oe,Se),get notebookDocuments(){return dt.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,oe){let Se;if(y.URI.isUri(Z))Se=Z,await dt.openNotebookDocument(Z);else if(typeof Z=="string")Se=y.URI.revive(await dt.createNotebookDocument({viewType:Z,content:oe}));else throw new Error("Invalid arguments");return dt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return dt.onDidCloseNotebookDocument},registerNotebookSerializer(Z,oe,Se,Ye){return dt.registerNotebookSerializer(Pe,Z,oe,Se,(0,Ve.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ye:void 0)},registerNotebookContentProvider:(Z,oe,Se,Ye)=>((0,Ve.checkProposedApiEnabled)(Pe,"notebookContentProvider"),dt.registerNotebookContentProvider(Pe,Z,oe,Se,(0,Ve.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ye:void 0)),onDidChangeConfiguration:(Z,oe,Se)=>Zt.onDidChangeConfiguration(Z,oe,Se),getConfiguration(Z,oe){return oe=arguments.length===1?void 0:oe,Zt.getConfiguration(Z,oe,Pe)},registerTextDocumentContentProvider(Z,oe){return Bt.registerTextDocumentContentProvider(Z,oe)},registerTaskProvider:(Z,oe)=>(Be.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),ct.registerTaskProvider(Pe,Z,oe)),registerFileSystemProvider(Z,oe,Se){return(0,Tt.combinedDisposable)(ai.registerFileSystemProvider(Pe,Z,oe,Se),Dt.addFileSystemProvider(Z,oe))},get fs(){return Dt.value},registerFileSearchProvider:(Z,oe)=>((0,Ve.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Mt.registerFileSearchProvider(Z,oe)),registerTextSearchProvider:(Z,oe)=>((0,Ve.checkProposedApiEnabled)(Pe,"textSearchProvider"),Mt.registerTextSearchProvider(Z,oe)),registerRemoteAuthorityResolver:(Z,oe)=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),Ct.registerRemoteAuthorityResolver(Z,oe)),registerResourceLabelFormatter:Z=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),yi.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,oe,Se)=>Vt.onDidCreateFile(Z,oe,Se),onDidDeleteFiles:(Z,oe,Se)=>Vt.onDidDeleteFile(Z,oe,Se),onDidRenameFiles:(Z,oe,Se)=>Vt.onDidRenameFile(Z,oe,Se),onWillCreateFiles:(Z,oe,Se)=>Vt.getOnWillCreateFileEvent(Pe)(Z,oe,Se),onWillDeleteFiles:(Z,oe,Se)=>Vt.getOnWillDeleteFileEvent(Pe)(Z,oe,Se),onWillRenameFiles:(Z,oe,Se)=>Vt.getOnWillRenameFileEvent(Pe)(Z,oe,Se),openTunnel:Z=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),Te.openTunnel(Pe,Z).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),Te.getTunnels()},onDidChangeTunnels:(Z,oe,Se)=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),Te.onDidChangeTunnels(Z,oe,Se)),registerPortAttributesProvider:(Z,oe)=>((0,Ve.checkProposedApiEnabled)(Pe,"portsAttributes"),Te.registerPortsAttributesProvider(Z,oe)),registerTimelineProvider:(Z,oe)=>((0,Ve.checkProposedApiEnabled)(Pe,"timeline"),li.registerTimelineProvider(Z,oe,Pe.identifier,it.converter)),get isTrusted(){return lt.trusted},requestWorkspaceTrust:Z=>((0,Ve.checkProposedApiEnabled)(Pe,"workspaceTrust"),lt.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,oe,Se)=>lt.onDidGrantWorkspaceTrust(Z,oe,Se)},Mi={get inputBox(){return Be.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Pe)},createSourceControl(Z,oe,Se){return ni.createSourceControl(Pe,Z,oe,Se)}},Ni={createCommentController(Z,oe){return Si.createCommentController(Pe,Z,oe)}},Li={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(Z,oe,Se){return mt.onDidStartDebugSession(Z,oe,Se)},onDidTerminateDebugSession(Z,oe,Se){return mt.onDidTerminateDebugSession(Z,oe,Se)},onDidChangeActiveDebugSession(Z,oe,Se){return mt.onDidChangeActiveDebugSession(Z,oe,Se)},onDidReceiveDebugSessionCustomEvent(Z,oe,Se){return mt.onDidReceiveDebugSessionCustomEvent(Z,oe,Se)},onDidChangeBreakpoints(Z,oe,Se){return mt.onDidChangeBreakpoints(Z,oe,Se)},registerDebugConfigurationProvider(Z,oe,Se){return mt.registerDebugConfigurationProvider(Z,oe,Se||pt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,oe){return mt.registerDebugAdapterDescriptorFactory(Pe,Z,oe)},registerDebugAdapterTrackerFactory(Z,oe){return mt.registerDebugAdapterTrackerFactory(Z,oe)},startDebugging(Z,oe,Se){return!Se||typeof Se=="object"&&"configuration"in Se?mt.startDebugging(Z,oe,{parentSession:Se}):mt.startDebugging(Z,oe,Se||{})},stopDebugging(Z){return mt.stopDebugging(Z)},addBreakpoints(Z){return mt.addBreakpoints(Z)},removeBreakpoints(Z){return mt.removeBreakpoints(Z)},asDebugSourceUri(Z,oe){return mt.asDebugSourceUri(Z,oe)}},Ui={registerTaskProvider:(Z,oe)=>ct.registerTaskProvider(Pe,Z,oe),fetchTasks:Z=>ct.fetchTasks(Z),executeTask:Z=>ct.executeTask(Pe,Z),get taskExecutions(){return ct.taskExecutions},onDidStartTask:(Z,oe,Se)=>ct.onDidStartTask(Z,oe,Se),onDidEndTask:(Z,oe,Se)=>ct.onDidEndTask(Z,oe,Se),onDidStartTaskProcess:(Z,oe,Se)=>ct.onDidStartTaskProcess(Z,oe,Se),onDidEndTaskProcess:(Z,oe,Se)=>ct.onDidEndTaskProcess(Z,oe,Se)},Bi={createNotebookController(Z,oe,Se,Ye,gt){return ti.createNotebookController(Pe,Z,oe,Se,Ye,(0,Ve.isProposedApiEnabled)(Pe,"notebookMessaging")?gt:void 0)},registerNotebookCellStatusBarItemProvider:(Z,oe)=>dt.registerNotebookCellStatusBarItemProvider(Pe,Z,oe),get onDidSaveNotebookDocument(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Z){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return oi.createRendererMessaging(Pe,Z)},onDidChangeNotebookDocumentMetadata(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(Z,oe,Se)},onDidChangeNotebookCells(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeNotebookCells(Z,oe,Se)},onDidChangeNotebookCellExecutionState(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(Z,oe,Se)},onDidChangeCellOutputs(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeCellOutputs(Z,oe,Se)},onDidChangeCellMetadata(Z,oe,Se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),dt.onDidChangeCellMetadata(Z,oe,Se)},createConcatTextDocument(Z,oe){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new pe.ExtHostNotebookConcatDocument(dt,bt,Z,oe)}};return{version:ot.version,authentication:Pi,commands:Ai,comments:Ni,debug:Li,env:vi,extensions:Oi,languages:hi,notebooks:Bi,scm:Mi,tasks:Ui,tests:Ri,window:Fi,workspace:bi,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:s.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:pt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestions,Hover:W.Hover,IndentAction:R.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:p.UIKind,Uri:y.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlayHint:W.InlayHint,InlayHintLabelPart:W.InlayHintLabelPart,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:Re.TextSearchCompleteMessageType,TreeDataTransfer:W.TreeDataTransfer,TreeDataTransferItem:W.TreeDataTransferItem,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Nt}),define(ve[223],Ee([1,0,222,33,216,7,11,4,9]),function(Y,e,r,I,_,x,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class R extends _.RequireInterceptor{_installInterceptor(){}getModule(n,i){for(let d of this._alternatives){let S=d(n);if(S){n=S;break}}if(this._factories.has(n))return this._factories.get(n).load(n,i,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=x.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const n=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);s(n,this._initData.environment.isExtensionDevelopmentDebug);const i=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,i,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(n){return n.browser}async _loadCommonJSModule(n,i,d){i=i.with({path:b(i.path,".js")}),n&&performance.mark(`code/extHost/willFetchExtensionCode/${n.value}`);const S=await fetch(C.FileAccess.asBrowserUri(i).toString(!0));if(n&&performance.mark(`code/extHost/didFetchExtensionCode/${n.value}`),S.status!==200)throw new Error(S.statusText);const M=await S.text(),u=`${i.toString(!0)}#vscode-extension`,f=`${M}
//# sourceURL=${u}`;let w;try{w=new Function("module","exports","require",f)}catch(t){throw console.error(n?`Loading code for extension ${n.value} failed: ${t.message}`:`Loading code failed: ${t.message}`),console.error(`${i.toString(!0)}${typeof t.line=="number"?` line ${t.line}`:""}${typeof t.column=="number"?` column ${t.column}`:""}`),console.error(t),t}const a={},P={exports:a},c=t=>{const h=this._fakeModules.getModule(t,i);if(h===void 0)throw new Error(`Cannot load module '${t}'`);return h};try{return d.codeLoadingStart(),n&&performance.mark(`code/extHost/willLoadExtensionCode/${n.value}`),w(P,a,c),P.exports!==a?P.exports:a}finally{n&&performance.mark(`code/extHost/didLoadExtensionCode/${n.value}`),d.codeLoadingStop()}}async $setRemoteEnvironment(n){}async _waitForDebuggerAttachment(n=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const i=Date.now()+n;for(;Date.now()<i&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}e.ExtHostExtensionService=N;function b(p,n){return p.endsWith(n)?p:p+n}function s(p,n){i("info","log"),i("log","log"),i("warn","warn"),i("error","error");function i(M,u){const f=console[M];console[M]=function(){p.$logExtensionHostMessage({type:"__$console",severity:u,arguments:S(arguments)}),n&&f.apply(console,arguments)}}const d=1e5;function S(M){const u=[],f=[];if(M.length)for(let w=0;w<M.length;w++){if(typeof M[w]=="undefined")M[w]="undefined";else if(M[w]instanceof Error){const a=M[w];a.stack?M[w]=a.stack:M[w]=a.toString()}f.push(M[w])}try{const w=JSON.stringify(f,function(a,P){if(P&&typeof P=="object"){if(u.indexOf(P)!==-1)return"[Circular]";u.push(P)}return P});return w.length>d?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}}),define(ve[224],Ee([1,0,44,33,67,223]),function(Y,e,r,I,_,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(I.IExtHostExtensionService,x.ExtHostExtensionService),(0,r.registerSingleton)(_.IExtensionStoragePaths,_.ExtensionStoragePaths)}),define(ve[235],Ee([1,0,21,5,91,217,210,17,68,9,2,219,224]),function(Y,e,r,I,_,x,y,A,C,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const s=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const p=fetch.bind(self);if(self.fetch=function(u,f){return u instanceof Request||/^file:/i.test(String(u))&&(u=R.FileAccess.asBrowserUri(N.URI.parse(String(u))).toString(!0)),p(u,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,f,w,a,P){return/^file:/i.test(f.toString())&&(f=R.FileAccess.asBrowserUri(N.URI.parse(f.toString())).toString(!0)),super.open(u,f,w??!0,a,P)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const u=self.Worker;Worker=function(f,w){/^file:/i.test(f.toString())&&(f=R.FileAccess.asBrowserUri(N.URI.parse(f.toString())).toString(!0));const P=`(${function(o){function l(v){return typeof v=="string"||v instanceof URL?String(v).replace(/^file:\/\//i,"vscode-file://vscode-app"):v}const E=fetch.bind(self);self.fetch=function(v,k){return v instanceof Request?E(v,k):E(l(v),k)},self.XMLHttpRequest=class extends XMLHttpRequest{open(v,k,T,$,g){return super.open(v,l(k),T??!0,$,g)}};const m=importScripts.bind(self);self.importScripts=(...v)=>{m(...v.map(l))},m(o)}.toString()}('${f}'))`;w=w||{},w.name=w.name||A.basename(f.toString());const c=new Blob([P],{type:"application/javascript"}),t=URL.createObjectURL(c);return new u(t,w)}}else self.Worker=class extends y.NestedWorker{constructor(u,f){super(s,u,{name:A.basename(u.toString()),...f})}};const n=new class{constructor(){this.pid=void 0}exit(u){b()}async exists(u){return!0}async realpath(u){return u}};class i{constructor(){const f=new MessageChannel,w=new I.Emitter;let a=!1;s(f.port2,[f.port2]),f.port1.onmessage=P=>{const{data:c}=P;if(!(c instanceof ArrayBuffer)){console.warn("UNKNOWN data received",c);return}const t=r.VSBuffer.wrap(new Uint8Array(c,0,c.byteLength));if((0,_.isMessageOfType)(t,2)){a=!0,S("received terminate message from renderer");return}w.fire(t)},this.protocol={onMessage:w.event,send:P=>{if(!a){const c=P.buffer.buffer.slice(P.buffer.byteOffset,P.buffer.byteOffset+P.buffer.byteLength);f.port1.postMessage(c,[c])}}}}}function d(u){return new Promise(f=>{const w=u.onMessage(a=>{w.dispose();const P=JSON.parse(a.toString());u.send((0,_.createMessageOfType)(0)),f({protocol:u,initData:P})});u.send((0,_.createMessageOfType)(1))})}let S=u=>b();function M(){C.mark("code/extHost/willConnectToRenderer");const u=new i;return{onmessage(f){d(u.protocol).then(w=>{C.mark("code/extHost/didWaitForInitData");const a=new x.ExtensionHostMain(w.protocol,w.initData,n,null,f);S=P=>a.terminate(P)})}}}e.create=M})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/97c1e76d668d23d568044feb31083407f4c4b1ed/core/vs/workbench/api/worker/extensionHostWorker.js.map
